/*!
 * @overview  Ember - JavaScript Application Framework
 * @copyright Copyright 2011-2014 Tilde Inc. and contributors
 *            Portions Copyright 2006-2011 Strobe Inc.
 *            Portions Copyright 2008-2011 Apple Inc. All rights reserved.
 * @license   Licensed under MIT license
 *            See https://raw.github.com/emberjs/ember.js/master/LICENSE
 * @version   1.5.0-beta.1+canary.8e1dc36c



 THIS IS A PRERELEASE BUILD OF EMBER WITH HTMLBARS. IT HAS HACKS. DON'T ATTEMPT TO USE THIS ANYWHERE.
 */


(function() {
var define, requireModule, require, requirejs;

(function() {
	var registry = {}, seen = {};

	define = function(name, deps, callback) {
		registry[name] = { deps: deps, callback: callback };
	};

	requirejs = require = requireModule = function(name) {
	requirejs._eak_seen = registry;

		if (seen[name]) { return seen[name]; }
		seen[name] = {};

		if (!registry[name]) {
			throw new Error("Could not find module " + name);
		}

		var mod = registry[name],
				deps = mod.deps,
				callback = mod.callback,
				reified = [],
				exports;

		for (var i=0, l=deps.length; i<l; i++) {
			if (deps[i] === 'exports') {
				reified.push(exports = {});
			} else {
				reified.push(requireModule(resolve(deps[i])));
			}
		}

		var value = callback.apply(this, reified);
		return seen[name] = exports || value;

		function resolve(child) {
			if (child.charAt(0) !== '.') { return child; }
			var parts = child.split("/");
			var parentBase = name.split("/").slice(0, -1);

			for (var i=0, l=parts.length; i<l; i++) {
				var part = parts[i];

				if (part === '..') { parentBase.pop(); }
				else if (part === '.') { continue; }
				else { parentBase.push(part); }
			}

			return parentBase.join("/");
		}
	};
})();
(function() {
/*globals Em:true ENV EmberENV MetamorphENV:true */

/**
@module ember
@submodule ember-metal
*/

/**
	All Ember methods and functions are defined inside of this namespace. You
	generally should not add new properties to this namespace as it may be
	overwritten by future versions of Ember.

	You can also use the shorthand `Em` instead of `Ember`.

	Ember-Runtime is a framework that provides core functions for Ember including
	cross-platform functions, support for property observing and objects. Its
	focus is on small size and performance. You can use this in place of or
	along-side other cross-platform libraries such as jQuery.

	The core Runtime framework is based on the jQuery API with a number of
	performance optimizations.

	@class Ember
	@static
	@version 1.5.0-beta.1+canary.8e1dc36c
*/

if ('undefined' === typeof Ember) {
	// Create core object. Make it act like an instance of Ember.Namespace so that
	// objects assigned to it are given a sane string representation.
	Ember = {};
}

// Default imports, exports and lookup to the global object;
var imports = Ember.imports = Ember.imports || this;
var exports = Ember.exports = Ember.exports || this;
var lookup  = Ember.lookup  = Ember.lookup  || this;

// aliases needed to keep minifiers from removing the global context
exports.Em = exports.Ember = Em = Ember;

// Make sure these are set whether Ember was already defined or not

Ember.isNamespace = true;

Ember.toString = function() { return "Ember"; };


/**
	@property VERSION
	@type String
	@default '1.5.0-beta.1+canary.8e1dc36c'
	@static
*/
Ember.VERSION = '1.5.0-beta.1+canary.8e1dc36c';

/**
	Standard environmental variables. You can define these in a global `EmberENV`
	variable before loading Ember to control various configuration settings.

	For backwards compatibility with earlier versions of Ember the global `ENV`
	variable will be used if `EmberENV` is not defined.

	@property ENV
	@type Hash
*/

// This needs to be kept in sync with the logic in
// `packages/ember-debug/lib/main.js`.
if (Ember.ENV) {
	// do nothing if Ember.ENV is already setup
} else if ('undefined' !== typeof EmberENV) {
	Ember.ENV = EmberENV;
} else if('undefined' !== typeof ENV) {
	Ember.ENV = ENV;
} else {
	Ember.ENV = {};
}

Ember.config = Ember.config || {};

// We disable the RANGE API by default for performance reasons
if ('undefined' === typeof Ember.ENV.DISABLE_RANGE_API) {
	Ember.ENV.DISABLE_RANGE_API = true;
}

if ("undefined" === typeof MetamorphENV) {
	exports.MetamorphENV = {};
}

MetamorphENV.DISABLE_RANGE_API = Ember.ENV.DISABLE_RANGE_API;

/**
	Hash of enabled Canary features. Add to before creating your application.

	You can also define `ENV.FEATURES` if you need to enable features flagged at runtime.

	@property FEATURES
	@type Hash
*/

Ember.FEATURES = Ember.ENV.FEATURES || {};

/**
	Test that a feature is enabled. Parsed by Ember's build tools to leave
	experimental features out of beta/stable builds.

	You can define the following configuration options:

	* `ENV.ENABLE_ALL_FEATURES` - force all features to be enabled.
	* `ENV.ENABLE_OPTIONAL_FEATURES` - enable any features that have not been explicitly
		enabled/disabled.

	@method isEnabled
	@param {string} feature
*/

Ember.FEATURES.isEnabled = function(feature) {
	var featureValue = Ember.FEATURES[feature];

	if (Ember.ENV.ENABLE_ALL_FEATURES) {
		return true;
	} else if (featureValue === true || featureValue === false || featureValue === undefined) {
		return featureValue;
	} else if (Ember.ENV.ENABLE_OPTIONAL_FEATURES) {
		return true;
	} else {
		return false;
	}
};

// ..........................................................
// BOOTSTRAP
//

/**
	Determines whether Ember should enhances some built-in object prototypes to
	provide a more friendly API. If enabled, a few methods will be added to
	`Function`, `String`, and `Array`. `Object.prototype` will not be enhanced,
	which is the one that causes most trouble for people.

	In general we recommend leaving this option set to true since it rarely
	conflicts with other code. If you need to turn it off however, you can
	define an `ENV.EXTEND_PROTOTYPES` config to disable it.

	@property EXTEND_PROTOTYPES
	@type Boolean
	@default true
*/
Ember.EXTEND_PROTOTYPES = Ember.ENV.EXTEND_PROTOTYPES;

if (typeof Ember.EXTEND_PROTOTYPES === 'undefined') {
	Ember.EXTEND_PROTOTYPES = true;
}

/**
	Determines whether Ember logs a full stack trace during deprecation warnings

	@property LOG_STACKTRACE_ON_DEPRECATION
	@type Boolean
	@default true
*/
Ember.LOG_STACKTRACE_ON_DEPRECATION = (Ember.ENV.LOG_STACKTRACE_ON_DEPRECATION !== false);

/**
	Determines whether Ember should add ECMAScript 5 shims to older browsers.

	@property SHIM_ES5
	@type Boolean
	@default Ember.EXTEND_PROTOTYPES
*/
Ember.SHIM_ES5 = (Ember.ENV.SHIM_ES5 === false) ? false : Ember.EXTEND_PROTOTYPES;

/**
	Determines whether Ember logs info about version of used libraries

	@property LOG_VERSION
	@type Boolean
	@default true
*/
Ember.LOG_VERSION = (Ember.ENV.LOG_VERSION === false) ? false : true;

/**
	Empty function. Useful for some operations. Always returns `this`.

	@method K
	@private
	@return {Object}
*/
Ember.K = function() { return this; };


// Stub out the methods defined by the ember-debug package in case it's not loaded

if ('undefined' === typeof Ember.assert) { Ember.assert = Ember.K; }
if ('undefined' === typeof Ember.warn) { Ember.warn = Ember.K; }
if ('undefined' === typeof Ember.debug) { Ember.debug = Ember.K; }
if ('undefined' === typeof Ember.deprecate) { Ember.deprecate = Ember.K; }
if ('undefined' === typeof Ember.deprecateFunc) {
	Ember.deprecateFunc = function(_, func) { return func; };
}

/**
	Previously we used `Ember.$.uuid`, however `$.uuid` has been removed from
	jQuery master. We'll just bootstrap our own uuid now.

	@property uuid
	@type Number
	@private
*/
Ember.uuid = 0;

/**
	Merge the contents of two objects together into the first object.

	```javascript
	Ember.merge({first: 'Tom'}, {last: 'Dale'}); // {first: 'Tom', last: 'Dale'}
	var a = {first: 'Yehuda'}, b = {last: 'Katz'};
	Ember.merge(a, b); // a == {first: 'Yehuda', last: 'Katz'}, b == {last: 'Katz'}
	```

	@method merge
	@for Ember
	@param {Object} original The object to merge into
	@param {Object} updates The object to copy properties from
	@return {Object}
*/
Ember.merge = function(original, updates) {
	for (var prop in updates) {
		if (!updates.hasOwnProperty(prop)) { continue; }
		original[prop] = updates[prop];
	}
	return original;
};

/**
	Returns true if the passed value is null or undefined. This avoids errors
	from JSLint complaining about use of ==, which can be technically
	confusing.

	```javascript
	Ember.isNone();              // true
	Ember.isNone(null);          // true
	Ember.isNone(undefined);     // true
	Ember.isNone('');            // false
	Ember.isNone([]);            // false
	Ember.isNone(function() {});  // false
	```

	@method isNone
	@for Ember
	@param {Object} obj Value to test
	@return {Boolean}
*/
Ember.isNone = function(obj) {
	return obj === null || obj === undefined;
};
Ember.none = Ember.deprecateFunc("Ember.none is deprecated. Please use Ember.isNone instead.", Ember.isNone);

/**
	Verifies that a value is `null` or an empty string, empty array,
	or empty function.

	Constrains the rules on `Ember.isNone` by returning false for empty
	string and empty arrays.

	```javascript
	Ember.isEmpty();                // true
	Ember.isEmpty(null);            // true
	Ember.isEmpty(undefined);       // true
	Ember.isEmpty('');              // true
	Ember.isEmpty([]);              // true
	Ember.isEmpty('Adam Hawkins');  // false
	Ember.isEmpty([0,1,2]);         // false
	```

	@method isEmpty
	@for Ember
	@param {Object} obj Value to test
	@return {Boolean}
*/
Ember.isEmpty = function(obj) {
	return Ember.isNone(obj) || (obj.length === 0 && typeof obj !== 'function') || (typeof obj === 'object' && Ember.get(obj, 'length') === 0);
};
Ember.empty = Ember.deprecateFunc("Ember.empty is deprecated. Please use Ember.isEmpty instead.", Ember.isEmpty);

if (Ember.FEATURES.isEnabled('ember-metal-is-blank')) {
	/**
		A value is blank if it is empty or a whitespace string.

		```javascript
		Ember.isBlank();                // true
		Ember.isBlank(null);            // true
		Ember.isBlank(undefined);       // true
		Ember.isBlank('');              // true
		Ember.isBlank([]);              // true
		Ember.isBlank('\n\t');          // true
		Ember.isBlank('  ');            // true
		Ember.isBlank({});              // false
		Ember.isBlank('\n\t Hello');    // false
		Ember.isBlank('Hello world');   // false
		Ember.isBlank([1,2,3]);         // false
		```

		@method isBlank
		@for Ember
		@param {Object} obj Value to test
		@return {Boolean}
	*/
	Ember.isBlank = function(obj) {
		return Ember.isEmpty(obj) || (typeof obj === 'string' && obj.match(/\S/) === null);
	};
}

})();



(function() {
/*globals Node */
/**
@module ember-metal
*/

/**
	Platform specific methods and feature detectors needed by the framework.

	@class platform
	@namespace Ember
	@static
*/
var platform = Ember.platform = {};


/**
	Identical to `Object.create()`. Implements if not available natively.

	@method create
	@for Ember
*/
Ember.create = Object.create;

// IE8 has Object.create but it couldn't treat property descriptors.
if (Ember.create) {
	if (Ember.create({a: 1}, {a: {value: 2}}).a !== 2) {
		Ember.create = null;
	}
}

// STUB_OBJECT_CREATE allows us to override other libraries that stub
// Object.create different than we would prefer
if (!Ember.create || Ember.ENV.STUB_OBJECT_CREATE) {
	var K = function() {};

	Ember.create = function(obj, props) {
		K.prototype = obj;
		obj = new K();
		if (props) {
			K.prototype = obj;
			for (var prop in props) {
				K.prototype[prop] = props[prop].value;
			}
			obj = new K();
		}
		K.prototype = null;

		return obj;
	};

	Ember.create.isSimulated = true;
}

var defineProperty = Object.defineProperty;
var canRedefineProperties, canDefinePropertyOnDOM;

// Catch IE8 where Object.defineProperty exists but only works on DOM elements
if (defineProperty) {
	try {
		defineProperty({}, 'a',{get:function() {}});
	} catch (e) {
		defineProperty = null;
	}
}

if (defineProperty) {
	// Detects a bug in Android <3.2 where you cannot redefine a property using
	// Object.defineProperty once accessors have already been set.
	canRedefineProperties = (function() {
		var obj = {};

		defineProperty(obj, 'a', {
			configurable: true,
			enumerable: true,
			get: function() { },
			set: function() { }
		});

		defineProperty(obj, 'a', {
			configurable: true,
			enumerable: true,
			writable: true,
			value: true
		});

		return obj.a === true;
	})();

	// This is for Safari 5.0, which supports Object.defineProperty, but not
	// on DOM nodes.
	canDefinePropertyOnDOM = (function() {
		try {
			defineProperty(document.createElement('div'), 'definePropertyOnDOM', {});
			return true;
		} catch(e) { }

		return false;
	})();

	if (!canRedefineProperties) {
		defineProperty = null;
	} else if (!canDefinePropertyOnDOM) {
		defineProperty = function(obj, keyName, desc) {
			var isNode;

			if (typeof Node === "object") {
				isNode = obj instanceof Node;
			} else {
				isNode = typeof obj === "object" && typeof obj.nodeType === "number" && typeof obj.nodeName === "string";
			}

			if (isNode) {
				// TODO: Should we have a warning here?
				return (obj[keyName] = desc.value);
			} else {
				return Object.defineProperty(obj, keyName, desc);
			}
		};
	}
}

/**
@class platform
@namespace Ember
*/

/**
	Identical to `Object.defineProperty()`. Implements as much functionality
	as possible if not available natively.

	@method defineProperty
	@param {Object} obj The object to modify
	@param {String} keyName property name to modify
	@param {Object} desc descriptor hash
	@return {void}
*/
platform.defineProperty = defineProperty;

/**
	Set to true if the platform supports native getters and setters.

	@property hasPropertyAccessors
	@final
*/
platform.hasPropertyAccessors = true;

if (!platform.defineProperty) {
	platform.hasPropertyAccessors = false;

	platform.defineProperty = function(obj, keyName, desc) {
		if (!desc.get) { obj[keyName] = desc.value; }
	};

	platform.defineProperty.isSimulated = true;
}

if (Ember.ENV.MANDATORY_SETTER && !platform.hasPropertyAccessors) {
	Ember.ENV.MANDATORY_SETTER = false;
}

})();



(function() {
/*jshint newcap:false*/
/**
@module ember-metal
*/

// NOTE: There is a bug in jshint that doesn't recognize `Object()` without `new`
// as being ok unless both `newcap:false` and not `use strict`.
// https://github.com/jshint/jshint/issues/392

// Testing this is not ideal, but we want to use native functions
// if available, but not to use versions created by libraries like Prototype
var isNativeFunc = function(func) {
	// This should probably work in all browsers likely to have ES5 array methods
	return func && Function.prototype.toString.call(func).indexOf('[native code]') > -1;
};

// From: https://developer.mozilla.org/en/JavaScript/Reference/Global_Objects/array/map
var arrayMap = isNativeFunc(Array.prototype.map) ? Array.prototype.map : function(fun /*, thisp */) {
	//"use strict";

	if (this === void 0 || this === null) {
		throw new TypeError();
	}

	var t = Object(this);
	var len = t.length >>> 0;
	if (typeof fun !== "function") {
		throw new TypeError();
	}

	var res = new Array(len);
	var thisp = arguments[1];
	for (var i = 0; i < len; i++) {
		if (i in t) {
			res[i] = fun.call(thisp, t[i], i, t);
		}
	}

	return res;
};

// From: https://developer.mozilla.org/en/JavaScript/Reference/Global_Objects/array/foreach
var arrayForEach = isNativeFunc(Array.prototype.forEach) ? Array.prototype.forEach : function(fun /*, thisp */) {
	//"use strict";

	if (this === void 0 || this === null) {
		throw new TypeError();
	}

	var t = Object(this);
	var len = t.length >>> 0;
	if (typeof fun !== "function") {
		throw new TypeError();
	}

	var thisp = arguments[1];
	for (var i = 0; i < len; i++) {
		if (i in t) {
			fun.call(thisp, t[i], i, t);
		}
	}
};

var arrayIndexOf = isNativeFunc(Array.prototype.indexOf) ? Array.prototype.indexOf : function (obj, fromIndex) {
	if (fromIndex === null || fromIndex === undefined) { fromIndex = 0; }
	else if (fromIndex < 0) { fromIndex = Math.max(0, this.length + fromIndex); }
	for (var i = fromIndex, j = this.length; i < j; i++) {
		if (this[i] === obj) { return i; }
	}
	return -1;
};


	/**
		Array polyfills to support ES5 features in older browsers.

		@namespace Ember
		@property ArrayPolyfills
	*/
	Ember.ArrayPolyfills = {
		map: arrayMap,
		forEach: arrayForEach,
		indexOf: arrayIndexOf
	};


if (Ember.SHIM_ES5) {
	if (!Array.prototype.map) {
		Array.prototype.map = arrayMap;
	}

	if (!Array.prototype.forEach) {
		Array.prototype.forEach = arrayForEach;
	}

	if (!Array.prototype.indexOf) {
		Array.prototype.indexOf = arrayIndexOf;
	}
}

})();



(function() {
var errorProps = ['description', 'fileName', 'lineNumber', 'message', 'name', 'number', 'stack'];

/**
	A subclass of the JavaScript Error object for use in Ember.

	@class Error
	@namespace Ember
	@extends Error
	@constructor
*/
Ember.Error = function() {
	var tmp = Error.apply(this, arguments);

	// Adds a `stack` property to the given error object that will yield the
	// stack trace at the time captureStackTrace was called.
	// When collecting the stack trace all frames above the topmost call
	// to this function, including that call, will be left out of the
	// stack trace.
	// This is useful because we can hide Ember implementation details
	// that are not very helpful for the user.
	if (Error.captureStackTrace) {
		Error.captureStackTrace(this, Ember.Error);
	}
	// Unfortunately errors are not enumerable in Chrome (at least), so `for prop in tmp` doesn't work.
	for (var idx = 0; idx < errorProps.length; idx++) {
		this[errorProps[idx]] = tmp[errorProps[idx]];
	}
};

Ember.Error.prototype = Ember.create(Error.prototype);

// ..........................................................
// ERROR HANDLING
//

/**
	A function may be assigned to `Ember.onerror` to be called when Ember
	internals encounter an error. This is useful for specialized error handling
	and reporting code.

	```javascript
	Ember.onerror = function(error) {
		Em.$.ajax('/report-error', 'POST', {
			stack: error.stack,
			otherInformation: 'whatever app state you want to provide'
		});
	};
	```

	@event onerror
	@for Ember
	@param {Exception} error the error object
*/
Ember.onerror = null;

/**
	Wrap code block in a try/catch if `Ember.onerror` is set.

	@private
	@method handleErrors
	@for Ember
	@param {Function} func
	@param [context]
*/
Ember.handleErrors = function(func, context) {
	// Unfortunately in some browsers we lose the backtrace if we rethrow the existing error,
	// so in the event that we don't have an `onerror` handler we don't wrap in a try/catch
	if ('function' === typeof Ember.onerror) {
		try {
			return func.call(context || this);
		} catch (error) {
			Ember.onerror(error);
		}
	} else {
		return func.call(context || this);
	}
};

})();



(function() {
/**
@module ember-metal
*/

/**
	Prefix used for guids through out Ember.
	@private
*/
Ember.GUID_PREFIX = 'ember';


var o_defineProperty = Ember.platform.defineProperty,
		o_create = Ember.create,
		// Used for guid generation...
		GUID_KEY = '__ember_guid', //+ (+ new Date()),
		uuid         = 0,
		numberCache  = [],
		stringCache  = {};

var MANDATORY_SETTER = Ember.ENV.MANDATORY_SETTER;

/**
	A unique key used to assign guids and other private metadata to objects.
	If you inspect an object in your browser debugger you will often see these.
	They can be safely ignored.

	On browsers that support it, these properties are added with enumeration
	disabled so they won't show up when you iterate over your properties.

	@private
	@property GUID_KEY
	@for Ember
	@type String
	@final
*/
Ember.GUID_KEY = GUID_KEY;

var GUID_DESC = Ember.GUID_DESC = {
	writable:    false,
	configurable: false,
	enumerable:  false,
	value: null
};

/**
	Generates a new guid, optionally saving the guid to the object that you
	pass in. You will rarely need to use this method. Instead you should
	call `Ember.guidFor(obj)`, which return an existing guid if available.

	@private
	@method generateGuid
	@for Ember
	@param {Object} [obj] Object the guid will be used for. If passed in, the guid will
		be saved on the object and reused whenever you pass the same object
		again.

		If no object is passed, just generate a new guid.
	@param {String} [prefix] Prefix to place in front of the guid. Useful when you want to
		separate the guid into separate namespaces.
	@return {String} the guid
*/
Ember.generateGuid = function generateGuid(obj, prefix) {
	if (!prefix) prefix = Ember.GUID_PREFIX;
	var ret = (prefix + (uuid++));
	if (obj) {
		GUID_DESC.value = ret;
		o_defineProperty(obj, GUID_KEY, GUID_DESC);
	}
	return ret;
};

/**
	Returns a unique id for the object. If the object does not yet have a guid,
	one will be assigned to it. You can call this on any object,
	`Ember.Object`-based or not, but be aware that it will add a `_guid`
	property.

	You can also use this method on DOM Element objects.

	@private
	@method guidFor
	@for Ember
	@param {Object} obj any object, string, number, Element, or primitive
	@return {String} the unique guid for this instance.
*/
Ember.guidFor = function guidFor(obj) {

	// special cases where we don't want to add a key to object
	if (obj === undefined) return "(undefined)";
	if (obj === null) return "(null)";

	var ret;
	var type = typeof obj;

	// Don't allow prototype changes to String etc. to change the guidFor
	switch(type) {
		case 'number':
			ret = numberCache[obj];
			if (!ret) ret = numberCache[obj] = 'nu'+obj;
			return ret;

		case 'string':
			ret = stringCache[obj];
			if (!ret) ret = stringCache[obj] = 'st'+(uuid++);
			return ret;

		case 'boolean':
			return obj ? '(true)' : '(false)';

		default:
			if (obj[GUID_KEY]) return obj[GUID_KEY];
			if (obj === Object) return '(Object)';
			if (obj === Array)  return '(Array)';
			ret = 'ember'+(uuid++);
			GUID_DESC.value = ret;
			o_defineProperty(obj, GUID_KEY, GUID_DESC);
			return ret;
	}
};

// ..........................................................
// META
//

var META_DESC = Ember.META_DESC = {
	writable:    true,
	configurable: false,
	enumerable:  false,
	value: null
};

var META_KEY = '__ember_meta';

/**
	The key used to store meta information on object for property observing.

	@property META_KEY
	@for Ember
	@private
	@final
	@type String
*/
Ember.META_KEY = META_KEY;

var isDefinePropertySimulated = Ember.platform.defineProperty.isSimulated;

function Meta(obj) {
	this.descs = {};
	this.watching = {};
	this.cache = {};
	this.source = obj;
	this.proto = null;
}

Meta.prototype = {
	descs: null,
	deps: null,
	watching: null,
	listeners: null,
	cache: null,
	source: null,
	mixins: null,
	bindings: null,
	chains: null,
	chainWatchers: null,
	values: null,
	proto: null
};

if (isDefinePropertySimulated) {
	// on platforms that don't support enumerable false
	// make meta fail jQuery.isPlainObject() to hide from
	// jQuery.extend() by having a property that fails
	// hasOwnProperty check.
	Meta.prototype.__preventPlainObject__ = true;

	// Without non-enumerable properties, meta objects will be output in JSON
	// unless explicitly suppressed
	Meta.prototype.toJSON = function () { };
}

// Placeholder for non-writable metas.
var EMPTY_META = new Meta(null);

if (MANDATORY_SETTER) { EMPTY_META.values = {}; }

Ember.EMPTY_META = EMPTY_META;

/**
	Retrieves the meta hash for an object. If `writable` is true ensures the
	hash is writable for this object as well.

	The meta object contains information about computed property descriptors as
	well as any watched properties and other information. You generally will
	not access this information directly but instead work with higher level
	methods that manipulate this hash indirectly.

	@method meta
	@for Ember
	@private

	@param {Object} obj The object to retrieve meta for
	@param {Boolean} [writable=true] Pass `false` if you do not intend to modify
		the meta hash, allowing the method to avoid making an unnecessary copy.
	@return {Object} the meta hash for an object
*/
Ember.meta = function meta(obj, writable) {

	var ret = obj.__ember_meta;
	if (writable===false) return ret || EMPTY_META;

	if (!ret) {
		if (!isDefinePropertySimulated) o_defineProperty(obj, '__ember_meta', META_DESC);

		ret = new Meta(obj);

		if (MANDATORY_SETTER) { ret.values = {}; }

		obj.__ember_meta = ret;

		// make sure we don't accidentally try to create constructor like desc
		ret.descs.constructor = null;

	} else if (ret.source !== obj) {
		if (!isDefinePropertySimulated) o_defineProperty(obj, '__ember_meta', META_DESC);

		ret = o_create(ret);
		ret.descs    = o_create(ret.descs);
		ret.watching = o_create(ret.watching);
		ret.cache    = {};
		ret.source   = obj;

		if (MANDATORY_SETTER) { ret.values = o_create(ret.values); }

		obj.__ember_meta = ret;
	}
	return ret;
};

Ember.Utils = {
	EMPTY_META: EMPTY_META,
	isDefinePropertySimulated: isDefinePropertySimulated,
	o_defineProperty: o_defineProperty,
	META_DESC: META_DESC,
	Meta: Meta,
	MANDATORY_SETTER: MANDATORY_SETTER,
	o_create: o_create,

	createMeta: function createMeta(obj) {
		if (!this.isDefinePropertySimulated) this.o_defineProperty(obj, '__ember_meta', this.META_DESC);

		var ret = new this.Meta(obj);

		if (this.MANDATORY_SETTER) { ret.values = {}; }

		obj.__ember_meta = ret;

		// make sure we don't accidentally try to create constructor like desc
		ret.descs.constructor = null;

		return ret;
	},

	inheritMeta: function inheritMeta(obj) {
		var meta     = obj.__ember_meta,
				ret      = this.o_create(meta);
		ret.descs    = this.o_create(ret.descs);
		ret.watching = this.o_create(ret.watching);
		ret.cache    = {};
		ret.source   = obj;

		if (this.MANDATORY_SETTER) { ret.values = this.o_create(ret.values); }

		obj.__ember_meta = ret;
		return ret;
	},

	updateMeta: function updateMeta(obj) {
		var meta = obj.__ember_meta;

		if (meta.source !== obj) {
			if (!this.isDefinePropertySimulated) this.o_defineProperty(obj, '__ember_meta', this.META_DESC);
			var ret      = this.o_create(meta);
			ret.descs    = this.o_create(ret.descs);
			ret.watching = this.o_create(ret.watching);
			ret.cache    = {};
			ret.source   = obj;

			if (this.MANDATORY_SETTER) { ret.values = this.o_create(ret.values); }

			obj.__ember_meta = ret;
			return ret;
		} else {
			return meta;
		}
	},

	meta: function fastMeta(obj, writable) {
		var meta = obj.__ember_meta;
		if (writable===false) return meta || this.EMPTY_META;
		return (meta ? (meta.source === obj ? meta : this.updateMeta(obj)) : this.createMeta(obj));
	}
};

Ember.getMeta = function getMeta(obj, property) {
	var meta = Ember.meta(obj, false);
	return meta[property];
};

Ember.setMeta = function setMeta(obj, property, value) {
	var meta = Ember.meta(obj, true);
	meta[property] = value;
	return value;
};

/**
	@deprecated
	@private

	In order to store defaults for a class, a prototype may need to create
	a default meta object, which will be inherited by any objects instantiated
	from the class's constructor.

	However, the properties of that meta object are only shallow-cloned,
	so if a property is a hash (like the event system's `listeners` hash),
	it will by default be shared across all instances of that class.

	This method allows extensions to deeply clone a series of nested hashes or
	other complex objects. For instance, the event system might pass
	`['listeners', 'foo:change', 'ember157']` to `prepareMetaPath`, which will
	walk down the keys provided.

	For each key, if the key does not exist, it is created. If it already
	exists and it was inherited from its constructor, the constructor's
	key is cloned.

	You can also pass false for `writable`, which will simply return
	undefined if `prepareMetaPath` discovers any part of the path that
	shared or undefined.

	@method metaPath
	@for Ember
	@param {Object} obj The object whose meta we are examining
	@param {Array} path An array of keys to walk down
	@param {Boolean} writable whether or not to create a new meta
		(or meta property) if one does not already exist or if it's
		shared with its constructor
*/
Ember.metaPath = function metaPath(obj, path, writable) {
		var meta = Ember.meta(obj, writable), keyName, value;

	for (var i=0, l=path.length; i<l; i++) {
		keyName = path[i];
		value = meta[keyName];

		if (!value) {
			if (!writable) { return undefined; }
			value = meta[keyName] = { __ember_source__: obj };
		} else if (value.__ember_source__ !== obj) {
			if (!writable) { return undefined; }
			value = meta[keyName] = o_create(value);
			value.__ember_source__ = obj;
		}

		meta = value;
	}

	return value;
};

/**
	Wraps the passed function so that `this._super` will point to the superFunc
	when the function is invoked. This is the primitive we use to implement
	calls to super.

	@private
	@method wrap
	@for Ember
	@param {Function} func The function to call
	@param {Function} superFunc The super function.
	@return {Function} wrapped function.
*/
Ember.wrap = function(func, superFunc) {
	function superWrapper() {
		var ret, sup = this.__nextSuper;
		this.__nextSuper = superFunc;
		ret = func.apply(this, arguments);
		this.__nextSuper = sup;
		return ret;
	}

	superWrapper.wrappedFunction = func;
	superWrapper.__ember_observes__ = func.__ember_observes__;
	superWrapper.__ember_observesBefore__ = func.__ember_observesBefore__;
	superWrapper.__ember_listens__ = func.__ember_listens__;

	return superWrapper;
};

/**
	Returns true if the passed object is an array or Array-like.

	Ember Array Protocol:

		- the object has an objectAt property
		- the object is a native Array
		- the object is an Object, and has a length property

	Unlike `Ember.typeOf` this method returns true even if the passed object is
	not formally array but appears to be array-like (i.e. implements `Ember.Array`)

	```javascript
	Ember.isArray();                                            // false
	Ember.isArray([]);                                          // true
	Ember.isArray( Ember.ArrayProxy.create({ content: [] }) );  // true
	```

	@method isArray
	@for Ember
	@param {Object} obj The object to test
	@return {Boolean} true if the passed object is an array or Array-like
*/
Ember.isArray = function(obj) {
	if (!obj || obj.setInterval) { return false; }
	if (Array.isArray && Array.isArray(obj)) { return true; }
	if (Ember.Array && Ember.Array.detect(obj)) { return true; }
	if ((obj.length !== undefined) && 'object'===typeof obj) { return true; }
	return false;
};

/**
	Forces the passed object to be part of an array. If the object is already
	an array or array-like, returns the object. Otherwise adds the object to
	an array. If obj is `null` or `undefined`, returns an empty array.

	```javascript
	Ember.makeArray();                           // []
	Ember.makeArray(null);                       // []
	Ember.makeArray(undefined);                  // []
	Ember.makeArray('lindsay');                  // ['lindsay']
	Ember.makeArray([1,2,42]);                   // [1,2,42]

	var controller = Ember.ArrayProxy.create({ content: [] });
	Ember.makeArray(controller) === controller;  // true
	```

	@method makeArray
	@for Ember
	@param {Object} obj the object
	@return {Array}
*/
Ember.makeArray = function(obj) {
	if (obj === null || obj === undefined) { return []; }
	return Ember.isArray(obj) ? obj : [obj];
};

function canInvoke(obj, methodName) {
	return !!(obj && typeof obj[methodName] === 'function');
}

/**
	Checks to see if the `methodName` exists on the `obj`.

	```javascript
	var foo = {bar: Ember.K, baz: null};
	Ember.canInvoke(foo, 'bar'); // true
	Ember.canInvoke(foo, 'baz'); // false
	Ember.canInvoke(foo, 'bat'); // false
	```

	@method canInvoke
	@for Ember
	@param {Object} obj The object to check for the method
	@param {String} methodName The method name to check for
	@return {Boolean}
*/
Ember.canInvoke = canInvoke;

/**
	Checks to see if the `methodName` exists on the `obj`,
	and if it does, invokes it with the arguments passed.

	```javascript
	var d = new Date('03/15/2013');
	Ember.tryInvoke(d, 'getTime'); // 1363320000000
	Ember.tryInvoke(d, 'setFullYear', [2014]); // 1394856000000
	Ember.tryInvoke(d, 'noSuchMethod', [2014]); // undefined
	```

	@method tryInvoke
	@for Ember
	@param {Object} obj The object to check for the method
	@param {String} methodName The method name to check for
	@param {Array} [args] The arguments to pass to the method
	@return {*} the return value of the invoked method or undefined if it cannot be invoked
*/
Ember.tryInvoke = function(obj, methodName, args) {
	if (canInvoke(obj, methodName)) {
		return obj[methodName].apply(obj, args || []);
	}
};

// https://github.com/emberjs/ember.js/pull/1617
var needsFinallyFix = (function() {
	var count = 0;
	try{
		try { }
		finally {
			count++;
			throw new Error('needsFinallyFixTest');
		}
	} catch (e) {}

	return count !== 1;
})();

/**
	Provides try { } finally { } functionality, while working
	around Safari's double finally bug.

	```javascript
	var tryable = function() {
		someResource.lock();
		runCallback(); // May throw error.
	};
	var finalizer = function() {
		someResource.unlock();
	};
	Ember.tryFinally(tryable, finalizer);
	```

	@method tryFinally
	@for Ember
	@param {Function} tryable The function to run the try callback
	@param {Function} finalizer The function to run the finally callback
	@param {Object} [binding] The optional calling object. Defaults to 'this'
	@return {*} The return value is the that of the finalizer,
	unless that value is undefined, in which case it is the return value
	of the tryable
*/

if (needsFinallyFix) {
	Ember.tryFinally = function(tryable, finalizer, binding) {
		var result, finalResult, finalError;

		binding = binding || this;

		try {
			result = tryable.call(binding);
		} finally {
			try {
				finalResult = finalizer.call(binding);
			} catch (e) {
				finalError = e;
			}
		}

		if (finalError) { throw finalError; }

		return (finalResult === undefined) ? result : finalResult;
	};
} else {
	Ember.tryFinally = function(tryable, finalizer, binding) {
		var result, finalResult;

		binding = binding || this;

		try {
			result = tryable.call(binding);
		} finally {
			finalResult = finalizer.call(binding);
		}

		return (finalResult === undefined) ? result : finalResult;
	};
}

/**
	Provides try { } catch finally { } functionality, while working
	around Safari's double finally bug.

	```javascript
	var tryable = function() {
		for (i=0, l=listeners.length; i<l; i++) {
			listener = listeners[i];
			beforeValues[i] = listener.before(name, time(), payload);
		}

		return callback.call(binding);
	};

	var catchable = function(e) {
		payload = payload || {};
		payload.exception = e;
	};

	var finalizer = function() {
		for (i=0, l=listeners.length; i<l; i++) {
			listener = listeners[i];
			listener.after(name, time(), payload, beforeValues[i]);
		}
	};
	Ember.tryCatchFinally(tryable, catchable, finalizer);
	```

	@method tryCatchFinally
	@for Ember
	@param {Function} tryable The function to run the try callback
	@param {Function} catchable The function to run the catchable callback
	@param {Function} finalizer The function to run the finally callback
	@param {Object} [binding] The optional calling object. Defaults to 'this'
	@return {*} The return value is the that of the finalizer,
	unless that value is undefined, in which case it is the return value
	of the tryable.
*/
if (needsFinallyFix) {
	Ember.tryCatchFinally = function(tryable, catchable, finalizer, binding) {
		var result, finalResult, finalError;

		binding = binding || this;

		try {
			result = tryable.call(binding);
		} catch(error) {
			result = catchable.call(binding, error);
		} finally {
			try {
				finalResult = finalizer.call(binding);
			} catch (e) {
				finalError = e;
			}
		}

		if (finalError) { throw finalError; }

		return (finalResult === undefined) ? result : finalResult;
	};
} else {
	Ember.tryCatchFinally = function(tryable, catchable, finalizer, binding) {
		var result, finalResult;

		binding = binding || this;

		try {
			result = tryable.call(binding);
		} catch(error) {
			result = catchable.call(binding, error);
		} finally {
			finalResult = finalizer.call(binding);
		}

		return (finalResult === undefined) ? result : finalResult;
	};
}

// ........................................
// TYPING & ARRAY MESSAGING
//

var TYPE_MAP = {};
var t = "Boolean Number String Function Array Date RegExp Object".split(" ");
Ember.ArrayPolyfills.forEach.call(t, function(name) {
	TYPE_MAP[ "[object " + name + "]" ] = name.toLowerCase();
});

var toString = Object.prototype.toString;

/**
	Returns a consistent type for the passed item.

	Use this instead of the built-in `typeof` to get the type of an item.
	It will return the same result across all browsers and includes a bit
	more detail. Here is what will be returned:

			| Return Value  | Meaning                                              |
			|---------------|------------------------------------------------------|
			| 'string'      | String primitive or String object.                   |
			| 'number'      | Number primitive or Number object.                   |
			| 'boolean'     | Boolean primitive or Boolean object.                 |
			| 'null'        | Null value                                           |
			| 'undefined'   | Undefined value                                      |
			| 'function'    | A function                                           |
			| 'array'       | An instance of Array                                 |
			| 'regexp'      | An instance of RegExp                                |
			| 'date'        | An instance of Date                                  |
			| 'class'       | An Ember class (created using Ember.Object.extend()) |
			| 'instance'    | An Ember object instance                             |
			| 'error'       | An instance of the Error object                      |
			| 'object'      | A JavaScript object not inheriting from Ember.Object |

	Examples:

	```javascript
	Ember.typeOf();                       // 'undefined'
	Ember.typeOf(null);                   // 'null'
	Ember.typeOf(undefined);              // 'undefined'
	Ember.typeOf('michael');              // 'string'
	Ember.typeOf(new String('michael'));  // 'string'
	Ember.typeOf(101);                    // 'number'
	Ember.typeOf(new Number(101));        // 'number'
	Ember.typeOf(true);                   // 'boolean'
	Ember.typeOf(new Boolean(true));      // 'boolean'
	Ember.typeOf(Ember.makeArray);        // 'function'
	Ember.typeOf([1,2,90]);               // 'array'
	Ember.typeOf(/abc/);                  // 'regexp'
	Ember.typeOf(new Date());             // 'date'
	Ember.typeOf(Ember.Object.extend());  // 'class'
	Ember.typeOf(Ember.Object.create());  // 'instance'
	Ember.typeOf(new Error('teamocil'));  // 'error'

	// "normal" JavaScript object
	Ember.typeOf({a: 'b'});              // 'object'
	```

	@method typeOf
	@for Ember
	@param {Object} item the item to check
	@return {String} the type
*/
Ember.typeOf = function(item) {
	var ret;

	ret = (item === null || item === undefined) ? String(item) : TYPE_MAP[toString.call(item)] || 'object';

	if (ret === 'function') {
		if (Ember.Object && Ember.Object.detect(item)) ret = 'class';
	} else if (ret === 'object') {
		if (item instanceof Error) ret = 'error';
		else if (Ember.Object && item instanceof Ember.Object) ret = 'instance';
		else if (item instanceof Date) ret = 'date';
	}

	return ret;
};

/**
	Convenience method to inspect an object. This method will attempt to
	convert the object into a useful string description.

	It is a pretty simple implementation. If you want something more robust,
	use something like JSDump: https://github.com/NV/jsDump

	@method inspect
	@for Ember
	@param {Object} obj The object you want to inspect.
	@return {String} A description of the object
*/
Ember.inspect = function(obj) {
	var type = Ember.typeOf(obj);
	if (type === 'array') {
		return '[' + obj + ']';
	}
	if (type !== 'object') {
		return obj + '';
	}

	var v, ret = [];
	for(var key in obj) {
		if (obj.hasOwnProperty(key)) {
			v = obj[key];
			if (v === 'toString') { continue; } // ignore useless items
			if (Ember.typeOf(v) === 'function') { v = "function() { ... }"; }
			ret.push(key + ": " + v);
		}
	}
	return "{" + ret.join(", ") + "}";
};



})();



(function() {
// Ember.tryCatchFinally

/**
	The purpose of the Ember Instrumentation module is
	to provide efficient, general-purpose instrumentation
	for Ember.

	Subscribe to a listener by using `Ember.subscribe`:

	```javascript
	Ember.subscribe("render", {
		before: function(name, timestamp, payload) {

		},

		after: function(name, timestamp, payload) {

		}
	});
	```

	If you return a value from the `before` callback, that same
	value will be passed as a fourth parameter to the `after`
	callback.

	Instrument a block of code by using `Ember.instrument`:

	```javascript
	Ember.instrument("render.handlebars", payload, function() {
		// rendering logic
	}, binding);
	```

	Event names passed to `Ember.instrument` are namespaced
	by periods, from more general to more specific. Subscribers
	can listen for events by whatever level of granularity they
	are interested in.

	In the above example, the event is `render.handlebars`,
	and the subscriber listened for all events beginning with
	`render`. It would receive callbacks for events named
	`render`, `render.handlebars`, `render.container`, or
	even `render.handlebars.layout`.

	@class Instrumentation
	@namespace Ember
	@static
*/
Ember.Instrumentation = {};

var subscribers = [], cache = {};

var populateListeners = function(name) {
	var listeners = [], subscriber;

	for (var i=0, l=subscribers.length; i<l; i++) {
		subscriber = subscribers[i];
		if (subscriber.regex.test(name)) {
			listeners.push(subscriber.object);
		}
	}

	cache[name] = listeners;
	return listeners;
};

var time = (function() {
	var perf = 'undefined' !== typeof window ? window.performance || {} : {};
	var fn = perf.now || perf.mozNow || perf.webkitNow || perf.msNow || perf.oNow;
	// fn.bind will be available in all the browsers that support the advanced window.performance... ;-)
	return fn ? fn.bind(perf) : function() { return +new Date(); };
})();

/**
	Notifies event's subscribers, calls `before` and `after` hooks.

	@method instrument
	@namespace Ember.Instrumentation

	@param {String} [name] Namespaced event name.
	@param {Object} payload
	@param {Function} callback Function that you're instrumenting.
	@param {Object} binding Context that instrument function is called with.
*/
Ember.Instrumentation.instrument = function(name, payload, callback, binding) {
	var listeners = cache[name], timeName, ret;

	if (Ember.STRUCTURED_PROFILE) {
		timeName = name + ": " + payload.object;
		console.time(timeName);
	}

	if (!listeners) {
		listeners = populateListeners(name);
	}

	if (listeners.length === 0) {
		ret = callback.call(binding);
		if (Ember.STRUCTURED_PROFILE) { console.timeEnd(timeName); }
		return ret;
	}

	var beforeValues = [], listener, i, l;

	function tryable() {
		for (i=0, l=listeners.length; i<l; i++) {
			listener = listeners[i];
			beforeValues[i] = listener.before(name, time(), payload);
		}

		return callback.call(binding);
	}

	function catchable(e) {
		payload = payload || {};
		payload.exception = e;
	}

	function finalizer() {
		for (i=0, l=listeners.length; i<l; i++) {
			listener = listeners[i];
			listener.after(name, time(), payload, beforeValues[i]);
		}

		if (Ember.STRUCTURED_PROFILE) {
			console.timeEnd(timeName);
		}
	}

	return Ember.tryCatchFinally(tryable, catchable, finalizer);
};

/**
	Subscribes to a particular event or instrumented block of code.

	@method subscribe
	@namespace Ember.Instrumentation

	@param {String} [pattern] Namespaced event name.
	@param {Object} [object] Before and After hooks.

	@return {Subscriber}
*/
Ember.Instrumentation.subscribe = function(pattern, object) {
	var paths = pattern.split("."), path, regex = [];

	for (var i=0, l=paths.length; i<l; i++) {
		path = paths[i];
		if (path === "*") {
			regex.push("[^\\.]*");
		} else {
			regex.push(path);
		}
	}

	regex = regex.join("\\.");
	regex = regex + "(\\..*)?";

	var subscriber = {
		pattern: pattern,
		regex: new RegExp("^" + regex + "$"),
		object: object
	};

	subscribers.push(subscriber);
	cache = {};

	return subscriber;
};

/**
	Unsubscribes from a particular event or instrumented block of code.

	@method unsubscribe
	@namespace Ember.Instrumentation

	@param {Object} [subscriber]
*/
Ember.Instrumentation.unsubscribe = function(subscriber) {
	var index;

	for (var i=0, l=subscribers.length; i<l; i++) {
		if (subscribers[i] === subscriber) {
			index = i;
		}
	}

	subscribers.splice(index, 1);
	cache = {};
};

/**
	Resets `Ember.Instrumentation` by flushing list of subscribers.

	@method reset
	@namespace Ember.Instrumentation
*/
Ember.Instrumentation.reset = function() {
	subscribers = [];
	cache = {};
};

Ember.instrument = Ember.Instrumentation.instrument;
Ember.subscribe = Ember.Instrumentation.subscribe;
})();



(function() {
var map, forEach, indexOf, splice, filter;
map     = Array.prototype.map     || Ember.ArrayPolyfills.map;
forEach = Array.prototype.forEach || Ember.ArrayPolyfills.forEach;
indexOf = Array.prototype.indexOf || Ember.ArrayPolyfills.indexOf;
filter = Array.prototype.filter || Ember.ArrayPolyfills.filter;
splice = Array.prototype.splice;

var utils = Ember.EnumerableUtils = {
	map: function(obj, callback, thisArg) {
		return obj.map ? obj.map.call(obj, callback, thisArg) : map.call(obj, callback, thisArg);
	},

	forEach: function(obj, callback, thisArg) {
		return obj.forEach ? obj.forEach.call(obj, callback, thisArg) : forEach.call(obj, callback, thisArg);
	},

	filter: function(obj, callback, thisArg) {
		return obj.filter ? obj.filter.call(obj, callback, thisArg) : filter.call(obj, callback, thisArg);
	},

	indexOf: function(obj, element, index) {
		return obj.indexOf ? obj.indexOf.call(obj, element, index) : indexOf.call(obj, element, index);
	},

	indexesOf: function(obj, elements) {
		return elements === undefined ? [] : utils.map(elements, function(item) {
			return utils.indexOf(obj, item);
		});
	},

	addObject: function(array, item) {
		var index = utils.indexOf(array, item);
		if (index === -1) { array.push(item); }
	},

	removeObject: function(array, item) {
		var index = utils.indexOf(array, item);
		if (index !== -1) { array.splice(index, 1); }
	},

	_replace: function(array, idx, amt, objects) {
		var args = [].concat(objects), chunk, ret = [],
				// https://code.google.com/p/chromium/issues/detail?id=56588
				size = 60000, start = idx, ends = amt, count;

		while (args.length) {
			count = ends > size ? size : ends;
			if (count <= 0) { count = 0; }

			chunk = args.splice(0, size);
			chunk = [start, count].concat(chunk);

			start += size;
			ends -= count;

			ret = ret.concat(splice.apply(array, chunk));
		}
		return ret;
	},

	replace: function(array, idx, amt, objects) {
		if (array.replace) {
			return array.replace(idx, amt, objects);
		} else {
			return utils._replace(array, idx, amt, objects);
		}
	},

	intersection: function(array1, array2) {
		var intersection = [];

		utils.forEach(array1, function(element) {
			if (utils.indexOf(array2, element) >= 0) {
				intersection.push(element);
			}
		});

		return intersection;
	}
};

})();



(function() {
/**
@module ember-metal
*/

var META_KEY = Ember.META_KEY, get;

var MANDATORY_SETTER = Ember.ENV.MANDATORY_SETTER;

var IS_GLOBAL_PATH = /^([A-Z$]|([0-9][A-Z$])).*[\.\*]/;
var HAS_THIS  = /^this[\.\*]/;
var FIRST_KEY = /^([^\.\*]+)/;

// ..........................................................
// GET AND SET
//
// If we are on a platform that supports accessors we can use those.
// Otherwise simulate accessors by looking up the property directly on the
// object.

/**
	Gets the value of a property on an object. If the property is computed,
	the function will be invoked. If the property is not defined but the
	object implements the `unknownProperty` method then that will be invoked.

	If you plan to run on IE8 and older browsers then you should use this
	method anytime you want to retrieve a property on an object that you don't
	know for sure is private. (Properties beginning with an underscore '_'
	are considered private.)

	On all newer browsers, you only need to use this method to retrieve
	properties if the property might not be defined on the object and you want
	to respect the `unknownProperty` handler. Otherwise you can ignore this
	method.

	Note that if the object itself is `undefined`, this method will throw
	an error.

	@method get
	@for Ember
	@param {Object} obj The object to retrieve from.
	@param {String} keyName The property key to retrieve
	@return {Object} the property value or `null`.
*/
get = function get(obj, keyName) {
	// Helpers that operate with 'this' within an #each
	// if (keyName === '') {
	//   return obj;
	// }

	// if (!keyName && 'string'===typeof obj) {
	//   keyName = obj;
	//   obj = null;
	// }

	// Ember.assert("Cannot call get with "+ keyName +" key.", !!keyName);
	// Ember.assert("Cannot call get with '"+ keyName +"' on an undefined object.", obj !== undefined);

	if (obj === null || keyName.indexOf('.') !== -1) {
		return getPath(obj, keyName);
	}

	var meta = obj.__ember_meta, desc = meta && meta.descs[keyName], ret;
	if (desc) {
		return desc.get(obj, keyName);
	} else {
		// if (MANDATORY_SETTER && meta && meta.watching[keyName] > 0) {
		//   ret = meta.values[keyName];
		// } else {
			ret = obj[keyName];
		// }

		if (ret === undefined &&
				'object' === typeof obj && !(keyName in obj) && 'function' === typeof obj.unknownProperty) {
			return obj.unknownProperty(keyName);
		}

		return ret;
	}
};

// Currently used only by Ember Data tests
if (Ember.config.overrideAccessors) {
	Ember.get = get;
	Ember.config.overrideAccessors();
	get = Ember.get;
}

/**
	Normalizes a target/path pair to reflect that actual target/path that should
	be observed, etc. This takes into account passing in global property
	paths (i.e. a path beginning with a captial letter not defined on the
	target) and * separators.

	@private
	@method normalizeTuple
	@for Ember
	@param {Object} target The current target. May be `null`.
	@param {String} path A path on the target or a global property path.
	@return {Array} a temporary array with the normalized target/path pair.
*/
var normalizeTuple = Ember.normalizeTuple = function(target, path) {
	var hasThis  = HAS_THIS.test(path),
			isGlobal = !hasThis && IS_GLOBAL_PATH.test(path),
			key;

	if (!target || isGlobal) target = Ember.lookup;
	if (hasThis) path = path.slice(5);

	if (target === Ember.lookup) {
		key = path.match(FIRST_KEY)[0];
		target = get(target, key);
		path   = path.slice(key.length+1);
	}

	// must return some kind of path to be valid else other things will break.
	if (!path || path.length===0) throw new Ember.Error('Path cannot be empty');

	return [ target, path ];
};

var getPath = Ember._getPath = function(root, path) {
	var hasThis, parts, tuple, idx, len;

	// If there is no root and path is a key name, return that
	// property from the global object.
	// E.g. get('Ember') -> Ember
	if (root === null && path.indexOf('.') === -1) { return get(Ember.lookup, path); }

	// detect complicated paths and normalize them
	hasThis  = HAS_THIS.test(path);

	if (!root || hasThis) {
		tuple = normalizeTuple(root, path);
		root = tuple[0];
		path = tuple[1];
		tuple.length = 0;
	}

	parts = path.split(".");
	len = parts.length;
	for (idx = 0; root != null && idx < len; idx++) {
		root = get(root, parts[idx], true);
		if (root && root.isDestroyed) { return undefined; }
	}
	return root;
};

Ember.getWithDefault = function(root, key, defaultValue) {
	var value = get(root, key);

	if (value === undefined) { return defaultValue; }
	return value;
};


Ember.get = get;

})();



(function() {
/**
@module ember-metal
*/

var o_create = Ember.create,
		Utils = Ember.Utils,
		metaFor = Ember.meta,
		META_KEY = Ember.META_KEY,
		a_slice = [].slice,
		/* listener flags */
		ONCE = 1, SUSPENDED = 2;

/*
	The event system uses a series of nested hashes to store listeners on an
	object. When a listener is registered, or when an event arrives, these
	hashes are consulted to determine which target and action pair to invoke.

	The hashes are stored in the object's meta hash, and look like this:

			// Object's meta hash
			{
				listeners: {       // variable name: `listenerSet`
					"foo:changed": [ // variable name: `actions`
						target, method, flags
					]
				}
			}

*/

function indexOf(array, target, method) {
	var index = -1;
	for (var i = 0, l = array.length; i < l; i += 3) {
		if (target === array[i] && method === array[i+1]) { index = i; break; }
	}
	return index;
}

function actionsFor(obj, eventName, m) {
	var meta = m || Utils.meta(obj),
			actions;

	if (!meta.listeners) { meta.listeners = {}; }

	if (!meta.hasOwnProperty('listeners')) {
		// setup inherited copy of the listeners object
		meta.listeners = o_create(meta.listeners);
	}

	actions = meta.listeners[eventName];

	// if there are actions, but the eventName doesn't exist in our listeners, then copy them from the prototype
	if (actions && !meta.listeners.hasOwnProperty(eventName)) {
		actions = meta.listeners[eventName] = meta.listeners[eventName].slice();
	} else if (!actions) {
		actions = meta.listeners[eventName] = [];
	}

	return actions;
}

function actionsUnion(obj, eventName, otherActions) {
	var meta = obj[META_KEY],
			actions = meta && meta.listeners && meta.listeners[eventName];

	if (!actions) { return; }
	for (var i = actions.length - 3; i >= 0; i -= 3) {
		var target = actions[i],
				method = actions[i+1],
				flags = actions[i+2],
				actionIndex = indexOf(otherActions, target, method);

		if (actionIndex === -1) {
			otherActions.push(target, method, flags);
		}
	}
}

function actionsDiff(obj, eventName, otherActions) {
	var meta = obj[META_KEY],
			actions = meta && meta.listeners && meta.listeners[eventName],
			diffActions = [];

	if (!actions) { return; }
	for (var i = actions.length - 3; i >= 0; i -= 3) {
		var target = actions[i],
				method = actions[i+1],
				flags = actions[i+2],
				actionIndex = indexOf(otherActions, target, method);

		if (actionIndex !== -1) { continue; }

		otherActions.push(target, method, flags);
		diffActions.push(target, method, flags);
	}

	return diffActions;
}

/**
	Add an event listener

	@method addListener
	@for Ember
	@param obj
	@param {String} eventName
	@param {Object|Function} targetOrMethod A target object or a function
	@param {Function|String} method A function or the name of a function to be called on `target`
	@param {Boolean} once A flag whether a function should only be called once
*/
function addListener(obj, eventName, target, method, once) {

	if (!method && 'function' === typeof target) {
		method = target;
		target = null;
	}

	var meta = Utils.meta(obj),
			actions = actionsFor(obj, eventName, meta),
			// actionIndex = indexOf(actions, target, method),
			flags = 0;

	if (once) flags |= ONCE;

	// if (actionIndex !== -1) { return; }

	actions.push(target, method, flags);

	if ('function' === typeof obj.didAddListener) {
		obj.didAddListener(eventName, target, method);
	}

	return meta;
}

/**
	Remove an event listener

	Arguments should match those passed to `Ember.addListener`.

	@method removeListener
	@for Ember
	@param obj
	@param {String} eventName
	@param {Object|Function} targetOrMethod A target object or a function
	@param {Function|String} method A function or the name of a function to be called on `target`
*/
function removeListener(obj, eventName, target, method) {

	if (!method && 'function' === typeof target) {
		method = target;
		target = null;
	}

	function _removeListener(target, method) {
		var actions = actionsFor(obj, eventName),
				actionIndex = indexOf(actions, target, method);

		// action doesn't exist, give up silently
		if (actionIndex === -1) { return; }

		actions.splice(actionIndex, 3);

		if ('function' === typeof obj.didRemoveListener) {
			obj.didRemoveListener(eventName, target, method);
		}
	}

	if (method) {
		_removeListener(target, method);
	} else {
		var meta = obj[META_KEY],
				actions = meta && meta.listeners && meta.listeners[eventName];

		if (!actions) { return; }
		for (var i = actions.length - 3; i >= 0; i -= 3) {
			_removeListener(actions[i], actions[i+1]);
		}
	}
}

/**
	Suspend listener during callback.

	This should only be used by the target of the event listener
	when it is taking an action that would cause the event, e.g.
	an object might suspend its property change listener while it is
	setting that property.

	@private
	@method suspendListener
	@for Ember
	@param obj
	@param {String} eventName
	@param {Object|Function} targetOrMethod A target object or a function
	@param {Function|String} method A function or the name of a function to be called on `target`
	@param {Function} callback
*/
function suspendListener(obj, eventName, target, method, callback) {
	if (!method && 'function' === typeof target) {
		method = target;
		target = null;
	}

	var actions = actionsFor(obj, eventName),
			actionIndex = indexOf(actions, target, method);

	if (actionIndex !== -1) {
		actions[actionIndex+2] |= SUSPENDED; // mark the action as suspended
	}

	function tryable()   { return callback.call(target); }
	function finalizer() { if (actionIndex !== -1) { actions[actionIndex+2] &= ~SUSPENDED; } }

	return Ember.tryFinally(tryable, finalizer);
}

/**
	Suspends multiple listeners during a callback.

	@private
	@method suspendListeners
	@for Ember
	@param obj
	@param {Array} eventName Array of event names
	@param {Object|Function} targetOrMethod A target object or a function
	@param {Function|String} method A function or the name of a function to be called on `target`
	@param {Function} callback
*/
function suspendListeners(obj, eventNames, target, method, callback) {
	if (!method && 'function' === typeof target) {
		method = target;
		target = null;
	}

	var suspendedActions = [],
			actionsList = [],
			eventName, actions, i, l;

	for (i=0, l=eventNames.length; i<l; i++) {
		eventName = eventNames[i];
		actions = actionsFor(obj, eventName);
		var actionIndex = indexOf(actions, target, method);

		if (actionIndex !== -1) {
			actions[actionIndex+2] |= SUSPENDED;
			suspendedActions.push(actionIndex);
			actionsList.push(actions);
		}
	}

	function tryable() { return callback.call(target); }

	function finalizer() {
		for (var i = 0, l = suspendedActions.length; i < l; i++) {
			var actionIndex = suspendedActions[i];
			actionsList[i][actionIndex+2] &= ~SUSPENDED;
		}
	}

	return Ember.tryFinally(tryable, finalizer);
}

/**
	Return a list of currently watched events

	@private
	@method watchedEvents
	@for Ember
	@param obj
*/
function watchedEvents(obj) {
	var listeners = obj[META_KEY].listeners, ret = [];

	if (listeners) {
		for(var eventName in listeners) {
			if (listeners[eventName]) { ret.push(eventName); }
		}
	}
	return ret;
}

/**
	Send an event. The execution of suspended listeners
	is skipped, and once listeners are removed. A listener without
	a target is executed on the passed object. If an array of actions
	is not passed, the actions stored on the passed object are invoked.

	@method sendEvent
	@for Ember
	@param obj
	@param {String} eventName
	@param {Array} params Optional parameters for each listener.
	@param {Array} actions Optional array of actions (listeners).
	@return true
*/
function sendEvent(obj, eventName, params, actions) {
	// first give object a chance to handle it
	if (obj !== Ember && 'function' === typeof obj.sendEvent) {
		obj.sendEvent(eventName, params);
	}

	if (!actions) {
		var meta = obj[META_KEY];
		actions = meta && meta.listeners && meta.listeners[eventName];
	}

	if (!actions) { return; }

	for (var i = actions.length - 3; i >= 0; i -= 3) { // looping in reverse for once listeners
		var target = actions[i], method = actions[i+1], flags = actions[i+2];
		if (!method) { continue; }
		if (flags & SUSPENDED) { continue; }
		if (flags & ONCE) { removeListener(obj, eventName, target, method); }
		if (!target) { target = obj; }
		if ('string' === typeof method) { method = target[method]; }
		if (params) {
			method.apply(target, params);
		} else {
			method.call(target);
		}
	}
	return true;
}

/**
	@private
	@method hasListeners
	@for Ember
	@param obj
	@param {String} eventName
*/
function hasListeners(obj, eventName) {
	var meta = obj[META_KEY],
			actions = meta && meta.listeners && meta.listeners[eventName];

	return !!(actions && actions.length);
}

/**
	@private
	@method listenersFor
	@for Ember
	@param obj
	@param {String} eventName
*/
function listenersFor(obj, eventName) {
	var ret = [];
	var meta = obj[META_KEY],
			actions = meta && meta.listeners && meta.listeners[eventName];

	if (!actions) { return ret; }

	for (var i = 0, l = actions.length; i < l; i += 3) {
		var target = actions[i],
				method = actions[i+1];
		ret.push([target, method]);
	}

	return ret;
}

/**
	Define a property as a function that should be executed when
	a specified event or events are triggered.


	``` javascript
	var Job = Ember.Object.extend({
		logCompleted: Ember.on('completed', function(){
			console.log('Job completed!');
		})
	});
	var job = Job.create();
	Ember.sendEvent(job, 'completed'); // Logs "Job completed!"
 ```

	@method on
	@for Ember
	@param {String} eventNames*
	@param {Function} func
	@return func
*/
Ember.on = function(){
	var func = a_slice.call(arguments, -1)[0],
			events = a_slice.call(arguments, 0, -1);
	func.__ember_listens__ = events;
	return func;
};

Ember.addListener = addListener;
Ember.removeListener = removeListener;
Ember._suspendListener = suspendListener;
Ember._suspendListeners = suspendListeners;
Ember.sendEvent = sendEvent;
Ember.hasListeners = hasListeners;
Ember.watchedEvents = watchedEvents;
Ember.listenersFor = listenersFor;
Ember.listenersDiff = actionsDiff;
Ember.listenersUnion = actionsUnion;

})();



(function() {
var guidFor = Ember.guidFor,
		sendEvent = Ember.sendEvent;

/*
	this.observerSet = {
		[senderGuid]: { // variable name: `keySet`
			[keyName]: listIndex
		}
	},
	this.observers = [
		{
			sender: obj,
			keyName: keyName,
			eventName: eventName,
			listeners: [
				[target, method, flags]
			]
		},
		...
	]
*/
var ObserverSet = Ember._ObserverSet = function() {
	this.clear();
};

ObserverSet.prototype.add = function(sender, keyName, eventName) {
	var observerSet = this.observerSet,
			observers = this.observers,
			senderGuid = guidFor(sender),
			keySet = observerSet[senderGuid],
			index;

	if (!keySet) {
		observerSet[senderGuid] = keySet = {};
	}
	index = keySet[keyName];
	if (index === undefined) {
		index = observers.push({
			sender: sender,
			keyName: keyName,
			eventName: eventName,
			listeners: []
		}) - 1;
		keySet[keyName] = index;
	}
	return observers[index].listeners;
};

ObserverSet.prototype.flush = function() {
	var observers = this.observers, i, len, observer, sender;
	this.clear();
	for (i=0, len=observers.length; i < len; ++i) {
		observer = observers[i];
		sender = observer.sender;
		if (sender.isDestroying || sender.isDestroyed) { continue; }
		sendEvent(sender, observer.eventName, [sender, observer.keyName], observer.listeners);
	}
};

ObserverSet.prototype.clear = function() {
	this.observerSet = {};
	this.observers = [];
};
})();



(function() {
var META_KEY = Ember.META_KEY,
		guidFor = Ember.guidFor,
		tryFinally = Ember.tryFinally,
		sendEvent = Ember.sendEvent,
		listenersUnion = Ember.listenersUnion,
		listenersDiff = Ember.listenersDiff,
		ObserverSet = Ember._ObserverSet,
		beforeObserverSet = new ObserverSet(),
		observerSet = new ObserverSet(),
		deferred = 0;

// ..........................................................
// PROPERTY CHANGES
//

/**
	This function is called just before an object property is about to change.
	It will notify any before observers and prepare caches among other things.

	Normally you will not need to call this method directly but if for some
	reason you can't directly watch a property you can invoke this method
	manually along with `Ember.propertyDidChange()` which you should call just
	after the property value changes.

	@method propertyWillChange
	@for Ember
	@param {Object} obj The object with the property that will change
	@param {String} keyName The property key (or path) that will change.
	@return {void}
*/
function propertyWillChange(obj, keyName) {
	var m = obj[META_KEY],
			watching = (m && m.watching[keyName] > 0) || keyName === 'length',
			proto = m && m.proto,
			desc = m && m.descs[keyName];

	if (!watching) { return; }
	if (proto === obj) { return; }
	if (desc && desc.willChange) { desc.willChange(obj, keyName); }
	if (m.deps) { dependentKeysWillChange(obj, keyName, m); }
	chainsWillChange(obj, keyName, m);
	notifyBeforeObservers(obj, keyName);
}
Ember.propertyWillChange = propertyWillChange;

/**
	This function is called just after an object property has changed.
	It will notify any observers and clear caches among other things.

	Normally you will not need to call this method directly but if for some
	reason you can't directly watch a property you can invoke this method
	manually along with `Ember.propertyWillChange()` which you should call just
	before the property value changes.

	@method propertyDidChange
	@for Ember
	@param {Object} obj The object with the property that will change
	@param {String} keyName The property key (or path) that will change.
	@return {void}
*/
function propertyDidChange(obj, keyName) {
	var m = obj[META_KEY],
			watching = (m && m.watching[keyName] > 0) || keyName === 'length',
			proto = m && m.proto,
			desc = m && m.descs[keyName];

	if (proto === obj) { return; }

	// shouldn't this mean that we're watching this key?
	if (desc && desc.didChange) { desc.didChange(obj, keyName); }
	if (!watching && keyName !== 'length') { return; }

	if (m.deps) { dependentKeysDidChange(obj, keyName, m); }
	chainsDidChange(obj, keyName, m, false);
	notifyObservers(obj, keyName);
}
Ember.propertyDidChange = propertyDidChange;

var WILL_SEEN, DID_SEEN;

// called whenever a property is about to change to clear the cache of any dependent keys (and notify those properties of changes, etc...)
function dependentKeysWillChange(obj, depKey, meta) {
	if (obj.isDestroying) { return; }

	var seen = WILL_SEEN, top = !seen;
	if (top) { seen = WILL_SEEN = {}; }
	iterDeps(propertyWillChange, obj, depKey, seen, meta);
	if (top) { WILL_SEEN = null; }
}

// called whenever a property has just changed to update dependent keys
function dependentKeysDidChange(obj, depKey, meta) {
	if (obj.isDestroying) { return; }

	var seen = DID_SEEN, top = !seen;
	if (top) { seen = DID_SEEN = {}; }
	iterDeps(propertyDidChange, obj, depKey, seen, meta);
	if (top) { DID_SEEN = null; }
}

function iterDeps(method, obj, depKey, seen, meta) {
	var guid = guidFor(obj);
	if (!seen[guid]) seen[guid] = {};
	if (seen[guid][depKey]) return;
	seen[guid][depKey] = true;

	var deps = meta.deps;
	deps = deps && deps[depKey];
	if (deps) {
		for(var key in deps) {
			var desc = meta.descs[key];
			if (desc && desc._suspended === obj) continue;
			method(obj, key);
		}
	}
}

function chainsWillChange(obj, keyName, m) {
	if (!(m.hasOwnProperty('chainWatchers') &&
				m.chainWatchers[keyName])) {
		return;
	}

	var nodes = m.chainWatchers[keyName],
			events = [],
			i, l;

	for(i = 0, l = nodes.length; i < l; i++) {
		nodes[i].willChange(events);
	}

	for (i = 0, l = events.length; i < l; i += 2) {
		propertyWillChange(events[i], events[i+1]);
	}
}

function chainsDidChange(obj, keyName, m, suppressEvents) {
	if (!(m && m.hasOwnProperty('chainWatchers') &&
				m.chainWatchers[keyName])) {
		return;
	}

	var nodes = m.chainWatchers[keyName],
			events = suppressEvents ? null : [],
			i, l;

	for(i = 0, l = nodes.length; i < l; i++) {
		nodes[i].didChange(events);
	}

	if (suppressEvents) {
		return;
	}

	for (i = 0, l = events.length; i < l; i += 2) {
		propertyDidChange(events[i], events[i+1]);
	}
}

Ember.overrideChains = function(obj, keyName, m) {
	chainsDidChange(obj, keyName, m, true);
};

/**
	@method beginPropertyChanges
	@chainable
	@private
*/
function beginPropertyChanges() {
	deferred++;
}

Ember.beginPropertyChanges = beginPropertyChanges;

/**
	@method endPropertyChanges
	@private
*/
function endPropertyChanges() {
	deferred--;
	if (deferred<=0) {
		beforeObserverSet.clear();
		observerSet.flush();
	}
}

Ember.endPropertyChanges = endPropertyChanges;

/**
	Make a series of property changes together in an
	exception-safe way.

	```javascript
	Ember.changeProperties(function() {
		obj1.set('foo', mayBlowUpWhenSet);
		obj2.set('bar', baz);
	});
	```

	@method changeProperties
	@param {Function} callback
	@param [binding]
*/
Ember.changeProperties = function(cb, binding) {
	beginPropertyChanges();
	tryFinally(cb, endPropertyChanges, binding);
};

function notifyBeforeObservers(obj, keyName) {
	if (obj.isDestroying) { return; }

	var eventName = keyName + ':before', listeners, diff;
	if (deferred) {
		listeners = beforeObserverSet.add(obj, keyName, eventName);
		diff = listenersDiff(obj, eventName, listeners);
		sendEvent(obj, eventName, [obj, keyName], diff);
	} else {
		sendEvent(obj, eventName, [obj, keyName]);
	}
}

function notifyObservers(obj, keyName) {
	if (obj.isDestroying) { return; }

	var eventName = keyName + ':change', listeners;
	if (deferred) {
		listeners = observerSet.add(obj, keyName, eventName);
		listenersUnion(obj, eventName, listeners);
	} else {
		sendEvent(obj, eventName, [obj, keyName]);
	}
}

})();



(function() {
// META_KEY
// _getPath
// propertyWillChange, propertyDidChange

var META_KEY = Ember.META_KEY,
		MANDATORY_SETTER = Ember.ENV.MANDATORY_SETTER,
		IS_GLOBAL = /^([A-Z$]|([0-9][A-Z$]))/,
		getPath = Ember._getPath;

/**
	Sets the value of a property on an object, respecting computed properties
	and notifying observers and other listeners of the change. If the
	property is not defined but the object implements the `setUnknownProperty`
	method then that will be invoked as well.

	If you plan to run on IE8 and older browsers then you should use this
	method anytime you want to set a property on an object that you don't
	know for sure is private. (Properties beginning with an underscore '_'
	are considered private.)

	On all newer browsers, you only need to use this method to set
	properties if the property might not be defined on the object and you want
	to respect the `setUnknownProperty` handler. Otherwise you can ignore this
	method.

	@method set
	@for Ember
	@param {Object} obj The object to modify.
	@param {String} keyName The property key to set
	@param {Object} value The value to set
	@return {Object} the passed value.
*/
var set = function set(obj, keyName, value, tolerant) {
	if (typeof obj === 'string') {
				value = keyName;
		keyName = obj;
		obj = null;
	}


	if (!obj || keyName.indexOf('.') !== -1) {
		return setPath(obj, keyName, value, tolerant);
	}


	var meta = obj[META_KEY], desc = meta && meta.descs[keyName],
			isUnknown, currentValue;
	if (desc) {
		desc.set(obj, keyName, value);
	} else {
		isUnknown = 'object' === typeof obj && !(keyName in obj);

		// setUnknownProperty is called if `obj` is an object,
		// the property does not already exist, and the
		// `setUnknownProperty` method exists on the object
		if (isUnknown && 'function' === typeof obj.setUnknownProperty) {
			obj.setUnknownProperty(keyName, value);
		} else if (meta && meta.watching[keyName] > 0) {
			if (MANDATORY_SETTER) {
				currentValue = meta.values[keyName];
			} else {
				currentValue = obj[keyName];
			}
			// only trigger a change if the value has changed
			if (value !== currentValue) {
				Ember.propertyWillChange(obj, keyName);
				if (MANDATORY_SETTER) {
					if ((currentValue === undefined && !(keyName in obj)) || !obj.propertyIsEnumerable(keyName)) {
						Ember.defineProperty(obj, keyName, null, value); // setup mandatory setter
					} else {
						meta.values[keyName] = value;
					}
				} else {
					obj[keyName] = value;
				}
				Ember.propertyDidChange(obj, keyName);
			}
		} else {
			obj[keyName] = value;
		}
	}
	return value;
};

// Currently used only by Ember Data tests
if (Ember.config.overrideAccessors) {
	Ember.set = set;
	Ember.config.overrideAccessors();
	set = Ember.set;
}

function setPath(root, path, value, tolerant) {
	var keyName;

	// get the last part of the path
	keyName = path.slice(path.lastIndexOf('.') + 1);

	// get the first part of the part
	path    = (path === keyName) ? keyName : path.slice(0, path.length-(keyName.length+1));

	// unless the path is this, look up the first part to
	// get the root
	if (path !== 'this') {
		root = getPath(root, path);
	}

	if (!keyName || keyName.length === 0) {
		throw new Ember.Error('Property set failed: You passed an empty path');
	}

	if (!root) {
		if (tolerant) { return; }
		else { throw new Ember.Error('Property set failed: object in path "'+path+'" could not be found or was destroyed.'); }
	}

	return set(root, keyName, value);
}

Ember.set = set;

/**
	Error-tolerant form of `Ember.set`. Will not blow up if any part of the
	chain is `undefined`, `null`, or destroyed.

	This is primarily used when syncing bindings, which may try to update after
	an object has been destroyed.

	@method trySet
	@for Ember
	@param {Object} obj The object to modify.
	@param {String} path The property path to set
	@param {Object} value The value to set
*/
Ember.trySet = function(root, path, value) {
	return set(root, path, value, true);
};

})();



(function() {
/**
@module ember-metal
*/

/*
	JavaScript (before ES6) does not have a Map implementation. Objects,
	which are often used as dictionaries, may only have Strings as keys.

	Because Ember has a way to get a unique identifier for every object
	via `Ember.guidFor`, we can implement a performant Map with arbitrary
	keys. Because it is commonly used in low-level bookkeeping, Map is
	implemented as a pure JavaScript object for performance.

	This implementation follows the current iteration of the ES6 proposal for
	maps (http://wiki.ecmascript.org/doku.php?id=harmony:simple_maps_and_sets),
	with two exceptions. First, because we need our implementation to be pleasant
	on older browsers, we do not use the `delete` name (using `remove` instead).
	Second, as we do not have the luxury of in-VM iteration, we implement a
	forEach method for iteration.

	Map is mocked out to look like an Ember object, so you can do
	`Ember.Map.create()` for symmetry with other Ember classes.
*/
var set = Ember.set,
		guidFor = Ember.guidFor,
		indexOf = Ember.ArrayPolyfills.indexOf;

var copy = function(obj) {
	var output = {};

	for (var prop in obj) {
		if (obj.hasOwnProperty(prop)) { output[prop] = obj[prop]; }
	}

	return output;
};

var copyMap = function(original, newObject) {
	var keys = original.keys.copy(),
			values = copy(original.values);

	newObject.keys = keys;
	newObject.values = values;
	newObject.length = original.length;

	return newObject;
};

/**
	This class is used internally by Ember and Ember Data.
	Please do not use it at this time. We plan to clean it up
	and add many tests soon.

	@class OrderedSet
	@namespace Ember
	@constructor
	@private
*/
var OrderedSet = Ember.OrderedSet = function() {
	this.clear();
};

/**
	@method create
	@static
	@return {Ember.OrderedSet}
*/
OrderedSet.create = function() {
	return new OrderedSet();
};


OrderedSet.prototype = {
	/**
		@method clear
	*/
	clear: function() {
		this.presenceSet = {};
		this.list = [];
	},

	/**
		@method add
		@param obj
	*/
	add: function(obj) {
		var guid = guidFor(obj),
				presenceSet = this.presenceSet,
				list = this.list;

		if (guid in presenceSet) { return; }

		presenceSet[guid] = true;
		list.push(obj);
	},

	/**
		@method remove
		@param obj
	*/
	remove: function(obj) {
		var guid = guidFor(obj),
				presenceSet = this.presenceSet,
				list = this.list;

		delete presenceSet[guid];

		var index = indexOf.call(list, obj);
		if (index > -1) {
			list.splice(index, 1);
		}
	},

	/**
		@method isEmpty
		@return {Boolean}
	*/
	isEmpty: function() {
		return this.list.length === 0;
	},

	/**
		@method has
		@param obj
		@return {Boolean}
	*/
	has: function(obj) {
		var guid = guidFor(obj),
				presenceSet = this.presenceSet;

		return guid in presenceSet;
	},

	/**
		@method forEach
		@param {Function} fn
		@param self
	*/
	forEach: function(fn, self) {
		// allow mutation during iteration
		var list = this.toArray();

		for (var i = 0, j = list.length; i < j; i++) {
			fn.call(self, list[i]);
		}
	},

	/**
		@method toArray
		@return {Array}
	*/
	toArray: function() {
		return this.list.slice();
	},

	/**
		@method copy
		@return {Ember.OrderedSet}
	*/
	copy: function() {
		var set = new OrderedSet();

		set.presenceSet = copy(this.presenceSet);
		set.list = this.toArray();

		return set;
	}
};

/**
	A Map stores values indexed by keys. Unlike JavaScript's
	default Objects, the keys of a Map can be any JavaScript
	object.

	Internally, a Map has two data structures:

	1. `keys`: an OrderedSet of all of the existing keys
	2. `values`: a JavaScript Object indexed by the `Ember.guidFor(key)`

	When a key/value pair is added for the first time, we
	add the key to the `keys` OrderedSet, and create or
	replace an entry in `values`. When an entry is deleted,
	we delete its entry in `keys` and `values`.

	@class Map
	@namespace Ember
	@private
	@constructor
*/
var Map = Ember.Map = function() {
	this.keys = Ember.OrderedSet.create();
	this.values = {};
};

/**
	@method create
	@static
*/
Map.create = function() {
	return new Map();
};

Map.prototype = {
	/**
		This property will change as the number of objects in the map changes.

		@property length
		@type number
		@default 0
	*/
	length: 0,


	/**
		Retrieve the value associated with a given key.

		@method get
		@param {*} key
		@return {*} the value associated with the key, or `undefined`
	*/
	get: function(key) {
		var values = this.values,
				guid = guidFor(key);

		return values[guid];
	},

	/**
		Adds a value to the map. If a value for the given key has already been
		provided, the new value will replace the old value.

		@method set
		@param {*} key
		@param {*} value
	*/
	set: function(key, value) {
		var keys = this.keys,
				values = this.values,
				guid = guidFor(key);

		keys.add(key);
		values[guid] = value;
		set(this, 'length', keys.list.length);
	},

	/**
		Removes a value from the map for an associated key.

		@method remove
		@param {*} key
		@return {Boolean} true if an item was removed, false otherwise
	*/
	remove: function(key) {
		// don't use ES6 "delete" because it will be annoying
		// to use in browsers that are not ES6 friendly;
		var keys = this.keys,
				values = this.values,
				guid = guidFor(key);

		if (values.hasOwnProperty(guid)) {
			keys.remove(key);
			delete values[guid];
			set(this, 'length', keys.list.length);
			return true;
		} else {
			return false;
		}
	},

	/**
		Check whether a key is present.

		@method has
		@param {*} key
		@return {Boolean} true if the item was present, false otherwise
	*/
	has: function(key) {
		var values = this.values,
				guid = guidFor(key);

		return values.hasOwnProperty(guid);
	},

	/**
		Iterate over all the keys and values. Calls the function once
		for each key, passing in the key and value, in that order.

		The keys are guaranteed to be iterated over in insertion order.

		@method forEach
		@param {Function} callback
		@param {*} self if passed, the `this` value inside the
			callback. By default, `this` is the map.
	*/
	forEach: function(callback, self) {
		var keys = this.keys,
				values = this.values;

		keys.forEach(function(key) {
			var guid = guidFor(key);
			callback.call(self, key, values[guid]);
		});
	},

	/**
		@method copy
		@return {Ember.Map}
	*/
	copy: function() {
		return copyMap(this, new Map());
	}
};

/**
	@class MapWithDefault
	@namespace Ember
	@extends Ember.Map
	@private
	@constructor
	@param [options]
		@param {*} [options.defaultValue]
*/
var MapWithDefault = Ember.MapWithDefault = function(options) {
	Map.call(this);
	this.defaultValue = options.defaultValue;
};

/**
	@method create
	@static
	@param [options]
		@param {*} [options.defaultValue]
	@return {Ember.MapWithDefault|Ember.Map} If options are passed, returns
		`Ember.MapWithDefault` otherwise returns `Ember.Map`
*/
MapWithDefault.create = function(options) {
	if (options) {
		return new MapWithDefault(options);
	} else {
		return new Map();
	}
};

MapWithDefault.prototype = Ember.create(Map.prototype);

/**
	Retrieve the value associated with a given key.

	@method get
	@param {*} key
	@return {*} the value associated with the key, or the default value
*/
MapWithDefault.prototype.get = function(key) {
	var hasValue = this.has(key);

	if (hasValue) {
		return Map.prototype.get.call(this, key);
	} else {
		var defaultValue = this.defaultValue(key);
		this.set(key, defaultValue);
		return defaultValue;
	}
};

/**
	@method copy
	@return {Ember.MapWithDefault}
*/
MapWithDefault.prototype.copy = function() {
	return copyMap(this, new MapWithDefault({
		defaultValue: this.defaultValue
	}));
};

})();



(function() {
function consoleMethod(name) {
	var consoleObj, logToConsole;
	if (Ember.imports.console) {
		consoleObj = Ember.imports.console;
	} else if (typeof console !== 'undefined') {
		consoleObj = console;
	}

	var method = typeof consoleObj === 'object' ? consoleObj[name] : null;

	if (method) {
		// Older IE doesn't support apply, but Chrome needs it
		if (method.apply) {
			logToConsole = function() {
				method.apply(consoleObj, arguments);
			};
			logToConsole.displayName = 'console.' + name;
			return logToConsole;
		} else {
			return function() {
				var message = Array.prototype.join.call(arguments, ', ');
				method(message);
			};
		}
	}
}

function assertPolyfill(test, message) {
	if (!test) {
		try {
			// attempt to preserve the stack
			throw new Ember.Error("assertion failed: " + message);
		} catch(error) {
			setTimeout(function() {
				throw error;
			}, 0);
		}
	}
}

/**
	Inside Ember-Metal, simply uses the methods from `imports.console`.
	Override this to provide more robust logging functionality.

	@class Logger
	@namespace Ember
*/
Ember.Logger = {
	/**
	 Logs the arguments to the console.
	 You can pass as many arguments as you want and they will be joined together with a space.

		```javascript
		var foo = 1;
		Ember.Logger.log('log value of foo:', foo); // "log value of foo: 1" will be printed to the console
		```

	 @method log
	 @for Ember.Logger
	 @param {*} arguments
	*/
	log:   consoleMethod('log')   || Ember.K,

	/**
	 Prints the arguments to the console with a warning icon.
	 You can pass as many arguments as you want and they will be joined together with a space.

		```javascript
		Ember.Logger.warn('Something happened!'); // "Something happened!" will be printed to the console with a warning icon.
		```

	 @method warn
	 @for Ember.Logger
	 @param {*} arguments
	*/
	warn:  consoleMethod('warn')  || Ember.K,

	/**
	 Prints the arguments to the console with an error icon, red text and a stack trace.
	 You can pass as many arguments as you want and they will be joined together with a space.

		```javascript
		Ember.Logger.error('Danger! Danger!'); // "Danger! Danger!" will be printed to the console in red text.
		```

	 @method error
	 @for Ember.Logger
	 @param {*} arguments
	*/
	error: consoleMethod('error') || Ember.K,

	/**
	 Logs the arguments to the console.
	 You can pass as many arguments as you want and they will be joined together with a space.

		```javascript
		var foo = 1;
		Ember.Logger.info('log value of foo:', foo); // "log value of foo: 1" will be printed to the console
		```

	 @method info
	 @for Ember.Logger
	 @param {*} arguments
	*/
	info:  consoleMethod('info')  || Ember.K,

	/**
	 Logs the arguments to the console in blue text.
	 You can pass as many arguments as you want and they will be joined together with a space.

		```javascript
		var foo = 1;
		Ember.Logger.debug('log value of foo:', foo); // "log value of foo: 1" will be printed to the console
		```

	 @method debug
	 @for Ember.Logger
	 @param {*} arguments
	*/
	debug: consoleMethod('debug') || consoleMethod('info') || Ember.K,

	/**
	 If the value passed into `Ember.Logger.assert` is not truthy it will throw an error with a stack trace.

		```javascript
		Ember.Logger.assert(true); // undefined
		Ember.Logger.assert(true === false); // Throws an Assertion failed error.
		```

	 @method assert
	 @for Ember.Logger
	 @param {Boolean} bool Value to test
	*/
	assert: consoleMethod('assert') || assertPolyfill
};


})();



(function() {
/**
@module ember-metal
*/

var META_KEY = Ember.META_KEY,
		metaFor = Ember.meta,
		objectDefineProperty = Ember.platform.defineProperty;

var MANDATORY_SETTER = Ember.ENV.MANDATORY_SETTER;

// ..........................................................
// DESCRIPTOR
//

/**
	Objects of this type can implement an interface to respond to requests to
	get and set. The default implementation handles simple properties.

	You generally won't need to create or subclass this directly.

	@class Descriptor
	@namespace Ember
	@private
	@constructor
*/
Ember.Descriptor = function() {};

// ..........................................................
// DEFINING PROPERTIES API
//

var MANDATORY_SETTER_FUNCTION = Ember.MANDATORY_SETTER_FUNCTION = function(value) {
	};

var DEFAULT_GETTER_FUNCTION = Ember.DEFAULT_GETTER_FUNCTION = function(name) {
	return function() {
		var meta = this[META_KEY];
		return meta && meta.values[name];
	};
};

/**
	NOTE: This is a low-level method used by other parts of the API. You almost
	never want to call this method directly. Instead you should use
	`Ember.mixin()` to define new properties.

	Defines a property on an object. This method works much like the ES5
	`Object.defineProperty()` method except that it can also accept computed
	properties and other special descriptors.

	Normally this method takes only three parameters. However if you pass an
	instance of `Ember.Descriptor` as the third param then you can pass an
	optional value as the fourth parameter. This is often more efficient than
	creating new descriptor hashes for each property.

	## Examples

	```javascript
	// ES5 compatible mode
	Ember.defineProperty(contact, 'firstName', {
		writable: true,
		configurable: false,
		enumerable: true,
		value: 'Charles'
	});

	// define a simple property
	Ember.defineProperty(contact, 'lastName', undefined, 'Jolley');

	// define a computed property
	Ember.defineProperty(contact, 'fullName', Ember.computed(function() {
		return this.firstName+' '+this.lastName;
	}).property('firstName', 'lastName'));
	```

	@private
	@method defineProperty
	@for Ember
	@param {Object} obj the object to define this property on. This may be a prototype.
	@param {String} keyName the name of the property
	@param {Ember.Descriptor} [desc] an instance of `Ember.Descriptor` (typically a
		computed property) or an ES5 descriptor.
		You must provide this or `data` but not both.
	@param {*} [data] something other than a descriptor, that will
		become the explicit value of this property.
*/
Ember.defineProperty = function(obj, keyName, desc, data, meta) {
	var descs, existingDesc, watching, value;

	if (!meta) meta = metaFor(obj);
	descs = meta.descs;
	existingDesc = meta.descs[keyName];
	watching = meta.watching[keyName] > 0;

	if (existingDesc instanceof Ember.Descriptor) {
		existingDesc.teardown(obj, keyName);
	}

	if (desc instanceof Ember.Descriptor) {
		value = desc;

		descs[keyName] = desc;
		if (MANDATORY_SETTER && watching) {
			objectDefineProperty(obj, keyName, {
				configurable: true,
				enumerable: true,
				writable: true,
				value: undefined // make enumerable
			});
		} else {
			obj[keyName] = undefined; // make enumerable
		}


			if (desc.func && desc._dependentCPs) {
				addImplicitCPs(obj, desc._dependentCPs, meta);
			}

	} else {
		descs[keyName] = undefined; // shadow descriptor in proto
		if (desc == null) {
			value = data;

			if (MANDATORY_SETTER && watching) {
				meta.values[keyName] = data;
				objectDefineProperty(obj, keyName, {
					configurable: true,
					enumerable: true,
					set: MANDATORY_SETTER_FUNCTION,
					get: DEFAULT_GETTER_FUNCTION(keyName)
				});
			} else {
				obj[keyName] = data;
			}
		} else {
			value = desc;

			// compatibility with ES5
			objectDefineProperty(obj, keyName, desc);
		}
	}

	// if key is being watched, override chains that
	// were initialized with the prototype
	if (watching) { Ember.overrideChains(obj, keyName, meta); }

	// The `value` passed to the `didDefineProperty` hook is
	// either the descriptor or data, whichever was passed.
	if (obj.didDefineProperty) { obj.didDefineProperty(obj, keyName, value); }

	return this;
};


	var addImplicitCPs = function defineImplicitCPs(obj, implicitCPs, meta) {
		var cp, key, length = implicitCPs.length;

		for (var i=0; i<length; ++i) {
			cp = implicitCPs[i];
			key = cp.implicitCPKey;

			Ember.defineProperty(obj, key, cp, undefined, meta);

			if (cp._dependentCPs) {
				addImplicitCPs(obj, cp._dependentCPs, meta);
			}
		}
	};


})();



(function() {
var get = Ember.get;

/**
	To get multiple properties at once, call `Ember.getProperties`
	with an object followed by a list of strings or an array:

	```javascript
	Ember.getProperties(record, 'firstName', 'lastName', 'zipCode');  // { firstName: 'John', lastName: 'Doe', zipCode: '10011' }
	```

	is equivalent to:

	```javascript
	Ember.getProperties(record, ['firstName', 'lastName', 'zipCode']);  // { firstName: 'John', lastName: 'Doe', zipCode: '10011' }
	```

	@method getProperties
	@param obj
	@param {String...|Array} list of keys to get
	@return {Hash}
*/
Ember.getProperties = function(obj) {
	var ret = {},
			propertyNames = arguments,
			i = 1;

	if (arguments.length === 2 && Ember.typeOf(arguments[1]) === 'array') {
		i = 0;
		propertyNames = arguments[1];
	}
	for(var len = propertyNames.length; i < len; i++) {
		ret[propertyNames[i]] = get(obj, propertyNames[i]);
	}
	return ret;
};

})();



(function() {
var changeProperties = Ember.changeProperties,
		set = Ember.set;

/**
	Set a list of properties on an object. These properties are set inside
	a single `beginPropertyChanges` and `endPropertyChanges` batch, so
	observers will be buffered.

	```javascript
	anObject.setProperties({
		firstName: "Stanley",
		lastName: "Stuart",
		age: "21"
	})
	```

	@method setProperties
	@param self
	@param {Object} hash
	@return self
*/
Ember.setProperties = function(self, hash) {
	changeProperties(function() {
		for(var prop in hash) {
			if (hash.hasOwnProperty(prop)) { set(self, prop, hash[prop]); }
		}
	});
	return self;
};

})();



(function() {
var metaFor = Ember.meta, // utils.js
		Utils = Ember.Utils,
		typeOf = Ember.typeOf, // utils.js
		MANDATORY_SETTER = Ember.ENV.MANDATORY_SETTER,
		o_defineProperty = Ember.platform.defineProperty;

Ember.watchKey = function(obj, keyName, meta) {
	// can't watch length on Array - it is special...
	if (keyName === 'length' && typeOf(obj) === 'array') { return; }

	var m = meta || Utils.meta(obj), watching = m.watching;

	if (watching[keyName]) {
		watching[keyName]++;
	} else {
		// activate watching first time
		watching[keyName] = 1;

		if ('function' === typeof obj.willWatchProperty) {
			obj.willWatchProperty(keyName);
		}

		if (MANDATORY_SETTER && keyName in obj) {
			m.values[keyName] = obj[keyName];
			o_defineProperty(obj, keyName, {
				configurable: true,
				enumerable: obj.propertyIsEnumerable(keyName),
				set: Ember.MANDATORY_SETTER_FUNCTION,
				get: Ember.DEFAULT_GETTER_FUNCTION(keyName)
			});
		}
	}
};


Ember.unwatchKey = function(obj, keyName, meta) {
	var m = meta || Utils.meta(obj), watching = m.watching;

	if (watching[keyName] === 1) {
		watching[keyName] = 0;

		if ('function' === typeof obj.didUnwatchProperty) {
			obj.didUnwatchProperty(keyName);
		}

		if (MANDATORY_SETTER && keyName in obj) {
			o_defineProperty(obj, keyName, {
				configurable: true,
				enumerable: obj.propertyIsEnumerable(keyName),
				set: function(val) {
					// redefine to set as enumerable
					o_defineProperty(obj, keyName, {
						configurable: true,
						writable: true,
						enumerable: true,
						value: val
					});
					delete m.values[keyName];
				},
				get: Ember.DEFAULT_GETTER_FUNCTION(keyName)
			});
		}
	} else if (watching[keyName] > 1) {
		watching[keyName]--;
	}
};

})();



(function() {
var metaFor = Ember.meta, // utils.js
		get = Ember.get, // property_get.js
		normalizeTuple = Ember.normalizeTuple, // property_get.js
		forEach = Ember.ArrayPolyfills.forEach, // array.js
		warn = Ember.warn,
		watchKey = Ember.watchKey,
		unwatchKey = Ember.unwatchKey,
		FIRST_KEY = /^([^\.\*]+)/,
		META_KEY = Ember.META_KEY;

function firstKey(path) {
	return path.match(FIRST_KEY)[0];
}

var pendingQueue = [];

// attempts to add the pendingQueue chains again. If some of them end up
// back in the queue and reschedule is true, schedules a timeout to try
// again.
Ember.flushPendingChains = function() {
	if (pendingQueue.length === 0) { return; } // nothing to do

	var queue = pendingQueue;
	pendingQueue = [];

	forEach.call(queue, function(q) { q[0].add(q[1]); });

	warn('Watching an undefined global, Ember expects watched globals to be setup by the time the run loop is flushed, check for typos', pendingQueue.length === 0);
};

var Utils = Ember.Utils;

function addChainWatcher(obj, keyName, node) {
	if (!obj || ('object' !== typeof obj)) { return; } // nothing to do

	var m = Utils.meta(obj), nodes = m.chainWatchers;

	if (!m.hasOwnProperty('chainWatchers')) {
		nodes = m.chainWatchers = {};
	}

	if (!nodes[keyName]) {
		nodes[keyName] = [node];
	} else {
		nodes[keyName].push(node);
	}
	watchKey(obj, keyName, m);
}

var removeChainWatcher = Ember.removeChainWatcher = function(obj, keyName, node) {
	if (!obj || 'object' !== typeof obj) { return; } // nothing to do

	var m = obj[META_KEY];
	if (m && !m.hasOwnProperty('chainWatchers')) { return; } // nothing to do

	var nodes = m && m.chainWatchers;

	if (nodes && nodes[keyName]) {
		nodes = nodes[keyName];
		for (var i = 0, l = nodes.length; i < l; i++) {
			if (nodes[i] === node) { nodes.splice(i, 1); }
		}
	}
	unwatchKey(obj, keyName, m);
};

// A ChainNode watches a single key on an object. If you provide a starting
// value for the key then the node won't actually watch it. For a root node
// pass null for parent and key and object for value.
var ChainNode = Ember._ChainNode = function(parent, key, value, parentObj) {
	this._parent = parent;
	this._key    = key;
	this._chains = null;
	this.count   = 0;

	// _watching is true when calling get(this._parent, this._key) will
	// return the value of this node.
	//
	// It is false for the root of a chain (because we have no parent)
	// and for global paths (because the parent node is the object with
	// the observer on it)
	this._watching = value===undefined;

	this._value  = value;
	this._paths = {};
	if (this._watching) {
		this._object = parentObj || parent.value();
		if (this._object) { addChainWatcher(this._object, this._key, this); }
	} else {
		// Make sure to set so we have the same object shape
		this._object = null;
	}

	// Special-case: the EachProxy relies on immediate evaluation to
	// establish its observers.
	//
	// TODO: Replace this with an efficient callback that the EachProxy
	// can implement.
	if (this._parent && this._parent._key === '@each') {
		this.value();
	}
};

var ChainNodePrototype = ChainNode.prototype;

function lazyGet(obj, key) {
	if (!obj) return undefined;

	var meta = obj.__ember_meta;
	// check if object meant only to be a prototype
	if (meta && meta.proto === obj) return undefined;

	if (key === "@each") return get(obj, key);

	// if a CP only return cached value
	var desc = meta && meta.descs[key];
	if (desc && desc._cacheable) {
		if (key in meta.cache) {
			return meta.cache[key];
		} else {
			return undefined;
		}
	}

	return get(obj, key);
}

ChainNodePrototype.value = function() {
	if (this._value === undefined && this._watching) {
		var obj = this._parent.value();
		this._value = lazyGet(obj, this._key);
	}
	return this._value;
};

ChainNodePrototype.destroy = function() {
	if (this._watching) {
		var obj = this._object;
		if (obj) { removeChainWatcher(obj, this._key, this); }
		this._watching = false; // so future calls do nothing
	}
};

// copies a top level object only
ChainNodePrototype.copy = function(obj) {
	var ret = new ChainNode(null, null, obj),
			paths = this._paths, path;
	for (path in paths) {
		if (paths[path] <= 0) { continue; } // this check will also catch non-number vals.
		ret.add(path, obj);
	}
	return ret;
};

// called on the root node of a chain to setup watchers on the specified
// path.
ChainNodePrototype.add = function(path, parentObj) {
	var obj, tuple, key, src, paths;

	paths = this._paths;
	if (paths[path]) {
		paths[path]++;
	} else {
		paths[path] = 1;
	}

	obj = parentObj || this.value();
	tuple = normalizeTuple(obj, path);

	// the path was a local path
	if (tuple[0] && tuple[0] === obj) {
		path = tuple[1];
		key  = firstKey(path);
		path = path.slice(key.length+1);

	// global path, but object does not exist yet.
	// put into a queue and try to connect later.
	} else if (!tuple[0]) {
		pendingQueue.push([this, path]);
		tuple.length = 0;
		return;

	// global path, and object already exists
	} else {
		src  = tuple[0];
		key  = path.slice(0, 0-(tuple[1].length+1));
		path = tuple[1];
	}

	tuple.length = 0;
	this.chain(key, path, src, obj);
};

// called on the root node of a chain to teardown watcher on the specified
// path
ChainNodePrototype.remove = function(path) {
	var obj, tuple, key, src, paths;

	paths = this._paths;
	if (paths[path] > 0) { paths[path]--; }

	obj = this.value();
	tuple = normalizeTuple(obj, path);
	if (tuple[0] === obj) {
		path = tuple[1];
		key  = firstKey(path);
		path = path.slice(key.length+1);
	} else {
		src  = tuple[0];
		key  = path.slice(0, 0-(tuple[1].length+1));
		path = tuple[1];
	}

	tuple.length = 0;
	this.unchain(key, path);
};

ChainNodePrototype.count = 0;

ChainNodePrototype.chain = function(key, path, src, parentObj) {
	var chains = this._chains, node;
	if (!chains) {
		chains = this._chains = {};
	}

	node = chains[key];
	if (!node) { node = chains[key] = new ChainNode(this, key, src, parentObj); }
	node.count++; // count chains...

	// chain rest of path if there is one
	if (path && path.length > 0) {
		key = firstKey(path);
		path = path.slice(key.length + 1);
		node.chain(key, path); // NOTE: no src means it will observe changes...
	}
};

ChainNodePrototype.unchain = function(key, path) {
	var chains = this._chains, node = chains[key];

	// unchain rest of path first...
	if (path && path.length>1) {
		key  = firstKey(path);
		path = path.slice(key.length+1);
		node.unchain(key, path);
	}

	// delete node if needed.
	node.count--;
	if (node.count<=0) {
		chains[node._key] = null;
		node.destroy();
	}

};

ChainNodePrototype.willChange = function(events) {
	var chains = this._chains, chain;
	if (chains) {
		for(var key in chains) {
			chain = chains[key];
			if (!chain || !chains.hasOwnProperty(key)) { continue; }
			chain.willChange(events);
		}
	}

	if (this._parent) { this._parent.chainWillChange(this, this._key, 1, events); }
};

ChainNodePrototype.chainWillChange = function(chain, path, depth, events) {
	if (this._key) { path = this._key + '.' + path; }

	if (this._parent) {
		this._parent.chainWillChange(this, path, depth+1, events);
	} else {
		if (depth > 1) {
			events.push(this.value(), path);
		}
		path = 'this.' + path;
		if (this._paths[path] > 0) {
			events.push(this.value(), path);
		}
	}
};

ChainNodePrototype.chainDidChange = function(chain, path, depth, events) {
	if (this._key) { path = this._key + '.' + path; }
	if (this._parent) {
		this._parent.chainDidChange(this, path, depth+1, events);
	} else {
		if (depth > 1) {
			events.push(this.value(), path);
		}
		path = 'this.' + path;
		if (this._paths[path] > 0) {
			events.push(this.value(), path);
		}
	}
};

ChainNodePrototype.didChange = function(events) {
	// invalidate my own value first.
	if (this._watching) {
		var obj = this._parent.value();
		if (obj !== this._object) {
			removeChainWatcher(this._object, this._key, this);
			this._object = obj;
			addChainWatcher(obj, this._key, this);
		}
		this._value  = undefined;

		// Special-case: the EachProxy relies on immediate evaluation to
		// establish its observers.
		if (this._parent && this._parent._key === '@each')
			this.value();
	}

	// then notify chains...
	var chains = this._chains, chain;
	if (chains) {
		for(var key in chains) {
			chain = chains[key];
			if (!chain || !chains.hasOwnProperty(key)) { continue; }
			chain.didChange(events);
		}
	}

	// if no events are passed in then we only care about the above wiring update
	if (events === null) { return; }

	// and finally tell parent about my path changing...
	if (this._parent) { this._parent.chainDidChange(this, this._key, 1, events); }
};

Ember.finishChains = function(obj) {
	// We only create meta if we really have to
	var m = obj.__ember_meta, chains = m && m.chains;
	if (chains) {
		if (chains.value() !== obj) {
			if (m.source !== obj) { m = Utils.createMeta(obj); }
			m.chains = chains = chains.copy(obj);
		} else {
			chains.didChange(null);
		}
	}
};

})();



(function() {

	/**
		@module ember-metal
	*/

	var forEach = Ember.EnumerableUtils.forEach,
			BRACE_EXPANSION = /^((?:[^\.]*\.)*)\{(.*)\}$/;

	/**
		Expands `pattern`, invoking `callback` for each expansion.

		The only pattern supported is brace-expansion, anything else will be passed
		once to `callback` directly. Brace expansion can only appear at the end of a
		pattern, for example as the last item in a chain.

		Example
		```js
		function echo(arg){ console.log(arg); }

		Ember.expandProperties('foo.bar', echo);        //=> 'foo.bar'
		Ember.expandProperties('{foo,bar}', echo);      //=> 'foo', 'bar'
		Ember.expandProperties('foo.{bar,baz}', echo);  //=> 'foo.bar', 'foo.baz'
		Ember.expandProperties('{foo,bar}.baz', echo);  //=> '{foo,bar}.baz'
		```

		@method
		@private
		@param {string} pattern The property pattern to expand.
		@param {function} callback The callback to invoke.  It is invoked once per
		expansion, and is passed the expansion.
	*/
	Ember.expandProperties = function (pattern, callback) {
		var match, prefix, list;

		if (match = BRACE_EXPANSION.exec(pattern)) {
			prefix = match[1];
			list = match[2];

			forEach(list.split(','), function (suffix) {
				callback(prefix + suffix);
			});
		} else {
			callback(pattern);
		}
	};


})();



(function() {
var metaFor = Ember.meta, // utils.js
		Utils = Ember.Utils,
		typeOf = Ember.typeOf, // utils.js
		ChainNode = Ember._ChainNode; // chains.js

// get the chains for the current object. If the current object has
// chains inherited from the proto they will be cloned and reconfigured for
// the current object.
function chainsFor(obj, meta) {
	var m = meta || Utils.meta(obj), ret = m.chains;
	if (!ret) {
		ret = m.chains = new ChainNode(null, null, obj);
	} else if (ret.value() !== obj) {
		ret = m.chains = ret.copy(obj);
	}
	return ret;
}

Ember.watchPath = function(obj, keyPath, meta) {
	// can't watch length on Array - it is special...
	if (keyPath === 'length' && typeOf(obj) === 'array') { return; }

	var m = meta || Utils.meta(obj), watching = m.watching;

	if (!watching[keyPath]) { // activate watching first time
		watching[keyPath] = 1;
		chainsFor(obj, m).add(keyPath);
	} else {
		if (watching[keyPath]) {
			watching[keyPath]++;
		} else {
			watching[keyPath] = 1;
		}
	}
};

Ember.unwatchPath = function(obj, keyPath, meta) {
	var m = meta || Utils.meta(obj), watching = m.watching;

	if (watching[keyPath] === 1) {
		watching[keyPath] = 0;
		chainsFor(obj, m).remove(keyPath);
	} else if (watching[keyPath] > 1) {
		watching[keyPath]--;
	}
};
})();



(function() {
/**
@module ember-metal
*/

var metaFor = Ember.meta, // utils.js
		GUID_KEY = Ember.GUID_KEY, // utils.js
		META_KEY = Ember.META_KEY, // utils.js
		removeChainWatcher = Ember.removeChainWatcher,
		watchKey = Ember.watchKey, // watch_key.js
		unwatchKey = Ember.unwatchKey,
		watchPath = Ember.watchPath, // watch_path.js
		unwatchPath = Ember.unwatchPath,
		typeOf = Ember.typeOf, // utils.js
		generateGuid = Ember.generateGuid,
		IS_PATH = /[\.\*]/;

// returns true if the passed path is just a keyName
function isKeyName(path) {
	return path==='*' || !IS_PATH.test(path);
}

/**
	Starts watching a property on an object. Whenever the property changes,
	invokes `Ember.propertyWillChange` and `Ember.propertyDidChange`. This is the
	primitive used by observers and dependent keys; usually you will never call
	this method directly but instead use higher level methods like
	`Ember.addObserver()`

	@private
	@method watch
	@for Ember
	@param obj
	@param {String} keyName
*/
Ember.watch = function(obj, _keyPath, m) {
	// can't watch length on Array - it is special...
	if (_keyPath === 'length' && typeOf(obj) === 'array') { return; }

	if (isKeyName(_keyPath)) {
		watchKey(obj, _keyPath, m);
	} else {
		watchPath(obj, _keyPath, m);
	}
};

Ember.isWatching = function isWatching(obj, key) {
	var meta = obj[META_KEY];
	return (meta && meta.watching[key]) > 0;
};

Ember.watch.flushPending = Ember.flushPendingChains;

Ember.unwatch = function(obj, _keyPath, m) {
	// can't watch length on Array - it is special...
	if (_keyPath === 'length' && typeOf(obj) === 'array') { return; }

	if (isKeyName(_keyPath)) {
		unwatchKey(obj, _keyPath, m);
	} else {
		unwatchPath(obj, _keyPath, m);
	}
};

/**
	Call on an object when you first beget it from another object. This will
	setup any chained watchers on the object instance as needed. This method is
	safe to call multiple times.

	@private
	@method rewatch
	@for Ember
	@param obj
*/
Ember.rewatch = function(obj) {
	var m = obj[META_KEY], chains = m && m.chains;

	// make sure the object has its own guid.
	if (GUID_KEY in obj && !obj.hasOwnProperty(GUID_KEY)) {
		generateGuid(obj);
	}

	// make sure any chained watchers update.
	if (chains && chains.value() !== obj) {
		m.chains = chains.copy(obj);
	}
};

var NODE_STACK = [];

/**
	Tears down the meta on an object so that it can be garbage collected.
	Multiple calls will have no effect.

	@method destroy
	@for Ember
	@param {Object} obj  the object to destroy
	@return {void}
*/
Ember.destroy = function (obj) {
	var meta = obj[META_KEY], node, nodes, key, nodeObject;
	if (meta) {
		obj[META_KEY] = null;
		// remove chainWatchers to remove circular references that would prevent GC
		node = meta.chains;
		if (node) {
			NODE_STACK.push(node);
			// process tree
			while (NODE_STACK.length > 0) {
				node = NODE_STACK.pop();
				// push children
				nodes = node._chains;
				if (nodes) {
					for (key in nodes) {
						if (nodes[key] && nodes.hasOwnProperty(key)) {
							NODE_STACK.push(nodes[key]);
						}
					}
				}
				// remove chainWatcher in node object
				if (node._watching) {
					nodeObject = node._object;
					if (nodeObject) {
						removeChainWatcher(nodeObject, node._key, node);
					}
				}
			}
		}
	}
};

})();



(function() {
/**
@module ember-metal
*/



var get = Ember.get,
		set = Ember.set,
		metaFor = Ember.meta,
		a_slice = [].slice,
		o_create = Ember.create,
		META_KEY = Ember.META_KEY,
		watch = Ember.watch,
		unwatch = Ember.unwatch;






	var expandProperties = Ember.expandProperties;


// ..........................................................
// DEPENDENT KEYS
//

// data structure:
//  meta.deps = {
//   'depKey': {
//     'keyName': count,
//   }
//  }

/*
	This function returns a map of unique dependencies for a
	given object and key.
*/
function keysForDep(depsMeta, depKey) {
	var keys = depsMeta[depKey];
	if (!keys) {
		// if there are no dependencies yet for a the given key
		// create a new empty list of dependencies for the key
		keys = depsMeta[depKey] = {};
	} else if (!depsMeta.hasOwnProperty(depKey)) {
		// otherwise if the dependency list is inherited from
		// a superclass, clone the hash
		keys = depsMeta[depKey] = o_create(keys);
	}
	return keys;
}

function metaForDeps(meta) {
	return keysForDep(meta, 'deps');
}

function addDependentKeys(desc, obj, keyName, meta) {
	// the descriptor has a list of dependent keys, so
	// add all of its dependent keys.
	var depKeys = desc._dependentKeys, depsMeta, idx, len, depKey, keys;
	if (!depKeys) return;

	depsMeta = metaForDeps(meta);

	for(idx = 0, len = depKeys.length; idx < len; idx++) {
		depKey = depKeys[idx];
		// Lookup keys meta for depKey
		keys = keysForDep(depsMeta, depKey);
		// Increment the number of times depKey depends on keyName.
		keys[keyName] = (keys[keyName] || 0) + 1;
		// Watch the depKey
		watch(obj, depKey, meta);
	}
}

function removeDependentKeys(desc, obj, keyName, meta) {
	// the descriptor has a list of dependent keys, so
	// add all of its dependent keys.
	var depKeys = desc._dependentKeys, depsMeta, idx, len, depKey, keys;
	if (!depKeys) return;

	depsMeta = metaForDeps(meta);

	for(idx = 0, len = depKeys.length; idx < len; idx++) {
		depKey = depKeys[idx];
		// Lookup keys meta for depKey
		keys = keysForDep(depsMeta, depKey);
		// Increment the number of times depKey depends on keyName.
		keys[keyName] = (keys[keyName] || 0) - 1;
		// Watch the depKey
		unwatch(obj, depKey, meta);
	}
}

// ..........................................................
// COMPUTED PROPERTY
//

/**
	A computed property transforms an objects function into a property.

	By default the function backing the computed property will only be called
	once and the result will be cached. You can specify various properties
	that your computed property is dependent on. This will force the cached
	result to be recomputed if the dependencies are modified.

	In the following example we declare a computed property (by calling
	`.property()` on the fullName function) and setup the properties
	dependencies (depending on firstName and lastName). The fullName function
	will be called once (regardless of how many times it is accessed) as long
	as it's dependencies have not been changed. Once firstName or lastName are updated
	any future calls (or anything bound) to fullName will incorporate the new
	values.

	```javascript
	Person = Ember.Object.extend({
		// these will be supplied by `create`
		firstName: null,
		lastName: null,

		fullName: function() {
			var firstName = this.get('firstName');
			var lastName = this.get('lastName');

		 return firstName + ' ' + lastName;
		}.property('firstName', 'lastName')
	});

	var tom = Person.create({
		firstName: "Tom",
		lastName: "Dale"
	});

	tom.get('fullName') // "Tom Dale"
	```

	You can also define what Ember should do when setting a computed property.
	If you try to set a computed property, it will be invoked with the key and
	value you want to set it to. You can also accept the previous value as the
	third parameter.

	```javascript

 Person = Ember.Object.extend({
		// these will be supplied by `create`
		firstName: null,
		lastName: null,

		fullName: function(key, value, oldValue) {
			// getter
			if (arguments.length === 1) {
				var firstName = this.get('firstName');
				var lastName = this.get('lastName');

				return firstName + ' ' + lastName;

			// setter
			} else {
				var name = value.split(" ");

				this.set('firstName', name[0]);
				this.set('lastName', name[1]);

				return value;
			}
		}.property('firstName', 'lastName')
	});

	var person = Person.create();
	person.set('fullName', "Peter Wagenet");
	person.get('firstName') // Peter
	person.get('lastName') // Wagenet
	```

	@class ComputedProperty
	@namespace Ember
	@extends Ember.Descriptor
	@constructor
*/
function ComputedProperty(func, opts) {
	this.func = func;

		setDependentKeys(this, opts && opts.dependentKeys);

	this._cacheable = (opts && opts.cacheable !== undefined) ? opts.cacheable : true;
	this._readOnly = opts && (opts.readOnly !== undefined || !!opts.readOnly);
}

Ember.ComputedProperty = ComputedProperty;
ComputedProperty.prototype = new Ember.Descriptor();

var ComputedPropertyPrototype = ComputedProperty.prototype;


	ComputedPropertyPrototype.toString = function() {
		if (this.implicitCPKey) {
			return this.implicitCPKey;
		}
		return Ember.Descriptor.prototype.toString.apply(this, arguments);
	};


/**
	Properties are cacheable by default. Computed property will automatically
	cache the return value of your function until one of the dependent keys changes.

	Call `volatile()` to set it into non-cached mode. When in this mode
	the computed property will not automatically cache the return value.

	However, if a property is properly observable, there is no reason to disable
	caching.

	@method cacheable
	@param {Boolean} aFlag optional set to `false` to disable caching
	@return {Ember.ComputedProperty} this
	@chainable
*/
ComputedPropertyPrototype.cacheable = function(aFlag) {
	this._cacheable = aFlag !== false;
	return this;
};

/**
	Call on a computed property to set it into non-cached mode. When in this
	mode the computed property will not automatically cache the return value.

	```javascript
	MyApp.outsideService = Ember.Object.extend({
		value: function() {
			return OutsideService.getValue();
		}.property().volatile()
	}).create();
	```

	@method volatile
	@return {Ember.ComputedProperty} this
	@chainable
*/
ComputedPropertyPrototype.volatile = function() {
	return this.cacheable(false);
};

/**
	Call on a computed property to set it into read-only mode. When in this
	mode the computed property will throw an error when set.

	```javascript
	MyApp.Person = Ember.Object.extend({
		guid: function() {
			return 'guid-guid-guid';
		}.property().readOnly()
	});

	MyApp.person = MyApp.Person.create();

	MyApp.person.set('guid', 'new-guid'); // will throw an exception
	```

	@method readOnly
	@return {Ember.ComputedProperty} this
	@chainable
*/
ComputedPropertyPrototype.readOnly = function(readOnly) {
	this._readOnly = readOnly === undefined || !!readOnly;
	return this;
};

/**
	Sets the dependent keys on this computed property. Pass any number of
	arguments containing key paths that this computed property depends on.

	```javascript
	MyApp.President = Ember.Object.extend({
		fullName: Ember.computed(function() {
			return this.get('firstName') + ' ' + this.get('lastName');

			// Tell Ember that this computed property depends on firstName
			// and lastName
		}).property('firstName', 'lastName')
	});

	MyApp.president = MyApp.President.create({
		firstName: 'Barack',
		lastName: 'Obama',
	});
	MyApp.president.get('fullName'); // Barack Obama
	```

	@method property
	@param {String} path* zero or more property paths
	@return {Ember.ComputedProperty} this
	@chainable
*/
ComputedPropertyPrototype.property = function() {
	var args;


		var addArg = function (property) {
			args.push(property);
		};

		args = [];
		for (var i = 0, l = arguments.length; i < l; i++) {
			expandProperties(arguments[i], addArg);
		}


		setDependentKeys(this, args);

	return this;
};

/**
	In some cases, you may want to annotate computed properties with additional
	metadata about how they function or what values they operate on. For example,
	computed property functions may close over variables that are then no longer
	available for introspection.

	You can pass a hash of these values to a computed property like this:

	```
	person: function() {
		var personId = this.get('personId');
		return App.Person.create({ id: personId });
	}.property().meta({ type: App.Person })
	```

	The hash that you pass to the `meta()` function will be saved on the
	computed property descriptor under the `_meta` key. Ember runtime
	exposes a public API for retrieving these values from classes,
	via the `metaForProperty()` function.

	@method meta
	@param {Hash} meta
	@chainable
*/

ComputedPropertyPrototype.meta = function(meta) {
	if (arguments.length === 0) {
		return this._meta || {};
	} else {
		this._meta = meta;
		return this;
	}
};

/* impl descriptor API */
ComputedPropertyPrototype.didChange = function(obj, keyName) {
	// _suspended is set via a CP.set to ensure we don't clear
	// the cached value set by the setter
	if (this._cacheable && this._suspended !== obj) {
		var meta = metaFor(obj);
		if (keyName in meta.cache) {
			delete meta.cache[keyName];
			removeDependentKeys(this, obj, keyName, meta);
		}
	}
};

function finishChains(chainNodes)
{
	for (var i=0, l=chainNodes.length; i<l; i++) {
		chainNodes[i].didChange(null);
	}
}

/**
	Access the value of the function backing the computed property.
	If this property has already been cached, return the cached result.
	Otherwise, call the function passing the property name as an argument.

	```javascript
	Person = Ember.Object.extend({
		fullName: function(keyName) {
			// the keyName parameter is 'fullName' in this case.

			return this.get('firstName') + ' ' + this.get('lastName');
		}.property('firstName', 'lastName')
	});


	var tom = Person.create({
		firstName: "Tom",
		lastName: "Dale"
	});

	tom.get('fullName') // "Tom Dale"
	```

	@method get
	@param {String} keyName The key being accessed.
	@return {Object} The return value of the function backing the CP.
*/
ComputedPropertyPrototype.get = function(obj, keyName) {
	var ret, cache, meta, chainNodes;
	if (this._cacheable) {
		meta = metaFor(obj);
		cache = meta.cache;
		if (keyName in cache) { return cache[keyName]; }
		ret = cache[keyName] = this.func.call(obj, keyName);
		chainNodes = meta.chainWatchers && meta.chainWatchers[keyName];
		if (chainNodes) { finishChains(chainNodes); }
		addDependentKeys(this, obj, keyName, meta);
	} else {
		ret = this.func.call(obj, keyName);
	}
	return ret;
};

/**
	Set the value of a computed property. If the function that backs your
	computed property does not accept arguments then the default action for
	setting would be to define the property on the current object, and set
	the value of the property to the value being set.

	Generally speaking if you intend for your computed property to be set
	your backing function should accept either two or three arguments.

	@method set
	@param {String} keyName The key being accessed.
	@param {Object} newValue The new value being assigned.
	@param {String} oldValue The old value being replaced.
	@return {Object} The return value of the function backing the CP.
*/
ComputedPropertyPrototype.set = function(obj, keyName, value) {
	var cacheable = this._cacheable,
			func = this.func,
			meta = metaFor(obj, cacheable),
			watched = meta.watching[keyName],
			oldSuspended = this._suspended,
			hadCachedValue = false,
			cache = meta.cache,
			funcArgLength, cachedValue, ret;

	if (this._readOnly) {
		throw new Ember.Error('Cannot Set: ' + keyName + ' on: ' + Ember.inspect(obj));
	}

	this._suspended = obj;

	try {

		if (cacheable && cache.hasOwnProperty(keyName)) {
			cachedValue = cache[keyName];
			hadCachedValue = true;
		}

		// Check if the CP has been wrapped. If if has, use the
		// length from the wrapped function.
		funcArgLength = (func.wrappedFunction ? func.wrappedFunction.length : func.length);

		// For backwards-compatibility with computed properties
		// that check for arguments.length === 2 to determine if
		// they are being get or set, only pass the old cached
		// value if the computed property opts into a third
		// argument.
		if (funcArgLength === 3) {
			ret = func.call(obj, keyName, value, cachedValue);
		} else if (funcArgLength === 2) {
			ret = func.call(obj, keyName, value);
		} else {
			Ember.defineProperty(obj, keyName, null, cachedValue);
			Ember.set(obj, keyName, value);
			return;
		}

		if (hadCachedValue && cachedValue === ret) { return; }

		if (watched) { Ember.propertyWillChange(obj, keyName); }

		if (hadCachedValue) {
			delete cache[keyName];
		}

		if (cacheable) {
			if (!hadCachedValue) {
				addDependentKeys(this, obj, keyName, meta);
			}
			cache[keyName] = ret;
		}

		if (watched) { Ember.propertyDidChange(obj, keyName); }
	} finally {
		this._suspended = oldSuspended;
	}
	return ret;
};

/* called before property is overridden */
ComputedPropertyPrototype.teardown = function(obj, keyName) {
	var meta = metaFor(obj);

	if (keyName in meta.cache) {
		removeDependentKeys(this, obj, keyName, meta);
	}

	if (this._cacheable) { delete meta.cache[keyName]; }

	return null; // no value to restore
};


/**
	This helper returns a new property descriptor that wraps the passed
	computed property function. You can use this helper to define properties
	with mixins or via `Ember.defineProperty()`.

	The function you pass will be used to both get and set property values.
	The function should accept two parameters, key and value. If value is not
	undefined you should set the value first. In either case return the
	current value of the property.
	@method computed
	@for Ember
	@param {Function} func The computed property function.
	@return {Ember.ComputedProperty} property descriptor instance
*/
Ember.computed = function(func) {
	var args;

	if (arguments.length > 1) {
		args = a_slice.call(arguments, 0, -1);
		func = a_slice.call(arguments, -1)[0];
	}

	if (typeof func !== "function") {
		throw new Ember.Error("Computed Property declared without a property function");
	}

	var cp = new ComputedProperty(func);

	if (args) {
		cp.property.apply(cp, args);
	}

	return cp;
};

/**
	Returns the cached value for a property, if one exists.
	This can be useful for peeking at the value of a computed
	property that is generated lazily, without accidentally causing
	it to be created.

	@method cacheFor
	@for Ember
	@param {Object} obj the object whose property you want to check
	@param {String} key the name of the property whose cached value you want
		to return
	@return {Object} the cached value
*/
Ember.cacheFor = function cacheFor(obj, key) {
	var meta = obj[META_KEY],
			cache = meta && meta.cache;

	if (cache && key in cache) {
		return cache[key];
	}
};

function getProperties(self, propertyNames) {
	var ret = {};
	for(var i = 0; i < propertyNames.length; i++) {
		ret[propertyNames[i]] = get(self, propertyNames[i]);
	}
	return ret;
}

var registerComputed, registerComputedWithProperties;


	var guidFor = Ember.guidFor,
			map = Ember.EnumerableUtils.map,
			filter = Ember.EnumerableUtils.filter,
			typeOf = Ember.typeOf;

	var implicitKey = function (cp) {
		return [guidFor(cp)].concat(cp._dependentKeys).join('_');
	};

	var normalizeDependentKey = function (key) {
		if (key instanceof Ember.ComputedProperty) {
			return implicitKey(key);
		} else if (typeof key === 'string' || key instanceof String || typeof key === 'object' || typeof key === 'number') {
			return key;
		} else {
					}
	};

	var normalizeDependentKeys = function (keys) {
		return map(keys, function (key) {
			return normalizeDependentKey(key);
		});
	};

	var selectDependentCPs = function (keys) {
		return filter(keys, function (key) {
			return key instanceof Ember.ComputedProperty;
		});
	};

	var setDependentKeys = function(cp, dependentKeys) {
		if (dependentKeys) {
			cp._dependentKeys = normalizeDependentKeys(dependentKeys);
			cp._dependentCPs = selectDependentCPs(dependentKeys);
			cp.implicitCPKey = implicitKey(cp);
		} else {
			cp._dependentKeys = cp._dependentCPs = [];
			delete cp.implicitCPKey;
		}
	};
	// expose `normalizeDependentKey[s]` so user CP macros can easily support
	// composition
	Ember.computed.normalizeDependentKey = normalizeDependentKey;
	Ember.computed.normalizeDependentKeys = normalizeDependentKeys;

	registerComputed = function (name, macro) {
		Ember.computed[name] = function(dependentKey) {
			var args = normalizeDependentKeys(a_slice.call(arguments));
			return Ember.computed(dependentKey, function() {
				return macro.apply(this, args);
			});
		};
	};



	registerComputedWithProperties = function(name, macro) {
		Ember.computed[name] = function() {
			var args = a_slice.call(arguments);
			var properties = normalizeDependentKeys(args);

			var computed = Ember.computed(function() {
				return macro.apply(this, [getProperties(this, properties)]);
			});

			return computed.property.apply(computed, args);
		};
	};



	Ember.computed.literal = function (value) {
		return Ember.computed(function () {
			return value;
		});
	};


/**
	A computed property that returns true if the value of the dependent
	property is null, an empty string, empty array, or empty function.

	Note: When using `Ember.computed.empty` to watch an array make sure to
	use the `array.[]` syntax so the computed can subscribe to transitions
	from empty to non-empty states.

	Example

	```javascript
	var ToDoList = Ember.Object.extend({
		done: Ember.computed.empty('todos.[]') // detect array changes
	});
	var todoList = ToDoList.create({todos: ['Unit Test', 'Documentation', 'Release']});
	todoList.get('done'); // false
	todoList.get('todos').clear(); // []
	todoList.get('done'); // true
	```

	@method computed.empty
	@for Ember
	@param {String} dependentKey
	@return {Ember.ComputedProperty} computed property which negate
	the original value for property
*/
registerComputed('empty', function(dependentKey) {
	return Ember.isEmpty(get(this, dependentKey));
});

/**
	A computed property that returns true if the value of the dependent
	property is NOT null, an empty string, empty array, or empty function.

	Note: When using `Ember.computed.notEmpty` to watch an array make sure to
	use the `array.[]` syntax so the computed can subscribe to transitions
	from empty to non-empty states.

	Example

	```javascript
	var Hamster = Ember.Object.extend({
		hasStuff: Ember.computed.notEmpty('backpack.[]')
	});
	var hamster = Hamster.create({backpack: ['Food', 'Sleeping Bag', 'Tent']});
	hamster.get('hasStuff'); // true
	hamster.get('backpack').clear(); // []
	hamster.get('hasStuff'); // false
	```

	@method computed.notEmpty
	@for Ember
	@param {String} dependentKey
	@return {Ember.ComputedProperty} computed property which returns true if
	original value for property is not empty.
*/
registerComputed('notEmpty', function(dependentKey) {
	return !Ember.isEmpty(get(this, dependentKey));
});

/**
	A computed property that returns true if the value of the dependent
	property is null or undefined. This avoids errors from JSLint complaining
	about use of ==, which can be technically confusing.

	Example

	```javascript
	var Hamster = Ember.Object.extend({
		isHungry: Ember.computed.none('food')
	});
	var hamster = Hamster.create();
	hamster.get('isHungry'); // true
	hamster.set('food', 'Banana');
	hamster.get('isHungry'); // false
	hamster.set('food', null);
	hamster.get('isHungry'); // true
	```

	@method computed.none
	@for Ember
	@param {String} dependentKey
	@return {Ember.ComputedProperty} computed property which
	returns true if original value for property is null or undefined.
*/
registerComputed('none', function(dependentKey) {
	return Ember.isNone(get(this, dependentKey));
});

/**
	A computed property that returns the inverse boolean value
	of the original value for the dependent property.

	Example

	```javascript
	var User = Ember.Object.extend({
		isAnonymous: Ember.computed.not('loggedIn')
	});
	var user = User.create({loggedIn: false});
	user.get('isAnonymous'); // true
	user.set('loggedIn', true);
	user.get('isAnonymous'); // false
	```

	@method computed.not
	@for Ember
	@param {String} dependentKey
	@return {Ember.ComputedProperty} computed property which returns
	inverse of the original value for property
*/
registerComputed('not', function(dependentKey) {
	return !get(this, dependentKey);
});

/**
	A computed property that converts the provided dependent property
	into a boolean value.

	```javascript
	var Hamster = Ember.Object.extend({
		hasBananas: Ember.computed.bool('numBananas')
	});
	var hamster = Hamster.create();
	hamster.get('hasBananas'); // false
	hamster.set('numBananas', 0);
	hamster.get('hasBananas'); // false
	hamster.set('numBananas', 1);
	hamster.get('hasBananas'); // true
	hamster.set('numBananas', null);
	hamster.get('hasBananas'); // false
	```

	@method computed.bool
	@for Ember
	@param {String} dependentKey
	@return {Ember.ComputedProperty} computed property which converts
	to boolean the original value for property
*/
registerComputed('bool', function(dependentKey) {
	return !!get(this, dependentKey);
});

/**
	A computed property which matches the original value for the
	dependent property against a given RegExp, returning `true`
	if they values matches the RegExp and `false` if it does not.

	Example

	```javascript
	var User = Ember.Object.extend({
		hasValidEmail: Ember.computed.match('email', /^.+@.+\..+$/)
	});
	var user = User.create({loggedIn: false});
	user.get('hasValidEmail'); // false
	user.set('email', '');
	user.get('hasValidEmail'); // false
	user.set('email', 'ember_hamster@example.com');
	user.get('hasValidEmail'); // true
	```

	@method computed.match
	@for Ember
	@param {String} dependentKey
	@param {RegExp} regexp
	@return {Ember.ComputedProperty} computed property which match
	the original value for property against a given RegExp
*/
registerComputed('match', function(dependentKey, regexp) {
	var value = get(this, dependentKey);
	return typeof value === 'string' ? regexp.test(value) : false;
});

/**
	A computed property that returns true if the provided dependent property
	is equal to the given value.

	Example

	```javascript
	var Hamster = Ember.Object.extend({
		napTime: Ember.computed.equal('state', 'sleepy')
	});
	var hamster = Hamster.create();
	hamster.get('napTime'); // false
	hamster.set('state', 'sleepy');
	hamster.get('napTime'); // true
	hamster.set('state', 'hungry');
	hamster.get('napTime'); // false
	```

	@method computed.equal
	@for Ember
	@param {String} dependentKey
	@param {String|Number|Object} value
	@return {Ember.ComputedProperty} computed property which returns true if
	the original value for property is equal to the given value.
*/
registerComputed('equal', function(dependentKey, value) {
	return get(this, dependentKey) === value;
});

/**
	A computed property that returns true if the provied dependent property
	is greater than the provided value.

	Example

	```javascript
	var Hamster = Ember.Object.extend({
		hasTooManyBananas: Ember.computed.gt('numBananas', 10)
	});
	var hamster = Hamster.create();
	hamster.get('hasTooManyBananas'); // false
	hamster.set('numBananas', 3);
	hamster.get('hasTooManyBananas'); // false
	hamster.set('numBananas', 11);
	hamster.get('hasTooManyBananas'); // true
	```

	@method computed.gt
	@for Ember
	@param {String} dependentKey
	@param {Number} value
	@return {Ember.ComputedProperty} computed property which returns true if
	the original value for property is greater then given value.
*/
registerComputed('gt', function(dependentKey, value) {
	return get(this, dependentKey) > value;
});

/**
	A computed property that returns true if the provided dependent property
	is greater than or equal to the provided value.

	Example

	```javascript
	var Hamster = Ember.Object.extend({
		hasTooManyBananas: Ember.computed.gte('numBananas', 10)
	});
	var hamster = Hamster.create();
	hamster.get('hasTooManyBananas'); // false
	hamster.set('numBananas', 3);
	hamster.get('hasTooManyBananas'); // false
	hamster.set('numBananas', 10);
	hamster.get('hasTooManyBananas'); // true
	```

	@method computed.gte
	@for Ember
	@param {String} dependentKey
	@param {Number} value
	@return {Ember.ComputedProperty} computed property which returns true if
	the original value for property is greater or equal then given value.
*/
registerComputed('gte', function(dependentKey, value) {
	return get(this, dependentKey) >= value;
});

/**
	A computed property that returns true if the provided dependent property
	is less than the provided value.

	Example

	```javascript
	var Hamster = Ember.Object.extend({
		needsMoreBananas: Ember.computed.lt('numBananas', 3)
	});
	var hamster = Hamster.create();
	hamster.get('needsMoreBananas'); // true
	hamster.set('numBananas', 3);
	hamster.get('needsMoreBananas'); // false
	hamster.set('numBananas', 2);
	hamster.get('needsMoreBananas'); // true
	```

	@method computed.lt
	@for Ember
	@param {String} dependentKey
	@param {Number} value
	@return {Ember.ComputedProperty} computed property which returns true if
	the original value for property is less then given value.
*/
registerComputed('lt', function(dependentKey, value) {
	return get(this, dependentKey) < value;
});

/**
	A computed property that returns true if the provided dependent property
	is less than or equal to the provided value.

	Example

	```javascript
	var Hamster = Ember.Object.extend({
		needsMoreBananas: Ember.computed.lte('numBananas', 3)
	});
	var hamster = Hamster.create();
	hamster.get('needsMoreBananas'); // true
	hamster.set('numBananas', 5);
	hamster.get('needsMoreBananas'); // false
	hamster.set('numBananas', 3);
	hamster.get('needsMoreBananas'); // true
	```

	@method computed.lte
	@for Ember
	@param {String} dependentKey
	@param {Number} value
	@return {Ember.ComputedProperty} computed property which returns true if
	the original value for property is less or equal then given value.
*/
registerComputed('lte', function(dependentKey, value) {
	return get(this, dependentKey) <= value;
});

/**
	A computed property that performs a logical `and` on the
	original values for the provided dependent properties.

	Example

	```javascript
	var Hamster = Ember.Object.extend({
		readyForCamp: Ember.computed.and('hasTent', 'hasBackpack')
	});
	var hamster = Hamster.create();
	hamster.get('readyForCamp'); // false
	hamster.set('hasTent', true);
	hamster.get('readyForCamp'); // false
	hamster.set('hasBackpack', true);
	hamster.get('readyForCamp'); // true
	```

	@method computed.and
	@for Ember
	@param {String} dependentKey*
	@return {Ember.ComputedProperty} computed property which performs
	a logical `and` on the values of all the original values for properties.
*/
registerComputedWithProperties('and', function(properties) {
	for (var key in properties) {
		if (properties.hasOwnProperty(key) && !properties[key]) {
			return false;
		}
	}
	return true;
});

/**
	A computed property which performs a logical `or` on the
	original values for the provided dependent properties.

	Example

	```javascript
	var Hamster = Ember.Object.extend({
		readyForRain: Ember.computed.or('hasJacket', 'hasUmbrella')
	});
	var hamster = Hamster.create();
	hamster.get('readyForRain'); // false
	hamster.set('hasJacket', true);
	hamster.get('readyForRain'); // true
	```

	@method computed.or
	@for Ember
	@param {String} dependentKey*
	@return {Ember.ComputedProperty} computed property which performs
	a logical `or` on the values of all the original values for properties.
*/
registerComputedWithProperties('or', function(properties) {
	for (var key in properties) {
		if (properties.hasOwnProperty(key) && properties[key]) {
			return true;
		}
	}
	return false;
});

/**
	A computed property that returns the first truthy value
	from a list of dependent properties.

	Example

	```javascript
	var Hamster = Ember.Object.extend({
		hasClothes: Ember.computed.any('hat', 'shirt')
	});
	var hamster = Hamster.create();
	hamster.get('hasClothes'); // null
	hamster.set('shirt', 'Hawaiian Shirt');
	hamster.get('hasClothes'); // 'Hawaiian Shirt'
	```

	@method computed.any
	@for Ember
	@param {String} dependentKey*
	@return {Ember.ComputedProperty} computed property which returns
	the first truthy value of given list of properties.
*/
registerComputedWithProperties('any', function(properties) {
	for (var key in properties) {
		if (properties.hasOwnProperty(key) && properties[key]) {
			return properties[key];
		}
	}
	return null;
});

/**
	A computed property that returns the array of values
	for the provided dependent properties.

	Example

	```javascript
	var Hamster = Ember.Object.extend({
		clothes: Ember.computed.collect('hat', 'shirt')
	});
	var hamster = Hamster.create();
	hamster.get('clothes'); // [null, null]
	hamster.set('hat', 'Camp Hat');
	hamster.set('shirt', 'Camp Shirt');
	hamster.get('clothes'); // ['Camp Hat', 'Camp Shirt']
	```

	@method computed.collect
	@for Ember
	@param {String} dependentKey*
	@return {Ember.ComputedProperty} computed property which maps
	values of all passed properties in to an array.
*/
registerComputedWithProperties('collect', function(properties) {
	var res = [];
	for (var key in properties) {
		if (properties.hasOwnProperty(key)) {
			if (Ember.isNone(properties[key])) {
				res.push(null);
			} else {
				res.push(properties[key]);
			}
		}
	}
	return res;
});

/**
	Creates a new property that is an alias for another property
	on an object. Calls to `get` or `set` this property behave as
	though they were called on the original property.

	```javascript
	Person = Ember.Object.extend({
		name: 'Alex Matchneer',
		nomen: Ember.computed.alias('name')
	});

	alex = Person.create();
	alex.get('nomen'); // 'Alex Matchneer'
	alex.get('name');  // 'Alex Matchneer'

	alex.set('nomen', '@machty');
	alex.get('name');  // '@machty'
	```
	@method computed.alias
	@for Ember
	@param {String} dependentKey
	@return {Ember.ComputedProperty} computed property which creates an
	alias to the original value for property.
*/
Ember.computed.alias = function(dependentKey) {
	return Ember.computed(dependentKey, function(key, value) {
		if (arguments.length > 1) {
			set(this, dependentKey, value);
			return value;
		} else {
			return get(this, dependentKey);
		}
	});
};

/**
	Where `computed.alias` aliases `get` and `set`, and allows for bidirectional
	data flow, `computed.oneWay` only provides an aliased `get`. The `set` will
	not mutate the upstream property, rather causes the current property to
	become the value set. This causes the downstream property to permentantly
	diverge from the upstream property.

	Example

	```javascript
	User = Ember.Object.extend({
		firstName: null,
		lastName: null,
		nickName: Ember.computed.oneWay('firstName')
	});

	user = User.create({
		firstName: 'Teddy',
		lastName:  'Zeenny'
	});

	user.get('nickName');
	# 'Teddy'

	user.set('nickName', 'TeddyBear');
	# 'TeddyBear'

	user.get('firstName');
	# 'Teddy'
	```

	@method computed.oneWay
	@for Ember
	@param {String} dependentKey
	@return {Ember.ComputedProperty} computed property which creates a
	one way computed property to the original value for property.
*/
Ember.computed.oneWay = function(dependentKey) {
	return Ember.computed(dependentKey, function() {
		return get(this, dependentKey);
	});
};

if (Ember.FEATURES.isEnabled('computed-read-only')) {
/**
	Where `computed.oneWay` provides oneWay bindings, `computed.readOnly` provides
	a readOnly one way binding. Very often when using `computed.oneWay` one does
	not also want changes to propogate back up, as they will replace the value.

	This prevents the reverse flow, and also throws an exception when it occurs.

	Example

	```javascript
	User = Ember.Object.extend({
		firstName: null,
		lastName: null,
		nickName: Ember.computed.readOnly('firstName')
	});

	user = User.create({
		firstName: 'Teddy',
		lastName:  'Zeenny'
	});

	user.get('nickName');
	# 'Teddy'

	user.set('nickName', 'TeddyBear');
	# throws Exception
	# throw new Ember.Error('Cannot Set: nickName on: <User:ember27288>' );`

	user.get('firstName');
	# 'Teddy'
	```

	@method computed.readOnly
	@for Ember
	@param {String} dependentKey
	@return {Ember.ComputedProperty} computed property which creates a
	one way computed property to the original value for property.
*/
Ember.computed.readOnly = function(dependentKey) {
	return Ember.computed(dependentKey, function() {
		return get(this, dependentKey);
	}).readOnly();
};
}
/**
	A computed property that acts like a standard getter and setter,
	but returns the value at the provided `defaultPath` if the
	property itself has not been set to a value

	Example

	```javascript
	var Hamster = Ember.Object.extend({
		wishList: Ember.computed.defaultTo('favoriteFood')
	});
	var hamster = Hamster.create({favoriteFood: 'Banana'});
	hamster.get('wishList'); // 'Banana'
	hamster.set('wishList', 'More Unit Tests');
	hamster.get('wishList'); // 'More Unit Tests'
	hamster.get('favoriteFood'); // 'Banana'
	```

	@method computed.defaultTo
	@for Ember
	@param {String} defaultPath
	@return {Ember.ComputedProperty} computed property which acts like
	a standard getter and setter, but defaults to the value from `defaultPath`.
*/
Ember.computed.defaultTo = function(defaultPath) {
	return Ember.computed(function(key, newValue, cachedValue) {
		if (arguments.length === 1) {
			return cachedValue != null ? cachedValue : get(this, defaultPath);
		}
		return newValue != null ? newValue : get(this, defaultPath);
	});
};


})();



(function() {
// Ember.tryFinally
/**
@module ember-metal
*/

var AFTER_OBSERVERS = ':change',
		BEFORE_OBSERVERS = ':before';

function changeEvent(keyName) {
	return keyName+AFTER_OBSERVERS;
}

function beforeEvent(keyName) {
	return keyName+BEFORE_OBSERVERS;
}

/**
	@method addObserver
	@param obj
	@param {String} path
	@param {Object|Function} targetOrMethod
	@param {Function|String} [method]
*/
Ember.addObserver = function(obj, _path, target, method) {
	var meta = Ember.addListener(obj, changeEvent(_path), target, method);
	Ember.watch(obj, _path, meta);

	return this;
};

Ember.observersFor = function(obj, path) {
	return Ember.listenersFor(obj, changeEvent(path));
};

/**
	@method removeObserver
	@param obj
	@param {String} path
	@param {Object|Function} targetOrMethod
	@param {Function|String} [method]
*/
Ember.removeObserver = function(obj, _path, target, method) {
	Ember.unwatch(obj, _path);
	Ember.removeListener(obj, changeEvent(_path), target, method);

	return this;
};

/**
	@method addBeforeObserver
	@param obj
	@param {String} path
	@param {Object|Function} targetOrMethod
	@param {Function|String} [method]
*/
Ember.addBeforeObserver = function(obj, _path, target, method) {
	Ember.addListener(obj, beforeEvent(_path), target, method);
	Ember.watch(obj, _path);

	return this;
};

// Suspend observer during callback.
//
// This should only be used by the target of the observer
// while it is setting the observed path.
Ember._suspendBeforeObserver = function(obj, path, target, method, callback) {
	return Ember._suspendListener(obj, beforeEvent(path), target, method, callback);
};

Ember._suspendObserver = function(obj, path, target, method, callback) {
	return Ember._suspendListener(obj, changeEvent(path), target, method, callback);
};

var map = Ember.ArrayPolyfills.map;

Ember._suspendBeforeObservers = function(obj, paths, target, method, callback) {
	var events = map.call(paths, beforeEvent);
	return Ember._suspendListeners(obj, events, target, method, callback);
};

Ember._suspendObservers = function(obj, paths, target, method, callback) {
	var events = map.call(paths, changeEvent);
	return Ember._suspendListeners(obj, events, target, method, callback);
};

Ember.beforeObserversFor = function(obj, path) {
	return Ember.listenersFor(obj, beforeEvent(path));
};

/**
	@method removeBeforeObserver
	@param obj
	@param {String} path
	@param {Object|Function} targetOrMethod
	@param {Function|String} [method]
*/
Ember.removeBeforeObserver = function(obj, _path, target, method) {
	Ember.unwatch(obj, _path);
	Ember.removeListener(obj, beforeEvent(_path), target, method);

	return this;
};

})();



(function() {
define("backburner/queue",
	["exports"],
	function(__exports__) {
		"use strict";
		function Queue(daq, name, options) {
			this.daq = daq;
			this.name = name;
			this.options = options;
			this._queue = [];
		}

		Queue.prototype = {
			daq: null,
			name: null,
			options: null,
			_queue: null,

			push: function(target, method, args, stack) {
				var queue = this._queue;
				queue.push(target, method, args, stack);
				return {queue: this, target: target, method: method};
			},

			pushUnique: function(target, method, args, stack) {
				var queue = this._queue, currentTarget, currentMethod, i, l;

				for (i = 0, l = queue.length; i < l; i += 4) {
					currentTarget = queue[i];
					currentMethod = queue[i+1];

					if (currentTarget === target && currentMethod === method) {
						queue[i+2] = args; // replace args
						queue[i+3] = stack; // replace stack
						return {queue: this, target: target, method: method}; // TODO: test this code path
					}
				}

				this._queue.push(target, method, args, stack);
				return {queue: this, target: target, method: method};
			},

			// TODO: remove me, only being used for Ember.run.sync
			flush: function() {
				var queue = this._queue,
						options = this.options,
						before = options && options.before,
						after = options && options.after,
						target, method, args, stack, i, l = queue.length;

				if (l && before) { before(); }
				for (i = 0; i < l; i += 4) {
					target = queue[i];
					method = queue[i+1];
					args   = queue[i+2];
					stack  = queue[i+3]; // Debugging assistance

					// TODO: error handling
					if (args && args.length > 0) {
						method.apply(target, args);
					} else {
						method.call(target);
					}
				}
				if (l && after) { after(); }

				// check if new items have been added
				if (queue.length > l) {
					this._queue = queue.slice(l);
					this.flush();
				} else {
					this._queue.length = 0;
				}
			},

			cancel: function(actionToCancel) {
				var queue = this._queue, currentTarget, currentMethod, i, l;

				for (i = 0, l = queue.length; i < l; i += 4) {
					currentTarget = queue[i];
					currentMethod = queue[i+1];

					if (currentTarget === actionToCancel.target && currentMethod === actionToCancel.method) {
						queue.splice(i, 4);
						return true;
					}
				}

				// if not found in current queue
				// could be in the queue that is being flushed
				queue = this._queueBeingFlushed;
				if (!queue) {
					return;
				}
				for (i = 0, l = queue.length; i < l; i += 4) {
					currentTarget = queue[i];
					currentMethod = queue[i+1];

					if (currentTarget === actionToCancel.target && currentMethod === actionToCancel.method) {
						// don't mess with array during flush
						// just nullify the method
						queue[i+1] = null;
						return true;
					}
				}
			}
		};


		__exports__.Queue = Queue;
	});

define("backburner/deferred_action_queues",
	["backburner/queue","exports"],
	function(__dependency1__, __exports__) {
		"use strict";
		var Queue = __dependency1__.Queue;

		function DeferredActionQueues(queueNames, options) {
			var queues = this.queues = {};
			this.queueNames = queueNames = queueNames || [];

			var queueName;
			for (var i = 0, l = queueNames.length; i < l; i++) {
				queueName = queueNames[i];
				queues[queueName] = new Queue(this, queueName, options[queueName]);
			}
		}

		DeferredActionQueues.prototype = {
			queueNames: null,
			queues: null,

			schedule: function(queueName, target, method, args, onceFlag, stack) {
				var queues = this.queues,
						queue = queues[queueName];

				if (!queue) { throw new Error("You attempted to schedule an action in a queue (" + queueName + ") that doesn't exist"); }

				if (onceFlag) {
					return queue.pushUnique(target, method, args, stack);
				} else {
					return queue.push(target, method, args, stack);
				}
			},

			flush: function() {
				var queues = this.queues,
						queueNames = this.queueNames,
						queueName, queue, queueItems, priorQueueNameIndex,
						queueNameIndex = 0, numberOfQueues = queueNames.length;

				outerloop:
				while (queueNameIndex < numberOfQueues) {
					queueName = queueNames[queueNameIndex];
					queue = queues[queueName];
					queueItems = queue._queueBeingFlushed = queue._queue.slice();
					queue._queue = [];

					var options = queue.options,
							before = options && options.before,
							after = options && options.after,
							target, method, args, stack,
							queueIndex = 0, numberOfQueueItems = queueItems.length;

					if (numberOfQueueItems && before) { before(); }
					while (queueIndex < numberOfQueueItems) {
						target = queueItems[queueIndex];
						method = queueItems[queueIndex+1];
						args   = queueItems[queueIndex+2];
						stack  = queueItems[queueIndex+3]; // Debugging assistance

						if (typeof method === 'string') { method = target[method]; }

						// method could have been nullified / canceled during flush
						if (method) {
							// TODO: error handling
							if (args && args.length > 0) {
								method.apply(target, args);
							} else {
								method.call(target);
							}
						}

						queueIndex += 4;
					}
					queue._queueBeingFlushed = null;
					if (numberOfQueueItems && after) { after(); }

					if ((priorQueueNameIndex = indexOfPriorQueueWithActions(this, queueNameIndex)) !== -1) {
						queueNameIndex = priorQueueNameIndex;
						continue outerloop;
					}

					queueNameIndex++;
				}
			}
		};

		function indexOfPriorQueueWithActions(daq, currentQueueIndex) {
			var queueName, queue;

			for (var i = 0, l = currentQueueIndex; i <= l; i++) {
				queueName = daq.queueNames[i];
				queue = daq.queues[queueName];
				if (queue._queue.length) { return i; }
			}

			return -1;
		}


		__exports__.DeferredActionQueues = DeferredActionQueues;
	});

define("backburner",
	["backburner/deferred_action_queues","exports"],
	function(__dependency1__, __exports__) {
		"use strict";
		var DeferredActionQueues = __dependency1__.DeferredActionQueues;

		var slice = [].slice,
				pop = [].pop,
				throttlers = [],
				debouncees = [],
				timers = [],
				autorun, laterTimer, laterTimerExpiresAt,
				global = this,
				NUMBER = /\d+/;

		function isCoercableNumber(number) {
			return typeof number === 'number' || NUMBER.test(number);
		}

		function Backburner(queueNames, options) {
			this.queueNames = queueNames;
			this.options = options || {};
			if (!this.options.defaultQueue) {
				this.options.defaultQueue = queueNames[0];
			}
			this.instanceStack = [];
		}

		Backburner.prototype = {
			queueNames: null,
			options: null,
			currentInstance: null,
			instanceStack: null,

			begin: function() {
				var onBegin = this.options && this.options.onBegin,
						previousInstance = this.currentInstance;

				if (previousInstance) {
					this.instanceStack.push(previousInstance);
				}

				this.currentInstance = new DeferredActionQueues(this.queueNames, this.options);
				if (onBegin) {
					onBegin(this.currentInstance, previousInstance);
				}
			},

			end: function() {
				var onEnd = this.options && this.options.onEnd,
						currentInstance = this.currentInstance,
						nextInstance = null;

				try {
					currentInstance.flush();
				} finally {
					this.currentInstance = null;

					if (this.instanceStack.length) {
						nextInstance = this.instanceStack.pop();
						this.currentInstance = nextInstance;
					}

					if (onEnd) {
						onEnd(currentInstance, nextInstance);
					}
				}
			},

			run: function(target, method /*, args */) {
				var ret;
				this.begin();

				if (!method) {
					method = target;
					target = null;
				}

				if (typeof method === 'string') {
					method = target[method];
				}

				// Prevent Safari double-finally.
				var finallyAlreadyCalled = false;
				try {
					if (arguments.length > 2) {
						ret = method.apply(target, slice.call(arguments, 2));
					} else {
						ret = method.call(target);
					}
				} finally {
					if (!finallyAlreadyCalled) {
						finallyAlreadyCalled = true;
						this.end();
					}
				}
				return ret;
			},

			defer: function(queueName, target, method /* , args */) {
				if (!method) {
					method = target;
					target = null;
				}

				if (typeof method === 'string') {
					method = target[method];
				}

				var stack = this.DEBUG ? new Error() : undefined,
						args = arguments.length > 3 ? slice.call(arguments, 3) : undefined;
				if (!this.currentInstance) { createAutorun(this); }
				return this.currentInstance.schedule(queueName, target, method, args, false, stack);
			},

			deferOnce: function(queueName, target, method /* , args */) {
				if (!method) {
					method = target;
					target = null;
				}

				if (typeof method === 'string') {
					method = target[method];
				}

				var stack = this.DEBUG ? new Error() : undefined,
						args = arguments.length > 3 ? slice.call(arguments, 3) : undefined;
				if (!this.currentInstance) { createAutorun(this); }
				return this.currentInstance.schedule(queueName, target, method, args, true, stack);
			},

			setTimeout: function() {
				var args = slice.call(arguments);
				var length = args.length;
				var method, wait, target;
				var self = this;
				var methodOrTarget, methodOrWait, methodOrArgs;

				if (length === 0) {
					return;
				} else if (length === 1) {
					method = args.shift();
					wait = 0;
				} else if (length === 2) {
					methodOrTarget = args[0];
					methodOrWait = args[1];

					if (typeof methodOrWait === 'function' || typeof  methodOrTarget[methodOrWait] === 'function') {
						target = args.shift();
						method = args.shift();
						wait = 0;
					} else if (isCoercableNumber(methodOrWait)) {
						method = args.shift();
						wait = args.shift();
					} else {
						method = args.shift();
						wait =  0;
					}
				} else {
					var last = args[args.length - 1];

					if (isCoercableNumber(last)) {
						wait = args.pop();
					}

					methodOrTarget = args[0];
					methodOrArgs = args[1];

					if (typeof methodOrArgs === 'function' || (typeof methodOrArgs === 'string' &&
																										 methodOrTarget !== null &&
																										 methodOrArgs in methodOrTarget)) {
						target = args.shift();
						method = args.shift();
					} else {
						method = args.shift();
					}
				}

				var executeAt = (+new Date()) + parseInt(wait, 10);

				if (typeof method === 'string') {
					method = target[method];
				}

				function fn() {
					method.apply(target, args);
				}

				// find position to insert - TODO: binary search
				var i, l;
				for (i = 0, l = timers.length; i < l; i += 2) {
					if (executeAt < timers[i]) { break; }
				}

				timers.splice(i, 0, executeAt, fn);

				updateLaterTimer(self, executeAt, wait);

				return fn;
			},

			throttle: function(target, method /* , args, wait */) {
				var self = this,
						args = arguments,
						wait = parseInt(pop.call(args), 10),
						throttler,
						index,
						timer;

				index = findThrottler(target, method);
				if (index > -1) { return throttlers[index]; } // throttled

				timer = global.setTimeout(function() {
					self.run.apply(self, args);

					var index = findThrottler(target, method);
					if (index > -1) { throttlers.splice(index, 1); }
				}, wait);

				throttler = [target, method, timer];

				throttlers.push(throttler);

				return throttler;
			},

			debounce: function(target, method /* , args, wait, [immediate] */) {
				var self = this,
						args = arguments,
						immediate = pop.call(args),
						wait,
						index,
						debouncee,
						timer;

				if (typeof immediate === "number" || typeof immediate === "string") {
					wait = immediate;
					immediate = false;
				} else {
					wait = pop.call(args);
				}

				wait = parseInt(wait, 10);
				// Remove debouncee
				index = findDebouncee(target, method);

				if (index > -1) {
					debouncee = debouncees[index];
					debouncees.splice(index, 1);
					clearTimeout(debouncee[2]);
				}

				timer = global.setTimeout(function() {
					if (!immediate) {
						self.run.apply(self, args);
					}
					var index = findDebouncee(target, method);
					if (index > -1) {
						debouncees.splice(index, 1);
					}
				}, wait);

				if (immediate && index === -1) {
					self.run.apply(self, args);
				}

				debouncee = [target, method, timer];

				debouncees.push(debouncee);

				return debouncee;
			},

			cancelTimers: function() {
				var i, len;

				for (i = 0, len = throttlers.length; i < len; i++) {
					clearTimeout(throttlers[i][2]);
				}
				throttlers = [];

				for (i = 0, len = debouncees.length; i < len; i++) {
					clearTimeout(debouncees[i][2]);
				}
				debouncees = [];

				if (laterTimer) {
					clearTimeout(laterTimer);
					laterTimer = null;
				}
				timers = [];

				if (autorun) {
					clearTimeout(autorun);
					autorun = null;
				}
			},

			hasTimers: function() {
				return !!timers.length || autorun;
			},

			cancel: function(timer) {
				var timerType = typeof timer;

				if (timer && timerType === 'object' && timer.queue && timer.method) { // we're cancelling a deferOnce
					return timer.queue.cancel(timer);
				} else if (timerType === 'function') { // we're cancelling a setTimeout
					for (var i = 0, l = timers.length; i < l; i += 2) {
						if (timers[i + 1] === timer) {
							timers.splice(i, 2); // remove the two elements
							return true;
						}
					}
				} else if (window.toString.call(timer) === "[object Array]"){ // we're cancelling a throttle or debounce
					return this._cancelItem(findThrottler, throttlers, timer) ||
									 this._cancelItem(findDebouncee, debouncees, timer);
				} else {
					return; // timer was null or not a timer
				}
			},

			_cancelItem: function(findMethod, array, timer){
				var item,
						index;

				if (timer.length < 3) { return false; }

				index = findMethod(timer[0], timer[1]);

				if(index > -1) {

					item = array[index];

					if(item[2] === timer[2]){
						array.splice(index, 1);
						clearTimeout(timer[2]);
						return true;
					}
				}

				return false;
			}

		};

		Backburner.prototype.schedule = Backburner.prototype.defer;
		Backburner.prototype.scheduleOnce = Backburner.prototype.deferOnce;
		Backburner.prototype.later = Backburner.prototype.setTimeout;

		function createAutorun(backburner) {
			backburner.begin();
			autorun = global.setTimeout(function() {
				autorun = null;
				backburner.end();
			});
		}

		function updateLaterTimer(self, executeAt, wait) {
			if (!laterTimer || executeAt < laterTimerExpiresAt) {
				if (laterTimer) {
					clearTimeout(laterTimer);
				}
				laterTimer = global.setTimeout(function() {
					laterTimer = null;
					laterTimerExpiresAt = null;
					executeTimers(self);
				}, wait);
				laterTimerExpiresAt = executeAt;
			}
		}

		function executeTimers(self) {
			var now = +new Date(),
					time, fns, i, l;

			self.run(function() {
				// TODO: binary search
				for (i = 0, l = timers.length; i < l; i += 2) {
					time = timers[i];
					if (time > now) { break; }
				}

				fns = timers.splice(0, i);

				for (i = 1, l = fns.length; i < l; i += 2) {
					self.schedule(self.options.defaultQueue, null, fns[i]);
				}
			});

			if (timers.length) {
				updateLaterTimer(self, timers[0], timers[0] - now);
			}
		}

		function findDebouncee(target, method) {
			var debouncee,
					index = -1;

			for (var i = 0, l = debouncees.length; i < l; i++) {
				debouncee = debouncees[i];
				if (debouncee[0] === target && debouncee[1] === method) {
					index = i;
					break;
				}
			}

			return index;
		}

		function findThrottler(target, method) {
			var throttler,
					index = -1;

			for (var i = 0, l = throttlers.length; i < l; i++) {
				throttler = throttlers[i];
				if (throttler[0] === target && throttler[1] === method) {
					index = i;
					break;
				}
			}

			return index;
		}


		__exports__.Backburner = Backburner;
	});
})();



(function() {
var onBegin = function(current) {
	Ember.run.currentRunLoop = current;
};

var onEnd = function(current, next) {
	Ember.run.currentRunLoop = next;
};

var Backburner = requireModule('backburner').Backburner,
		backburner = new Backburner(['sync', 'actions', 'destroy'], {
			sync: {
				before: Ember.beginPropertyChanges,
				after: Ember.endPropertyChanges
			},
			defaultQueue: 'actions',
			onBegin: onBegin,
			onEnd: onEnd
		}),
		slice = [].slice,
		concat = [].concat;

// ..........................................................
// Ember.run - this is ideally the only public API the dev sees
//

/**
	Runs the passed target and method inside of a RunLoop, ensuring any
	deferred actions including bindings and views updates are flushed at the
	end.

	Normally you should not need to invoke this method yourself. However if
	you are implementing raw event handlers when interfacing with other
	libraries or plugins, you should probably wrap all of your code inside this
	call.

	```javascript
	Ember.run(function() {
		// code to be execute within a RunLoop
	});
	```

	@class run
	@namespace Ember
	@static
	@constructor
	@param {Object} [target] target of method to call
	@param {Function|String} method Method to invoke.
		May be a function or a string. If you pass a string
		then it will be looked up on the passed target.
	@param {Object} [args*] Any additional arguments you wish to pass to the method.
	@return {Object} return value from invoking the passed function.
*/
Ember.run = function(target, method) {
	var ret;

	if (Ember.onerror) {
		try {
			ret = backburner.run.apply(backburner, arguments);
		} catch (e) {
			Ember.onerror(e);
		}
	} else {
		ret = backburner.run.apply(backburner, arguments);
	}

	return ret;
};

/**
	If no run-loop is present, it creates a new one. If a run loop is
	present it will queue itself to run on the existing run-loops action
	queue.

	Please note: This is not for normal usage, and should be used sparingly.

	If invoked when not within a run loop:

	```javascript
	Ember.run.join(function() {
		// creates a new run-loop
	});
	```

	Alternatively, if called within an existing run loop:

	```javascript
	Ember.run(function() {
		// creates a new run-loop
		Ember.run.join(function() {
			// joins with the existing run-loop, and queues for invocation on
			// the existing run-loops action queue.
		});
	});
	```

	@method join
	@namespace Ember
	@param {Object} [target] target of method to call
	@param {Function|String} method Method to invoke.
		May be a function or a string. If you pass a string
		then it will be looked up on the passed target.
	@param {Object} [args*] Any additional arguments you wish to pass to the method.
	@return {Object} Return value from invoking the passed function. Please note,
	when called within an existing loop, no return value is possible.
*/
Ember.run.join = function(target, method /* args */) {
	if (!Ember.run.currentRunLoop) {
		return Ember.run.apply(Ember.run, arguments);
	}

	var args = slice.call(arguments);
	args.unshift('actions');
	Ember.run.schedule.apply(Ember.run, args);
};


/**
	Provides a useful utility for when integrating with non-Ember libraries
	that provide asynchronous callbacks.

	Ember utilizes a run-loop to batch and coalesce changes. This works by
	marking the start and end of Ember-related Javascript execution.

	When using events such as a View's click handler, Ember wraps the event
	handler in a run-loop, but when integrating with non-Ember libraries this
	can be tedious.

	For example, the following is rather verbose but is the correct way to combine
	third-party events and Ember code.

	```javascript
	var that = this;
	jQuery(window).on('resize', function(){
		Ember.run(function(){
			that.handleResize();
		});
	});
	```

	To reduce the boilerplate, the following can be used to construct a
	run-loop-wrapped callback handler.

	```javascript
	jQuery(window).on('resize', Ember.run.bind(this, this.triggerResize));
	```

	@method bind
	@namespace Ember.run
	@param {Object} [target] target of method to call
	@param {Function|String} method Method to invoke.
		May be a function or a string. If you pass a string
		then it will be looked up on the passed target.
	@param {Object} [args*] Any additional arguments you wish to pass to the method.
	@return {Object} return value from invoking the passed function. Please note,
	when called within an existing loop, no return value is possible.
*/
	Ember.run.bind = function(target, method /* args*/) {
		var args = arguments;
		return function() {
			return Ember.run.join.apply(Ember.run, args);
		};
	};


Ember.run.backburner = backburner;

var run = Ember.run;

Ember.run.currentRunLoop = null;

Ember.run.queues = backburner.queueNames;

/**
	Begins a new RunLoop. Any deferred actions invoked after the begin will
	be buffered until you invoke a matching call to `Ember.run.end()`. This is
	a lower-level way to use a RunLoop instead of using `Ember.run()`.

	```javascript
	Ember.run.begin();
	// code to be execute within a RunLoop
	Ember.run.end();
	```

	@method begin
	@return {void}
*/
Ember.run.begin = function() {
	backburner.begin();
};

/**
	Ends a RunLoop. This must be called sometime after you call
	`Ember.run.begin()` to flush any deferred actions. This is a lower-level way
	to use a RunLoop instead of using `Ember.run()`.

	```javascript
	Ember.run.begin();
	// code to be execute within a RunLoop
	Ember.run.end();
	```

	@method end
	@return {void}
*/
Ember.run.end = function() {
	backburner.end();
};

/**
	Array of named queues. This array determines the order in which queues
	are flushed at the end of the RunLoop. You can define your own queues by
	simply adding the queue name to this array. Normally you should not need
	to inspect or modify this property.

	@property queues
	@type Array
	@default ['sync', 'actions', 'destroy']
*/

/**
	Adds the passed target/method and any optional arguments to the named
	queue to be executed at the end of the RunLoop. If you have not already
	started a RunLoop when calling this method one will be started for you
	automatically.

	At the end of a RunLoop, any methods scheduled in this way will be invoked.
	Methods will be invoked in an order matching the named queues defined in
	the `Ember.run.queues` property.

	```javascript
	Ember.run.schedule('sync', this, function() {
		// this will be executed in the first RunLoop queue, when bindings are synced
		console.log("scheduled on sync queue");
	});

	Ember.run.schedule('actions', this, function() {
		// this will be executed in the 'actions' queue, after bindings have synced.
		console.log("scheduled on actions queue");
	});

	// Note the functions will be run in order based on the run queues order.
	// Output would be:
	//   scheduled on sync queue
	//   scheduled on actions queue
	```

	@method schedule
	@param {String} queue The name of the queue to schedule against.
		Default queues are 'sync' and 'actions'
	@param {Object} [target] target object to use as the context when invoking a method.
	@param {String|Function} method The method to invoke. If you pass a string it
		will be resolved on the target object at the time the scheduled item is
		invoked allowing you to change the target function.
	@param {Object} [arguments*] Optional arguments to be passed to the queued method.
	@return {void}
*/
Ember.run.schedule = function(queue, target, method) {
	checkAutoRun();
	backburner.schedule.apply(backburner, arguments);
};

// Used by global test teardown
Ember.run.hasScheduledTimers = function() {
	return backburner.hasTimers();
};

// Used by global test teardown
Ember.run.cancelTimers = function () {
	backburner.cancelTimers();
};

/**
	Immediately flushes any events scheduled in the 'sync' queue. Bindings
	use this queue so this method is a useful way to immediately force all
	bindings in the application to sync.

	You should call this method anytime you need any changed state to propagate
	throughout the app immediately without repainting the UI (which happens
	in the later 'render' queue added by the `ember-views` package).

	```javascript
	Ember.run.sync();
	```

	@method sync
	@return {void}
*/
Ember.run.sync = function() {
	if (backburner.currentInstance) {
		backburner.currentInstance.queues.sync.flush();
	}
};

/**
	Invokes the passed target/method and optional arguments after a specified
	period if time. The last parameter of this method must always be a number
	of milliseconds.

	You should use this method whenever you need to run some action after a
	period of time instead of using `setTimeout()`. This method will ensure that
	items that expire during the same script execution cycle all execute
	together, which is often more efficient than using a real setTimeout.

	```javascript
	Ember.run.later(myContext, function() {
		// code here will execute within a RunLoop in about 500ms with this == myContext
	}, 500);
	```

	@method later
	@param {Object} [target] target of method to invoke
	@param {Function|String} method The method to invoke.
		If you pass a string it will be resolved on the
		target at the time the method is invoked.
	@param {Object} [args*] Optional arguments to pass to the timeout.
	@param {Number} wait Number of milliseconds to wait.
	@return {String} a string you can use to cancel the timer in
		`Ember.run.cancel` later.
*/
Ember.run.later = function(target, method) {
	return backburner.later.apply(backburner, arguments);
};

/**
	Schedule a function to run one time during the current RunLoop. This is equivalent
	to calling `scheduleOnce` with the "actions" queue.

	@method once
	@param {Object} [target] The target of the method to invoke.
	@param {Function|String} method The method to invoke.
		If you pass a string it will be resolved on the
		target at the time the method is invoked.
	@param {Object} [args*] Optional arguments to pass to the timeout.
	@return {Object} Timer information for use in cancelling, see `Ember.run.cancel`.
*/
Ember.run.once = function(target, method) {
	checkAutoRun();
	var args = slice.call(arguments);
	args.unshift('actions');
	return backburner.scheduleOnce.apply(backburner, args);
};

/**
	Schedules a function to run one time in a given queue of the current RunLoop.
	Calling this method with the same queue/target/method combination will have
	no effect (past the initial call).

	Note that although you can pass optional arguments these will not be
	considered when looking for duplicates. New arguments will replace previous
	calls.

	```javascript
	Ember.run(function() {
		var sayHi = function() { console.log('hi'); }
		Ember.run.scheduleOnce('afterRender', myContext, sayHi);
		Ember.run.scheduleOnce('afterRender', myContext, sayHi);
		// sayHi will only be executed once, in the afterRender queue of the RunLoop
	});
	```

	Also note that passing an anonymous function to `Ember.run.scheduleOnce` will
	not prevent additional calls with an identical anonymous function from
	scheduling the items multiple times, e.g.:

	```javascript
	function scheduleIt() {
		Ember.run.scheduleOnce('actions', myContext, function() { console.log("Closure"); });
	}
	scheduleIt();
	scheduleIt();
	// "Closure" will print twice, even though we're using `Ember.run.scheduleOnce`,
	// because the function we pass to it is anonymous and won't match the
	// previously scheduled operation.
	```

	Available queues, and their order, can be found at `Ember.run.queues`

	@method scheduleOnce
	@param {String} [queue] The name of the queue to schedule against. Default queues are 'sync' and 'actions'.
	@param {Object} [target] The target of the method to invoke.
	@param {Function|String} method The method to invoke.
		If you pass a string it will be resolved on the
		target at the time the method is invoked.
	@param {Object} [args*] Optional arguments to pass to the timeout.
	@return {Object} Timer information for use in cancelling, see `Ember.run.cancel`.
*/
Ember.run.scheduleOnce = function(queue, target, method) {
	checkAutoRun();
	return backburner.scheduleOnce.apply(backburner, arguments);
};

/**
	Schedules an item to run from within a separate run loop, after
	control has been returned to the system. This is equivalent to calling
	`Ember.run.later` with a wait time of 1ms.

	```javascript
	Ember.run.next(myContext, function() {
		// code to be executed in the next run loop,
		// which will be scheduled after the current one
	});
	```

	Multiple operations scheduled with `Ember.run.next` will coalesce
	into the same later run loop, along with any other operations
	scheduled by `Ember.run.later` that expire right around the same
	time that `Ember.run.next` operations will fire.

	Note that there are often alternatives to using `Ember.run.next`.
	For instance, if you'd like to schedule an operation to happen
	after all DOM element operations have completed within the current
	run loop, you can make use of the `afterRender` run loop queue (added
	by the `ember-views` package, along with the preceding `render` queue
	where all the DOM element operations happen). Example:

	```javascript
	App.MyCollectionView = Ember.CollectionView.extend({
		didInsertElement: function() {
			Ember.run.scheduleOnce('afterRender', this, 'processChildElements');
		},
		processChildElements: function() {
			// ... do something with collectionView's child view
			// elements after they've finished rendering, which
			// can't be done within the CollectionView's
			// `didInsertElement` hook because that gets run
			// before the child elements have been added to the DOM.
		}
	});
	```

	One benefit of the above approach compared to using `Ember.run.next` is
	that you will be able to perform DOM/CSS operations before unprocessed
	elements are rendered to the screen, which may prevent flickering or
	other artifacts caused by delaying processing until after rendering.

	The other major benefit to the above approach is that `Ember.run.next`
	introduces an element of non-determinism, which can make things much
	harder to test, due to its reliance on `setTimeout`; it's much harder
	to guarantee the order of scheduled operations when they are scheduled
	outside of the current run loop, i.e. with `Ember.run.next`.

	@method next
	@param {Object} [target] target of method to invoke
	@param {Function|String} method The method to invoke.
		If you pass a string it will be resolved on the
		target at the time the method is invoked.
	@param {Object} [args*] Optional arguments to pass to the timeout.
	@return {Object} Timer information for use in cancelling, see `Ember.run.cancel`.
*/
Ember.run.next = function() {
	var args = slice.call(arguments);
	args.push(1);
	return backburner.later.apply(backburner, args);
};

/**
	Cancels a scheduled item. Must be a value returned by `Ember.run.later()`,
	`Ember.run.once()`, `Ember.run.next()`, `Ember.run.debounce()`, or
	`Ember.run.throttle()`.

	```javascript
	var runNext = Ember.run.next(myContext, function() {
		// will not be executed
	});
	Ember.run.cancel(runNext);

	var runLater = Ember.run.later(myContext, function() {
		// will not be executed
	}, 500);
	Ember.run.cancel(runLater);

	var runOnce = Ember.run.once(myContext, function() {
		// will not be executed
	});
	Ember.run.cancel(runOnce);

	var throttle = Ember.run.throttle(myContext, function() {
		// will not be executed
	}, 1);
	Ember.run.cancel(throttle);

	var debounce = Ember.run.debounce(myContext, function() {
		// will not be executed
	}, 1);
	Ember.run.cancel(debounce);

	var debounceImmediate = Ember.run.debounce(myContext, function() {
		// will be executed since we passed in true (immediate)
	}, 100, true);
	// the 100ms delay until this method can be called again will be cancelled
	Ember.run.cancel(debounceImmediate);
	```
	```
	```

	@method cancel
	@param {Object} timer Timer object to cancel
	@return {Boolean} true if cancelled or false/undefined if it wasn't found
*/
Ember.run.cancel = function(timer) {
	return backburner.cancel(timer);
};

/**
	Delay calling the target method until the debounce period has elapsed
	with no additional debounce calls. If `debounce` is called again before
	the specified time has elapsed, the timer is reset and the entire period
	must pass again before the target method is called.

	This method should be used when an event may be called multiple times
	but the action should only be called once when the event is done firing.
	A common example is for scroll events where you only want updates to
	happen once scrolling has ceased.

	```javascript
		var myFunc = function() { console.log(this.name + ' ran.'); };
		var myContext = {name: 'debounce'};

		Ember.run.debounce(myContext, myFunc, 150);

		// less than 150ms passes

		Ember.run.debounce(myContext, myFunc, 150);

		// 150ms passes
		// myFunc is invoked with context myContext
		// console logs 'debounce ran.' one time.
	```

	Immediate allows you to run the function immediately, but debounce
	other calls for this function until the wait time has elapsed. If
	`debounce` is called again before the specified time has elapsed,
	the timer is reset and the entire period msut pass again before
	the method can be called again.

	```javascript
		var myFunc = function() { console.log(this.name + ' ran.'); };
		var myContext = {name: 'debounce'};

		Ember.run.debounce(myContext, myFunc, 150, true);

		// console logs 'debounce ran.' one time immediately.
		// 100ms passes

		Ember.run.debounce(myContext, myFunc, 150, true);

		// 150ms passes and nothing else is logged to the console and
		// the debouncee is no longer being watched

		Ember.run.debounce(myContext, myFunc, 150, true);

		// console logs 'debounce ran.' one time immediately.
		// 150ms passes and nothing else is logged tot he console and
		// the debouncee is no longer being watched

	```

	@method debounce
	@param {Object} [target] target of method to invoke
	@param {Function|String} method The method to invoke.
		May be a function or a string. If you pass a string
		then it will be looked up on the passed target.
	@param {Object} [args*] Optional arguments to pass to the timeout.
	@param {Number} wait Number of milliseconds to wait.
	@param {Boolean} immediate Trigger the function on the leading instead of the trailing edge of the wait interval.
	@return {Array} Timer information for use in cancelling, see `Ember.run.cancel`.
*/
Ember.run.debounce = function() {
	return backburner.debounce.apply(backburner, arguments);
};

/**
	Ensure that the target method is never called more frequently than
	the specified spacing period.

	```javascript
		var myFunc = function() { console.log(this.name + ' ran.'); };
		var myContext = {name: 'throttle'};

		Ember.run.throttle(myContext, myFunc, 150);

		// 50ms passes
		Ember.run.throttle(myContext, myFunc, 150);

		// 50ms passes
		Ember.run.throttle(myContext, myFunc, 150);

		// 50ms passes
		Ember.run.throttle(myContext, myFunc, 150);

		// 150ms passes
		// myFunc is invoked with context myContext
		// console logs 'throttle ran.' twice, 150ms apart.
	```

	@method throttle
	@param {Object} [target] target of method to invoke
	@param {Function|String} method The method to invoke.
		May be a function or a string. If you pass a string
		then it will be looked up on the passed target.
	@param {Object} [args*] Optional arguments to pass to the timeout.
	@param {Number} spacing Number of milliseconds to space out requests.
	@return {Array} Timer information for use in cancelling, see `Ember.run.cancel`.
*/
Ember.run.throttle = function() {
	return backburner.throttle.apply(backburner, arguments);
};

// Make sure it's not an autorun during testing
function checkAutoRun() {
	if (!Ember.run.currentRunLoop) {
			}
}

})();



(function() {
// Ember.Logger
// get
// set
// guidFor, meta
// addObserver, removeObserver
// Ember.run.schedule
/**
@module ember-metal
*/

// ..........................................................
// CONSTANTS
//

/**
	Debug parameter you can turn on. This will log all bindings that fire to
	the console. This should be disabled in production code. Note that you
	can also enable this from the console or temporarily.

	@property LOG_BINDINGS
	@for Ember
	@type Boolean
	@default false
*/
Ember.LOG_BINDINGS = false || !!Ember.ENV.LOG_BINDINGS;

var get     = Ember.get,
		set     = Ember.set,
		guidFor = Ember.guidFor,
		IS_GLOBAL = /^([A-Z$]|([0-9][A-Z$]))/;

/**
	Returns true if the provided path is global (e.g., `MyApp.fooController.bar`)
	instead of local (`foo.bar.baz`).

	@method isGlobalPath
	@for Ember
	@private
	@param {String} path
	@return Boolean
*/
var isGlobalPath = Ember.isGlobalPath = function(path) {
	return IS_GLOBAL.test(path);
};

function getWithGlobals(obj, path) {
	return get(isGlobalPath(path) ? Ember.lookup : obj, path);
}

// ..........................................................
// BINDING
//

var Binding = function(toPath, fromPath) {
	this._direction = 'fwd';
	this._from = fromPath;
	this._to   = toPath;
	this._directionMap = Ember.Map.create();
};

/**
@class Binding
@namespace Ember
*/

Binding.prototype = {
	/**
		This copies the Binding so it can be connected to another object.

		@method copy
		@return {Ember.Binding} `this`
	*/
	copy: function () {
		var copy = new Binding(this._to, this._from);
		if (this._oneWay) { copy._oneWay = true; }
		return copy;
	},

	// ..........................................................
	// CONFIG
	//

	/**
		This will set `from` property path to the specified value. It will not
		attempt to resolve this property path to an actual object until you
		connect the binding.

		The binding will search for the property path starting at the root object
		you pass when you `connect()` the binding. It follows the same rules as
		`get()` - see that method for more information.

		@method from
		@param {String} path the property path to connect to
		@return {Ember.Binding} `this`
	*/
	from: function(path) {
		this._from = path;
		return this;
	},

	/**
		This will set the `to` property path to the specified value. It will not
		attempt to resolve this property path to an actual object until you
		connect the binding.

		The binding will search for the property path starting at the root object
		you pass when you `connect()` the binding. It follows the same rules as
		`get()` - see that method for more information.

		@method to
		@param {String|Tuple} path A property path or tuple
		@return {Ember.Binding} `this`
	*/
	to: function(path) {
		this._to = path;
		return this;
	},

	/**
		Configures the binding as one way. A one-way binding will relay changes
		on the `from` side to the `to` side, but not the other way around. This
		means that if you change the `to` side directly, the `from` side may have
		a different value.

		@method oneWay
		@return {Ember.Binding} `this`
	*/
	oneWay: function() {
		this._oneWay = true;
		return this;
	},

	/**
		@method toString
		@return {String} string representation of binding
	*/
	toString: function() {
		var oneWay = this._oneWay ? '[oneWay]' : '';
		return "Ember.Binding<" + guidFor(this) + ">(" + this._from + " -> " + this._to + ")" + oneWay;
	},

	// ..........................................................
	// CONNECT AND SYNC
	//

	/**
		Attempts to connect this binding instance so that it can receive and relay
		changes. This method will raise an exception if you have not set the
		from/to properties yet.

		@method connect
		@param {Object} obj The root object for this binding.
		@return {Ember.Binding} `this`
	*/
	connect: function(obj) {

		var fromPath = this._from, toPath = this._to;
		Ember.trySet(obj, toPath, getWithGlobals(obj, fromPath));

		// add an observer on the object to be notified when the binding should be updated
		Ember.addObserver(obj, fromPath, this, this.fromDidChange);

		// if the binding is a two-way binding, also set up an observer on the target
		if (!this._oneWay) { Ember.addObserver(obj, toPath, this, this.toDidChange); }

		this._readyToSync = true;

		return this;
	},

	/**
		Disconnects the binding instance. Changes will no longer be relayed. You
		will not usually need to call this method.

		@method disconnect
		@param {Object} obj The root object you passed when connecting the binding.
		@return {Ember.Binding} `this`
	*/
	disconnect: function(obj) {

		var twoWay = !this._oneWay;

		// remove an observer on the object so we're no longer notified of
		// changes that should update bindings.
		Ember.removeObserver(obj, this._from, this, this.fromDidChange);

		// if the binding is two-way, remove the observer from the target as well
		if (twoWay) { Ember.removeObserver(obj, this._to, this, this.toDidChange); }

		this._readyToSync = false; // disable scheduled syncs...
		return this;
	},

	// ..........................................................
	// PRIVATE
	//

	/* called when the from side changes */
	fromDidChange: function(target) {
		this._scheduleSync(target, 'fwd');
	},

	/* called when the to side changes */
	toDidChange: function(target) {
		this._scheduleSync(target, 'back');
	},

	_scheduleSync: function(obj, dir) {
		var directionMap = this._directionMap;
		var existingDir = directionMap.get(obj);

		// if we haven't scheduled the binding yet, schedule it
		if (!existingDir) {
			Ember.run.schedule('sync', this, this._sync, obj);
			directionMap.set(obj, dir);
		}

		// If both a 'back' and 'fwd' sync have been scheduled on the same object,
		// default to a 'fwd' sync so that it remains deterministic.
		if (existingDir === 'back' && dir === 'fwd') {
			directionMap.set(obj, 'fwd');
		}
	},

	_sync: function(obj) {
		var log = Ember.LOG_BINDINGS;

		// don't synchronize destroyed objects or disconnected bindings
		if (obj.isDestroyed || !this._readyToSync) { return; }

		// get the direction of the binding for the object we are
		// synchronizing from
		var directionMap = this._directionMap;
		var direction = directionMap.get(obj);

		var fromPath = this._from, toPath = this._to;

		directionMap.remove(obj);

		// if we're synchronizing from the remote object...
		if (direction === 'fwd') {
			var fromValue = getWithGlobals(obj, this._from);
			if (log) {
				Ember.Logger.log(' ', this.toString(), '->', fromValue, obj);
			}
			if (this._oneWay) {
				Ember.trySet(obj, toPath, fromValue);
			} else {
				Ember._suspendObserver(obj, toPath, this, this.toDidChange, function () {
					Ember.trySet(obj, toPath, fromValue);
				});
			}
		// if we're synchronizing *to* the remote object
		} else if (direction === 'back') {
			var toValue = get(obj, this._to);
			if (log) {
				Ember.Logger.log(' ', this.toString(), '<-', toValue, obj);
			}
			Ember._suspendObserver(obj, fromPath, this, this.fromDidChange, function () {
				Ember.trySet(Ember.isGlobalPath(fromPath) ? Ember.lookup : obj, fromPath, toValue);
			});
		}
	}

};

function mixinProperties(to, from) {
	for (var key in from) {
		if (from.hasOwnProperty(key)) {
			to[key] = from[key];
		}
	}
}

mixinProperties(Binding, {

	/*
		See `Ember.Binding.from`.

		@method from
		@static
	*/
	from: function() {
		var C = this, binding = new C();
		return binding.from.apply(binding, arguments);
	},

	/*
		See `Ember.Binding.to`.

		@method to
		@static
	*/
	to: function() {
		var C = this, binding = new C();
		return binding.to.apply(binding, arguments);
	},

	/**
		Creates a new Binding instance and makes it apply in a single direction.
		A one-way binding will relay changes on the `from` side object (supplied
		as the `from` argument) the `to` side, but not the other way around.
		This means that if you change the "to" side directly, the "from" side may have
		a different value.

		See `Binding.oneWay`.

		@method oneWay
		@param {String} from from path.
		@param {Boolean} [flag] (Optional) passing nothing here will make the
			binding `oneWay`. You can instead pass `false` to disable `oneWay`, making the
			binding two way again.
		@return {Ember.Binding} `this`
	*/
	oneWay: function(from, flag) {
		var C = this, binding = new C(null, from);
		return binding.oneWay(flag);
	}

});

/**
	An `Ember.Binding` connects the properties of two objects so that whenever
	the value of one property changes, the other property will be changed also.

	## Automatic Creation of Bindings with `/^*Binding/`-named Properties

	You do not usually create Binding objects directly but instead describe
	bindings in your class or object definition using automatic binding
	detection.

	Properties ending in a `Binding` suffix will be converted to `Ember.Binding`
	instances. The value of this property should be a string representing a path
	to another object or a custom binding instanced created using Binding helpers
	(see "One Way Bindings"):

	```
	valueBinding: "MyApp.someController.title"
	```

	This will create a binding from `MyApp.someController.title` to the `value`
	property of your object instance automatically. Now the two values will be
	kept in sync.

	## One Way Bindings

	One especially useful binding customization you can use is the `oneWay()`
	helper. This helper tells Ember that you are only interested in
	receiving changes on the object you are binding from. For example, if you
	are binding to a preference and you want to be notified if the preference
	has changed, but your object will not be changing the preference itself, you
	could do:

	```
	bigTitlesBinding: Ember.Binding.oneWay("MyApp.preferencesController.bigTitles")
	```

	This way if the value of `MyApp.preferencesController.bigTitles` changes the
	`bigTitles` property of your object will change also. However, if you
	change the value of your `bigTitles` property, it will not update the
	`preferencesController`.

	One way bindings are almost twice as fast to setup and twice as fast to
	execute because the binding only has to worry about changes to one side.

	You should consider using one way bindings anytime you have an object that
	may be created frequently and you do not intend to change a property; only
	to monitor it for changes (such as in the example above).

	## Adding Bindings Manually

	All of the examples above show you how to configure a custom binding, but the
	result of these customizations will be a binding template, not a fully active
	Binding instance. The binding will actually become active only when you
	instantiate the object the binding belongs to. It is useful however, to
	understand what actually happens when the binding is activated.

	For a binding to function it must have at least a `from` property and a `to`
	property. The `from` property path points to the object/key that you want to
	bind from while the `to` path points to the object/key you want to bind to.

	When you define a custom binding, you are usually describing the property
	you want to bind from (such as `MyApp.someController.value` in the examples
	above). When your object is created, it will automatically assign the value
	you want to bind `to` based on the name of your binding key. In the
	examples above, during init, Ember objects will effectively call
	something like this on your binding:

	```javascript
	binding = Ember.Binding.from(this.valueBinding).to("value");
	```

	This creates a new binding instance based on the template you provide, and
	sets the to path to the `value` property of the new object. Now that the
	binding is fully configured with a `from` and a `to`, it simply needs to be
	connected to become active. This is done through the `connect()` method:

	```javascript
	binding.connect(this);
	```

	Note that when you connect a binding you pass the object you want it to be
	connected to. This object will be used as the root for both the from and
	to side of the binding when inspecting relative paths. This allows the
	binding to be automatically inherited by subclassed objects as well.

	Now that the binding is connected, it will observe both the from and to side
	and relay changes.

	If you ever needed to do so (you almost never will, but it is useful to
	understand this anyway), you could manually create an active binding by
	using the `Ember.bind()` helper method. (This is the same method used by
	to setup your bindings on objects):

	```javascript
	Ember.bind(MyApp.anotherObject, "value", "MyApp.someController.value");
	```

	Both of these code fragments have the same effect as doing the most friendly
	form of binding creation like so:

	```javascript
	MyApp.anotherObject = Ember.Object.create({
		valueBinding: "MyApp.someController.value",

		// OTHER CODE FOR THIS OBJECT...
	});
	```

	Ember's built in binding creation method makes it easy to automatically
	create bindings for you. You should always use the highest-level APIs
	available, even if you understand how it works underneath.

	@class Binding
	@namespace Ember
	@since Ember 0.9
*/
Ember.Binding = Binding;


/**
	Global helper method to create a new binding. Just pass the root object
	along with a `to` and `from` path to create and connect the binding.

	@method bind
	@for Ember
	@param {Object} obj The root object of the transform.
	@param {String} to The path to the 'to' side of the binding.
		Must be relative to obj.
	@param {String} from The path to the 'from' side of the binding.
		Must be relative to obj or a global path.
	@return {Ember.Binding} binding instance
*/
Ember.bind = function(obj, to, from) {
	return new Ember.Binding(to, from).connect(obj);
};

/**
	@method oneWay
	@for Ember
	@param {Object} obj The root object of the transform.
	@param {String} to The path to the 'to' side of the binding.
		Must be relative to obj.
	@param {String} from The path to the 'from' side of the binding.
		Must be relative to obj or a global path.
	@return {Ember.Binding} binding instance
*/
Ember.oneWay = function(obj, to, from) {
	return new Ember.Binding(to, from).oneWay().connect(obj);
};

})();



(function() {
/**
@module ember
@submodule ember-metal
*/

var Mixin, REQUIRED, Alias,
		a_map = Ember.ArrayPolyfills.map,
		a_indexOf = Ember.ArrayPolyfills.indexOf,
		a_forEach = Ember.ArrayPolyfills.forEach,
		a_slice = [].slice,
		o_create = Ember.create,
		defineProperty = Ember.defineProperty,
		guidFor = Ember.guidFor,
		metaFor = Ember.meta,
		META_KEY = Ember.META_KEY;


	var expandProperties = Ember.expandProperties;


function superFunction(){
	var ret, func = this.__nextSuper;
	if (func) {
		this.__nextSuper = null;
		ret = func.apply(this, arguments);
		this.__nextSuper = func;
	}
	return ret;
}

function mixinsMeta(obj) {
	var m = metaFor(obj, true), ret = m.mixins;
	if (!ret) {
		ret = m.mixins = {};
	} else if (!m.hasOwnProperty('mixins')) {
		ret = m.mixins = o_create(ret);
	}
	return ret;
}

function initMixin(mixin, args) {
	if (args && args.length > 0) {
		mixin.mixins = a_map.call(args, function(x) {
			if (x instanceof Mixin) { return x; }

			// Note: Manually setup a primitive mixin here. This is the only
			// way to actually get a primitive mixin. This way normal creation
			// of mixins will give you combined mixins...
			var mixin = new Mixin();
			mixin.properties = x;
			return mixin;
		});
	}
	return mixin;
}

function isMethod(obj) {
	return 'function' === typeof obj &&
				 obj.isMethod !== false &&
				 obj !== Boolean && obj !== Object && obj !== Number && obj !== Array && obj !== Date && obj !== String;
}

var CONTINUE = {};

function mixinProperties(mixinsMeta, mixin) {
	var guid;

	if (mixin instanceof Mixin) {
		guid = guidFor(mixin);
		if (mixinsMeta[guid]) { return CONTINUE; }
		mixinsMeta[guid] = mixin;
		return mixin.properties;
	} else {
		return mixin; // apply anonymous mixin properties
	}
}

function concatenatedMixinProperties(concatProp, props, values, base) {
	var concats;

	// reset before adding each new mixin to pickup concats from previous
	concats = values[concatProp] || base[concatProp];
	if (props[concatProp]) {
		concats = concats ? concats.concat(props[concatProp]) : props[concatProp];
	}

	return concats;
}

function giveDescriptorSuper(meta, key, property, values, descs) {
	var superProperty;

	// Computed properties override methods, and do not call super to them
	if (values[key] === undefined) {
		// Find the original descriptor in a parent mixin
		superProperty = descs[key];
	}

	// If we didn't find the original descriptor in a parent mixin, find
	// it on the original object.
	superProperty = superProperty || meta.descs[key];

	if (!superProperty || !(superProperty instanceof Ember.ComputedProperty)) {
		return property;
	}

	// Since multiple mixins may inherit from the same parent, we need
	// to clone the computed property so that other mixins do not receive
	// the wrapped version.
	property = o_create(property);
	property.func = Ember.wrap(property.func, superProperty.func);

	return property;
}

function giveMethodSuper(obj, key, method, values, descs) {
	var superMethod;

	// Methods overwrite computed properties, and do not call super to them.
	if (descs[key] === undefined) {
		// Find the original method in a parent mixin
		superMethod = values[key];
	}

	// If we didn't find the original value in a parent mixin, find it in
	// the original object
	superMethod = superMethod || obj[key];

	// Only wrap the new method if the original method was a function
	if ('function' !== typeof superMethod) {
		return method;
	}

	return Ember.wrap(method, superMethod);
}

function applyConcatenatedProperties(obj, key, value, values) {
	var baseValue = values[key] || obj[key];

	if (baseValue) {
		if ('function' === typeof baseValue.concat) {
			return baseValue.concat(value);
		} else {
			return Ember.makeArray(baseValue).concat(value);
		}
	} else {
		return Ember.makeArray(value);
	}
}

function applyMergedProperties(obj, key, value, values) {
	var baseValue = values[key] || obj[key];

	if (!baseValue) { return value; }

	var newBase = Ember.merge({}, baseValue),
			hasFunction = false;

	for (var prop in value) {
		if (!value.hasOwnProperty(prop)) { continue; }

		var propValue = value[prop];
		if (isMethod(propValue)) {
			// TODO: support for Computed Properties, etc?
			hasFunction = true;
			newBase[prop] = giveMethodSuper(obj, prop, propValue, baseValue, {});
		} else {
			newBase[prop] = propValue;
		}
	}

	if (hasFunction) {
		newBase._super = superFunction;
	}

	return newBase;
}

function addNormalizedProperty(base, key, value, meta, descs, values, concats, mergings) {
	if (value instanceof Ember.Descriptor) {
		if (value === REQUIRED && descs[key]) { return CONTINUE; }

		// Wrap descriptor function to implement
		// __nextSuper() if needed
		if (value.func) {
			value = giveDescriptorSuper(meta, key, value, values, descs);
		}

		descs[key]  = value;
		values[key] = undefined;
	} else {
		if ((concats && a_indexOf.call(concats, key) >= 0) ||
								key === 'concatenatedProperties' ||
								key === 'mergedProperties') {
			value = applyConcatenatedProperties(base, key, value, values);
		} else if ((mergings && a_indexOf.call(mergings, key) >= 0)) {
			value = applyMergedProperties(base, key, value, values);
		} else if (isMethod(value)) {
			value = giveMethodSuper(base, key, value, values, descs);
		}

		descs[key] = undefined;
		values[key] = value;
	}
}

function mergeMixins(mixins, m, descs, values, base, keys) {
	var mixin, props, key, concats, mergings, meta;

	function removeKeys(keyName) {
		delete descs[keyName];
		delete values[keyName];
	}

	for(var i=0, l=mixins.length; i<l; i++) {
		mixin = mixins[i];

		props = mixinProperties(m, mixin);
		if (props === CONTINUE) { continue; }

		if (props) {
			meta = metaFor(base);
			if (base.willMergeMixin) { base.willMergeMixin(props); }
			concats = concatenatedMixinProperties('concatenatedProperties', props, values, base);
			mergings = concatenatedMixinProperties('mergedProperties', props, values, base);

			for (key in props) {
				if (!props.hasOwnProperty(key)) { continue; }
				keys.push(key);
				addNormalizedProperty(base, key, props[key], meta, descs, values, concats, mergings);
			}

			// manually copy toString() because some JS engines do not enumerate it
			if (props.hasOwnProperty('toString')) { base.toString = props.toString; }
		} else if (mixin.mixins) {
			mergeMixins(mixin.mixins, m, descs, values, base, keys);
			if (mixin._without) { a_forEach.call(mixin._without, removeKeys); }
		}
	}
}

var IS_BINDING = Ember.IS_BINDING = /^.+Binding$/;

function detectBinding(obj, key, value, m) {
	if (IS_BINDING.test(key)) {
		var bindings = m.bindings;
		if (!bindings) {
			bindings = m.bindings = {};
		} else if (!m.hasOwnProperty('bindings')) {
			bindings = m.bindings = o_create(m.bindings);
		}
		bindings[key] = value;
	}
}

function connectBindings(obj, m) {
	// TODO Mixin.apply(instance) should disconnect binding if exists
	var bindings = m.bindings, key, binding, to;
	if (bindings) {
		for (key in bindings) {
			binding = bindings[key];
			if (binding) {
				to = key.slice(0, -7); // strip Binding off end
				if (binding instanceof Ember.Binding) {
					binding = binding.copy(); // copy prototypes' instance
					binding.to(to);
				} else { // binding is string path
					binding = new Ember.Binding(to, binding);
				}
				binding.connect(obj);
				obj[key] = binding;
			}
		}
		// mark as applied
		m.bindings = {};
	}
}

function finishPartial(obj, m) {
	connectBindings(obj, m || metaFor(obj));
	return obj;
}

function followAlias(obj, desc, m, descs, values) {
	var altKey = desc.methodName, value;
	if (descs[altKey] || values[altKey]) {
		value = values[altKey];
		desc  = descs[altKey];
	} else if (m.descs[altKey]) {
		desc  = m.descs[altKey];
		value = undefined;
	} else {
		desc = undefined;
		value = obj[altKey];
	}

	return { desc: desc, value: value };
}

function updateObserversAndListeners(obj, key, observerOrListener, pathsKey, updateMethod) {
	var paths = observerOrListener[pathsKey];

	if (paths) {
		for (var i=0, l=paths.length; i<l; i++) {
			Ember[updateMethod](obj, paths[i], null, key);
		}
	}
}

function replaceObserversAndListeners(obj, key, observerOrListener) {
	var prev = obj[key];

	if ('function' === typeof prev) {
		updateObserversAndListeners(obj, key, prev, '__ember_observesBefore__', 'removeBeforeObserver');
		updateObserversAndListeners(obj, key, prev, '__ember_observes__', 'removeObserver');
		updateObserversAndListeners(obj, key, prev, '__ember_listens__', 'removeListener');
	}

	if ('function' === typeof observerOrListener) {
		updateObserversAndListeners(obj, key, observerOrListener, '__ember_observesBefore__', 'addBeforeObserver');
		updateObserversAndListeners(obj, key, observerOrListener, '__ember_observes__', 'addObserver');
		updateObserversAndListeners(obj, key, observerOrListener, '__ember_listens__', 'addListener');
	}
}

function applyMixin(obj, mixins, partial) {
	var descs = {}, values = {}, m = metaFor(obj),
			key, value, desc, keys = [];

	obj._super = superFunction;

	// Go through all mixins and hashes passed in, and:
	//
	// * Handle concatenated properties
	// * Handle merged properties
	// * Set up _super wrapping if necessary
	// * Set up computed property descriptors
	// * Copying `toString` in broken browsers
	mergeMixins(mixins, mixinsMeta(obj), descs, values, obj, keys);

	for(var i = 0, l = keys.length; i < l; i++) {
		key = keys[i];
		if (key === 'constructor' || !values.hasOwnProperty(key)) { continue; }

		desc = descs[key];
		value = values[key];

		if (desc === REQUIRED) { continue; }

		while (desc && desc instanceof Alias) {
			var followed = followAlias(obj, desc, m, descs, values);
			desc = followed.desc;
			value = followed.value;
		}

		if (desc === undefined && value === undefined) { continue; }

		replaceObserversAndListeners(obj, key, value);
		detectBinding(obj, key, value, m);
		defineProperty(obj, key, desc, value, m);
	}

	if (!partial) { // don't apply to prototype
		finishPartial(obj, m);
	}

	return obj;
}

/**
	@method mixin
	@for Ember
	@param obj
	@param mixins*
	@return obj
*/
Ember.mixin = function(obj) {
	var args = a_slice.call(arguments, 1);
	applyMixin(obj, args, false);
	return obj;
};

/**
	The `Ember.Mixin` class allows you to create mixins, whose properties can be
	added to other classes. For instance,

	```javascript
	App.Editable = Ember.Mixin.create({
		edit: function() {
			console.log('starting to edit');
			this.set('isEditing', true);
		},
		isEditing: false
	});

	// Mix mixins into classes by passing them as the first arguments to
	// .extend.
	App.CommentView = Ember.View.extend(App.Editable, {
		template: Ember.Handlebars.compile('{{#if view.isEditing}}...{{else}}...{{/if}}')
	});

	commentView = App.CommentView.create();
	commentView.edit(); // outputs 'starting to edit'
	```

	Note that Mixins are created with `Ember.Mixin.create`, not
	`Ember.Mixin.extend`.

	Note that mixins extend a constructor's prototype so arrays and object literals
	defined as properties will be shared amongst objects that implement the mixin.
	If you want to define an property in a mixin that is not shared, you can define
	it either as a computed property or have it be created on initialization of the object.

	```javascript
	//filters array will be shared amongst any object implementing mixin
	App.Filterable = Ember.Mixin.create({
		filters: Ember.A()
	});

	//filters will be a separate  array for every object implementing the mixin
	App.Filterable = Ember.Mixin.create({
		filters: Ember.computed(function(){return Ember.A();})
	});

	//filters will be created as a separate array during the object's initialization
	App.Filterable = Ember.Mixin.create({
		init: function() {
			this._super();
			this.set("filters", Ember.A());
		}
	});
	```

	@class Mixin
	@namespace Ember
*/
Ember.Mixin = function() { return initMixin(this, arguments); };

Mixin = Ember.Mixin;

Mixin.prototype = {
	properties: null,
	mixins: null,
	ownerConstructor: null
};

Mixin._apply = applyMixin;

Mixin.applyPartial = function(obj) {
	var args = a_slice.call(arguments, 1);
	return applyMixin(obj, args, true);
};

Mixin.finishPartial = finishPartial;

Ember.anyUnprocessedMixins = false;

/**
	@method create
	@static
	@param arguments*
*/
Mixin.create = function() {
	Ember.anyUnprocessedMixins = true;
	var M = this;
	return initMixin(new M(), arguments);
};

var MixinPrototype = Mixin.prototype;

/**
	@method reopen
	@param arguments*
*/
MixinPrototype.reopen = function() {
	var mixin, tmp;

	if (this.properties) {
		mixin = Mixin.create();
		mixin.properties = this.properties;
		delete this.properties;
		this.mixins = [mixin];
	} else if (!this.mixins) {
		this.mixins = [];
	}

	var len = arguments.length, mixins = this.mixins, idx;

	for(idx=0; idx < len; idx++) {
		mixin = arguments[idx];

		if (mixin instanceof Mixin) {
			mixins.push(mixin);
		} else {
			tmp = Mixin.create();
			tmp.properties = mixin;
			mixins.push(tmp);
		}
	}

	return this;
};

/**
	@method apply
	@param obj
	@return applied object
*/
MixinPrototype.apply = function(obj) {
	return applyMixin(obj, [this], false);
};

MixinPrototype.applyPartial = function(obj) {
	return applyMixin(obj, [this], true);
};

function _detect(curMixin, targetMixin, seen) {
	var guid = guidFor(curMixin);

	if (seen[guid]) { return false; }
	seen[guid] = true;

	if (curMixin === targetMixin) { return true; }
	var mixins = curMixin.mixins, loc = mixins ? mixins.length : 0;
	while (--loc >= 0) {
		if (_detect(mixins[loc], targetMixin, seen)) { return true; }
	}
	return false;
}

/**
	@method detect
	@param obj
	@return {Boolean}
*/
MixinPrototype.detect = function(obj) {
	if (!obj) { return false; }
	if (obj instanceof Mixin) { return _detect(obj, this, {}); }
	var m = obj[META_KEY],
			mixins = m && m.mixins;
	if (mixins) {
		return !!mixins[guidFor(this)];
	}
	return false;
};

MixinPrototype.without = function() {
	var ret = new Mixin(this);
	ret._without = a_slice.call(arguments);
	return ret;
};

function _keys(ret, mixin, seen) {
	if (seen[guidFor(mixin)]) { return; }
	seen[guidFor(mixin)] = true;

	if (mixin.properties) {
		var props = mixin.properties;
		for (var key in props) {
			if (props.hasOwnProperty(key)) { ret[key] = true; }
		}
	} else if (mixin.mixins) {
		a_forEach.call(mixin.mixins, function(x) { _keys(ret, x, seen); });
	}
}

MixinPrototype.keys = function() {
	var keys = {}, seen = {}, ret = [];
	_keys(keys, this, seen);
	for(var key in keys) {
		if (keys.hasOwnProperty(key)) { ret.push(key); }
	}
	return ret;
};

// returns the mixins currently applied to the specified object
// TODO: Make Ember.mixin
Mixin.mixins = function(obj) {
	var m = obj[META_KEY],
			mixins = m && m.mixins, ret = [];

	if (!mixins) { return ret; }

	for (var key in mixins) {
		var mixin = mixins[key];

		// skip primitive mixins since these are always anonymous
		if (!mixin.properties) { ret.push(mixin); }
	}

	return ret;
};

REQUIRED = new Ember.Descriptor();
REQUIRED.toString = function() { return '(Required Property)'; };

/**
	Denotes a required property for a mixin

	@method required
	@for Ember
*/
Ember.required = function() {
	return REQUIRED;
};

Alias = function(methodName) {
	this.methodName = methodName;
};
Alias.prototype = new Ember.Descriptor();

/**
	Makes a method available via an additional name.

	```javascript
	App.Person = Ember.Object.extend({
		name: function() {
			return 'Tomhuda Katzdale';
		},
		moniker: Ember.aliasMethod('name')
	});

	var goodGuy = App.Person.create()
	```

	@method aliasMethod
	@for Ember
	@param {String} methodName name of the method to alias
	@return {Ember.Descriptor}
*/
Ember.aliasMethod = function(methodName) {
	return new Alias(methodName);
};

// ..........................................................
// OBSERVER HELPER
//

/**
	Specify a method that observes property changes.

	```javascript
	Ember.Object.extend({
		valueObserver: Ember.observer('value', function() {
			// Executes whenever the "value" property changes
		})
	});
	```

	In the future this method may become asynchronous. If you want to ensure
	synchronous behavior, use `immediateObserver`.

	Also available as `Function.prototype.observes` if prototype extensions are
	enabled.

	@method observer
	@for Ember
	@param {String} propertyNames*
	@param {Function} func
	@return func
*/
Ember.observer = function() {
	var func  = a_slice.call(arguments, -1)[0];
	var paths;


		var addWatchedProperty = function (path) { paths.push(path); };
		var _paths = a_slice.call(arguments, 0, -1);

		if (typeof func !== "function") {
			// revert to old, soft-deprecated argument ordering

			func  = arguments[0];
			_paths = a_slice.call(arguments, 1);
		}

		paths = [];

		for (var i=0; i<_paths.length; ++i) {
			expandProperties(_paths[i], addWatchedProperty);
		}

	if (typeof func !== "function") {
		throw new Ember.Error("Ember.observer called without a function");
	}

	func.__ember_observes__ = paths;
	return func;
};

/**
	Specify a method that observes property changes.

	```javascript
	Ember.Object.extend({
		valueObserver: Ember.immediateObserver('value', function() {
			// Executes whenever the "value" property changes
		})
	});
	```

	In the future, `Ember.observer` may become asynchronous. In this event,
	`Ember.immediateObserver` will maintain the synchronous behavior.

	Also available as `Function.prototype.observesImmediately` if prototype extensions are
	enabled.

	@method immediateObserver
	@for Ember
	@param {String} propertyNames*
	@param {Function} func
	@return func
*/
Ember.immediateObserver = function() {
	for (var i=0, l=arguments.length; i<l; i++) {
		var arg = arguments[i];
			}

	return Ember.observer.apply(this, arguments);
};

/**
	When observers fire, they are called with the arguments `obj`, `keyName`.

	Note, `@each.property` observer is called per each add or replace of an element
	and it's not called with a specific enumeration item.

	A `beforeObserver` fires before a property changes.

	A `beforeObserver` is an alternative form of `.observesBefore()`.

	```javascript
	App.PersonView = Ember.View.extend({

		friends: [{ name: 'Tom' }, { name: 'Stefan' }, { name: 'Kris' }],

		valueWillChange: Ember.beforeObserver('content.value', function(obj, keyName) {
			this.changingFrom = obj.get(keyName);
		}),

		valueDidChange: Ember.observer('content.value', function(obj, keyName) {
				// only run if updating a value already in the DOM
				if (this.get('state') === 'inDOM') {
					var color = obj.get(keyName) > this.changingFrom ? 'green' : 'red';
					// logic
				}
		}),

		friendsDidChange: Ember.observer('friends.@each.name', function(obj, keyName) {
			// some logic
			// obj.get(keyName) returns friends array
		})
	});
	```

	Also available as `Function.prototype.observesBefore` if prototype extensions are
	enabled.

	@method beforeObserver
	@for Ember
	@param {String} propertyNames*
	@param {Function} func
	@return func
*/
Ember.beforeObserver = function() {
	var func  = a_slice.call(arguments, -1)[0];
	var paths;


		var addWatchedProperty = function(path) { paths.push(path); };

		var _paths = a_slice.call(arguments, 0, -1);

		if (typeof func !== "function") {
			// revert to old, soft-deprecated argument ordering

			func  = arguments[0];
			_paths = a_slice.call(arguments, 1);
		}

		paths = [];

		for (var i=0; i<_paths.length; ++i) {
			expandProperties(_paths[i], addWatchedProperty);
		}

	if (typeof func !== "function") {
		throw new Ember.Error("Ember.beforeObserver called without a function");
	}

	func.__ember_observesBefore__ = paths;
	return func;
};

})();



(function() {
// Provides a way to register library versions with ember.
var forEach = Ember.EnumerableUtils.forEach,
		indexOf = Ember.EnumerableUtils.indexOf;

Ember.libraries = function() {
	var libraries    = [];
	var coreLibIndex = 0;

	var getLibrary = function(name) {
		for (var i = 0; i < libraries.length; i++) {
			if (libraries[i].name === name) {
				return libraries[i];
			}
		}
	};

	libraries.register = function(name, version) {
		if (!getLibrary(name)) {
			libraries.push({name: name, version: version});
		}
	};

	libraries.registerCoreLibrary = function(name, version) {
		if (!getLibrary(name)) {
			libraries.splice(coreLibIndex++, 0, {name: name, version: version});
		}
	};

	libraries.deRegister = function(name) {
		var lib = getLibrary(name);
		if (lib) libraries.splice(indexOf(libraries, lib), 1);
	};

	libraries.each = function (callback) {
		forEach(libraries, function(lib) {
			callback(lib.name, lib.version);
		});
	};

	return libraries;
}();

Ember.libraries.registerCoreLibrary('Ember', Ember.VERSION);

})();



(function() {
/**
Ember Metal

@module ember
@submodule ember-metal
*/

})();

(function() {
/**
	@class RSVP
	@module RSVP
	*/
define("rsvp/all",
	["./promise","exports"],
	function(__dependency1__, __exports__) {
		"use strict";
		var Promise = __dependency1__["default"];

		/**
			This is a convenient alias for `RSVP.Promise.all`.

			@method all
			@for RSVP
			@param {Array} array Array of promises.
			@param {String} label An optional label. This is useful
			for tooling.
			@static
		*/
		__exports__["default"] = function all(array, label) {
			return Promise.all(array, label);
		};
	});
define("rsvp/all_settled",
	["./promise","./utils","exports"],
	function(__dependency1__, __dependency2__, __exports__) {
		"use strict";
		var Promise = __dependency1__["default"];
		var isArray = __dependency2__.isArray;
		var isNonThenable = __dependency2__.isNonThenable;

		/**
			`RSVP.allSettled` is similar to `RSVP.all`, but instead of implementing
			a fail-fast method, it waits until all the promises have returned and
			shows you all the results. This is useful if you want to handle multiple
			promises' failure states together as a set.

			Returns a promise that is fulfilled when all the given promises have been
			settled. The return promise is fulfilled with an array of the states of
			the promises passed into the `promises` array argument.

			Each state object will either indicate fulfillment or rejection, and
			provide the corresponding value or reason. The states will take one of
			the following formats:

			```javascript
			{ state: 'fulfilled', value: value }
				or
			{ state: 'rejected', reason: reason }
			```

			Example:

			```javascript
			var promise1 = RSVP.Promise.resolve(1);
			var promise2 = RSVP.Promise.reject(new Error('2'));
			var promise3 = RSVP.Promise.reject(new Error('3'));
			var promises = [ promise1, promise2, promise3 ];

			RSVP.allSettled(promises).then(function(array){
				// array == [
				//   { state: 'fulfilled', value: 1 },
				//   { state: 'rejected', reason: Error },
				//   { state: 'rejected', reason: Error }
				// ]
				// Note that for the second item, reason.message will be "2", and for the
				// third item, reason.message will be "3".
			}, function(error) {
				// Not run. (This block would only be called if allSettled had failed,
				// for instance if passed an incorrect argument type.)
			});
			```

			@method allSettled
			@for RSVP
			@param {Array} promises
			@param {String} label - optional string that describes the promise.
			Useful for tooling.
			@return {Promise} promise that is fulfilled with an array of the settled
			states of the constituent promises.
			@static
		*/

		__exports__["default"] = function allSettled(entries, label) {
			return new Promise(function(resolve, reject) {
				if (!isArray(entries)) {
					throw new TypeError('You must pass an array to allSettled.');
				}

				var remaining = entries.length;
				var entry;

				if (remaining === 0) {
					resolve([]);
					return;
				}

				var results = new Array(remaining);

				function fulfilledResolver(index) {
					return function(value) {
						resolveAll(index, fulfilled(value));
					};
				}

				function rejectedResolver(index) {
					return function(reason) {
						resolveAll(index, rejected(reason));
					};
				}

				function resolveAll(index, value) {
					results[index] = value;
					if (--remaining === 0) {
						resolve(results);
					}
				}

				for (var index = 0; index < entries.length; index++) {
					entry = entries[index];

					if (isNonThenable(entry)) {
						resolveAll(index, fulfilled(entry));
					} else {
						Promise.cast(entry).then(fulfilledResolver(index), rejectedResolver(index));
					}
				}
			}, label);
		};

		function fulfilled(value) {
			return { state: 'fulfilled', value: value };
		}

		function rejected(reason) {
			return { state: 'rejected', reason: reason };
		}
	});
define("rsvp/config",
	["./events","exports"],
	function(__dependency1__, __exports__) {
		"use strict";
		var EventTarget = __dependency1__["default"];

		var config = {
			instrument: false
		};

		EventTarget.mixin(config);

		function configure(name, value) {
			if (name === 'onerror') {
				// handle for legacy users that expect the actual
				// error to be passed to their function added via
				// `RSVP.configure('onerror', someFunctionHere);`
				config.on('error', value);
				return;
			}

			if (arguments.length === 2) {
				config[name] = value;
			} else {
				return config[name];
			}
		}

		__exports__.config = config;
		__exports__.configure = configure;
	});
define("rsvp/defer",
	["./promise","exports"],
	function(__dependency1__, __exports__) {
		"use strict";
		var Promise = __dependency1__["default"];

		/**
			`RSVP.defer` returns an object similar to jQuery's `$.Deferred`.
			`RSVP.defer` should be used when porting over code reliant on `$.Deferred`'s
			interface. New code should use the `RSVP.Promise` constructor instead.

			The object returned from `RSVP.defer` is a plain object with three properties:

			* promise - an `RSVP.Promise`.
			* reject - a function that causes the `promise` property on this object to
				become rejected
			* resolve - a function that causes the `promise` property on this object to
				become fulfilled.

			Example:

			 ```javascript
			 var deferred = RSVP.defer();

			 deferred.resolve("Success!");

			 defered.promise.then(function(value){
				 // value here is "Success!"
			 });
			 ```

			@method defer
			@for RSVP
			@param {String} label optional string for labeling the promise.
			Useful for tooling.
			@return {Object}
		 */

		__exports__["default"] = function defer(label) {
			var deferred = { };

			deferred.promise = new Promise(function(resolve, reject) {
				deferred.resolve = resolve;
				deferred.reject = reject;
			}, label);

			return deferred;
		};
	});
define("rsvp/events",
	["exports"],
	function(__exports__) {
		"use strict";
		var indexOf = function(callbacks, callback) {
			for (var i=0, l=callbacks.length; i<l; i++) {
				if (callbacks[i] === callback) { return i; }
			}

			return -1;
		};

		var callbacksFor = function(object) {
			var callbacks = object._promiseCallbacks;

			if (!callbacks) {
				callbacks = object._promiseCallbacks = {};
			}

			return callbacks;
		};

		/**
			@class RSVP.EventTarget
		*/
		__exports__["default"] = {

			/**
				`RSVP.EventTarget.mixin` extends an object with EventTarget methods. For
				Example:

				```javascript
				var object = {};

				RSVP.EventTarget.mixin(object);

				object.on("finished", function(event) {
					// handle event
				});

				object.trigger("finished", { detail: value });
				```

				`EventTarget.mixin` also works with prototypes:

				```javascript
				var Person = function() {};
				RSVP.EventTarget.mixin(Person.prototype);

				var yehuda = new Person();
				var tom = new Person();

				yehuda.on("poke", function(event) {
					console.log("Yehuda says OW");
				});

				tom.on("poke", function(event) {
					console.log("Tom says OW");
				});

				yehuda.trigger("poke");
				tom.trigger("poke");
				```

				@method mixin
				@param {Object} object object to extend with EventTarget methods
				@private
			*/
			mixin: function(object) {
				object.on = this.on;
				object.off = this.off;
				object.trigger = this.trigger;
				object._promiseCallbacks = undefined;
				return object;
			},

			/**
				Registers a callback to be executed when `eventName` is triggered

				```javascript
				object.on('event', function(eventInfo){
					// handle the event
				});

				object.trigger('event');
				```

				@method on
				@param {String} eventName name of the event to listen for
				@param {Function} callback function to be called when the event is triggered.
				@private
			*/
			on: function(eventName, callback) {
				var allCallbacks = callbacksFor(this), callbacks;

				callbacks = allCallbacks[eventName];

				if (!callbacks) {
					callbacks = allCallbacks[eventName] = [];
				}

				if (indexOf(callbacks, callback) === -1) {
					callbacks.push(callback);
				}
			},

			/**
				You can use `off` to stop firing a particular callback for an event:

				```javascript
				function doStuff() { // do stuff! }
				object.on('stuff', doStuff);

				object.trigger('stuff'); // doStuff will be called

				// Unregister ONLY the doStuff callback
				object.off('stuff', doStuff);
				object.trigger('stuff'); // doStuff will NOT be called
				```

				If you don't pass a `callback` argument to `off`, ALL callbacks for the
				event will not be executed when the event fires. For example:

				```javascript
				var callback1 = function(){};
				var callback2 = function(){};

				object.on('stuff', callback1);
				object.on('stuff', callback2);

				object.trigger('stuff'); // callback1 and callback2 will be executed.

				object.off('stuff');
				object.trigger('stuff'); // callback1 and callback2 will not be executed!
				```

				@method off
				@param {String} eventName event to stop listening to
				@param {Function} callback optional argument. If given, only the function
				given will be removed from the event's callback queue. If no `callback`
				argument is given, all callbacks will be removed from the event's callback
				queue.
				@private

			*/
			off: function(eventName, callback) {
				var allCallbacks = callbacksFor(this), callbacks, index;

				if (!callback) {
					allCallbacks[eventName] = [];
					return;
				}

				callbacks = allCallbacks[eventName];

				index = indexOf(callbacks, callback);

				if (index !== -1) { callbacks.splice(index, 1); }
			},

			/**
				Use `trigger` to fire custom events. For example:

				```javascript
				object.on('foo', function(){
					console.log('foo event happened!');
				});
				object.trigger('foo');
				// 'foo event happened!' logged to the console
				```

				You can also pass a value as a second argument to `trigger` that will be
				passed as an argument to all event listeners for the event:

				```javascript
				object.on('foo', function(value){
					console.log(value.name);
				});

				object.trigger('foo', { name: 'bar' });
				// 'bar' logged to the console
				```

				@method trigger
				@param {String} eventName name of the event to be triggered
				@param {Any} options optional value to be passed to any event handlers for
				the given `eventName`
				@private
			*/
			trigger: function(eventName, options) {
				var allCallbacks = callbacksFor(this),
						callbacks, callbackTuple, callback, binding;

				if (callbacks = allCallbacks[eventName]) {
					// Don't cache the callbacks.length since it may grow
					for (var i=0; i<callbacks.length; i++) {
						callback = callbacks[i];

						callback(options);
					}
				}
			}
		};
	});
define("rsvp/filter",
	["./all","./map","./utils","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __exports__) {
		"use strict";
		var all = __dependency1__["default"];
		var map = __dependency2__["default"];
		var isFunction = __dependency3__.isFunction;
		var isArray = __dependency3__.isArray;

		/**
		 `RSVP.filter` is similar to JavaScript's native `filter` method, except that it
			waits for all promises to become fulfilled before running the `filterFn` on
			each item in given to `promises`. `RSVP.filter` returns a promise that will
			become fulfilled with the result of running `filterFn` on the values the
			promises become fulfilled with.

			For example:

			```javascript

			var promise1 = RSVP.resolve(1);
			var promise2 = RSVP.resolve(2);
			var promise3 = RSVP.resolve(3);

			var filterFn = function(item){
				return item > 1;
			};

			RSVP.filter(promises, filterFn).then(function(result){
				// result is [ 2, 3 ]
			});
			```

			If any of the `promises` given to `RSVP.filter` are rejected, the first promise
			that is rejected will be given as an argument to the returned promise's
			rejection handler. For example:

			```javascript
			var promise1 = RSVP.resolve(1);
			var promise2 = RSVP.reject(new Error("2"));
			var promise3 = RSVP.reject(new Error("3"));
			var promises = [ promise1, promise2, promise3 ];

			var filterFn = function(item){
				return item > 1;
			};

			RSVP.filter(promises, filterFn).then(function(array){
				// Code here never runs because there are rejected promises!
			}, function(reason) {
				// reason.message === "2"
			});
			```

			`RSVP.filter` will also wait for any promises returned from `filterFn`.
			For instance, you may want to fetch a list of users then return a subset
			of those users based on some asynchronous operation:

			```javascript

			var alice = { name: 'alice' };
			var bob   = { name: 'bob' };
			var users = [ alice, bob ];

			var promises = users.map(function(user){
				return RSVP.resolve(user);
			});

			var filterFn = function(user){
				// Here, Alice has permissions to create a blog post, but Bob does not.
				return getPrivilegesForUser(user).then(function(privs){
					return privs.can_create_blog_post === true;
				});
			};
			RSVP.filter(promises, filterFn).then(function(users){
				// true, because the server told us only Alice can create a blog post.
				users.length === 1;
				// false, because Alice is the only user present in `users`
				users[0] === bob;
			});
			```

			@method filter
			@for RSVP
			@param {Array} promises
			@param {Function} filterFn - function to be called on each resolved value to
			filter the final results.
			@param {String} label optional string describing the promise. Useful for
			tooling.
			@return {Promise}
		*/
		function filter(promises, filterFn, label) {
			return all(promises, label).then(function(values){
				if (!isArray(promises)) {
					throw new TypeError('You must pass an array to filter.');
				}

				if (!isFunction(filterFn)){
					throw new TypeError("You must pass a function to filter's second argument.");
				}

				return map(promises, filterFn, label).then(function(filterResults){
					 var i,
							 valuesLen = values.length,
							 filtered = [];

					 for (i = 0; i < valuesLen; i++){
						 if(filterResults[i]) filtered.push(values[i]);
					 }
					 return filtered;
				});
			});
		}

		__exports__["default"] = filter;
	});
define("rsvp/hash",
	["./promise","./utils","exports"],
	function(__dependency1__, __dependency2__, __exports__) {
		"use strict";
		var Promise = __dependency1__["default"];
		var isNonThenable = __dependency2__.isNonThenable;
		var keysOf = __dependency2__.keysOf;

		/**
			`RSVP.hash` is similar to `RSVP.all`, but takes an object instead of an array
			for its `promises` argument.

			Returns a promise that is fulfilled when all the given promises have been
			fulfilled, or rejected if any of them become rejected. The returned promise
			is fulfilled with a hash that has the same key names as the `promises` object
			argument. If any of the values in the object are not promises, they will
			simply be copied over to the fulfilled object.

			Example:

			```javascript
			var promises = {
				myPromise: RSVP.resolve(1),
				yourPromise: RSVP.resolve(2),
				theirPromise: RSVP.resolve(3),
				notAPromise: 4
			};

			RSVP.hash(promises).then(function(hash){
				// hash here is an object that looks like:
				// {
				//   myPromise: 1,
				//   yourPromise: 2,
				//   theirPromise: 3,
				//   notAPromise: 4
				// }
			});
			````

			If any of the `promises` given to `RSVP.hash` are rejected, the first promise
			that is rejected will be given as the reason to the rejection handler.

			Example:

			```javascript
			var promises = {
				myPromise: RSVP.resolve(1),
				rejectedPromise: RSVP.reject(new Error("rejectedPromise")),
				anotherRejectedPromise: RSVP.reject(new Error("anotherRejectedPromise")),
			};

			RSVP.hash(promises).then(function(hash){
				// Code here never runs because there are rejected promises!
			}, function(reason) {
				// reason.message === "rejectedPromise"
			});
			```

			An important note: `RSVP.hash` is intended for plain JavaScript objects that
			are just a set of keys and values. `RSVP.hash` will NOT preserve prototype
			chains.

			Example:

			```javascript
			function MyConstructor(){
				this.example = RSVP.resolve("Example");
			}

			MyConstructor.prototype = {
				protoProperty: RSVP.resolve("Proto Property")
			};

			var myObject = new MyConstructor();

			RSVP.hash(myObject).then(function(hash){
				// protoProperty will not be present, instead you will just have an
				// object that looks like:
				// {
				//   example: "Example"
				// }
				//
				// hash.hasOwnProperty('protoProperty'); // false
				// 'undefined' === typeof hash.protoProperty
			});
			```

			@method hash
			@for RSVP
			@param {Object} promises
			@param {String} label optional string that describes the promise.
			Useful for tooling.
			@return {Promise} promise that is fulfilled when all properties of `promises`
			have been fulfilled, or rejected if any of them become rejected.
			@static
		*/
		__exports__["default"] = function hash(object, label) {
			return new Promise(function(resolve, reject){
				var results = {};
				var keys = keysOf(object);
				var remaining = keys.length;
				var entry, property;

				if (remaining === 0) {
					resolve(results);
					return;
				}

			 function fulfilledTo(property) {
					return function(value) {
						results[property] = value;
						if (--remaining === 0) {
							resolve(results);
						}
					};
				}

				function onRejection(reason) {
					remaining = 0;
					reject(reason);
				}

				for (var i = 0; i < keys.length; i++) {
					property = keys[i];
					entry = object[property];

					if (isNonThenable(entry)) {
						results[property] = entry;
						if (--remaining === 0) {
							resolve(results);
						}
					} else {
						Promise.cast(entry).then(fulfilledTo(property), onRejection);
					}
				}
			});
		};
	});
define("rsvp/instrument",
	["./config","./utils","exports"],
	function(__dependency1__, __dependency2__, __exports__) {
		"use strict";
		var config = __dependency1__.config;
		var now = __dependency2__.now;

		__exports__["default"] = function instrument(eventName, promise, child) {
			// instrumentation should not disrupt normal usage.
			try {
				config.trigger(eventName, {
					guid: promise._guidKey + promise._id,
					eventName: eventName,
					detail: promise._detail,
					childGuid: child && promise._guidKey + child._id,
					label: promise._label,
					timeStamp: now(),
					stack: new Error(promise._label).stack
				});
			} catch(error) {
				setTimeout(function(){
					throw error;
				}, 0);
			}
		};
	});
define("rsvp/map",
	["./promise","./all","./utils","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __exports__) {
		"use strict";
		var Promise = __dependency1__["default"];
		var all = __dependency2__["default"];
		var isArray = __dependency3__.isArray;
		var isFunction = __dependency3__.isFunction;

		/**
		 `RSVP.map` is similar to JavaScript's native `map` method, except that it
			waits for all promises to become fulfilled before running the `mapFn` on
			each item in given to `promises`. `RSVP.map` returns a promise that will
			become fulfilled with the result of running `mapFn` on the values the promises
			become fulfilled with.

			For example:

			```javascript

			var promise1 = RSVP.resolve(1);
			var promise2 = RSVP.resolve(2);
			var promise3 = RSVP.resolve(3);
			var promises = [ promise1, promise2, promise3 ];

			var mapFn = function(item){
				return item + 1;
			};

			RSVP.map(promises, mapFn).then(function(result){
				// result is [ 2, 3, 4 ]
			});
			```

			If any of the `promises` given to `RSVP.map` are rejected, the first promise
			that is rejected will be given as an argument to the returned promise's
			rejection handler. For example:

			```javascript
			var promise1 = RSVP.resolve(1);
			var promise2 = RSVP.reject(new Error("2"));
			var promise3 = RSVP.reject(new Error("3"));
			var promises = [ promise1, promise2, promise3 ];

			var mapFn = function(item){
				return item + 1;
			};

			RSVP.map(promises, mapFn).then(function(array){
				// Code here never runs because there are rejected promises!
			}, function(reason) {
				// reason.message === "2"
			});
			```

			`RSVP.map` will also wait if a promise is returned from `mapFn`. For example,
			say you want to get all comments from a set of blog posts, but you need
			the blog posts first becuase they contain a url to those comments.

			```javscript

			var mapFn = function(blogPost){
				// getComments does some ajax and returns an RSVP.Promise that is fulfilled
				// with some comments data
				return getComments(blogPost.comments_url);
			};

			// getBlogPosts does some ajax and returns an RSVP.Promise that is fulfilled
			// with some blog post data
			RSVP.map(getBlogPosts(), mapFn).then(function(comments){
				// comments is the result of asking the server for the comments
				// of all blog posts returned from getBlogPosts()
			});
			```

			@method map
			@for RSVP
			@param {Array} promises
			@param {Function} mapFn function to be called on each fulfilled promise.
			@param {String} label optional string for labeling the promise.
			Useful for tooling.
			@return {Promise} promise that is fulfilled with the result of calling
			`mapFn` on each fulfilled promise or value when they become fulfilled.
			 The promise will be rejected if any of the given `promises` become rejected.
			@static
		*/
		__exports__["default"] = function map(promises, mapFn, label) {
			return all(promises, label).then(function(results){
				if (!isArray(promises)) {
					throw new TypeError('You must pass an array to map.');
				}

				if (!isFunction(mapFn)){
					throw new TypeError("You must pass a function to map's second argument.");
				}


				var resultLen = results.length,
						mappedResults = [],
						i;

				for (i = 0; i < resultLen; i++){
					mappedResults.push(mapFn(results[i]));
				}

				return all(mappedResults, label);
			});
		};
	});
define("rsvp/node",
	["./promise","exports"],
	function(__dependency1__, __exports__) {
		"use strict";
		var Promise = __dependency1__["default"];

		var slice = Array.prototype.slice;

		function makeNodeCallbackFor(resolve, reject) {
			return function (error, value) {
				if (error) {
					reject(error);
				} else if (arguments.length > 2) {
					resolve(slice.call(arguments, 1));
				} else {
					resolve(value);
				}
			};
		}

		/**
			`RSVP.denodeify` takes a "node-style" function and returns a function that
			will return an `RSVP.Promise`. You can use `denodeify` in Node.js or the
			browser when you'd prefer to use promises over using callbacks. For example,
			`denodeify` transforms the following:

			```javascript
			var fs = require('fs');

			fs.readFile('myfile.txt', function(err, data){
				if (err) return handleError(err);
				handleData(data);
			});
			```

			into:

			```javascript
			var fs = require('fs');

			var readFile = RSVP.denodeify(fs.readFile);

			readFile('myfile.txt').then(handleData, handleError);
			```

			Using `denodeify` makes it easier to compose asynchronous operations instead
			of using callbacks. For example, instead of:

			```javascript
			var fs = require('fs');
			var log = require('some-async-logger');

			fs.readFile('myfile.txt', function(err, data){
				if (err) return handleError(err);
				fs.writeFile('myfile2.txt', data, function(err){
					if (err) throw err;
					log('success', function(err) {
						if (err) throw err;
					});
				});
			});
			```

			You can chain the operations together using `then` from the returned promise:

			```javascript
			var fs = require('fs');
			var denodeify = RSVP.denodeify;
			var readFile = denodeify(fs.readFile);
			var writeFile = denodeify(fs.writeFile);
			var log = denodeify(require('some-async-logger'));

			readFile('myfile.txt').then(function(data){
				return writeFile('myfile2.txt', data);
			}).then(function(){
				return log('SUCCESS');
			}).then(function(){
				// success handler
			}, function(reason){
				// rejection handler
			});
			```

			@method denodeify
			@for RSVP
			@param {Function} nodeFunc a "node-style" function that takes a callback as
			its last argument. The callback expects an error to be passed as its first
			argument (if an error occurred, otherwise null), and the value from the
			operation as its second argument ("function(err, value){ }").
			@param {Any} binding optional argument for binding the "this" value when
			calling the `nodeFunc` function.
			@return {Function} a function that wraps `nodeFunc` to return an
			`RSVP.Promise`
			@static
		*/
		__exports__["default"] = function denodeify(nodeFunc, binding) {
			return function()  {
				var nodeArgs = slice.call(arguments), resolve, reject;
				var thisArg = this || binding;

				return new Promise(function(resolve, reject) {
					Promise.all(nodeArgs).then(function(nodeArgs) {
						try {
							nodeArgs.push(makeNodeCallbackFor(resolve, reject));
							nodeFunc.apply(thisArg, nodeArgs);
						} catch(e) {
							reject(e);
						}
					});
				});
			};
		};
	});
define("rsvp/promise",
	["./config","./events","./instrument","./utils","./promise/cast","./promise/all","./promise/race","./promise/resolve","./promise/reject","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __dependency4__, __dependency5__, __dependency6__, __dependency7__, __dependency8__, __dependency9__, __exports__) {
		"use strict";
		var config = __dependency1__.config;
		var EventTarget = __dependency2__["default"];
		var instrument = __dependency3__["default"];
		var objectOrFunction = __dependency4__.objectOrFunction;
		var isFunction = __dependency4__.isFunction;
		var now = __dependency4__.now;
		var cast = __dependency5__["default"];
		var all = __dependency6__["default"];
		var race = __dependency7__["default"];
		var Resolve = __dependency8__["default"];
		var Reject = __dependency9__["default"];

		var guidKey = 'rsvp_' + now() + '-';
		var counter = 0;

		function noop() {}

		__exports__["default"] = Promise;


		/**
			Promise objects represent the eventual result of an asynchronous operation. The
			primary way of interacting with a promise is through its `then` method, which
			registers callbacks to receive either a promise’s eventual value or the reason
			why the promise cannot be fulfilled.

			Terminology
			-----------

			- `promise` is an object or function with a `then` method whose behavior conforms to this specification.
			- `thenable` is an object or function that defines a `then` method.
			- `value` is any legal JavaScript value (including undefined, a thenable, or a promise).
			- `exception` is a value that is thrown using the throw statement.
			- `reason` is a value that indicates why a promise was rejected.
			- `settled` the final resting state of a promise, fulfilled or rejected.

			A promise can be in one of three states: pending, fulfilled, or rejected.

			Promises that are fulfilled have a fulfillment value and are in the fulfilled
			state.  Promises that are rejected have a rejection reason and are in the
			rejected state.  A fulfillment value is never a thenable.  Similarly, a
			rejection reason is never a thenable.

			Promises can also be said to *resolve* a value.  If this value is also a
			promise, then the original promise's settled state will match the value's
			settled state.  So a promise that *resolves* a promise that rejects will
			itself reject, and a promise that *resolves* a promise that fulfills will
			itself fulfill.


			Basic Usage:
			------------

			```js
			var promise = new Promise(function(resolve, reject) {
				// on success
				resolve(value);

				// on failure
				reject(reason);
			});

			promise.then(function(value) {
				// on fulfillment
			}, function(reason) {
				// on rejection
			});
			```

			Advanced Usage:
			---------------

			Promises shine when abstracting away asynchronous interactions such as
			`XMLHttpRequest`s.

			```js
			function getJSON(url) {
				return new Promise(function(resolve, reject){
					var xhr = new XMLHttpRequest();

					xhr.open('GET', url);
					xhr.onreadystatechange = handler;
					xhr.responseType = 'json';
					xhr.setRequestHeader('Accept', 'application/json');
					xhr.send();

					function handler() {
						if (this.readyState === this.DONE) {
							if (this.status === 200) {
								resolve(this.response);
							} else {
								reject(new Error("getJSON: `" + url + "` failed with status: [" + this.status + "]");
							}
						}
					};
				});
			}

			getJSON('/posts.json').then(function(json) {
				// on fulfillment
			}, function(reason) {
				// on rejection
			});
			```

			Unlike callbacks, promises are great composable primitives.

			```js
			Promise.all([
				getJSON('/posts'),
				getJSON('/comments')
			]).then(function(values){
				values[0] // => postsJSON
				values[1] // => commentsJSON

				return values;
			});
			```

			@class RSVP.Promise
			@param {function}
			@param {String} label optional string for labeling the promise.
			Useful for tooling.
			@constructor
		*/
		function Promise(resolver, label) {
			if (!isFunction(resolver)) {
				throw new TypeError('You must pass a resolver function as the first argument to the promise constructor');
			}

			if (!(this instanceof Promise)) {
				throw new TypeError("Failed to construct 'Promise': Please use the 'new' operator, this object constructor cannot be called as a function.");
			}

			this._id = counter++;
			this._label = label;
			this._subscribers = [];

			if (config.instrument) {
				instrument('created', this);
			}

			if (noop !== resolver) {
				invokeResolver(resolver, this);
			}
		}

		function invokeResolver(resolver, promise) {
			function resolvePromise(value) {
				resolve(promise, value);
			}

			function rejectPromise(reason) {
				reject(promise, reason);
			}

			try {
				resolver(resolvePromise, rejectPromise);
			} catch(e) {
				rejectPromise(e);
			}
		}

		Promise.cast = cast;
		Promise.all = all;
		Promise.race = race;
		Promise.resolve = Resolve;
		Promise.reject = Reject;

		var PENDING   = void 0;
		var SEALED    = 0;
		var FULFILLED = 1;
		var REJECTED  = 2;

		function subscribe(parent, child, onFulfillment, onRejection) {
			var subscribers = parent._subscribers;
			var length = subscribers.length;

			subscribers[length] = child;
			subscribers[length + FULFILLED] = onFulfillment;
			subscribers[length + REJECTED]  = onRejection;
		}

		function publish(promise, settled) {
			var child, callback, subscribers = promise._subscribers, detail = promise._detail;

			if (config.instrument) {
				instrument(settled === FULFILLED ? 'fulfilled' : 'rejected', promise);
			}

			for (var i = 0; i < subscribers.length; i += 3) {
				child = subscribers[i];
				callback = subscribers[i + settled];

				invokeCallback(settled, child, callback, detail);
			}

			promise._subscribers = null;
		}

		Promise.prototype = {
			constructor: Promise,

			_id: undefined,
			_guidKey: guidKey,
			_label: undefined,

			_state: undefined,
			_detail: undefined,
			_subscribers: undefined,

			_onerror: function (reason) {
				config.trigger('error', reason);
			},

		/**
			The primary way of interacting with a promise is through its `then` method,
			which registers callbacks to receive either a promise's eventual value or the
			reason why the promise cannot be fulfilled.

			```js
			findUser().then(function(user){
				// user is available
			}, function(reason){
				// user is unavailable, and you are given the reason why
			});
			```

			Chaining
			--------

			The return value of `then` is itself a promise.  This second, "downstream"
			promise is resolved with the return value of the first promise's fulfillment
			or rejection handler, or rejected if the handler throws an exception.

			```js
			findUser().then(function (user) {
				return user.name;
			}, function (reason) {
				return "default name";
			}).then(function (userName) {
				// If `findUser` fulfilled, `userName` will be the user's name, otherwise it
				// will be `"default name"`
			});

			findUser().then(function (user) {
				throw new Error("Found user, but still unhappy");
			}, function (reason) {
				throw new Error("`findUser` rejected and we're unhappy");
			}).then(function (value) {
				// never reached
			}, function (reason) {
				// if `findUser` fulfilled, `reason` will be "Found user, but still unhappy".
				// If `findUser` rejected, `reason` will be "`findUser` rejected and we're unhappy".
			});
			```
			If the downstream promise does not specify a rejection handler, rejection reasons will be propagated further downstream.

			```js
			findUser().then(function (user) {
				throw new PedagogicalException("Upstream error");
			}).then(function (value) {
				// never reached
			}).then(function (value) {
				// never reached
			}, function (reason) {
				// The `PedgagocialException` is propagated all the way down to here
			});
			```

			Assimilation
			------------

			Sometimes the value you want to propagate to a downstream promise can only be
			retrieved asynchronously. This can be achieved by returning a promise in the
			fulfillment or rejection handler. The downstream promise will then be pending
			until the returned promise is settled. This is called *assimilation*.

			```js
			findUser().then(function (user) {
				return findCommentsByAuthor(user);
			}).then(function (comments) {
				// The user's comments are now available
			});
			```

			If the assimliated promise rejects, then the downstream promise will also reject.

			```js
			findUser().then(function (user) {
				return findCommentsByAuthor(user);
			}).then(function (comments) {
				// If `findCommentsByAuthor` fulfills, we'll have the value here
			}, function (reason) {
				// If `findCommentsByAuthor` rejects, we'll have the reason here
			});
			```

			Simple Example
			--------------

			Synchronous Example

			```javascript
			var result;

			try {
				result = findResult();
				// success
			} catch(reason) {
				// failure
			}
			```

			Errback Example

			```js
			findResult(function(result, err){
				if (err) {
					// failure
				} else {
					// success
				}
			});
			```

			Promise Example;

			```javascript
			findResult().then(function(result){
				// success
			}, function(reason){
				// failure
			});
			```

			Advanced Example
			--------------

			Synchronous Example

			```javascript
			var author, books;

			try {
				author = findAuthor();
				books  = findBooksByAuthor(author);
				// success
			} catch(reason) {
				// failure
			}
			```

			Errback Example

			```js

			function foundBooks(books) {

			}

			function failure(reason) {

			}

			findAuthor(function(author, err){
				if (err) {
					failure(err);
					// failure
				} else {
					try {
						findBoooksByAuthor(author, function(books, err) {
							if (err) {
								failure(err);
							} else {
								try {
									foundBooks(books);
								} catch(reason) {
									failure(reason);
								}
							}
						});
					} catch(error) {
						failure(err);
					}
					// success
				}
			});
			```

			Promise Example;

			```javascript
			findAuthor().
				then(findBooksByAuthor).
				then(function(books){
					// found books
			}).catch(function(reason){
				// something went wrong
			});
			```

			@method then
			@param {Function} onFulfilled
			@param {Function} onRejected
			@param {String} label optional string for labeling the promise.
			Useful for tooling.
			@return {Promise}
		*/
			then: function(onFulfillment, onRejection, label) {
				var promise = this;
				this._onerror = null;

				var thenPromise = new this.constructor(noop, label);

				if (this._state) {
					var callbacks = arguments;
					config.async(function invokePromiseCallback() {
						invokeCallback(promise._state, thenPromise, callbacks[promise._state - 1], promise._detail);
					});
				} else {
					subscribe(this, thenPromise, onFulfillment, onRejection);
				}

				if (config.instrument) {
					instrument('chained', promise, thenPromise);
				}

				return thenPromise;
			},

		/**
			`catch` is simply sugar for `then(undefined, onRejection)` which makes it the same
			as the catch block of a try/catch statement.

			```js
			function findAuthor(){
				throw new Error("couldn't find that author");
			}

			// synchronous
			try {
				findAuthor();
			} catch(reason) {
				// something went wrong
			}

			// async with promises
			findAuthor().catch(function(reason){
				// something went wrong
			});
			```

			@method catch
			@param {Function} onRejection
			@param {String} label optional string for labeling the promise.
			Useful for tooling.
			@return {Promise}
		*/
			'catch': function(onRejection, label) {
				return this.then(null, onRejection, label);
			},

		/**
			`finally` will be invoked regardless of the promise's fate just as native
			try/catch/finally behaves

			Synchronous example:

			```js
			findAuthor() {
				if (Math.random() > 0.5) {
					throw new Error();
				}
				return new Author();
			}

			try {
				return findAuthor(); // succeed or fail
			} catch(error) {
				return findOtherAuther();
			} finally {
				// always runs
				// doesn't affect the return value
			}
			```

			Asynchronous example:

			```js
			findAuthor().catch(function(reason){
				return findOtherAuther();
			}).finally(function(){
				// author was either found, or not
			});
			```

			@method finally
			@param {Function} callback
			@param {String} label optional string for labeling the promise.
			Useful for tooling.
			@return {Promise}
		*/
			'finally': function(callback, label) {
				var constructor = this.constructor;

				return this.then(function(value) {
					return constructor.cast(callback()).then(function(){
						return value;
					});
				}, function(reason) {
					return constructor.cast(callback()).then(function(){
						throw reason;
					});
				}, label);
			}
		};

		function invokeCallback(settled, promise, callback, detail) {
			var hasCallback = isFunction(callback),
					value, error, succeeded, failed;

			if (hasCallback) {
				try {
					value = callback(detail);
					succeeded = true;
				} catch(e) {
					failed = true;
					error = e;
				}
			} else {
				value = detail;
				succeeded = true;
			}

			if (handleThenable(promise, value)) {
				return;
			} else if (hasCallback && succeeded) {
				resolve(promise, value);
			} else if (failed) {
				reject(promise, error);
			} else if (settled === FULFILLED) {
				resolve(promise, value);
			} else if (settled === REJECTED) {
				reject(promise, value);
			}
		}

		function handleThenable(promise, value) {
			var then = null,
			resolved;

			try {
				if (promise === value) {
					throw new TypeError("A promises callback cannot return that same promise.");
				}

				if (objectOrFunction(value)) {
					then = value.then;

					if (isFunction(then)) {
						then.call(value, function(val) {
							if (resolved) { return true; }
							resolved = true;

							if (value !== val) {
								resolve(promise, val);
							} else {
								fulfill(promise, val);
							}
						}, function(val) {
							if (resolved) { return true; }
							resolved = true;

							reject(promise, val);
						}, 'derived from: ' + (promise._label || ' unknown promise'));

						return true;
					}
				}
			} catch (error) {
				if (resolved) { return true; }
				reject(promise, error);
				return true;
			}

			return false;
		}

		function resolve(promise, value) {
			if (promise === value) {
				fulfill(promise, value);
			} else if (!handleThenable(promise, value)) {
				fulfill(promise, value);
			}
		}

		function fulfill(promise, value) {
			if (promise._state !== PENDING) { return; }
			promise._state = SEALED;
			promise._detail = value;

			config.async(publishFulfillment, promise);
		}

		function reject(promise, reason) {
			if (promise._state !== PENDING) { return; }
			promise._state = SEALED;
			promise._detail = reason;

			config.async(publishRejection, promise);
		}

		function publishFulfillment(promise) {
			publish(promise, promise._state = FULFILLED);
		}

		function publishRejection(promise) {
			if (promise._onerror) {
				promise._onerror(promise._detail);
			}

			publish(promise, promise._state = REJECTED);
		}
	});
define("rsvp/promise/all",
	["../utils","exports"],
	function(__dependency1__, __exports__) {
		"use strict";
		var isArray = __dependency1__.isArray;
		var isNonThenable = __dependency1__.isNonThenable;

		/**
			`RSVP.Promise.all` accepts an array of promises, and returns a new promise which
			is fulfilled with an array of fulfillment values for the passed promises, or
			rejected with the reason of the first passed promise to be rejected. It casts all
			elements of the passed iterable to promises as it runs this algorithm.

			Example:

			```javascript
			var promise1 = RSVP.resolve(1);
			var promise2 = RSVP.resolve(2);
			var promise3 = RSVP.resolve(3);
			var promises = [ promise1, promise2, promise3 ];

			RSVP.Promise.all(promises).then(function(array){
				// The array here would be [ 1, 2, 3 ];
			});
			```

			If any of the `promises` given to `RSVP.all` are rejected, the first promise
			that is rejected will be given as an argument to the returned promises's
			rejection handler. For example:

			Example:

			```javascript
			var promise1 = RSVP.resolve(1);
			var promise2 = RSVP.reject(new Error("2"));
			var promise3 = RSVP.reject(new Error("3"));
			var promises = [ promise1, promise2, promise3 ];

			RSVP.Promise.all(promises).then(function(array){
				// Code here never runs because there are rejected promises!
			}, function(error) {
				// error.message === "2"
			});
			```

			@method all
			@for Ember.RSVP.Promise
			@param {Array} entries array of promises
			@param {String} label optional string for labeling the promise.
			Useful for tooling.
			@return {Promise} promise that is fulfilled when all `promises` have been
			fulfilled, or rejected if any of them become rejected.
			@static
		*/
		__exports__["default"] = function all(entries, label) {

			/*jshint validthis:true */
			var Constructor = this;

			return new Constructor(function(resolve, reject) {
				if (!isArray(entries)) {
					throw new TypeError('You must pass an array to all.');
				}

				var remaining = entries.length;
				var results = new Array(remaining);
				var entry, pending = true;

				if (remaining === 0) {
					resolve(results);
					return;
				}

				function fulfillmentAt(index) {
					return function(value) {
						results[index] = value;
						if (--remaining === 0) {
							resolve(results);
						}
					};
				}

				function onRejection(reason) {
					remaining = 0;
					reject(reason);
				}

				for (var index = 0; index < entries.length; index++) {
					entry = entries[index];
					if (isNonThenable(entry)) {
						results[index] = entry;
						if (--remaining === 0) {
							resolve(results);
						}
					} else {
						Constructor.cast(entry).then(fulfillmentAt(index), onRejection);
					}
				}
			}, label);
		};
	});
define("rsvp/promise/cast",
	["exports"],
	function(__exports__) {
		"use strict";
		/**
			`RSVP.Promise.cast` coerces its argument to a promise, or returns the
			argument if it is already a promise which shares a constructor with the caster.

			Example:

			```javascript
			var promise = RSVP.Promise.resolve(1);
			var casted = RSVP.Promise.cast(promise);

			console.log(promise === casted); // true
			```

			In the case of a promise whose constructor does not match, it is assimilated.
			The resulting promise will fulfill or reject based on the outcome of the
			promise being casted.

			Example:

			```javascript
			var thennable = $.getJSON('/api/foo');
			var casted = RSVP.Promise.cast(thennable);

			console.log(thennable === casted); // false
			console.log(casted instanceof RSVP.Promise) // true

			casted.then(function(data) {
				// data is the value getJSON fulfills with
			});
			```

			In the case of a non-promise, a promise which will fulfill with that value is
			returned.

			Example:

			```javascript
			var value = 1; // could be a number, boolean, string, undefined...
			var casted = RSVP.Promise.cast(value);

			console.log(value === casted); // false
			console.log(casted instanceof RSVP.Promise) // true

			casted.then(function(val) {
				val === value // => true
			});
			```

			`RSVP.Promise.cast` is similar to `RSVP.Promise.resolve`, but `RSVP.Promise.cast` differs in the
			following ways:

			* `RSVP.Promise.cast` serves as a memory-efficient way of getting a promise, when you
			have something that could either be a promise or a value. RSVP.resolve
			will have the same effect but will create a new promise wrapper if the
			argument is a promise.
			* `RSVP.Promise.cast` is a way of casting incoming thenables or promise subclasses to
			promises of the exact class specified, so that the resulting object's `then` is
			ensured to have the behavior of the constructor you are calling cast on (i.e., RSVP.Promise).

			@method cast
			@param {Object} object to be casted
			@param {String} label optional string for labeling the promise.
			Useful for tooling.
			@return {Promise} promise
			@static
		*/

		__exports__["default"] = function cast(object, label) {
			/*jshint validthis:true */
			var Constructor = this;

			if (object && typeof object === 'object' && object.constructor === Constructor) {
				return object;
			}

			return new Constructor(function(resolve) {
				resolve(object);
			}, label);
		};
	});
define("rsvp/promise/race",
	["../utils","exports"],
	function(__dependency1__, __exports__) {
		"use strict";
		/* global toString */

		var isArray = __dependency1__.isArray;
		var isFunction = __dependency1__.isFunction;
		var isNonThenable = __dependency1__.isNonThenable;

		/**
			`RSVP.Promise.race` returns a new promise which is settled in the same way as the
			first passed promise to settle.

			Example:

			```javascript
			var promise1 = new RSVP.Promise(function(resolve, reject){
				setTimeout(function(){
					resolve("promise 1");
				}, 200);
			});

			var promise2 = new RSVP.Promise(function(resolve, reject){
				setTimeout(function(){
					resolve("promise 2");
				}, 100);
			});

			RSVP.Promise.race([promise1, promise2]).then(function(result){
				// result === "promise 2" because it was resolved before promise1
				// was resolved.
			});
			```

			`RSVP.Promise.race` is deterministic in that only the state of the first
			settled promise matters. For example, even if other promises given to the
			`promises` array argument are resolved, but the first settled promise has
			become rejected before the other promises became fulfilled, the returned
			promise will become rejected:

			```javascript
			var promise1 = new RSVP.Promise(function(resolve, reject){
				setTimeout(function(){
					resolve("promise 1");
				}, 200);
			});

			var promise2 = new RSVP.Promise(function(resolve, reject){
				setTimeout(function(){
					reject(new Error("promise 2"));
				}, 100);
			});

			RSVP.Promise.race([promise1, promise2]).then(function(result){
				// Code here never runs
			}, function(reason){
				// reason.message === "promise2" because promise 2 became rejected before
				// promise 1 became fulfilled
			});
			```

			An example real-world use case is implementing timeouts:

			```javascript
			RSVP.Promise.race([ajax('foo.json'), timeout(5000)])
			```

			@method race
			@param {Array} promises array of promises to observe
			@param {String} label optional string for describing the promise returned.
			Useful for tooling.
			@return {Promise} a promise which settles in the same way as the first passed
			promise to settle.
			@static
		*/
		__exports__["default"] = function race(entries, label) {
			/*jshint validthis:true */
			var Constructor = this, entry;

			return new Constructor(function(resolve, reject) {
				if (!isArray(entries)) {
					throw new TypeError('You must pass an array to race.');
				}

				var pending = true;

				function onFulfillment(value) { if (pending) { pending = false; resolve(value); } }
				function onRejection(reason)  { if (pending) { pending = false; reject(reason); } }

				for (var i = 0; i < entries.length; i++) {
					entry = entries[i];
					if (isNonThenable(entry)) {
						pending = false;
						resolve(entry);
						return;
					} else {
						Constructor.cast(entry).then(onFulfillment, onRejection);
					}
				}
			}, label);
		};
	});
define("rsvp/promise/reject",
	["exports"],
	function(__exports__) {
		"use strict";
		/**
			`RSVP.Promise.reject` returns a promise rejected with the passed `reason`.
			It is shorthand for the following:

			```javascript
			var promise = new RSVP.Promise(function(resolve, reject){
				reject(new Error('WHOOPS'));
			});

			promise.then(function(value){
				// Code here doesn't run because the promise is rejected!
			}, function(reason){
				// reason.message === 'WHOOPS'
			});
			```

			Instead of writing the above, your code now simply becomes the following:

			```javascript
			var promise = RSVP.Promise.reject(new Error('WHOOPS'));

			promise.then(function(value){
				// Code here doesn't run because the promise is rejected!
			}, function(reason){
				// reason.message === 'WHOOPS'
			});
			```

			@method reject
			@param {Any} reason value that the returned promise will be rejected with.
			@param {String} label optional string for identifying the returned promise.
			Useful for tooling.
			@return {Promise} a promise rejected with the given `reason`.
			@static
		*/
		__exports__["default"] = function reject(reason, label) {
			/*jshint validthis:true */
			var Constructor = this;

			return new Constructor(function (resolve, reject) {
				reject(reason);
			}, label);
		};
	});
define("rsvp/promise/resolve",
	["exports"],
	function(__exports__) {
		"use strict";
		/**
			`RSVP.Promise.resolve` returns a promise that will become resolved with the
			passed `value`. It is shorthand for the following:

			```javascript
			var promise = new RSVP.Promise(function(resolve, reject){
				resolve(1);
			});

			promise.then(function(value){
				// value === 1
			});
			```

			Instead of writing the above, your code now simply becomes the following:

			```javascript
			var promise = RSVP.Promise.resolve(1);

			promise.then(function(value){
				// value === 1
			});
			```

			@method resolve
			@param {Any} value value that the returned promise will be resolved with
			@param {String} label optional string for identifying the returned promise.
			Useful for tooling.
			@return {Promise} a promise that will become fulfilled with the given
			`value`
			@static
		*/
		__exports__["default"] = function resolve(value, label) {
			/*jshint validthis:true */
			var Constructor = this;

			return new Constructor(function(resolve, reject) {
				resolve(value);
			}, label);
		};
	});
define("rsvp/race",
	["./promise","exports"],
	function(__dependency1__, __exports__) {
		"use strict";
		var Promise = __dependency1__["default"];

		/**
			This is a convenient alias for `RSVP.Promise.race`.

			@method race
			@param {Array} array Array of promises.
			@param {String} label An optional label. This is useful
			for tooling.
			@static
		*/
		__exports__["default"] = function race(array, label) {
			return Promise.race(array, label);
		};
	});
define("rsvp/reject",
	["./promise","exports"],
	function(__dependency1__, __exports__) {
		"use strict";
		var Promise = __dependency1__["default"];

		/**
			This is a convenient alias for `RSVP.Promise.reject`.

			@method reject
			@for RSVP
			@param {Any} reason value that the returned promise will be rejected with.
			@param {String} label optional string for identifying the returned promise.
			Useful for tooling.
			@return {Promise} a promise rejected with the given `reason`.
			@static
		*/
		__exports__["default"] = function reject(reason, label) {
			return Promise.reject(reason, label);
		};
	});
define("rsvp/resolve",
	["./promise","exports"],
	function(__dependency1__, __exports__) {
		"use strict";
		var Promise = __dependency1__["default"];

		/**
			This is a convenient alias for `RSVP.Promise.resolve`.

			@method resolve
			@for RSVP
			@param {Any} value value that the returned promise will be resolved with
			@param {String} label optional string for identifying the returned promise.
			Useful for tooling.
			@return {Promise} a promise that will become fulfilled with the given
			`value`
			@static
		*/
		__exports__["default"] = function resolve(value, label) {
			return Promise.resolve(value, label);
		};
	});
define("rsvp/rethrow",
	["exports"],
	function(__exports__) {
		"use strict";
		/**
			`RSVP.rethrow` will rethrow an error on the next turn of the JavaScript event
			loop in order to aid debugging.

			Promises A+ specifies that any exceptions that occur with a promise must be
			caught by the promises implementation and bubbled to the last handler. For
			this reason, it is recommended that you always specify a second rejection
			handler function to `then`. However, `RSVP.rethrow` will throw the exception
			outside of the promise, so it bubbles up to your console if in the browser,
			or domain/cause uncaught exception in Node. `rethrow` will also throw the
			error again so the error can be handled by the promise per the spec.

			```javascript
			function throws(){
				throw new Error('Whoops!');
			}

			var promise = new RSVP.Promise(function(resolve, reject){
				throws();
			});

			promise.catch(RSVP.rethrow).then(function(){
				// Code here doesn't run because the promise became rejected due to an
				// error!
			}, function (err){
				// handle the error here
			});
			```

			The 'Whoops' error will be thrown on the next turn of the event loop
			and you can watch for it in your console. You can also handle it using a
			rejection handler given to `.then` or `.catch` on the returned promise.

			@method rethrow
			@for RSVP
			@param {Error} reason reason the promise became rejected.
			@throws Error
			@static
		*/
		__exports__["default"] = function rethrow(reason) {
			setTimeout(function() {
				throw reason;
			});
			throw reason;
		};
	});
define("rsvp/utils",
	["exports"],
	function(__exports__) {
		"use strict";
		function objectOrFunction(x) {
			return typeof x === "function" || (typeof x === "object" && x !== null);
		}

		__exports__.objectOrFunction = objectOrFunction;function isFunction(x) {
			return typeof x === "function";
		}

		__exports__.isFunction = isFunction;function isNonThenable(x) {
			return !objectOrFunction(x);
		}

		__exports__.isNonThenable = isNonThenable;function isArray(x) {
			return Object.prototype.toString.call(x) === "[object Array]";
		}

		__exports__.isArray = isArray;// Date.now is not available in browsers < IE9
		// https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/now#Compatibility
		var now = Date.now || function() { return new Date().getTime(); };
		__exports__.now = now;
		var keysOf = Object.keys || function(object) {
			var result = [];

			for (var prop in object) {
				result.push(prop);
			}

			return result;
		};
		__exports__.keysOf = keysOf;
	});
define("rsvp",
	["./rsvp/promise","./rsvp/events","./rsvp/node","./rsvp/all","./rsvp/all_settled","./rsvp/race","./rsvp/hash","./rsvp/rethrow","./rsvp/defer","./rsvp/config","./rsvp/map","./rsvp/resolve","./rsvp/reject","./rsvp/filter","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __dependency4__, __dependency5__, __dependency6__, __dependency7__, __dependency8__, __dependency9__, __dependency10__, __dependency11__, __dependency12__, __dependency13__, __dependency14__, __exports__) {
		"use strict";
		var Promise = __dependency1__["default"];
		var EventTarget = __dependency2__["default"];
		var denodeify = __dependency3__["default"];
		var all = __dependency4__["default"];
		var allSettled = __dependency5__["default"];
		var race = __dependency6__["default"];
		var hash = __dependency7__["default"];
		var rethrow = __dependency8__["default"];
		var defer = __dependency9__["default"];
		var config = __dependency10__.config;
		var configure = __dependency10__.configure;
		var map = __dependency11__["default"];
		var resolve = __dependency12__["default"];
		var reject = __dependency13__["default"];
		var filter = __dependency14__["default"];

		function async(callback, arg) {
			config.async(callback, arg);
		}

		function on() {
			config.on.apply(config, arguments);
		}

		function off() {
			config.off.apply(config, arguments);
		}

		// Set up instrumentation through `window.__PROMISE_INTRUMENTATION__`
		if (typeof window !== 'undefined' && typeof window.__PROMISE_INSTRUMENTATION__ === 'object') {
			var callbacks = window.__PROMISE_INSTRUMENTATION__;
			configure('instrument', true);
			for (var eventName in callbacks) {
				if (callbacks.hasOwnProperty(eventName)) {
					on(eventName, callbacks[eventName]);
				}
			}
		}

		__exports__.Promise = Promise;
		__exports__.EventTarget = EventTarget;
		__exports__.all = all;
		__exports__.allSettled = allSettled;
		__exports__.race = race;
		__exports__.hash = hash;
		__exports__.rethrow = rethrow;
		__exports__.defer = defer;
		__exports__.denodeify = denodeify;
		__exports__.configure = configure;
		__exports__.on = on;
		__exports__.off = off;
		__exports__.resolve = resolve;
		__exports__.reject = reject;
		__exports__.async = async;
		__exports__.map = map;
		__exports__.filter = filter;
	});

})();

(function() {
/**
Public api for the container is still in flux.
The public api, specified on the application namespace should be considered the stable api.
// @module container
	@private
*/

/*
 Flag to enable/disable model factory injections (disabled by default)
 If model factory injections are enabled, models should not be
 accessed globally (only through `container.lookupFactory('model:modelName'))`);
*/
Ember.MODEL_FACTORY_INJECTIONS = false || !!Ember.ENV.MODEL_FACTORY_INJECTIONS;

define("container",
	[],
	function() {
		"use strict";

		// A safe and simple inheriting object.
		function InheritingDict(parent) {
			this.parent = parent;
			this.dict = {};
		}

		InheritingDict.prototype = {

			/**
				@property parent
				@type InheritingDict
				@default null
			*/

			parent: null,

			/**
				Object used to store the current nodes data.

				@property dict
				@type Object
				@default Object
			*/
			dict: null,

			/**
				Retrieve the value given a key, if the value is present at the current
				level use it, otherwise walk up the parent hierarchy and try again. If
				no matching key is found, return undefined.

				@method get
				@param {String} key
				@return {any}
			*/
			get: function(key) {
				var dict = this.dict;

				if (dict.hasOwnProperty(key)) {
					return dict[key];
				}

				if (this.parent) {
					return this.parent.get(key);
				}
			},

			/**
				Set the given value for the given key, at the current level.

				@method set
				@param {String} key
				@param {Any} value
			*/
			set: function(key, value) {
				this.dict[key] = value;
			},

			/**
				Delete the given key

				@method remove
				@param {String} key
			*/
			remove: function(key) {
				delete this.dict[key];
			},

			/**
				Check for the existence of given a key, if the key is present at the current
				level return true, otherwise walk up the parent hierarchy and try again. If
				no matching key is found, return false.

				@method has
				@param {String} key
				@return {Boolean}
			*/
			has: function(key) {
				var dict = this.dict;

				if (dict.hasOwnProperty(key)) {
					return true;
				}

				if (this.parent) {
					return this.parent.has(key);
				}

				return false;
			},

			/**
				Iterate and invoke a callback for each local key-value pair.

				@method eachLocal
				@param {Function} callback
				@param {Object} binding
			*/
			eachLocal: function(callback, binding) {
				var dict = this.dict;

				for (var prop in dict) {
					if (dict.hasOwnProperty(prop)) {
						callback.call(binding, prop, dict[prop]);
					}
				}
			}
		};


		// A lightweight container that helps to assemble and decouple components.
		// Public api for the container is still in flux.
		// The public api, specified on the application namespace should be considered the stable api.
		function Container(parent) {
			this.parent = parent;
			this.children = [];

			this.resolver = parent && parent.resolver || function() {};

			this.registry = new InheritingDict(parent && parent.registry);
			this.cache = new InheritingDict(parent && parent.cache);
			this.factoryCache = new InheritingDict(parent && parent.factoryCache);
			this.resolveCache = new InheritingDict(parent && parent.resolveCache);
			this.typeInjections = new InheritingDict(parent && parent.typeInjections);
			this.injections = {};

			this.factoryTypeInjections = new InheritingDict(parent && parent.factoryTypeInjections);
			this.factoryInjections = {};

			this._options = new InheritingDict(parent && parent._options);
			this._typeOptions = new InheritingDict(parent && parent._typeOptions);
		}

		Container.prototype = {

			/**
				@property parent
				@type Container
				@default null
			*/
			parent: null,

			/**
				@property children
				@type Array
				@default []
			*/
			children: null,

			/**
				@property resolver
				@type function
			*/
			resolver: null,

			/**
				@property registry
				@type InheritingDict
			*/
			registry: null,

			/**
				@property cache
				@type InheritingDict
			*/
			cache: null,

			/**
				@property typeInjections
				@type InheritingDict
			*/
			typeInjections: null,

			/**
				@property injections
				@type Object
				@default {}
			*/
			injections: null,

			/**
				@private

				@property _options
				@type InheritingDict
				@default null
			*/
			_options: null,

			/**
				@private

				@property _typeOptions
				@type InheritingDict
			*/
			_typeOptions: null,

			/**
				Returns a new child of the current container. These children are configured
				to correctly inherit from the current container.

				@method child
				@return {Container}
			*/
			child: function() {
				var container = new Container(this);
				this.children.push(container);
				return container;
			},

			/**
				Sets a key-value pair on the current container. If a parent container,
				has the same key, once set on a child, the parent and child will diverge
				as expected.

				@method set
				@param {Object} object
				@param {String} key
				@param {any} value
			*/
			set: function(object, key, value) {
				object[key] = value;
			},

			/**
				Registers a factory for later injection.

				Example:

				```javascript
				var container = new Container();

				container.register('model:user', Person, {singleton: false });
				container.register('fruit:favorite', Orange);
				container.register('communication:main', Email, {singleton: false});
				```

				@method register
				@param {String} fullName
				@param {Function} factory
				@param {Object} options
			*/
			register: function(fullName, factory, options) {
				validateFullName(fullName);

				if (factory === undefined) {
					throw new TypeError('Attempting to register an unknown factory: `' + fullName + '`');
				}

				var normalizedName = this.normalize(fullName);

				if (this.cache.has(normalizedName)) {
					throw new Error('Cannot re-register: `' + fullName +'`, as it has already been looked up.');
				}

				this.registry.set(normalizedName, factory);
				this._options.set(normalizedName, options || {});
			},

			/**
				Unregister a fullName

				```javascript
				var container = new Container();
				container.register('model:user', User);

				container.lookup('model:user') instanceof User //=> true

				container.unregister('model:user')
				container.lookup('model:user') === undefined //=> true
				```

				@method unregister
				@param {String} fullName
			 */
			unregister: function(fullName) {
				validateFullName(fullName);

				var normalizedName = this.normalize(fullName);

				this.registry.remove(normalizedName);
				this.cache.remove(normalizedName);
				this.factoryCache.remove(normalizedName);
				this.resolveCache.remove(normalizedName);
				this._options.remove(normalizedName);
			},

			/**
				Given a fullName return the corresponding factory.

				By default `resolve` will retrieve the factory from
				its container's registry.

				```javascript
				var container = new Container();
				container.register('api:twitter', Twitter);

				container.resolve('api:twitter') // => Twitter
				```

				Optionally the container can be provided with a custom resolver.
				If provided, `resolve` will first provide the custom resolver
				the oppertunity to resolve the fullName, otherwise it will fallback
				to the registry.

				```javascript
				var container = new Container();
				container.resolver = function(fullName) {
					// lookup via the module system of choice
				};

				// the twitter factory is added to the module system
				container.resolve('api:twitter') // => Twitter
				```

				@method resolve
				@param {String} fullName
				@return {Function} fullName's factory
			*/
			resolve: function(fullName) {
				validateFullName(fullName);

				var normalizedName = this.normalize(fullName);
				var cached = this.resolveCache.get(normalizedName);

				if (cached) { return cached; }

				var resolved = this.resolver(normalizedName) || this.registry.get(normalizedName);

				this.resolveCache.set(normalizedName, resolved);

				return resolved;
			},

			/**
				A hook that can be used to describe how the resolver will
				attempt to find the factory.

				For example, the default Ember `.describe` returns the full
				class name (including namespace) where Ember's resolver expects
				to find the `fullName`.

				@method describe
				@param {String} fullName
				@return {string} described fullName
			*/
			describe: function(fullName) {
				return fullName;
			},

			/**
				A hook to enable custom fullName normalization behaviour

				@method normalize
				@param {String} fullName
				@return {string} normalized fullName
			*/
			normalize: function(fullName) {
				return fullName;
			},

			/**
				@method makeToString

				@param {any} factory
				@param {string} fullName
				@return {function} toString function
			*/
			makeToString: function(factory, fullName) {
				return factory.toString();
			},

			/**
				Given a fullName return a corresponding instance.

				The default behaviour is for lookup to return a singleton instance.
				The singleton is scoped to the container, allowing multiple containers
				to all have their own locally scoped singletons.

				```javascript
				var container = new Container();
				container.register('api:twitter', Twitter);

				var twitter = container.lookup('api:twitter');

				twitter instanceof Twitter; // => true

				// by default the container will return singletons
				var twitter2 = container.lookup('api:twitter');
				twitter instanceof Twitter; // => true

				twitter === twitter2; //=> true
				```

				If singletons are not wanted an optional flag can be provided at lookup.

				```javascript
				var container = new Container();
				container.register('api:twitter', Twitter);

				var twitter = container.lookup('api:twitter', { singleton: false });
				var twitter2 = container.lookup('api:twitter', { singleton: false });

				twitter === twitter2; //=> false
				```

				@method lookup
				@param {String} fullName
				@param {Object} options
				@return {any}
			*/
			lookup: function(fullName, options) {
				validateFullName(fullName);
				return lookup(this, this.normalize(fullName), options);
			},

			/**
				Given a fullName return the corresponding factory.

				@method lookupFactory
				@param {String} fullName
				@return {any}
			*/
			lookupFactory: function(fullName) {
				validateFullName(fullName);
				return factoryFor(this, this.normalize(fullName));
			},

			/**
				Given a fullName check if the container is aware of its factory
				or singleton instance.

				@method has
				@param {String} fullName
				@return {Boolean}
			*/
			has: function(fullName) {
				validateFullName(fullName);
				return has(this, this.normalize(fullName));
			},

			/**
				Allow registering options for all factories of a type.

				```javascript
				var container = new Container();

				// if all of type `connection` must not be singletons
				container.optionsForType('connection', { singleton: false });

				container.register('connection:twitter', TwitterConnection);
				container.register('connection:facebook', FacebookConnection);

				var twitter = container.lookup('connection:twitter');
				var twitter2 = container.lookup('connection:twitter');

				twitter === twitter2; // => false

				var facebook = container.lookup('connection:facebook');
				var facebook2 = container.lookup('connection:facebook');

				facebook === facebook2; // => false
				```

				@method optionsForType
				@param {String} type
				@param {Object} options
			*/
			optionsForType: function(type, options) {
				if (this.parent) { illegalChildOperation('optionsForType'); }

				this._typeOptions.set(type, options);
			},

			/**
				@method options
				@param {String} type
				@param {Object} options
			*/
			options: function(type, options) {
				this.optionsForType(type, options);
			},

			/**
				Used only via `injection`.

				Provides a specialized form of injection, specifically enabling
				all objects of one type to be injected with a reference to another
				object.

				For example, provided each object of type `controller` needed a `router`.
				one would do the following:

				```javascript
				var container = new Container();

				container.register('router:main', Router);
				container.register('controller:user', UserController);
				container.register('controller:post', PostController);

				container.typeInjection('controller', 'router', 'router:main');

				var user = container.lookup('controller:user');
				var post = container.lookup('controller:post');

				user.router instanceof Router; //=> true
				post.router instanceof Router; //=> true

				// both controllers share the same router
				user.router === post.router; //=> true
				```

				@private
				@method typeInjection
				@param {String} type
				@param {String} property
				@param {String} fullName
			*/
			typeInjection: function(type, property, fullName) {
				validateFullName(fullName);
				if (this.parent) { illegalChildOperation('typeInjection'); }

				addTypeInjection(this.typeInjections, type, property, fullName);
			},

			/**
				Defines injection rules.

				These rules are used to inject dependencies onto objects when they
				are instantiated.

				Two forms of injections are possible:

				* Injecting one fullName on another fullName
				* Injecting one fullName on a type

				Example:

				```javascript
				var container = new Container();

				container.register('source:main', Source);
				container.register('model:user', User);
				container.register('model:post', Post);

				// injecting one fullName on another fullName
				// eg. each user model gets a post model
				container.injection('model:user', 'post', 'model:post');

				// injecting one fullName on another type
				container.injection('model', 'source', 'source:main');

				var user = container.lookup('model:user');
				var post = container.lookup('model:post');

				user.source instanceof Source; //=> true
				post.source instanceof Source; //=> true

				user.post instanceof Post; //=> true

				// and both models share the same source
				user.source === post.source; //=> true
				```

				@method injection
				@param {String} factoryName
				@param {String} property
				@param {String} injectionName
			*/
			injection: function(fullName, property, injectionName) {
				if (this.parent) { illegalChildOperation('injection'); }

				validateFullName(injectionName);
				var normalizedInjectionName = this.normalize(injectionName);

				if (fullName.indexOf(':') === -1) {
					return this.typeInjection(fullName, property, normalizedInjectionName);
				}

				validateFullName(fullName);
				var normalizedName = this.normalize(fullName);

				addInjection(this.injections, normalizedName, property, normalizedInjectionName);
			},


			/**
				Used only via `factoryInjection`.

				Provides a specialized form of injection, specifically enabling
				all factory of one type to be injected with a reference to another
				object.

				For example, provided each factory of type `model` needed a `store`.
				one would do the following:

				```javascript
				var container = new Container();

				container.register('store:main', SomeStore);

				container.factoryTypeInjection('model', 'store', 'store:main');

				var store = container.lookup('store:main');
				var UserFactory = container.lookupFactory('model:user');

				UserFactory.store instanceof SomeStore; //=> true
				```

				@private
				@method factoryTypeInjection
				@param {String} type
				@param {String} property
				@param {String} fullName
			*/
			factoryTypeInjection: function(type, property, fullName) {
				if (this.parent) { illegalChildOperation('factoryTypeInjection'); }

				addTypeInjection(this.factoryTypeInjections, type, property, this.normalize(fullName));
			},

			/**
				Defines factory injection rules.

				Similar to regular injection rules, but are run against factories, via
				`Container#lookupFactory`.

				These rules are used to inject objects onto factories when they
				are looked up.

				Two forms of injections are possible:

			* Injecting one fullName on another fullName
			* Injecting one fullName on a type

				Example:

				```javascript
				var container = new Container();

				container.register('store:main', Store);
				container.register('store:secondary', OtherStore);
				container.register('model:user', User);
				container.register('model:post', Post);

				// injecting one fullName on another type
				container.factoryInjection('model', 'store', 'store:main');

				// injecting one fullName on another fullName
				container.factoryInjection('model:post', 'secondaryStore', 'store:secondary');

				var UserFactory = container.lookupFactory('model:user');
				var PostFactory = container.lookupFactory('model:post');
				var store = container.lookup('store:main');

				UserFactory.store instanceof Store; //=> true
				UserFactory.secondaryStore instanceof OtherStore; //=> false

				PostFactory.store instanceof Store; //=> true
				PostFactory.secondaryStore instanceof OtherStore; //=> true

				// and both models share the same source instance
				UserFactory.store === PostFactory.store; //=> true
				```

				@method factoryInjection
				@param {String} factoryName
				@param {String} property
				@param {String} injectionName
			*/
			factoryInjection: function(fullName, property, injectionName) {
				if (this.parent) { illegalChildOperation('injection'); }

				var normalizedName = this.normalize(fullName);
				var normalizedInjectionName = this.normalize(injectionName);

				validateFullName(injectionName);

				if (fullName.indexOf(':') === -1) {
					return this.factoryTypeInjection(normalizedName, property, normalizedInjectionName);
				}

				validateFullName(fullName);

				addInjection(this.factoryInjections, normalizedName, property, normalizedInjectionName);
			},

			/**
				A depth first traversal, destroying the container, its descendant containers and all
				their managed objects.

				@method destroy
			*/
			destroy: function() {
				for (var i=0, l=this.children.length; i<l; i++) {
					this.children[i].destroy();
				}

				this.children = [];

				eachDestroyable(this, function(item) {
					item.destroy();
				});

				this.parent = undefined;
				this.isDestroyed = true;
			},

			/**
				@method reset
			*/
			reset: function() {
				for (var i=0, l=this.children.length; i<l; i++) {
					resetCache(this.children[i]);
				}
				resetCache(this);
			}
		};

		function has(container, fullName){
			if (container.cache.has(fullName)) {
				return true;
			}

			return !!container.resolve(fullName);
		}

		function lookup(container, fullName, options) {
			options = options || {};

			if (container.cache.has(fullName) && options.singleton !== false) {
				return container.cache.get(fullName);
			}

			var value = instantiate(container, fullName);

			if (value === undefined) { return; }

			if (isSingleton(container, fullName) && options.singleton !== false) {
				container.cache.set(fullName, value);
			}

			return value;
		}

		function illegalChildOperation(operation) {
			throw new Error(operation + " is not currently supported on child containers");
		}

		function isSingleton(container, fullName) {
			var singleton = option(container, fullName, 'singleton');

			return singleton !== false;
		}

		function buildInjections(container, injections) {
			var hash = {};

			if (!injections) { return hash; }

			var injection, injectable;

			for (var i=0, l=injections.length; i<l; i++) {
				injection = injections[i];
				injectable = lookup(container, injection.fullName);

				if (injectable !== undefined) {
					hash[injection.property] = injectable;
				} else {
					throw new Error('Attempting to inject an unknown injection: `' + injection.fullName + '`');
				}
			}

			return hash;
		}

		function option(container, fullName, optionName) {
			var options = container._options.get(fullName);

			if (options && options[optionName] !== undefined) {
				return options[optionName];
			}

			var type = fullName.split(":")[0];
			options = container._typeOptions.get(type);

			if (options) {
				return options[optionName];
			}
		}

		function factoryFor(container, fullName) {
			var name = fullName;
			var factory = container.resolve(name);
			var injectedFactory;
			var cache = container.factoryCache;
			var type = fullName.split(":")[0];

			if (factory === undefined) { return; }

			if (cache.has(fullName)) {
				return cache.get(fullName);
			}

			if (!factory || typeof factory.extend !== 'function' || (!Ember.MODEL_FACTORY_INJECTIONS && type === 'model')) {
				// TODO: think about a 'safe' merge style extension
				// for now just fallback to create time injection
				return factory;
			} else {

				var injections        = injectionsFor(container, fullName);
				var factoryInjections = factoryInjectionsFor(container, fullName);

				factoryInjections._toString = container.makeToString(factory, fullName);

				injectedFactory = factory.extend(injections);
				injectedFactory.reopenClass(factoryInjections);

				cache.set(fullName, injectedFactory);

				return injectedFactory;
			}
		}

		function injectionsFor(container ,fullName) {
			var splitName = fullName.split(":"),
				type = splitName[0],
				injections = [];

			injections = injections.concat(container.typeInjections.get(type) || []);
			injections = injections.concat(container.injections[fullName] || []);

			injections = buildInjections(container, injections);
			injections._debugContainerKey = fullName;
			injections.container = container;

			return injections;
		}

		function factoryInjectionsFor(container, fullName) {
			var splitName = fullName.split(":"),
				type = splitName[0],
				factoryInjections = [];

			factoryInjections = factoryInjections.concat(container.factoryTypeInjections.get(type) || []);
			factoryInjections = factoryInjections.concat(container.factoryInjections[fullName] || []);

			factoryInjections = buildInjections(container, factoryInjections);
			factoryInjections._debugContainerKey = fullName;

			return factoryInjections;
		}

		function instantiate(container, fullName) {
			var factory = factoryFor(container, fullName);

			if (option(container, fullName, 'instantiate') === false) {
				return factory;
			}

			if (factory) {
				if (typeof factory.extend === 'function') {
					// assume the factory was extendable and is already injected
					return factory.create();
				} else {
					// assume the factory was extendable
					// to create time injections
					// TODO: support new'ing for instantiation and merge injections for pure JS Functions
					return factory.create(injectionsFor(container, fullName));
				}
			}
		}

		function eachDestroyable(container, callback) {
			container.cache.eachLocal(function(key, value) {
				if (option(container, key, 'instantiate') === false) { return; }
				callback(value);
			});
		}

		function resetCache(container) {
			container.cache.eachLocal(function(key, value) {
				if (option(container, key, 'instantiate') === false) { return; }
				value.destroy();
			});
			container.cache.dict = {};
		}

		function addTypeInjection(rules, type, property, fullName) {
			var injections = rules.get(type);

			if (!injections) {
				injections = [];
				rules.set(type, injections);
			}

			injections.push({
				property: property,
				fullName: fullName
			});
		}

		var VALID_FULL_NAME_REGEXP = /^[^:]+.+:[^:]+$/;
		function validateFullName(fullName) {
			if (!VALID_FULL_NAME_REGEXP.test(fullName)) {
				throw new TypeError('Invalid Fullname, expected: `type:name` got: ' + fullName);
			}
		}

		function addInjection(rules, factoryName, property, injectionName) {
			var injections = rules[factoryName] = rules[factoryName] || [];
			injections.push({ property: property, fullName: injectionName });
		}

		return Container;
});

})();

(function() {
/*globals ENV */
/**
@module ember
@submodule ember-runtime
*/

var indexOf = Ember.EnumerableUtils.indexOf;

/**
 This will compare two javascript values of possibly different types.
 It will tell you which one is greater than the other by returning:

	- -1 if the first is smaller than the second,
	- 0 if both are equal,
	- 1 if the first is greater than the second.

 The order is calculated based on `Ember.ORDER_DEFINITION`, if types are different.
 In case they have the same type an appropriate comparison for this type is made.

	```javascript
	Ember.compare('hello', 'hello');  // 0
	Ember.compare('abc', 'dfg');      // -1
	Ember.compare(2, 1);              // 1
	```

 @method compare
 @for Ember
 @param {Object} v First value to compare
 @param {Object} w Second value to compare
 @return {Number} -1 if v < w, 0 if v = w and 1 if v > w.
*/
Ember.compare = function compare(v, w) {
	if (v === w) { return 0; }

	var type1 = Ember.typeOf(v);
	var type2 = Ember.typeOf(w);

	var Comparable = Ember.Comparable;
	if (Comparable) {
		if (type1==='instance' && Comparable.detect(v.constructor)) {
			return v.constructor.compare(v, w);
		}

		if (type2 === 'instance' && Comparable.detect(w.constructor)) {
			return 1-w.constructor.compare(w, v);
		}
	}

	// If we haven't yet generated a reverse-mapping of Ember.ORDER_DEFINITION,
	// do so now.
	var mapping = Ember.ORDER_DEFINITION_MAPPING;
	if (!mapping) {
		var order = Ember.ORDER_DEFINITION;
		mapping = Ember.ORDER_DEFINITION_MAPPING = {};
		var idx, len;
		for (idx = 0, len = order.length; idx < len;  ++idx) {
			mapping[order[idx]] = idx;
		}

		// We no longer need Ember.ORDER_DEFINITION.
		delete Ember.ORDER_DEFINITION;
	}

	var type1Index = mapping[type1];
	var type2Index = mapping[type2];

	if (type1Index < type2Index) { return -1; }
	if (type1Index > type2Index) { return 1; }

	// types are equal - so we have to check values now
	switch (type1) {
		case 'boolean':
		case 'number':
			if (v < w) { return -1; }
			if (v > w) { return 1; }
			return 0;

		case 'string':
			var comp = v.localeCompare(w);
			if (comp < 0) { return -1; }
			if (comp > 0) { return 1; }
			return 0;

		case 'array':
			var vLen = v.length;
			var wLen = w.length;
			var l = Math.min(vLen, wLen);
			var r = 0;
			var i = 0;
			while (r === 0 && i < l) {
				r = compare(v[i],w[i]);
				i++;
			}
			if (r !== 0) { return r; }

			// all elements are equal now
			// shorter array should be ordered first
			if (vLen < wLen) { return -1; }
			if (vLen > wLen) { return 1; }
			// arrays are equal now
			return 0;

		case 'instance':
			if (Ember.Comparable && Ember.Comparable.detect(v)) {
				return v.compare(v, w);
			}
			return 0;

		case 'date':
			var vNum = v.getTime();
			var wNum = w.getTime();
			if (vNum < wNum) { return -1; }
			if (vNum > wNum) { return 1; }
			return 0;

		default:
			return 0;
	}
};

function _copy(obj, deep, seen, copies) {
	var ret, loc, key;

	// primitive data types are immutable, just return them.
	if ('object' !== typeof obj || obj===null) return obj;

	// avoid cyclical loops
	if (deep && (loc=indexOf(seen, obj))>=0) return copies[loc];


	// IMPORTANT: this specific test will detect a native array only. Any other
	// object will need to implement Copyable.
	if (Ember.typeOf(obj) === 'array') {
		ret = obj.slice();
		if (deep) {
			loc = ret.length;
			while(--loc>=0) ret[loc] = _copy(ret[loc], deep, seen, copies);
		}
	} else if (Ember.Copyable && Ember.Copyable.detect(obj)) {
		ret = obj.copy(deep, seen, copies);
	} else {
		ret = {};
		for(key in obj) {
			if (!obj.hasOwnProperty(key)) continue;

			// Prevents browsers that don't respect non-enumerability from
			// copying internal Ember properties
			if (key.substring(0,2) === '__') continue;

			ret[key] = deep ? _copy(obj[key], deep, seen, copies) : obj[key];
		}
	}

	if (deep) {
		seen.push(obj);
		copies.push(ret);
	}

	return ret;
}

/**
	Creates a clone of the passed object. This function can take just about
	any type of object and create a clone of it, including primitive values
	(which are not actually cloned because they are immutable).

	If the passed object implements the `clone()` method, then this function
	will simply call that method and return the result.

	@method copy
	@for Ember
	@param {Object} obj The object to clone
	@param {Boolean} deep If true, a deep copy of the object is made
	@return {Object} The cloned object
*/
Ember.copy = function(obj, deep) {
	// fast paths
	if ('object' !== typeof obj || obj===null) return obj; // can't copy primitives
	if (Ember.Copyable && Ember.Copyable.detect(obj)) return obj.copy(deep);
	return _copy(obj, deep, deep ? [] : null, deep ? [] : null);
};

/**
	Compares two objects, returning true if they are logically equal. This is
	a deeper comparison than a simple triple equal. For sets it will compare the
	internal objects. For any other object that implements `isEqual()` it will
	respect that method.

	```javascript
	Ember.isEqual('hello', 'hello');  // true
	Ember.isEqual(1, 2);              // false
	Ember.isEqual([4,2], [4,2]);      // false
	```

	@method isEqual
	@for Ember
	@param {Object} a first object to compare
	@param {Object} b second object to compare
	@return {Boolean}
*/
Ember.isEqual = function(a, b) {
	if (a && 'function'===typeof a.isEqual) return a.isEqual(b);
	return a === b;
};

// Used by Ember.compare
Ember.ORDER_DEFINITION = Ember.ENV.ORDER_DEFINITION || [
	'undefined',
	'null',
	'boolean',
	'number',
	'string',
	'array',
	'object',
	'instance',
	'function',
	'class',
	'date'
];

/**
	Returns all of the keys defined on an object or hash. This is useful
	when inspecting objects for debugging. On browsers that support it, this
	uses the native `Object.keys` implementation.

	@method keys
	@for Ember
	@param {Object} obj
	@return {Array} Array containing keys of obj
*/
Ember.keys = Object.keys;

if (!Ember.keys || Ember.create.isSimulated) {
	var prototypeProperties = [
		'constructor',
		'hasOwnProperty',
		'isPrototypeOf',
		'propertyIsEnumerable',
		'valueOf',
		'toLocaleString',
		'toString'
	],
	pushPropertyName = function(obj, array, key) {
		// Prevents browsers that don't respect non-enumerability from
		// copying internal Ember properties
		if (key.substring(0,2) === '__') return;
		if (key === '_super') return;
		if (indexOf(array, key) >= 0) return;
		if (!obj.hasOwnProperty(key)) return;

		array.push(key);
	};

	Ember.keys = function(obj) {
		var ret = [], key;
		for (key in obj) {
			pushPropertyName(obj, ret, key);
		}

		// IE8 doesn't enumerate property that named the same as prototype properties.
		for (var i = 0, l = prototypeProperties.length; i < l; i++) {
			key = prototypeProperties[i];

			pushPropertyName(obj, ret, key);
		}

		return ret;
	};
}

})();



(function() {
/**
@module ember
@submodule ember-runtime
*/

var STRING_DASHERIZE_REGEXP = (/[ _]/g);
var STRING_DASHERIZE_CACHE = {};
var STRING_DECAMELIZE_REGEXP = (/([a-z\d])([A-Z])/g);
var STRING_CAMELIZE_REGEXP = (/(\-|_|\.|\s)+(.)?/g);
var STRING_UNDERSCORE_REGEXP_1 = (/([a-z\d])([A-Z]+)/g);
var STRING_UNDERSCORE_REGEXP_2 = (/\-|\s+/g);
var STRING_PARAMETERIZE_REGEXP_1 = (/[_|\/|\s]+/g);
var STRING_PARAMETERIZE_REGEXP_2 = (/[^a-z0-9\-]+/gi);
var STRING_PARAMETERIZE_REGEXP_3 = (/[\-]+/g);
var STRING_PARAMETERIZE_REGEXP_4 = (/^-+|-+$/g);

/**
	Defines the hash of localized strings for the current language. Used by
	the `Ember.String.loc()` helper. To localize, add string values to this
	hash.

	@property STRINGS
	@for Ember
	@type Hash
*/
Ember.STRINGS = {};

/**
	Defines string helper methods including string formatting and localization.
	Unless `Ember.EXTEND_PROTOTYPES.String` is `false` these methods will also be
	added to the `String.prototype` as well.

	@class String
	@namespace Ember
	@static
*/
Ember.String = {

	/**
		Apply formatting options to the string. This will look for occurrences
		of "%@" in your string and substitute them with the arguments you pass into
		this method. If you want to control the specific order of replacement,
		you can add a number after the key as well to indicate which argument
		you want to insert.

		Ordered insertions are most useful when building loc strings where values
		you need to insert may appear in different orders.

		```javascript
		"Hello %@ %@".fmt('John', 'Doe');     // "Hello John Doe"
		"Hello %@2, %@1".fmt('John', 'Doe');  // "Hello Doe, John"
		```

		@method fmt
		@param {String} str The string to format
		@param {Array} formats An array of parameters to interpolate into string.
		@return {String} formatted string
	*/
	fmt: function(str, formats) {
		// first, replace any ORDERED replacements.
		var idx  = 0; // the current index for non-numerical replacements
		return str.replace(/%@([0-9]+)?/g, function(s, argIndex) {
			argIndex = (argIndex) ? parseInt(argIndex, 10) - 1 : idx++;
			s = formats[argIndex];
			return (s === null) ? '(null)' : (s === undefined) ? '' : Ember.inspect(s);
		}) ;
	},

	/**
		Formats the passed string, but first looks up the string in the localized
		strings hash. This is a convenient way to localize text. See
		`Ember.String.fmt()` for more information on formatting.

		Note that it is traditional but not required to prefix localized string
		keys with an underscore or other character so you can easily identify
		localized strings.

		```javascript
		Ember.STRINGS = {
			'_Hello World': 'Bonjour le monde',
			'_Hello %@ %@': 'Bonjour %@ %@'
		};

		Ember.String.loc("_Hello World");  // 'Bonjour le monde';
		Ember.String.loc("_Hello %@ %@", ["John", "Smith"]);  // "Bonjour John Smith";
		```

		@method loc
		@param {String} str The string to format
		@param {Array} formats Optional array of parameters to interpolate into string.
		@return {String} formatted string
	*/
	loc: function(str, formats) {
		str = Ember.STRINGS[str] || str;
		return Ember.String.fmt(str, formats) ;
	},

	/**
		Splits a string into separate units separated by spaces, eliminating any
		empty strings in the process. This is a convenience method for split that
		is mostly useful when applied to the `String.prototype`.

		```javascript
		Ember.String.w("alpha beta gamma").forEach(function(key) {
			console.log(key);
		});

		// > alpha
		// > beta
		// > gamma
		```

		@method w
		@param {String} str The string to split
		@return {String} split string
	*/
	w: function(str) { return str.split(/\s+/); },

	/**
		Converts a camelized string into all lower case separated by underscores.

		```javascript
		'innerHTML'.decamelize();           // 'inner_html'
		'action_name'.decamelize();        // 'action_name'
		'css-class-name'.decamelize();     // 'css-class-name'
		'my favorite items'.decamelize();  // 'my favorite items'
		```

		@method decamelize
		@param {String} str The string to decamelize.
		@return {String} the decamelized string.
	*/
	decamelize: function(str) {
		return str.replace(STRING_DECAMELIZE_REGEXP, '$1_$2').toLowerCase();
	},

	/**
		Replaces underscores, spaces, or camelCase with dashes.

		```javascript
		'innerHTML'.dasherize();          // 'inner-html'
		'action_name'.dasherize();        // 'action-name'
		'css-class-name'.dasherize();     // 'css-class-name'
		'my favorite items'.dasherize();  // 'my-favorite-items'
		```

		@method dasherize
		@param {String} str The string to dasherize.
		@return {String} the dasherized string.
	*/
	dasherize: function(str) {
		var cache = STRING_DASHERIZE_CACHE,
				hit   = cache.hasOwnProperty(str),
				ret;

		if (hit) {
			return cache[str];
		} else {
			ret = Ember.String.decamelize(str).replace(STRING_DASHERIZE_REGEXP,'-');
			cache[str] = ret;
		}

		return ret;
	},

	/**
		Returns the lowerCamelCase form of a string.

		```javascript
		'innerHTML'.camelize();          // 'innerHTML'
		'action_name'.camelize();        // 'actionName'
		'css-class-name'.camelize();     // 'cssClassName'
		'my favorite items'.camelize();  // 'myFavoriteItems'
		'My Favorite Items'.camelize();  // 'myFavoriteItems'
		```

		@method camelize
		@param {String} str The string to camelize.
		@return {String} the camelized string.
	*/
	camelize: function(str) {
		return str.replace(STRING_CAMELIZE_REGEXP, function(match, separator, chr) {
			return chr ? chr.toUpperCase() : '';
		}).replace(/^([A-Z])/, function(match, separator, chr) {
			return match.toLowerCase();
		});
	},

	/**
		Returns the UpperCamelCase form of a string.

		```javascript
		'innerHTML'.classify();          // 'InnerHTML'
		'action_name'.classify();        // 'ActionName'
		'css-class-name'.classify();     // 'CssClassName'
		'my favorite items'.classify();  // 'MyFavoriteItems'
		```

		@method classify
		@param {String} str the string to classify
		@return {String} the classified string
	*/
	classify: function(str) {
		var parts = str.split("."),
				out = [];

		for (var i=0, l=parts.length; i<l; i++) {
			var camelized = Ember.String.camelize(parts[i]);
			out.push(camelized.charAt(0).toUpperCase() + camelized.substr(1));
		}

		return out.join(".");
	},

	/**
		More general than decamelize. Returns the lower\_case\_and\_underscored
		form of a string.

		```javascript
		'innerHTML'.underscore();          // 'inner_html'
		'action_name'.underscore();        // 'action_name'
		'css-class-name'.underscore();     // 'css_class_name'
		'my favorite items'.underscore();  // 'my_favorite_items'
		```

		@method underscore
		@param {String} str The string to underscore.
		@return {String} the underscored string.
	*/
	underscore: function(str) {
		return str.replace(STRING_UNDERSCORE_REGEXP_1, '$1_$2').
			replace(STRING_UNDERSCORE_REGEXP_2, '_').toLowerCase();
	},

	/**
		Returns the Capitalized form of a string

		```javascript
		'innerHTML'.capitalize()         // 'InnerHTML'
		'action_name'.capitalize()       // 'Action_name'
		'css-class-name'.capitalize()    // 'Css-class-name'
		'my favorite items'.capitalize() // 'My favorite items'
		```

		@method capitalize
		@param {String} str The string to capitalize.
		@return {String} The capitalized string.
	*/
	capitalize: function(str) {
		return str.charAt(0).toUpperCase() + str.substr(1);
	}
};

if (Ember.FEATURES.isEnabled("string-humanize")) {
	/**
		Returns the Humanized form of a string

		Replaces underscores with spaces, and capitializes first character
		of string. Also strips "_id" suffixes.

		```javascript
		'first_name'.humanize()       // 'First name'
		'user_id'.humanize()          // 'User'
		```

		@method humanize
		@param {String} str The string to humanize.
		@return {String} The humanized string.
	*/

	Ember.String.humanize = function(str) {
		return str.replace(/_id$/, '').
			replace(/_/g, ' ').
			replace(/^\w/g, function(s){
				return s.toUpperCase();
			});
	};
}

if (Ember.FEATURES.isEnabled("string-parameterize")) {
	/**
		Transforms a string so that it may be used as part of a 'pretty' / SEO friendly URL.

		```javascript
		'My favorite items.'.parameterize();                        // 'my-favorite-items'
		'action_name'.parameterize();                               // 'action-name'
		'100 ways Ember.js is better than Angular.'.parameterize(); // '100-ways-emberjs-is-better-than-angular'
		```

		@method parameterize
		@param {String} str The string to parameterize.
		@return {String} the parameterized string.
	*/
	Ember.String.parameterize = function(str) {
		return str.replace(STRING_PARAMETERIZE_REGEXP_1, '-') // replace underscores, slashes and spaces with separator
							.replace(STRING_PARAMETERIZE_REGEXP_2, '')  // remove non-alphanumeric characters except the separator
							.replace(STRING_PARAMETERIZE_REGEXP_3, '-') // replace multiple occurring separators
							.replace(STRING_PARAMETERIZE_REGEXP_4, '')  // trim leading and trailing separators
							.toLowerCase();
	};
}


})();



(function() {
/**
@module ember
@submodule ember-runtime
*/



var fmt = Ember.String.fmt,
		w   = Ember.String.w,
		loc = Ember.String.loc,
		camelize = Ember.String.camelize,
		decamelize = Ember.String.decamelize,
		dasherize = Ember.String.dasherize,
		underscore = Ember.String.underscore,
		capitalize = Ember.String.capitalize,
		classify = Ember.String.classify;

if (Ember.FEATURES.isEnabled("string-humanize")) {
	var humanize = Ember.String.humanize;
}

if (Ember.FEATURES.isEnabled("string-parameterize")) {
	var parameterize = Ember.String.parameterize;
}

if (Ember.EXTEND_PROTOTYPES === true || Ember.EXTEND_PROTOTYPES.String) {

	/**
		See [Ember.String.fmt](/api/classes/Ember.String.html#method_fmt).

		@method fmt
		@for String
	*/
	String.prototype.fmt = function() {
		return fmt(this, arguments);
	};

	/**
		See [Ember.String.w](/api/classes/Ember.String.html#method_w).

		@method w
		@for String
	*/
	String.prototype.w = function() {
		return w(this);
	};

	/**
		See [Ember.String.loc](/api/classes/Ember.String.html#method_loc).

		@method loc
		@for String
	*/
	String.prototype.loc = function() {
		return loc(this, arguments);
	};

	/**
		See [Ember.String.camelize](/api/classes/Ember.String.html#method_camelize).

		@method camelize
		@for String
	*/
	String.prototype.camelize = function() {
		return camelize(this);
	};

	/**
		See [Ember.String.decamelize](/api/classes/Ember.String.html#method_decamelize).

		@method decamelize
		@for String
	*/
	String.prototype.decamelize = function() {
		return decamelize(this);
	};

	/**
		See [Ember.String.dasherize](/api/classes/Ember.String.html#method_dasherize).

		@method dasherize
		@for String
	*/
	String.prototype.dasherize = function() {
		return dasherize(this);
	};

	/**
		See [Ember.String.underscore](/api/classes/Ember.String.html#method_underscore).

		@method underscore
		@for String
	*/
	String.prototype.underscore = function() {
		return underscore(this);
	};

	/**
		See [Ember.String.classify](/api/classes/Ember.String.html#method_classify).

		@method classify
		@for String
	*/
	String.prototype.classify = function() {
		return classify(this);
	};

	/**
		See [Ember.String.capitalize](/api/classes/Ember.String.html#method_capitalize).

		@method capitalize
		@for String
	*/
	String.prototype.capitalize = function() {
		return capitalize(this);
	};

	if (Ember.FEATURES.isEnabled("string-humanize")) {
		/**
			See [Ember.String.humanize](/api/classes/Ember.String.html#method_humanize).

			@method humanize
			@for String
		*/
		String.prototype.humanize = function() {
			return humanize(this);
		};
	}

	if (Ember.FEATURES.isEnabled("string-parameterize")) {
		/**
			See [Ember.String.parameterize](/api/classes/Ember.String.html#method_parameterize).

			@method parameterize
			@for String
		*/
		String.prototype.parameterize = function() {
			return parameterize(this);
		};
	}

}


})();



(function() {
/**
@module ember
@submodule ember-runtime
*/

var get = Ember.get,
		set = Ember.set,
		slice = Array.prototype.slice,
		getProperties = Ember.getProperties;

/**
	## Overview

	This mixin provides properties and property observing functionality, core
	features of the Ember object model.

	Properties and observers allow one object to observe changes to a
	property on another object. This is one of the fundamental ways that
	models, controllers and views communicate with each other in an Ember
	application.

	Any object that has this mixin applied can be used in observer
	operations. That includes `Ember.Object` and most objects you will
	interact with as you write your Ember application.

	Note that you will not generally apply this mixin to classes yourself,
	but you will use the features provided by this module frequently, so it
	is important to understand how to use it.

	## Using `get()` and `set()`

	Because of Ember's support for bindings and observers, you will always
	access properties using the get method, and set properties using the
	set method. This allows the observing objects to be notified and
	computed properties to be handled properly.

	More documentation about `get` and `set` are below.

	## Observing Property Changes

	You typically observe property changes simply by adding the `observes`
	call to the end of your method declarations in classes that you write.
	For example:

	```javascript
	Ember.Object.extend({
		valueObserver: function() {
			// Executes whenever the "value" property changes
		}.observes('value')
	});
	```

	Although this is the most common way to add an observer, this capability
	is actually built into the `Ember.Object` class on top of two methods
	defined in this mixin: `addObserver` and `removeObserver`. You can use
	these two methods to add and remove observers yourself if you need to
	do so at runtime.

	To add an observer for a property, call:

	```javascript
	object.addObserver('propertyKey', targetObject, targetAction)
	```

	This will call the `targetAction` method on the `targetObject` whenever
	the value of the `propertyKey` changes.

	Note that if `propertyKey` is a computed property, the observer will be
	called when any of the property dependencies are changed, even if the
	resulting value of the computed property is unchanged. This is necessary
	because computed properties are not computed until `get` is called.

	@class Observable
	@namespace Ember
*/
Ember.Observable = Ember.Mixin.create({

	/**
		Retrieves the value of a property from the object.

		This method is usually similar to using `object[keyName]` or `object.keyName`,
		however it supports both computed properties and the unknownProperty
		handler.

		Because `get` unifies the syntax for accessing all these kinds
		of properties, it can make many refactorings easier, such as replacing a
		simple property with a computed property, or vice versa.

		### Computed Properties

		Computed properties are methods defined with the `property` modifier
		declared at the end, such as:

		```javascript
		fullName: function() {
			return this.get('firstName') + ' ' + this.get('lastName');
		}.property('firstName', 'lastName')
		```

		When you call `get` on a computed property, the function will be
		called and the return value will be returned instead of the function
		itself.

		### Unknown Properties

		Likewise, if you try to call `get` on a property whose value is
		`undefined`, the `unknownProperty()` method will be called on the object.
		If this method returns any value other than `undefined`, it will be returned
		instead. This allows you to implement "virtual" properties that are
		not defined upfront.

		@method get
		@param {String} keyName The property to retrieve
		@return {Object} The property value or undefined.
	*/
	get: function(keyName) {
		return get(this, keyName);
	},

	/**
		To get multiple properties at once, call `getProperties`
		with a list of strings or an array:

		```javascript
		record.getProperties('firstName', 'lastName', 'zipCode');  // { firstName: 'John', lastName: 'Doe', zipCode: '10011' }
		```

		is equivalent to:

		```javascript
		record.getProperties(['firstName', 'lastName', 'zipCode']);  // { firstName: 'John', lastName: 'Doe', zipCode: '10011' }
		```

		@method getProperties
		@param {String...|Array} list of keys to get
		@return {Hash}
	*/
	getProperties: function() {
		return getProperties.apply(null, [this].concat(slice.call(arguments)));
	},

	/**
		Sets the provided key or path to the value.

		This method is generally very similar to calling `object[key] = value` or
		`object.key = value`, except that it provides support for computed
		properties, the `setUnknownProperty()` method and property observers.

		### Computed Properties

		If you try to set a value on a key that has a computed property handler
		defined (see the `get()` method for an example), then `set()` will call
		that method, passing both the value and key instead of simply changing
		the value itself. This is useful for those times when you need to
		implement a property that is composed of one or more member
		properties.

		### Unknown Properties

		If you try to set a value on a key that is undefined in the target
		object, then the `setUnknownProperty()` handler will be called instead. This
		gives you an opportunity to implement complex "virtual" properties that
		are not predefined on the object. If `setUnknownProperty()` returns
		undefined, then `set()` will simply set the value on the object.

		### Property Observers

		In addition to changing the property, `set()` will also register a property
		change with the object. Unless you have placed this call inside of a
		`beginPropertyChanges()` and `endPropertyChanges(),` any "local" observers
		(i.e. observer methods declared on the same object), will be called
		immediately. Any "remote" observers (i.e. observer methods declared on
		another object) will be placed in a queue and called at a later time in a
		coalesced manner.

		### Chaining

		In addition to property changes, `set()` returns the value of the object
		itself so you can do chaining like this:

		```javascript
		record.set('firstName', 'Charles').set('lastName', 'Jolley');
		```

		@method set
		@param {String} keyName The property to set
		@param {Object} value The value to set or `null`.
		@return {Ember.Observable}
	*/
	set: function(keyName, value) {
		set(this, keyName, value);
		return this;
	},


	/**
		Sets a list of properties at once. These properties are set inside
		a single `beginPropertyChanges` and `endPropertyChanges` batch, so
		observers will be buffered.

		```javascript
		record.setProperties({ firstName: 'Charles', lastName: 'Jolley' });
		```

		@method setProperties
		@param {Hash} hash the hash of keys and values to set
		@return {Ember.Observable}
	*/
	setProperties: function(hash) {
		return Ember.setProperties(this, hash);
	},

	/**
		Begins a grouping of property changes.

		You can use this method to group property changes so that notifications
		will not be sent until the changes are finished. If you plan to make a
		large number of changes to an object at one time, you should call this
		method at the beginning of the changes to begin deferring change
		notifications. When you are done making changes, call
		`endPropertyChanges()` to deliver the deferred change notifications and end
		deferring.

		@method beginPropertyChanges
		@return {Ember.Observable}
	*/
	beginPropertyChanges: function() {
		Ember.beginPropertyChanges();
		return this;
	},

	/**
		Ends a grouping of property changes.

		You can use this method to group property changes so that notifications
		will not be sent until the changes are finished. If you plan to make a
		large number of changes to an object at one time, you should call
		`beginPropertyChanges()` at the beginning of the changes to defer change
		notifications. When you are done making changes, call this method to
		deliver the deferred change notifications and end deferring.

		@method endPropertyChanges
		@return {Ember.Observable}
	*/
	endPropertyChanges: function() {
		Ember.endPropertyChanges();
		return this;
	},

	/**
		Notify the observer system that a property is about to change.

		Sometimes you need to change a value directly or indirectly without
		actually calling `get()` or `set()` on it. In this case, you can use this
		method and `propertyDidChange()` instead. Calling these two methods
		together will notify all observers that the property has potentially
		changed value.

		Note that you must always call `propertyWillChange` and `propertyDidChange`
		as a pair. If you do not, it may get the property change groups out of
		order and cause notifications to be delivered more often than you would
		like.

		@method propertyWillChange
		@param {String} keyName The property key that is about to change.
		@return {Ember.Observable}
	*/
	propertyWillChange: function(keyName) {
		Ember.propertyWillChange(this, keyName);
		return this;
	},

	/**
		Notify the observer system that a property has just changed.

		Sometimes you need to change a value directly or indirectly without
		actually calling `get()` or `set()` on it. In this case, you can use this
		method and `propertyWillChange()` instead. Calling these two methods
		together will notify all observers that the property has potentially
		changed value.

		Note that you must always call `propertyWillChange` and `propertyDidChange`
		as a pair. If you do not, it may get the property change groups out of
		order and cause notifications to be delivered more often than you would
		like.

		@method propertyDidChange
		@param {String} keyName The property key that has just changed.
		@return {Ember.Observable}
	*/
	propertyDidChange: function(keyName) {
		Ember.propertyDidChange(this, keyName);
		return this;
	},

	/**
		Convenience method to call `propertyWillChange` and `propertyDidChange` in
		succession.

		@method notifyPropertyChange
		@param {String} keyName The property key to be notified about.
		@return {Ember.Observable}
	*/
	notifyPropertyChange: function(keyName) {
		this.propertyWillChange(keyName);
		this.propertyDidChange(keyName);
		return this;
	},

	addBeforeObserver: function(key, target, method) {
		Ember.addBeforeObserver(this, key, target, method);
	},

	/**
		Adds an observer on a property.

		This is the core method used to register an observer for a property.

		Once you call this method, any time the key's value is set, your observer
		will be notified. Note that the observers are triggered any time the
		value is set, regardless of whether it has actually changed. Your
		observer should be prepared to handle that.

		You can also pass an optional context parameter to this method. The
		context will be passed to your observer method whenever it is triggered.
		Note that if you add the same target/method pair on a key multiple times
		with different context parameters, your observer will only be called once
		with the last context you passed.

		### Observer Methods

		Observer methods you pass should generally have the following signature if
		you do not pass a `context` parameter:

		```javascript
		fooDidChange: function(sender, key, value, rev) { };
		```

		The sender is the object that changed. The key is the property that
		changes. The value property is currently reserved and unused. The rev
		is the last property revision of the object when it changed, which you can
		use to detect if the key value has really changed or not.

		If you pass a `context` parameter, the context will be passed before the
		revision like so:

		```javascript
		fooDidChange: function(sender, key, value, context, rev) { };
		```

		Usually you will not need the value, context or revision parameters at
		the end. In this case, it is common to write observer methods that take
		only a sender and key value as parameters or, if you aren't interested in
		any of these values, to write an observer that has no parameters at all.

		@method addObserver
		@param {String} key The key to observer
		@param {Object} target The target object to invoke
		@param {String|Function} method The method to invoke.
		@return {Ember.Object} self
	*/
	addObserver: function(key, target, method) {
		Ember.addObserver(this, key, target, method);
	},

	/**
		Remove an observer you have previously registered on this object. Pass
		the same key, target, and method you passed to `addObserver()` and your
		target will no longer receive notifications.

		@method removeObserver
		@param {String} key The key to observer
		@param {Object} target The target object to invoke
		@param {String|Function} method The method to invoke.
		@return {Ember.Observable} receiver
	*/
	removeObserver: function(key, target, method) {
		Ember.removeObserver(this, key, target, method);
	},

	/**
		Returns `true` if the object currently has observers registered for a
		particular key. You can use this method to potentially defer performing
		an expensive action until someone begins observing a particular property
		on the object.

		@method hasObserverFor
		@param {String} key Key to check
		@return {Boolean}
	*/
	hasObserverFor: function(key) {
		return Ember.hasListeners(this, key+':change');
	},

	/**
		Retrieves the value of a property, or a default value in the case that the
		property returns `undefined`.

		```javascript
		person.getWithDefault('lastName', 'Doe');
		```

		@method getWithDefault
		@param {String} keyName The name of the property to retrieve
		@param {Object} defaultValue The value to return if the property value is undefined
		@return {Object} The property value or the defaultValue.
	*/
	getWithDefault: function(keyName, defaultValue) {
		return Ember.getWithDefault(this, keyName, defaultValue);
	},

	/**
		Set the value of a property to the current value plus some amount.

		```javascript
		person.incrementProperty('age');
		team.incrementProperty('score', 2);
		```

		@method incrementProperty
		@param {String} keyName The name of the property to increment
		@param {Number} increment The amount to increment by. Defaults to 1
		@return {Number} The new property value
	*/
	incrementProperty: function(keyName, increment) {
		if (Ember.isNone(increment)) { increment = 1; }
				set(this, keyName, (get(this, keyName) || 0) + increment);
		return get(this, keyName);
	},

	/**
		Set the value of a property to the current value minus some amount.

		```javascript
		player.decrementProperty('lives');
		orc.decrementProperty('health', 5);
		```

		@method decrementProperty
		@param {String} keyName The name of the property to decrement
		@param {Number} decrement The amount to decrement by. Defaults to 1
		@return {Number} The new property value
	*/
	decrementProperty: function(keyName, decrement) {
		if (Ember.isNone(decrement)) { decrement = 1; }
				set(this, keyName, (get(this, keyName) || 0) - decrement);
		return get(this, keyName);
	},

	/**
		Set the value of a boolean property to the opposite of it's
		current value.

		```javascript
		starship.toggleProperty('warpDriveEngaged');
		```

		@method toggleProperty
		@param {String} keyName The name of the property to toggle
		@return {Object} The new property value
	*/
	toggleProperty: function(keyName) {
		set(this, keyName, !get(this, keyName));
		return get(this, keyName);
	},

	/**
		Returns the cached value of a computed property, if it exists.
		This allows you to inspect the value of a computed property
		without accidentally invoking it if it is intended to be
		generated lazily.

		@method cacheFor
		@param {String} keyName
		@return {Object} The cached value of the computed property, if any
	*/
	cacheFor: function(keyName) {
		return Ember.cacheFor(this, keyName);
	},

	// intended for debugging purposes
	observersForKey: function(keyName) {
		return Ember.observersFor(this, keyName);
	}
});

})();



(function() {
/**
	@module ember
	@submodule ember-runtime
*/


// NOTE: this object should never be included directly. Instead use `Ember.Object`.
// We only define this separately so that `Ember.Set` can depend on it.


var set = Ember.set, get = Ember.get,
		o_create = Ember.create,
		o_defineProperty = Ember.platform.defineProperty,
		GUID_KEY = Ember.GUID_KEY,
		guidFor = Ember.guidFor,
		generateGuid = Ember.generateGuid,
		meta = Ember.meta,
		META_KEY = Ember.META_KEY,
		rewatch = Ember.rewatch,
		finishChains = Ember.finishChains,
		sendEvent = Ember.sendEvent,
		destroy = Ember.destroy,
		schedule = Ember.run.schedule,
		Mixin = Ember.Mixin,
		applyMixin = Mixin._apply,
		finishPartial = Mixin.finishPartial,
		reopen = Mixin.prototype.reopen,
		MANDATORY_SETTER = Ember.ENV.MANDATORY_SETTER,
		indexOf = Ember.EnumerableUtils.indexOf;

var undefinedDescriptor = {
	configurable: true,
	writable: true,
	enumerable: false,
	value: undefined
};

function makeCtor() {

	// Note: avoid accessing any properties on the object since it makes the
	// method a lot faster. This is glue code so we want it to be as fast as
	// possible.

	var wasApplied = false, initMixins, initProperties;

	var Class = function() {
		if (!wasApplied) {
			Class.proto(); // prepare prototype...
		}
		o_defineProperty(this, GUID_KEY, undefinedDescriptor);
		o_defineProperty(this, '__nextSuper', undefinedDescriptor);
		var m = meta(this), proto = m.proto;
		m.proto = this;
		if (initMixins) {
			// capture locally so we can clear the closed over variable
			var mixins = initMixins;
			initMixins = null;
			this.reopen.apply(this, mixins);
		}
		if (initProperties) {
			// capture locally so we can clear the closed over variable
			var props = initProperties;
			initProperties = null;

			var concatenatedProperties = this.concatenatedProperties;

			for (var i = 0, l = props.length; i < l; i++) {
				var properties = props[i];


				if (typeof properties !== 'object' && properties !== undefined) {
					throw new Ember.Error("Ember.Object.create only accepts objects.");
				}

				if (!properties) { continue; }

				var keyNames = Ember.keys(properties);

				for (var j = 0, ll = keyNames.length; j < ll; j++) {
					var keyName = keyNames[j];
					if (!properties.hasOwnProperty(keyName)) { continue; }

					var value = properties[keyName],
							IS_BINDING = Ember.IS_BINDING;

					if (IS_BINDING.test(keyName)) {
						var bindings = m.bindings;
						if (!bindings) {
							bindings = m.bindings = {};
						} else if (!m.hasOwnProperty('bindings')) {
							bindings = m.bindings = o_create(m.bindings);
						}
						bindings[keyName] = value;
					}

					var desc = m.descs[keyName];


					if (concatenatedProperties && indexOf(concatenatedProperties, keyName) >= 0) {
						var baseValue = this[keyName];

						if (baseValue) {
							if ('function' === typeof baseValue.concat) {
								value = baseValue.concat(value);
							} else {
								value = Ember.makeArray(baseValue).concat(value);
							}
						} else {
							value = Ember.makeArray(value);
						}
					}

					if (desc) {
						desc.set(this, keyName, value);
					} else {
						if (typeof this.setUnknownProperty === 'function' && !(keyName in this)) {
							this.setUnknownProperty(keyName, value);
						} else if (MANDATORY_SETTER) {
							Ember.defineProperty(this, keyName, null, value); // setup mandatory setter
						} else {
							this[keyName] = value;
						}
					}
				}
			}
		}
		finishPartial(this, m);
		this.init.apply(this, arguments);
		m.proto = proto;
		finishChains(this);
		sendEvent(this, "init");
	};

	Class.toString = Mixin.prototype.toString;
	Class.willReopen = function() {
		if (wasApplied) {
			Class.PrototypeMixin = Mixin.create(Class.PrototypeMixin);
		}

		wasApplied = false;
	};
	Class._initMixins = function(args) { initMixins = args; };
	Class._initProperties = function(args) { initProperties = args; };

	Class.proto = function() {
		var superclass = Class.superclass;
		if (superclass) { superclass.proto(); }

		if (!wasApplied) {
			wasApplied = true;
			Class.PrototypeMixin.applyPartial(Class.prototype);
			rewatch(Class.prototype);
		}

		return this.prototype;
	};

	return Class;

}

/**
	@class CoreObject
	@namespace Ember
*/
var CoreObject = makeCtor();
CoreObject.toString = function() { return "Ember.CoreObject"; };

CoreObject.PrototypeMixin = Mixin.create({
	reopen: function() {
		applyMixin(this, arguments, true);
		return this;
	},

	/**
		An overridable method called when objects are instantiated. By default,
		does nothing unless it is overridden during class definition.

		Example:

		```javascript
		App.Person = Ember.Object.extend({
			init: function() {
				alert('Name is ' + this.get('name'));
			}
		});

		var steve = App.Person.create({
			name: "Steve"
		});

		// alerts 'Name is Steve'.
		```

		NOTE: If you do override `init` for a framework class like `Ember.View` or
		`Ember.ArrayController`, be sure to call `this._super()` in your
		`init` declaration! If you don't, Ember may not have an opportunity to
		do important setup work, and you'll see strange behavior in your
		application.

		@method init
	*/
	init: function() {},

	/**
		Defines the properties that will be concatenated from the superclass
		(instead of overridden).

		By default, when you extend an Ember class a property defined in
		the subclass overrides a property with the same name that is defined
		in the superclass. However, there are some cases where it is preferable
		to build up a property's value by combining the superclass' property
		value with the subclass' value. An example of this in use within Ember
		is the `classNames` property of `Ember.View`.

		Here is some sample code showing the difference between a concatenated
		property and a normal one:

		```javascript
		App.BarView = Ember.View.extend({
			someNonConcatenatedProperty: ['bar'],
			classNames: ['bar']
		});

		App.FooBarView = App.BarView.extend({
			someNonConcatenatedProperty: ['foo'],
			classNames: ['foo'],
		});

		var fooBarView = App.FooBarView.create();
		fooBarView.get('someNonConcatenatedProperty'); // ['foo']
		fooBarView.get('classNames'); // ['ember-view', 'bar', 'foo']
		```

		This behavior extends to object creation as well. Continuing the
		above example:

		```javascript
		var view = App.FooBarView.create({
			someNonConcatenatedProperty: ['baz'],
			classNames: ['baz']
		})
		view.get('someNonConcatenatedProperty'); // ['baz']
		view.get('classNames'); // ['ember-view', 'bar', 'foo', 'baz']
		```
		Adding a single property that is not an array will just add it in the array:

		```javascript
		var view = App.FooBarView.create({
			classNames: 'baz'
		})
		view.get('classNames'); // ['ember-view', 'bar', 'foo', 'baz']
		```

		Using the `concatenatedProperties` property, we can tell to Ember that mix
		the content of the properties.

		In `Ember.View` the `classNameBindings` and `attributeBindings` properties
		are also concatenated, in addition to `classNames`.

		This feature is available for you to use throughout the Ember object model,
		although typical app developers are likely to use it infrequently. Since
		it changes expectations about behavior of properties, you should properly
		document its usage in each individual concatenated property (to not
		mislead your users to think they can override the property in a subclass).

		@property concatenatedProperties
		@type Array
		@default null
	*/
	concatenatedProperties: null,

	/**
		Destroyed object property flag.

		if this property is `true` the observers and bindings were already
		removed by the effect of calling the `destroy()` method.

		@property isDestroyed
		@default false
	*/
	isDestroyed: false,

	/**
		Destruction scheduled flag. The `destroy()` method has been called.

		The object stays intact until the end of the run loop at which point
		the `isDestroyed` flag is set.

		@property isDestroying
		@default false
	*/
	isDestroying: false,

	/**
		Destroys an object by setting the `isDestroyed` flag and removing its
		metadata, which effectively destroys observers and bindings.

		If you try to set a property on a destroyed object, an exception will be
		raised.

		Note that destruction is scheduled for the end of the run loop and does not
		happen immediately.  It will set an isDestroying flag immediately.

		@method destroy
		@return {Ember.Object} receiver
	*/
	destroy: function() {
		if (this.isDestroying) { return; }
		this.isDestroying = true;

		schedule('actions', this, this.willDestroy);
		schedule('destroy', this, this._scheduledDestroy);
		return this;
	},

	/**
		Override to implement teardown.

		@method willDestroy
	 */
	willDestroy: Ember.K,

	/**
		Invoked by the run loop to actually destroy the object. This is
		scheduled for execution by the `destroy` method.

		@private
		@method _scheduledDestroy
	*/
	_scheduledDestroy: function() {
		if (this.isDestroyed) { return; }
		destroy(this);
		this.isDestroyed = true;
	},

	bind: function(to, from) {
		if (!(from instanceof Ember.Binding)) { from = Ember.Binding.from(from); }
		from.to(to).connect(this);
		return from;
	},

	/**
		Returns a string representation which attempts to provide more information
		than Javascript's `toString` typically does, in a generic way for all Ember
		objects.

		```javascript
		App.Person = Em.Object.extend()
		person = App.Person.create()
		person.toString() //=> "<App.Person:ember1024>"
		```

		If the object's class is not defined on an Ember namespace, it will
		indicate it is a subclass of the registered superclass:

	 ```javascript
		Student = App.Person.extend()
		student = Student.create()
		student.toString() //=> "<(subclass of App.Person):ember1025>"
		```

		If the method `toStringExtension` is defined, its return value will be
		included in the output.

		```javascript
		App.Teacher = App.Person.extend({
			toStringExtension: function() {
				return this.get('fullName');
			}
		});
		teacher = App.Teacher.create()
		teacher.toString(); //=> "<App.Teacher:ember1026:Tom Dale>"
		```

		@method toString
		@return {String} string representation
	*/
	toString: function toString() {
		var hasToStringExtension = typeof this.toStringExtension === 'function',
				extension = hasToStringExtension ? ":" + this.toStringExtension() : '';
		var ret = '<'+this.constructor.toString()+':'+guidFor(this)+extension+'>';
		this.toString = makeToString(ret);
		return ret;
	}
});

CoreObject.PrototypeMixin.ownerConstructor = CoreObject;

function makeToString(ret) {
	return function() { return ret; };
}

if (Ember.config.overridePrototypeMixin) {
	Ember.config.overridePrototypeMixin(CoreObject.PrototypeMixin);
}

CoreObject.__super__ = null;

var ClassMixin = Mixin.create({

	ClassMixin: Ember.required(),

	PrototypeMixin: Ember.required(),

	isClass: true,

	isMethod: false,

	/**
		Creates a new subclass.

		```javascript
		App.Person = Ember.Object.extend({
			say: function(thing) {
				alert(thing);
			 }
		});
		```

		This defines a new subclass of Ember.Object: `App.Person`. It contains one method: `say()`.

		You can also create a subclass from any existing class by calling its `extend()`  method. For example, you might want to create a subclass of Ember's built-in `Ember.View` class:

		```javascript
		App.PersonView = Ember.View.extend({
			tagName: 'li',
			classNameBindings: ['isAdministrator']
		});
		```

		When defining a subclass, you can override methods but still access the implementation of your parent class by calling the special `_super()` method:

		```javascript
		App.Person = Ember.Object.extend({
			say: function(thing) {
				var name = this.get('name');
				alert(name + ' says: ' + thing);
			}
		});

		App.Soldier = App.Person.extend({
			say: function(thing) {
				this._super(thing + ", sir!");
			},
			march: function(numberOfHours) {
				alert(this.get('name') + ' marches for ' + numberOfHours + ' hours.')
			}
		});

		var yehuda = App.Soldier.create({
			name: "Yehuda Katz"
		});

		yehuda.say("Yes");  // alerts "Yehuda Katz says: Yes, sir!"
		```

		The `create()` on line #17 creates an *instance* of the `App.Soldier` class. The `extend()` on line #8 creates a *subclass* of `App.Person`. Any instance of the `App.Person` class will *not* have the `march()` method.

		You can also pass `Ember.Mixin` classes to add additional properties to the subclass.

		```javascript
		App.Person = Ember.Object.extend({
			say: function(thing) {
				alert(this.get('name') + ' says: ' + thing);
			}
		});

		App.SingingMixin = Ember.Mixin.create({
			sing: function(thing){
				alert(this.get('name') + ' sings: la la la ' + thing);
			}
		});

		App.BroadwayStar = App.Person.extend(App.SingingMixin, {
			dance: function() {
				alert(this.get('name') + ' dances: tap tap tap tap ');
			}
		});
		```

		The `App.BroadwayStar` class contains three methods: `say()`, `sing()`, and `dance()`.

		@method extend
		@static

		@param {Ember.Mixin} [mixins]* One or more Ember.Mixin classes
		@param {Object} [arguments]* Object containing values to use within the new class
	*/
	extend: function() {
		var Class = makeCtor(), proto;
		Class.ClassMixin = Mixin.create(this.ClassMixin);
		Class.PrototypeMixin = Mixin.create(this.PrototypeMixin);

		Class.ClassMixin.ownerConstructor = Class;
		Class.PrototypeMixin.ownerConstructor = Class;

		reopen.apply(Class.PrototypeMixin, arguments);

		Class.superclass = this;
		Class.__super__  = this.prototype;

		proto = Class.prototype = o_create(this.prototype);
		proto.constructor = Class;
		generateGuid(proto);
		meta(proto).proto = proto; // this will disable observers on prototype

		Class.ClassMixin.apply(Class);
		return Class;
	},

	/**
		Equivalent to doing `extend(arguments).create()`.
		If possible use the normal `create` method instead.

		@method createWithMixins
		@static
		@param [arguments]*
	*/
	createWithMixins: function() {
		var C = this;
		if (arguments.length>0) { this._initMixins(arguments); }
		return new C();
	},

	/**
		Creates an instance of a class. Accepts either no arguments, or an object
		containing values to initialize the newly instantiated object with.

		```javascript
		App.Person = Ember.Object.extend({
			helloWorld: function() {
				alert("Hi, my name is " + this.get('name'));
			}
		});

		var tom = App.Person.create({
			name: 'Tom Dale'
		});

		tom.helloWorld(); // alerts "Hi, my name is Tom Dale".
		```

		`create` will call the `init` function if defined during
		`Ember.AnyObject.extend`

		If no arguments are passed to `create`, it will not set values to the new
		instance during initialization:

		```javascript
		var noName = App.Person.create();
		noName.helloWorld(); // alerts undefined
		```

		NOTE: For performance reasons, you cannot declare methods or computed
		properties during `create`. You should instead declare methods and computed
		properties when using `extend` or use the `createWithMixins` shorthand.

		@method create
		@static
		@param [arguments]*
	*/
	create: function() {
		var C = this;
		if (arguments.length>0) { this._initProperties(arguments); }
		return new C();
	},

	/**
		Augments a constructor's prototype with additional
		properties and functions:

		```javascript
		MyObject = Ember.Object.extend({
			name: 'an object'
		});

		o = MyObject.create();
		o.get('name'); // 'an object'

		MyObject.reopen({
			say: function(msg){
				console.log(msg);
			}
		})

		o2 = MyObject.create();
		o2.say("hello"); // logs "hello"

		o.say("goodbye"); // logs "goodbye"
		```

		To add functions and properties to the constructor itself,
		see `reopenClass`

		@method reopen
	*/
	reopen: function() {
		this.willReopen();
		reopen.apply(this.PrototypeMixin, arguments);
		return this;
	},

	/**
		Augments a constructor's own properties and functions:

		```javascript
		MyObject = Ember.Object.extend({
			name: 'an object'
		});

		MyObject.reopenClass({
			canBuild: false
		});

		MyObject.canBuild; // false
		o = MyObject.create();
		```

		In other words, this creates static properties and functions for the class. These are only available on the class
		and not on any instance of that class.

		```javascript
		App.Person = Ember.Object.extend({
			name : "",
			sayHello : function(){
				alert("Hello. My name is " + this.get('name'));
			}
		});

		App.Person.reopenClass({
			species : "Homo sapiens",
			createPerson: function(newPersonsName){
				return App.Person.create({
					name:newPersonsName
				});
			}
		});

		var tom = App.Person.create({
			name : "Tom Dale"
		});
		var yehuda = App.Person.createPerson("Yehuda Katz");

		tom.sayHello(); // "Hello. My name is Tom Dale"
		yehuda.sayHello(); // "Hello. My name is Yehuda Katz"
		alert(App.Person.species); // "Homo sapiens"
		```

		Note that `species` and `createPerson` are *not* valid on the `tom` and `yehuda`
		variables. They are only valid on `App.Person`.

		To add functions and properties to instances of
		a constructor by extending the constructor's prototype
		see `reopen`

		@method reopenClass
	*/
	reopenClass: function() {
		reopen.apply(this.ClassMixin, arguments);
		applyMixin(this, arguments, false);
		return this;
	},

	detect: function(obj) {
		if ('function' !== typeof obj) { return false; }
		while(obj) {
			if (obj===this) { return true; }
			obj = obj.superclass;
		}
		return false;
	},

	detectInstance: function(obj) {
		return obj instanceof this;
	},

	/**
		In some cases, you may want to annotate computed properties with additional
		metadata about how they function or what values they operate on. For
		example, computed property functions may close over variables that are then
		no longer available for introspection.

		You can pass a hash of these values to a computed property like this:

		```javascript
		person: function() {
			var personId = this.get('personId');
			return App.Person.create({ id: personId });
		}.property().meta({ type: App.Person })
		```

		Once you've done this, you can retrieve the values saved to the computed
		property from your class like this:

		```javascript
		MyClass.metaForProperty('person');
		```

		This will return the original hash that was passed to `meta()`.

		@method metaForProperty
		@param key {String} property name
	*/
	metaForProperty: function(key) {
		var meta = this.proto()[META_KEY],
				desc = meta && meta.descs[key];

				return desc._meta || {};
	},

	/**
		Iterate over each computed property for the class, passing its name
		and any associated metadata (see `metaForProperty`) to the callback.

		@method eachComputedProperty
		@param {Function} callback
		@param {Object} binding
	*/
	eachComputedProperty: function(callback, binding) {
		var proto = this.proto(),
				descs = meta(proto).descs,
				empty = {},
				property;

		for (var name in descs) {
			property = descs[name];

			if (property instanceof Ember.ComputedProperty) {
				callback.call(binding || this, name, property._meta || empty);
			}
		}
	}

});

ClassMixin.ownerConstructor = CoreObject;

if (Ember.config.overrideClassMixin) {
	Ember.config.overrideClassMixin(ClassMixin);
}

CoreObject.ClassMixin = ClassMixin;
ClassMixin.apply(CoreObject);

Ember.CoreObject = CoreObject;

})();



(function() {
/**
@module ember
@submodule ember-runtime
*/

/**
	`Ember.Object` is the main base class for all Ember objects. It is a subclass
	of `Ember.CoreObject` with the `Ember.Observable` mixin applied. For details,
	see the documentation for each of these.

	@class Object
	@namespace Ember
	@extends Ember.CoreObject
	@uses Ember.Observable
*/
Ember.Object = Ember.CoreObject.extend(Ember.Observable);
Ember.Object.toString = function() { return "Ember.Object"; };

})();



(function() {
/**
@module ember
@submodule ember-runtime
*/

var get = Ember.get, indexOf = Ember.ArrayPolyfills.indexOf;

/**
	A Namespace is an object usually used to contain other objects or methods
	such as an application or framework. Create a namespace anytime you want
	to define one of these new containers.

	# Example Usage

	```javascript
	MyFramework = Ember.Namespace.create({
		VERSION: '1.0.0'
	});
	```

	@class Namespace
	@namespace Ember
	@extends Ember.Object
*/
var Namespace = Ember.Namespace = Ember.Object.extend({
	isNamespace: true,

	init: function() {
		Ember.Namespace.NAMESPACES.push(this);
		Ember.Namespace.PROCESSED = false;
	},

	toString: function() {
		var name = get(this, 'name');
		if (name) { return name; }

		findNamespaces();
		return this[Ember.GUID_KEY+'_name'];
	},

	nameClasses: function() {
		processNamespace([this.toString()], this, {});
	},

	destroy: function() {
		var namespaces = Ember.Namespace.NAMESPACES;
		Ember.lookup[this.toString()] = undefined;
		namespaces.splice(indexOf.call(namespaces, this), 1);
		this._super();
	}
});

Namespace.reopenClass({
	NAMESPACES: [Ember],
	NAMESPACES_BY_ID: {},
	PROCESSED: false,
	processAll: processAllNamespaces,
	byName: function(name) {
		if (!Ember.BOOTED) {
			processAllNamespaces();
		}

		return NAMESPACES_BY_ID[name];
	}
});

var NAMESPACES_BY_ID = Namespace.NAMESPACES_BY_ID;

var hasOwnProp = ({}).hasOwnProperty,
		guidFor = Ember.guidFor;

function processNamespace(paths, root, seen) {
	var idx = paths.length;

	NAMESPACES_BY_ID[paths.join('.')] = root;

	// Loop over all of the keys in the namespace, looking for classes
	for(var key in root) {
		if (!hasOwnProp.call(root, key)) { continue; }
		var obj = root[key];

		// If we are processing the `Ember` namespace, for example, the
		// `paths` will start with `["Ember"]`. Every iteration through
		// the loop will update the **second** element of this list with
		// the key, so processing `Ember.View` will make the Array
		// `['Ember', 'View']`.
		paths[idx] = key;

		// If we have found an unprocessed class
		if (obj && obj.toString === classToString) {
			// Replace the class' `toString` with the dot-separated path
			// and set its `NAME_KEY`
			obj.toString = makeToString(paths.join('.'));
			obj[NAME_KEY] = paths.join('.');

		// Support nested namespaces
		} else if (obj && obj.isNamespace) {
			// Skip aliased namespaces
			if (seen[guidFor(obj)]) { continue; }
			seen[guidFor(obj)] = true;

			// Process the child namespace
			processNamespace(paths, obj, seen);
		}
	}

	paths.length = idx; // cut out last item
}

function findNamespaces() {
	var Namespace = Ember.Namespace, lookup = Ember.lookup, obj, isNamespace;

	if (Namespace.PROCESSED) { return; }

	for (var prop in lookup) {
		// These don't raise exceptions but can cause warnings
		if (prop === "parent" || prop === "top" || prop === "frameElement" || prop === "webkitStorageInfo") { continue; }

		//  get(window.globalStorage, 'isNamespace') would try to read the storage for domain isNamespace and cause exception in Firefox.
		// globalStorage is a storage obsoleted by the WhatWG storage specification. See https://developer.mozilla.org/en/DOM/Storage#globalStorage
		if (prop === "globalStorage" && lookup.StorageList && lookup.globalStorage instanceof lookup.StorageList) { continue; }
		// Unfortunately, some versions of IE don't support window.hasOwnProperty
		if (lookup.hasOwnProperty && !lookup.hasOwnProperty(prop)) { continue; }

		// At times we are not allowed to access certain properties for security reasons.
		// There are also times where even if we can access them, we are not allowed to access their properties.
		try {
			obj = Ember.lookup[prop];
			isNamespace = obj && obj.isNamespace;
		} catch (e) {
			continue;
		}

		if (isNamespace) {
						obj[NAME_KEY] = prop;
		}
	}
}

var NAME_KEY = Ember.NAME_KEY = Ember.GUID_KEY + '_name';

function superClassString(mixin) {
	var superclass = mixin.superclass;
	if (superclass) {
		if (superclass[NAME_KEY]) { return superclass[NAME_KEY]; }
		else { return superClassString(superclass); }
	} else {
		return;
	}
}

function classToString() {
	if (!Ember.BOOTED && !this[NAME_KEY]) {
		processAllNamespaces();
	}

	var ret;

	if (this[NAME_KEY]) {
		ret = this[NAME_KEY];
	} else if (this._toString) {
		ret = this._toString;
	} else {
		var str = superClassString(this);
		if (str) {
			ret = "(subclass of " + str + ")";
		} else {
			ret = "(unknown mixin)";
		}
		this.toString = makeToString(ret);
	}

	return ret;
}

function processAllNamespaces() {
	var unprocessedNamespaces = !Namespace.PROCESSED,
			unprocessedMixins = Ember.anyUnprocessedMixins;

	if (unprocessedNamespaces) {
		findNamespaces();
		Namespace.PROCESSED = true;
	}

	if (unprocessedNamespaces || unprocessedMixins) {
		var namespaces = Namespace.NAMESPACES, namespace;
		for (var i=0, l=namespaces.length; i<l; i++) {
			namespace = namespaces[i];
			processNamespace([namespace.toString()], namespace, {});
		}

		Ember.anyUnprocessedMixins = false;
	}
}

function makeToString(ret) {
	return function() { return ret; };
}

Ember.Mixin.prototype.toString = classToString;

})();



(function() {
/**
@module ember
@submodule ember-runtime
*/

var get = Ember.get,
		set = Ember.set,
		fmt = Ember.String.fmt,
		addBeforeObserver = Ember.addBeforeObserver,
		addObserver = Ember.addObserver,
		removeBeforeObserver = Ember.removeBeforeObserver,
		removeObserver = Ember.removeObserver,
		propertyWillChange = Ember.propertyWillChange,
		propertyDidChange = Ember.propertyDidChange,
		meta = Ember.meta,
		defineProperty = Ember.defineProperty;

function contentPropertyWillChange(content, contentKey) {
	var key = contentKey.slice(8); // remove "content."
	if (key in this) { return; }  // if shadowed in proxy
	propertyWillChange(this, key);
}

function contentPropertyDidChange(content, contentKey) {
	var key = contentKey.slice(8); // remove "content."
	if (key in this) { return; } // if shadowed in proxy
	propertyDidChange(this, key);
}

/**
	`Ember.ObjectProxy` forwards all properties not defined by the proxy itself
	to a proxied `content` object.

	```javascript
	object = Ember.Object.create({
		name: 'Foo'
	});

	proxy = Ember.ObjectProxy.create({
		content: object
	});

	// Access and change existing properties
	proxy.get('name')          // 'Foo'
	proxy.set('name', 'Bar');
	object.get('name')         // 'Bar'

	// Create new 'description' property on `object`
	proxy.set('description', 'Foo is a whizboo baz');
	object.get('description')  // 'Foo is a whizboo baz'
	```

	While `content` is unset, setting a property to be delegated will throw an
	Error.

	```javascript
	proxy = Ember.ObjectProxy.create({
		content: null,
		flag: null
	});
	proxy.set('flag', true);
	proxy.get('flag');         // true
	proxy.get('foo');          // undefined
	proxy.set('foo', 'data');  // throws Error
	```

	Delegated properties can be bound to and will change when content is updated.

	Computed properties on the proxy itself can depend on delegated properties.

	```javascript
	ProxyWithComputedProperty = Ember.ObjectProxy.extend({
		fullName: function () {
			var firstName = this.get('firstName'),
					lastName = this.get('lastName');
			if (firstName && lastName) {
				return firstName + ' ' + lastName;
			}
			return firstName || lastName;
		}.property('firstName', 'lastName')
	});

	proxy = ProxyWithComputedProperty.create();

	proxy.get('fullName');  // undefined
	proxy.set('content', {
		firstName: 'Tom', lastName: 'Dale'
	}); // triggers property change for fullName on proxy

	proxy.get('fullName');  // 'Tom Dale'
	```

	@class ObjectProxy
	@namespace Ember
	@extends Ember.Object
*/
Ember.ObjectProxy = Ember.Object.extend({
	/**
		The object whose properties will be forwarded.

		@property content
		@type Ember.Object
		@default null
	*/
	content: null,
	_contentDidChange: Ember.observer('content', function() {
			}),

	isTruthy: Ember.computed.bool('content'),

	_debugContainerKey: null,

	willWatchProperty: function (key) {
		var contentKey = 'content.' + key;
		addBeforeObserver(this, contentKey, null, contentPropertyWillChange);
		addObserver(this, contentKey, null, contentPropertyDidChange);
	},

	didUnwatchProperty: function (key) {
		var contentKey = 'content.' + key;
		removeBeforeObserver(this, contentKey, null, contentPropertyWillChange);
		removeObserver(this, contentKey, null, contentPropertyDidChange);
	},

	unknownProperty: function (key) {
		var content = get(this, 'content');
		if (content) {
			return get(content, key);
		}
	},

	setUnknownProperty: function (key, value) {
		var m = meta(this);
		if (m.proto === this) {
			// if marked as prototype then just defineProperty
			// rather than delegate
			defineProperty(this, key, null, value);
			return value;
		}

		var content = get(this, 'content');
				return set(content, key, value);
	}

});

})();



(function() {
/**
@module ember
@submodule ember-runtime
*/

// ..........................................................
// HELPERS
//

var get = Ember.get, set = Ember.set;
var a_slice = Array.prototype.slice;
var a_indexOf = Ember.EnumerableUtils.indexOf;

var contexts = [];

function popCtx() {
	return contexts.length===0 ? {} : contexts.pop();
}

function pushCtx(ctx) {
	contexts.push(ctx);
	return null;
}

function iter(key, value) {
	var valueProvided = arguments.length === 2;

	function i(item) {
		var cur = get(item, key);
		return valueProvided ? value===cur : !!cur;
	}
	return i ;
}

/**
	This mixin defines the common interface implemented by enumerable objects
	in Ember. Most of these methods follow the standard Array iteration
	API defined up to JavaScript 1.8 (excluding language-specific features that
	cannot be emulated in older versions of JavaScript).

	This mixin is applied automatically to the Array class on page load, so you
	can use any of these methods on simple arrays. If Array already implements
	one of these methods, the mixin will not override them.

	## Writing Your Own Enumerable

	To make your own custom class enumerable, you need two items:

	1. You must have a length property. This property should change whenever
		 the number of items in your enumerable object changes. If you using this
		 with an `Ember.Object` subclass, you should be sure to change the length
		 property using `set().`

	2. You must implement `nextObject().` See documentation.

	Once you have these two methods implement, apply the `Ember.Enumerable` mixin
	to your class and you will be able to enumerate the contents of your object
	like any other collection.

	## Using Ember Enumeration with Other Libraries

	Many other libraries provide some kind of iterator or enumeration like
	facility. This is often where the most common API conflicts occur.
	Ember's API is designed to be as friendly as possible with other
	libraries by implementing only methods that mostly correspond to the
	JavaScript 1.8 API.

	@class Enumerable
	@namespace Ember
	@since Ember 0.9
*/
Ember.Enumerable = Ember.Mixin.create({

	/**
		Implement this method to make your class enumerable.

		This method will be call repeatedly during enumeration. The index value
		will always begin with 0 and increment monotonically. You don't have to
		rely on the index value to determine what object to return, but you should
		always check the value and start from the beginning when you see the
		requested index is 0.

		The `previousObject` is the object that was returned from the last call
		to `nextObject` for the current iteration. This is a useful way to
		manage iteration if you are tracing a linked list, for example.

		Finally the context parameter will always contain a hash you can use as
		a "scratchpad" to maintain any other state you need in order to iterate
		properly. The context object is reused and is not reset between
		iterations so make sure you setup the context with a fresh state whenever
		the index parameter is 0.

		Generally iterators will continue to call `nextObject` until the index
		reaches the your current length-1. If you run out of data before this
		time for some reason, you should simply return undefined.

		The default implementation of this method simply looks up the index.
		This works great on any Array-like objects.

		@method nextObject
		@param {Number} index the current index of the iteration
		@param {Object} previousObject the value returned by the last call to
			`nextObject`.
		@param {Object} context a context object you can use to maintain state.
		@return {Object} the next object in the iteration or undefined
	*/
	nextObject: Ember.required(Function),

	/**
		Helper method returns the first object from a collection. This is usually
		used by bindings and other parts of the framework to extract a single
		object if the enumerable contains only one item.

		If you override this method, you should implement it so that it will
		always return the same value each time it is called. If your enumerable
		contains only one object, this method should always return that object.
		If your enumerable is empty, this method should return `undefined`.

		```javascript
		var arr = ["a", "b", "c"];
		arr.get('firstObject');  // "a"

		var arr = [];
		arr.get('firstObject');  // undefined
		```

		@property firstObject
		@return {Object} the object or undefined
	*/
	firstObject: Ember.computed(function() {
		if (get(this, 'length')===0) return undefined ;

		// handle generic enumerables
		var context = popCtx(), ret;
		ret = this.nextObject(0, null, context);
		pushCtx(context);
		return ret ;
	}).property('[]'),

	/**
		Helper method returns the last object from a collection. If your enumerable
		contains only one object, this method should always return that object.
		If your enumerable is empty, this method should return `undefined`.

		```javascript
		var arr = ["a", "b", "c"];
		arr.get('lastObject');  // "c"

		var arr = [];
		arr.get('lastObject');  // undefined
		```

		@property lastObject
		@return {Object} the last object or undefined
	*/
	lastObject: Ember.computed(function() {
		var len = get(this, 'length');
		if (len===0) return undefined ;
		var context = popCtx(), idx=0, cur, last = null;
		do {
			last = cur;
			cur = this.nextObject(idx++, last, context);
		} while (cur !== undefined);
		pushCtx(context);
		return last;
	}).property('[]'),

	/**
		Returns `true` if the passed object can be found in the receiver. The
		default version will iterate through the enumerable until the object
		is found. You may want to override this with a more efficient version.

		```javascript
		var arr = ["a", "b", "c"];
		arr.contains("a"); // true
		arr.contains("z"); // false
		```

		@method contains
		@param {Object} obj The object to search for.
		@return {Boolean} `true` if object is found in enumerable.
	*/
	contains: function(obj) {
		return this.find(function(item) { return item===obj; }) !== undefined;
	},

	/**
		Iterates through the enumerable, calling the passed function on each
		item. This method corresponds to the `forEach()` method defined in
		JavaScript 1.6.

		The callback method you provide should have the following signature (all
		parameters are optional):

		```javascript
		function(item, index, enumerable);
		```

		- `item` is the current item in the iteration.
		- `index` is the current index in the iteration.
		- `enumerable` is the enumerable object itself.

		Note that in addition to a callback, you can also pass an optional target
		object that will be set as `this` on the context. This is a good way
		to give your iterator function access to the current object.

		@method forEach
		@param {Function} callback The callback to execute
		@param {Object} [target] The target object to use
		@return {Object} receiver
	*/
	forEach: function(callback, target) {
		if (typeof callback !== "function") throw new TypeError() ;
		var len = get(this, 'length'), last = null, context = popCtx();

		if (target === undefined) target = null;

		for(var idx=0;idx<len;idx++) {
			var next = this.nextObject(idx, last, context) ;
			callback.call(target, next, idx, this);
			last = next ;
		}
		last = null ;
		context = pushCtx(context);
		return this ;
	},

	/**
		Alias for `mapBy`

		@method getEach
		@param {String} key name of the property
		@return {Array} The mapped array.
	*/
	getEach: function(key) {
		return this.mapBy(key);
	},

	/**
		Sets the value on the named property for each member. This is more
		efficient than using other methods defined on this helper. If the object
		implements Ember.Observable, the value will be changed to `set(),` otherwise
		it will be set directly. `null` objects are skipped.

		@method setEach
		@param {String} key The key to set
		@param {Object} value The object to set
		@return {Object} receiver
	*/
	setEach: function(key, value) {
		return this.forEach(function(item) {
			set(item, key, value);
		});
	},

	/**
		Maps all of the items in the enumeration to another value, returning
		a new array. This method corresponds to `map()` defined in JavaScript 1.6.

		The callback method you provide should have the following signature (all
		parameters are optional):

		```javascript
		function(item, index, enumerable);
		```

		- `item` is the current item in the iteration.
		- `index` is the current index in the iteration.
		- `enumerable` is the enumerable object itself.

		It should return the mapped value.

		Note that in addition to a callback, you can also pass an optional target
		object that will be set as `this` on the context. This is a good way
		to give your iterator function access to the current object.

		@method map
		@param {Function} callback The callback to execute
		@param {Object} [target] The target object to use
		@return {Array} The mapped array.
	*/
	map: function(callback, target) {
		var ret = Ember.A();
		this.forEach(function(x, idx, i) {
			ret[idx] = callback.call(target, x, idx,i);
		});
		return ret ;
	},

	/**
		Similar to map, this specialized function returns the value of the named
		property on all items in the enumeration.

		@method mapBy
		@param {String} key name of the property
		@return {Array} The mapped array.
	*/
	mapBy: function(key) {
		return this.map(function(next) {
			return get(next, key);
		});
	},

	/**
		Similar to map, this specialized function returns the value of the named
		property on all items in the enumeration.

		@method mapProperty
		@param {String} key name of the property
		@return {Array} The mapped array.
		@deprecated Use `mapBy` instead
	*/

	mapProperty: Ember.aliasMethod('mapBy'),

	/**
		Returns an array with all of the items in the enumeration that the passed
		function returns true for. This method corresponds to `filter()` defined in
		JavaScript 1.6.

		The callback method you provide should have the following signature (all
		parameters are optional):

		```javascript
		function(item, index, enumerable);
		```

		- `item` is the current item in the iteration.
		- `index` is the current index in the iteration.
		- `enumerable` is the enumerable object itself.

		It should return the `true` to include the item in the results, `false`
		otherwise.

		Note that in addition to a callback, you can also pass an optional target
		object that will be set as `this` on the context. This is a good way
		to give your iterator function access to the current object.

		@method filter
		@param {Function} callback The callback to execute
		@param {Object} [target] The target object to use
		@return {Array} A filtered array.
	*/
	filter: function(callback, target) {
		var ret = Ember.A();
		this.forEach(function(x, idx, i) {
			if (callback.call(target, x, idx, i)) ret.push(x);
		});
		return ret ;
	},

	/**
		Returns an array with all of the items in the enumeration where the passed
		function returns false for. This method is the inverse of filter().

		The callback method you provide should have the following signature (all
		parameters are optional):

		```javascript
		function(item, index, enumerable);
		```

		- *item* is the current item in the iteration.
		- *index* is the current index in the iteration
		- *enumerable* is the enumerable object itself.

		It should return the a falsey value to include the item in the results.

		Note that in addition to a callback, you can also pass an optional target
		object that will be set as "this" on the context. This is a good way
		to give your iterator function access to the current object.

		@method reject
		@param {Function} callback The callback to execute
		@param {Object} [target] The target object to use
		@return {Array} A rejected array.
	 */
	reject: function(callback, target) {
		return this.filter(function() {
			return !(callback.apply(target, arguments));
		});
	},

	/**
		Returns an array with just the items with the matched property. You
		can pass an optional second argument with the target value. Otherwise
		this will match any property that evaluates to `true`.

		@method filterBy
		@param {String} key the property to test
		@param {String} [value] optional value to test against.
		@return {Array} filtered array
	*/
	filterBy: function(key, value) {
		return this.filter(iter.apply(this, arguments));
	},

	/**
		Returns an array with just the items with the matched property. You
		can pass an optional second argument with the target value. Otherwise
		this will match any property that evaluates to `true`.

		@method filterProperty
		@param {String} key the property to test
		@param {String} [value] optional value to test against.
		@return {Array} filtered array
		@deprecated Use `filterBy` instead
	*/
	filterProperty: Ember.aliasMethod('filterBy'),

	/**
		Returns an array with the items that do not have truthy values for
		key.  You can pass an optional second argument with the target value.  Otherwise
		this will match any property that evaluates to false.

		@method rejectBy
		@param {String} key the property to test
		@param {String} [value] optional value to test against.
		@return {Array} rejected array
	*/
	rejectBy: function(key, value) {
		var exactValue = function(item) { return get(item, key) === value; },
				hasValue = function(item) { return !!get(item, key); },
				use = (arguments.length === 2 ? exactValue : hasValue);

		return this.reject(use);
	},

	/**
		Returns an array with the items that do not have truthy values for
		key.  You can pass an optional second argument with the target value.  Otherwise
		this will match any property that evaluates to false.

		@method rejectProperty
		@param {String} key the property to test
		@param {String} [value] optional value to test against.
		@return {Array} rejected array
		@deprecated Use `rejectBy` instead
	*/
	rejectProperty: Ember.aliasMethod('rejectBy'),

	/**
		Returns the first item in the array for which the callback returns true.
		This method works similar to the `filter()` method defined in JavaScript 1.6
		except that it will stop working on the array once a match is found.

		The callback method you provide should have the following signature (all
		parameters are optional):

		```javascript
		function(item, index, enumerable);
		```

		- `item` is the current item in the iteration.
		- `index` is the current index in the iteration.
		- `enumerable` is the enumerable object itself.

		It should return the `true` to include the item in the results, `false`
		otherwise.

		Note that in addition to a callback, you can also pass an optional target
		object that will be set as `this` on the context. This is a good way
		to give your iterator function access to the current object.

		@method find
		@param {Function} callback The callback to execute
		@param {Object} [target] The target object to use
		@return {Object} Found item or `undefined`.
	*/
	find: function(callback, target) {
		var len = get(this, 'length') ;
		if (target === undefined) target = null;

		var last = null, next, found = false, ret ;
		var context = popCtx();
		for(var idx=0;idx<len && !found;idx++) {
			next = this.nextObject(idx, last, context) ;
			if (found = callback.call(target, next, idx, this)) ret = next ;
			last = next ;
		}
		next = last = null ;
		context = pushCtx(context);
		return ret ;
	},

	/**
		Returns the first item with a property matching the passed value. You
		can pass an optional second argument with the target value. Otherwise
		this will match any property that evaluates to `true`.

		This method works much like the more generic `find()` method.

		@method findBy
		@param {String} key the property to test
		@param {String} [value] optional value to test against.
		@return {Object} found item or `undefined`
	*/
	findBy: function(key, value) {
		return this.find(iter.apply(this, arguments));
	},

	/**
		Returns the first item with a property matching the passed value. You
		can pass an optional second argument with the target value. Otherwise
		this will match any property that evaluates to `true`.

		This method works much like the more generic `find()` method.

		@method findProperty
		@param {String} key the property to test
		@param {String} [value] optional value to test against.
		@return {Object} found item or `undefined`
		@deprecated Use `findBy` instead
	*/
	findProperty: Ember.aliasMethod('findBy'),

	/**
		Returns `true` if the passed function returns true for every item in the
		enumeration. This corresponds with the `every()` method in JavaScript 1.6.

		The callback method you provide should have the following signature (all
		parameters are optional):

		```javascript
		function(item, index, enumerable);
		```

		- `item` is the current item in the iteration.
		- `index` is the current index in the iteration.
		- `enumerable` is the enumerable object itself.

		It should return the `true` or `false`.

		Note that in addition to a callback, you can also pass an optional target
		object that will be set as `this` on the context. This is a good way
		to give your iterator function access to the current object.

		Example Usage:

		```javascript
		if (people.every(isEngineer)) { Paychecks.addBigBonus(); }
		```

		@method every
		@param {Function} callback The callback to execute
		@param {Object} [target] The target object to use
		@return {Boolean}
	*/
	every: function(callback, target) {
		return !this.find(function(x, idx, i) {
			return !callback.call(target, x, idx, i);
		});
	},

	/**
		@method everyBy
		@param {String} key the property to test
		@param {String} [value] optional value to test against.
		@deprecated Use `isEvery` instead
		@return {Boolean}
	*/
	everyBy: Ember.aliasMethod('isEvery'),

	/**
		@method everyProperty
		@param {String} key the property to test
		@param {String} [value] optional value to test against.
		@deprecated Use `isEvery` instead
		@return {Boolean}
	*/
	everyProperty: Ember.aliasMethod('isEvery'),

	/**
		Returns `true` if the passed property resolves to `true` for all items in
		the enumerable. This method is often simpler/faster than using a callback.

		@method isEvery
		@param {String} key the property to test
		@param {String} [value] optional value to test against.
		@return {Boolean}
	*/
	isEvery: function(key, value) {
		return this.every(iter.apply(this, arguments));
	},

	/**
		Returns `true` if the passed function returns true for any item in the
		enumeration. This corresponds with the `some()` method in JavaScript 1.6.

		The callback method you provide should have the following signature (all
		parameters are optional):

		```javascript
		function(item, index, enumerable);
		```

		- `item` is the current item in the iteration.
		- `index` is the current index in the iteration.
		- `enumerable` is the enumerable object itself.

		It should return the `true` to include the item in the results, `false`
		otherwise.

		Note that in addition to a callback, you can also pass an optional target
		object that will be set as `this` on the context. This is a good way
		to give your iterator function access to the current object.

		Usage Example:

		```javascript
		if (people.any(isManager)) { Paychecks.addBiggerBonus(); }
		```

		@method any
		@param {Function} callback The callback to execute
		@param {Object} [target] The target object to use
		@return {Boolean} `true` if the passed function returns `true` for any item
	*/
	any: function(callback, target) {
		var found = this.find(function(x, idx, i) {
			return !!callback.call(target, x, idx, i);
		});

		return typeof found !== 'undefined';
	},

	/**
		Returns `true` if the passed function returns true for any item in the
		enumeration. This corresponds with the `some()` method in JavaScript 1.6.

		The callback method you provide should have the following signature (all
		parameters are optional):

		```javascript
		function(item, index, enumerable);
		```

		- `item` is the current item in the iteration.
		- `index` is the current index in the iteration.
		- `enumerable` is the enumerable object itself.

		It should return the `true` to include the item in the results, `false`
		otherwise.

		Note that in addition to a callback, you can also pass an optional target
		object that will be set as `this` on the context. This is a good way
		to give your iterator function access to the current object.

		Usage Example:

		```javascript
		if (people.some(isManager)) { Paychecks.addBiggerBonus(); }
		```

		@method some
		@param {Function} callback The callback to execute
		@param {Object} [target] The target object to use
		@return {Boolean} `true` if the passed function returns `true` for any item
		@deprecated Use `any` instead
	*/
	some: Ember.aliasMethod('any'),

	/**
		Returns `true` if the passed property resolves to `true` for any item in
		the enumerable. This method is often simpler/faster than using a callback.

		@method isAny
		@param {String} key the property to test
		@param {String} [value] optional value to test against.
		@return {Boolean} `true` if the passed function returns `true` for any item
	*/
	isAny: function(key, value) {
		return this.any(iter.apply(this, arguments));
	},

	/**
		@method anyBy
		@param {String} key the property to test
		@param {String} [value] optional value to test against.
		@return {Boolean} `true` if the passed function returns `true` for any item
		@deprecated Use `isAny` instead
	*/
	anyBy: Ember.aliasMethod('isAny'),

	/**
		@method someProperty
		@param {String} key the property to test
		@param {String} [value] optional value to test against.
		@return {Boolean} `true` if the passed function returns `true` for any item
		@deprecated Use `isAny` instead
	*/
	someProperty: Ember.aliasMethod('isAny'),

	/**
		This will combine the values of the enumerator into a single value. It
		is a useful way to collect a summary value from an enumeration. This
		corresponds to the `reduce()` method defined in JavaScript 1.8.

		The callback method you provide should have the following signature (all
		parameters are optional):

		```javascript
		function(previousValue, item, index, enumerable);
		```

		- `previousValue` is the value returned by the last call to the iterator.
		- `item` is the current item in the iteration.
		- `index` is the current index in the iteration.
		- `enumerable` is the enumerable object itself.

		Return the new cumulative value.

		In addition to the callback you can also pass an `initialValue`. An error
		will be raised if you do not pass an initial value and the enumerator is
		empty.

		Note that unlike the other methods, this method does not allow you to
		pass a target object to set as this for the callback. It's part of the
		spec. Sorry.

		@method reduce
		@param {Function} callback The callback to execute
		@param {Object} initialValue Initial value for the reduce
		@param {String} reducerProperty internal use only.
		@return {Object} The reduced value.
	*/
	reduce: function(callback, initialValue, reducerProperty) {
		if (typeof callback !== "function") { throw new TypeError(); }

		var ret = initialValue;

		this.forEach(function(item, i) {
			ret = callback(ret, item, i, this, reducerProperty);
		}, this);

		return ret;
	},

	/**
		Invokes the named method on every object in the receiver that
		implements it. This method corresponds to the implementation in
		Prototype 1.6.

		@method invoke
		@param {String} methodName the name of the method
		@param {Object...} args optional arguments to pass as well.
		@return {Array} return values from calling invoke.
	*/
	invoke: function(methodName) {
		var args, ret = Ember.A();
		if (arguments.length>1) args = a_slice.call(arguments, 1);

		this.forEach(function(x, idx) {
			var method = x && x[methodName];
			if ('function' === typeof method) {
				ret[idx] = args ? method.apply(x, args) : x[methodName]();
			}
		}, this);

		return ret;
	},

	/**
		Simply converts the enumerable into a genuine array. The order is not
		guaranteed. Corresponds to the method implemented by Prototype.

		@method toArray
		@return {Array} the enumerable as an array.
	*/
	toArray: function() {
		var ret = Ember.A();
		this.forEach(function(o, idx) { ret[idx] = o; });
		return ret ;
	},

	/**
		Returns a copy of the array with all null and undefined elements removed.

		```javascript
		var arr = ["a", null, "c", undefined];
		arr.compact();  // ["a", "c"]
		```

		@method compact
		@return {Array} the array without null and undefined elements.
	*/
	compact: function() {
		return this.filter(function(value) { return value != null; });
	},

	/**
		Returns a new enumerable that excludes the passed value. The default
		implementation returns an array regardless of the receiver type unless
		the receiver does not contain the value.

		```javascript
		var arr = ["a", "b", "a", "c"];
		arr.without("a");  // ["b", "c"]
		```

		@method without
		@param {Object} value
		@return {Ember.Enumerable}
	*/
	without: function(value) {
		if (!this.contains(value)) return this; // nothing to do
		var ret = Ember.A();
		this.forEach(function(k) {
			if (k !== value) ret[ret.length] = k;
		}) ;
		return ret ;
	},

	/**
		Returns a new enumerable that contains only unique values. The default
		implementation returns an array regardless of the receiver type.

		```javascript
		var arr = ["a", "a", "b", "b"];
		arr.uniq();  // ["a", "b"]
		```

		@method uniq
		@return {Ember.Enumerable}
	*/
	uniq: function() {
		var ret = Ember.A();
		this.forEach(function(k) {
			if (a_indexOf(ret, k)<0) ret.push(k);
		});
		return ret;
	},

	/**
		This property will trigger anytime the enumerable's content changes.
		You can observe this property to be notified of changes to the enumerables
		content.

		For plain enumerables, this property is read only. `Ember.Array` overrides
		this method.

		@property []
		@type Ember.Array
		@return this
	*/
	'[]': Ember.computed(function(key, value) {
		return this;
	}),

	// ..........................................................
	// ENUMERABLE OBSERVERS
	//

	/**
		Registers an enumerable observer. Must implement `Ember.EnumerableObserver`
		mixin.

		@method addEnumerableObserver
		@param {Object} target
		@param {Hash} [opts]
		@return this
	*/
	addEnumerableObserver: function(target, opts) {
		var willChange = (opts && opts.willChange) || 'enumerableWillChange',
				didChange  = (opts && opts.didChange) || 'enumerableDidChange';

		var hasObservers = get(this, 'hasEnumerableObservers');
		if (!hasObservers) Ember.propertyWillChange(this, 'hasEnumerableObservers');
		Ember.addListener(this, '@enumerable:before', target, willChange);
		Ember.addListener(this, '@enumerable:change', target, didChange);
		if (!hasObservers) Ember.propertyDidChange(this, 'hasEnumerableObservers');
		return this;
	},

	/**
		Removes a registered enumerable observer.

		@method removeEnumerableObserver
		@param {Object} target
		@param {Hash} [opts]
		@return this
	*/
	removeEnumerableObserver: function(target, opts) {
		var willChange = (opts && opts.willChange) || 'enumerableWillChange',
				didChange  = (opts && opts.didChange) || 'enumerableDidChange';

		var hasObservers = get(this, 'hasEnumerableObservers');
		if (hasObservers) Ember.propertyWillChange(this, 'hasEnumerableObservers');
		Ember.removeListener(this, '@enumerable:before', target, willChange);
		Ember.removeListener(this, '@enumerable:change', target, didChange);
		if (hasObservers) Ember.propertyDidChange(this, 'hasEnumerableObservers');
		return this;
	},

	/**
		Becomes true whenever the array currently has observers watching changes
		on the array.

		@property hasEnumerableObservers
		@type Boolean
	*/
	hasEnumerableObservers: Ember.computed(function() {
		return Ember.hasListeners(this, '@enumerable:change') || Ember.hasListeners(this, '@enumerable:before');
	}),


	/**
		Invoke this method just before the contents of your enumerable will
		change. You can either omit the parameters completely or pass the objects
		to be removed or added if available or just a count.

		@method enumerableContentWillChange
		@param {Ember.Enumerable|Number} removing An enumerable of the objects to
			be removed or the number of items to be removed.
		@param {Ember.Enumerable|Number} adding An enumerable of the objects to be
			added or the number of items to be added.
		@chainable
	*/
	enumerableContentWillChange: function(removing, adding) {

		var removeCnt, addCnt, hasDelta;

		if ('number' === typeof removing) removeCnt = removing;
		else if (removing) removeCnt = get(removing, 'length');
		else removeCnt = removing = -1;

		if ('number' === typeof adding) addCnt = adding;
		else if (adding) addCnt = get(adding,'length');
		else addCnt = adding = -1;

		hasDelta = addCnt<0 || removeCnt<0 || addCnt-removeCnt!==0;

		if (removing === -1) removing = null;
		if (adding   === -1) adding   = null;

		Ember.propertyWillChange(this, '[]');
		if (hasDelta) Ember.propertyWillChange(this, 'length');
		Ember.sendEvent(this, '@enumerable:before', [this, removing, adding]);

		return this;
	},

	/**
		Invoke this method when the contents of your enumerable has changed.
		This will notify any observers watching for content changes. If your are
		implementing an ordered enumerable (such as an array), also pass the
		start and end values where the content changed so that it can be used to
		notify range observers.

		@method enumerableContentDidChange
		@param {Ember.Enumerable|Number} removing An enumerable of the objects to
			be removed or the number of items to be removed.
		@param {Ember.Enumerable|Number} adding  An enumerable of the objects to
			be added or the number of items to be added.
		@chainable
	*/
	enumerableContentDidChange: function(removing, adding) {
		var removeCnt, addCnt, hasDelta;

		if ('number' === typeof removing) removeCnt = removing;
		else if (removing) removeCnt = get(removing, 'length');
		else removeCnt = removing = -1;

		if ('number' === typeof adding) addCnt = adding;
		else if (adding) addCnt = get(adding, 'length');
		else addCnt = adding = -1;

		hasDelta = addCnt<0 || removeCnt<0 || addCnt-removeCnt!==0;

		if (removing === -1) removing = null;
		if (adding   === -1) adding   = null;

		Ember.sendEvent(this, '@enumerable:change', [this, removing, adding]);
		if (hasDelta) Ember.propertyDidChange(this, 'length');
		Ember.propertyDidChange(this, '[]');

		return this ;
	},

	/**
		Converts the enumerable into an array and sorts by the keys
		specified in the argument.

		You may provide multiple arguments to sort by multiple properties.

		@method sortBy
		@param {String} property name(s) to sort on
		@return {Array} The sorted array.
		*/
	sortBy: function() {
		var sortKeys = arguments;
		return this.toArray().sort(function(a, b){
			for(var i = 0; i < sortKeys.length; i++) {
				var key = sortKeys[i],
				propA = get(a, key),
				propB = get(b, key);
				// return 1 or -1 else continue to the next sortKey
				var compareValue = Ember.compare(propA, propB);
				if (compareValue) { return compareValue; }
			}
			return 0;
		});
	}
});

})();



(function() {
/**
@module ember
@submodule ember-runtime
*/

// ..........................................................
// HELPERS
//

var get = Ember.get, set = Ember.set, isNone = Ember.isNone, map = Ember.EnumerableUtils.map, cacheFor = Ember.cacheFor;

// ..........................................................
// ARRAY
//
/**
	This module implements Observer-friendly Array-like behavior. This mixin is
	picked up by the Array class as well as other controllers, etc. that want to
	appear to be arrays.

	Unlike `Ember.Enumerable,` this mixin defines methods specifically for
	collections that provide index-ordered access to their contents. When you
	are designing code that needs to accept any kind of Array-like object, you
	should use these methods instead of Array primitives because these will
	properly notify observers of changes to the array.

	Although these methods are efficient, they do add a layer of indirection to
	your application so it is a good idea to use them only when you need the
	flexibility of using both true JavaScript arrays and "virtual" arrays such
	as controllers and collections.

	You can use the methods defined in this module to access and modify array
	contents in a KVO-friendly way. You can also be notified whenever the
	membership of an array changes by changing the syntax of the property to
	`.observes('*myProperty.[]')`.

	To support `Ember.Array` in your own class, you must override two
	primitives to use it: `replace()` and `objectAt()`.

	Note that the Ember.Array mixin also incorporates the `Ember.Enumerable`
	mixin. All `Ember.Array`-like objects are also enumerable.

	@class Array
	@namespace Ember
	@uses Ember.Enumerable
	@since Ember 0.9.0
*/
Ember.Array = Ember.Mixin.create(Ember.Enumerable, {

	/**
		Your array must support the `length` property. Your replace methods should
		set this property whenever it changes.

		@property {Number} length
	*/
	length: Ember.required(),

	/**
		Returns the object at the given `index`. If the given `index` is negative
		or is greater or equal than the array length, returns `undefined`.

		This is one of the primitives you must implement to support `Ember.Array`.
		If your object supports retrieving the value of an array item using `get()`
		(i.e. `myArray.get(0)`), then you do not need to implement this method
		yourself.

		```javascript
		var arr = ['a', 'b', 'c', 'd'];
		arr.objectAt(0);   // "a"
		arr.objectAt(3);   // "d"
		arr.objectAt(-1);  // undefined
		arr.objectAt(4);   // undefined
		arr.objectAt(5);   // undefined
		```

		@method objectAt
		@param {Number} idx The index of the item to return.
		@return {*} item at index or undefined
	*/
	objectAt: function(idx) {
		if ((idx < 0) || (idx>=get(this, 'length'))) return undefined ;
		return get(this, idx);
	},

	/**
		This returns the objects at the specified indexes, using `objectAt`.

		```javascript
		var arr = ['a', 'b', 'c', 'd'];
		arr.objectsAt([0, 1, 2]);  // ["a", "b", "c"]
		arr.objectsAt([2, 3, 4]);  // ["c", "d", undefined]
		```

		@method objectsAt
		@param {Array} indexes An array of indexes of items to return.
		@return {Array}
	 */
	objectsAt: function(indexes) {
		var self = this;
		return map(indexes, function(idx) { return self.objectAt(idx); });
	},

	// overrides Ember.Enumerable version
	nextObject: function(idx) {
		return this.objectAt(idx);
	},

	/**
		This is the handler for the special array content property. If you get
		this property, it will return this. If you set this property it a new
		array, it will replace the current content.

		This property overrides the default property defined in `Ember.Enumerable`.

		@property []
		@return this
	*/
	'[]': Ember.computed(function(key, value) {
		if (value !== undefined) this.replace(0, get(this, 'length'), value) ;
		return this ;
	}),

	firstObject: Ember.computed(function() {
		return this.objectAt(0);
	}),

	lastObject: Ember.computed(function() {
		return this.objectAt(get(this, 'length')-1);
	}),

	// optimized version from Enumerable
	contains: function(obj) {
		return this.indexOf(obj) >= 0;
	},

	// Add any extra methods to Ember.Array that are native to the built-in Array.
	/**
		Returns a new array that is a slice of the receiver. This implementation
		uses the observable array methods to retrieve the objects for the new
		slice.

		```javascript
		var arr = ['red', 'green', 'blue'];
		arr.slice(0);       // ['red', 'green', 'blue']
		arr.slice(0, 2);    // ['red', 'green']
		arr.slice(1, 100);  // ['green', 'blue']
		```

		@method slice
		@param {Integer} beginIndex (Optional) index to begin slicing from.
		@param {Integer} endIndex (Optional) index to end the slice at (but not included).
		@return {Array} New array with specified slice
	*/
	slice: function(beginIndex, endIndex) {
		var ret = Ember.A();
		var length = get(this, 'length') ;
		if (isNone(beginIndex)) beginIndex = 0 ;
		if (isNone(endIndex) || (endIndex > length)) endIndex = length ;

		if (beginIndex < 0) beginIndex = length + beginIndex;
		if (endIndex < 0) endIndex = length + endIndex;

		while(beginIndex < endIndex) {
			ret[ret.length] = this.objectAt(beginIndex++) ;
		}
		return ret ;
	},

	/**
		Returns the index of the given object's first occurrence.
		If no `startAt` argument is given, the starting location to
		search is 0. If it's negative, will count backward from
		the end of the array. Returns -1 if no match is found.

		```javascript
		var arr = ["a", "b", "c", "d", "a"];
		arr.indexOf("a");       //  0
		arr.indexOf("z");       // -1
		arr.indexOf("a", 2);    //  4
		arr.indexOf("a", -1);   //  4
		arr.indexOf("b", 3);    // -1
		arr.indexOf("a", 100);  // -1
		```

		@method indexOf
		@param {Object} object the item to search for
		@param {Number} startAt optional starting location to search, default 0
		@return {Number} index or -1 if not found
	*/
	indexOf: function(object, startAt) {
		var idx, len = get(this, 'length');

		if (startAt === undefined) startAt = 0;
		if (startAt < 0) startAt += len;

		for(idx=startAt;idx<len;idx++) {
			if (this.objectAt(idx) === object) return idx ;
		}
		return -1;
	},

	/**
		Returns the index of the given object's last occurrence.
		If no `startAt` argument is given, the search starts from
		the last position. If it's negative, will count backward
		from the end of the array. Returns -1 if no match is found.

		```javascript
		var arr = ["a", "b", "c", "d", "a"];
		arr.lastIndexOf("a");       //  4
		arr.lastIndexOf("z");       // -1
		arr.lastIndexOf("a", 2);    //  0
		arr.lastIndexOf("a", -1);   //  4
		arr.lastIndexOf("b", 3);    //  1
		arr.lastIndexOf("a", 100);  //  4
		```

		@method lastIndexOf
		@param {Object} object the item to search for
		@param {Number} startAt optional starting location to search, default 0
		@return {Number} index or -1 if not found
	*/
	lastIndexOf: function(object, startAt) {
		var idx, len = get(this, 'length');

		if (startAt === undefined || startAt >= len) startAt = len-1;
		if (startAt < 0) startAt += len;

		for(idx=startAt;idx>=0;idx--) {
			if (this.objectAt(idx) === object) return idx ;
		}
		return -1;
	},

	// ..........................................................
	// ARRAY OBSERVERS
	//

	/**
		Adds an array observer to the receiving array. The array observer object
		normally must implement two methods:

		* `arrayWillChange(observedObj, start, removeCount, addCount)` - This method will be
			called just before the array is modified.
		* `arrayDidChange(observedObj, start, removeCount, addCount)` - This method will be
			called just after the array is modified.

		Both callbacks will be passed the observed object, starting index of the
		change as well a a count of the items to be removed and added. You can use
		these callbacks to optionally inspect the array during the change, clear
		caches, or do any other bookkeeping necessary.

		In addition to passing a target, you can also include an options hash
		which you can use to override the method names that will be invoked on the
		target.

		@method addArrayObserver
		@param {Object} target The observer object.
		@param {Hash} opts Optional hash of configuration options including
			`willChange` and `didChange` option.
		@return {Ember.Array} receiver
	*/
	addArrayObserver: function(target, opts) {
		var willChange = (opts && opts.willChange) || 'arrayWillChange',
				didChange  = (opts && opts.didChange) || 'arrayDidChange';

		var hasObservers = get(this, 'hasArrayObservers');
		if (!hasObservers) Ember.propertyWillChange(this, 'hasArrayObservers');
		Ember.addListener(this, '@array:before', target, willChange);
		Ember.addListener(this, '@array:change', target, didChange);
		if (!hasObservers) Ember.propertyDidChange(this, 'hasArrayObservers');
		return this;
	},

	/**
		Removes an array observer from the object if the observer is current
		registered. Calling this method multiple times with the same object will
		have no effect.

		@method removeArrayObserver
		@param {Object} target The object observing the array.
		@param {Hash} opts Optional hash of configuration options including
			`willChange` and `didChange` option.
		@return {Ember.Array} receiver
	*/
	removeArrayObserver: function(target, opts) {
		var willChange = (opts && opts.willChange) || 'arrayWillChange',
				didChange  = (opts && opts.didChange) || 'arrayDidChange';

		var hasObservers = get(this, 'hasArrayObservers');
		if (hasObservers) Ember.propertyWillChange(this, 'hasArrayObservers');
		Ember.removeListener(this, '@array:before', target, willChange);
		Ember.removeListener(this, '@array:change', target, didChange);
		if (hasObservers) Ember.propertyDidChange(this, 'hasArrayObservers');
		return this;
	},

	/**
		Becomes true whenever the array currently has observers watching changes
		on the array.

		@property {Boolean} hasArrayObservers
	*/
	hasArrayObservers: Ember.computed(function() {
		return Ember.hasListeners(this, '@array:change') || Ember.hasListeners(this, '@array:before');
	}),

	/**
		If you are implementing an object that supports `Ember.Array`, call this
		method just before the array content changes to notify any observers and
		invalidate any related properties. Pass the starting index of the change
		as well as a delta of the amounts to change.

		@method arrayContentWillChange
		@param {Number} startIdx The starting index in the array that will change.
		@param {Number} removeAmt The number of items that will be removed. If you
			pass `null` assumes 0
		@param {Number} addAmt The number of items that will be added. If you
			pass `null` assumes 0.
		@return {Ember.Array} receiver
	*/
	arrayContentWillChange: function(startIdx, removeAmt, addAmt) {

		// if no args are passed assume everything changes
		if (startIdx===undefined) {
			startIdx = 0;
			removeAmt = addAmt = -1;
		} else {
			if (removeAmt === undefined) removeAmt=-1;
			if (addAmt    === undefined) addAmt=-1;
		}

		// Make sure the @each proxy is set up if anyone is observing @each
		if (Ember.isWatching(this, '@each')) { get(this, '@each'); }

		Ember.sendEvent(this, '@array:before', [this, startIdx, removeAmt, addAmt]);

		var removing, lim;
		if (startIdx>=0 && removeAmt>=0 && get(this, 'hasEnumerableObservers')) {
			removing = [];
			lim = startIdx+removeAmt;
			for(var idx=startIdx;idx<lim;idx++) removing.push(this.objectAt(idx));
		} else {
			removing = removeAmt;
		}

		this.enumerableContentWillChange(removing, addAmt);

		return this;
	},

	/**
		If you are implementing an object that supports `Ember.Array`, call this
		method just after the array content changes to notify any observers and
		invalidate any related properties. Pass the starting index of the change
		as well as a delta of the amounts to change.

		@method arrayContentDidChange
		@param {Number} startIdx The starting index in the array that did change.
		@param {Number} removeAmt The number of items that were removed. If you
			pass `null` assumes 0
		@param {Number} addAmt The number of items that were added. If you
			pass `null` assumes 0.
		@return {Ember.Array} receiver
	*/
	arrayContentDidChange: function(startIdx, removeAmt, addAmt) {

		// if no args are passed assume everything changes
		if (startIdx===undefined) {
			startIdx = 0;
			removeAmt = addAmt = -1;
		} else {
			if (removeAmt === undefined) removeAmt=-1;
			if (addAmt    === undefined) addAmt=-1;
		}

		var adding, lim;
		if (startIdx>=0 && addAmt>=0 && get(this, 'hasEnumerableObservers')) {
			adding = [];
			lim = startIdx+addAmt;
			for(var idx=startIdx;idx<lim;idx++) adding.push(this.objectAt(idx));
		} else {
			adding = addAmt;
		}

		this.enumerableContentDidChange(removeAmt, adding);
		Ember.sendEvent(this, '@array:change', [this, startIdx, removeAmt, addAmt]);

		var length      = get(this, 'length'),
				cachedFirst = cacheFor(this, 'firstObject'),
				cachedLast  = cacheFor(this, 'lastObject');
		if (this.objectAt(0) !== cachedFirst) {
			Ember.propertyWillChange(this, 'firstObject');
			Ember.propertyDidChange(this, 'firstObject');
		}
		if (this.objectAt(length-1) !== cachedLast) {
			Ember.propertyWillChange(this, 'lastObject');
			Ember.propertyDidChange(this, 'lastObject');
		}

		return this;
	},

	// ..........................................................
	// ENUMERATED PROPERTIES
	//

	/**
		Returns a special object that can be used to observe individual properties
		on the array. Just get an equivalent property on this object and it will
		return an enumerable that maps automatically to the named key on the
		member objects.

		If you merely want to watch for any items being added or removed to the array,
		use the `[]` property instead of `@each`.

		@property @each
	*/
	'@each': Ember.computed(function() {
		if (!this.__each) this.__each = new Ember.EachProxy(this);
		return this.__each;
	})

}) ;

})();



(function() {
var e_get = Ember.get,
		set = Ember.set,
		guidFor = Ember.guidFor,
		metaFor = Ember.meta,
		propertyWillChange = Ember.propertyWillChange,
		propertyDidChange = Ember.propertyDidChange,
		addBeforeObserver = Ember.addBeforeObserver,
		removeBeforeObserver = Ember.removeBeforeObserver,
		addObserver = Ember.addObserver,
		removeObserver = Ember.removeObserver,
		ComputedProperty = Ember.ComputedProperty,
		a_slice = [].slice,
		o_create = Ember.create,
		forEach = Ember.EnumerableUtils.forEach,
		// Here we explicitly don't allow `@each.foo`; it would require some special
		// testing, but there's no particular reason why it should be disallowed.
		eachPropertyPattern = /^(.*)\.@each\.(.*)/,
		doubleEachPropertyPattern = /(.*\.@each){2,}/,
		arrayBracketPattern = /\.\[\]$/;


	var expandProperties = Ember.expandProperties;


function get(obj, key) {
	if (key === '@this') {
		return obj;
	}

	return e_get(obj, key);
}

/*
	Tracks changes to dependent arrays, as well as to properties of items in
	dependent arrays.

	@class DependentArraysObserver
*/
function DependentArraysObserver(callbacks, cp, instanceMeta, context, propertyName, sugarMeta) {
	// user specified callbacks for `addedItem` and `removedItem`
	this.callbacks = callbacks;

	// the computed property: remember these are shared across instances
	this.cp = cp;

	// the ReduceComputedPropertyInstanceMeta this DependentArraysObserver is
	// associated with
	this.instanceMeta = instanceMeta;

	// A map of array guids to dependentKeys, for the given context.  We track
	// this because we want to set up the computed property potentially before the
	// dependent array even exists, but when the array observer fires, we lack
	// enough context to know what to update: we can recover that context by
	// getting the dependentKey.
	this.dependentKeysByGuid = {};

	// a map of dependent array guids -> Ember.TrackedArray instances.  We use
	// this to lazily recompute indexes for item property observers.
	this.trackedArraysByGuid = {};

	// We suspend observers to ignore replacements from `reset` when totally
	// recomputing.  Unfortunately we cannot properly suspend the observers
	// because we only have the key; instead we make the observers no-ops
	this.suspended = false;

	// This is used to coalesce item changes from property observers.
	this.changedItems = {};
}

function ItemPropertyObserverContext (dependentArray, index, trackedArray) {

	this.dependentArray = dependentArray;
	this.index = index;
	this.item = dependentArray.objectAt(index);
	this.trackedArray = trackedArray;
	this.beforeObserver = null;
	this.observer = null;

	this.destroyed = false;
}

DependentArraysObserver.prototype = {
	setValue: function (newValue) {
		this.instanceMeta.setValue(newValue, true);
	},
	getValue: function () {
		return this.instanceMeta.getValue();
	},

	setupObservers: function (dependentArray, dependentKey) {

		this.dependentKeysByGuid[guidFor(dependentArray)] = dependentKey;

		dependentArray.addArrayObserver(this, {
			willChange: 'dependentArrayWillChange',
			didChange: 'dependentArrayDidChange'
		});

		if (this.cp._itemPropertyKeys[dependentKey]) {
			this.setupPropertyObservers(dependentKey, this.cp._itemPropertyKeys[dependentKey]);
		}
	},

	teardownObservers: function (dependentArray, dependentKey) {
		var itemPropertyKeys = this.cp._itemPropertyKeys[dependentKey] || [];

		delete this.dependentKeysByGuid[guidFor(dependentArray)];

		this.teardownPropertyObservers(dependentKey, itemPropertyKeys);

		dependentArray.removeArrayObserver(this, {
			willChange: 'dependentArrayWillChange',
			didChange: 'dependentArrayDidChange'
		});
	},

	suspendArrayObservers: function (callback, binding) {
		var oldSuspended = this.suspended;
		this.suspended = true;
		callback.call(binding);
		this.suspended = oldSuspended;
	},

	setupPropertyObservers: function (dependentKey, itemPropertyKeys) {
		var dependentArray = get(this.instanceMeta.context, dependentKey),
				length = get(dependentArray, 'length'),
				observerContexts = new Array(length);

		this.resetTransformations(dependentKey, observerContexts);

		forEach(dependentArray, function (item, index) {
			var observerContext = this.createPropertyObserverContext(dependentArray, index, this.trackedArraysByGuid[dependentKey]);
			observerContexts[index] = observerContext;

			forEach(itemPropertyKeys, function (propertyKey) {
				addBeforeObserver(item, propertyKey, this, observerContext.beforeObserver);
				addObserver(item, propertyKey, this, observerContext.observer);
			}, this);
		}, this);
	},

	teardownPropertyObservers: function (dependentKey, itemPropertyKeys) {
		var dependentArrayObserver = this,
				trackedArray = this.trackedArraysByGuid[dependentKey],
				beforeObserver,
				observer,
				item;

		if (!trackedArray) { return; }

		trackedArray.apply(function (observerContexts, offset, operation) {
			if (operation === Ember.TrackedArray.DELETE) { return; }

			forEach(observerContexts, function (observerContext) {
				observerContext.destroyed = true;
				beforeObserver = observerContext.beforeObserver;
				observer = observerContext.observer;
				item = observerContext.item;

				forEach(itemPropertyKeys, function (propertyKey) {
					removeBeforeObserver(item, propertyKey, dependentArrayObserver, beforeObserver);
					removeObserver(item, propertyKey, dependentArrayObserver, observer);
				});
			});
		});
	},

	createPropertyObserverContext: function (dependentArray, index, trackedArray) {
		var observerContext = new ItemPropertyObserverContext(dependentArray, index, trackedArray);

		this.createPropertyObserver(observerContext);

		return observerContext;
	},

	createPropertyObserver: function (observerContext) {
		var dependentArrayObserver = this;

		observerContext.beforeObserver = function (obj, keyName) {
			return dependentArrayObserver.itemPropertyWillChange(obj, keyName, observerContext.dependentArray, observerContext);
		};
		observerContext.observer = function (obj, keyName) {
			return dependentArrayObserver.itemPropertyDidChange(obj, keyName, observerContext.dependentArray, observerContext);
		};
	},

	resetTransformations: function (dependentKey, observerContexts) {
		this.trackedArraysByGuid[dependentKey] = new Ember.TrackedArray(observerContexts);
	},

	trackAdd: function (dependentKey, index, newItems) {
		var trackedArray = this.trackedArraysByGuid[dependentKey];
		if (trackedArray) {
			trackedArray.addItems(index, newItems);
		}
	},

	trackRemove: function (dependentKey, index, removedCount) {
		var trackedArray = this.trackedArraysByGuid[dependentKey];

		if (trackedArray) {
			return trackedArray.removeItems(index, removedCount);
		}

		return [];
	},

	updateIndexes: function (trackedArray, array) {
		var length = get(array, 'length');
		// OPTIMIZE: we could stop updating once we hit the object whose observer
		// fired; ie partially apply the transformations
		trackedArray.apply(function (observerContexts, offset, operation) {
			// we don't even have observer contexts for removed items, even if we did,
			// they no longer have any index in the array
			if (operation === Ember.TrackedArray.DELETE) { return; }
			if (operation === Ember.TrackedArray.RETAIN && observerContexts.length === length && offset === 0) {
				// If we update many items we don't want to walk the array each time: we
				// only need to update the indexes at most once per run loop.
				return;
			}

			forEach(observerContexts, function (context, index) {
				context.index = index + offset;
			});
		});
	},

	dependentArrayWillChange: function (dependentArray, index, removedCount, addedCount) {
		if (this.suspended) { return; }

		var removedItem = this.callbacks.removedItem,
				changeMeta,
				guid = guidFor(dependentArray),
				dependentKey = this.dependentKeysByGuid[guid],
				itemPropertyKeys = this.cp._itemPropertyKeys[dependentKey] || [],
				length = get(dependentArray, 'length'),
				normalizedIndex = normalizeIndex(index, length, 0),
				normalizedRemoveCount = normalizeRemoveCount(normalizedIndex, length, removedCount),
				item,
				itemIndex,
				sliceIndex,
				observerContexts;

		observerContexts = this.trackRemove(dependentKey, normalizedIndex, normalizedRemoveCount);

		function removeObservers(propertyKey) {
			observerContexts[sliceIndex].destroyed = true;
			removeBeforeObserver(item, propertyKey, this, observerContexts[sliceIndex].beforeObserver);
			removeObserver(item, propertyKey, this, observerContexts[sliceIndex].observer);
		}

		for (sliceIndex = normalizedRemoveCount - 1; sliceIndex >= 0; --sliceIndex) {
			itemIndex = normalizedIndex + sliceIndex;
			if (itemIndex >= length) { break; }

			item = dependentArray.objectAt(itemIndex);

			forEach(itemPropertyKeys, removeObservers, this);

			changeMeta = createChangeMeta(dependentArray, item, itemIndex, this.instanceMeta.propertyName, this.cp);
			this.setValue( removedItem.call(
				this.instanceMeta.context, this.getValue(), item, changeMeta, this.instanceMeta.sugarMeta));
		}
	},

	dependentArrayDidChange: function (dependentArray, index, removedCount, addedCount) {
		if (this.suspended) { return; }

		var addedItem = this.callbacks.addedItem,
				guid = guidFor(dependentArray),
				dependentKey = this.dependentKeysByGuid[guid],
				observerContexts = new Array(addedCount),
				itemPropertyKeys = this.cp._itemPropertyKeys[dependentKey],
				length = get(dependentArray, 'length'),
				normalizedIndex = normalizeIndex(index, length, addedCount),
				changeMeta,
				observerContext;

		forEach(dependentArray.slice(normalizedIndex, normalizedIndex + addedCount), function (item, sliceIndex) {
			if (itemPropertyKeys) {
				observerContext =
					observerContexts[sliceIndex] =
					this.createPropertyObserverContext(dependentArray, normalizedIndex + sliceIndex, this.trackedArraysByGuid[dependentKey]);
				forEach(itemPropertyKeys, function (propertyKey) {
					addBeforeObserver(item, propertyKey, this, observerContext.beforeObserver);
					addObserver(item, propertyKey, this, observerContext.observer);
				}, this);
			}

			changeMeta = createChangeMeta(dependentArray, item, normalizedIndex + sliceIndex, this.instanceMeta.propertyName, this.cp);
			this.setValue( addedItem.call(
				this.instanceMeta.context, this.getValue(), item, changeMeta, this.instanceMeta.sugarMeta));
		}, this);

		this.trackAdd(dependentKey, normalizedIndex, observerContexts);
	},

	itemPropertyWillChange: function (obj, keyName, array, observerContext) {
		var guid = guidFor(obj);

		if (!this.changedItems[guid]) {
			this.changedItems[guid] = {
				array:            array,
				observerContext:  observerContext,
				obj:              obj,
				previousValues:   {}
			};
		}

		this.changedItems[guid].previousValues[keyName] = get(obj, keyName);
	},

	itemPropertyDidChange: function(obj, keyName, array, observerContext) {
		this.flushChanges();
	},

	flushChanges: function() {
		var changedItems = this.changedItems, key, c, changeMeta;

		for (key in changedItems) {
			c = changedItems[key];
			if (c.observerContext.destroyed) { continue; }

			this.updateIndexes(c.observerContext.trackedArray, c.observerContext.dependentArray);

			changeMeta = createChangeMeta(c.array, c.obj, c.observerContext.index, this.instanceMeta.propertyName, this.cp, c.previousValues);
			this.setValue(
				this.callbacks.removedItem.call(this.instanceMeta.context, this.getValue(), c.obj, changeMeta, this.instanceMeta.sugarMeta));
			this.setValue(
				this.callbacks.addedItem.call(this.instanceMeta.context, this.getValue(), c.obj, changeMeta, this.instanceMeta.sugarMeta));
		}
		this.changedItems = {};
	}
};

function normalizeIndex(index, length, newItemsOffset) {
	if (index < 0) {
		return Math.max(0, length + index);
	} else if (index < length) {
		return index;
	} else /* index > length */ {
		return Math.min(length - newItemsOffset, index);
	}
}

function normalizeRemoveCount(index, length, removedCount) {
	return Math.min(removedCount, length - index);
}

function createChangeMeta(dependentArray, item, index, propertyName, property, previousValues) {
	var meta = {
		arrayChanged: dependentArray,
		index: index,
		item: item,
		propertyName: propertyName,
		property: property
	};

	if (previousValues) {
		// previous values only available for item property changes
		meta.previousValues = previousValues;
	}

	return meta;
}

function addItems (dependentArray, callbacks, cp, propertyName, meta) {
	forEach(dependentArray, function (item, index) {
		meta.setValue( callbacks.addedItem.call(
			this, meta.getValue(), item, createChangeMeta(dependentArray, item, index, propertyName, cp), meta.sugarMeta));
	}, this);
}

function reset(cp, propertyName) {
	var callbacks = cp._callbacks(),
			meta;

	if (cp._hasInstanceMeta(this, propertyName)) {
		meta = cp._instanceMeta(this, propertyName);
		meta.setValue(cp.resetValue(meta.getValue()));
	} else {
		meta = cp._instanceMeta(this, propertyName);
	}

	if (cp.options.initialize) {
		cp.options.initialize.call(this, meta.getValue(), { property: cp, propertyName: propertyName }, meta.sugarMeta);
	}
}

function partiallyRecomputeFor(obj, dependentKey) {
	if (arrayBracketPattern.test(dependentKey)) {
		return false;
	}

	var value = get(obj, dependentKey);
	return Ember.Array.detect(value);
}

function ReduceComputedPropertyInstanceMeta(context, propertyName, initialValue) {
	this.context = context;
	this.propertyName = propertyName;
	this.cache = metaFor(context).cache;

	this.dependentArrays = {};
	this.sugarMeta = {};

	this.initialValue = initialValue;
}

ReduceComputedPropertyInstanceMeta.prototype = {
	getValue: function () {
		if (this.propertyName in this.cache) {
			return this.cache[this.propertyName];
		} else {
			return this.initialValue;
		}
	},

	setValue: function(newValue, triggerObservers) {
		// This lets sugars force a recomputation, handy for very simple
		// implementations of eg max.
		if (newValue !== undefined) {
			var fireObservers = triggerObservers && (newValue !== this.cache[this.propertyName]);

			if (fireObservers) {
				propertyWillChange(this.context, this.propertyName);
			}

			this.cache[this.propertyName] = newValue;

			if (fireObservers) {
				propertyDidChange(this.context, this.propertyName);
			}
		} else {
			delete this.cache[this.propertyName];
		}
	}
};

/**
	A computed property whose dependent keys are arrays and which is updated with
	"one at a time" semantics.

	@class ReduceComputedProperty
	@namespace Ember
	@extends Ember.ComputedProperty
	@constructor
*/
function ReduceComputedProperty(options) {
	var cp = this;

	this.options = options;
	this._instanceMetas = {};

	this._dependentKeys = null;
	// A map of dependentKey -> [itemProperty, ...] that tracks what properties of
	// items in the array we must track to update this property.
	this._itemPropertyKeys = {};
	this._previousItemPropertyKeys = {};

	this.readOnly();
	this.cacheable();

	this.recomputeOnce = function(propertyName) {
		// What we really want to do is coalesce by <cp, propertyName>.
		// We need a form of `scheduleOnce` that accepts an arbitrary token to
		// coalesce by, in addition to the target and method.
		Ember.run.once(this, recompute, propertyName);
	};
	var recompute = function(propertyName) {
		var dependentKeys = cp._dependentKeys,
				meta = cp._instanceMeta(this, propertyName),
				callbacks = cp._callbacks();

		reset.call(this, cp, propertyName);

		meta.dependentArraysObserver.suspendArrayObservers(function () {
			forEach(cp._dependentKeys, function (dependentKey) {
				if (!partiallyRecomputeFor(this, dependentKey)) { return; }

				var dependentArray = get(this, dependentKey),
						previousDependentArray = meta.dependentArrays[dependentKey];

				if (dependentArray === previousDependentArray) {
					// The array may be the same, but our item property keys may have
					// changed, so we set them up again.  We can't easily tell if they've
					// changed: the array may be the same object, but with different
					// contents.
					if (cp._previousItemPropertyKeys[dependentKey]) {
						delete cp._previousItemPropertyKeys[dependentKey];
						meta.dependentArraysObserver.setupPropertyObservers(dependentKey, cp._itemPropertyKeys[dependentKey]);
					}
				} else {
					meta.dependentArrays[dependentKey] = dependentArray;

					if (previousDependentArray) {
						meta.dependentArraysObserver.teardownObservers(previousDependentArray, dependentKey);
					}

					if (dependentArray) {
						meta.dependentArraysObserver.setupObservers(dependentArray, dependentKey);
					}
				}
			}, this);
		}, this);

		forEach(cp._dependentKeys, function(dependentKey) {
			if (!partiallyRecomputeFor(this, dependentKey)) { return; }

			var dependentArray = get(this, dependentKey);
			if (dependentArray) {
				addItems.call(this, dependentArray, callbacks, cp, propertyName, meta);
			}
		}, this);
	};


	this.func = function (propertyName) {

		recompute.call(this, propertyName);

		return cp._instanceMeta(this, propertyName).getValue();
	};
}

Ember.ReduceComputedProperty = ReduceComputedProperty;
ReduceComputedProperty.prototype = o_create(ComputedProperty.prototype);

function defaultCallback(computedValue) {
	return computedValue;
}

ReduceComputedProperty.prototype._callbacks = function () {
	if (!this.callbacks) {
		var options = this.options;
		this.callbacks = {
			removedItem: options.removedItem || defaultCallback,
			addedItem: options.addedItem || defaultCallback
		};
	}
	return this.callbacks;
};

ReduceComputedProperty.prototype._hasInstanceMeta = function (context, propertyName) {
	var guid = guidFor(context),
			key = guid + ':' + propertyName;

	return !!this._instanceMetas[key];
};

ReduceComputedProperty.prototype._instanceMeta = function (context, propertyName) {
	var guid = guidFor(context),
			key = guid + ':' + propertyName,
			meta = this._instanceMetas[key];

	if (!meta) {
		meta = this._instanceMetas[key] = new ReduceComputedPropertyInstanceMeta(context, propertyName, this.initialValue());
		meta.dependentArraysObserver = new DependentArraysObserver(this._callbacks(), this, meta, context, propertyName, meta.sugarMeta);
	}

	return meta;
};

ReduceComputedProperty.prototype.initialValue = function () {
	if (typeof this.options.initialValue === 'function') {
		return this.options.initialValue();
	}
	else {
		return this.options.initialValue;
	}
};

ReduceComputedProperty.prototype.resetValue = function (value) {
	return this.initialValue();
};

ReduceComputedProperty.prototype.itemPropertyKey = function (dependentArrayKey, itemPropertyKey) {
	this._itemPropertyKeys[dependentArrayKey] = this._itemPropertyKeys[dependentArrayKey] || [];
	this._itemPropertyKeys[dependentArrayKey].push(itemPropertyKey);
};

ReduceComputedProperty.prototype.clearItemPropertyKeys = function (dependentArrayKey) {
	if (this._itemPropertyKeys[dependentArrayKey]) {
		this._previousItemPropertyKeys[dependentArrayKey] = this._itemPropertyKeys[dependentArrayKey];
		this._itemPropertyKeys[dependentArrayKey] = [];
	}
};

ReduceComputedProperty.prototype.property = function () {
	var cp = this,
			args = a_slice.call(arguments),
			propertyArgs = new Ember.Set(),
			match,
			dependentArrayKey,
			itemPropertyKey;

	forEach(a_slice.call(arguments), function (dependentKey) {
		if (doubleEachPropertyPattern.test(dependentKey)) {
			throw new Ember.Error("Nested @each properties not supported: " + dependentKey);
		} else if (match = eachPropertyPattern.exec(dependentKey)) {
			dependentArrayKey = match[1];


				var itemPropertyKeyPattern = match[2],
						addItemPropertyKey = function (itemPropertyKey) {
							cp.itemPropertyKey(dependentArrayKey, itemPropertyKey);
						};

				expandProperties(itemPropertyKeyPattern, addItemPropertyKey);
						propertyArgs.add(dependentArrayKey);
		} else {
			propertyArgs.add(dependentKey);
		}
	});

	return ComputedProperty.prototype.property.apply(this, propertyArgs.toArray());

};

/**
	Creates a computed property which operates on dependent arrays and
	is updated with "one at a time" semantics. When items are added or
	removed from the dependent array(s) a reduce computed only operates
	on the change instead of re-evaluating the entire array.

	If there are more than one arguments the first arguments are
	considered to be dependent property keys. The last argument is
	required to be an options object. The options object can have the
	following four properties:

	`initialValue` - A value or function that will be used as the initial
	value for the computed. If this property is a function the result of calling
	the function will be used as the initial value. This property is required.

	`initialize` - An optional initialize function. Typically this will be used
	to set up state on the instanceMeta object.

	`removedItem` - A function that is called each time an element is removed
	from the array.

	`addedItem` - A function that is called each time an element is added to
	the array.


	The `initialize` function has the following signature:

	```javascript
	 function (initialValue, changeMeta, instanceMeta)
	```

	`initialValue` - The value of the `initialValue` property from the
	options object.

	`changeMeta` - An object which contains meta information about the
	computed. It contains the following properties:

		 - `property` the computed property
		 - `propertyName` the name of the property on the object

	`instanceMeta` - An object that can be used to store meta
	information needed for calculating your computed. For example a
	unique computed might use this to store the number of times a given
	element is found in the dependent array.


	The `removedItem` and `addedItem` functions both have the following signature:

	```javascript
	function (accumulatedValue, item, changeMeta, instanceMeta)
	```

	`accumulatedValue` - The value returned from the last time
	`removedItem` or `addedItem` was called or `initialValue`.

	`item` - the element added or removed from the array

	`changeMeta` - An object which contains meta information about the
	change. It contains the following properties:

		- `property` the computed property
		- `propertyName` the name of the property on the object
		- `index` the index of the added or removed item
		- `item` the added or removed item: this is exactly the same as
			the second arg
		- `arrayChanged` the array that triggered the change. Can be
			useful when depending on multiple arrays.

	For property changes triggered on an item property change (when
	depKey is something like `someArray.@each.someProperty`),
	`changeMeta` will also contain the following property:

		- `previousValues` an object whose keys are the properties that changed on
		the item, and whose values are the item's previous values.

	`previousValues` is important Ember coalesces item property changes via
	Ember.run.once. This means that by the time removedItem gets called, item has
	the new values, but you may need the previous value (eg for sorting &
	filtering).

	`instanceMeta` - An object that can be used to store meta
	information needed for calculating your computed. For example a
	unique computed might use this to store the number of times a given
	element is found in the dependent array.

	The `removedItem` and `addedItem` functions should return the accumulated
	value. It is acceptable to not return anything (ie return undefined)
	to invalidate the computation. This is generally not a good idea for
	arrayComputed but it's used in eg max and min.

	Note that observers will be fired if either of these functions return a value
	that differs from the accumulated value.  When returning an object that
	mutates in response to array changes, for example an array that maps
	everything from some other array (see `Ember.computed.map`), it is usually
	important that the *same* array be returned to avoid accidentally triggering observers.

	Example

	```javascript
	Ember.computed.max = function (dependentKey) {
		return Ember.reduceComputed(dependentKey, {
			initialValue: -Infinity,

			addedItem: function (accumulatedValue, item, changeMeta, instanceMeta) {
				return Math.max(accumulatedValue, item);
			},

			removedItem: function (accumulatedValue, item, changeMeta, instanceMeta) {
				if (item < accumulatedValue) {
					return accumulatedValue;
				}
			}
		});
	};
	```

	Dependent keys may refer to `@this` to observe changes to the object itself,
	which must be array-like, rather than a property of the object.  This is
	mostly useful for array proxies, to ensure objects are retrieved via
	`objectAtContent`.  This is how you could sort items by properties defined on an item controller.

	Example

	```javascript
	App.PeopleController = Ember.ArrayController.extend({
		itemController: 'person',

		sortedPeople: Ember.computed.sort('@this.@each.reversedName', function(personA, personB) {
			// `reversedName` isn't defined on Person, but we have access to it via
			// the item controller App.PersonController.  If we'd used
			// `content.@each.reversedName` above, we would be getting the objects
			// directly and not have access to `reversedName`.
			//
			var reversedNameA = get(personA, 'reversedName'),
					reversedNameB = get(personB, 'reversedName');

			return Ember.compare(reversedNameA, reversedNameB);
		})
	});

	App.PersonController = Ember.ObjectController.extend({
		reversedName: function () {
			return reverse(get(this, 'name'));
		}.property('name')
	})
	```

	Dependent keys whose values are not arrays are treated as regular
	dependencies: when they change, the computed property is completely
	recalculated.  It is sometimes useful to have dependent arrays with similar
	semantics.  Dependent keys which end in `.[]` do not use "one at a time"
	semantics.  When an item is added or removed from such a dependency, the
	computed property is completely recomputed.

	Example

	```javascript
	Ember.Object.extend({
		// When `string` is changed, `computed` is completely recomputed.
		string: 'a string',

		// When an item is added to `array`, `addedItem` is called.
		array: [],

		// When an item is added to `anotherArray`, `computed` is completely
		// recomputed.
		anotherArray: [],

		computed: Ember.reduceComputed('string', 'array', 'anotherArray.[]', {
			addedItem: addedItemCallback,
			removedItem: removedItemCallback
		})
	});
	```

	@method reduceComputed
	@for Ember
	@param {String} [dependentKeys*]
	@param {Object} options
	@return {Ember.ComputedProperty}
*/
Ember.reduceComputed = function (options) {
	var args;

	if (arguments.length > 1) {
		args = a_slice.call(arguments, 0, -1);
		options = a_slice.call(arguments, -1)[0];
	}

	if (typeof options !== "object") {
		throw new Ember.Error("Reduce Computed Property declared without an options hash");
	}

	if (!('initialValue' in options)) {
		throw new Ember.Error("Reduce Computed Property declared without an initial value");
	}

	var cp = new ReduceComputedProperty(options);

	if (args) {
		cp.property.apply(cp, args);
	}

	return cp;
};

})();



(function() {
var ReduceComputedProperty = Ember.ReduceComputedProperty,
		a_slice = [].slice,
		o_create = Ember.create,
		forEach = Ember.EnumerableUtils.forEach;

function ArrayComputedProperty() {
	var cp = this;

	ReduceComputedProperty.apply(this, arguments);

	this.func = (function(reduceFunc) {
		return function (propertyName) {
			if (!cp._hasInstanceMeta(this, propertyName)) {
				// When we recompute an array computed property, we need already
				// retrieved arrays to be updated; we can't simply empty the cache and
				// hope the array is re-retrieved.
				forEach(cp._dependentKeys, function(dependentKey) {
					Ember.addObserver(this, dependentKey, function() {
						cp.recomputeOnce.call(this, propertyName);
					});
				}, this);
			}

			return reduceFunc.apply(this, arguments);
		};
	})(this.func);

	return this;
}
Ember.ArrayComputedProperty = ArrayComputedProperty;
ArrayComputedProperty.prototype = o_create(ReduceComputedProperty.prototype);
ArrayComputedProperty.prototype.initialValue = function () {
	return Ember.A();
};
ArrayComputedProperty.prototype.resetValue = function (array) {
	array.clear();
	return array;
};

// This is a stopgap to keep the reference counts correct with lazy CPs.
ArrayComputedProperty.prototype.didChange = function (obj, keyName) {
	return;
};

/**
	Creates a computed property which operates on dependent arrays and
	is updated with "one at a time" semantics. When items are added or
	removed from the dependent array(s) an array computed only operates
	on the change instead of re-evaluating the entire array. This should
	return an array, if you'd like to use "one at a time" semantics and
	compute some value other then an array look at
	`Ember.reduceComputed`.

	If there are more than one arguments the first arguments are
	considered to be dependent property keys. The last argument is
	required to be an options object. The options object can have the
	following three properties.

	`initialize` - An optional initialize function. Typically this will be used
	to set up state on the instanceMeta object.

	`removedItem` - A function that is called each time an element is
	removed from the array.

	`addedItem` - A function that is called each time an element is
	added to the array.


	The `initialize` function has the following signature:

	```javascript
	 function (array, changeMeta, instanceMeta)
	```

	`array` - The initial value of the arrayComputed, an empty array.

	`changeMeta` - An object which contains meta information about the
	computed. It contains the following properties:

		 - `property` the computed property
		 - `propertyName` the name of the property on the object

	`instanceMeta` - An object that can be used to store meta
	information needed for calculating your computed. For example a
	unique computed might use this to store the number of times a given
	element is found in the dependent array.


	The `removedItem` and `addedItem` functions both have the following signature:

	```javascript
	function (accumulatedValue, item, changeMeta, instanceMeta)
	```

	`accumulatedValue` - The value returned from the last time
	`removedItem` or `addedItem` was called or an empty array.

	`item` - the element added or removed from the array

	`changeMeta` - An object which contains meta information about the
	change. It contains the following properties:

		- `property` the computed property
		- `propertyName` the name of the property on the object
		- `index` the index of the added or removed item
		- `item` the added or removed item: this is exactly the same as
			the second arg
		- `arrayChanged` the array that triggered the change. Can be
			useful when depending on multiple arrays.

	For property changes triggered on an item property change (when
	depKey is something like `someArray.@each.someProperty`),
	`changeMeta` will also contain the following property:

		- `previousValues` an object whose keys are the properties that changed on
		the item, and whose values are the item's previous values.

	`previousValues` is important Ember coalesces item property changes via
	Ember.run.once. This means that by the time removedItem gets called, item has
	the new values, but you may need the previous value (eg for sorting &
	filtering).

	`instanceMeta` - An object that can be used to store meta
	information needed for calculating your computed. For example a
	unique computed might use this to store the number of times a given
	element is found in the dependent array.

	The `removedItem` and `addedItem` functions should return the accumulated
	value. It is acceptable to not return anything (ie return undefined)
	to invalidate the computation. This is generally not a good idea for
	arrayComputed but it's used in eg max and min.

	Example

	```javascript
	Ember.computed.map = function(dependentKey, callback) {
		var options = {
			addedItem: function(array, item, changeMeta, instanceMeta) {
				var mapped = callback(item);
				array.insertAt(changeMeta.index, mapped);
				return array;
			},
			removedItem: function(array, item, changeMeta, instanceMeta) {
				array.removeAt(changeMeta.index, 1);
				return array;
			}
		};

		return Ember.arrayComputed(dependentKey, options);
	};
	```

	@method arrayComputed
	@for Ember
	@param {String} [dependentKeys*]
	@param {Object} options
	@return {Ember.ComputedProperty}
*/
Ember.arrayComputed = function (options) {
	var args;

	if (arguments.length > 1) {
		args = a_slice.call(arguments, 0, -1);
		options = a_slice.call(arguments, -1)[0];
	}

	if (typeof options !== "object") {
		throw new Ember.Error("Array Computed Property declared without an options hash");
	}

	var cp = new ArrayComputedProperty(options);

	if (args) {
		cp.property.apply(cp, args);
	}

	return cp;
};

})();



(function() {
/**
@module ember
@submodule ember-runtime
*/

var get = Ember.get,
		set = Ember.set,
		guidFor = Ember.guidFor,
		merge = Ember.merge,
		a_slice = [].slice,
		forEach = Ember.EnumerableUtils.forEach,
		map = Ember.EnumerableUtils.map,
		SearchProxy;

/**
 A computed property that returns the sum of the value
 in the dependent array.

 @method computed.sum
 @for Ember
 @param {String} dependentKey
 @return {Ember.ComputedProperty} computes the sum of all values in the dependentKey's array
*/

Ember.computed.sum = function(dependentKey){
	return Ember.reduceComputed(dependentKey, {
		initialValue: 0,

		addedItem: function(accumulatedValue, item, changeMeta, instanceMeta){
			return accumulatedValue + item;
		},

		removedItem: function(accumulatedValue, item, changeMeta, instanceMeta){
			return accumulatedValue - item;
		}
	});
};

/**
	A computed property that calculates the maximum value in the
	dependent array. This will return `-Infinity` when the dependent
	array is empty.

	```javascript
	App.Person = Ember.Object.extend({
		childAges: Ember.computed.mapBy('children', 'age'),
		maxChildAge: Ember.computed.max('childAges')
	});

	var lordByron = App.Person.create({children: []});
	lordByron.get('maxChildAge'); // -Infinity
	lordByron.get('children').pushObject({
		name: 'Augusta Ada Byron', age: 7
	});
	lordByron.get('maxChildAge'); // 7
	lordByron.get('children').pushObjects([{
		name: 'Allegra Byron',
		age: 5
	}, {
		name: 'Elizabeth Medora Leigh',
		age: 8
	}]);
	lordByron.get('maxChildAge'); // 8
	```

	@method computed.max
	@for Ember
	@param {String} dependentKey
	@return {Ember.ComputedProperty} computes the largest value in the dependentKey's array
*/
Ember.computed.max = function (dependentKey) {
	return Ember.reduceComputed(dependentKey, {
		initialValue: -Infinity,

		addedItem: function (accumulatedValue, item, changeMeta, instanceMeta) {
			return Math.max(accumulatedValue, item);
		},

		removedItem: function (accumulatedValue, item, changeMeta, instanceMeta) {
			if (item < accumulatedValue) {
				return accumulatedValue;
			}
		}
	});
};

/**
	A computed property that calculates the minimum value in the
	dependent array. This will return `Infinity` when the dependent
	array is empty.

	```javascript
	App.Person = Ember.Object.extend({
		childAges: Ember.computed.mapBy('children', 'age'),
		minChildAge: Ember.computed.min('childAges')
	});

	var lordByron = App.Person.create({children: []});
	lordByron.get('minChildAge'); // Infinity
	lordByron.get('children').pushObject({
		name: 'Augusta Ada Byron', age: 7
	});
	lordByron.get('minChildAge'); // 7
	lordByron.get('children').pushObjects([{
		name: 'Allegra Byron',
		age: 5
	}, {
		name: 'Elizabeth Medora Leigh',
		age: 8
	}]);
	lordByron.get('minChildAge'); // 5
	```

	@method computed.min
	@for Ember
	@param {String} dependentKey
	@return {Ember.ComputedProperty} computes the smallest value in the dependentKey's array
*/
Ember.computed.min = function (dependentKey) {
	return Ember.reduceComputed(dependentKey, {
		initialValue: Infinity,

		addedItem: function (accumulatedValue, item, changeMeta, instanceMeta) {
			return Math.min(accumulatedValue, item);
		},

		removedItem: function (accumulatedValue, item, changeMeta, instanceMeta) {
			if (item > accumulatedValue) {
				return accumulatedValue;
			}
		}
	});
};

/**
	Returns an array mapped via the callback

	The callback method you provide should have the following signature.
	`item` is the current item in the iteration.

	```javascript
	function(item);
	```

	Example

	```javascript
	App.Hamster = Ember.Object.extend({
		excitingChores: Ember.computed.map('chores', function(chore) {
			return chore.toUpperCase() + '!';
		})
	});

	var hamster = App.Hamster.create({
		chores: ['clean', 'write more unit tests']
	});
	hamster.get('excitingChores'); // ['CLEAN!', 'WRITE MORE UNIT TESTS!']
	```

	@method computed.map
	@for Ember
	@param {String} dependentKey
	@param {Function} callback
	@return {Ember.ComputedProperty} an array mapped via the callback
*/
Ember.computed.map = function(dependentKey, callback) {
	var options = {
		addedItem: function(array, item, changeMeta, instanceMeta) {
			var mapped = callback.call(this, item);
			array.insertAt(changeMeta.index, mapped);
			return array;
		},
		removedItem: function(array, item, changeMeta, instanceMeta) {
			array.removeAt(changeMeta.index, 1);
			return array;
		}
	};

	return Ember.arrayComputed(dependentKey, options);
};

/**
	Returns an array mapped to the specified key.

	```javascript
	App.Person = Ember.Object.extend({
		childAges: Ember.computed.mapBy('children', 'age')
	});

	var lordByron = App.Person.create({children: []});
	lordByron.get('childAges'); // []
	lordByron.get('children').pushObject({name: 'Augusta Ada Byron', age: 7});
	lordByron.get('childAges'); // [7]
	lordByron.get('children').pushObjects([{
		name: 'Allegra Byron',
		age: 5
	}, {
		name: 'Elizabeth Medora Leigh',
		age: 8
	}]);
	lordByron.get('childAges'); // [7, 5, 8]
	```

	@method computed.mapBy
	@for Ember
	@param {String} dependentKey
	@param {String} propertyKey
	@return {Ember.ComputedProperty} an array mapped to the specified key
*/
Ember.computed.mapBy = function(dependentKey, propertyKey) {
	var callback = function(item) { return get(item, propertyKey); };
	return Ember.computed.map(dependentKey + '.@each.' + propertyKey, callback);
};

/**
	@method computed.mapProperty
	@for Ember
	@deprecated Use `Ember.computed.mapBy` instead
	@param dependentKey
	@param propertyKey
*/
Ember.computed.mapProperty = Ember.computed.mapBy;

/**
	Filters the array by the callback.

	The callback method you provide should have the following signature.
	`item` is the current item in the iteration.

	```javascript
	function(item);
	```

	```javascript
	App.Hamster = Ember.Object.extend({
		remainingChores: Ember.computed.filter('chores', function(chore) {
			return !chore.done;
		})
	});

	var hamster = App.Hamster.create({chores: [
		{name: 'cook', done: true},
		{name: 'clean', done: true},
		{name: 'write more unit tests', done: false}
	]});
	hamster.get('remainingChores'); // [{name: 'write more unit tests', done: false}]
	```

	@method computed.filter
	@for Ember
	@param {String} dependentKey
	@param {Function} callback
	@return {Ember.ComputedProperty} the filtered array
*/
Ember.computed.filter = function(dependentKey, callback) {
	var options = {
		initialize: function (array, changeMeta, instanceMeta) {
			instanceMeta.filteredArrayIndexes = new Ember.SubArray();
		},

		addedItem: function(array, item, changeMeta, instanceMeta) {
			var match = !!callback.call(this, item),
					filterIndex = instanceMeta.filteredArrayIndexes.addItem(changeMeta.index, match);

			if (match) {
				array.insertAt(filterIndex, item);
			}

			return array;
		},

		removedItem: function(array, item, changeMeta, instanceMeta) {
			var filterIndex = instanceMeta.filteredArrayIndexes.removeItem(changeMeta.index);

			if (filterIndex > -1) {
				array.removeAt(filterIndex);
			}

			return array;
		}
	};

	return Ember.arrayComputed(dependentKey, options);
};

/**
	Filters the array by the property and value

	```javascript
	App.Hamster = Ember.Object.extend({
		remainingChores: Ember.computed.filterBy('chores', 'done', false)
	});

	var hamster = App.Hamster.create({chores: [
		{name: 'cook', done: true},
		{name: 'clean', done: true},
		{name: 'write more unit tests', done: false}
	]});
	hamster.get('remainingChores'); // [{name: 'write more unit tests', done: false}]
	```

	@method computed.filterBy
	@for Ember
	@param {String} dependentKey
	@param {String} propertyKey
	@param {String} value
	@return {Ember.ComputedProperty} the filtered array
*/
Ember.computed.filterBy = function(dependentKey, propertyKey, value) {
	var callback;

	if (arguments.length === 2) {
		callback = function(item) {
			return get(item, propertyKey);
		};
	} else {
		callback = function(item) {
			return get(item, propertyKey) === value;
		};
	}

	return Ember.computed.filter(dependentKey + '.@each.' + propertyKey, callback);
};

/**
	@method computed.filterProperty
	@for Ember
	@param dependentKey
	@param propertyKey
	@param value
	@deprecated Use `Ember.computed.filterBy` instead
*/
Ember.computed.filterProperty = Ember.computed.filterBy;

/**
	A computed property which returns a new array with all the unique
	elements from one or more dependent arrays.

	Example

	```javascript
	App.Hamster = Ember.Object.extend({
		uniqueFruits: Ember.computed.uniq('fruits')
	});

	var hamster = App.Hamster.create({fruits: [
		'banana',
		'grape',
		'kale',
		'banana'
	]});
	hamster.get('uniqueFruits'); // ['banana', 'grape', 'kale']
	```

	@method computed.uniq
	@for Ember
	@param {String} propertyKey*
	@return {Ember.ComputedProperty} computes a new array with all the
	unique elements from the dependent array
*/
Ember.computed.uniq = function() {
	var args = a_slice.call(arguments);
	args.push({
		initialize: function(array, changeMeta, instanceMeta) {
			instanceMeta.itemCounts = {};
		},

		addedItem: function(array, item, changeMeta, instanceMeta) {
			var guid = guidFor(item);

			if (!instanceMeta.itemCounts[guid]) {
				instanceMeta.itemCounts[guid] = 1;
			} else {
				++instanceMeta.itemCounts[guid];
			}
			array.addObject(item);
			return array;
		},
		removedItem: function(array, item, _, instanceMeta) {
			var guid = guidFor(item),
					itemCounts = instanceMeta.itemCounts;

			if (--itemCounts[guid] === 0) {
				array.removeObject(item);
			}
			return array;
		}
	});
	return Ember.arrayComputed.apply(null, args);
};

/**
	Alias for [Ember.computed.uniq](/api/#method_computed_uniq).

	@method computed.union
	@for Ember
	@param {String} propertyKey*
	@return {Ember.ComputedProperty} computes a new array with all the
	unique elements from the dependent array
*/
Ember.computed.union = Ember.computed.uniq;

/**
	A computed property which returns a new array with all the duplicated
	elements from two or more dependent arrays.

	Example

	```javascript
	var obj = Ember.Object.createWithMixins({
		adaFriends: ['Charles Babbage', 'John Hobhouse', 'William King', 'Mary Somerville'],
		charlesFriends: ['William King', 'Mary Somerville', 'Ada Lovelace', 'George Peacock'],
		friendsInCommon: Ember.computed.intersect('adaFriends', 'charlesFriends')
	});

	obj.get('friendsInCommon'); // ['William King', 'Mary Somerville']
	```

	@method computed.intersect
	@for Ember
	@param {String} propertyKey*
	@return {Ember.ComputedProperty} computes a new array with all the
	duplicated elements from the dependent arrays
*/
Ember.computed.intersect = function () {
	var getDependentKeyGuids = function (changeMeta) {
		return map(changeMeta.property._dependentKeys, function (dependentKey) {
			return guidFor(dependentKey);
		});
	};

	var args = a_slice.call(arguments);
	args.push({
		initialize: function (array, changeMeta, instanceMeta) {
			instanceMeta.itemCounts = {};
		},

		addedItem: function(array, item, changeMeta, instanceMeta) {
			var itemGuid = guidFor(item),
					dependentGuids = getDependentKeyGuids(changeMeta),
					dependentGuid = guidFor(changeMeta.arrayChanged),
					numberOfDependentArrays = changeMeta.property._dependentKeys.length,
					itemCounts = instanceMeta.itemCounts;

			if (!itemCounts[itemGuid]) { itemCounts[itemGuid] = {}; }
			if (itemCounts[itemGuid][dependentGuid] === undefined) { itemCounts[itemGuid][dependentGuid] = 0; }

			if (++itemCounts[itemGuid][dependentGuid] === 1 &&
					numberOfDependentArrays === Ember.keys(itemCounts[itemGuid]).length) {

				array.addObject(item);
			}
			return array;
		},
		removedItem: function(array, item, changeMeta, instanceMeta) {
			var itemGuid = guidFor(item),
					dependentGuids = getDependentKeyGuids(changeMeta),
					dependentGuid = guidFor(changeMeta.arrayChanged),
					numberOfDependentArrays = changeMeta.property._dependentKeys.length,
					numberOfArraysItemAppearsIn,
					itemCounts = instanceMeta.itemCounts;

			if (itemCounts[itemGuid][dependentGuid] === undefined) { itemCounts[itemGuid][dependentGuid] = 0; }
			if (--itemCounts[itemGuid][dependentGuid] === 0) {
				delete itemCounts[itemGuid][dependentGuid];
				numberOfArraysItemAppearsIn = Ember.keys(itemCounts[itemGuid]).length;

				if (numberOfArraysItemAppearsIn === 0) {
					delete itemCounts[itemGuid];
				}
				array.removeObject(item);
			}
			return array;
		}
	});
	return Ember.arrayComputed.apply(null, args);
};

/**
	A computed property which returns a new array with all the
	properties from the first dependent array that are not in the second
	dependent array.

	Example

	```javascript
	App.Hamster = Ember.Object.extend({
		likes: ['banana', 'grape', 'kale'],
		wants: Ember.computed.setDiff('likes', 'fruits')
	});

	var hamster = App.Hamster.create({fruits: [
		'grape',
		'kale',
	]});
	hamster.get('wants'); // ['banana']
	```

	@method computed.setDiff
	@for Ember
	@param {String} setAProperty
	@param {String} setBProperty
	@return {Ember.ComputedProperty} computes a new array with all the
	items from the first dependent array that are not in the second
	dependent array
*/
Ember.computed.setDiff = function (setAProperty, setBProperty) {
	if (arguments.length !== 2) {
		throw new Ember.Error("setDiff requires exactly two dependent arrays.");
	}
	return Ember.arrayComputed(setAProperty, setBProperty, {
		addedItem: function (array, item, changeMeta, instanceMeta) {
			var setA = get(this, setAProperty),
					setB = get(this, setBProperty);

			if (changeMeta.arrayChanged === setA) {
				if (!setB.contains(item)) {
					array.addObject(item);
				}
			} else {
				array.removeObject(item);
			}
			return array;
		},

		removedItem: function (array, item, changeMeta, instanceMeta) {
			var setA = get(this, setAProperty),
					setB = get(this, setBProperty);

			if (changeMeta.arrayChanged === setB) {
				if (setA.contains(item)) {
					array.addObject(item);
				}
			} else {
				array.removeObject(item);
			}
			return array;
		}
	});
};

function binarySearch(array, item, low, high) {
	var mid, midItem, res, guidMid, guidItem;

	if (arguments.length < 4) { high = get(array, 'length'); }
	if (arguments.length < 3) { low = 0; }

	if (low === high) {
		return low;
	}

	mid = low + Math.floor((high - low) / 2);
	midItem = array.objectAt(mid);

	guidMid = _guidFor(midItem);
	guidItem = _guidFor(item);

	if (guidMid === guidItem) {
		return mid;
	}

	res = this.order(midItem, item);
	if (res === 0) {
		res = guidMid < guidItem ? -1 : 1;
	}


	if (res < 0) {
		return this.binarySearch(array, item, mid+1, high);
	} else if (res > 0) {
		return this.binarySearch(array, item, low, mid);
	}

	return mid;

	function _guidFor(item) {
		if (SearchProxy.detectInstance(item)) {
			return guidFor(get(item, 'content'));
		}
		return guidFor(item);
	}
}


SearchProxy = Ember.ObjectProxy.extend();

/**
	A computed property which returns a new array with all the
	properties from the first dependent array sorted based on a property
	or sort function.

	The callback method you provide should have the following signature:

	```javascript
	function(itemA, itemB);
	```

	- `itemA` the first item to compare.
	- `itemB` the second item to compare.

	This function should return `-1` when `itemA` should come before
	`itemB`. It should return `1` when `itemA` should come after
	`itemB`. If the `itemA` and `itemB` are equal this function should return `0`.

	Example

	```javascript
	var ToDoList = Ember.Object.extend({
		todosSorting: ['name'],
		sortedTodos: Ember.computed.sort('todos', 'todosSorting'),
		priorityTodos: Ember.computed.sort('todos', function(a, b){
			if (a.priority > b.priority) {
				return 1;
			} else if (a.priority < b.priority) {
				return -1;
			}
			return 0;
		}),
	});
	var todoList = ToDoList.create({todos: [
		{name: 'Unit Test', priority: 2},
		{name: 'Documentation', priority: 3},
		{name: 'Release', priority: 1}
	]});

	todoList.get('sortedTodos'); // [{name:'Documentation', priority:3}, {name:'Release', priority:1}, {name:'Unit Test', priority:2}]
	todoList.get('priorityTodos'); // [{name:'Release', priority:1}, {name:'Unit Test', priority:2}, {name:'Documentation', priority:3}]
	```

	@method computed.sort
	@for Ember
	@param {String} dependentKey
	@param {String or Function} sortDefinition a dependent key to an
	array of sort properties or a function to use when sorting
	@return {Ember.ComputedProperty} computes a new sorted array based
	on the sort property array or callback function
*/
Ember.computed.sort = function (itemsKey, sortDefinition) {

	var initFn, sortPropertiesKey;

	if (typeof sortDefinition === 'function') {
		initFn = function (array, changeMeta, instanceMeta) {
			instanceMeta.order = sortDefinition;
			instanceMeta.binarySearch = binarySearch;
		};
	} else {
		sortPropertiesKey = sortDefinition;
		initFn = function (array, changeMeta, instanceMeta) {
			function setupSortProperties() {
				var sortPropertyDefinitions = get(this, sortPropertiesKey),
						sortProperty,
						sortProperties = instanceMeta.sortProperties = [],
						sortPropertyAscending = instanceMeta.sortPropertyAscending = {},
						idx,
						asc;


				changeMeta.property.clearItemPropertyKeys(itemsKey);

				forEach(sortPropertyDefinitions, function (sortPropertyDefinition) {
					if ((idx = sortPropertyDefinition.indexOf(':')) !== -1) {
						sortProperty = sortPropertyDefinition.substring(0, idx);
						asc = sortPropertyDefinition.substring(idx+1).toLowerCase() !== 'desc';
					} else {
						sortProperty = sortPropertyDefinition;
						asc = true;
					}

					sortProperties.push(sortProperty);
					sortPropertyAscending[sortProperty] = asc;
					changeMeta.property.itemPropertyKey(itemsKey, sortProperty);
				});

				sortPropertyDefinitions.addObserver('@each', this, updateSortPropertiesOnce);
			}

			function updateSortPropertiesOnce() {
				Ember.run.once(this, updateSortProperties, changeMeta.propertyName);
			}

			function updateSortProperties(propertyName) {
				setupSortProperties.call(this);
				changeMeta.property.recomputeOnce.call(this, propertyName);
			}

			Ember.addObserver(this, sortPropertiesKey, updateSortPropertiesOnce);

			setupSortProperties.call(this);


			instanceMeta.order = function (itemA, itemB) {
				var sortProperty, result, asc;
				for (var i = 0; i < this.sortProperties.length; ++i) {
					sortProperty = this.sortProperties[i];
					result = Ember.compare(get(itemA, sortProperty), get(itemB, sortProperty));

					if (result !== 0) {
						asc = this.sortPropertyAscending[sortProperty];
						return asc ? result : (-1 * result);
					}
				}

				return 0;
			};

			instanceMeta.binarySearch = binarySearch;
		};
	}

	return Ember.arrayComputed(itemsKey, {
		initialize: initFn,

		addedItem: function (array, item, changeMeta, instanceMeta) {
			var index = instanceMeta.binarySearch(array, item);
			array.insertAt(index, item);
			return array;
		},

		removedItem: function (array, item, changeMeta, instanceMeta) {
			var proxyProperties, index, searchItem;

			if (changeMeta.previousValues) {
				proxyProperties = merge({ content: item }, changeMeta.previousValues);

				searchItem = SearchProxy.create(proxyProperties);
			} else {
				searchItem = item;
			}

			index = instanceMeta.binarySearch(array, searchItem);
			array.removeAt(index);
			return array;
		}
	});
};

})();



(function() {
Ember.RSVP = requireModule('rsvp');

Ember.RSVP.onerrorDefault = function(error) {
	if (error instanceof Error) {
		if (Ember.testing) {
			if (Ember.Test && Ember.Test.adapter) {
				Ember.Test.adapter.exception(error);
			} else {
				throw error;
			}
		} else {
			Ember.Logger.error(error.stack);
					}
	}
};

Ember.RSVP.on('error', Ember.RSVP.onerrorDefault);

})();



(function() {
/**
@module ember
@submodule ember-runtime
*/

var a_slice = Array.prototype.slice;


	var expandProperties = Ember.expandProperties;


if (Ember.EXTEND_PROTOTYPES === true || Ember.EXTEND_PROTOTYPES.Function) {

	/**
		The `property` extension of Javascript's Function prototype is available
		when `Ember.EXTEND_PROTOTYPES` or `Ember.EXTEND_PROTOTYPES.Function` is
		`true`, which is the default.

		Computed properties allow you to treat a function like a property:

		```javascript
		MyApp.President = Ember.Object.extend({
			firstName: '',
			lastName:  '',

			fullName: function() {
				return this.get('firstName') + ' ' + this.get('lastName');

				// Call this flag to mark the function as a property
			}.property()
		});

		var president = MyApp.President.create({
			firstName: "Barack",
			lastName: "Obama"
		});

		president.get('fullName');    // "Barack Obama"
		```

		Treating a function like a property is useful because they can work with
		bindings, just like any other property.

		Many computed properties have dependencies on other properties. For
		example, in the above example, the `fullName` property depends on
		`firstName` and `lastName` to determine its value. You can tell Ember
		about these dependencies like this:

		```javascript
		MyApp.President = Ember.Object.extend({
			firstName: '',
			lastName:  '',

			fullName: function() {
				return this.get('firstName') + ' ' + this.get('lastName');

				// Tell Ember.js that this computed property depends on firstName
				// and lastName
			}.property('firstName', 'lastName')
		});
		```

		Make sure you list these dependencies so Ember knows when to update
		bindings that connect to a computed property. Changing a dependency
		will not immediately trigger an update of the computed property, but
		will instead clear the cache so that it is updated when the next `get`
		is called on the property.

		See [Ember.ComputedProperty](/api/classes/Ember.ComputedProperty.html), [Ember.computed](/api/#method_computed).

		@method property
		@for Function
	*/
	Function.prototype.property = function() {
		var ret = Ember.computed(this);
		// ComputedProperty.prototype.property expands properties; no need for us to
		// do so here.
		return ret.property.apply(ret, arguments);
	};

	/**
		The `observes` extension of Javascript's Function prototype is available
		when `Ember.EXTEND_PROTOTYPES` or `Ember.EXTEND_PROTOTYPES.Function` is
		true, which is the default.

		You can observe property changes simply by adding the `observes`
		call to the end of your method declarations in classes that you write.
		For example:

		```javascript
		Ember.Object.extend({
			valueObserver: function() {
				// Executes whenever the "value" property changes
			}.observes('value')
		});
		```

		In the future this method may become asynchronous. If you want to ensure
		synchronous behavior, use `observesImmediately`.

		See `Ember.observer`.

		@method observes
		@for Function
	*/
	Function.prototype.observes = function() {

			var addWatchedProperty = function (obs) { watched.push(obs); };
			var watched = [];

			for (var i=0; i<arguments.length; ++i) {
				expandProperties(arguments[i], addWatchedProperty);
			}

			this.__ember_observes__ = watched;

		return this;
	};

	/**
		The `observesImmediately` extension of Javascript's Function prototype is
		available when `Ember.EXTEND_PROTOTYPES` or
		`Ember.EXTEND_PROTOTYPES.Function` is true, which is the default.

		You can observe property changes simply by adding the `observesImmediately`
		call to the end of your method declarations in classes that you write.
		For example:

		```javascript
		Ember.Object.extend({
			valueObserver: function() {
				// Executes immediately after the "value" property changes
			}.observesImmediately('value')
		});
		```

		In the future, `observes` may become asynchronous. In this event,
		`observesImmediately` will maintain the synchronous behavior.

		See `Ember.immediateObserver`.

		@method observesImmediately
		@for Function
	*/
	Function.prototype.observesImmediately = function() {
		for (var i=0, l=arguments.length; i<l; i++) {
			var arg = arguments[i];
					}

		// observes handles property expansion
		return this.observes.apply(this, arguments);
	};

	/**
		The `observesBefore` extension of Javascript's Function prototype is
		available when `Ember.EXTEND_PROTOTYPES` or
		`Ember.EXTEND_PROTOTYPES.Function` is true, which is the default.

		You can get notified when a property change is about to happen by
		by adding the `observesBefore` call to the end of your method
		declarations in classes that you write. For example:

		```javascript
		Ember.Object.extend({
			valueObserver: function() {
				// Executes whenever the "value" property is about to change
			}.observesBefore('value')
		});
		```

		See `Ember.beforeObserver`.

		@method observesBefore
		@for Function
	*/
	Function.prototype.observesBefore = function() {

			var addWatchedProperty = function (obs) { watched.push(obs); };
			var watched = [];

			for (var i=0; i<arguments.length; ++i) {
				expandProperties(arguments[i], addWatchedProperty);
			}

			this.__ember_observesBefore__ = watched;

		return this;
	};

	/**
		The `on` extension of Javascript's Function prototype is available
		when `Ember.EXTEND_PROTOTYPES` or `Ember.EXTEND_PROTOTYPES.Function` is
		true, which is the default.

		You can listen for events simply by adding the `on` call to the end of
		your method declarations in classes or mixins that you write. For example:

		```javascript
		Ember.Mixin.create({
			doSomethingWithElement: function() {
				// Executes whenever the "didInsertElement" event fires
			}.on('didInsertElement')
		});
		```

		See `Ember.on`.

		@method on
		@for Function
	*/
	Function.prototype.on = function() {
		var events = a_slice.call(arguments);
		this.__ember_listens__ = events;
		return this;
	};
}


})();



(function() {

})();



(function() {
/**
@module ember
@submodule ember-runtime
*/


/**
	Implements some standard methods for comparing objects. Add this mixin to
	any class you create that can compare its instances.

	You should implement the `compare()` method.

	@class Comparable
	@namespace Ember
	@since Ember 0.9
*/
Ember.Comparable = Ember.Mixin.create({

	/**
		Override to return the result of the comparison of the two parameters. The
		compare method should return:

		- `-1` if `a < b`
		- `0` if `a == b`
		- `1` if `a > b`

		Default implementation raises an exception.

		@method compare
		@param a {Object} the first object to compare
		@param b {Object} the second object to compare
		@return {Integer} the result of the comparison
	*/
	compare: Ember.required(Function)

});


})();



(function() {
/**
@module ember
@submodule ember-runtime
*/



var get = Ember.get, set = Ember.set;

/**
	Implements some standard methods for copying an object. Add this mixin to
	any object you create that can create a copy of itself. This mixin is
	added automatically to the built-in array.

	You should generally implement the `copy()` method to return a copy of the
	receiver.

	Note that `frozenCopy()` will only work if you also implement
	`Ember.Freezable`.

	@class Copyable
	@namespace Ember
	@since Ember 0.9
*/
Ember.Copyable = Ember.Mixin.create({

	/**
		Override to return a copy of the receiver. Default implementation raises
		an exception.

		@method copy
		@param {Boolean} deep if `true`, a deep copy of the object should be made
		@return {Object} copy of receiver
	*/
	copy: Ember.required(Function),

	/**
		If the object implements `Ember.Freezable`, then this will return a new
		copy if the object is not frozen and the receiver if the object is frozen.

		Raises an exception if you try to call this method on a object that does
		not support freezing.

		You should use this method whenever you want a copy of a freezable object
		since a freezable object can simply return itself without actually
		consuming more memory.

		@method frozenCopy
		@return {Object} copy of receiver or receiver
	*/
	frozenCopy: function() {
		if (Ember.Freezable && Ember.Freezable.detect(this)) {
			return get(this, 'isFrozen') ? this : this.copy().freeze();
		} else {
			throw new Ember.Error(Ember.String.fmt("%@ does not support freezing", [this]));
		}
	}
});

})();



(function() {
/**
@module ember
@submodule ember-runtime
*/


var get = Ember.get, set = Ember.set;

/**
	The `Ember.Freezable` mixin implements some basic methods for marking an
	object as frozen. Once an object is frozen it should be read only. No changes
	may be made the internal state of the object.

	## Enforcement

	To fully support freezing in your subclass, you must include this mixin and
	override any method that might alter any property on the object to instead
	raise an exception. You can check the state of an object by checking the
	`isFrozen` property.

	Although future versions of JavaScript may support language-level freezing
	object objects, that is not the case today. Even if an object is freezable,
	it is still technically possible to modify the object, even though it could
	break other parts of your application that do not expect a frozen object to
	change. It is, therefore, very important that you always respect the
	`isFrozen` property on all freezable objects.

	## Example Usage

	The example below shows a simple object that implement the `Ember.Freezable`
	protocol.

	```javascript
	Contact = Ember.Object.extend(Ember.Freezable, {
		firstName: null,
		lastName: null,

		// swaps the names
		swapNames: function() {
			if (this.get('isFrozen')) throw Ember.FROZEN_ERROR;
			var tmp = this.get('firstName');
			this.set('firstName', this.get('lastName'));
			this.set('lastName', tmp);
			return this;
		}

	});

	c = Contact.create({ firstName: "John", lastName: "Doe" });
	c.swapNames();  // returns c
	c.freeze();
	c.swapNames();  // EXCEPTION
	```

	## Copying

	Usually the `Ember.Freezable` protocol is implemented in cooperation with the
	`Ember.Copyable` protocol, which defines a `frozenCopy()` method that will
	return a frozen object, if the object implements this method as well.

	@class Freezable
	@namespace Ember
	@since Ember 0.9
*/
Ember.Freezable = Ember.Mixin.create({

	/**
		Set to `true` when the object is frozen. Use this property to detect
		whether your object is frozen or not.

		@property isFrozen
		@type Boolean
	*/
	isFrozen: false,

	/**
		Freezes the object. Once this method has been called the object should
		no longer allow any properties to be edited.

		@method freeze
		@return {Object} receiver
	*/
	freeze: function() {
		if (get(this, 'isFrozen')) return this;
		set(this, 'isFrozen', true);
		return this;
	}

});

Ember.FROZEN_ERROR = "Frozen object cannot be modified.";

})();



(function() {
/**
@module ember
@submodule ember-runtime
*/

var forEach = Ember.EnumerableUtils.forEach;

/**
	This mixin defines the API for modifying generic enumerables. These methods
	can be applied to an object regardless of whether it is ordered or
	unordered.

	Note that an Enumerable can change even if it does not implement this mixin.
	For example, a MappedEnumerable cannot be directly modified but if its
	underlying enumerable changes, it will change also.

	## Adding Objects

	To add an object to an enumerable, use the `addObject()` method. This
	method will only add the object to the enumerable if the object is not
	already present and is of a type supported by the enumerable.

	```javascript
	set.addObject(contact);
	```

	## Removing Objects

	To remove an object from an enumerable, use the `removeObject()` method. This
	will only remove the object if it is present in the enumerable, otherwise
	this method has no effect.

	```javascript
	set.removeObject(contact);
	```

	## Implementing In Your Own Code

	If you are implementing an object and want to support this API, just include
	this mixin in your class and implement the required methods. In your unit
	tests, be sure to apply the Ember.MutableEnumerableTests to your object.

	@class MutableEnumerable
	@namespace Ember
	@uses Ember.Enumerable
*/
Ember.MutableEnumerable = Ember.Mixin.create(Ember.Enumerable, {

	/**
		__Required.__ You must implement this method to apply this mixin.

		Attempts to add the passed object to the receiver if the object is not
		already present in the collection. If the object is present, this method
		has no effect.

		If the passed object is of a type not supported by the receiver,
		then this method should raise an exception.

		@method addObject
		@param {Object} object The object to add to the enumerable.
		@return {Object} the passed object
	*/
	addObject: Ember.required(Function),

	/**
		Adds each object in the passed enumerable to the receiver.

		@method addObjects
		@param {Ember.Enumerable} objects the objects to add.
		@return {Object} receiver
	*/
	addObjects: function(objects) {
		Ember.beginPropertyChanges(this);
		forEach(objects, function(obj) { this.addObject(obj); }, this);
		Ember.endPropertyChanges(this);
		return this;
	},

	/**
		__Required.__ You must implement this method to apply this mixin.

		Attempts to remove the passed object from the receiver collection if the
		object is present in the collection. If the object is not present,
		this method has no effect.

		If the passed object is of a type not supported by the receiver,
		then this method should raise an exception.

		@method removeObject
		@param {Object} object The object to remove from the enumerable.
		@return {Object} the passed object
	*/
	removeObject: Ember.required(Function),


	/**
		Removes each object in the passed enumerable from the receiver.

		@method removeObjects
		@param {Ember.Enumerable} objects the objects to remove
		@return {Object} receiver
	*/
	removeObjects: function(objects) {
		Ember.beginPropertyChanges(this);
		forEach(objects, function(obj) { this.removeObject(obj); }, this);
		Ember.endPropertyChanges(this);
		return this;
	}

});

})();



(function() {
/**
@module ember
@submodule ember-runtime
*/
// ..........................................................
// CONSTANTS
//

var OUT_OF_RANGE_EXCEPTION = "Index out of range" ;
var EMPTY = [];

// ..........................................................
// HELPERS
//

var get = Ember.get, set = Ember.set;

/**
	This mixin defines the API for modifying array-like objects. These methods
	can be applied only to a collection that keeps its items in an ordered set.

	Note that an Array can change even if it does not implement this mixin.
	For example, one might implement a SparseArray that cannot be directly
	modified, but if its underlying enumerable changes, it will change also.

	@class MutableArray
	@namespace Ember
	@uses Ember.Array
	@uses Ember.MutableEnumerable
*/
Ember.MutableArray = Ember.Mixin.create(Ember.Array, Ember.MutableEnumerable, {

	/**
		__Required.__ You must implement this method to apply this mixin.

		This is one of the primitives you must implement to support `Ember.Array`.
		You should replace amt objects started at idx with the objects in the
		passed array. You should also call `this.enumerableContentDidChange()`

		@method replace
		@param {Number} idx Starting index in the array to replace. If
			idx >= length, then append to the end of the array.
		@param {Number} amt Number of elements that should be removed from
			the array, starting at *idx*.
		@param {Array} objects An array of zero or more objects that should be
			inserted into the array at *idx*
	*/
	replace: Ember.required(),

	/**
		Remove all elements from self. This is useful if you
		want to reuse an existing array without having to recreate it.

		```javascript
		var colors = ["red", "green", "blue"];
		color.length();   //  3
		colors.clear();   //  []
		colors.length();  //  0
		```

		@method clear
		@return {Ember.Array} An empty Array.
	*/
	clear: function () {
		var len = get(this, 'length');
		if (len === 0) return this;
		this.replace(0, len, EMPTY);
		return this;
	},

	/**
		This will use the primitive `replace()` method to insert an object at the
		specified index.

		```javascript
		var colors = ["red", "green", "blue"];
		colors.insertAt(2, "yellow");  // ["red", "green", "yellow", "blue"]
		colors.insertAt(5, "orange");  // Error: Index out of range
		```

		@method insertAt
		@param {Number} idx index of insert the object at.
		@param {Object} object object to insert
		@return this
	*/
	insertAt: function(idx, object) {
		if (idx > get(this, 'length')) throw new Ember.Error(OUT_OF_RANGE_EXCEPTION) ;
		this.replace(idx, 0, [object]) ;
		return this ;
	},

	/**
		Remove an object at the specified index using the `replace()` primitive
		method. You can pass either a single index, or a start and a length.

		If you pass a start and length that is beyond the
		length this method will throw an `OUT_OF_RANGE_EXCEPTION`.

		```javascript
		var colors = ["red", "green", "blue", "yellow", "orange"];
		colors.removeAt(0);     // ["green", "blue", "yellow", "orange"]
		colors.removeAt(2, 2);  // ["green", "blue"]
		colors.removeAt(4, 2);  // Error: Index out of range
		```

		@method removeAt
		@param {Number} start index, start of range
		@param {Number} len length of passing range
		@return {Object} receiver
	*/
	removeAt: function(start, len) {
		if ('number' === typeof start) {

			if ((start < 0) || (start >= get(this, 'length'))) {
				throw new Ember.Error(OUT_OF_RANGE_EXCEPTION);
			}

			// fast case
			if (len === undefined) len = 1;
			this.replace(start, len, EMPTY);
		}

		return this ;
	},

	/**
		Push the object onto the end of the array. Works just like `push()` but it
		is KVO-compliant.

		```javascript
		var colors = ["red", "green"];
		colors.pushObject("black");     // ["red", "green", "black"]
		colors.pushObject(["yellow"]);  // ["red", "green", ["yellow"]]
		```

		@method pushObject
		@param {*} obj object to push
		@return The same obj passed as param
	*/
	pushObject: function(obj) {
		this.insertAt(get(this, 'length'), obj) ;
		return obj;
	},

	/**
		Add the objects in the passed numerable to the end of the array. Defers
		notifying observers of the change until all objects are added.

		```javascript
		var colors = ["red"];
		colors.pushObjects(["yellow", "orange"]);  // ["red", "yellow", "orange"]
		```

		@method pushObjects
		@param {Ember.Enumerable} objects the objects to add
		@return {Ember.Array} receiver
	*/
	pushObjects: function(objects) {
		if (!(Ember.Enumerable.detect(objects) || Ember.isArray(objects))) {
			throw new TypeError("Must pass Ember.Enumerable to Ember.MutableArray#pushObjects");
		}
		this.replace(get(this, 'length'), 0, objects);
		return this;
	},

	/**
		Pop object from array or nil if none are left. Works just like `pop()` but
		it is KVO-compliant.

		```javascript
		var colors = ["red", "green", "blue"];
		colors.popObject();   // "blue"
		console.log(colors);  // ["red", "green"]
		```

		@method popObject
		@return object
	*/
	popObject: function() {
		var len = get(this, 'length') ;
		if (len === 0) return null ;

		var ret = this.objectAt(len-1) ;
		this.removeAt(len-1, 1) ;
		return ret ;
	},

	/**
		Shift an object from start of array or nil if none are left. Works just
		like `shift()` but it is KVO-compliant.

		```javascript
		var colors = ["red", "green", "blue"];
		colors.shiftObject();  // "red"
		console.log(colors);   // ["green", "blue"]
		```

		@method shiftObject
		@return object
	*/
	shiftObject: function() {
		if (get(this, 'length') === 0) return null ;
		var ret = this.objectAt(0) ;
		this.removeAt(0) ;
		return ret ;
	},

	/**
		Unshift an object to start of array. Works just like `unshift()` but it is
		KVO-compliant.

		```javascript
		var colors = ["red"];
		colors.unshiftObject("yellow");    // ["yellow", "red"]
		colors.unshiftObject(["black"]);   // [["black"], "yellow", "red"]
		```

		@method unshiftObject
		@param {*} obj object to unshift
		@return The same obj passed as param
	*/
	unshiftObject: function(obj) {
		this.insertAt(0, obj) ;
		return obj ;
	},

	/**
		Adds the named objects to the beginning of the array. Defers notifying
		observers until all objects have been added.

		```javascript
		var colors = ["red"];
		colors.unshiftObjects(["black", "white"]);   // ["black", "white", "red"]
		colors.unshiftObjects("yellow"); // Type Error: 'undefined' is not a function
		```

		@method unshiftObjects
		@param {Ember.Enumerable} objects the objects to add
		@return {Ember.Array} receiver
	*/
	unshiftObjects: function(objects) {
		this.replace(0, 0, objects);
		return this;
	},

	/**
		Reverse objects in the array. Works just like `reverse()` but it is
		KVO-compliant.

		@method reverseObjects
		@return {Ember.Array} receiver
	 */
	reverseObjects: function() {
		var len = get(this, 'length');
		if (len === 0) return this;
		var objects = this.toArray().reverse();
		this.replace(0, len, objects);
		return this;
	},

	/**
		Replace all the the receiver's content with content of the argument.
		If argument is an empty array receiver will be cleared.

		```javascript
		var colors = ["red", "green", "blue"];
		colors.setObjects(["black", "white"]);  // ["black", "white"]
		colors.setObjects([]);                  // []
		```

		@method setObjects
		@param {Ember.Array} objects array whose content will be used for replacing
				the content of the receiver
		@return {Ember.Array} receiver with the new content
	 */
	setObjects: function(objects) {
		if (objects.length === 0) return this.clear();

		var len = get(this, 'length');
		this.replace(0, len, objects);
		return this;
	},

	// ..........................................................
	// IMPLEMENT Ember.MutableEnumerable
	//

	removeObject: function(obj) {
		var loc = get(this, 'length') || 0;
		while(--loc >= 0) {
			var curObject = this.objectAt(loc) ;
			if (curObject === obj) this.removeAt(loc) ;
		}
		return this ;
	},

	addObject: function(obj) {
		if (!this.contains(obj)) this.pushObject(obj);
		return this ;
	}

});

})();



(function() {
/**
@module ember
@submodule ember-runtime
*/

var get = Ember.get, set = Ember.set;

/**
`Ember.TargetActionSupport` is a mixin that can be included in a class
to add a `triggerAction` method with semantics similar to the Handlebars
`{{action}}` helper. In normal Ember usage, the `{{action}}` helper is
usually the best choice. This mixin is most often useful when you are
doing more complex event handling in View objects.

See also `Ember.ViewTargetActionSupport`, which has
view-aware defaults for target and actionContext.

@class TargetActionSupport
@namespace Ember
@extends Ember.Mixin
*/
Ember.TargetActionSupport = Ember.Mixin.create({
	target: null,
	action: null,
	actionContext: null,

	targetObject: Ember.computed(function() {
		var target = get(this, 'target');

		if (Ember.typeOf(target) === "string") {
			var value = get(this, target);
			if (value === undefined) { value = get(Ember.lookup, target); }
			return value;
		} else {
			return target;
		}
	}).property('target'),

	actionContextObject: Ember.computed(function() {
		var actionContext = get(this, 'actionContext');

		if (Ember.typeOf(actionContext) === "string") {
			var value = get(this, actionContext);
			if (value === undefined) { value = get(Ember.lookup, actionContext); }
			return value;
		} else {
			return actionContext;
		}
	}).property('actionContext'),

	/**
	Send an "action" with an "actionContext" to a "target". The action, actionContext
	and target will be retrieved from properties of the object. For example:

	```javascript
	App.SaveButtonView = Ember.View.extend(Ember.TargetActionSupport, {
		target: Ember.computed.alias('controller'),
		action: 'save',
		actionContext: Ember.computed.alias('context'),
		click: function() {
			this.triggerAction(); // Sends the `save` action, along with the current context
														// to the current controller
		}
	});
	```

	The `target`, `action`, and `actionContext` can be provided as properties of
	an optional object argument to `triggerAction` as well.

	```javascript
	App.SaveButtonView = Ember.View.extend(Ember.TargetActionSupport, {
		click: function() {
			this.triggerAction({
				action: 'save',
				target: this.get('controller'),
				actionContext: this.get('context'),
			}); // Sends the `save` action, along with the current context
					// to the current controller
		}
	});
	```

	The `actionContext` defaults to the object you mixing `TargetActionSupport` into.
	But `target` and `action` must be specified either as properties or with the argument
	to `triggerAction`, or a combination:

	```javascript
	App.SaveButtonView = Ember.View.extend(Ember.TargetActionSupport, {
		target: Ember.computed.alias('controller'),
		click: function() {
			this.triggerAction({
				action: 'save'
			}); // Sends the `save` action, along with a reference to `this`,
					// to the current controller
		}
	});
	```

	@method triggerAction
	@param opts {Hash} (optional, with the optional keys action, target and/or actionContext)
	@return {Boolean} true if the action was sent successfully and did not return false
	*/
	triggerAction: function(opts) {
		opts = opts || {};
		var action = opts.action || get(this, 'action'),
				target = opts.target || get(this, 'targetObject'),
				actionContext = opts.actionContext;

		function args(options, actionName) {
			var ret = [];
			if (actionName) { ret.push(actionName); }

			return ret.concat(options);
		}

		if (typeof actionContext === 'undefined') {
			actionContext = get(this, 'actionContextObject') || this;
		}

		if (target && action) {
			var ret;

			if (target.send) {
				ret = target.send.apply(target, args(actionContext, action));
			} else {
								ret = target[action].apply(target, args(actionContext));
			}

			if (ret !== false) ret = true;

			return ret;
		} else {
			return false;
		}
	}
});

})();



(function() {
/**
@module ember
@submodule ember-runtime
*/

/**
	This mixin allows for Ember objects to subscribe to and emit events.

	```javascript
	App.Person = Ember.Object.extend(Ember.Evented, {
		greet: function() {
			// ...
			this.trigger('greet');
		}
	});

	var person = App.Person.create();

	person.on('greet', function() {
		console.log('Our person has greeted');
	});

	person.greet();

	// outputs: 'Our person has greeted'
	```

	You can also chain multiple event subscriptions:

	```javascript
	person.on('greet', function() {
		console.log('Our person has greeted');
	}).one('greet', function() {
		console.log('Offer one-time special');
	}).off('event', this, forgetThis);
	```

	@class Evented
	@namespace Ember
 */
Ember.Evented = Ember.Mixin.create({

	/**
	 Subscribes to a named event with given function.

	 ```javascript
	 person.on('didLoad', function() {
		 // fired once the person has loaded
	 });
	 ```

	 An optional target can be passed in as the 2nd argument that will
	 be set as the "this" for the callback. This is a good way to give your
	 function access to the object triggering the event. When the target
	 parameter is used the callback becomes the third argument.

	 @method on
	 @param {String} name The name of the event
	 @param {Object} [target] The "this" binding for the callback
	 @param {Function} method The callback to execute
	 @return this
	*/
	on: function(name, target, method) {
		Ember.addListener(this, name, target, method);
		return this;
	},

	/**
		Subscribes a function to a named event and then cancels the subscription
		after the first time the event is triggered. It is good to use ``one`` when
		you only care about the first time an event has taken place.

		This function takes an optional 2nd argument that will become the "this"
		value for the callback. If this argument is passed then the 3rd argument
		becomes the function.

		@method one
		@param {String} name The name of the event
		@param {Object} [target] The "this" binding for the callback
		@param {Function} method The callback to execute
		@return this
	*/
	one: function(name, target, method) {
		if (!method) {
			method = target;
			target = null;
		}

		Ember.addListener(this, name, target, method, true);
		return this;
	},

	/**
		Triggers a named event for the object. Any additional arguments
		will be passed as parameters to the functions that are subscribed to the
		event.

		```javascript
		person.on('didEat', function(food) {
			console.log('person ate some ' + food);
		});

		person.trigger('didEat', 'broccoli');

		// outputs: person ate some broccoli
		```
		@method trigger
		@param {String} name The name of the event
		@param {Object...} args Optional arguments to pass on
	*/
	trigger: function(name) {
		var args = [], i, l;
		for (i = 1, l = arguments.length; i < l; i++) {
			args.push(arguments[i]);
		}
		Ember.sendEvent(this, name, args);
	},

	/**
		Cancels subscription for given name, target, and method.

		@method off
		@param {String} name The name of the event
		@param {Object} target The target of the subscription
		@param {Function} method The function of the subscription
		@return this
	*/
	off: function(name, target, method) {
		Ember.removeListener(this, name, target, method);
		return this;
	},

	/**
		Checks to see if object has any subscriptions for named event.

		@method has
		@param {String} name The name of the event
		@return {Boolean} does the object have a subscription for event
	 */
	has: function(name) {
		return Ember.hasListeners(this, name);
	}
});

})();



(function() {
var RSVP = requireModule("rsvp");

RSVP.configure('async', function(callback, promise) {
	Ember.run.schedule('actions', promise, callback, promise);
});

RSVP.Promise.prototype.fail = function(callback, label){
		return this['catch'](callback, label);
};

/**
@module ember
@submodule ember-runtime
*/

var get = Ember.get;

/**
	@class Deferred
	@namespace Ember
 */
Ember.DeferredMixin = Ember.Mixin.create({
	/**
		Add handlers to be called when the Deferred object is resolved or rejected.

		@method then
		@param {Function} resolve a callback function to be called when done
		@param {Function} reject  a callback function to be called when failed
	*/
	then: function(resolve, reject, label) {
		var deferred, promise, entity;

		entity = this;
		deferred = get(this, '_deferred');
		promise = deferred.promise;

		function fulfillmentHandler(fulfillment) {
			if (fulfillment === promise) {
				return resolve(entity);
			} else {
				return resolve(fulfillment);
			}
		}

		return promise.then(resolve && fulfillmentHandler, reject, label);
	},

	/**
		Resolve a Deferred object and call any `doneCallbacks` with the given args.

		@method resolve
	*/
	resolve: function(value) {
		var deferred, promise;

		deferred = get(this, '_deferred');
		promise = deferred.promise;

		if (value === this) {
			deferred.resolve(promise);
		} else {
			deferred.resolve(value);
		}
	},

	/**
		Reject a Deferred object and call any `failCallbacks` with the given args.

		@method reject
	*/
	reject: function(value) {
		get(this, '_deferred').reject(value);
	},

	_deferred: Ember.computed(function() {
		return RSVP.defer('Ember: DeferredMixin - ' + this);
	})
});


})();



(function() {
/**
@module ember
@submodule ember-runtime
*/

var get = Ember.get, typeOf = Ember.typeOf;

/**
	The `Ember.ActionHandler` mixin implements support for moving an `actions`
	property to an `_actions` property at extend time, and adding `_actions`
	to the object's mergedProperties list.

	`Ember.ActionHandler` is used internally by Ember in  `Ember.View`,
	`Ember.Controller`, and `Ember.Route`.

	@class ActionHandler
	@namespace Ember
*/
Ember.ActionHandler = Ember.Mixin.create({
	mergedProperties: ['_actions'],

	/**
		The collection of functions, keyed by name, available on this
		`ActionHandler` as action targets.

		These functions will be invoked when a matching `{{action}}` is triggered
		from within a template and the application's current route is this route.

		Actions can also be invoked from other parts of your application
		via `ActionHandler#send`.

		The `actions` hash will inherit action handlers from
		the `actions` hash defined on extended parent classes
		or mixins rather than just replace the entire hash, e.g.:

		```js
		App.CanDisplayBanner = Ember.Mixin.create({
			actions: {
				displayBanner: function(msg) {
					// ...
				}
			}
		});

		App.WelcomeRoute = Ember.Route.extend(App.CanDisplayBanner, {
			actions: {
				playMusic: function() {
					// ...
				}
			}
		});

		// `WelcomeRoute`, when active, will be able to respond
		// to both actions, since the actions hash is merged rather
		// then replaced when extending mixins / parent classes.
		this.send('displayBanner');
		this.send('playMusic');
		```

		Within a Controller, Route, View or Component's action handler,
		the value of the `this` context is the Controller, Route, View or
		Component object:

		```js
		App.SongRoute = Ember.Route.extend({
			actions: {
				myAction: function() {
					this.controllerFor("song");
					this.transitionTo("other.route");
					...
				}
			}
		});
		```

		It is also possible to call `this._super()` from within an
		action handler if it overrides a handler defined on a parent
		class or mixin:

		Take for example the following routes:

		```js
		App.DebugRoute = Ember.Mixin.create({
			actions: {
				debugRouteInformation: function() {
					console.debug("trololo");
				}
			}
		});

		App.AnnoyingDebugRoute = Ember.Route.extend(App.DebugRoute, {
			actions: {
				debugRouteInformation: function() {
					// also call the debugRouteInformation of mixed in App.DebugRoute
					this._super();

					// show additional annoyance
					window.alert(...);
				}
			}
		});
		```

		## Bubbling

		By default, an action will stop bubbling once a handler defined
		on the `actions` hash handles it. To continue bubbling the action,
		you must return `true` from the handler:

		```js
		App.Router.map(function() {
			this.resource("album", function() {
				this.route("song");
			});
		});

		App.AlbumRoute = Ember.Route.extend({
			actions: {
				startPlaying: function() {
				}
			}
		});

		App.AlbumSongRoute = Ember.Route.extend({
			actions: {
				startPlaying: function() {
					// ...

					if (actionShouldAlsoBeTriggeredOnParentRoute) {
						return true;
					}
				}
			}
		});
		```

		@property actions
		@type Hash
		@default null
	*/

	/**
		Moves `actions` to `_actions` at extend time. Note that this currently
		modifies the mixin themselves, which is technically dubious but
		is practically of little consequence. This may change in the future.

		@private
		@method willMergeMixin
	*/
	willMergeMixin: function(props) {
		var hashName;

		if (!props._actions) {

			if (typeOf(props.actions) === 'object') {
				hashName = 'actions';
			} else if (typeOf(props.events) === 'object') {
								hashName = 'events';
			}

			if (hashName) {
				props._actions = Ember.merge(props._actions || {}, props[hashName]);
			}

			delete props[hashName];
		}
	},

	send: function(actionName) {
		var args = [].slice.call(arguments, 1), target;

		if (this._actions && this._actions[actionName]) {
			if (this._actions[actionName].apply(this, args) === true) {
				// handler returned true, so this action will bubble
			} else {
				return;
			}
		} else if (!Ember.FEATURES.isEnabled('ember-routing-drop-deprecated-action-style') && this.deprecatedSend && this.deprecatedSendHandles && this.deprecatedSendHandles(actionName)) {
						if (this.deprecatedSend.apply(this, [].slice.call(arguments)) === true) {
				// handler return true, so this action will bubble
			} else {
				return;
			}
		}

		if (target = get(this, 'target')) {
						target.send.apply(target, arguments);
		}
	}

});

})();



(function() {
var set = Ember.set, get = Ember.get,
		not = Ember.computed.not,
		or = Ember.computed.or;

/**
	@module ember
	@submodule ember-runtime
 */

function tap(proxy, promise) {
	return promise.then(function(value) {
		set(proxy, 'isFulfilled', true);
		set(proxy, 'content', value);
		return value;
	}, function(reason) {
		set(proxy, 'isRejected', true);
		set(proxy, 'reason', reason);
		throw reason;
	}, "Ember: PromiseProxy");
}

/**
	A low level mixin making ObjectProxy, ObjectController or ArrayController's promise aware.

	```javascript
	var ObjectPromiseController = Ember.ObjectController.extend(Ember.PromiseProxyMixin);

	var controller = ObjectPromiseController.create({
		promise: $.getJSON('/some/remote/data.json')
	});

	controller.then(function(json){
		 // the json
	}, function(reason) {
		 // the reason why you have no json
	});
	```

	the controller has bindable attributes which
	track the promises life cycle

	```javascript
	controller.get('isPending')   //=> true
	controller.get('isSettled')  //=> false
	controller.get('isRejected')  //=> false
	controller.get('isFulfilled') //=> false
	```

	When the the $.getJSON completes, and the promise is fulfilled
	with json, the life cycle attributes will update accordingly.

	```javascript
	controller.get('isPending')   //=> false
	controller.get('isSettled')   //=> true
	controller.get('isRejected')  //=> false
	controller.get('isFulfilled') //=> true
	```

	As the controller is an ObjectController, and the json now its content,
	all the json properties will be available directly from the controller.

	```javascript
	// Assuming the following json:
	{
		firstName: 'Stefan',
		lastName: 'Penner'
	}

	// both properties will accessible on the controller
	controller.get('firstName') //=> 'Stefan'
	controller.get('lastName')  //=> 'Penner'
	```

	If the controller is backing a template, the attributes are
	bindable from within that template

	```handlebars
	{{#if isPending}}
		loading...
	{{else}}
		firstName: {{firstName}}
		lastName: {{lastName}}
	{{/if}}
	```
	@class Ember.PromiseProxyMixin
*/
Ember.PromiseProxyMixin = Ember.Mixin.create({
	/**
		If the proxied promise is rejected this will contain the reason
		provided.

		@property reason
		@default null
	*/
	reason:    null,

	/**
		Once the proxied promise has settled this will become `false`.

		@property isPending
		@default true
	*/
	isPending:  not('isSettled').readOnly(),

	/**
		Once the proxied promise has settled this will become `true`.

		@property isSettled
		@default false
	*/
	isSettled:  or('isRejected', 'isFulfilled').readOnly(),

	/**
		Will become `true` if the proxied promise is rejected.

		@property isRejected
		@default false
	*/
	isRejected:  false,

	/**
		Will become `true` if the proxied promise is fulfilled.

		@property isFullfilled
		@default false
	*/
	isFulfilled: false,

	/**
		The promise whose fulfillment value is being proxied by this object.

		This property must be specified upon creation, and should not be
		changed once created.

		Example:

		```javascript
		Ember.ObjectController.extend(Ember.PromiseProxyMixin).create({
			promise: <thenable>
		});
		```

		@property promise
	*/
	promise: Ember.computed(function(key, promise) {
		if (arguments.length === 2) {
			return tap(this, promise);
		} else {
			throw new Ember.Error("PromiseProxy's promise must be set");
		}
	}),

	/**
		An alias to the proxied promise's `then`.

		See RSVP.Promise.then.

		@method then
		@param {Function} callback
		@return {RSVP.Promise}
	*/
	then: promiseAlias('then'),

	/**
		An alias to the proxied promise's `catch`.

		See RSVP.Promise.catch.

		@method catch
		@param {Function} callback
		@return {RSVP.Promise}
	*/
	'catch': promiseAlias('catch'),

	/**
		An alias to the proxied promise's `finally`.

		See RSVP.Promise.finally.

		@method finally
		@param {Function} callback
		@return {RSVP.Promise}
	*/
	'finally': promiseAlias('finally')

});

function promiseAlias(name) {
	return function () {
		var promise = get(this, 'promise');
		return promise[name].apply(promise, arguments);
	};
}

})();



(function() {

})();



(function() {
var get = Ember.get,
		forEach = Ember.EnumerableUtils.forEach,
		RETAIN = 'r',
		INSERT = 'i',
		DELETE = 'd';

/**
	An `Ember.TrackedArray` tracks array operations.  It's useful when you want to
	lazily compute the indexes of items in an array after they've been shifted by
	subsequent operations.

	@class TrackedArray
	@namespace Ember
	@param {array} [items=[]] The array to be tracked.  This is used just to get
	the initial items for the starting state of retain:n.
*/
Ember.TrackedArray = function (items) {
	if (arguments.length < 1) { items = []; }

	var length = get(items, 'length');

	if (length) {
		this._operations = [new ArrayOperation(RETAIN, length, items)];
	} else {
		this._operations = [];
	}
};

Ember.TrackedArray.RETAIN = RETAIN;
Ember.TrackedArray.INSERT = INSERT;
Ember.TrackedArray.DELETE = DELETE;

Ember.TrackedArray.prototype = {

	/**
		Track that `newItems` were added to the tracked array at `index`.

		@method addItems
		@param index
		@param newItems
	*/
	addItems: function (index, newItems) {
		var count = get(newItems, 'length');
		if (count < 1) { return; }

		var match = this._findArrayOperation(index),
				arrayOperation = match.operation,
				arrayOperationIndex = match.index,
				arrayOperationRangeStart = match.rangeStart,
				composeIndex,
				splitIndex,
				splitItems,
				splitArrayOperation,
				newArrayOperation;

		newArrayOperation = new ArrayOperation(INSERT, count, newItems);

		if (arrayOperation) {
			if (!match.split) {
				// insert left of arrayOperation
				this._operations.splice(arrayOperationIndex, 0, newArrayOperation);
				composeIndex = arrayOperationIndex;
			} else {
				this._split(arrayOperationIndex, index - arrayOperationRangeStart, newArrayOperation);
				composeIndex = arrayOperationIndex + 1;
			}
		} else {
			// insert at end
			this._operations.push(newArrayOperation);
			composeIndex = arrayOperationIndex;
		}

		this._composeInsert(composeIndex);
	},

	/**
		Track that `count` items were removed at `index`.

		@method removeItems
		@param index
		@param count
	*/
	removeItems: function (index, count) {
		if (count < 1) { return; }

		var match = this._findArrayOperation(index),
				arrayOperation = match.operation,
				arrayOperationIndex = match.index,
				arrayOperationRangeStart = match.rangeStart,
				newArrayOperation,
				composeIndex;

		newArrayOperation = new ArrayOperation(DELETE, count);
		if (!match.split) {
			// insert left of arrayOperation
			this._operations.splice(arrayOperationIndex, 0, newArrayOperation);
			composeIndex = arrayOperationIndex;
		} else {
			this._split(arrayOperationIndex, index - arrayOperationRangeStart, newArrayOperation);
			composeIndex = arrayOperationIndex + 1;
		}

		return this._composeDelete(composeIndex);
	},

	/**
		Apply all operations, reducing them to retain:n, for `n`, the number of
		items in the array.

		`callback` will be called for each operation and will be passed the following arguments:

		* {array} items The items for the given operation
		* {number} offset The computed offset of the items, ie the index in the
		array of the first item for this operation.
		* {string} operation The type of the operation.  One of
		`Ember.TrackedArray.{RETAIN, DELETE, INSERT}`

		@method apply
		@param {function} callback
	*/
	apply: function (callback) {
		var items = [],
				offset = 0;

		forEach(this._operations, function (arrayOperation) {
			callback(arrayOperation.items, offset, arrayOperation.type);

			if (arrayOperation.type !== DELETE) {
				offset += arrayOperation.count;
				items = items.concat(arrayOperation.items);
			}
		});

		this._operations = [new ArrayOperation(RETAIN, items.length, items)];
	},

	/**
		Return an `ArrayOperationMatch` for the operation that contains the item at `index`.

		@method _findArrayOperation

		@param {number} index the index of the item whose operation information
		should be returned.
		@private
	*/
	_findArrayOperation: function (index) {
		var arrayOperationIndex,
				len,
				split = false,
				arrayOperation,
				arrayOperationRangeStart,
				arrayOperationRangeEnd;

		// OPTIMIZE: we could search these faster if we kept a balanced tree.
		// find leftmost arrayOperation to the right of `index`
		for (arrayOperationIndex = arrayOperationRangeStart = 0, len = this._operations.length; arrayOperationIndex < len; ++arrayOperationIndex) {
			arrayOperation = this._operations[arrayOperationIndex];

			if (arrayOperation.type === DELETE) { continue; }

			arrayOperationRangeEnd = arrayOperationRangeStart + arrayOperation.count - 1;

			if (index === arrayOperationRangeStart) {
				break;
			} else if (index > arrayOperationRangeStart && index <= arrayOperationRangeEnd) {
				split = true;
				break;
			} else {
				arrayOperationRangeStart = arrayOperationRangeEnd + 1;
			}
		}

		return new ArrayOperationMatch(arrayOperation, arrayOperationIndex, split, arrayOperationRangeStart);
	},

	_split: function (arrayOperationIndex, splitIndex, newArrayOperation) {
		var arrayOperation = this._operations[arrayOperationIndex],
				splitItems = arrayOperation.items.slice(splitIndex),
				splitArrayOperation = new ArrayOperation(arrayOperation.type, splitItems.length, splitItems);

		// truncate LHS
		arrayOperation.count = splitIndex;
		arrayOperation.items = arrayOperation.items.slice(0, splitIndex);

		this._operations.splice(arrayOperationIndex + 1, 0, newArrayOperation, splitArrayOperation);
	},

	// see SubArray for a better implementation.
	_composeInsert: function (index) {
		var newArrayOperation = this._operations[index],
				leftArrayOperation = this._operations[index-1], // may be undefined
				rightArrayOperation = this._operations[index+1], // may be undefined
				leftOp = leftArrayOperation && leftArrayOperation.type,
				rightOp = rightArrayOperation && rightArrayOperation.type;

		if (leftOp === INSERT) {
				// merge left
				leftArrayOperation.count += newArrayOperation.count;
				leftArrayOperation.items = leftArrayOperation.items.concat(newArrayOperation.items);

			if (rightOp === INSERT) {
				// also merge right (we have split an insert with an insert)
				leftArrayOperation.count += rightArrayOperation.count;
				leftArrayOperation.items = leftArrayOperation.items.concat(rightArrayOperation.items);
				this._operations.splice(index, 2);
			} else {
				// only merge left
				this._operations.splice(index, 1);
			}
		} else if (rightOp === INSERT) {
			// merge right
			newArrayOperation.count += rightArrayOperation.count;
			newArrayOperation.items = newArrayOperation.items.concat(rightArrayOperation.items);
			this._operations.splice(index + 1, 1);
		}
	},

	_composeDelete: function (index) {
		var arrayOperation = this._operations[index],
				deletesToGo = arrayOperation.count,
				leftArrayOperation = this._operations[index-1], // may be undefined
				leftOp = leftArrayOperation && leftArrayOperation.type,
				nextArrayOperation,
				nextOp,
				nextCount,
				removeNewAndNextOp = false,
				removedItems = [];

		if (leftOp === DELETE) {
			arrayOperation = leftArrayOperation;
			index -= 1;
		}

		for (var i = index + 1; deletesToGo > 0; ++i) {
			nextArrayOperation = this._operations[i];
			nextOp = nextArrayOperation.type;
			nextCount = nextArrayOperation.count;

			if (nextOp === DELETE) {
				arrayOperation.count += nextCount;
				continue;
			}

			if (nextCount > deletesToGo) {
				// d:2 {r,i}:5  we reduce the retain or insert, but it stays
				removedItems = removedItems.concat(nextArrayOperation.items.splice(0, deletesToGo));
				nextArrayOperation.count -= deletesToGo;

				// In the case where we truncate the last arrayOperation, we don't need to
				// remove it; also the deletesToGo reduction is not the entirety of
				// nextCount
				i -= 1;
				nextCount = deletesToGo;

				deletesToGo = 0;
			} else {
				if (nextCount === deletesToGo) {
					// Handle edge case of d:2 i:2 in which case both operations go away
					// during composition.
					removeNewAndNextOp = true;
				}
				removedItems = removedItems.concat(nextArrayOperation.items);
				deletesToGo -= nextCount;
			}

			if (nextOp === INSERT) {
				// d:2 i:3 will result in delete going away
				arrayOperation.count -= nextCount;
			}
		}

		if (arrayOperation.count > 0) {
			// compose our new delete with possibly several operations to the right of
			// disparate types
			this._operations.splice(index+1, i-1-index);
		} else {
			// The delete operation can go away; it has merely reduced some other
			// operation, as in d:3 i:4; it may also have eliminated that operation,
			// as in d:3 i:3.
			this._operations.splice(index, removeNewAndNextOp ? 2 : 1);
		}

		return removedItems;
	},

	toString: function () {
		var str = "";
		forEach(this._operations, function (operation) {
			str += " " + operation.type + ":" + operation.count;
		});
		return str.substring(1);
	}
};

/**
	Internal data structure to represent an array operation.

	@method ArrayOperation
	@private
	@param {string} type The type of the operation.  One of
	`Ember.TrackedArray.{RETAIN, INSERT, DELETE}`
	@param {number} count The number of items in this operation.
	@param {array} items The items of the operation, if included.  RETAIN and
	INSERT include their items, DELETE does not.
*/
function ArrayOperation (operation, count, items) {
	this.type = operation; // RETAIN | INSERT | DELETE
	this.count = count;
	this.items = items;
}

/**
	Internal data structure used to include information when looking up operations
	by item index.

	@method ArrayOperationMatch
	@private
	@param {ArrayOperation} operation
	@param {number} index The index of `operation` in the array of operations.
	@param {boolean} split Whether or not the item index searched for would
	require a split for a new operation type.
	@param {number} rangeStart The index of the first item in the operation,
	with respect to the tracked array.  The index of the last item can be computed
	from `rangeStart` and `operation.count`.
*/
function ArrayOperationMatch(operation, index, split, rangeStart) {
	this.operation = operation;
	this.index = index;
	this.split = split;
	this.rangeStart = rangeStart;
}

})();



(function() {
var get = Ember.get,
		forEach = Ember.EnumerableUtils.forEach,
		RETAIN = 'r',
		FILTER = 'f';

function Operation (type, count) {
	this.type = type;
	this.count = count;
}

/**
	An `Ember.SubArray` tracks an array in a way similar to, but more specialized
	than, `Ember.TrackedArray`.  It is useful for keeping track of the indexes of
	items within a filtered array.

	@class SubArray
	@namespace Ember
*/
Ember.SubArray = function (length) {
	if (arguments.length < 1) { length = 0; }

	if (length > 0) {
		this._operations = [new Operation(RETAIN, length)];
	} else {
		this._operations = [];
	}
};

Ember.SubArray.prototype = {
	/**
		Track that an item was added to the tracked array.

		@method addItem

		@param {number} index The index of the item in the tracked array.
		@param {boolean} match `true` iff the item is included in the subarray.

		@return {number} The index of the item in the subarray.
	*/
	addItem: function(index, match) {
		var returnValue = -1,
				itemType = match ? RETAIN : FILTER,
				self = this;

		this._findOperation(index, function(operation, operationIndex, rangeStart, rangeEnd, seenInSubArray) {
			var newOperation, splitOperation;

			if (itemType === operation.type) {
				++operation.count;
			} else if (index === rangeStart) {
				// insert to the left of `operation`
				self._operations.splice(operationIndex, 0, new Operation(itemType, 1));
			} else {
				newOperation = new Operation(itemType, 1);
				splitOperation = new Operation(operation.type, rangeEnd - index + 1);
				operation.count = index - rangeStart;

				self._operations.splice(operationIndex + 1, 0, newOperation, splitOperation);
			}

			if (match) {
				if (operation.type === RETAIN) {
					returnValue = seenInSubArray + (index - rangeStart);
				} else {
					returnValue = seenInSubArray;
				}
			}

			self._composeAt(operationIndex);
		}, function(seenInSubArray) {
			self._operations.push(new Operation(itemType, 1));

			if (match) {
				returnValue = seenInSubArray;
			}

			self._composeAt(self._operations.length-1);
		});

		return returnValue;
	},

	/**
		Track that an item was removed from the tracked array.

		@method removeItem

		@param {number} index The index of the item in the tracked array.

		@return {number} The index of the item in the subarray, or `-1` if the item
		was not in the subarray.
	*/
	removeItem: function(index) {
		var returnValue = -1,
				self = this;

		this._findOperation(index, function (operation, operationIndex, rangeStart, rangeEnd, seenInSubArray) {
			if (operation.type === RETAIN) {
				returnValue = seenInSubArray + (index - rangeStart);
			}

			if (operation.count > 1) {
				--operation.count;
			} else {
				self._operations.splice(operationIndex, 1);
				self._composeAt(operationIndex);
			}
		}, function() {
			throw new Ember.Error("Can't remove an item that has never been added.");
		});

		return returnValue;
	},


	_findOperation: function (index, foundCallback, notFoundCallback) {
		var operationIndex,
				len,
				operation,
				rangeStart,
				rangeEnd,
				seenInSubArray = 0;

		// OPTIMIZE: change to balanced tree
		// find leftmost operation to the right of `index`
		for (operationIndex = rangeStart = 0, len = this._operations.length; operationIndex < len; rangeStart = rangeEnd + 1, ++operationIndex) {
			operation = this._operations[operationIndex];
			rangeEnd = rangeStart + operation.count - 1;

			if (index >= rangeStart && index <= rangeEnd) {
				foundCallback(operation, operationIndex, rangeStart, rangeEnd, seenInSubArray);
				return;
			} else if (operation.type === RETAIN) {
				seenInSubArray += operation.count;
			}
		}

		notFoundCallback(seenInSubArray);
	},

	_composeAt: function(index) {
		var op = this._operations[index],
				otherOp;

		if (!op) {
			// Composing out of bounds is a no-op, as when removing the last operation
			// in the list.
			return;
		}

		if (index > 0) {
			otherOp = this._operations[index-1];
			if (otherOp.type === op.type) {
				op.count += otherOp.count;
				this._operations.splice(index-1, 1);
				--index;
			}
		}

		if (index < this._operations.length-1) {
			otherOp = this._operations[index+1];
			if (otherOp.type === op.type) {
				op.count += otherOp.count;
				this._operations.splice(index+1, 1);
			}
		}
	},

	toString: function () {
		var str = "";
		forEach(this._operations, function (operation) {
			str += " " + operation.type + ":" + operation.count;
		});
		return str.substring(1);
	}
};

})();



(function() {
Ember.Container = requireModule('container');
Ember.Container.set = Ember.set;

})();



(function() {
Ember.Application = Ember.Namespace.extend();

})();



(function() {
/**
@module ember
@submodule ember-runtime
*/

var OUT_OF_RANGE_EXCEPTION = "Index out of range";
var EMPTY = [];

var get = Ember.get, set = Ember.set;

/**
	An ArrayProxy wraps any other object that implements `Ember.Array` and/or
	`Ember.MutableArray,` forwarding all requests. This makes it very useful for
	a number of binding use cases or other cases where being able to swap
	out the underlying array is useful.

	A simple example of usage:

	```javascript
	var pets = ['dog', 'cat', 'fish'];
	var ap = Ember.ArrayProxy.create({ content: Ember.A(pets) });

	ap.get('firstObject');                        // 'dog'
	ap.set('content', ['amoeba', 'paramecium']);
	ap.get('firstObject');                        // 'amoeba'
	```

	This class can also be useful as a layer to transform the contents of
	an array, as they are accessed. This can be done by overriding
	`objectAtContent`:

	```javascript
	var pets = ['dog', 'cat', 'fish'];
	var ap = Ember.ArrayProxy.create({
			content: Ember.A(pets),
			objectAtContent: function(idx) {
					return this.get('content').objectAt(idx).toUpperCase();
			}
	});

	ap.get('firstObject'); // . 'DOG'
	```

	@class ArrayProxy
	@namespace Ember
	@extends Ember.Object
	@uses Ember.MutableArray
*/
Ember.ArrayProxy = Ember.Object.extend(Ember.MutableArray, {

	/**
		The content array. Must be an object that implements `Ember.Array` and/or
		`Ember.MutableArray.`

		@property content
		@type Ember.Array
	*/
	content: null,

	/**
	 The array that the proxy pretends to be. In the default `ArrayProxy`
	 implementation, this and `content` are the same. Subclasses of `ArrayProxy`
	 can override this property to provide things like sorting and filtering.

	 @property arrangedContent
	*/
	arrangedContent: Ember.computed.alias('content'),

	/**
		Should actually retrieve the object at the specified index from the
		content. You can override this method in subclasses to transform the
		content item to something new.

		This method will only be called if content is non-`null`.

		@method objectAtContent
		@param {Number} idx The index to retrieve.
		@return {Object} the value or undefined if none found
	*/
	objectAtContent: function(idx) {
		return get(this, 'arrangedContent').objectAt(idx);
	},

	/**
		Should actually replace the specified objects on the content array.
		You can override this method in subclasses to transform the content item
		into something new.

		This method will only be called if content is non-`null`.

		@method replaceContent
		@param {Number} idx The starting index
		@param {Number} amt The number of items to remove from the content.
		@param {Array} objects Optional array of objects to insert or null if no
			objects.
		@return {void}
	*/
	replaceContent: function(idx, amt, objects) {
		get(this, 'content').replace(idx, amt, objects);
	},

	/**
		Invoked when the content property is about to change. Notifies observers that the
		entire array content will change.

		@private
		@method _contentWillChange
	*/
	_contentWillChange: Ember.beforeObserver('content', function() {
		this._teardownContent();
	}),

	_teardownContent: function() {
		var content = get(this, 'content');

		if (content) {
			content.removeArrayObserver(this, {
				willChange: 'contentArrayWillChange',
				didChange: 'contentArrayDidChange'
			});
		}
	},

	contentArrayWillChange: Ember.K,
	contentArrayDidChange: Ember.K,

	/**
		Invoked when the content property changes. Notifies observers that the
		entire array content has changed.

		@private
		@method _contentDidChange
	*/
	_contentDidChange: Ember.observer('content', function() {
		var content = get(this, 'content');


		this._setupContent();
	}),

	_setupContent: function() {
		var content = get(this, 'content');

		if (content) {
			content.addArrayObserver(this, {
				willChange: 'contentArrayWillChange',
				didChange: 'contentArrayDidChange'
			});
		}
	},

	_arrangedContentWillChange: Ember.beforeObserver('arrangedContent', function() {
		var arrangedContent = get(this, 'arrangedContent'),
				len = arrangedContent ? get(arrangedContent, 'length') : 0;

		this.arrangedContentArrayWillChange(this, 0, len, undefined);
		this.arrangedContentWillChange(this);

		this._teardownArrangedContent(arrangedContent);
	}),

	_arrangedContentDidChange: Ember.observer('arrangedContent', function() {
		var arrangedContent = get(this, 'arrangedContent'),
				len = arrangedContent ? get(arrangedContent, 'length') : 0;


		this._setupArrangedContent();

		this.arrangedContentDidChange(this);
		this.arrangedContentArrayDidChange(this, 0, undefined, len);
	}),

	_setupArrangedContent: function() {
		var arrangedContent = get(this, 'arrangedContent');

		if (arrangedContent) {
			arrangedContent.addArrayObserver(this, {
				willChange: 'arrangedContentArrayWillChange',
				didChange: 'arrangedContentArrayDidChange'
			});
		}
	},

	_teardownArrangedContent: function() {
		var arrangedContent = get(this, 'arrangedContent');

		if (arrangedContent) {
			arrangedContent.removeArrayObserver(this, {
				willChange: 'arrangedContentArrayWillChange',
				didChange: 'arrangedContentArrayDidChange'
			});
		}
	},

	arrangedContentWillChange: Ember.K,
	arrangedContentDidChange: Ember.K,

	objectAt: function(idx) {
		return get(this, 'content') && this.objectAtContent(idx);
	},

	length: Ember.computed(function() {
		var arrangedContent = get(this, 'arrangedContent');
		return arrangedContent ? get(arrangedContent, 'length') : 0;
		// No dependencies since Enumerable notifies length of change
	}),

	_replace: function(idx, amt, objects) {
		var content = get(this, 'content');
				if (content) this.replaceContent(idx, amt, objects);
		return this;
	},

	replace: function() {
		if (get(this, 'arrangedContent') === get(this, 'content')) {
			this._replace.apply(this, arguments);
		} else {
			throw new Ember.Error("Using replace on an arranged ArrayProxy is not allowed.");
		}
	},

	_insertAt: function(idx, object) {
		if (idx > get(this, 'content.length')) throw new Ember.Error(OUT_OF_RANGE_EXCEPTION);
		this._replace(idx, 0, [object]);
		return this;
	},

	insertAt: function(idx, object) {
		if (get(this, 'arrangedContent') === get(this, 'content')) {
			return this._insertAt(idx, object);
		} else {
			throw new Ember.Error("Using insertAt on an arranged ArrayProxy is not allowed.");
		}
	},

	removeAt: function(start, len) {
		if ('number' === typeof start) {
			var content = get(this, 'content'),
					arrangedContent = get(this, 'arrangedContent'),
					indices = [], i;

			if ((start < 0) || (start >= get(this, 'length'))) {
				throw new Ember.Error(OUT_OF_RANGE_EXCEPTION);
			}

			if (len === undefined) len = 1;

			// Get a list of indices in original content to remove
			for (i=start; i<start+len; i++) {
				// Use arrangedContent here so we avoid confusion with objects transformed by objectAtContent
				indices.push(content.indexOf(arrangedContent.objectAt(i)));
			}

			// Replace in reverse order since indices will change
			indices.sort(function(a,b) { return b - a; });

			Ember.beginPropertyChanges();
			for (i=0; i<indices.length; i++) {
				this._replace(indices[i], 1, EMPTY);
			}
			Ember.endPropertyChanges();
		}

		return this ;
	},

	pushObject: function(obj) {
		this._insertAt(get(this, 'content.length'), obj) ;
		return obj ;
	},

	pushObjects: function(objects) {
		if (!(Ember.Enumerable.detect(objects) || Ember.isArray(objects))) {
			throw new TypeError("Must pass Ember.Enumerable to Ember.MutableArray#pushObjects");
		}
		this._replace(get(this, 'length'), 0, objects);
		return this;
	},

	setObjects: function(objects) {
		if (objects.length === 0) return this.clear();

		var len = get(this, 'length');
		this._replace(0, len, objects);
		return this;
	},

	unshiftObject: function(obj) {
		this._insertAt(0, obj) ;
		return obj ;
	},

	unshiftObjects: function(objects) {
		this._replace(0, 0, objects);
		return this;
	},

	slice: function() {
		var arr = this.toArray();
		return arr.slice.apply(arr, arguments);
	},

	arrangedContentArrayWillChange: function(item, idx, removedCnt, addedCnt) {
		this.arrayContentWillChange(idx, removedCnt, addedCnt);
	},

	arrangedContentArrayDidChange: function(item, idx, removedCnt, addedCnt) {
		this.arrayContentDidChange(idx, removedCnt, addedCnt);
	},

	init: function() {
		this._super();
		this._setupContent();
		this._setupArrangedContent();
	},

	willDestroy: function() {
		this._teardownArrangedContent();
		this._teardownContent();
	}
});

})();



(function() {
/**
@module ember
@submodule ember-runtime
*/


var set = Ember.set, get = Ember.get, guidFor = Ember.guidFor;
var forEach = Ember.EnumerableUtils.forEach,
		indexOf = Ember.ArrayPolyfills.indexOf;

var EachArray = Ember.Object.extend(Ember.Array, {

	init: function(content, keyName, owner) {
		this._super();
		this._keyName = keyName;
		this._owner   = owner;
		this._content = content;
	},

	objectAt: function(idx) {
		var item = this._content.objectAt(idx);
		return item && get(item, this._keyName);
	},

	length: Ember.computed(function() {
		var content = this._content;
		return content ? get(content, 'length') : 0;
	})

});

var IS_OBSERVER = /^.+:(before|change)$/;

function addObserverForContentKey(content, keyName, proxy, idx, loc) {
	var objects = proxy._objects, guid;
	if (!objects) objects = proxy._objects = {};

	while(--loc>=idx) {
		var item = content.objectAt(loc);
		if (item) {
						Ember.addBeforeObserver(item, keyName, proxy, 'contentKeyWillChange');
			Ember.addObserver(item, keyName, proxy, 'contentKeyDidChange');

			// keep track of the index each item was found at so we can map
			// it back when the obj changes.
			guid = guidFor(item);
			if (!objects[guid]) objects[guid] = [];
			objects[guid].push(loc);
		}
	}
}

function removeObserverForContentKey(content, keyName, proxy, idx, loc) {
	var objects = proxy._objects;
	if (!objects) objects = proxy._objects = {};
	var indicies, guid;

	while(--loc>=idx) {
		var item = content.objectAt(loc);
		if (item) {
			Ember.removeBeforeObserver(item, keyName, proxy, 'contentKeyWillChange');
			Ember.removeObserver(item, keyName, proxy, 'contentKeyDidChange');

			guid = guidFor(item);
			indicies = objects[guid];
			indicies[indexOf.call(indicies, loc)] = null;
		}
	}
}

/**
	This is the object instance returned when you get the `@each` property on an
	array. It uses the unknownProperty handler to automatically create
	EachArray instances for property names.

	@private
	@class EachProxy
	@namespace Ember
	@extends Ember.Object
*/
Ember.EachProxy = Ember.Object.extend({

	init: function(content) {
		this._super();
		this._content = content;
		content.addArrayObserver(this);

		// in case someone is already observing some keys make sure they are
		// added
		forEach(Ember.watchedEvents(this), function(eventName) {
			this.didAddListener(eventName);
		}, this);
	},

	/**
		You can directly access mapped properties by simply requesting them.
		The `unknownProperty` handler will generate an EachArray of each item.

		@method unknownProperty
		@param keyName {String}
		@param value {*}
	*/
	unknownProperty: function(keyName, value) {
		var ret;
		ret = new EachArray(this._content, keyName, this);
		Ember.defineProperty(this, keyName, null, ret);
		this.beginObservingContentKey(keyName);
		return ret;
	},

	// ..........................................................
	// ARRAY CHANGES
	// Invokes whenever the content array itself changes.

	arrayWillChange: function(content, idx, removedCnt, addedCnt) {
		var keys = this._keys, key, lim;

		lim = removedCnt>0 ? idx+removedCnt : -1;
		Ember.beginPropertyChanges(this);

		for(key in keys) {
			if (!keys.hasOwnProperty(key)) { continue; }

			if (lim>0) { removeObserverForContentKey(content, key, this, idx, lim); }

			Ember.propertyWillChange(this, key);
		}

		Ember.propertyWillChange(this._content, '@each');
		Ember.endPropertyChanges(this);
	},

	arrayDidChange: function(content, idx, removedCnt, addedCnt) {
		var keys = this._keys, lim;

		lim = addedCnt>0 ? idx+addedCnt : -1;
		Ember.changeProperties(function() {
			for(var key in keys) {
				if (!keys.hasOwnProperty(key)) { continue; }

				if (lim>0) { addObserverForContentKey(content, key, this, idx, lim); }

				Ember.propertyDidChange(this, key);
			}

			Ember.propertyDidChange(this._content, '@each');
		}, this);
	},

	// ..........................................................
	// LISTEN FOR NEW OBSERVERS AND OTHER EVENT LISTENERS
	// Start monitoring keys based on who is listening...

	didAddListener: function(eventName) {
		if (IS_OBSERVER.test(eventName)) {
			this.beginObservingContentKey(eventName.slice(0, -7));
		}
	},

	didRemoveListener: function(eventName) {
		if (IS_OBSERVER.test(eventName)) {
			this.stopObservingContentKey(eventName.slice(0, -7));
		}
	},

	// ..........................................................
	// CONTENT KEY OBSERVING
	// Actual watch keys on the source content.

	beginObservingContentKey: function(keyName) {
		var keys = this._keys;
		if (!keys) keys = this._keys = {};
		if (!keys[keyName]) {
			keys[keyName] = 1;
			var content = this._content,
					len = get(content, 'length');
			addObserverForContentKey(content, keyName, this, 0, len);
		} else {
			keys[keyName]++;
		}
	},

	stopObservingContentKey: function(keyName) {
		var keys = this._keys;
		if (keys && (keys[keyName]>0) && (--keys[keyName]<=0)) {
			var content = this._content,
					len     = get(content, 'length');
			removeObserverForContentKey(content, keyName, this, 0, len);
		}
	},

	contentKeyWillChange: function(obj, keyName) {
		Ember.propertyWillChange(this, keyName);
	},

	contentKeyDidChange: function(obj, keyName) {
		Ember.propertyDidChange(this, keyName);
	}

});



})();



(function() {
/**
@module ember
@submodule ember-runtime
*/


var get = Ember.get, set = Ember.set, replace = Ember.EnumerableUtils._replace;

// Add Ember.Array to Array.prototype. Remove methods with native
// implementations and supply some more optimized versions of generic methods
// because they are so common.
var NativeArray = Ember.Mixin.create(Ember.MutableArray, Ember.Observable, Ember.Copyable, {

	// because length is a built-in property we need to know to just get the
	// original property.
	get: function(key) {
		if (key==='length') return this.length;
		else if ('number' === typeof key) return this[key];
		else return this._super(key);
	},

	objectAt: function(idx) {
		return this[idx];
	},

	// primitive for array support.
	replace: function(idx, amt, objects) {

		if (this.isFrozen) throw Ember.FROZEN_ERROR;

		// if we replaced exactly the same number of items, then pass only the
		// replaced range. Otherwise, pass the full remaining array length
		// since everything has shifted
		var len = objects ? get(objects, 'length') : 0;
		this.arrayContentWillChange(idx, amt, len);

		if (len === 0) {
			this.splice(idx, amt);
		} else {
			replace(this, idx, amt, objects);
		}

		this.arrayContentDidChange(idx, amt, len);
		return this;
	},

	// If you ask for an unknown property, then try to collect the value
	// from member items.
	unknownProperty: function(key, value) {
		var ret;// = this.reducedProperty(key, value) ;
		if ((value !== undefined) && ret === undefined) {
			ret = this[key] = value;
		}
		return ret ;
	},

	// If browser did not implement indexOf natively, then override with
	// specialized version
	indexOf: function(object, startAt) {
		var idx, len = this.length;

		if (startAt === undefined) startAt = 0;
		else startAt = (startAt < 0) ? Math.ceil(startAt) : Math.floor(startAt);
		if (startAt < 0) startAt += len;

		for(idx=startAt;idx<len;idx++) {
			if (this[idx] === object) return idx ;
		}
		return -1;
	},

	lastIndexOf: function(object, startAt) {
		var idx, len = this.length;

		if (startAt === undefined) startAt = len-1;
		else startAt = (startAt < 0) ? Math.ceil(startAt) : Math.floor(startAt);
		if (startAt < 0) startAt += len;

		for(idx=startAt;idx>=0;idx--) {
			if (this[idx] === object) return idx ;
		}
		return -1;
	},

	copy: function(deep) {
		if (deep) {
			return this.map(function(item) { return Ember.copy(item, true); });
		}

		return this.slice();
	}
});

// Remove any methods implemented natively so we don't override them
var ignore = ['length'];
Ember.EnumerableUtils.forEach(NativeArray.keys(), function(methodName) {
	if (Array.prototype[methodName]) ignore.push(methodName);
});

if (ignore.length>0) {
	NativeArray = NativeArray.without.apply(NativeArray, ignore);
}

/**
	The NativeArray mixin contains the properties needed to to make the native
	Array support Ember.MutableArray and all of its dependent APIs. Unless you
	have `Ember.EXTEND_PROTOTYPES` or `Ember.EXTEND_PROTOTYPES.Array` set to
	false, this will be applied automatically. Otherwise you can apply the mixin
	at anytime by calling `Ember.NativeArray.activate`.

	@class NativeArray
	@namespace Ember
	@uses Ember.MutableArray
	@uses Ember.Observable
	@uses Ember.Copyable
*/
Ember.NativeArray = NativeArray;

/**
	Creates an `Ember.NativeArray` from an Array like object.
	Does not modify the original object. Ember.A is not needed if
	`Ember.EXTEND_PROTOTYPES` is `true` (the default value). However,
	it is recommended that you use Ember.A when creating addons for
	ember or when you can not guarantee that `Ember.EXTEND_PROTOTYPES`
	will be `true`.

	Example

	```js
	var Pagination = Ember.CollectionView.extend({
		tagName: 'ul',
		classNames: ['pagination'],
		init: function() {
			this._super();
			if (!this.get('content')) {
				this.set('content', Ember.A([]));
			}
		}
	});
	```

	@method A
	@for Ember
	@return {Ember.NativeArray}
*/
Ember.A = function(arr) {
	if (arr === undefined) { arr = []; }
	return Ember.Array.detect(arr) ? arr : Ember.NativeArray.apply(arr);
};

/**
	Activates the mixin on the Array.prototype if not already applied. Calling
	this method more than once is safe. This will be called when ember is loaded
	unless you have `Ember.EXTEND_PROTOTYPES` or `Ember.EXTEND_PROTOTYPES.Array`
	set to `false`.

	Example

	```js
	if (Ember.EXTEND_PROTOTYPES === true || Ember.EXTEND_PROTOTYPES.Array) {
		Ember.NativeArray.activate();
	}
	```

	@method activate
	@for Ember.NativeArray
	@static
	@return {void}
*/
Ember.NativeArray.activate = function() {
	NativeArray.apply(Array.prototype);

	Ember.A = function(arr) { return arr || []; };
};

if (Ember.EXTEND_PROTOTYPES === true || Ember.EXTEND_PROTOTYPES.Array) {
	Ember.NativeArray.activate();
}


})();



(function() {
/**
@module ember
@submodule ember-runtime
*/

var get = Ember.get, set = Ember.set, guidFor = Ember.guidFor, isNone = Ember.isNone, fmt = Ember.String.fmt;

/**
	An unordered collection of objects.

	A Set works a bit like an array except that its items are not ordered. You
	can create a set to efficiently test for membership for an object. You can
	also iterate through a set just like an array, even accessing objects by
	index, however there is no guarantee as to their order.

	All Sets are observable via the Enumerable Observer API - which works
	on any enumerable object including both Sets and Arrays.

	## Creating a Set

	You can create a set like you would most objects using
	`new Ember.Set()`. Most new sets you create will be empty, but you can
	also initialize the set with some content by passing an array or other
	enumerable of objects to the constructor.

	Finally, you can pass in an existing set and the set will be copied. You
	can also create a copy of a set by calling `Ember.Set#copy()`.

	```javascript
	// creates a new empty set
	var foundNames = new Ember.Set();

	// creates a set with four names in it.
	var names = new Ember.Set(["Charles", "Tom", "Juan", "Alex"]); // :P

	// creates a copy of the names set.
	var namesCopy = new Ember.Set(names);

	// same as above.
	var anotherNamesCopy = names.copy();
	```

	## Adding/Removing Objects

	You generally add or remove objects from a set using `add()` or
	`remove()`. You can add any type of object including primitives such as
	numbers, strings, and booleans.

	Unlike arrays, objects can only exist one time in a set. If you call `add()`
	on a set with the same object multiple times, the object will only be added
	once. Likewise, calling `remove()` with the same object multiple times will
	remove the object the first time and have no effect on future calls until
	you add the object to the set again.

	NOTE: You cannot add/remove `null` or `undefined` to a set. Any attempt to do
	so will be ignored.

	In addition to add/remove you can also call `push()`/`pop()`. Push behaves
	just like `add()` but `pop()`, unlike `remove()` will pick an arbitrary
	object, remove it and return it. This is a good way to use a set as a job
	queue when you don't care which order the jobs are executed in.

	## Testing for an Object

	To test for an object's presence in a set you simply call
	`Ember.Set#contains()`.

	## Observing changes

	When using `Ember.Set`, you can observe the `"[]"` property to be
	alerted whenever the content changes. You can also add an enumerable
	observer to the set to be notified of specific objects that are added and
	removed from the set. See [Ember.Enumerable](/api/classes/Ember.Enumerable.html)
	for more information on enumerables.

	This is often unhelpful. If you are filtering sets of objects, for instance,
	it is very inefficient to re-filter all of the items each time the set
	changes. It would be better if you could just adjust the filtered set based
	on what was changed on the original set. The same issue applies to merging
	sets, as well.

	## Other Methods

	`Ember.Set` primary implements other mixin APIs. For a complete reference
	on the methods you will use with `Ember.Set`, please consult these mixins.
	The most useful ones will be `Ember.Enumerable` and
	`Ember.MutableEnumerable` which implement most of the common iterator
	methods you are used to on Array.

	Note that you can also use the `Ember.Copyable` and `Ember.Freezable`
	APIs on `Ember.Set` as well. Once a set is frozen it can no longer be
	modified. The benefit of this is that when you call `frozenCopy()` on it,
	Ember will avoid making copies of the set. This allows you to write
	code that can know with certainty when the underlying set data will or
	will not be modified.

	@class Set
	@namespace Ember
	@extends Ember.CoreObject
	@uses Ember.MutableEnumerable
	@uses Ember.Copyable
	@uses Ember.Freezable
	@since Ember 0.9
*/
Ember.Set = Ember.CoreObject.extend(Ember.MutableEnumerable, Ember.Copyable, Ember.Freezable,
	{

	// ..........................................................
	// IMPLEMENT ENUMERABLE APIS
	//

	/**
		This property will change as the number of objects in the set changes.

		@property length
		@type number
		@default 0
	*/
	length: 0,

	/**
		Clears the set. This is useful if you want to reuse an existing set
		without having to recreate it.

		```javascript
		var colors = new Ember.Set(["red", "green", "blue"]);
		colors.length;  // 3
		colors.clear();
		colors.length;  // 0
		```

		@method clear
		@return {Ember.Set} An empty Set
	*/
	clear: function() {
		if (this.isFrozen) { throw new Ember.Error(Ember.FROZEN_ERROR); }

		var len = get(this, 'length');
		if (len === 0) { return this; }

		var guid;

		this.enumerableContentWillChange(len, 0);
		Ember.propertyWillChange(this, 'firstObject');
		Ember.propertyWillChange(this, 'lastObject');

		for (var i=0; i < len; i++) {
			guid = guidFor(this[i]);
			delete this[guid];
			delete this[i];
		}

		set(this, 'length', 0);

		Ember.propertyDidChange(this, 'firstObject');
		Ember.propertyDidChange(this, 'lastObject');
		this.enumerableContentDidChange(len, 0);

		return this;
	},

	/**
		Returns true if the passed object is also an enumerable that contains the
		same objects as the receiver.

		```javascript
		var colors = ["red", "green", "blue"],
				same_colors = new Ember.Set(colors);

		same_colors.isEqual(colors);               // true
		same_colors.isEqual(["purple", "brown"]);  // false
		```

		@method isEqual
		@param {Ember.Set} obj the other object.
		@return {Boolean}
	*/
	isEqual: function(obj) {
		// fail fast
		if (!Ember.Enumerable.detect(obj)) return false;

		var loc = get(this, 'length');
		if (get(obj, 'length') !== loc) return false;

		while(--loc >= 0) {
			if (!obj.contains(this[loc])) return false;
		}

		return true;
	},

	/**
		Adds an object to the set. Only non-`null` objects can be added to a set
		and those can only be added once. If the object is already in the set or
		the passed value is null this method will have no effect.

		This is an alias for `Ember.MutableEnumerable.addObject()`.

		```javascript
		var colors = new Ember.Set();
		colors.add("blue");     // ["blue"]
		colors.add("blue");     // ["blue"]
		colors.add("red");      // ["blue", "red"]
		colors.add(null);       // ["blue", "red"]
		colors.add(undefined);  // ["blue", "red"]
		```

		@method add
		@param {Object} obj The object to add.
		@return {Ember.Set} The set itself.
	*/
	add: Ember.aliasMethod('addObject'),

	/**
		Removes the object from the set if it is found. If you pass a `null` value
		or an object that is already not in the set, this method will have no
		effect. This is an alias for `Ember.MutableEnumerable.removeObject()`.

		```javascript
		var colors = new Ember.Set(["red", "green", "blue"]);
		colors.remove("red");     // ["blue", "green"]
		colors.remove("purple");  // ["blue", "green"]
		colors.remove(null);      // ["blue", "green"]
		```

		@method remove
		@param {Object} obj The object to remove
		@return {Ember.Set} The set itself.
	*/
	remove: Ember.aliasMethod('removeObject'),

	/**
		Removes the last element from the set and returns it, or `null` if it's empty.

		```javascript
		var colors = new Ember.Set(["green", "blue"]);
		colors.pop();  // "blue"
		colors.pop();  // "green"
		colors.pop();  // null
		```

		@method pop
		@return {Object} The removed object from the set or null.
	*/
	pop: function() {
		if (get(this, 'isFrozen')) throw new Ember.Error(Ember.FROZEN_ERROR);
		var obj = this.length > 0 ? this[this.length-1] : null;
		this.remove(obj);
		return obj;
	},

	/**
		Inserts the given object on to the end of the set. It returns
		the set itself.

		This is an alias for `Ember.MutableEnumerable.addObject()`.

		```javascript
		var colors = new Ember.Set();
		colors.push("red");   // ["red"]
		colors.push("green"); // ["red", "green"]
		colors.push("blue");  // ["red", "green", "blue"]
		```

		@method push
		@return {Ember.Set} The set itself.
	*/
	push: Ember.aliasMethod('addObject'),

	/**
		Removes the last element from the set and returns it, or `null` if it's empty.

		This is an alias for `Ember.Set.pop()`.

		```javascript
		var colors = new Ember.Set(["green", "blue"]);
		colors.shift();  // "blue"
		colors.shift();  // "green"
		colors.shift();  // null
		```

		@method shift
		@return {Object} The removed object from the set or null.
	*/
	shift: Ember.aliasMethod('pop'),

	/**
		Inserts the given object on to the end of the set. It returns
		the set itself.

		This is an alias of `Ember.Set.push()`

		```javascript
		var colors = new Ember.Set();
		colors.unshift("red");    // ["red"]
		colors.unshift("green");  // ["red", "green"]
		colors.unshift("blue");   // ["red", "green", "blue"]
		```

		@method unshift
		@return {Ember.Set} The set itself.
	*/
	unshift: Ember.aliasMethod('push'),

	/**
		Adds each object in the passed enumerable to the set.

		This is an alias of `Ember.MutableEnumerable.addObjects()`

		```javascript
		var colors = new Ember.Set();
		colors.addEach(["red", "green", "blue"]);  // ["red", "green", "blue"]
		```

		@method addEach
		@param {Ember.Enumerable} objects the objects to add.
		@return {Ember.Set} The set itself.
	*/
	addEach: Ember.aliasMethod('addObjects'),

	/**
		Removes each object in the passed enumerable to the set.

		This is an alias of `Ember.MutableEnumerable.removeObjects()`

		```javascript
		var colors = new Ember.Set(["red", "green", "blue"]);
		colors.removeEach(["red", "blue"]);  //  ["green"]
		```

		@method removeEach
		@param {Ember.Enumerable} objects the objects to remove.
		@return {Ember.Set} The set itself.
	*/
	removeEach: Ember.aliasMethod('removeObjects'),

	// ..........................................................
	// PRIVATE ENUMERABLE SUPPORT
	//

	init: function(items) {
		this._super();
		if (items) this.addObjects(items);
	},

	// implement Ember.Enumerable
	nextObject: function(idx) {
		return this[idx];
	},

	// more optimized version
	firstObject: Ember.computed(function() {
		return this.length > 0 ? this[0] : undefined;
	}),

	// more optimized version
	lastObject: Ember.computed(function() {
		return this.length > 0 ? this[this.length-1] : undefined;
	}),

	// implements Ember.MutableEnumerable
	addObject: function(obj) {
		if (get(this, 'isFrozen')) throw new Ember.Error(Ember.FROZEN_ERROR);
		if (isNone(obj)) return this; // nothing to do

		var guid = guidFor(obj),
				idx  = this[guid],
				len  = get(this, 'length'),
				added ;

		if (idx>=0 && idx<len && (this[idx] === obj)) return this; // added

		added = [obj];

		this.enumerableContentWillChange(null, added);
		Ember.propertyWillChange(this, 'lastObject');

		len = get(this, 'length');
		this[guid] = len;
		this[len] = obj;
		set(this, 'length', len+1);

		Ember.propertyDidChange(this, 'lastObject');
		this.enumerableContentDidChange(null, added);

		return this;
	},

	// implements Ember.MutableEnumerable
	removeObject: function(obj) {
		if (get(this, 'isFrozen')) throw new Ember.Error(Ember.FROZEN_ERROR);
		if (isNone(obj)) return this; // nothing to do

		var guid = guidFor(obj),
				idx  = this[guid],
				len = get(this, 'length'),
				isFirst = idx === 0,
				isLast = idx === len-1,
				last, removed;


		if (idx>=0 && idx<len && (this[idx] === obj)) {
			removed = [obj];

			this.enumerableContentWillChange(removed, null);
			if (isFirst) { Ember.propertyWillChange(this, 'firstObject'); }
			if (isLast)  { Ember.propertyWillChange(this, 'lastObject'); }

			// swap items - basically move the item to the end so it can be removed
			if (idx < len-1) {
				last = this[len-1];
				this[idx] = last;
				this[guidFor(last)] = idx;
			}

			delete this[guid];
			delete this[len-1];
			set(this, 'length', len-1);

			if (isFirst) { Ember.propertyDidChange(this, 'firstObject'); }
			if (isLast)  { Ember.propertyDidChange(this, 'lastObject'); }
			this.enumerableContentDidChange(removed, null);
		}

		return this;
	},

	// optimized version
	contains: function(obj) {
		return this[guidFor(obj)]>=0;
	},

	copy: function() {
		var C = this.constructor, ret = new C(), loc = get(this, 'length');
		set(ret, 'length', loc);
		while(--loc>=0) {
			ret[loc] = this[loc];
			ret[guidFor(this[loc])] = loc;
		}
		return ret;
	},

	toString: function() {
		var len = this.length, idx, array = [];
		for(idx = 0; idx < len; idx++) {
			array[idx] = this[idx];
		}
		return fmt("Ember.Set<%@>", [array.join(',')]);
	}

});

})();



(function() {
var DeferredMixin = Ember.DeferredMixin, // mixins/deferred
		get = Ember.get;

var Deferred = Ember.Object.extend(DeferredMixin);

Deferred.reopenClass({
	promise: function(callback, binding) {
		var deferred = Deferred.create();
		callback.call(binding, deferred);
		return deferred;
	}
});

Ember.Deferred = Deferred;

})();



(function() {
var forEach = Ember.ArrayPolyfills.forEach;

/**
	@module ember
	@submodule ember-runtime
*/

var loadHooks = Ember.ENV.EMBER_LOAD_HOOKS || {};
var loaded = {};

/**
	Detects when a specific package of Ember (e.g. 'Ember.Handlebars')
	has fully loaded and is available for extension.

	The provided `callback` will be called with the `name` passed
	resolved from a string into the object:

	``` javascript
	Ember.onLoad('Ember.Handlebars' function(hbars){
		hbars.registerHelper(...);
	});
	```

	@method onLoad
	@for Ember
	@param name {String} name of hook
	@param callback {Function} callback to be called
*/
Ember.onLoad = function(name, callback) {
	var object;

	loadHooks[name] = loadHooks[name] || Ember.A();
	loadHooks[name].pushObject(callback);

	if (object = loaded[name]) {
		callback(object);
	}
};

/**
	Called when an Ember.js package (e.g Ember.Handlebars) has finished
	loading. Triggers any callbacks registered for this event.

	@method runLoadHooks
	@for Ember
	@param name {String} name of hook
	@param object {Object} object to pass to callbacks
*/
Ember.runLoadHooks = function(name, object) {
	loaded[name] = object;

	if (loadHooks[name]) {
		forEach.call(loadHooks[name], function(callback) {
			callback(object);
		});
	}
};

})();



(function() {

})();



(function() {
var get = Ember.get;

/**
@module ember
@submodule ember-runtime
*/

/**
	`Ember.ControllerMixin` provides a standard interface for all classes that
	compose Ember's controller layer: `Ember.Controller`,
	`Ember.ArrayController`, and `Ember.ObjectController`.

	@class ControllerMixin
	@namespace Ember
	@uses Ember.ActionHandler
*/
Ember.ControllerMixin = Ember.Mixin.create(Ember.ActionHandler, {
	/* ducktype as a controller */
	isController: true,

	/**
		The object to which actions from the view should be sent.

		For example, when a Handlebars template uses the `{{action}}` helper,
		it will attempt to send the action to the view's controller's `target`.

		By default, a controller's `target` is set to the router after it is
		instantiated by `Ember.Application#initialize`.

		@property target
		@default null
	*/
	target: null,

	container: null,

	parentController: null,

	store: null,

	model: Ember.computed.alias('content'),

	deprecatedSendHandles: function(actionName) {
		return !!this[actionName];
	},

	deprecatedSend: function(actionName) {
		var args = [].slice.call(arguments, 1);
						this[actionName].apply(this, args);
		return;
	}
});

/**
	@class Controller
	@namespace Ember
	@extends Ember.Object
	@uses Ember.ControllerMixin
*/
Ember.Controller = Ember.Object.extend(Ember.ControllerMixin);

})();



(function() {
/**
@module ember
@submodule ember-runtime
*/

var get = Ember.get, set = Ember.set, forEach = Ember.EnumerableUtils.forEach;

/**
	`Ember.SortableMixin` provides a standard interface for array proxies
	to specify a sort order and maintain this sorting when objects are added,
	removed, or updated without changing the implicit order of their underlying
	content array:

	```javascript
	songs = [
		{trackNumber: 4, title: 'Ob-La-Di, Ob-La-Da'},
		{trackNumber: 2, title: 'Back in the U.S.S.R.'},
		{trackNumber: 3, title: 'Glass Onion'},
	];

	songsController = Ember.ArrayController.create({
		content: songs,
		sortProperties: ['trackNumber'],
		sortAscending: true
	});

	songsController.get('firstObject');  // {trackNumber: 2, title: 'Back in the U.S.S.R.'}

	songsController.addObject({trackNumber: 1, title: 'Dear Prudence'});
	songsController.get('firstObject');  // {trackNumber: 1, title: 'Dear Prudence'}
	```

	If you add or remove the properties to sort by or change the sort direction the content
	sort order will be automatically updated.

	```javascript
	songsController.set('sortProperties', ['title']);
	songsController.get('firstObject'); // {trackNumber: 2, title: 'Back in the U.S.S.R.'}

	songsController.toggleProperty('sortAscending');
	songsController.get('firstObject'); // {trackNumber: 4, title: 'Ob-La-Di, Ob-La-Da'}
	```

	SortableMixin works by sorting the arrangedContent array, which is the array that
	arrayProxy displays. Due to the fact that the underlying 'content' array is not changed, that
	array will not display the sorted list:

	 ```javascript
	songsController.get('content').get('firstObject'); // Returns the unsorted original content
	songsController.get('firstObject'); // Returns the sorted content.
	```

	Although the sorted content can also be accessed through the arrangedContent property,
	it is preferable to use the proxied class and not the arrangedContent array directly.

	@class SortableMixin
	@namespace Ember
	@uses Ember.MutableEnumerable
*/
Ember.SortableMixin = Ember.Mixin.create(Ember.MutableEnumerable, {

	/**
		Specifies which properties dictate the arrangedContent's sort order.

		When specifying multiple properties the sorting will use properties
		from the `sortProperties` array prioritized from first to last.

		@property {Array} sortProperties
	*/
	sortProperties: null,

	/**
		Specifies the arrangedContent's sort direction

		@property {Boolean} sortAscending
	*/
	sortAscending: true,

	/**
		The function used to compare two values. You can override this if you
		want to do custom comparisons. Functions must be of the type expected by
		Array#sort, i.e.
			return 0 if the two parameters are equal,
			return a negative value if the first parameter is smaller than the second or
			return a positive value otherwise:

		```javascript
		function(x,y) { // These are assumed to be integers
			if (x === y)
				return 0;
			return x < y ? -1 : 1;
		}
		```

		@property sortFunction
		@type {Function}
		@default Ember.compare
	*/
	sortFunction: Ember.compare,

	orderBy: function(item1, item2) {
		var result = 0,
				sortProperties = get(this, 'sortProperties'),
				sortAscending = get(this, 'sortAscending'),
				sortFunction = get(this, 'sortFunction');


		forEach(sortProperties, function(propertyName) {
			if (result === 0) {
				result = sortFunction(get(item1, propertyName), get(item2, propertyName));
				if ((result !== 0) && !sortAscending) {
					result = (-1) * result;
				}
			}
		});

		return result;
	},

	destroy: function() {
		var content = get(this, 'content'),
				sortProperties = get(this, 'sortProperties');

		if (content && sortProperties) {
			forEach(content, function(item) {
				forEach(sortProperties, function(sortProperty) {
					Ember.removeObserver(item, sortProperty, this, 'contentItemSortPropertyDidChange');
				}, this);
			}, this);
		}

		return this._super();
	},

	isSorted: Ember.computed.bool('sortProperties'),

	/**
		Overrides the default arrangedContent from arrayProxy in order to sort by sortFunction.
		Also sets up observers for each sortProperty on each item in the content Array.

		@property arrangedContent
	*/

	arrangedContent: Ember.computed('content', 'sortProperties.@each', function(key, value) {
		var content = get(this, 'content'),
				isSorted = get(this, 'isSorted'),
				sortProperties = get(this, 'sortProperties'),
				self = this;

		if (content && isSorted) {
			content = content.slice();
			content.sort(function(item1, item2) {
				return self.orderBy(item1, item2);
			});
			forEach(content, function(item) {
				forEach(sortProperties, function(sortProperty) {
					Ember.addObserver(item, sortProperty, this, 'contentItemSortPropertyDidChange');
				}, this);
			}, this);
			return Ember.A(content);
		}

		return content;
	}),

	_contentWillChange: Ember.beforeObserver('content', function() {
		var content = get(this, 'content'),
				sortProperties = get(this, 'sortProperties');

		if (content && sortProperties) {
			forEach(content, function(item) {
				forEach(sortProperties, function(sortProperty) {
					Ember.removeObserver(item, sortProperty, this, 'contentItemSortPropertyDidChange');
				}, this);
			}, this);
		}

		this._super();
	}),

	sortAscendingWillChange: Ember.beforeObserver('sortAscending', function() {
		this._lastSortAscending = get(this, 'sortAscending');
	}),

	sortAscendingDidChange: Ember.observer('sortAscending', function() {
		if (get(this, 'sortAscending') !== this._lastSortAscending) {
			var arrangedContent = get(this, 'arrangedContent');
			arrangedContent.reverseObjects();
		}
	}),

	contentArrayWillChange: function(array, idx, removedCount, addedCount) {
		var isSorted = get(this, 'isSorted');

		if (isSorted) {
			var arrangedContent = get(this, 'arrangedContent');
			var removedObjects = array.slice(idx, idx+removedCount);
			var sortProperties = get(this, 'sortProperties');

			forEach(removedObjects, function(item) {
				arrangedContent.removeObject(item);

				forEach(sortProperties, function(sortProperty) {
					Ember.removeObserver(item, sortProperty, this, 'contentItemSortPropertyDidChange');
				}, this);
			}, this);
		}

		return this._super(array, idx, removedCount, addedCount);
	},

	contentArrayDidChange: function(array, idx, removedCount, addedCount) {
		var isSorted = get(this, 'isSorted'),
				sortProperties = get(this, 'sortProperties');

		if (isSorted) {
			var addedObjects = array.slice(idx, idx+addedCount);

			forEach(addedObjects, function(item) {
				this.insertItemSorted(item);

				forEach(sortProperties, function(sortProperty) {
					Ember.addObserver(item, sortProperty, this, 'contentItemSortPropertyDidChange');
				}, this);
			}, this);
		}

		return this._super(array, idx, removedCount, addedCount);
	},

	insertItemSorted: function(item) {
		var arrangedContent = get(this, 'arrangedContent');
		var length = get(arrangedContent, 'length');

		var idx = this._binarySearch(item, 0, length);
		arrangedContent.insertAt(idx, item);
	},

	contentItemSortPropertyDidChange: function(item) {
		var arrangedContent = get(this, 'arrangedContent'),
				oldIndex = arrangedContent.indexOf(item),
				leftItem = arrangedContent.objectAt(oldIndex - 1),
				rightItem = arrangedContent.objectAt(oldIndex + 1),
				leftResult = leftItem && this.orderBy(item, leftItem),
				rightResult = rightItem && this.orderBy(item, rightItem);

		if (leftResult < 0 || rightResult > 0) {
			arrangedContent.removeObject(item);
			this.insertItemSorted(item);
		}
	},

	_binarySearch: function(item, low, high) {
		var mid, midItem, res, arrangedContent;

		if (low === high) {
			return low;
		}

		arrangedContent = get(this, 'arrangedContent');

		mid = low + Math.floor((high - low) / 2);
		midItem = arrangedContent.objectAt(mid);

		res = this.orderBy(midItem, item);

		if (res < 0) {
			return this._binarySearch(item, mid+1, high);
		} else if (res > 0) {
			return this._binarySearch(item, low, mid);
		}

		return mid;
	}
});

})();



(function() {
/**
@module ember
@submodule ember-runtime
*/

var get = Ember.get, set = Ember.set, forEach = Ember.EnumerableUtils.forEach,
		replace = Ember.EnumerableUtils.replace;

/**
	`Ember.ArrayController` provides a way for you to publish a collection of
	objects so that you can easily bind to the collection from a Handlebars
	`#each` helper, an `Ember.CollectionView`, or other controllers.

	The advantage of using an `ArrayController` is that you only have to set up
	your view bindings once; to change what's displayed, simply swap out the
	`content` property on the controller.

	For example, imagine you wanted to display a list of items fetched via an XHR
	request. Create an `Ember.ArrayController` and set its `content` property:

	```javascript
	MyApp.listController = Ember.ArrayController.create();

	$.get('people.json', function(data) {
		MyApp.listController.set('content', data);
	});
	```

	Then, create a view that binds to your new controller:

	```handlebars
	{{#each MyApp.listController}}
		{{firstName}} {{lastName}}
	{{/each}}
	```

	Although you are binding to the controller, the behavior of this controller
	is to pass through any methods or properties to the underlying array. This
	capability comes from `Ember.ArrayProxy`, which this class inherits from.

	Sometimes you want to display computed properties within the body of an
	`#each` helper that depend on the underlying items in `content`, but are not
	present on those items.   To do this, set `itemController` to the name of a
	controller (probably an `ObjectController`) that will wrap each individual item.

	For example:

	```handlebars
		{{#each post in controller}}
			<li>{{title}} ({{titleLength}} characters)</li>
		{{/each}}
	```

	```javascript
	App.PostsController = Ember.ArrayController.extend({
		itemController: 'post'
	});

	App.PostController = Ember.ObjectController.extend({
		// the `title` property will be proxied to the underlying post.

		titleLength: function() {
			return this.get('title').length;
		}.property('title')
	});
	```

	In some cases it is helpful to return a different `itemController` depending
	on the particular item.  Subclasses can do this by overriding
	`lookupItemController`.

	For example:

	```javascript
	App.MyArrayController = Ember.ArrayController.extend({
		lookupItemController: function( object ) {
			if (object.get('isSpecial')) {
				return "special"; // use App.SpecialController
			} else {
				return "regular"; // use App.RegularController
			}
		}
	});
	```

	The itemController instances will have a `parentController` property set to
	either the the `parentController` property of the `ArrayController`
	or to the `ArrayController` instance itself.

	@class ArrayController
	@namespace Ember
	@extends Ember.ArrayProxy
	@uses Ember.SortableMixin
	@uses Ember.ControllerMixin
*/

Ember.ArrayController = Ember.ArrayProxy.extend(Ember.ControllerMixin,
	Ember.SortableMixin, {

	/**
		The controller used to wrap items, if any.

		@property itemController
		@type String
		@default null
	*/
	itemController: null,

	/**
		Return the name of the controller to wrap items, or `null` if items should
		be returned directly.  The default implementation simply returns the
		`itemController` property, but subclasses can override this method to return
		different controllers for different objects.

		For example:

		```javascript
		App.MyArrayController = Ember.ArrayController.extend({
			lookupItemController: function( object ) {
				if (object.get('isSpecial')) {
					return "special"; // use App.SpecialController
				} else {
					return "regular"; // use App.RegularController
				}
			}
		});
		```

		@method lookupItemController
		@param {Object} object
		@return {String}
	*/
	lookupItemController: function(object) {
		return get(this, 'itemController');
	},

	objectAtContent: function(idx) {
		var length = get(this, 'length'),
				arrangedContent = get(this,'arrangedContent'),
				object = arrangedContent && arrangedContent.objectAt(idx);

		if (idx >= 0 && idx < length) {
			var controllerClass = this.lookupItemController(object);
			if (controllerClass) {
				return this.controllerAt(idx, object, controllerClass);
			}
		}

		// When `controllerClass` is falsy, we have not opted in to using item
		// controllers, so return the object directly.

		// When the index is out of range, we want to return the "out of range"
		// value, whatever that might be.  Rather than make assumptions
		// (e.g. guessing `null` or `undefined`) we defer this to `arrangedContent`.
		return object;
	},

	arrangedContentDidChange: function() {
		this._super();
		this._resetSubControllers();
	},

	arrayContentDidChange: function(idx, removedCnt, addedCnt) {
		var subControllers = get(this, '_subControllers'),
				subControllersToRemove = subControllers.slice(idx, idx+removedCnt);

		forEach(subControllersToRemove, function(subController) {
			if (subController) { subController.destroy(); }
		});

		replace(subControllers, idx, removedCnt, new Array(addedCnt));

		// The shadow array of subcontrollers must be updated before we trigger
		// observers, otherwise observers will get the wrong subcontainer when
		// calling `objectAt`
		this._super(idx, removedCnt, addedCnt);
	},

	init: function() {
		this._super();

		this.set('_subControllers', Ember.A());
	},

	content: Ember.computed(function () {
		return Ember.A();
	}),

	controllerAt: function(idx, object, controllerClass) {
		var container = get(this, 'container'),
				subControllers = get(this, '_subControllers'),
				subController = subControllers[idx],
				factory, fullName;

		if (subController) { return subController; }

		fullName = "controller:" + controllerClass;

		if (!container.has(fullName)) {
			throw new Ember.Error('Could not resolve itemController: "' + controllerClass + '"');
		}

		subController = container.lookupFactory(fullName).create({
			target: this,
			parentController: get(this, 'parentController') || this,
			content: object
		});

		subControllers[idx] = subController;

		return subController;
	},

	_subControllers: null,

	_resetSubControllers: function() {
		var subControllers = get(this, '_subControllers');
		if (subControllers) {
			forEach(subControllers, function(subController) {
				if (subController) { subController.destroy(); }
			});
		}

		this.set('_subControllers', Ember.A());
	}
});

})();



(function() {
/**
@module ember
@submodule ember-runtime
*/

/**
	`Ember.ObjectController` is part of Ember's Controller layer. It is intended
	to wrap a single object, proxying unhandled attempts to `get` and `set` to the underlying
	content object, and to forward unhandled action attempts to its `target`.

	`Ember.ObjectController` derives this functionality from its superclass
	`Ember.ObjectProxy` and the `Ember.ControllerMixin` mixin.

	@class ObjectController
	@namespace Ember
	@extends Ember.ObjectProxy
	@uses Ember.ControllerMixin
**/
Ember.ObjectController = Ember.ObjectProxy.extend(Ember.ControllerMixin);

})();



(function() {

})();



(function() {
/**
Ember Runtime

@module ember
@submodule ember-runtime
@requires ember-metal
*/

})();

(function() {
/**
@module ember
@submodule ember-views
*/

var jQuery = (this && this.jQuery) || (Ember.imports && Ember.imports.jQuery);
if (!jQuery && typeof require === 'function') {
	jQuery = require('jquery');
}


/**
	Alias for jQuery

	@method $
	@for Ember
*/
Ember.$ = jQuery;

})();



(function() {
/**
@module ember
@submodule ember-views
*/
if (Ember.$) {
	// http://www.whatwg.org/specs/web-apps/current-work/multipage/dnd.html#dndevents
	var dragEvents = Ember.String.w('dragstart drag dragenter dragleave dragover drop dragend');

	// Copies the `dataTransfer` property from a browser event object onto the
	// jQuery event object for the specified events
	Ember.EnumerableUtils.forEach(dragEvents, function(eventName) {
		Ember.$.event.fixHooks[eventName] = { props: ['dataTransfer'] };
	});
}

})();



(function() {
/**
@module ember
@submodule ember-views
*/

/* BEGIN METAMORPH HELPERS */

// Internet Explorer prior to 9 does not allow setting innerHTML if the first element
// is a "zero-scope" element. This problem can be worked around by making
// the first node an invisible text node. We, like Modernizr, use &shy;

var needsShy = typeof document !== 'undefined' && (function() {
	var testEl = document.createElement('div');
	testEl.innerHTML = "<div></div>";
	testEl.firstChild.innerHTML = "<script></script>";
	return testEl.firstChild.innerHTML === '';
})();

// IE 8 (and likely earlier) likes to move whitespace preceeding
// a script tag to appear after it. This means that we can
// accidentally remove whitespace when updating a morph.
var movesWhitespace = typeof document !== 'undefined' && (function() {
	var testEl = document.createElement('div');
	testEl.innerHTML = "Test: <script type='text/x-placeholder'></script>Value";
	return testEl.childNodes[0].nodeValue === 'Test:' &&
					testEl.childNodes[2].nodeValue === ' Value';
})();

// Use this to find children by ID instead of using jQuery
var findChildById = function(element, id) {
	if (element.getAttribute('id') === id) { return element; }

	var len = element.childNodes.length, idx, node, found;
	for (idx=0; idx<len; idx++) {
		node = element.childNodes[idx];
		found = node.nodeType === 1 && findChildById(node, id);
		if (found) { return found; }
	}
};

var setInnerHTMLWithoutFix = function(element, html) {
	if (needsShy) {
		html = '&shy;' + html;
	}

	var matches = [];
	if (movesWhitespace) {
		// Right now we only check for script tags with ids with the
		// goal of targeting morphs.
		html = html.replace(/(\s+)(<script id='([^']+)')/g, function(match, spaces, tag, id) {
			matches.push([id, spaces]);
			return tag;
		});
	}

	element.innerHTML = html;

	// If we have to do any whitespace adjustments do them now
	if (matches.length > 0) {
		var len = matches.length, idx;
		for (idx=0; idx<len; idx++) {
			var script = findChildById(element, matches[idx][0]),
					node = document.createTextNode(matches[idx][1]);
			script.parentNode.insertBefore(node, script);
		}
	}

	if (needsShy) {
		var shyElement = element.firstChild;
		while (shyElement.nodeType === 1 && !shyElement.nodeName) {
			shyElement = shyElement.firstChild;
		}
		if (shyElement.nodeType === 3 && shyElement.nodeValue.charAt(0) === "\u00AD") {
			shyElement.nodeValue = shyElement.nodeValue.slice(1);
		}
	}
};

/* END METAMORPH HELPERS */


var innerHTMLTags = {};
var canSetInnerHTML = function(tagName) {
	if (innerHTMLTags[tagName] !== undefined) {
		return innerHTMLTags[tagName];
	}

	var canSet = true;

	// IE 8 and earlier don't allow us to do innerHTML on select
	if (tagName.toLowerCase() === 'select') {
		var el = document.createElement('select');
		setInnerHTMLWithoutFix(el, '<option value="test">Test</option>');
		canSet = el.options.length === 1;
	}

	innerHTMLTags[tagName] = canSet;

	return canSet;
};

var setInnerHTML = function(element, html) {
	var tagName = element.tagName;

	if (canSetInnerHTML(tagName)) {
		setInnerHTMLWithoutFix(element, html);
	} else {
		// Firefox versions < 11 do not have support for element.outerHTML.
		var outerHTML = element.outerHTML || new XMLSerializer().serializeToString(element);

		var startTag = outerHTML.match(new RegExp("<"+tagName+"([^>]*)>", 'i'))[0],
				endTag = '</'+tagName+'>';

		var wrapper = document.createElement('div');
		setInnerHTMLWithoutFix(wrapper, startTag + html + endTag);
		element = wrapper.firstChild;
		while (element.tagName !== tagName) {
			element = element.nextSibling;
		}
	}

	return element;
};

function isSimpleClick(event) {
	var modifier = event.shiftKey || event.metaKey || event.altKey || event.ctrlKey,
			secondaryClick = event.which > 1; // IE9 may return undefined

	return !modifier && !secondaryClick;
}

Ember.ViewUtils = {
	setInnerHTML: setInnerHTML,
	isSimpleClick: isSimpleClick
};

})();



(function() {
/**
@module ember
@submodule ember-views
*/

var get = Ember.get, set = Ember.set;

var ClassSet = function() {
	this.seen = {};
	this.list = [];
};

ClassSet.prototype = {
	add: function(string) {
		if (string in this.seen) { return; }
		this.seen[string] = true;

		this.list.push(string);
	},

	toDOM: function() {
		return this.list.join(" ");
	}
};

var BAD_TAG_NAME_TEST_REGEXP = /[^a-zA-Z0-9\-]/;
var BAD_TAG_NAME_REPLACE_REGEXP = /[^a-zA-Z0-9\-]/g;

function stripTagName(tagName) {
	if (!tagName) {
		return tagName;
	}

	if (!BAD_TAG_NAME_TEST_REGEXP.test(tagName)) {
		return tagName;
	}

	return tagName.replace(BAD_TAG_NAME_REPLACE_REGEXP, '');
}

var BAD_CHARS_REGEXP = /&(?!\w+;)|[<>"'`]/g;
var POSSIBLE_CHARS_REGEXP = /[&<>"'`]/;

function escapeAttribute(value) {
	// Stolen shamelessly from Handlebars

	var escape = {
		"<": "&lt;",
		">": "&gt;",
		'"': "&quot;",
		"'": "&#x27;",
		"`": "&#x60;"
	};

	var escapeChar = function(chr) {
		return escape[chr] || "&amp;";
	};

	var string = value.toString();

	if(!POSSIBLE_CHARS_REGEXP.test(string)) { return string; }
	return string.replace(BAD_CHARS_REGEXP, escapeChar);
}

// IE 6/7 have bugs arond setting names on inputs during creation.
// From http://msdn.microsoft.com/en-us/library/ie/ms536389(v=vs.85).aspx:
// "To include the NAME attribute at run time on objects created with the createElement method, use the eTag."
var canSetNameOnInputs = (function() {
	var div = document.createElement('div'),
			el = document.createElement('input');

	el.setAttribute('name', 'foo');
	div.appendChild(el);

	return !!div.innerHTML.match('foo');
})();

/**
	`Ember.RenderBuffer` gathers information regarding the a view and generates the
	final representation. `Ember.RenderBuffer` will generate HTML which can be pushed
	to the DOM.

	 ```javascript
	 var buffer = Ember.RenderBuffer('div');
	```

	@class RenderBuffer
	@namespace Ember
	@constructor
	@param {String} tagName tag name (such as 'div' or 'p') used for the buffer
*/
Ember.RenderBuffer = function(tagName, elementId) {
	return new Ember._RenderBuffer(tagName, elementId);
};

Ember._RenderBuffer = function(tagName, elementId) {
	this.tagNames = [tagName || null];
	this.elementIds = [elementId || null];
	this.queuedAppendChilds = [];
	this.buffer = "";
};

Ember._RenderBuffer.prototype = {

	// The root view's element
	_element: null,

	_hasElement: true,

	// Stacks
	tagNames: null,
	elementIds: null,

	queuedAppendChilds: null,

	/**
		An internal set used to de-dupe class names when `addClass()` is
		used. After each call to `addClass()`, the `classes` property
		will be updated.

		@private
		@property elementClasses
		@type Array
		@default []
	*/
	elementClasses: null,

	/**
		Array of class names which will be applied in the class attribute.

		You can use `setClasses()` to set this property directly. If you
		use `addClass()`, it will be maintained for you.

		@property classes
		@type Array
		@default []
	*/
	classes: null,

	/**
		The id in of the element, to be applied in the id attribute.

		You should not set this property yourself, rather, you should use
		the `id()` method of `Ember.RenderBuffer`.

		@property elementId
		@type String
		@default null
	*/
	elementId: null,

	/**
		A hash keyed on the name of the attribute and whose value will be
		applied to that attribute. For example, if you wanted to apply a
		`data-view="Foo.bar"` property to an element, you would set the
		elementAttributes hash to `{'data-view':'Foo.bar'}`.

		You should not maintain this hash yourself, rather, you should use
		the `attr()` method of `Ember.RenderBuffer`.

		@property elementAttributes
		@type Hash
		@default {}
	*/
	elementAttributes: null,

	/**
		A hash keyed on the name of the properties and whose value will be
		applied to that property. For example, if you wanted to apply a
		`checked=true` property to an element, you would set the
		elementProperties hash to `{'checked':true}`.

		You should not maintain this hash yourself, rather, you should use
		the `prop()` method of `Ember.RenderBuffer`.

		@property elementProperties
		@type Hash
		@default {}
	*/
	elementProperties: null,

	/**
		The tagname of the element an instance of `Ember.RenderBuffer` represents.

		Usually, this gets set as the first parameter to `Ember.RenderBuffer`. For
		example, if you wanted to create a `p` tag, then you would call

		```javascript
		Ember.RenderBuffer('p')
		```

		@property elementTag
		@type String
		@default null
	*/
	elementTag: null,

	/**
		A hash keyed on the name of the style attribute and whose value will
		be applied to that attribute. For example, if you wanted to apply a
		`background-color:black;` style to an element, you would set the
		elementStyle hash to `{'background-color':'black'}`.

		You should not maintain this hash yourself, rather, you should use
		the `style()` method of `Ember.RenderBuffer`.

		@property elementStyle
		@type Hash
		@default {}
	*/
	elementStyle: null,

	/**
		Nested `RenderBuffers` will set this to their parent `RenderBuffer`
		instance.

		@property parentBuffer
		@type Ember._RenderBuffer
	*/
	parentBuffer: null,

	/**
		Adds a string of HTML to the `RenderBuffer`.

		@method push
		@param {String} string HTML to push into the buffer
		@chainable
	*/
	push: function(string) {
		this.buffer += string;
		return this;
	},

	queueAppendChild: function(node) {
		this.queuedAppendChilds.push([this.elementIds[this.elementIds.length-1], node]);
	},

	/**
		Adds a class to the buffer, which will be rendered to the class attribute.

		@method addClass
		@param {String} className Class name to add to the buffer
		@chainable
	*/
	addClass: function(className) {
		// lazily create elementClasses
		this.elementClasses = (this.elementClasses || new ClassSet());
		this.elementClasses.add(className);
		this.classes = this.elementClasses.list;

		return this;
	},

	setClasses: function(classNames) {
		this.classes = classNames;
	},

	/**
		Sets the elementID to be used for the element.

		@method id
		@param {String} id
		@chainable
	*/
	id: function(id) {
		this.elementId = id;
		return this;
	},

	// duck type attribute functionality like jQuery so a render buffer
	// can be used like a jQuery object in attribute binding scenarios.

	/**
		Adds an attribute which will be rendered to the element.

		@method attr
		@param {String} name The name of the attribute
		@param {String} value The value to add to the attribute
		@chainable
		@return {Ember.RenderBuffer|String} this or the current attribute value
	*/
	attr: function(name, value) {
		var attributes = this.elementAttributes = (this.elementAttributes || {});

		if (arguments.length === 1) {
			return attributes[name];
		} else {
			attributes[name] = value;
		}

		return this;
	},

	/**
		Remove an attribute from the list of attributes to render.

		@method removeAttr
		@param {String} name The name of the attribute
		@chainable
	*/
	removeAttr: function(name) {
		var attributes = this.elementAttributes;
		if (attributes) { delete attributes[name]; }

		return this;
	},

	/**
		Adds an property which will be rendered to the element.

		@method prop
		@param {String} name The name of the property
		@param {String} value The value to add to the property
		@chainable
		@return {Ember.RenderBuffer|String} this or the current property value
	*/
	prop: function(name, value) {
		var properties = this.elementProperties = (this.elementProperties || {});

		if (arguments.length === 1) {
			return properties[name];
		} else {
			properties[name] = value;
		}

		return this;
	},

	/**
		Remove an property from the list of properties to render.

		@method removeProp
		@param {String} name The name of the property
		@chainable
	*/
	removeProp: function(name) {
		var properties = this.elementProperties;
		if (properties) { delete properties[name]; }

		return this;
	},

	/**
		Adds a style to the style attribute which will be rendered to the element.

		@method style
		@param {String} name Name of the style
		@param {String} value
		@chainable
	*/
	style: function(name, value) {
		this.elementStyle = (this.elementStyle || {});

		this.elementStyle[name] = value;
		return this;
	},

	begin: function(tagName, elementId) {
		this.tagNames.push(tagName || null);
		this.elementIds.push(elementId || null);
		return this;
	},

	pushOpeningTag: function() {
		var tagName = this.currentTagName();
		if (!tagName) { return; }

		if (this._hasElement && !this._element && this.buffer.length === 0) {
			this._element = this.generateElement();
			return;
		}

		var buffer = this.buffer,
				id = this.elementId,
				classes = this.classes,
				attrs = this.elementAttributes,
				props = this.elementProperties,
				style = this.elementStyle,
				attr, prop;

		buffer += '<' + stripTagName(tagName);

		if (id) {
			buffer += ' id="' + escapeAttribute(id) + '"';
			this.elementId = null;
		}
		if (classes) {
			buffer += ' class="' + escapeAttribute(classes.join(' ')) + '"';
			this.classes = null;
		}

		if (style) {
			buffer += ' style="';

			for (prop in style) {
				if (style.hasOwnProperty(prop)) {
					buffer += prop + ':' + escapeAttribute(style[prop]) + ';';
				}
			}

			buffer += '"';

			this.elementStyle = null;
		}

		if (attrs) {
			for (attr in attrs) {
				if (attrs.hasOwnProperty(attr)) {
					buffer += ' ' + attr + '="' + escapeAttribute(attrs[attr]) + '"';
				}
			}

			this.elementAttributes = null;
		}

		if (props) {
			for (prop in props) {
				if (props.hasOwnProperty(prop)) {
					var value = props[prop];
					if (value || typeof(value) === 'number') {
						if (value === true) {
							buffer += ' ' + prop + '="' + prop + '"';
						} else {
							buffer += ' ' + prop + '="' + escapeAttribute(props[prop]) + '"';
						}
					}
				}
			}

			this.elementProperties = null;
		}

		buffer += '>';
		this.buffer = buffer;
	},

	pushClosingTag: function() {
		var tagName = this.tagNames.pop();
		if (tagName) { this.buffer += '</' + stripTagName(tagName) + '>'; }
	},

	currentTagName: function() {
		return this.tagNames[this.tagNames.length-1];
	},

	generateElement: function() {
		var tagName = this.tagNames.pop(), // pop since we don't need to close
				id = this.elementId,
				classes = this.classes,
				attrs = this.elementAttributes,
				props = this.elementProperties,
				style = this.elementStyle,
				styleBuffer = '', attr, prop, tagString;

		if (attrs && attrs.name && !canSetNameOnInputs) {
			// IE allows passing a tag to createElement. See note on `canSetNameOnInputs` above as well.
			tagString = '<'+stripTagName(tagName)+' name="'+escapeAttribute(attrs.name)+'">';
		} else {
			tagString = tagName;
		}

		var element = document.createElement(tagString),
				$element = Ember.$(element);

		if (id) {
			$element.attr('id', id);
			this.elementId = null;
		}
		if (classes) {
			$element.attr('class', classes.join(' '));
			this.classes = null;
		}

		if (style) {
			for (prop in style) {
				if (style.hasOwnProperty(prop)) {
					styleBuffer += (prop + ':' + style[prop] + ';');
				}
			}

			$element.attr('style', styleBuffer);

			this.elementStyle = null;
		}

		if (attrs) {
			for (attr in attrs) {
				if (attrs.hasOwnProperty(attr)) {
					$element.attr(attr, attrs[attr]);
				}
			}

			this.elementAttributes = null;
		}

		if (props) {
			for (prop in props) {
				if (props.hasOwnProperty(prop)) {
					$element.prop(prop, props[prop]);
				}
			}

			this.elementProperties = null;
		}

		return element;
	},

	/**
		@method element
		@return {DOMElement} The element corresponding to the generated HTML
			of this buffer
	*/
	element: function() {
		var html = this.innerString();

		if (html) {
			this._element = Ember.ViewUtils.setInnerHTML(this._element, html);
		}

		// append HTMLBars shizzle
		var queuedAppendChilds = this.queuedAppendChilds,
				queuedIdAndNode;
		for (var i = 0, l = queuedAppendChilds.length; i < l; i++) {
			queuedIdAndNode = queuedAppendChilds[i];
			if (queuedIdAndNode[0] === this._element.id) {
				this._element.appendChild(queuedIdAndNode[1]);
			} else {
				Ember.$('#'+queuedIdAndNode[0], this._element)[0].appendChild(queuedIdAndNode[1]);
			}
		}
		this.queuedAppendChilds.length = 0; // clear it

		return this._element;
	},

	/**
		Generates the HTML content for this buffer.

		@method string
		@return {String} The generated HTML
	*/
	string: function() {
		if (this._hasElement && this._element) {
			// Firefox versions < 11 do not have support for element.outerHTML.
			var thisElement = this.element(), outerHTML = thisElement.outerHTML;
			if (typeof outerHTML === 'undefined') {
				return Ember.$('<div/>').append(thisElement).html();
			}
			return outerHTML;
		} else {
			return this.innerString();
		}
	},

	innerString: function() {
		return this.buffer;
	}
};

})();



(function() {
/**
@module ember
@submodule ember-views
*/

var get = Ember.get, set = Ember.set, fmt = Ember.String.fmt;

/**
	`Ember.EventDispatcher` handles delegating browser events to their
	corresponding `Ember.Views.` For example, when you click on a view,
	`Ember.EventDispatcher` ensures that that view's `mouseDown` method gets
	called.

	@class EventDispatcher
	@namespace Ember
	@private
	@extends Ember.Object
*/
Ember.EventDispatcher = Ember.Object.extend({

	/**
		The set of events names (and associated handler function names) to be setup
		and dispatched by the `EventDispatcher`. Custom events can added to this list at setup
		time, generally via the `Ember.Application.customEvents` hash. Only override this
		default set to prevent the EventDispatcher from listening on some events all together.

		This set will be modified by `setup` to also include any events added at that time.

		@property events
		@type Object
	*/
	events: {
		touchstart  : 'touchStart',
		touchmove   : 'touchMove',
		touchend    : 'touchEnd',
		touchcancel : 'touchCancel',
		keydown     : 'keyDown',
		keyup       : 'keyUp',
		keypress    : 'keyPress',
		mousedown   : 'mouseDown',
		mouseup     : 'mouseUp',
		contextmenu : 'contextMenu',
		click       : 'click',
		dblclick    : 'doubleClick',
		mousemove   : 'mouseMove',
		focusin     : 'focusIn',
		focusout    : 'focusOut',
		mouseenter  : 'mouseEnter',
		mouseleave  : 'mouseLeave',
		submit      : 'submit',
		input       : 'input',
		change      : 'change',
		dragstart   : 'dragStart',
		drag        : 'drag',
		dragenter   : 'dragEnter',
		dragleave   : 'dragLeave',
		dragover    : 'dragOver',
		drop        : 'drop',
		dragend     : 'dragEnd'
	},

	/**
		The root DOM element to which event listeners should be attached. Event
		listeners will be attached to the document unless this is overridden.

		Can be specified as a DOMElement or a selector string.

		The default body is a string since this may be evaluated before document.body
		exists in the DOM.

		@private
		@property rootElement
		@type DOMElement
		@default 'body'
	*/
	rootElement: 'body',

	/**
		Sets up event listeners for standard browser events.

		This will be called after the browser sends a `DOMContentReady` event. By
		default, it will set up all of the listeners on the document body. If you
		would like to register the listeners on a different element, set the event
		dispatcher's `root` property.

		@private
		@method setup
		@param addedEvents {Hash}
	*/
	setup: function(addedEvents, rootElement) {
		var event, events = get(this, 'events');

		Ember.$.extend(events, addedEvents || {});


		if (!Ember.isNone(rootElement)) {
			set(this, 'rootElement', rootElement);
		}

		rootElement = Ember.$(get(this, 'rootElement'));


		rootElement.addClass('ember-application');


		for (event in events) {
			if (events.hasOwnProperty(event)) {
				this.setupHandler(rootElement, event, events[event]);
			}
		}
	},

	/**
		Registers an event listener on the document. If the given event is
		triggered, the provided event handler will be triggered on the target view.

		If the target view does not implement the event handler, or if the handler
		returns `false`, the parent view will be called. The event will continue to
		bubble to each successive parent view until it reaches the top.

		For example, to have the `mouseDown` method called on the target view when
		a `mousedown` event is received from the browser, do the following:

		```javascript
		setupHandler('mousedown', 'mouseDown');
		```

		@private
		@method setupHandler
		@param {Element} rootElement
		@param {String} event the browser-originated event to listen to
		@param {String} eventName the name of the method to call on the view
	*/
	setupHandler: function(rootElement, event, eventName) {
		var self = this;

		rootElement.on(event + '.ember', '.ember-view', function(evt, triggeringManager) {
			return Ember.handleErrors(function handleViewEvent() {
				var view = Ember.View.views[this.id],
						result = true, manager = null;

				manager = self._findNearestEventManager(view,eventName);

				if (manager && manager !== triggeringManager) {
					result = self._dispatchEvent(manager, evt, eventName, view);
				} else if (view) {
					result = self._bubbleEvent(view,evt,eventName);
				} else {
					evt.stopPropagation();
				}

				return result;
			}, this);
		});

		rootElement.on(event + '.ember', '[data-ember-action]', function(evt) {
			return Ember.handleErrors(function handleActionEvent() {
				var actionId = Ember.$(evt.currentTarget).attr('data-ember-action'),
						action   = Ember.Handlebars.ActionHelper.registeredActions[actionId];

				// We have to check for action here since in some cases, jQuery will trigger
				// an event on `removeChild` (i.e. focusout) after we've already torn down the
				// action handlers for the view.
				if (action && action.eventName === eventName) {
					return action.handler(evt);
				}
			}, this);
		});
	},

	_findNearestEventManager: function(view, eventName) {
		var manager = null;

		while (view) {
			manager = get(view, 'eventManager');
			if (manager && manager[eventName]) { break; }

			view = get(view, 'parentView');
		}

		return manager;
	},

	_dispatchEvent: function(object, evt, eventName, view) {
		var result = true;

		var handler = object[eventName];
		if (Ember.typeOf(handler) === 'function') {
			result = Ember.run(function() {
				return handler.call(object, evt, view);
			});
			// Do not preventDefault in eventManagers.
			evt.stopPropagation();
		}
		else {
			result = this._bubbleEvent(view, evt, eventName);
		}

		return result;
	},

	_bubbleEvent: function(view, evt, eventName) {
		return Ember.run(function bubbleEvent() {
			return view.handleEvent(eventName, evt);
		});
	},

	destroy: function() {
		var rootElement = get(this, 'rootElement');
		Ember.$(rootElement).off('.ember', '**').removeClass('ember-application');
		return this._super();
	}
});

})();



(function() {
/**
@module ember
@submodule ember-views
*/

// Add a new named queue for rendering views that happens
// after bindings have synced, and a queue for scheduling actions
// that that should occur after view rendering.
var queues = Ember.run.queues,
		indexOf = Ember.ArrayPolyfills.indexOf;
queues.splice(indexOf.call(queues, 'actions')+1, 0, 'render', 'afterRender');

})();



(function() {
/**
@module ember
@submodule ember-views
*/

var get = Ember.get, set = Ember.set;

// Original class declaration and documentation in runtime/lib/controllers/controller.js
// NOTE: It may be possible with YUIDoc to combine docs in two locations

/**
Additional methods for the ControllerMixin

@class ControllerMixin
@namespace Ember
*/
Ember.ControllerMixin.reopen({
	target: null,
	namespace: null,
	view: null,
	container: null,
	_childContainers: null,

	init: function() {
		this._super();
		set(this, '_childContainers', {});
	},

	_modelDidChange: Ember.observer('model', function() {
		var containers = get(this, '_childContainers');

		for (var prop in containers) {
			if (!containers.hasOwnProperty(prop)) { continue; }
			containers[prop].destroy();
		}

		set(this, '_childContainers', {});
	})
});

})();



(function() {

})();



(function() {
var states = {};

/**
@module ember
@submodule ember-views
*/

var get = Ember.get, set = Ember.set;
var guidFor = Ember.guidFor;
var a_forEach = Ember.EnumerableUtils.forEach;
var a_addObject = Ember.EnumerableUtils.addObject;
var meta = Ember.meta;

var childViewsProperty = Ember.computed(function() {
	var childViews = this._childViews, ret = Ember.A(), view = this;

	a_forEach(childViews, function(view) {
		var currentChildViews;
		if (view.isVirtual) {
			if (currentChildViews = get(view, 'childViews')) {
				ret.pushObjects(currentChildViews);
			}
		} else {
			ret.push(view);
		}
	});

	ret.replace = function (idx, removedCount, addedViews) {
		if (view instanceof Ember.ContainerView) {
						return view.replace(idx, removedCount, addedViews);
		}
		throw new Ember.Error("childViews is immutable");
	};

	return ret;
});


/**
	Global hash of shared templates. This will automatically be populated
	by the build tools so that you can store your Handlebars templates in
	separate files that get loaded into JavaScript at buildtime.

	@property TEMPLATES
	@for Ember
	@type Hash
*/
Ember.TEMPLATES = {};

/**
	`Ember.CoreView` is an abstract class that exists to give view-like behavior
	to both Ember's main view class `Ember.View` and other classes like
	`Ember._SimpleMetamorphView` that don't need the fully functionaltiy of
	`Ember.View`.

	Unless you have specific needs for `CoreView`, you will use `Ember.View`
	in your applications.

	@class CoreView
	@namespace Ember
	@extends Ember.Object
	@uses Ember.Evented
	@uses Ember.ActionHandler
*/

Ember.CoreView = Ember.Object.extend(Ember.Evented, Ember.ActionHandler, {
	isView: true,

	states: states,

	init: function() {
		this._super();
		this.transitionTo('preRender');
	},

	/**
		If the view is currently inserted into the DOM of a parent view, this
		property will point to the parent of the view.

		@property parentView
		@type Ember.View
		@default null
	*/
	parentView: Ember.computed(function() {
		var parent = this._parentView;

		if (parent && parent.isVirtual) {
			return get(parent, 'parentView');
		} else {
			return parent;
		}
	}).property('_parentView'),

	state: null,

	_parentView: null,

	// return the current view, not including virtual views
	concreteView: Ember.computed(function() {
		if (!this.isVirtual) { return this; }
		else { return get(this, 'parentView'); }
	}).property('parentView'),

	instrumentName: 'core_view',

	instrumentDetails: function(hash) {
		hash.object = this.toString();
	},

	/**
		Invoked by the view system when this view needs to produce an HTML
		representation. This method will create a new render buffer, if needed,
		then apply any default attributes, such as class names and visibility.
		Finally, the `render()` method is invoked, which is responsible for
		doing the bulk of the rendering.

		You should not need to override this method; instead, implement the
		`template` property, or if you need more control, override the `render`
		method.

		@method renderToBuffer
		@param {Ember.RenderBuffer} buffer the render buffer. If no buffer is
			passed, a default buffer, using the current view's `tagName`, will
			be used.
		@private
	*/
	renderToBuffer: function(parentBuffer, bufferOperation) {
		var name = 'render.' + this.instrumentName,
				details = {};

		this.instrumentDetails(details);

		return Ember.instrument(name, details, function instrumentRenderToBuffer() {
			return this._renderToBuffer(parentBuffer, bufferOperation);
		}, this);
	},

	_renderToBuffer: function(parentBuffer, bufferOperation) {
		// If this is the top-most view, start a new buffer. Otherwise,
		// create a new buffer relative to the original using the
		// provided buffer operation (for example, `insertAfter` will
		// insert a new buffer after the "parent buffer").
		var tagName = this.tagName;

		if (tagName === null || tagName === undefined) {
			tagName = 'div';
		}

		var buffer = this.buffer = parentBuffer && parentBuffer.begin(tagName, this.elementId) || Ember.RenderBuffer(tagName, this.elementId);
		this.transitionTo('inBuffer', false);

		this.beforeRender(buffer);
		this.render(buffer);
		this.afterRender(buffer);

		return buffer;
	},

	/**
		Override the default event firing from `Ember.Evented` to
		also call methods with the given name.

		@method trigger
		@param name {String}
		@private
	*/
	trigger: function(name) {
		this._super.apply(this, arguments);
		var method = this[name];
		if (method) {
			var args = [], i, l;
			for (i = 1, l = arguments.length; i < l; i++) {
				args.push(arguments[i]);
			}
			return method.apply(this, args);
		}
	},

	deprecatedSendHandles: function(actionName) {
		return !!this[actionName];
	},

	deprecatedSend: function(actionName) {
		var args = [].slice.call(arguments, 1);
						this[actionName].apply(this, args);
		return;
	},

	has: function(name) {
		return Ember.typeOf(this[name]) === 'function' || this._super(name);
	},

	destroy: function() {
		var parent = this._parentView;

		if (!this._super()) { return; }

		// destroy the element -- this will avoid each child view destroying
		// the element over and over again...
		if (!this.removedFromDOM) { this.destroyElement(); }

		// remove from parent if found. Don't call removeFromParent,
		// as removeFromParent will try to remove the element from
		// the DOM again.
		if (parent) { parent.removeChild(this); }

		this.transitionTo('destroying', false);

		return this;
	},

	clearRenderedChildren: Ember.K,
	triggerRecursively: Ember.K,
	invokeRecursively: Ember.K,
	transitionTo: Ember.K,
	destroyElement: Ember.K
});

var ViewCollection = Ember._ViewCollection = function(initialViews) {
	var views = this.views = initialViews || [];
	this.length = views.length;
};

ViewCollection.prototype = {
	length: 0,

	trigger: function(eventName) {
		var views = this.views, view;
		for (var i = 0, l = views.length; i < l; i++) {
			view = views[i];
			if (view.trigger) { view.trigger(eventName); }
		}
	},

	triggerRecursively: function(eventName) {
		var views = this.views;
		for (var i = 0, l = views.length; i < l; i++) {
			views[i].triggerRecursively(eventName);
		}
	},

	invokeRecursively: function(fn) {
		var views = this.views, view;

		for (var i = 0, l = views.length; i < l; i++) {
			view = views[i];
			fn(view);
		}
	},

	transitionTo: function(state, children) {
		var views = this.views;
		for (var i = 0, l = views.length; i < l; i++) {
			views[i].transitionTo(state, children);
		}
	},

	push: function() {
		this.length += arguments.length;
		var views = this.views;
		return views.push.apply(views, arguments);
	},

	objectAt: function(idx) {
		return this.views[idx];
	},

	forEach: function(callback) {
		var views = this.views;
		return a_forEach(views, callback);
	},

	clear: function() {
		this.length = 0;
		this.views.length = 0;
	}
};

var EMPTY_ARRAY = [];

/**
	`Ember.View` is the class in Ember responsible for encapsulating templates of
	HTML content, combining templates with data to render as sections of a page's
	DOM, and registering and responding to user-initiated events.

	## HTML Tag

	The default HTML tag name used for a view's DOM representation is `div`. This
	can be customized by setting the `tagName` property. The following view
	class:

	```javascript
	ParagraphView = Ember.View.extend({
		tagName: 'em'
	});
	```

	Would result in instances with the following HTML:

	```html
	<em id="ember1" class="ember-view"></em>
	```

	## HTML `class` Attribute

	The HTML `class` attribute of a view's tag can be set by providing a
	`classNames` property that is set to an array of strings:

	```javascript
	MyView = Ember.View.extend({
		classNames: ['my-class', 'my-other-class']
	});
	```

	Will result in view instances with an HTML representation of:

	```html
	<div id="ember1" class="ember-view my-class my-other-class"></div>
	```

	`class` attribute values can also be set by providing a `classNameBindings`
	property set to an array of properties names for the view. The return value
	of these properties will be added as part of the value for the view's `class`
	attribute. These properties can be computed properties:

	```javascript
	MyView = Ember.View.extend({
		classNameBindings: ['propertyA', 'propertyB'],
		propertyA: 'from-a',
		propertyB: function() {
			if (someLogic) { return 'from-b'; }
		}.property()
	});
	```

	Will result in view instances with an HTML representation of:

	```html
	<div id="ember1" class="ember-view from-a from-b"></div>
	```

	If the value of a class name binding returns a boolean the property name
	itself will be used as the class name if the property is true. The class name
	will not be added if the value is `false` or `undefined`.

	```javascript
	MyView = Ember.View.extend({
		classNameBindings: ['hovered'],
		hovered: true
	});
	```

	Will result in view instances with an HTML representation of:

	```html
	<div id="ember1" class="ember-view hovered"></div>
	```

	When using boolean class name bindings you can supply a string value other
	than the property name for use as the `class` HTML attribute by appending the
	preferred value after a ":" character when defining the binding:

	```javascript
	MyView = Ember.View.extend({
		classNameBindings: ['awesome:so-very-cool'],
		awesome: true
	});
	```

	Will result in view instances with an HTML representation of:

	```html
	<div id="ember1" class="ember-view so-very-cool"></div>
	```

	Boolean value class name bindings whose property names are in a
	camelCase-style format will be converted to a dasherized format:

	```javascript
	MyView = Ember.View.extend({
		classNameBindings: ['isUrgent'],
		isUrgent: true
	});
	```

	Will result in view instances with an HTML representation of:

	```html
	<div id="ember1" class="ember-view is-urgent"></div>
	```

	Class name bindings can also refer to object values that are found by
	traversing a path relative to the view itself:

	```javascript
	MyView = Ember.View.extend({
		classNameBindings: ['messages.empty']
		messages: Ember.Object.create({
			empty: true
		})
	});
	```

	Will result in view instances with an HTML representation of:

	```html
	<div id="ember1" class="ember-view empty"></div>
	```

	If you want to add a class name for a property which evaluates to true and
	and a different class name if it evaluates to false, you can pass a binding
	like this:

	```javascript
	// Applies 'enabled' class when isEnabled is true and 'disabled' when isEnabled is false
	Ember.View.extend({
		classNameBindings: ['isEnabled:enabled:disabled']
		isEnabled: true
	});
	```

	Will result in view instances with an HTML representation of:

	```html
	<div id="ember1" class="ember-view enabled"></div>
	```

	When isEnabled is `false`, the resulting HTML reprensentation looks like
	this:

	```html
	<div id="ember1" class="ember-view disabled"></div>
	```

	This syntax offers the convenience to add a class if a property is `false`:

	```javascript
	// Applies no class when isEnabled is true and class 'disabled' when isEnabled is false
	Ember.View.extend({
		classNameBindings: ['isEnabled::disabled']
		isEnabled: true
	});
	```

	Will result in view instances with an HTML representation of:

	```html
	<div id="ember1" class="ember-view"></div>
	```

	When the `isEnabled` property on the view is set to `false`, it will result
	in view instances with an HTML representation of:

	```html
	<div id="ember1" class="ember-view disabled"></div>
	```

	Updates to the the value of a class name binding will result in automatic
	update of the  HTML `class` attribute in the view's rendered HTML
	representation. If the value becomes `false` or `undefined` the class name
	will be removed.

	Both `classNames` and `classNameBindings` are concatenated properties. See
	[Ember.Object](/api/classes/Ember.Object.html) documentation for more
	information about concatenated properties.

	## HTML Attributes

	The HTML attribute section of a view's tag can be set by providing an
	`attributeBindings` property set to an array of property names on the view.
	The return value of these properties will be used as the value of the view's
	HTML associated attribute:

	```javascript
	AnchorView = Ember.View.extend({
		tagName: 'a',
		attributeBindings: ['href'],
		href: 'http://google.com'
	});
	```

	Will result in view instances with an HTML representation of:

	```html
	<a id="ember1" class="ember-view" href="http://google.com"></a>
	```

	If the return value of an `attributeBindings` monitored property is a boolean
	the property will follow HTML's pattern of repeating the attribute's name as
	its value:

	```javascript
	MyTextInput = Ember.View.extend({
		tagName: 'input',
		attributeBindings: ['disabled'],
		disabled: true
	});
	```

	Will result in view instances with an HTML representation of:

	```html
	<input id="ember1" class="ember-view" disabled="disabled" />
	```

	`attributeBindings` can refer to computed properties:

	```javascript
	MyTextInput = Ember.View.extend({
		tagName: 'input',
		attributeBindings: ['disabled'],
		disabled: function() {
			if (someLogic) {
				return true;
			} else {
				return false;
			}
		}.property()
	});
	```

	Updates to the the property of an attribute binding will result in automatic
	update of the  HTML attribute in the view's rendered HTML representation.

	`attributeBindings` is a concatenated property. See [Ember.Object](/api/classes/Ember.Object.html)
	documentation for more information about concatenated properties.

	## Templates

	The HTML contents of a view's rendered representation are determined by its
	template. Templates can be any function that accepts an optional context
	parameter and returns a string of HTML that will be inserted within the
	view's tag. Most typically in Ember this function will be a compiled
	`Ember.Handlebars` template.

	```javascript
	AView = Ember.View.extend({
		template: Ember.Handlebars.compile('I am the template')
	});
	```

	Will result in view instances with an HTML representation of:

	```html
	<div id="ember1" class="ember-view">I am the template</div>
	```

	Within an Ember application is more common to define a Handlebars templates as
	part of a page:

	```html
	<script type='text/x-handlebars' data-template-name='some-template'>
		Hello
	</script>
	```

	And associate it by name using a view's `templateName` property:

	```javascript
	AView = Ember.View.extend({
		templateName: 'some-template'
	});
	```

	If you have nested resources, your Handlebars template will look like this:

	```html
	<script type='text/x-handlebars' data-template-name='posts/new'>
		<h1>New Post</h1>
	</script>
	```

	And `templateName` property:

	```javascript
	AView = Ember.View.extend({
		templateName: 'posts/new'
	});
	```

	Using a value for `templateName` that does not have a Handlebars template
	with a matching `data-template-name` attribute will throw an error.

	For views classes that may have a template later defined (e.g. as the block
	portion of a `{{view}}` Handlebars helper call in another template or in
	a subclass), you can provide a `defaultTemplate` property set to compiled
	template function. If a template is not later provided for the view instance
	the `defaultTemplate` value will be used:

	```javascript
	AView = Ember.View.extend({
		defaultTemplate: Ember.Handlebars.compile('I was the default'),
		template: null,
		templateName: null
	});
	```

	Will result in instances with an HTML representation of:

	```html
	<div id="ember1" class="ember-view">I was the default</div>
	```

	If a `template` or `templateName` is provided it will take precedence over
	`defaultTemplate`:

	```javascript
	AView = Ember.View.extend({
		defaultTemplate: Ember.Handlebars.compile('I was the default')
	});

	aView = AView.create({
		template: Ember.Handlebars.compile('I was the template, not default')
	});
	```

	Will result in the following HTML representation when rendered:

	```html
	<div id="ember1" class="ember-view">I was the template, not default</div>
	```

	## View Context

	The default context of the compiled template is the view's controller:

	```javascript
	AView = Ember.View.extend({
		template: Ember.Handlebars.compile('Hello {{excitedGreeting}}')
	});

	aController = Ember.Object.create({
		firstName: 'Barry',
		excitedGreeting: function() {
			return this.get("content.firstName") + "!!!"
		}.property()
	});

	aView = AView.create({
		controller: aController,
	});
	```

	Will result in an HTML representation of:

	```html
	<div id="ember1" class="ember-view">Hello Barry!!!</div>
	```

	A context can also be explicitly supplied through the view's `context`
	property. If the view has neither `context` nor `controller` properties, the
	`parentView`'s context will be used.

	## Layouts

	Views can have a secondary template that wraps their main template. Like
	primary templates, layouts can be any function that  accepts an optional
	context parameter and returns a string of HTML that will be inserted inside
	view's tag. Views whose HTML element is self closing (e.g. `<input />`)
	cannot have a layout and this property will be ignored.

	Most typically in Ember a layout will be a compiled `Ember.Handlebars`
	template.

	A view's layout can be set directly with the `layout` property or reference
	an existing Handlebars template by name with the `layoutName` property.

	A template used as a layout must contain a single use of the Handlebars
	`{{yield}}` helper. The HTML contents of a view's rendered `template` will be
	inserted at this location:

	```javascript
	AViewWithLayout = Ember.View.extend({
		layout: Ember.Handlebars.compile("<div class='my-decorative-class'>{{yield}}</div>")
		template: Ember.Handlebars.compile("I got wrapped"),
	});
	```

	Will result in view instances with an HTML representation of:

	```html
	<div id="ember1" class="ember-view">
		<div class="my-decorative-class">
			I got wrapped
		</div>
	</div>
	```

	See [Ember.Handlebars.helpers.yield](/api/classes/Ember.Handlebars.helpers.html#method_yield)
	for more information.

	## Responding to Browser Events

	Views can respond to user-initiated events in one of three ways: method
	implementation, through an event manager, and through `{{action}}` helper use
	in their template or layout.

	### Method Implementation

	Views can respond to user-initiated events by implementing a method that
	matches the event name. A `jQuery.Event` object will be passed as the
	argument to this method.

	```javascript
	AView = Ember.View.extend({
		click: function(event) {
			// will be called when when an instance's
			// rendered element is clicked
		}
	});
	```

	### Event Managers

	Views can define an object as their `eventManager` property. This object can
	then implement methods that match the desired event names. Matching events
	that occur on the view's rendered HTML or the rendered HTML of any of its DOM
	descendants will trigger this method. A `jQuery.Event` object will be passed
	as the first argument to the method and an  `Ember.View` object as the
	second. The `Ember.View` will be the view whose rendered HTML was interacted
	with. This may be the view with the `eventManager` property or one of its
	descendent views.

	```javascript
	AView = Ember.View.extend({
		eventManager: Ember.Object.create({
			doubleClick: function(event, view) {
				// will be called when when an instance's
				// rendered element or any rendering
				// of this views's descendent
				// elements is clicked
			}
		})
	});
	```

	An event defined for an event manager takes precedence over events of the
	same name handled through methods on the view.

	```javascript
	AView = Ember.View.extend({
		mouseEnter: function(event) {
			// will never trigger.
		},
		eventManager: Ember.Object.create({
			mouseEnter: function(event, view) {
				// takes precedence over AView#mouseEnter
			}
		})
	});
	```

	Similarly a view's event manager will take precedence for events of any views
	rendered as a descendent. A method name that matches an event name will not
	be called if the view instance was rendered inside the HTML representation of
	a view that has an `eventManager` property defined that handles events of the
	name. Events not handled by the event manager will still trigger method calls
	on the descendent.

	```javascript
	OuterView = Ember.View.extend({
		template: Ember.Handlebars.compile("outer {{#view InnerView}}inner{{/view}} outer"),
		eventManager: Ember.Object.create({
			mouseEnter: function(event, view) {
				// view might be instance of either
				// OuterView or InnerView depending on
				// where on the page the user interaction occured
			}
		})
	});

	InnerView = Ember.View.extend({
		click: function(event) {
			// will be called if rendered inside
			// an OuterView because OuterView's
			// eventManager doesn't handle click events
		},
		mouseEnter: function(event) {
			// will never be called if rendered inside
			// an OuterView.
		}
	});
	```

	### Handlebars `{{action}}` Helper

	See [Handlebars.helpers.action](/api/classes/Ember.Handlebars.helpers.html#method_action).

	### Event Names

	All of the event handling approaches described above respond to the same set
	of events. The names of the built-in events are listed below. (The hash of
	built-in events exists in `Ember.EventDispatcher`.) Additional, custom events
	can be registered by using `Ember.Application.customEvents`.

	Touch events:

	* `touchStart`
	* `touchMove`
	* `touchEnd`
	* `touchCancel`

	Keyboard events

	* `keyDown`
	* `keyUp`
	* `keyPress`

	Mouse events

	* `mouseDown`
	* `mouseUp`
	* `contextMenu`
	* `click`
	* `doubleClick`
	* `mouseMove`
	* `focusIn`
	* `focusOut`
	* `mouseEnter`
	* `mouseLeave`

	Form events:

	* `submit`
	* `change`
	* `focusIn`
	* `focusOut`
	* `input`

	HTML5 drag and drop events:

	* `dragStart`
	* `drag`
	* `dragEnter`
	* `dragLeave`
	* `drop`
	* `dragEnd`

	## Handlebars `{{view}}` Helper

	Other `Ember.View` instances can be included as part of a view's template by
	using the `{{view}}` Handlebars helper. See [Ember.Handlebars.helpers.view](/api/classes/Ember.Handlebars.helpers.html#method_view)
	for additional information.

	@class View
	@namespace Ember
	@extends Ember.CoreView
*/
Ember.View = Ember.CoreView.extend({

	concatenatedProperties: ['classNames', 'classNameBindings', 'attributeBindings'],

	/**
		@property isView
		@type Boolean
		@default true
		@static
	*/
	isView: true,

	// ..........................................................
	// TEMPLATE SUPPORT
	//

	/**
		The name of the template to lookup if no template is provided.

		By default `Ember.View` will lookup a template with this name in
		`Ember.TEMPLATES` (a shared global object).

		@property templateName
		@type String
		@default null
	*/
	templateName: null,

	/**
		The name of the layout to lookup if no layout is provided.

		By default `Ember.View` will lookup a template with this name in
		`Ember.TEMPLATES` (a shared global object).

		@property layoutName
		@type String
		@default null
	*/
	layoutName: null,

	/**
		The template used to render the view. This should be a function that
		accepts an optional context parameter and returns a string of HTML that
		will be inserted into the DOM relative to its parent view.

		In general, you should set the `templateName` property instead of setting
		the template yourself.

		@property template
		@type Function
	*/
	template: Ember.computed(function(key, value) {
		if (value !== undefined) { return value; }

		var templateName = get(this, 'templateName'),
				template = this.templateForName(templateName, 'template');


		return template || get(this, 'defaultTemplate');
	}).property('templateName'),

	/**
		The controller managing this view. If this property is set, it will be
		made available for use by the template.

		@property controller
		@type Object
	*/
	controller: Ember.computed(function(key) {
		var parentView = get(this, '_parentView');
		return parentView ? get(parentView, 'controller') : null;
	}).property('_parentView'),

	/**
		A view may contain a layout. A layout is a regular template but
		supersedes the `template` property during rendering. It is the
		responsibility of the layout template to retrieve the `template`
		property from the view (or alternatively, call `Handlebars.helpers.yield`,
		`{{yield}}`) to render it in the correct location.

		This is useful for a view that has a shared wrapper, but which delegates
		the rendering of the contents of the wrapper to the `template` property
		on a subclass.

		@property layout
		@type Function
	*/
	layout: Ember.computed(function(key) {
		var layoutName = get(this, 'layoutName'),
				layout = this.templateForName(layoutName, 'layout');


		return layout || get(this, 'defaultLayout');
	}).property('layoutName'),

	_yield: function(context, options) {
		var template = get(this, 'template');
		if (template) { template(context, options); }
	},

	templateForName: function(name, type) {
		if (!name) { return; }

		// the defaultContainer is deprecated
		var container = this.container || (Ember.Container && Ember.Container.defaultContainer);
		return container && container.lookup('template:' + name);
	},

	/**
		The object from which templates should access properties.

		This object will be passed to the template function each time the render
		method is called, but it is up to the individual function to decide what
		to do with it.

		By default, this will be the view's controller.

		@property context
		@type Object
	*/
	context: Ember.computed(function(key, value) {
		if (arguments.length === 2) {
			set(this, '_context', value);
			return value;
		} else {
			return get(this, '_context');
		}
	}).volatile(),

	/**
		Private copy of the view's template context. This can be set directly
		by Handlebars without triggering the observer that causes the view
		to be re-rendered.

		The context of a view is looked up as follows:

		1. Supplied context (usually by Handlebars)
		2. Specified controller
		3. `parentView`'s context (for a child of a ContainerView)

		The code in Handlebars that overrides the `_context` property first
		checks to see whether the view has a specified controller. This is
		something of a hack and should be revisited.

		@property _context
		@private
	*/
	_context: Ember.computed(function(key) {
		var parentView, controller;

		if (controller = get(this, 'controller')) {
			return controller;
		}

		parentView = this._parentView;
		if (parentView) {
			return get(parentView, '_context');
		}

		return null;
	}),

	/**
		If a value that affects template rendering changes, the view should be
		re-rendered to reflect the new value.

		@method _contextDidChange
		@private
	*/
	_contextDidChange: Ember.observer('context', function() {
		this.rerender();
	}),

	/**
		If `false`, the view will appear hidden in DOM.

		@property isVisible
		@type Boolean
		@default null
	*/
	isVisible: true,

	/**
		Array of child views. You should never edit this array directly.
		Instead, use `appendChild` and `removeFromParent`.

		@property childViews
		@type Array
		@default []
		@private
	*/
	childViews: childViewsProperty,

	_childViews: EMPTY_ARRAY,

	// When it's a virtual view, we need to notify the parent that their
	// childViews will change.
	_childViewsWillChange: Ember.beforeObserver('childViews', function() {
		if (this.isVirtual) {
			var parentView = get(this, 'parentView');
			if (parentView) { Ember.propertyWillChange(parentView, 'childViews'); }
		}
	}),

	// When it's a virtual view, we need to notify the parent that their
	// childViews did change.
	_childViewsDidChange: Ember.observer('childViews', function() {
		if (this.isVirtual) {
			var parentView = get(this, 'parentView');
			if (parentView) { Ember.propertyDidChange(parentView, 'childViews'); }
		}
	}),

	/**
		Return the nearest ancestor that is an instance of the provided
		class.

		@property nearestInstanceOf
		@param {Class} klass Subclass of Ember.View (or Ember.View itself)
		@return Ember.View
		@deprecated
	*/
	nearestInstanceOf: function(klass) {
				var view = get(this, 'parentView');

		while (view) {
			if (view instanceof klass) { return view; }
			view = get(view, 'parentView');
		}
	},

	/**
		Return the nearest ancestor that is an instance of the provided
		class or mixin.

		@property nearestOfType
		@param {Class,Mixin} klass Subclass of Ember.View (or Ember.View itself),
					 or an instance of Ember.Mixin.
		@return Ember.View
	*/
	nearestOfType: function(klass) {
		var view = get(this, 'parentView'),
				isOfType = klass instanceof Ember.Mixin ?
									 function(view) { return klass.detect(view); } :
									 function(view) { return klass.detect(view.constructor); };

		while (view) {
			if (isOfType(view)) { return view; }
			view = get(view, 'parentView');
		}
	},

	/**
		Return the nearest ancestor that has a given property.

		@function nearestWithProperty
		@param {String} property A property name
		@return Ember.View
	*/
	nearestWithProperty: function(property) {
		var view = get(this, 'parentView');

		while (view) {
			if (property in view) { return view; }
			view = get(view, 'parentView');
		}
	},

	/**
		Return the nearest ancestor whose parent is an instance of
		`klass`.

		@method nearestChildOf
		@param {Class} klass Subclass of Ember.View (or Ember.View itself)
		@return Ember.View
	*/
	nearestChildOf: function(klass) {
		var view = get(this, 'parentView');

		while (view) {
			if (get(view, 'parentView') instanceof klass) { return view; }
			view = get(view, 'parentView');
		}
	},

	/**
		When the parent view changes, recursively invalidate `controller`

		@method _parentViewDidChange
		@private
	*/
	_parentViewDidChange: Ember.observer('_parentView', function() {
		if (this.isDestroying) { return; }

		this.trigger('parentViewDidChange');

		if (get(this, 'parentView.controller') && !get(this, 'controller')) {
			this.notifyPropertyChange('controller');
		}
	}),

	_controllerDidChange: Ember.observer('controller', function() {
		if (this.isDestroying) { return; }

		this.rerender();

		this.forEachChildView(function(view) {
			view.propertyDidChange('controller');
		});
	}),

	cloneKeywords: function() {
		var templateData = get(this, 'templateData');

		var keywords = templateData ? Ember.copy(templateData.keywords) : {};
		set(keywords, 'view', get(this, 'concreteView'));
		set(keywords, '_view', this);
		set(keywords, 'controller', get(this, 'controller'));

		return keywords;
	},

	/**
		Called on your view when it should push strings of HTML into a
		`Ember.RenderBuffer`. Most users will want to override the `template`
		or `templateName` properties instead of this method.

		By default, `Ember.View` will look for a function in the `template`
		property and invoke it with the value of `context`. The value of
		`context` will be the view's controller unless you override it.

		@method render
		@param {Ember.RenderBuffer} buffer The render buffer
	*/
	render: function(buffer) {
		// If this view has a layout, it is the responsibility of the
		// the layout to render the view's template. Otherwise, render the template
		// directly.
		var template = get(this, 'layout') || get(this, 'template');

		if (template) {
			var context = get(this, 'context');
			var keywords = this.cloneKeywords();
			var output;

			var data = {
				view: this,
				buffer: buffer,
				isRenderData: true,
				keywords: keywords,
				insideGroup: get(this, 'templateData.insideGroup')
			};

			// Invoke the template with the provided template context, which
			// is the view's controller by default. A hash of data is also passed that provides
			// the template with access to the view and render buffer.

						// The template should write directly to the render buffer instead
			// of returning a string.
			if (this.usingHTMLBars) {
				output = template(context, { data: data, helpers: Ember.HTMLBars.View.DEFAULT_TEMPLATE_OPTIONS.helpers });
			} else {
				output = template(context, { data: data });
			}

			// If the template returned a string instead of writing to the buffer,
			// push the string onto the buffer.
			if (output !== undefined) {
				if (output instanceof DocumentFragment) {
					// TODO: the buffer's element isn't always going to be our view's element
					// buffer._element.appendChild(output);
					buffer.queueAppendChild(output);
				} else {
					buffer.push(output);
				}
			}
		}
	},

	/**
		Renders the view again. This will work regardless of whether the
		view is already in the DOM or not. If the view is in the DOM, the
		rendering process will be deferred to give bindings a chance
		to synchronize.

		If children were added during the rendering process using `appendChild`,
		`rerender` will remove them, because they will be added again
		if needed by the next `render`.

		In general, if the display of your view changes, you should modify
		the DOM element directly instead of manually calling `rerender`, which can
		be slow.

		@method rerender
	*/
	rerender: function() {
		return this.currentState.rerender(this);
	},

	clearRenderedChildren: function() {
		var lengthBefore = this.lengthBeforeRender,
				lengthAfter  = this.lengthAfterRender;

		// If there were child views created during the last call to render(),
		// remove them under the assumption that they will be re-created when
		// we re-render.

		// VIEW-TODO: Unit test this path.
		var childViews = this._childViews;
		for (var i=lengthAfter-1; i>=lengthBefore; i--) {
			if (childViews[i]) { childViews[i].destroy(); }
		}
	},

	/**
		Iterates over the view's `classNameBindings` array, inserts the value
		of the specified property into the `classNames` array, then creates an
		observer to update the view's element if the bound property ever changes
		in the future.

		@method _applyClassNameBindings
		@private
	*/
	_applyClassNameBindings: function(classBindings) {
		var classNames = this.classNames,
		elem, newClass, dasherizedClass;

		// Loop through all of the configured bindings. These will be either
		// property names ('isUrgent') or property paths relative to the view
		// ('content.isUrgent')
		a_forEach(classBindings, function(binding) {

			// Variable in which the old class value is saved. The observer function
			// closes over this variable, so it knows which string to remove when
			// the property changes.
			var oldClass;
			// Extract just the property name from bindings like 'foo:bar'
			var parsedPath = Ember.View._parsePropertyPath(binding);

			// Set up an observer on the context. If the property changes, toggle the
			// class name.
			var observer = function() {
				// Get the current value of the property
				newClass = this._classStringForProperty(binding);
				elem = this.$();

				// If we had previously added a class to the element, remove it.
				if (oldClass) {
					elem.removeClass(oldClass);
					// Also remove from classNames so that if the view gets rerendered,
					// the class doesn't get added back to the DOM.
					classNames.removeObject(oldClass);
				}

				// If necessary, add a new class. Make sure we keep track of it so
				// it can be removed in the future.
				if (newClass) {
					elem.addClass(newClass);
					oldClass = newClass;
				} else {
					oldClass = null;
				}
			};

			// Get the class name for the property at its current value
			dasherizedClass = this._classStringForProperty(binding);

			if (dasherizedClass) {
				// Ensure that it gets into the classNames array
				// so it is displayed when we render.
				a_addObject(classNames, dasherizedClass);

				// Save a reference to the class name so we can remove it
				// if the observer fires. Remember that this variable has
				// been closed over by the observer.
				oldClass = dasherizedClass;
			}

			this.registerObserver(this, parsedPath.path, observer);
			// Remove className so when the view is rerendered,
			// the className is added based on binding reevaluation
			this.one('willClearRender', function() {
				if (oldClass) {
					classNames.removeObject(oldClass);
					oldClass = null;
				}
			});

		}, this);
	},

	/**
		Iterates through the view's attribute bindings, sets up observers for each,
		then applies the current value of the attributes to the passed render buffer.

		@method _applyAttributeBindings
		@param {Ember.RenderBuffer} buffer
		@private
	*/
	_applyAttributeBindings: function(buffer, attributeBindings) {
		var attributeValue, elem;

		a_forEach(attributeBindings, function(binding) {
			var split = binding.split(':'),
					property = split[0],
					attributeName = split[1] || property;

			// Create an observer to add/remove/change the attribute if the
			// JavaScript property changes.
			var observer = function() {
				elem = this.$();

				attributeValue = get(this, property);

				Ember.View.applyAttributeBindings(elem, attributeName, attributeValue);
			};

			this.registerObserver(this, property, observer);

			// Determine the current value and add it to the render buffer
			// if necessary.
			attributeValue = get(this, property);
			Ember.View.applyAttributeBindings(buffer, attributeName, attributeValue);
		}, this);
	},

	/**
		Given a property name, returns a dasherized version of that
		property name if the property evaluates to a non-falsy value.

		For example, if the view has property `isUrgent` that evaluates to true,
		passing `isUrgent` to this method will return `"is-urgent"`.

		@method _classStringForProperty
		@param property
		@private
	*/
	_classStringForProperty: function(property) {
		var parsedPath = Ember.View._parsePropertyPath(property);
		var path = parsedPath.path;

		var val = get(this, path);
		if (val === undefined && Ember.isGlobalPath(path)) {
			val = get(Ember.lookup, path);
		}

		return Ember.View._classStringForValue(path, val, parsedPath.className, parsedPath.falsyClassName);
	},

	// ..........................................................
	// ELEMENT SUPPORT
	//

	/**
		Returns the current DOM element for the view.

		@property element
		@type DOMElement
	*/
	element: Ember.computed(function(key, value) {
		if (value !== undefined) {
			return this.currentState.setElement(this, value);
		} else {
			return this.currentState.getElement(this);
		}
	}).property('_parentView'),

	/**
		Returns a jQuery object for this view's element. If you pass in a selector
		string, this method will return a jQuery object, using the current element
		as its buffer.

		For example, calling `view.$('li')` will return a jQuery object containing
		all of the `li` elements inside the DOM element of this view.

		@method $
		@param {String} [selector] a jQuery-compatible selector string
		@return {jQuery} the jQuery object for the DOM node
	*/
	$: function(sel) {
		return this.currentState.$(this, sel);
	},

	mutateChildViews: function(callback) {
		var childViews = this._childViews,
				idx = childViews.length,
				view;

		while(--idx >= 0) {
			view = childViews[idx];
			callback(this, view, idx);
		}

		return this;
	},

	forEachChildView: function(callback) {
		var childViews = this._childViews;

		if (!childViews) { return this; }

		var len = childViews.length,
				view, idx;

		for (idx = 0; idx < len; idx++) {
			view = childViews[idx];
			callback(view);
		}

		return this;
	},

	/**
		Appends the view's element to the specified parent element.

		If the view does not have an HTML representation yet, `createElement()`
		will be called automatically.

		Note that this method just schedules the view to be appended; the DOM
		element will not be appended to the given element until all bindings have
		finished synchronizing.

		This is not typically a function that you will need to call directly when
		building your application. You might consider using `Ember.ContainerView`
		instead. If you do need to use `appendTo`, be sure that the target element
		you are providing is associated with an `Ember.Application` and does not
		have an ancestor element that is associated with an Ember view.

		@method appendTo
		@param {String|DOMElement|jQuery} A selector, element, HTML string, or jQuery object
		@return {Ember.View} receiver
	*/
	appendTo: function(target) {
		// Schedule the DOM element to be created and appended to the given
		// element after bindings have synchronized.
		this._insertElementLater(function() {
									this.$().appendTo(target);
		});

		return this;
	},

	/**
		Replaces the content of the specified parent element with this view's
		element. If the view does not have an HTML representation yet,
		`createElement()` will be called automatically.

		Note that this method just schedules the view to be appended; the DOM
		element will not be appended to the given element until all bindings have
		finished synchronizing

		@method replaceIn
		@param {String|DOMElement|jQuery} target A selector, element, HTML string, or jQuery object
		@return {Ember.View} received
	*/
	replaceIn: function(target) {

		this._insertElementLater(function() {
			Ember.$(target).empty();
			this.$().appendTo(target);
		});

		return this;
	},

	/**
		Schedules a DOM operation to occur during the next render phase. This
		ensures that all bindings have finished synchronizing before the view is
		rendered.

		To use, pass a function that performs a DOM operation.

		Before your function is called, this view and all child views will receive
		the `willInsertElement` event. After your function is invoked, this view
		and all of its child views will receive the `didInsertElement` event.

		```javascript
		view._insertElementLater(function() {
			this.createElement();
			this.$().appendTo('body');
		});
		```

		@method _insertElementLater
		@param {Function} fn the function that inserts the element into the DOM
		@private
	*/
	_insertElementLater: function(fn) {
		this._scheduledInsert = Ember.run.scheduleOnce('render', this, '_insertElement', fn);
	},

	_insertElement: function (fn) {
		this._scheduledInsert = null;
		this.currentState.insertElement(this, fn);
	},

	/**
		Appends the view's element to the document body. If the view does
		not have an HTML representation yet, `createElement()` will be called
		automatically.

		If your application uses the `rootElement` property, you must append
		the view within that element. Rendering views outside of the `rootElement`
		is not supported.

		Note that this method just schedules the view to be appended; the DOM
		element will not be appended to the document body until all bindings have
		finished synchronizing.

		@method append
		@return {Ember.View} receiver
	*/
	append: function() {
		return this.appendTo(document.body);
	},

	/**
		Removes the view's element from the element to which it is attached.

		@method remove
		@return {Ember.View} receiver
	*/
	remove: function() {
		// What we should really do here is wait until the end of the run loop
		// to determine if the element has been re-appended to a different
		// element.
		// In the interim, we will just re-render if that happens. It is more
		// important than elements get garbage collected.
		if (!this.removedFromDOM) { this.destroyElement(); }
		this.invokeRecursively(function(view) {
			if (view.clearRenderedChildren) { view.clearRenderedChildren(); }
		});
	},

	elementId: null,

	/**
		Attempts to discover the element in the parent element. The default
		implementation looks for an element with an ID of `elementId` (or the
		view's guid if `elementId` is null). You can override this method to
		provide your own form of lookup. For example, if you want to discover your
		element using a CSS class name instead of an ID.

		@method findElementInParentElement
		@param {DOMElement} parentElement The parent's DOM element
		@return {DOMElement} The discovered element
	*/
	findElementInParentElement: function(parentElem) {
		var id = "#" + this.elementId;
		return Ember.$(id)[0] || Ember.$(id, parentElem)[0];
	},

	/**
		Creates a DOM representation of the view and all of its
		child views by recursively calling the `render()` method.

		After the element has been created, `didInsertElement` will
		be called on this view and all of its child views.

		@method createElement
		@return {Ember.View} receiver
	*/
	createElement: function() {
		if (get(this, 'element')) { return this; }

		var buffer = this.renderToBuffer();
		set(this, 'element', buffer.element());

		return this;
	},

	/**
		Called when a view is going to insert an element into the DOM.

		@event willInsertElement
	*/
	willInsertElement: Ember.K,

	/**
		Called when the element of the view has been inserted into the DOM
		or after the view was re-rendered. Override this function to do any
		set up that requires an element in the document body.

		@event didInsertElement
	*/
	didInsertElement: Ember.K,

	/**
		Called when the view is about to rerender, but before anything has
		been torn down. This is a good opportunity to tear down any manual
		observers you have installed based on the DOM state

		@event willClearRender
	*/
	willClearRender: Ember.K,

	/**
		Run this callback on the current view (unless includeSelf is false) and recursively on child views.

		@method invokeRecursively
		@param fn {Function}
		@param includeSelf {Boolean} Includes itself if true.
		@private
	*/
	invokeRecursively: function(fn, includeSelf) {
		var childViews = (includeSelf === false) ? this._childViews : [this];
		var currentViews, view, currentChildViews;

		while (childViews.length) {
			currentViews = childViews.slice();
			childViews = [];

			for (var i=0, l=currentViews.length; i<l; i++) {
				view = currentViews[i];
				currentChildViews = view._childViews ? view._childViews.slice(0) : null;
				fn(view);
				if (currentChildViews) {
					childViews.push.apply(childViews, currentChildViews);
				}
			}
		}
	},

	triggerRecursively: function(eventName) {
		var childViews = [this], currentViews, view, currentChildViews;

		while (childViews.length) {
			currentViews = childViews.slice();
			childViews = [];

			for (var i=0, l=currentViews.length; i<l; i++) {
				view = currentViews[i];
				currentChildViews = view._childViews ? view._childViews.slice(0) : null;
				if (view.trigger) { view.trigger(eventName); }
				if (currentChildViews) {
					childViews.push.apply(childViews, currentChildViews);
				}

			}
		}
	},

	viewHierarchyCollection: function() {
		var currentView, viewCollection = new ViewCollection([this]);

		for (var i = 0; i < viewCollection.length; i++) {
			currentView = viewCollection.objectAt(i);
			if (currentView._childViews) {
				viewCollection.push.apply(viewCollection, currentView._childViews);
			}
		}

		return viewCollection;
	},

	/**
		Destroys any existing element along with the element for any child views
		as well. If the view does not currently have a element, then this method
		will do nothing.

		If you implement `willDestroyElement()` on your view, then this method will
		be invoked on your view before your element is destroyed to give you a
		chance to clean up any event handlers, etc.

		If you write a `willDestroyElement()` handler, you can assume that your
		`didInsertElement()` handler was called earlier for the same element.

		You should not call or override this method yourself, but you may
		want to implement the above callbacks.

		@method destroyElement
		@return {Ember.View} receiver
	*/
	destroyElement: function() {
		return this.currentState.destroyElement(this);
	},

	/**
		Called when the element of the view is going to be destroyed. Override
		this function to do any teardown that requires an element, like removing
		event listeners.

		@event willDestroyElement
	*/
	willDestroyElement: Ember.K,

	/**
		Triggers the `willDestroyElement` event (which invokes the
		`willDestroyElement()` method if it exists) on this view and all child
		views.

		Before triggering `willDestroyElement`, it first triggers the
		`willClearRender` event recursively.

		@method _notifyWillDestroyElement
		@private
	*/
	_notifyWillDestroyElement: function() {
		var viewCollection = this.viewHierarchyCollection();
		viewCollection.trigger('willClearRender');
		viewCollection.trigger('willDestroyElement');
		return viewCollection;
	},

	/**
		If this view's element changes, we need to invalidate the caches of our
		child views so that we do not retain references to DOM elements that are
		no longer needed.

		@method _elementDidChange
		@private
	*/
	_elementDidChange: Ember.observer('element', function() {
		this.forEachChildView(function(view) {
			delete meta(view).cache.element;
		});
	}),

	/**
		Called when the parentView property has changed.

		@event parentViewDidChange
	*/
	parentViewDidChange: Ember.K,

	instrumentName: 'view',

	instrumentDetails: function(hash) {
		hash.template = get(this, 'templateName');
		this._super(hash);
	},

	_renderToBuffer: function(parentBuffer, bufferOperation) {
		this.lengthBeforeRender = this._childViews.length;
		var buffer = this._super(parentBuffer, bufferOperation);
		this.lengthAfterRender = this._childViews.length;

		return buffer;
	},

	renderToBufferIfNeeded: function (buffer) {
		return this.currentState.renderToBufferIfNeeded(this, buffer);
	},

	beforeRender: function(buffer) {
		this.applyAttributesToBuffer(buffer);
		buffer.pushOpeningTag();
	},

	afterRender: function(buffer) {
		buffer.pushClosingTag();
	},

	applyAttributesToBuffer: function(buffer) {
		// Creates observers for all registered class name and attribute bindings,
		// then adds them to the element.
		var classNameBindings = get(this, 'classNameBindings');
		if (classNameBindings.length) {
			this._applyClassNameBindings(classNameBindings);
		}

		// Pass the render buffer so the method can apply attributes directly.
		// This isn't needed for class name bindings because they use the
		// existing classNames infrastructure.
		var attributeBindings = get(this, 'attributeBindings');
		if (attributeBindings.length) {
			this._applyAttributeBindings(buffer, attributeBindings);
		}

		buffer.setClasses(this.classNames);
		buffer.id(this.elementId);

		var role = get(this, 'ariaRole');
		if (role) {
			buffer.attr('role', role);
		}

		if (get(this, 'isVisible') === false) {
			buffer.style('display', 'none');
		}
	},

	// ..........................................................
	// STANDARD RENDER PROPERTIES
	//

	/**
		Tag name for the view's outer element. The tag name is only used when an
		element is first created. If you change the `tagName` for an element, you
		must destroy and recreate the view element.

		By default, the render buffer will use a `<div>` tag for views.

		@property tagName
		@type String
		@default null
	*/

	// We leave this null by default so we can tell the difference between
	// the default case and a user-specified tag.
	tagName: null,

	/**
		The WAI-ARIA role of the control represented by this view. For example, a
		button may have a role of type 'button', or a pane may have a role of
		type 'alertdialog'. This property is used by assistive software to help
		visually challenged users navigate rich web applications.

		The full list of valid WAI-ARIA roles is available at:
		[http://www.w3.org/TR/wai-aria/roles#roles_categorization](http://www.w3.org/TR/wai-aria/roles#roles_categorization)

		@property ariaRole
		@type String
		@default null
	*/
	ariaRole: null,

	/**
		Standard CSS class names to apply to the view's outer element. This
		property automatically inherits any class names defined by the view's
		superclasses as well.

		@property classNames
		@type Array
		@default ['ember-view']
	*/
	classNames: ['ember-view'],

	/**
		A list of properties of the view to apply as class names. If the property
		is a string value, the value of that string will be applied as a class
		name.

		```javascript
		// Applies the 'high' class to the view element
		Ember.View.extend({
			classNameBindings: ['priority']
			priority: 'high'
		});
		```

		If the value of the property is a Boolean, the name of that property is
		added as a dasherized class name.

		```javascript
		// Applies the 'is-urgent' class to the view element
		Ember.View.extend({
			classNameBindings: ['isUrgent']
			isUrgent: true
		});
		```

		If you would prefer to use a custom value instead of the dasherized
		property name, you can pass a binding like this:

		```javascript
		// Applies the 'urgent' class to the view element
		Ember.View.extend({
			classNameBindings: ['isUrgent:urgent']
			isUrgent: true
		});
		```

		This list of properties is inherited from the view's superclasses as well.

		@property classNameBindings
		@type Array
		@default []
	*/
	classNameBindings: EMPTY_ARRAY,

	/**
		A list of properties of the view to apply as attributes. If the property is
		a string value, the value of that string will be applied as the attribute.

		```javascript
		// Applies the type attribute to the element
		// with the value "button", like <div type="button">
		Ember.View.extend({
			attributeBindings: ['type'],
			type: 'button'
		});
		```

		If the value of the property is a Boolean, the name of that property is
		added as an attribute.

		```javascript
		// Renders something like <div enabled="enabled">
		Ember.View.extend({
			attributeBindings: ['enabled'],
			enabled: true
		});
		```

		@property attributeBindings
	*/
	attributeBindings: EMPTY_ARRAY,

	// .......................................................
	// CORE DISPLAY METHODS
	//

	/**
		Setup a view, but do not finish waking it up.

		* configure `childViews`
		* register the view with the global views hash, which is used for event
			dispatch

		@method init
		@private
	*/
	init: function() {
		this.elementId = this.elementId || guidFor(this);

		this._super();

		// setup child views. be sure to clone the child views array first
		this._childViews = this._childViews.slice();

				this.classNameBindings = Ember.A(this.classNameBindings.slice());

				this.classNames = Ember.A(this.classNames.slice());
	},

	appendChild: function(view, options) {
		return this.currentState.appendChild(this, view, options);
	},

	/**
		Removes the child view from the parent view.

		@method removeChild
		@param {Ember.View} view
		@return {Ember.View} receiver
	*/
	removeChild: function(view) {
		// If we're destroying, the entire subtree will be
		// freed, and the DOM will be handled separately,
		// so no need to mess with childViews.
		if (this.isDestroying) { return; }

		// update parent node
		set(view, '_parentView', null);

		// remove view from childViews array.
		var childViews = this._childViews;

		Ember.EnumerableUtils.removeObject(childViews, view);

		this.propertyDidChange('childViews'); // HUH?! what happened to will change?

		return this;
	},

	/**
		Removes all children from the `parentView`.

		@method removeAllChildren
		@return {Ember.View} receiver
	*/
	removeAllChildren: function() {
		return this.mutateChildViews(function(parentView, view) {
			parentView.removeChild(view);
		});
	},

	destroyAllChildren: function() {
		return this.mutateChildViews(function(parentView, view) {
			view.destroy();
		});
	},

	/**
		Removes the view from its `parentView`, if one is found. Otherwise
		does nothing.

		@method removeFromParent
		@return {Ember.View} receiver
	*/
	removeFromParent: function() {
		var parent = this._parentView;

		// Remove DOM element from parent
		this.remove();

		if (parent) { parent.removeChild(this); }
		return this;
	},

	/**
		You must call `destroy` on a view to destroy the view (and all of its
		child views). This will remove the view from any parent node, then make
		sure that the DOM element managed by the view can be released by the
		memory manager.

		@method destroy
	*/
	destroy: function() {
		var childViews = this._childViews,
				// get parentView before calling super because it'll be destroyed
				nonVirtualParentView = get(this, 'parentView'),
				viewName = this.viewName,
				childLen, i;

		if (!this._super()) { return; }

		childLen = childViews.length;
		for (i=childLen-1; i>=0; i--) {
			childViews[i].removedFromDOM = true;
		}

		// remove from non-virtual parent view if viewName was specified
		if (viewName && nonVirtualParentView) {
			nonVirtualParentView.set(viewName, null);
		}

		childLen = childViews.length;
		for (i=childLen-1; i>=0; i--) {
			childViews[i].destroy();
		}

		return this;
	},

	/**
		Instantiates a view to be added to the childViews array during view
		initialization. You generally will not call this method directly unless
		you are overriding `createChildViews()`. Note that this method will
		automatically configure the correct settings on the new view instance to
		act as a child of the parent.

		@method createChildView
		@param {Class|String} viewClass
		@param {Hash} [attrs] Attributes to add
		@return {Ember.View} new instance
	*/
	createChildView: function(view, attrs) {
		if (!view) {
			throw new TypeError("createChildViews first argument must exist");
		}

		if (view.isView && view._parentView === this && view.container === this.container) {
			return view;
		}

		attrs = attrs || {};
		attrs._parentView = this;

		if (Ember.CoreView.detect(view)) {
			attrs.templateData = attrs.templateData || get(this, 'templateData');

			attrs.container = this.container;
			view = view.create(attrs);

			// don't set the property on a virtual view, as they are invisible to
			// consumers of the view API
			if (view.viewName) {
				set(get(this, 'concreteView'), view.viewName, view);
			}
		} else if ('string' === typeof view) {
			var fullName = 'view:' + view;
			var View = this.container.lookupFactory(fullName);


			attrs.templateData = get(this, 'templateData');
			view = View.create(attrs);
		} else {
						attrs.container = this.container;

			if (!get(view, 'templateData')) {
				attrs.templateData = get(this, 'templateData');
			}

			Ember.setProperties(view, attrs);

		}

		return view;
	},

	becameVisible: Ember.K,
	becameHidden: Ember.K,

	/**
		When the view's `isVisible` property changes, toggle the visibility
		element of the actual DOM element.

		@method _isVisibleDidChange
		@private
	*/
	_isVisibleDidChange: Ember.observer('isVisible', function() {
		var $el = this.$();
		if (!$el) { return; }

		var isVisible = get(this, 'isVisible');

		$el.toggle(isVisible);

		if (this._isAncestorHidden()) { return; }

		if (isVisible) {
			this._notifyBecameVisible();
		} else {
			this._notifyBecameHidden();
		}
	}),

	_notifyBecameVisible: function() {
		this.trigger('becameVisible');

		this.forEachChildView(function(view) {
			var isVisible = get(view, 'isVisible');

			if (isVisible || isVisible === null) {
				view._notifyBecameVisible();
			}
		});
	},

	_notifyBecameHidden: function() {
		this.trigger('becameHidden');
		this.forEachChildView(function(view) {
			var isVisible = get(view, 'isVisible');

			if (isVisible || isVisible === null) {
				view._notifyBecameHidden();
			}
		});
	},

	_isAncestorHidden: function() {
		var parent = get(this, 'parentView');

		while (parent) {
			if (get(parent, 'isVisible') === false) { return true; }

			parent = get(parent, 'parentView');
		}

		return false;
	},

	clearBuffer: function() {
		this.invokeRecursively(function(view) {
			view.buffer = null;
		});
	},

	transitionTo: function(state, children) {
		var priorState = this.currentState,
				currentState = this.currentState = this.states[state];
		this.state = state;

		if (priorState && priorState.exit) { priorState.exit(this); }
		if (currentState.enter) { currentState.enter(this); }
		if (state === 'inDOM') { delete Ember.meta(this).cache.element; }

		if (children !== false) {
			this.forEachChildView(function(view) {
				view.transitionTo(state);
			});
		}
	},

	// .......................................................
	// EVENT HANDLING
	//

	/**
		Handle events from `Ember.EventDispatcher`

		@method handleEvent
		@param eventName {String}
		@param evt {Event}
		@private
	*/
	handleEvent: function(eventName, evt) {
		return this.currentState.handleEvent(this, eventName, evt);
	},

	registerObserver: function(root, path, target, observer) {
		if (!observer && 'function' === typeof target) {
			observer = target;
			target = null;
		}

		if (!root || typeof root !== 'object') {
			return;
		}

		var view = this,
				stateCheckedObserver = function() {
					view.currentState.invokeObserver(this, observer);
				},
				scheduledObserver = function() {
					Ember.run.scheduleOnce('render', this, stateCheckedObserver);
				};

		Ember.addObserver(root, path, target, scheduledObserver);

		this.one('willClearRender', function() {
			Ember.removeObserver(root, path, target, scheduledObserver);
		});
	}

});

/*
	Describe how the specified actions should behave in the various
	states that a view can exist in. Possible states:

	* preRender: when a view is first instantiated, and after its
		element was destroyed, it is in the preRender state
	* inBuffer: once a view has been rendered, but before it has
		been inserted into the DOM, it is in the inBuffer state
	* hasElement: the DOM representation of the view is created,
		and is ready to be inserted
	* inDOM: once a view has been inserted into the DOM it is in
		the inDOM state. A view spends the vast majority of its
		existence in this state.
	* destroyed: once a view has been destroyed (using the destroy
		method), it is in this state. No further actions can be invoked
		on a destroyed view.
*/

	// in the destroyed state, everything is illegal

	// before rendering has begun, all legal manipulations are noops.

	// inside the buffer, legal manipulations are done on the buffer

	// once the view has been inserted into the DOM, legal manipulations
	// are done on the DOM element.

function notifyMutationListeners() {
	Ember.run.once(Ember.View, 'notifyMutationListeners');
}

var DOMManager = {
	prepend: function(view, html) {
		view.$().prepend(html);
		notifyMutationListeners();
	},

	after: function(view, html) {
		view.$().after(html);
		notifyMutationListeners();
	},

	html: function(view, html) {
		view.$().html(html);
		notifyMutationListeners();
	},

	replace: function(view) {
		var element = get(view, 'element');

		set(view, 'element', null);

		view._insertElementLater(function() {
			Ember.$(element).replaceWith(get(view, 'element'));
			notifyMutationListeners();
		});
	},

	remove: function(view) {
		view.$().remove();
		notifyMutationListeners();
	},

	empty: function(view) {
		view.$().empty();
		notifyMutationListeners();
	}
};

Ember.View.reopen({
	domManager: DOMManager
});

Ember.View.reopenClass({

	/**
		Parse a path and return an object which holds the parsed properties.

		For example a path like "content.isEnabled:enabled:disabled" will return the
		following object:

		```javascript
		{
			path: "content.isEnabled",
			className: "enabled",
			falsyClassName: "disabled",
			classNames: ":enabled:disabled"
		}
		```

		@method _parsePropertyPath
		@static
		@private
	*/
	_parsePropertyPath: function(path) {
		var split = path.split(':'),
				propertyPath = split[0],
				classNames = "",
				className,
				falsyClassName;

		// check if the property is defined as prop:class or prop:trueClass:falseClass
		if (split.length > 1) {
			className = split[1];
			if (split.length === 3) { falsyClassName = split[2]; }

			classNames = ':' + className;
			if (falsyClassName) { classNames += ":" + falsyClassName; }
		}

		return {
			path: propertyPath,
			classNames: classNames,
			className: (className === '') ? undefined : className,
			falsyClassName: falsyClassName
		};
	},

	/**
		Get the class name for a given value, based on the path, optional
		`className` and optional `falsyClassName`.

		- if a `className` or `falsyClassName` has been specified:
			- if the value is truthy and `className` has been specified,
				`className` is returned
			- if the value is falsy and `falsyClassName` has been specified,
				`falsyClassName` is returned
			- otherwise `null` is returned
		- if the value is `true`, the dasherized last part of the supplied path
			is returned
		- if the value is not `false`, `undefined` or `null`, the `value`
			is returned
		- if none of the above rules apply, `null` is returned

		@method _classStringForValue
		@param path
		@param val
		@param className
		@param falsyClassName
		@static
		@private
	*/
	_classStringForValue: function(path, val, className, falsyClassName) {
		// When using the colon syntax, evaluate the truthiness or falsiness
		// of the value to determine which className to return
		if (className || falsyClassName) {
			if (className && !!val) {
				return className;

			} else if (falsyClassName && !val) {
				return falsyClassName;

			} else {
				return null;
			}

		// If value is a Boolean and true, return the dasherized property
		// name.
		} else if (val === true) {
			// Normalize property path to be suitable for use
			// as a class name. For exaple, content.foo.barBaz
			// becomes bar-baz.
			var parts = path.split('.');
			return Ember.String.dasherize(parts[parts.length-1]);

		// If the value is not false, undefined, or null, return the current
		// value of the property.
		} else if (val !== false && val != null) {
			return val;

		// Nothing to display. Return null so that the old class is removed
		// but no new class is added.
		} else {
			return null;
		}
	}
});

var mutation = Ember.Object.extend(Ember.Evented).create();

Ember.View.addMutationListener = function(callback) {
	mutation.on('change', callback);
};

Ember.View.removeMutationListener = function(callback) {
	mutation.off('change', callback);
};

Ember.View.notifyMutationListeners = function() {
	mutation.trigger('change');
};

/**
	Global views hash

	@property views
	@static
	@type Hash
*/
Ember.View.views = {};

// If someone overrides the child views computed property when
// defining their class, we want to be able to process the user's
// supplied childViews and then restore the original computed property
// at view initialization time. This happens in Ember.ContainerView's init
// method.
Ember.View.childViewsProperty = childViewsProperty;

Ember.View.applyAttributeBindings = function(elem, name, value) {
	var type = Ember.typeOf(value);

	// if this changes, also change the logic in ember-handlebars/lib/helpers/binding.js
	if (name !== 'value' && (type === 'string' || (type === 'number' && !isNaN(value)))) {
		if (value !== elem.attr(name)) {
			elem.attr(name, value);
		}
	} else if (name === 'value' || type === 'boolean') {
		// We can't set properties to undefined or null
		if (Ember.isNone(value)) { value = ''; }

		if (!value) {
			elem.removeAttr(name);
		}

		if (value !== elem.prop(name)) {
			// value and booleans should always be properties
			elem.prop(name, value);
		}
	} else if (!value) {
		elem.removeAttr(name);
	}
};

Ember.View.states = states;

})();



(function() {
/**
@module ember
@submodule ember-views
*/

var get = Ember.get, set = Ember.set;

Ember.View.states._default = {
	// appendChild is only legal while rendering the buffer.
	appendChild: function() {
		throw "You can't use appendChild outside of the rendering process";
	},

	$: function() {
		return undefined;
	},

	getElement: function() {
		return null;
	},

	// Handle events from `Ember.EventDispatcher`
	handleEvent: function() {
		return true; // continue event propagation
	},

	destroyElement: function(view) {
		set(view, 'element', null);
		if (view._scheduledInsert) {
			Ember.run.cancel(view._scheduledInsert);
			view._scheduledInsert = null;
		}
		return view;
	},

	renderToBufferIfNeeded: function () {
		return false;
	},

	rerender: Ember.K,
	invokeObserver: Ember.K
};

})();



(function() {
/**
@module ember
@submodule ember-views
*/

var preRender = Ember.View.states.preRender = Ember.create(Ember.View.states._default);

Ember.merge(preRender, {
	// a view leaves the preRender state once its element has been
	// created (createElement).
	insertElement: function(view, fn) {
		view.createElement();
		var viewCollection = view.viewHierarchyCollection();

		viewCollection.trigger('willInsertElement');

		fn.call(view);

		// We transition to `inDOM` if the element exists in the DOM
		var element = view.get('element');
		while (element = element.parentNode) {
			if (element === document) {
				viewCollection.transitionTo('inDOM', false);
				viewCollection.trigger('didInsertElement');
			}
		}

	},

	renderToBufferIfNeeded: function(view, buffer) {
		view.renderToBuffer(buffer);
		return true;
	},

	empty: Ember.K,

	setElement: function(view, value) {
		if (value !== null) {
			view.transitionTo('hasElement');
		}
		return value;
	}
});

})();



(function() {
/**
@module ember
@submodule ember-views
*/

var get = Ember.get, set = Ember.set;

var inBuffer = Ember.View.states.inBuffer = Ember.create(Ember.View.states._default);

Ember.merge(inBuffer, {
	$: function(view, sel) {
		// if we don't have an element yet, someone calling this.$() is
		// trying to update an element that isn't in the DOM. Instead,
		// rerender the view to allow the render method to reflect the
		// changes.
		view.rerender();
		return Ember.$();
	},

	// when a view is rendered in a buffer, rerendering it simply
	// replaces the existing buffer with a new one
	rerender: function(view) {
		throw new Ember.Error("Something you did caused a view to re-render after it rendered but before it was inserted into the DOM.");
	},

	// when a view is rendered in a buffer, appending a child
	// view will render that view and append the resulting
	// buffer into its buffer.
	appendChild: function(view, childView, options) {
		var buffer = view.buffer, _childViews = view._childViews;

		childView = view.createChildView(childView, options);
		if (!_childViews.length) { _childViews = view._childViews = _childViews.slice(); }
		_childViews.push(childView);

		childView.renderToBuffer(buffer);

		view.propertyDidChange('childViews');

		return childView;
	},

	// when a view is rendered in a buffer, destroying the
	// element will simply destroy the buffer and put the
	// state back into the preRender state.
	destroyElement: function(view) {
		view.clearBuffer();
		var viewCollection = view._notifyWillDestroyElement();
		viewCollection.transitionTo('preRender', false);

		return view;
	},

	empty: function() {
			},

	renderToBufferIfNeeded: function (view, buffer) {
		return false;
	},

	// It should be impossible for a rendered view to be scheduled for
	// insertion.
	insertElement: function() {
		throw "You can't insert an element that has already been rendered";
	},

	setElement: function(view, value) {
		if (value === null) {
			view.transitionTo('preRender');
		} else {
			view.clearBuffer();
			view.transitionTo('hasElement');
		}

		return value;
	},

	invokeObserver: function(target, observer) {
		observer.call(target);
	}
});


})();



(function() {
/**
@module ember
@submodule ember-views
*/

var get = Ember.get, set = Ember.set;

var hasElement = Ember.View.states.hasElement = Ember.create(Ember.View.states._default);

Ember.merge(hasElement, {
	$: function(view, sel) {
		var elem = get(view, 'element');
		return sel ? Ember.$(sel, elem) : Ember.$(elem);
	},

	getElement: function(view) {
		var parent = get(view, 'parentView');
		if (parent) { parent = get(parent, 'element'); }
		if (parent) { return view.findElementInParentElement(parent); }
		return Ember.$("#" + get(view, 'elementId'))[0];
	},

	setElement: function(view, value) {
		if (value === null) {
			view.transitionTo('preRender');
		} else {
			throw "You cannot set an element to a non-null value when the element is already in the DOM.";
		}

		return value;
	},

	// once the view has been inserted into the DOM, rerendering is
	// deferred to allow bindings to synchronize.
	rerender: function(view) {
		view.triggerRecursively('willClearRender');

		view.clearRenderedChildren();

		view.domManager.replace(view);
		return view;
	},

	// once the view is already in the DOM, destroying it removes it
	// from the DOM, nukes its element, and puts it back into the
	// preRender state if inDOM.

	destroyElement: function(view) {
		view._notifyWillDestroyElement();
		view.domManager.remove(view);
		set(view, 'element', null);
		if (view._scheduledInsert) {
			Ember.run.cancel(view._scheduledInsert);
			view._scheduledInsert = null;
		}
		return view;
	},

	empty: function(view) {
		var _childViews = view._childViews, len, idx;
		if (_childViews) {
			len = _childViews.length;
			for (idx = 0; idx < len; idx++) {
				_childViews[idx]._notifyWillDestroyElement();
			}
		}
		view.domManager.empty(view);
	},

	// Handle events from `Ember.EventDispatcher`
	handleEvent: function(view, eventName, evt) {
		if (view.has(eventName)) {
			// Handler should be able to re-dispatch events, so we don't
			// preventDefault or stopPropagation.
			return view.trigger(eventName, evt);
		} else {
			return true; // continue event propagation
		}
	},

	invokeObserver: function(target, observer) {
		observer.call(target);
	}
});
})();



(function() {
/**
@module ember
@submodule ember-views
*/

var hasElement = Ember.View.states.hasElement;
var inDOM = Ember.View.states.inDOM = Ember.create(hasElement);

Ember.merge(inDOM, {
	enter: function(view) {
		// Register the view for event handling. This hash is used by
		// Ember.EventDispatcher to dispatch incoming events.
		if (!view.isVirtual) {
						Ember.View.views[view.elementId] = view;
		}

		view.addBeforeObserver('elementId', function() {
			throw new Ember.Error("Changing a view's elementId after creation is not allowed");
		});
	},

	exit: function(view) {
		if (!this.isVirtual) delete Ember.View.views[view.elementId];
	},

	insertElement: function(view, fn) {
		throw "You can't insert an element into the DOM that has already been inserted";
	}
});

})();



(function() {
/**
@module ember
@submodule ember-views
*/

var destroyingError = "You can't call %@ on a view being destroyed", fmt = Ember.String.fmt;

var destroying = Ember.View.states.destroying = Ember.create(Ember.View.states._default);

Ember.merge(destroying, {
	appendChild: function() {
		throw fmt(destroyingError, ['appendChild']);
	},
	rerender: function() {
		throw fmt(destroyingError, ['rerender']);
	},
	destroyElement: function() {
		throw fmt(destroyingError, ['destroyElement']);
	},
	empty: function() {
		throw fmt(destroyingError, ['empty']);
	},

	setElement: function() {
		throw fmt(destroyingError, ["set('element', ...)"]);
	},

	renderToBufferIfNeeded: function() {
		return false;
	},

	// Since element insertion is scheduled, don't do anything if
	// the view has been destroyed between scheduling and execution
	insertElement: Ember.K
});


})();



(function() {
Ember.View.cloneStates = function(from) {
	var into = {};

	into._default = {};
	into.preRender = Ember.create(into._default);
	into.destroying = Ember.create(into._default);
	into.inBuffer = Ember.create(into._default);
	into.hasElement = Ember.create(into._default);
	into.inDOM = Ember.create(into.hasElement);

	for (var stateName in from) {
		if (!from.hasOwnProperty(stateName)) { continue; }
		Ember.merge(into[stateName], from[stateName]);
	}

	return into;
};

})();



(function() {
var states = Ember.View.cloneStates(Ember.View.states);

/**
@module ember
@submodule ember-views
*/

var get = Ember.get, set = Ember.set;
var forEach = Ember.EnumerableUtils.forEach;
var ViewCollection = Ember._ViewCollection;

/**
	A `ContainerView` is an `Ember.View` subclass that implements `Ember.MutableArray`
	allowing programmatic management of its child views.

	## Setting Initial Child Views

	The initial array of child views can be set in one of two ways. You can
	provide a `childViews` property at creation time that contains instance of
	`Ember.View`:

	```javascript
	aContainer = Ember.ContainerView.create({
		childViews: [Ember.View.create(), Ember.View.create()]
	});
	```

	You can also provide a list of property names whose values are instances of
	`Ember.View`:

	```javascript
	aContainer = Ember.ContainerView.create({
		childViews: ['aView', 'bView', 'cView'],
		aView: Ember.View.create(),
		bView: Ember.View.create(),
		cView: Ember.View.create()
	});
	```

	The two strategies can be combined:

	```javascript
	aContainer = Ember.ContainerView.create({
		childViews: ['aView', Ember.View.create()],
		aView: Ember.View.create()
	});
	```

	Each child view's rendering will be inserted into the container's rendered
	HTML in the same order as its position in the `childViews` property.

	## Adding and Removing Child Views

	The container view implements `Ember.MutableArray` allowing programmatic management of its child views.

	To remove a view, pass that view into a `removeObject` call on the container view.

	Given an empty `<body>` the following code

	```javascript
	aContainer = Ember.ContainerView.create({
		classNames: ['the-container'],
		childViews: ['aView', 'bView'],
		aView: Ember.View.create({
			template: Ember.Handlebars.compile("A")
		}),
		bView: Ember.View.create({
			template: Ember.Handlebars.compile("B")
		})
	});

	aContainer.appendTo('body');
	```

	Results in the HTML

	```html
	<div class="ember-view the-container">
		<div class="ember-view">A</div>
		<div class="ember-view">B</div>
	</div>
	```

	Removing a view

	```javascript
	aContainer.toArray();  // [aContainer.aView, aContainer.bView]
	aContainer.removeObject(aContainer.get('bView'));
	aContainer.toArray();  // [aContainer.aView]
	```

	Will result in the following HTML

	```html
	<div class="ember-view the-container">
		<div class="ember-view">A</div>
	</div>
	```

	Similarly, adding a child view is accomplished by adding `Ember.View` instances to the
	container view.

	Given an empty `<body>` the following code

	```javascript
	aContainer = Ember.ContainerView.create({
		classNames: ['the-container'],
		childViews: ['aView', 'bView'],
		aView: Ember.View.create({
			template: Ember.Handlebars.compile("A")
		}),
		bView: Ember.View.create({
			template: Ember.Handlebars.compile("B")
		})
	});

	aContainer.appendTo('body');
	```

	Results in the HTML

	```html
	<div class="ember-view the-container">
		<div class="ember-view">A</div>
		<div class="ember-view">B</div>
	</div>
	```

	Adding a view

	```javascript
	AnotherViewClass = Ember.View.extend({
		template: Ember.Handlebars.compile("Another view")
	});

	aContainer.toArray();  // [aContainer.aView, aContainer.bView]
	aContainer.pushObject(AnotherViewClass.create());
	aContainer.toArray(); // [aContainer.aView, aContainer.bView, <AnotherViewClass instance>]
	```

	Will result in the following HTML

	```html
	<div class="ember-view the-container">
		<div class="ember-view">A</div>
		<div class="ember-view">B</div>
		<div class="ember-view">Another view</div>
	</div>
	```

	## Templates and Layout

	A `template`, `templateName`, `defaultTemplate`, `layout`, `layoutName` or
	`defaultLayout` property on a container view will not result in the template
	or layout being rendered. The HTML contents of a `Ember.ContainerView`'s DOM
	representation will only be the rendered HTML of its child views.

	@class ContainerView
	@namespace Ember
	@extends Ember.View
*/
Ember.ContainerView = Ember.View.extend(Ember.MutableArray, {
	states: states,

	init: function() {
		this._super();

		var childViews = get(this, 'childViews');

		// redefine view's childViews property that was obliterated
		Ember.defineProperty(this, 'childViews', Ember.View.childViewsProperty);

		var _childViews = this._childViews;

		forEach(childViews, function(viewName, idx) {
			var view;

			if ('string' === typeof viewName) {
				view = get(this, viewName);
				view = this.createChildView(view);
				set(this, viewName, view);
			} else {
				view = this.createChildView(viewName);
			}

			_childViews[idx] = view;
		}, this);

		var currentView = get(this, 'currentView');
		if (currentView) {
			if (!_childViews.length) { _childViews = this._childViews = this._childViews.slice(); }
			_childViews.push(this.createChildView(currentView));
		}
	},

	replace: function(idx, removedCount, addedViews) {
		var addedCount = addedViews ? get(addedViews, 'length') : 0;
		var self = this;

		this.arrayContentWillChange(idx, removedCount, addedCount);
		this.childViewsWillChange(this._childViews, idx, removedCount);

		if (addedCount === 0) {
			this._childViews.splice(idx, removedCount) ;
		} else {
			var args = [idx, removedCount].concat(addedViews);
			if (addedViews.length && !this._childViews.length) { this._childViews = this._childViews.slice(); }
			this._childViews.splice.apply(this._childViews, args);
		}

		this.arrayContentDidChange(idx, removedCount, addedCount);
		this.childViewsDidChange(this._childViews, idx, removedCount, addedCount);

		return this;
	},

	objectAt: function(idx) {
		return this._childViews[idx];
	},

	length: Ember.computed(function () {
		return this._childViews.length;
	}).volatile(),

	/**
		Instructs each child view to render to the passed render buffer.

		@private
		@method render
		@param {Ember.RenderBuffer} buffer the buffer to render to
	*/
	render: function(buffer) {
		this.forEachChildView(function(view) {
			view.renderToBuffer(buffer);
		});
	},

	instrumentName: 'container',

	/**
		When a child view is removed, destroy its element so that
		it is removed from the DOM.

		The array observer that triggers this action is set up in the
		`renderToBuffer` method.

		@private
		@method childViewsWillChange
		@param {Ember.Array} views the child views array before mutation
		@param {Number} start the start position of the mutation
		@param {Number} removed the number of child views removed
	**/
	childViewsWillChange: function(views, start, removed) {
		this.propertyWillChange('childViews');

		if (removed > 0) {
			var changedViews = views.slice(start, start+removed);
			// transition to preRender before clearing parentView
			this.currentState.childViewsWillChange(this, views, start, removed);
			this.initializeViews(changedViews, null, null);
		}
	},

	removeChild: function(child) {
		this.removeObject(child);
		return this;
	},

	/**
		When a child view is added, make sure the DOM gets updated appropriately.

		If the view has already rendered an element, we tell the child view to
		create an element and insert it into the DOM. If the enclosing container
		view has already written to a buffer, but not yet converted that buffer
		into an element, we insert the string representation of the child into the
		appropriate place in the buffer.

		@private
		@method childViewsDidChange
		@param {Ember.Array} views the array of child views afte the mutation has occurred
		@param {Number} start the start position of the mutation
		@param {Number} removed the number of child views removed
		@param {Number} the number of child views added
	*/
	childViewsDidChange: function(views, start, removed, added) {
		if (added > 0) {
			var changedViews = views.slice(start, start+added);
			this.initializeViews(changedViews, this, get(this, 'templateData'));
			this.currentState.childViewsDidChange(this, views, start, added);
		}
		this.propertyDidChange('childViews');
	},

	initializeViews: function(views, parentView, templateData) {
		forEach(views, function(view) {
			set(view, '_parentView', parentView);

			if (!view.container && parentView) {
				set(view, 'container', parentView.container);
			}

			if (!get(view, 'templateData')) {
				set(view, 'templateData', templateData);
			}
		});
	},

	currentView: null,

	_currentViewWillChange: Ember.beforeObserver('currentView', function() {
		var currentView = get(this, 'currentView');
		if (currentView) {
			currentView.destroy();
		}
	}),

	_currentViewDidChange: Ember.observer('currentView', function() {
		var currentView = get(this, 'currentView');
		if (currentView) {
						this.pushObject(currentView);
		}
	}),

	_ensureChildrenAreInDOM: function () {
		this.currentState.ensureChildrenAreInDOM(this);
	}
});

Ember.merge(states._default, {
	childViewsWillChange: Ember.K,
	childViewsDidChange: Ember.K,
	ensureChildrenAreInDOM: Ember.K
});

Ember.merge(states.inBuffer, {
	childViewsDidChange: function(parentView, views, start, added) {
		throw new Ember.Error('You cannot modify child views while in the inBuffer state');
	}
});

Ember.merge(states.hasElement, {
	childViewsWillChange: function(view, views, start, removed) {
		for (var i=start; i<start+removed; i++) {
			views[i].remove();
		}
	},

	childViewsDidChange: function(view, views, start, added) {
		Ember.run.scheduleOnce('render', view, '_ensureChildrenAreInDOM');
	},

	ensureChildrenAreInDOM: function(view) {
		var childViews = view._childViews, i, len, childView, previous, buffer, viewCollection = new ViewCollection();

		for (i = 0, len = childViews.length; i < len; i++) {
			childView = childViews[i];

			if (!buffer) { buffer = Ember.RenderBuffer(); buffer._hasElement = false; }

			if (childView.renderToBufferIfNeeded(buffer)) {
				viewCollection.push(childView);
			} else if (viewCollection.length) {
				insertViewCollection(view, viewCollection, previous, buffer);
				buffer = null;
				previous = childView;
				viewCollection.clear();
			} else {
				previous = childView;
			}
		}

		if (viewCollection.length) {
			insertViewCollection(view, viewCollection, previous, buffer);
		}
	}
});

function insertViewCollection(view, viewCollection, previous, buffer) {
	viewCollection.triggerRecursively('willInsertElement');

	if (previous) {
		previous.domManager.after(previous, buffer.string());
	} else {
		view.domManager.prepend(view, buffer.string());
	}

	viewCollection.forEach(function(v) {
		v.transitionTo('inDOM');
		v.propertyDidChange('element');
		v.triggerRecursively('didInsertElement');
	});
}


})();



(function() {
/**
@module ember
@submodule ember-views
*/

var get = Ember.get, set = Ember.set, fmt = Ember.String.fmt;

/**
	`Ember.CollectionView` is an `Ember.View` descendent responsible for managing
	a collection (an array or array-like object) by maintaining a child view object
	and associated DOM representation for each item in the array and ensuring
	that child views and their associated rendered HTML are updated when items in
	the array are added, removed, or replaced.

	## Setting content

	The managed collection of objects is referenced as the `Ember.CollectionView`
	instance's `content` property.

	```javascript
	someItemsView = Ember.CollectionView.create({
		content: ['A', 'B','C']
	})
	```

	The view for each item in the collection will have its `content` property set
	to the item.

	## Specifying itemViewClass

	By default the view class for each item in the managed collection will be an
	instance of `Ember.View`. You can supply a different class by setting the
	`CollectionView`'s `itemViewClass` property.

	Given an empty `<body>` and the following code:

	```javascript
	someItemsView = Ember.CollectionView.create({
		classNames: ['a-collection'],
		content: ['A','B','C'],
		itemViewClass: Ember.View.extend({
			template: Ember.Handlebars.compile("the letter: {{view.content}}")
		})
	});

	someItemsView.appendTo('body');
	```

	Will result in the following HTML structure

	```html
	<div class="ember-view a-collection">
		<div class="ember-view">the letter: A</div>
		<div class="ember-view">the letter: B</div>
		<div class="ember-view">the letter: C</div>
	</div>
	```

	## Automatic matching of parent/child tagNames

	Setting the `tagName` property of a `CollectionView` to any of
	"ul", "ol", "table", "thead", "tbody", "tfoot", "tr", or "select" will result
	in the item views receiving an appropriately matched `tagName` property.

	Given an empty `<body>` and the following code:

	```javascript
	anUnorderedListView = Ember.CollectionView.create({
		tagName: 'ul',
		content: ['A','B','C'],
		itemViewClass: Ember.View.extend({
			template: Ember.Handlebars.compile("the letter: {{view.content}}")
		})
	});

	anUnorderedListView.appendTo('body');
	```

	Will result in the following HTML structure

	```html
	<ul class="ember-view a-collection">
		<li class="ember-view">the letter: A</li>
		<li class="ember-view">the letter: B</li>
		<li class="ember-view">the letter: C</li>
	</ul>
	```

	Additional `tagName` pairs can be provided by adding to
	`Ember.CollectionView.CONTAINER_MAP `

	```javascript
	Ember.CollectionView.CONTAINER_MAP['article'] = 'section'
	```

	## Programmatic creation of child views

	For cases where additional customization beyond the use of a single
	`itemViewClass` or `tagName` matching is required CollectionView's
	`createChildView` method can be overidden:

	```javascript
	CustomCollectionView = Ember.CollectionView.extend({
		createChildView: function(viewClass, attrs) {
			if (attrs.content.kind == 'album') {
				viewClass = App.AlbumView;
			} else {
				viewClass = App.SongView;
			}
			return this._super(viewClass, attrs);
		}
	});
	```

	## Empty View

	You can provide an `Ember.View` subclass to the `Ember.CollectionView`
	instance as its `emptyView` property. If the `content` property of a
	`CollectionView` is set to `null` or an empty array, an instance of this view
	will be the `CollectionView`s only child.

	```javascript
	aListWithNothing = Ember.CollectionView.create({
		classNames: ['nothing']
		content: null,
		emptyView: Ember.View.extend({
			template: Ember.Handlebars.compile("The collection is empty")
		})
	});

	aListWithNothing.appendTo('body');
	```

	Will result in the following HTML structure

	```html
	<div class="ember-view nothing">
		<div class="ember-view">
			The collection is empty
		</div>
	</div>
	```

	## Adding and Removing items

	The `childViews` property of a `CollectionView` should not be directly
	manipulated. Instead, add, remove, replace items from its `content` property.
	This will trigger appropriate changes to its rendered HTML.


	@class CollectionView
	@namespace Ember
	@extends Ember.ContainerView
	@since Ember 0.9
*/
Ember.CollectionView = Ember.ContainerView.extend({

	/**
		A list of items to be displayed by the `Ember.CollectionView`.

		@property content
		@type Ember.Array
		@default null
	*/
	content: null,

	/**
		This provides metadata about what kind of empty view class this
		collection would like if it is being instantiated from another
		system (like Handlebars)

		@private
		@property emptyViewClass
	*/
	emptyViewClass: Ember.View,

	/**
		An optional view to display if content is set to an empty array.

		@property emptyView
		@type Ember.View
		@default null
	*/
	emptyView: null,

	/**
		@property itemViewClass
		@type Ember.View
		@default Ember.View
	*/
	itemViewClass: Ember.View,

	/**
		Setup a CollectionView

		@method init
	*/
	init: function() {
		var ret = this._super();
		this._contentDidChange();
		return ret;
	},

	/**
		Invoked when the content property is about to change. Notifies observers that the
		entire array content will change.

		@private
		@method _contentWillChange
	*/
	_contentWillChange: Ember.beforeObserver('content', function() {
		var content = this.get('content');

		if (content) { content.removeArrayObserver(this); }
		var len = content ? get(content, 'length') : 0;
		this.arrayWillChange(content, 0, len);
	}),

	/**
		Check to make sure that the content has changed, and if so,
		update the children directly. This is always scheduled
		asynchronously, to allow the element to be created before
		bindings have synchronized and vice versa.

		@private
		@method _contentDidChange
	*/
	_contentDidChange: Ember.observer('content', function() {
		var content = get(this, 'content');

		if (content) {
			this._assertArrayLike(content);
			content.addArrayObserver(this);
		}

		var len = content ? get(content, 'length') : 0;
		this.arrayDidChange(content, 0, null, len);
	}),

	/**
		Ensure that the content implements Ember.Array

		@private
		@method _assertArrayLike
	*/
	_assertArrayLike: function(content) {
			},

	/**
		Removes the content and content observers.

		@method destroy
	*/
	destroy: function() {
		if (!this._super()) { return; }

		var content = get(this, 'content');
		if (content) { content.removeArrayObserver(this); }

		if (this._createdEmptyView) {
			this._createdEmptyView.destroy();
		}

		return this;
	},

	/**
		Called when a mutation to the underlying content array will occur.

		This method will remove any views that are no longer in the underlying
		content array.

		Invokes whenever the content array itself will change.

		@method arrayWillChange
		@param {Array} content the managed collection of objects
		@param {Number} start the index at which the changes will occurr
		@param {Number} removed number of object to be removed from content
	*/
	arrayWillChange: function(content, start, removedCount) {
		// If the contents were empty before and this template collection has an
		// empty view remove it now.
		var emptyView = get(this, 'emptyView');
		if (emptyView && emptyView instanceof Ember.View) {
			emptyView.removeFromParent();
		}

		// Loop through child views that correspond with the removed items.
		// Note that we loop from the end of the array to the beginning because
		// we are mutating it as we go.
		var childViews = this._childViews, childView, idx, len;

		len = this._childViews.length;

		var removingAll = removedCount === len;

		if (removingAll) {
			this.currentState.empty(this);
			this.invokeRecursively(function(view) {
				view.removedFromDOM = true;
			}, false);
		}

		for (idx = start + removedCount - 1; idx >= start; idx--) {
			childView = childViews[idx];
			childView.destroy();
		}
	},

	/**
		Called when a mutation to the underlying content array occurs.

		This method will replay that mutation against the views that compose the
		`Ember.CollectionView`, ensuring that the view reflects the model.

		This array observer is added in `contentDidChange`.

		@method arrayDidChange
		@param {Array} content the managed collection of objects
		@param {Number} start the index at which the changes occurred
		@param {Number} removed number of object removed from content
		@param {Number} added number of object added to content
	*/
	arrayDidChange: function(content, start, removed, added) {
		var addedViews = [], view, item, idx, len, itemViewClass,
			emptyView;

		len = content ? get(content, 'length') : 0;

		if (len) {
			itemViewClass = get(this, 'itemViewClass');

			if ('string' === typeof itemViewClass) {
				itemViewClass = get(itemViewClass) || itemViewClass;
			}


			for (idx = start; idx < start+added; idx++) {
				item = content.objectAt(idx);

				view = this.createChildView(itemViewClass, {
					content: item,
					contentIndex: idx
				});

				addedViews.push(view);
			}
		} else {
			emptyView = get(this, 'emptyView');

			if (!emptyView) { return; }

			if ('string' === typeof emptyView) {
				emptyView = get(emptyView) || emptyView;
			}

			emptyView = this.createChildView(emptyView);
			addedViews.push(emptyView);
			set(this, 'emptyView', emptyView);

			if (Ember.CoreView.detect(emptyView)) {
				this._createdEmptyView = emptyView;
			}
		}

		this.replace(start, 0, addedViews);
	},

	/**
		Instantiates a view to be added to the childViews array during view
		initialization. You generally will not call this method directly unless
		you are overriding `createChildViews()`. Note that this method will
		automatically configure the correct settings on the new view instance to
		act as a child of the parent.

		The tag name for the view will be set to the tagName of the viewClass
		passed in.

		@method createChildView
		@param {Class} viewClass
		@param {Hash} [attrs] Attributes to add
		@return {Ember.View} new instance
	*/
	createChildView: function(view, attrs) {
		view = this._super(view, attrs);

		var itemTagName = get(view, 'tagName');

		if (itemTagName === null || itemTagName === undefined) {
			itemTagName = Ember.CollectionView.CONTAINER_MAP[get(this, 'tagName')];
			set(view, 'tagName', itemTagName);
		}

		return view;
	}
});

/**
	A map of parent tags to their default child tags. You can add
	additional parent tags if you want collection views that use
	a particular parent tag to default to a child tag.

	@property CONTAINER_MAP
	@type Hash
	@static
	@final
*/
Ember.CollectionView.CONTAINER_MAP = {
	ul: 'li',
	ol: 'li',
	table: 'tr',
	thead: 'tr',
	tbody: 'tr',
	tfoot: 'tr',
	tr: 'td',
	select: 'option'
};

})();



(function() {
/**
	The ComponentTemplateDeprecation mixin is used to provide a useful
	deprecation warning when using either `template` or `templateName` with
	a component. The `template` and `templateName` properties specified at
	extend time are moved to `layout` and `layoutName` respectively.

	`Ember.ComponentTemplateDeprecation` is used internally by Ember in
	`Ember.Component`.

	@class ComponentTemplateDeprecation
	@namespace Ember
*/
Ember.ComponentTemplateDeprecation = Ember.Mixin.create({
	/**
		@private

		Moves `templateName` to `layoutName` and `template` to `layout` at extend
		time if a layout is not also specified.

		Note that this currently modifies the mixin themselves, which is technically
		dubious but is practically of little consequence. This may change in the
		future.

		@method willMergeMixin
	*/
	willMergeMixin: function(props) {
		// must call _super here to ensure that the ActionHandler
		// mixin is setup properly (moves actions -> _actions)
		//
		// Calling super is only OK here since we KNOW that
		// there is another Mixin loaded first.
		this._super.apply(this, arguments);

		var deprecatedProperty, replacementProperty,
				layoutSpecified = (props.layoutName || props.layout);

		if (props.templateName && !layoutSpecified) {
			deprecatedProperty = 'templateName';
			replacementProperty = 'layoutName';

			props.layoutName = props.templateName;
			delete props['templateName'];
		}

		if (props.template && !layoutSpecified) {
			deprecatedProperty = 'template';
			replacementProperty = 'layout';

			props.layout = props.template;
			delete props['template'];
		}

		if (deprecatedProperty) {
					}
	}
});


})();



(function() {
var get = Ember.get, set = Ember.set, isNone = Ember.isNone,
		a_slice = Array.prototype.slice;


/**
@module ember
@submodule ember-views
*/

/**
	An `Ember.Component` is a view that is completely
	isolated. Property access in its templates go
	to the view object and actions are targeted at
	the view object. There is no access to the
	surrounding context or outer controller; all
	contextual information must be passed in.

	The easiest way to create an `Ember.Component` is via
	a template. If you name a template
	`components/my-foo`, you will be able to use
	`{{my-foo}}` in other templates, which will make
	an instance of the isolated component.

	```html
	{{app-profile person=currentUser}}
	```

	```html
	<!-- app-profile template -->
	<h1>{{person.title}}</h1>
	<img {{bind-attr src=person.avatar}}>
	<p class='signature'>{{person.signature}}</p>
	```

	You can use `yield` inside a template to
	include the **contents** of any block attached to
	the component. The block will be executed in the
	context of the surrounding context or outer controller:

	```handlebars
	{{#app-profile person=currentUser}}
		<p>Admin mode</p>
		{{! Executed in the controllers context. }}
	{{/app-profile}}
	```

	```handlebars
	<!-- app-profile template -->
	<h1>{{person.title}}</h1>
	{{! Executed in the components context. }}
	{{yield}} {{! block contents }}
	```

	If you want to customize the component, in order to
	handle events or actions, you implement a subclass
	of `Ember.Component` named after the name of the
	component. Note that `Component` needs to be appended to the name of
	your subclass like `AppProfileComponent`.

	For example, you could implement the action
	`hello` for the `app-profile` component:

	```javascript
	App.AppProfileComponent = Ember.Component.extend({
		actions: {
			hello: function(name) {
				console.log("Hello", name);
			}
		}
	});
	```

	And then use it in the component's template:

	```html
	<!-- app-profile template -->

	<h1>{{person.title}}</h1>
	{{yield}} <!-- block contents -->

	<button {{action 'hello' person.name}}>
		Say Hello to {{person.name}}
	</button>
	```

	Components must have a `-` in their name to avoid
	conflicts with built-in controls that wrap HTML
	elements. This is consistent with the same
	requirement in web components.

	@class Component
	@namespace Ember
	@extends Ember.View
*/
Ember.Component = Ember.View.extend(Ember.TargetActionSupport, Ember.ComponentTemplateDeprecation, {
	init: function() {
		this._super();
		set(this, 'context', this);
		set(this, 'controller', this);
	},

	defaultLayout: function(context, options){
		Ember.Handlebars.helpers['yield'].call(context, options);
	},

	/**
	A components template property is set by passing a block
	during its invocation. It is executed within the parent context.

	Example:

	```handlebars
	{{#my-component}}
		// something that is run in the context
		// of the parent context
	{{/my-component}}
	```

	Specifying a template directly to a component is deprecated without
	also specifying the layout property.

	@deprecated
	@property template
	*/
	template: Ember.computed(function(key, value) {
		if (value !== undefined) { return value; }

		var templateName = get(this, 'templateName'),
				template = this.templateForName(templateName, 'template');


		return template || get(this, 'defaultTemplate');
	}).property('templateName'),

	/**
	Specifying a components `templateName` is deprecated without also
	providing the `layout` or `layoutName` properties.

	@deprecated
	@property templateName
	*/
	templateName: null,

	// during render, isolate keywords
	cloneKeywords: function() {
		return {
			view: this,
			controller: this
		};
	},

	_yield: function(context, options) {
		var view = options.data.view,
				parentView = this._parentView,
				template = get(this, 'template');

		if (template) {

			view.appendChild(Ember.View, {
				isVirtual: true,
				tagName: '',
				_contextView: parentView,
				template: template,
				context: get(parentView, 'context'),
				controller: get(parentView, 'controller'),
				templateData: { keywords: parentView.cloneKeywords() }
			});
		}
	},

	/**
		If the component is currently inserted into the DOM of a parent view, this
		property will point to the controller of the parent view.

		@property targetObject
		@type Ember.Controller
		@default null
	*/
	targetObject: Ember.computed(function(key) {
		var parentView = get(this, '_parentView');
		return parentView ? get(parentView, 'controller') : null;
	}).property('_parentView'),

	/**
		Triggers a named action on the controller context where the component is used if
		this controller has registered for notifications of the action.

		For example a component for playing or pausing music may translate click events
		into action notifications of "play" or "stop" depending on some internal state
		of the component:


		```javascript
		App.PlayButtonComponent = Ember.Component.extend({
			click: function(){
				if (this.get('isPlaying')) {
					this.triggerAction('play');
				} else {
					this.triggerAction('stop');
				}
			}
		});
		```

		When used inside a template these component actions are configured to
		trigger actions in the outer application context:

		```handlebars
		{{! application.hbs }}
		{{play-button play="musicStarted" stop="musicStopped"}}
		```

		When the component receives a browser `click` event it translate this
		interaction into application-specific semantics ("play" or "stop") and
		triggers the specified action name on the controller for the template
		where the component is used:


		```javascript
		App.ApplicationController = Ember.Controller.extend({
			actions: {
				musicStarted: function(){
					// called when the play button is clicked
					// and the music started playing
				},
				musicStopped: function(){
					// called when the play button is clicked
					// and the music stopped playing
				}
			}
		});
		```

		If no action name is passed to `sendAction` a default name of "action"
		is assumed.

		```javascript
		App.NextButtonComponent = Ember.Component.extend({
			click: function(){
				this.sendAction();
			}
		});
		```

		```handlebars
		{{! application.hbs }}
		{{next-button action="playNextSongInAlbum"}}
		```

		```javascript
		App.ApplicationController = Ember.Controller.extend({
			actions: {
				playNextSongInAlbum: function(){
					...
				}
			}
		});
		```

		@method sendAction
		@param [action] {String} the action to trigger
		@param [context] {*} a context to send with the action
	*/
	sendAction: function(action) {
		var actionName,
				contexts = a_slice.call(arguments, 1);

		// Send the default action
		if (action === undefined) {
			actionName = get(this, 'action');
					} else {
			actionName = get(this, action);
					}

		// If no action name for that action could be found, just abort.
		if (actionName === undefined) { return; }

		this.triggerAction({
			action: actionName,
			actionContext: contexts
		});
	}
});

})();



(function() {

})();



(function() {
/**
`Ember.ViewTargetActionSupport` is a mixin that can be included in a
view class to add a `triggerAction` method with semantics similar to
the Handlebars `{{action}}` helper. It provides intelligent defaults
for the action's target: the view's controller; and the context that is
sent with the action: the view's context.

Note: In normal Ember usage, the `{{action}}` helper is usually the best
choice. This mixin is most often useful when you are doing more complex
event handling in custom View subclasses.

For example:

```javascript
App.SaveButtonView = Ember.View.extend(Ember.ViewTargetActionSupport, {
	action: 'save',
	click: function() {
		this.triggerAction(); // Sends the `save` action, along with the current context
													// to the current controller
	}
});
```

The `action` can be provided as properties of an optional object argument
to `triggerAction` as well.

```javascript
App.SaveButtonView = Ember.View.extend(Ember.ViewTargetActionSupport, {
	click: function() {
		this.triggerAction({
			action: 'save'
		}); // Sends the `save` action, along with the current context
				// to the current controller
	}
});
```

@class ViewTargetActionSupport
@namespace Ember
@extends Ember.TargetActionSupport
*/
Ember.ViewTargetActionSupport = Ember.Mixin.create(Ember.TargetActionSupport, {
	/**
	@property target
	*/
	target: Ember.computed.alias('controller'),
	/**
	@property actionContext
	*/
	actionContext: Ember.computed.alias('context')
});

})();



(function() {

})();



(function() {
/**
Ember Views

@module ember
@submodule ember-views
@requires ember-runtime
@main ember-views
*/

})();

(function() {
/* jshint ignore:start */
define(
	'handlebars/safe-string',["exports"],
	function(__exports__) {

		// Build out our basic SafeString type
		function SafeString(string) {
			this.string = string;
		}

		SafeString.prototype.toString = function() {
			return "" + this.string;
		};

		__exports__['default'] = SafeString;
	});
define(
	'handlebars/utils',["./safe-string","exports"],
	function(__dependency1__, __exports__) {

		var SafeString = __dependency1__['default'];

		var isArray = Array.isArray;

		var escape = {
			"&": "&amp;",
			"<": "&lt;",
			">": "&gt;",
			'"': "&quot;",
			"'": "&#x27;",
			"`": "&#x60;"
		};

		var badChars = /[&<>"'`]/g;
		var possible = /[&<>"'`]/;

		function escapeChar(chr) {
			return escape[chr] || "&amp;";
		}

		function extend(obj, value) {
			for(var key in value) {
				if(value.hasOwnProperty(key)) {
					obj[key] = value[key];
				}
			}
		}

		__exports__.extend = extend;function escapeExpression(string) {
			// don't escape SafeStrings, since they're already safe
			if (string instanceof SafeString) {
				return string.toString();
			} else if (!string && string !== 0) {
				return "";
			}

			// Force a string conversion as this will be done by the append regardless and
			// the regex test will do this transparently behind the scenes, causing issues if
			// an object's to string has escaped characters in it.
			string = "" + string;

			if(!possible.test(string)) { return string; }
			return string.replace(badChars, escapeChar);
		}

		__exports__.escapeExpression = escapeExpression;function isEmpty(value) {
			if (!value && value !== 0) {
				return true;
			} else if (isArray(value) && value.length === 0) {
				return true;
			} else {
				return false;
			}
		}

		__exports__.isEmpty = isEmpty;
	});
define(
	'handlebars/exception',["exports"],
	function(__exports__) {


		var errorProps = ['description', 'fileName', 'lineNumber', 'message', 'name', 'number', 'stack'];

		function Exception(/* message */) {
			var tmp = Error.prototype.constructor.apply(this, arguments);

			// Unfortunately errors are not enumerable in Chrome (at least), so `for prop in tmp` doesn't work.
			for (var idx = 0; idx < errorProps.length; idx++) {
				this[errorProps[idx]] = tmp[errorProps[idx]];
			}
		}

		Exception.prototype = new Error();

		__exports__['default'] = Exception;
	});
define(
	'handlebars/base',["./utils","./exception","exports"],
	function(__dependency1__, __dependency2__, __exports__) {

		/*jshint eqnull: true */

		var extend = __dependency1__.extend;
		var isEmpty = __dependency1__.isEmpty;
		var Exception = __dependency2__['default'];

		var VERSION = "1.0.0";
		__exports__.VERSION = VERSION;var COMPILER_REVISION = 4;
		__exports__.COMPILER_REVISION = COMPILER_REVISION;
		var REVISION_CHANGES = {
			1: '<= 1.0.rc.2', // 1.0.rc.2 is actually rev2 but doesn't report it
			2: '== 1.0.0-rc.3',
			3: '== 1.0.0-rc.4',
			4: '>= 1.0.0'
		};
		__exports__.REVISION_CHANGES = REVISION_CHANGES;
		var toString = Object.prototype.toString,
				objectType = '[object Object]';

		// Sourced from lodash
		// https://github.com/bestiejs/lodash/blob/master/LICENSE.txt
		var isFunction = function(value) {
			return typeof value === 'function';
		};
		// fallback for older versions of Chrome and Safari
		if (isFunction(/x/)) {
			isFunction = function(value) {
				return typeof value === 'function' && toString.call(value) === '[object Function]';
			};
		}

		function isArray(value) {
			return (value && typeof value === 'object') ? toString.call(value) === '[object Array]' : false;
		}

		function HandlebarsEnvironment(helpers, partials) {
			this.helpers = helpers || {};
			this.partials = partials || {};

			registerDefaultHelpers(this);
		}

		__exports__.HandlebarsEnvironment = HandlebarsEnvironment;HandlebarsEnvironment.prototype = {
			constructor: HandlebarsEnvironment,

			logger: logger,
			log: log,

			registerHelper: function(name, fn, inverse) {
				if (toString.call(name) === objectType) {
					if (inverse || fn) { throw new Exception('Arg not supported with multiple helpers'); }
					extend(this.helpers, name);
				} else {
					if (inverse) { fn.not = inverse; }
					this.helpers[name] = fn;
				}
			},

			registerPartial: function(name, str) {
				if (toString.call(name) === objectType) {
					extend(this.partials,  name);
				} else {
					this.partials[name] = str;
				}
			}
		};

		function registerDefaultHelpers(instance) {
			instance.registerHelper('helperMissing', function(arg) {
				if(arguments.length === 2) {
					return undefined;
				} else {
					throw new Error("Missing helper: '" + arg + "'");
				}
			});

			instance.registerHelper('blockHelperMissing', function(context, options) {
				var inverse = options.inverse || function() {}, fn = options.fn;

				if (isFunction(context)) { context = context.call(this); }

				if(context === true) {
					return fn(this);
				} else if(context === false || context == null) {
					return inverse(this);
				} else if (isArray(context)) {
					if(context.length > 0) {
						return instance.helpers.each(context, options);
					} else {
						return inverse(this);
					}
				} else {
					return fn(context);
				}
			});

			instance.registerHelper('each', function(context, options) {
				var fn = options.fn, inverse = options.inverse;
				var i = 0, ret = "", data;

				if (isFunction(context)) { context = context.call(this); }

				if (options.data) {
					data = createFrame(options.data);
				}

				if(context && typeof context === 'object') {
					if (isArray(context)) {
						for(var j = context.length; i<j; i++) {
							if (data) { data.index = i; }
							ret = ret + fn(context[i], { data: data });
						}
					} else {
						for(var key in context) {
							if(context.hasOwnProperty(key)) {
								if(data) { data.key = key; }
								ret = ret + fn(context[key], {data: data});
								i++;
							}
						}
					}
				}

				if(i === 0){
					ret = inverse(this);
				}

				return ret;
			});

			instance.registerHelper('if', function(conditional, options) {
				if (isFunction(conditional)) { conditional = conditional.call(this); }

				if (isEmpty(conditional)) {
					return options.inverse(this);
				} else {
					return options.fn(this);
				}
			});

			instance.registerHelper('unless', function(conditional, options) {
				return instance.helpers['if'].call(this, conditional, {fn: options.inverse, inverse: options.fn});
			});

			instance.registerHelper('with', function(context, options) {
				if (isFunction(context)) { context = context.call(this); }

				if (!isEmpty(context)) return options.fn(context);
			});

			instance.registerHelper('log', function(context, options) {
				var level = options.data && options.data.level != null ? parseInt(options.data.level, 10) : 1;
				instance.log(level, context);
			});
		}

		var levels = {
			DEBUG: 0, INFO: 1, WARN: 2, ERROR: 3, level: 3
		};

		var methodMap = { 0: 'debug', 1: 'info', 2: 'warn', 3: 'error' };

		var logger = {
			// can be overridden in the host environment
			log: function(level, obj) {
				if (logger.level <= level) {
					var method = logger.methodMap[level];
					if (typeof console !== 'undefined' && console[method]) {
						console[method].call(console, obj);
					}
				}
			}
		};
		__exports__.logger = logger;
		function log(level, obj) { logger.log(level, obj); }

		__exports__.log = log;var createFrame = function(object) {
			var obj = {};
			extend(obj, object);
			return obj;
		};
		__exports__.createFrame = createFrame;
	});
define(
	'handlebars/runtime',["./exception","./utils","./base","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __exports__) {

		var Exception = __dependency1__['default'];
		var escapeExpression = __dependency2__.escapeExpression;
		var extend = __dependency2__.extend;
		var COMPILER_REVISION = __dependency3__.COMPILER_REVISION;
		var REVISION_CHANGES = __dependency3__.REVISION_CHANGES;

		function checkRevision(compilerInfo) {
			var compilerRevision = compilerInfo && compilerInfo[0] || 1,
					currentRevision = COMPILER_REVISION;

			if (compilerRevision !== currentRevision) {
				if (compilerRevision < currentRevision) {
					var runtimeVersions = REVISION_CHANGES[currentRevision],
							compilerVersions = REVISION_CHANGES[compilerRevision];
					throw new Error("Template was precompiled with an older version of Handlebars than the current runtime. "+
								"Please update your precompiler to a newer version ("+runtimeVersions+") or downgrade your runtime to an older version ("+compilerVersions+").");
				} else {
					// Use the embedded version info since the runtime doesn't know about this revision yet
					throw new Error("Template was precompiled with a newer version of Handlebars than the current runtime. "+
								"Please update your runtime to a newer version ("+compilerInfo[1]+").");
				}
			}
		}

		// TODO: Remove this line and break up compilePartial

		function template(templateSpec, env) {
			if (!env) {
				throw new Error("No environment passed to template");
			}

			var invokePartialWrapper;
			if (env.compile) {
				invokePartialWrapper = function(partial, name, context, helpers, partials, data) {
					// TODO : Check this for all inputs and the options handling (partial flag, etc). This feels
					// like there should be a common exec path
					var result = invokePartial.apply(this, arguments);
					if (result) { return result; }

					var options = { helpers: helpers, partials: partials, data: data };
					partials[name] = env.compile(partial, { data: data !== undefined }, env);
					return partials[name](context, options);
				};
			} else {
				invokePartialWrapper = function(partial, name /* , context, helpers, partials, data */) {
					var result = invokePartial.apply(this, arguments);
					if (result) { return result; }
					throw new Exception("The partial " + name + " could not be compiled when running in runtime-only mode");
				};
			}

			// Just add water
			var container = {
				escapeExpression: escapeExpression,
				invokePartial: invokePartialWrapper,
				programs: [],
				program: function(i, fn, data) {
					var programWrapper = this.programs[i];
					if(data) {
						programWrapper = program(i, fn, data);
					} else if (!programWrapper) {
						programWrapper = this.programs[i] = program(i, fn);
					}
					return programWrapper;
				},
				merge: function(param, common) {
					var ret = param || common;

					if (param && common && (param !== common)) {
						ret = {};
						extend(ret, common);
						extend(ret, param);
					}
					return ret;
				},
				programWithDepth: programWithDepth,
				noop: noop,
				compilerInfo: null
			};

			return function(context, options) {
				options = options || {};
				var namespace = options.partial ? options : env,
						helpers,
						partials;

				if (!options.partial) {
					helpers = options.helpers;
					partials = options.partials;
				}
				var result = templateSpec.call(
							container,
							namespace, context,
							helpers,
							partials,
							options.data);

				if (!options.partial) {
					checkRevision(container.compilerInfo);
				}

				return result;
			};
		}

		__exports__.template = template;function programWithDepth(i, fn, data /*, $depth */) {
			var args = Array.prototype.slice.call(arguments, 3);

			var prog = function(context, options) {
				options = options || {};

				return fn.apply(this, [context, options.data || data].concat(args));
			};
			prog.program = i;
			prog.depth = args.length;
			return prog;
		}

		__exports__.programWithDepth = programWithDepth;function program(i, fn, data) {
			var prog = function(context, options) {
				options = options || {};

				return fn(context, options.data || data);
			};
			prog.program = i;
			prog.depth = 0;
			return prog;
		}

		__exports__.program = program;function invokePartial(partial, name, context, helpers, partials, data) {
			var options = { partial: true, helpers: helpers, partials: partials, data: data };

			if(partial === undefined) {
				throw new Exception("The partial " + name + " could not be found");
			} else if(partial instanceof Function) {
				return partial(context, options);
			}
		}

		__exports__.invokePartial = invokePartial;function noop() { return ""; }

		__exports__.noop = noop;
	});
define(
	'handlebars.runtime',["./handlebars/base","./handlebars/safe-string","./handlebars/exception","./handlebars/utils","./handlebars/runtime","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __dependency4__, __dependency5__, __exports__) {

		var base = __dependency1__;

		// Each of these augment the Handlebars object. No need to setup here.
		// (This is done to easily share code between commonjs and browse envs)
		var SafeString = __dependency2__['default'];
		var Exception = __dependency3__['default'];
		var Utils = __dependency4__;
		var runtime = __dependency5__;

		// For compatibility and usage outside of module systems, make the Handlebars object a namespace
		var create = function() {
			var hb = new base.HandlebarsEnvironment();

			Utils.extend(hb, base);
			hb.SafeString = SafeString;
			hb.Exception = Exception;
			hb.Utils = Utils;

			hb.VM = runtime;
			hb.template = function(spec) {
				return runtime.template(spec, hb);
			};

			return hb;
		};

		var Handlebars = create();
		Handlebars.create = create;

		__exports__['default'] = Handlebars;
	});
define(
	'handlebars/compiler/ast',["../exception","exports"],
	function(__dependency1__, __exports__) {

		var Exception = __dependency1__['default'];

		function ProgramNode(statements, inverse) {
			this.type = "program";
			this.statements = statements;
			if(inverse) { this.inverse = new ProgramNode(inverse); }
		}

		__exports__.ProgramNode = ProgramNode;function MustacheNode(rawParams, hash, unescaped) {
			this.type = "mustache";
			this.escaped = !unescaped;
			this.hash = hash;

			var id = this.id = rawParams[0];
			var params = this.params = rawParams.slice(1);

			// a mustache is an eligible helper if:
			// * its id is simple (a single part, not `this` or `..`)
			var eligibleHelper = this.eligibleHelper = id.isSimple;

			// a mustache is definitely a helper if:
			// * it is an eligible helper, and
			// * it has at least one parameter or hash segment
			this.isHelper = eligibleHelper && (params.length || hash);

			// if a mustache is an eligible helper but not a definite
			// helper, it is ambiguous, and will be resolved in a later
			// pass or at runtime.
		}

		__exports__.MustacheNode = MustacheNode;function PartialNode(partialName, context) {
			this.type         = "partial";
			this.partialName  = partialName;
			this.context      = context;
		}

		__exports__.PartialNode = PartialNode;function BlockNode(mustache, program, inverse, close) {
			if(mustache.id.original !== close.original) {
				throw new Exception(mustache.id.original + " doesn't match " + close.original);
			}

			this.type = "block";
			this.mustache = mustache;
			this.program  = program;
			this.inverse  = inverse;

			if (this.inverse && !this.program) {
				this.isInverse = true;
			}
		}

		__exports__.BlockNode = BlockNode;function ContentNode(string) {
			this.type = "content";
			this.string = string;
		}

		__exports__.ContentNode = ContentNode;function HashNode(pairs) {
			this.type = "hash";
			this.pairs = pairs;
		}

		__exports__.HashNode = HashNode;function IdNode(parts) {
			this.type = "ID";

			var original = "",
					dig = [],
					depth = 0;

			for(var i=0,l=parts.length; i<l; i++) {
				var part = parts[i].part;
				original += (parts[i].separator || '') + part;

				if (part === ".." || part === "." || part === "this") {
					if (dig.length > 0) { throw new Exception("Invalid path: " + original); }
					else if (part === "..") { depth++; }
					else { this.isScoped = true; }
				}
				else { dig.push(part); }
			}

			this.original = original;
			this.parts    = dig;
			this.string   = dig.join('.');
			this.depth    = depth;

			// an ID is simple if it only has one part, and that part is not
			// `..` or `this`.
			this.isSimple = parts.length === 1 && !this.isScoped && depth === 0;

			this.stringModeValue = this.string;
		}

		__exports__.IdNode = IdNode;function PartialNameNode(name) {
			this.type = "PARTIAL_NAME";
			this.name = name.original;
		}

		__exports__.PartialNameNode = PartialNameNode;function DataNode(id) {
			this.type = "DATA";
			this.id = id;
		}

		__exports__.DataNode = DataNode;function StringNode(string) {
			this.type = "STRING";
			this.original =
				this.string =
				this.stringModeValue = string;
		}

		__exports__.StringNode = StringNode;function IntegerNode(integer) {
			this.type = "INTEGER";
			this.original =
				this.integer = integer;
			this.stringModeValue = Number(integer);
		}

		__exports__.IntegerNode = IntegerNode;function BooleanNode(bool) {
			this.type = "BOOLEAN";
			this.bool = bool;
			this.stringModeValue = bool === "true";
		}

		__exports__.BooleanNode = BooleanNode;function CommentNode(comment) {
			this.type = "comment";
			this.comment = comment;
		}

		__exports__.CommentNode = CommentNode;
	});
define(
	'handlebars/compiler/parser',["exports"],
	function(__exports__) {

		/* Jison generated parser */
		var handlebars = (function(){
		var parser = {trace: function trace() { },
		yy: {},
		symbols_: {"error":2,"root":3,"statements":4,"EOF":5,"program":6,"simpleInverse":7,"statement":8,"openInverse":9,"closeBlock":10,"openBlock":11,"mustache":12,"partial":13,"CONTENT":14,"COMMENT":15,"OPEN_BLOCK":16,"inMustache":17,"CLOSE":18,"OPEN_INVERSE":19,"OPEN_ENDBLOCK":20,"path":21,"OPEN":22,"OPEN_UNESCAPED":23,"CLOSE_UNESCAPED":24,"OPEN_PARTIAL":25,"partialName":26,"partial_option0":27,"inMustache_repetition0":28,"inMustache_option0":29,"dataName":30,"param":31,"STRING":32,"INTEGER":33,"BOOLEAN":34,"hash":35,"hash_repetition_plus0":36,"hashSegment":37,"ID":38,"EQUALS":39,"DATA":40,"pathSegments":41,"SEP":42,"$accept":0,"$end":1},
		terminals_: {2:"error",5:"EOF",14:"CONTENT",15:"COMMENT",16:"OPEN_BLOCK",18:"CLOSE",19:"OPEN_INVERSE",20:"OPEN_ENDBLOCK",22:"OPEN",23:"OPEN_UNESCAPED",24:"CLOSE_UNESCAPED",25:"OPEN_PARTIAL",32:"STRING",33:"INTEGER",34:"BOOLEAN",38:"ID",39:"EQUALS",40:"DATA",42:"SEP"},
		productions_: [0,[3,2],[6,2],[6,3],[6,2],[6,1],[6,1],[6,0],[4,1],[4,2],[8,3],[8,3],[8,1],[8,1],[8,1],[8,1],[11,3],[9,3],[10,3],[12,3],[12,3],[13,4],[7,2],[17,3],[17,1],[31,1],[31,1],[31,1],[31,1],[31,1],[35,1],[37,3],[26,1],[26,1],[26,1],[30,2],[21,1],[41,3],[41,1],[27,0],[27,1],[28,0],[28,2],[29,0],[29,1],[36,1],[36,2]],
		performAction: function anonymous(yytext,yyleng,yylineno,yy,yystate,$$,_$) {

		var $0 = $$.length - 1;
		switch (yystate) {
		case 1: return new yy.ProgramNode($$[$0-1]);
		break;
		case 2:this.$ = new yy.ProgramNode([], $$[$0]);
		break;
		case 3:this.$ = new yy.ProgramNode($$[$0-2], $$[$0]);
		break;
		case 4:this.$ = new yy.ProgramNode($$[$0-1], []);
		break;
		case 5:this.$ = new yy.ProgramNode($$[$0]);
		break;
		case 6:this.$ = new yy.ProgramNode([]);
		break;
		case 7:this.$ = new yy.ProgramNode([]);
		break;
		case 8:this.$ = [$$[$0]];
		break;
		case 9: $$[$0-1].push($$[$0]); this.$ = $$[$0-1];
		break;
		case 10:this.$ = new yy.BlockNode($$[$0-2], $$[$0-1].inverse, $$[$0-1], $$[$0]);
		break;
		case 11:this.$ = new yy.BlockNode($$[$0-2], $$[$0-1], $$[$0-1].inverse, $$[$0]);
		break;
		case 12:this.$ = $$[$0];
		break;
		case 13:this.$ = $$[$0];
		break;
		case 14:this.$ = new yy.ContentNode($$[$0]);
		break;
		case 15:this.$ = new yy.CommentNode($$[$0]);
		break;
		case 16:this.$ = new yy.MustacheNode($$[$0-1][0], $$[$0-1][1]);
		break;
		case 17:this.$ = new yy.MustacheNode($$[$0-1][0], $$[$0-1][1]);
		break;
		case 18:this.$ = $$[$0-1];
		break;
		case 19:
				// Parsing out the '&' escape token at this level saves ~500 bytes after min due to the removal of one parser node.
				this.$ = new yy.MustacheNode($$[$0-1][0], $$[$0-1][1], $$[$0-2][2] === '&');

		break;
		case 20:this.$ = new yy.MustacheNode($$[$0-1][0], $$[$0-1][1], true);
		break;
		case 21:this.$ = new yy.PartialNode($$[$0-2], $$[$0-1]);
		break;
		case 22:
		break;
		case 23:this.$ = [[$$[$0-2]].concat($$[$0-1]), $$[$0]];
		break;
		case 24:this.$ = [[$$[$0]], null];
		break;
		case 25:this.$ = $$[$0];
		break;
		case 26:this.$ = new yy.StringNode($$[$0]);
		break;
		case 27:this.$ = new yy.IntegerNode($$[$0]);
		break;
		case 28:this.$ = new yy.BooleanNode($$[$0]);
		break;
		case 29:this.$ = $$[$0];
		break;
		case 30:this.$ = new yy.HashNode($$[$0]);
		break;
		case 31:this.$ = [$$[$0-2], $$[$0]];
		break;
		case 32:this.$ = new yy.PartialNameNode($$[$0]);
		break;
		case 33:this.$ = new yy.PartialNameNode(new yy.StringNode($$[$0]));
		break;
		case 34:this.$ = new yy.PartialNameNode(new yy.IntegerNode($$[$0]));
		break;
		case 35:this.$ = new yy.DataNode($$[$0]);
		break;
		case 36:this.$ = new yy.IdNode($$[$0]);
		break;
		case 37: $$[$0-2].push({part: $$[$0], separator: $$[$0-1]}); this.$ = $$[$0-2];
		break;
		case 38:this.$ = [{part: $$[$0]}];
		break;
		case 41:this.$ = [];
		break;
		case 42:$$[$0-1].push($$[$0]);
		break;
		case 45:this.$ = [$$[$0]];
		break;
		case 46:$$[$0-1].push($$[$0]);
		break;
		}
		},
		table: [{3:1,4:2,8:3,9:4,11:5,12:6,13:7,14:[1,8],15:[1,9],16:[1,11],19:[1,10],22:[1,12],23:[1,13],25:[1,14]},{1:[3]},{5:[1,15],8:16,9:4,11:5,12:6,13:7,14:[1,8],15:[1,9],16:[1,11],19:[1,10],22:[1,12],23:[1,13],25:[1,14]},{5:[2,8],14:[2,8],15:[2,8],16:[2,8],19:[2,8],20:[2,8],22:[2,8],23:[2,8],25:[2,8]},{4:19,6:17,7:18,8:3,9:4,11:5,12:6,13:7,14:[1,8],15:[1,9],16:[1,11],19:[1,20],20:[2,7],22:[1,12],23:[1,13],25:[1,14]},{4:19,6:21,7:18,8:3,9:4,11:5,12:6,13:7,14:[1,8],15:[1,9],16:[1,11],19:[1,20],20:[2,7],22:[1,12],23:[1,13],25:[1,14]},{5:[2,12],14:[2,12],15:[2,12],16:[2,12],19:[2,12],20:[2,12],22:[2,12],23:[2,12],25:[2,12]},{5:[2,13],14:[2,13],15:[2,13],16:[2,13],19:[2,13],20:[2,13],22:[2,13],23:[2,13],25:[2,13]},{5:[2,14],14:[2,14],15:[2,14],16:[2,14],19:[2,14],20:[2,14],22:[2,14],23:[2,14],25:[2,14]},{5:[2,15],14:[2,15],15:[2,15],16:[2,15],19:[2,15],20:[2,15],22:[2,15],23:[2,15],25:[2,15]},{17:22,21:23,30:24,38:[1,27],40:[1,26],41:25},{17:28,21:23,30:24,38:[1,27],40:[1,26],41:25},{17:29,21:23,30:24,38:[1,27],40:[1,26],41:25},{17:30,21:23,30:24,38:[1,27],40:[1,26],41:25},{21:32,26:31,32:[1,33],33:[1,34],38:[1,27],41:25},{1:[2,1]},{5:[2,9],14:[2,9],15:[2,9],16:[2,9],19:[2,9],20:[2,9],22:[2,9],23:[2,9],25:[2,9]},{10:35,20:[1,36]},{4:37,8:3,9:4,11:5,12:6,13:7,14:[1,8],15:[1,9],16:[1,11],19:[1,10],20:[2,6],22:[1,12],23:[1,13],25:[1,14]},{7:38,8:16,9:4,11:5,12:6,13:7,14:[1,8],15:[1,9],16:[1,11],19:[1,20],20:[2,5],22:[1,12],23:[1,13],25:[1,14]},{17:22,18:[1,39],21:23,30:24,38:[1,27],40:[1,26],41:25},{10:40,20:[1,36]},{18:[1,41]},{18:[2,41],24:[2,41],28:42,32:[2,41],33:[2,41],34:[2,41],38:[2,41],40:[2,41]},{18:[2,24],24:[2,24]},{18:[2,36],24:[2,36],32:[2,36],33:[2,36],34:[2,36],38:[2,36],40:[2,36],42:[1,43]},{21:44,38:[1,27],41:25},{18:[2,38],24:[2,38],32:[2,38],33:[2,38],34:[2,38],38:[2,38],40:[2,38],42:[2,38]},{18:[1,45]},{18:[1,46]},{24:[1,47]},{18:[2,39],21:49,27:48,38:[1,27],41:25},{18:[2,32],38:[2,32]},{18:[2,33],38:[2,33]},{18:[2,34],38:[2,34]},{5:[2,10],14:[2,10],15:[2,10],16:[2,10],19:[2,10],20:[2,10],22:[2,10],23:[2,10],25:[2,10]},{21:50,38:[1,27],41:25},{8:16,9:4,11:5,12:6,13:7,14:[1,8],15:[1,9],16:[1,11],19:[1,10],20:[2,2],22:[1,12],23:[1,13],25:[1,14]},{4:51,8:3,9:4,11:5,12:6,13:7,14:[1,8],15:[1,9],16:[1,11],19:[1,10],20:[2,4],22:[1,12],23:[1,13],25:[1,14]},{14:[2,22],15:[2,22],16:[2,22],19:[2,22],20:[2,22],22:[2,22],23:[2,22],25:[2,22]},{5:[2,11],14:[2,11],15:[2,11],16:[2,11],19:[2,11],20:[2,11],22:[2,11],23:[2,11],25:[2,11]},{14:[2,17],15:[2,17],16:[2,17],19:[2,17],20:[2,17],22:[2,17],23:[2,17],25:[2,17]},{18:[2,43],21:55,24:[2,43],29:52,30:59,31:53,32:[1,56],33:[1,57],34:[1,58],35:54,36:60,37:61,38:[1,62],40:[1,26],41:25},{38:[1,63]},{18:[2,35],24:[2,35],32:[2,35],33:[2,35],34:[2,35],38:[2,35],40:[2,35]},{14:[2,16],15:[2,16],16:[2,16],19:[2,16],20:[2,16],22:[2,16],23:[2,16],25:[2,16]},{5:[2,19],14:[2,19],15:[2,19],16:[2,19],19:[2,19],20:[2,19],22:[2,19],23:[2,19],25:[2,19]},{5:[2,20],14:[2,20],15:[2,20],16:[2,20],19:[2,20],20:[2,20],22:[2,20],23:[2,20],25:[2,20]},{18:[1,64]},{18:[2,40]},{18:[1,65]},{8:16,9:4,11:5,12:6,13:7,14:[1,8],15:[1,9],16:[1,11],19:[1,10],20:[2,3],22:[1,12],23:[1,13],25:[1,14]},{18:[2,23],24:[2,23]},{18:[2,42],24:[2,42],32:[2,42],33:[2,42],34:[2,42],38:[2,42],40:[2,42]},{18:[2,44],24:[2,44]},{18:[2,25],24:[2,25],32:[2,25],33:[2,25],34:[2,25],38:[2,25],40:[2,25]},{18:[2,26],24:[2,26],32:[2,26],33:[2,26],34:[2,26],38:[2,26],40:[2,26]},{18:[2,27],24:[2,27],32:[2,27],33:[2,27],34:[2,27],38:[2,27],40:[2,27]},{18:[2,28],24:[2,28],32:[2,28],33:[2,28],34:[2,28],38:[2,28],40:[2,28]},{18:[2,29],24:[2,29],32:[2,29],33:[2,29],34:[2,29],38:[2,29],40:[2,29]},{18:[2,30],24:[2,30],37:66,38:[1,67]},{18:[2,45],24:[2,45],38:[2,45]},{18:[2,38],24:[2,38],32:[2,38],33:[2,38],34:[2,38],38:[2,38],39:[1,68],40:[2,38],42:[2,38]},{18:[2,37],24:[2,37],32:[2,37],33:[2,37],34:[2,37],38:[2,37],40:[2,37],42:[2,37]},{5:[2,21],14:[2,21],15:[2,21],16:[2,21],19:[2,21],20:[2,21],22:[2,21],23:[2,21],25:[2,21]},{5:[2,18],14:[2,18],15:[2,18],16:[2,18],19:[2,18],20:[2,18],22:[2,18],23:[2,18],25:[2,18]},{18:[2,46],24:[2,46],38:[2,46]},{39:[1,68]},{21:55,30:59,31:69,32:[1,56],33:[1,57],34:[1,58],38:[1,27],40:[1,26],41:25},{18:[2,31],24:[2,31],38:[2,31]}],
		defaultActions: {15:[2,1],49:[2,40]},
		parseError: function parseError(str, hash) {
				throw new Error(str);
		},
		parse: function parse(input) {
				var self = this, stack = [0], vstack = [null], lstack = [], table = this.table, yytext = "", yylineno = 0, yyleng = 0, recovering = 0, TERROR = 2, EOF = 1;
				this.lexer.setInput(input);
				this.lexer.yy = this.yy;
				this.yy.lexer = this.lexer;
				this.yy.parser = this;
				if (typeof this.lexer.yylloc == "undefined")
						this.lexer.yylloc = {};
				var yyloc = this.lexer.yylloc;
				lstack.push(yyloc);
				var ranges = this.lexer.options && this.lexer.options.ranges;
				if (typeof this.yy.parseError === "function")
						this.parseError = this.yy.parseError;
				function popStack(n) {
						stack.length = stack.length - 2 * n;
						vstack.length = vstack.length - n;
						lstack.length = lstack.length - n;
				}
				function lex() {
						var token;
						token = self.lexer.lex() || 1;
						if (typeof token !== "number") {
								token = self.symbols_[token] || token;
						}
						return token;
				}
				var symbol, preErrorSymbol, state, action, a, r, yyval = {}, p, len, newState, expected;
				while (true) {
						state = stack[stack.length - 1];
						if (this.defaultActions[state]) {
								action = this.defaultActions[state];
						} else {
								if (symbol === null || typeof symbol == "undefined") {
										symbol = lex();
								}
								action = table[state] && table[state][symbol];
						}
						if (typeof action === "undefined" || !action.length || !action[0]) {
								var errStr = "";
								if (!recovering) {
										expected = [];
										for (p in table[state])
												if (this.terminals_[p] && p > 2) {
														expected.push("'" + this.terminals_[p] + "'");
												}
										if (this.lexer.showPosition) {
												errStr = "Parse error on line " + (yylineno + 1) + ":\n" + this.lexer.showPosition() + "\nExpecting " + expected.join(", ") + ", got '" + (this.terminals_[symbol] || symbol) + "'";
										} else {
												errStr = "Parse error on line " + (yylineno + 1) + ": Unexpected " + (symbol == 1?"end of input":"'" + (this.terminals_[symbol] || symbol) + "'");
										}
										this.parseError(errStr, {text: this.lexer.match, token: this.terminals_[symbol] || symbol, line: this.lexer.yylineno, loc: yyloc, expected: expected});
								}
						}
						if (action[0] instanceof Array && action.length > 1) {
								throw new Error("Parse Error: multiple actions possible at state: " + state + ", token: " + symbol);
						}
						switch (action[0]) {
						case 1:
								stack.push(symbol);
								vstack.push(this.lexer.yytext);
								lstack.push(this.lexer.yylloc);
								stack.push(action[1]);
								symbol = null;
								if (!preErrorSymbol) {
										yyleng = this.lexer.yyleng;
										yytext = this.lexer.yytext;
										yylineno = this.lexer.yylineno;
										yyloc = this.lexer.yylloc;
										if (recovering > 0)
												recovering--;
								} else {
										symbol = preErrorSymbol;
										preErrorSymbol = null;
								}
								break;
						case 2:
								len = this.productions_[action[1]][1];
								yyval.$ = vstack[vstack.length - len];
								yyval._$ = {first_line: lstack[lstack.length - (len || 1)].first_line, last_line: lstack[lstack.length - 1].last_line, first_column: lstack[lstack.length - (len || 1)].first_column, last_column: lstack[lstack.length - 1].last_column};
								if (ranges) {
										yyval._$.range = [lstack[lstack.length - (len || 1)].range[0], lstack[lstack.length - 1].range[1]];
								}
								r = this.performAction.call(yyval, yytext, yyleng, yylineno, this.yy, action[1], vstack, lstack);
								if (typeof r !== "undefined") {
										return r;
								}
								if (len) {
										stack = stack.slice(0, -1 * len * 2);
										vstack = vstack.slice(0, -1 * len);
										lstack = lstack.slice(0, -1 * len);
								}
								stack.push(this.productions_[action[1]][0]);
								vstack.push(yyval.$);
								lstack.push(yyval._$);
								newState = table[stack[stack.length - 2]][stack[stack.length - 1]];
								stack.push(newState);
								break;
						case 3:
								return true;
						}
				}
				return true;
		}
		};
		/* Jison generated lexer */
		var lexer = (function(){
		var lexer = ({EOF:1,
		parseError:function parseError(str, hash) {
						if (this.yy.parser) {
								this.yy.parser.parseError(str, hash);
						} else {
								throw new Error(str);
						}
				},
		setInput:function (input) {
						this._input = input;
						this._more = this._less = this.done = false;
						this.yylineno = this.yyleng = 0;
						this.yytext = this.matched = this.match = '';
						this.conditionStack = ['INITIAL'];
						this.yylloc = {first_line:1,first_column:0,last_line:1,last_column:0};
						if (this.options.ranges) this.yylloc.range = [0,0];
						this.offset = 0;
						return this;
				},
		input:function () {
						var ch = this._input[0];
						this.yytext += ch;
						this.yyleng++;
						this.offset++;
						this.match += ch;
						this.matched += ch;
						var lines = ch.match(/(?:\r\n?|\n).*/g);
						if (lines) {
								this.yylineno++;
								this.yylloc.last_line++;
						} else {
								this.yylloc.last_column++;
						}
						if (this.options.ranges) this.yylloc.range[1]++;

						this._input = this._input.slice(1);
						return ch;
				},
		unput:function (ch) {
						var len = ch.length;
						var lines = ch.split(/(?:\r\n?|\n)/g);

						this._input = ch + this._input;
						this.yytext = this.yytext.substr(0, this.yytext.length-len-1);
						//this.yyleng -= len;
						this.offset -= len;
						var oldLines = this.match.split(/(?:\r\n?|\n)/g);
						this.match = this.match.substr(0, this.match.length-1);
						this.matched = this.matched.substr(0, this.matched.length-1);

						if (lines.length-1) this.yylineno -= lines.length-1;
						var r = this.yylloc.range;

						this.yylloc = {first_line: this.yylloc.first_line,
							last_line: this.yylineno+1,
							first_column: this.yylloc.first_column,
							last_column: lines ?
									(lines.length === oldLines.length ? this.yylloc.first_column : 0) + oldLines[oldLines.length - lines.length].length - lines[0].length:
									this.yylloc.first_column - len
							};

						if (this.options.ranges) {
								this.yylloc.range = [r[0], r[0] + this.yyleng - len];
						}
						return this;
				},
		more:function () {
						this._more = true;
						return this;
				},
		less:function (n) {
						this.unput(this.match.slice(n));
				},
		pastInput:function () {
						var past = this.matched.substr(0, this.matched.length - this.match.length);
						return (past.length > 20 ? '...':'') + past.substr(-20).replace(/\n/g, "");
				},
		upcomingInput:function () {
						var next = this.match;
						if (next.length < 20) {
								next += this._input.substr(0, 20-next.length);
						}
						return (next.substr(0,20)+(next.length > 20 ? '...':'')).replace(/\n/g, "");
				},
		showPosition:function () {
						var pre = this.pastInput();
						var c = new Array(pre.length + 1).join("-");
						return pre + this.upcomingInput() + "\n" + c+"^";
				},
		next:function () {
						if (this.done) {
								return this.EOF;
						}
						if (!this._input) this.done = true;

						var token,
								match,
								tempMatch,
								index,
								col,
								lines;
						if (!this._more) {
								this.yytext = '';
								this.match = '';
						}
						var rules = this._currentRules();
						for (var i=0;i < rules.length; i++) {
								tempMatch = this._input.match(this.rules[rules[i]]);
								if (tempMatch && (!match || tempMatch[0].length > match[0].length)) {
										match = tempMatch;
										index = i;
										if (!this.options.flex) break;
								}
						}
						if (match) {
								lines = match[0].match(/(?:\r\n?|\n).*/g);
								if (lines) this.yylineno += lines.length;
								this.yylloc = {first_line: this.yylloc.last_line,
															 last_line: this.yylineno+1,
															 first_column: this.yylloc.last_column,
															 last_column: lines ? lines[lines.length-1].length-lines[lines.length-1].match(/\r?\n?/)[0].length : this.yylloc.last_column + match[0].length};
								this.yytext += match[0];
								this.match += match[0];
								this.matches = match;
								this.yyleng = this.yytext.length;
								if (this.options.ranges) {
										this.yylloc.range = [this.offset, this.offset += this.yyleng];
								}
								this._more = false;
								this._input = this._input.slice(match[0].length);
								this.matched += match[0];
								token = this.performAction.call(this, this.yy, this, rules[index],this.conditionStack[this.conditionStack.length-1]);
								if (this.done && this._input) this.done = false;
								if (token) return token;
								else return;
						}
						if (this._input === "") {
								return this.EOF;
						} else {
								return this.parseError('Lexical error on line '+(this.yylineno+1)+'. Unrecognized text.\n'+this.showPosition(),
												{text: "", token: null, line: this.yylineno});
						}
				},
		lex:function lex() {
						var r = this.next();
						if (typeof r !== 'undefined') {
								return r;
						} else {
								return this.lex();
						}
				},
		begin:function begin(condition) {
						this.conditionStack.push(condition);
				},
		popState:function popState() {
						return this.conditionStack.pop();
				},
		_currentRules:function _currentRules() {
						return this.conditions[this.conditionStack[this.conditionStack.length-1]].rules;
				},
		topState:function () {
						return this.conditionStack[this.conditionStack.length-2];
				},
		pushState:function begin(condition) {
						this.begin(condition);
				}});
		lexer.options = {};
		lexer.performAction = function anonymous(yy,yy_,$avoiding_name_collisions,YY_START) {


		function strip(start, end) {
			return yy_.yytext = yy_.yytext.substr(start, yy_.yyleng-end);
		}


		var YYSTATE=YY_START
		switch($avoiding_name_collisions) {
		case 0:yy_.yytext = "\\"; return 14;
		break;
		case 1:
																			 if(yy_.yytext.slice(-1) !== "\\") this.begin("mu");
																			 if(yy_.yytext.slice(-1) === "\\") strip(0,1), this.begin("emu");
																			 if(yy_.yytext) return 14;

		break;
		case 2:return 14;
		break;
		case 3:
																			 if(yy_.yytext.slice(-1) !== "\\") this.popState();
																			 if(yy_.yytext.slice(-1) === "\\") strip(0,1);
																			 return 14;

		break;
		case 4:strip(0,4); this.popState(); return 15;
		break;
		case 5:return 25;
		break;
		case 6:return 16;
		break;
		case 7:return 20;
		break;
		case 8:return 19;
		break;
		case 9:return 19;
		break;
		case 10:return 23;
		break;
		case 11:return 22;
		break;
		case 12:this.popState(); this.begin('com');
		break;
		case 13:strip(3,5); this.popState(); return 15;
		break;
		case 14:return 22;
		break;
		case 15:return 39;
		break;
		case 16:return 38;
		break;
		case 17:return 38;
		break;
		case 18:return 42;
		break;
		case 19:/*ignore whitespace*/
		break;
		case 20:this.popState(); return 24;
		break;
		case 21:this.popState(); return 18;
		break;
		case 22:yy_.yytext = strip(1,2).replace(/\\"/g,'"'); return 32;
		break;
		case 23:yy_.yytext = strip(1,2).replace(/\\'/g,"'"); return 32;
		break;
		case 24:return 40;
		break;
		case 25:return 34;
		break;
		case 26:return 34;
		break;
		case 27:return 33;
		break;
		case 28:return 38;
		break;
		case 29:yy_.yytext = strip(1,2); return 38;
		break;
		case 30:return 'INVALID';
		break;
		case 31:return 5;
		break;
		}
		};
		lexer.rules = [/^(?:\\\\(?=(\{\{)))/,/^(?:[^\x00]*?(?=(\{\{)))/,/^(?:[^\x00]+)/,/^(?:[^\x00]{2,}?(?=(\{\{|$)))/,/^(?:[\s\S]*?--\}\})/,/^(?:\{\{>)/,/^(?:\{\{#)/,/^(?:\{\{\/)/,/^(?:\{\{\^)/,/^(?:\{\{\s*else\b)/,/^(?:\{\{\{)/,/^(?:\{\{&)/,/^(?:\{\{!--)/,/^(?:\{\{![\s\S]*?\}\})/,/^(?:\{\{)/,/^(?:=)/,/^(?:\.(?=[}\/ ]))/,/^(?:\.\.)/,/^(?:[\/.])/,/^(?:\s+)/,/^(?:\}\}\})/,/^(?:\}\})/,/^(?:"(\\["]|[^"])*")/,/^(?:'(\\[']|[^'])*')/,/^(?:@)/,/^(?:true(?=[}\s]))/,/^(?:false(?=[}\s]))/,/^(?:-?[0-9]+(?=[}\s]))/,/^(?:([^\s!"#%-,\.\/;->@\[-\^`\{-~]+(?=[=}\s\/.])))/,/^(?:\[[^\]]*\])/,/^(?:.)/,/^(?:$)/];
		lexer.conditions = {"mu":{"rules":[5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31],"inclusive":false},"emu":{"rules":[3],"inclusive":false},"com":{"rules":[4],"inclusive":false},"INITIAL":{"rules":[0,1,2,31],"inclusive":true}};
		return lexer;})()
		parser.lexer = lexer;
		function Parser () { this.yy = {}; }Parser.prototype = parser;parser.Parser = Parser;
		return new Parser;
		})();__exports__['default'] = handlebars;
	});
define(
	'handlebars/compiler/base',["./parser","./ast","exports"],
	function(__dependency1__, __dependency2__, __exports__) {

		var parser = __dependency1__['default'];
		var AST = __dependency2__;

		__exports__.parser = parser;

		function parse(input) {
			// Just return if an already-compile AST was passed in.
			if(input.constructor === AST.ProgramNode) { return input; }

			parser.yy = AST;
			return parser.parse(input);
		}

		__exports__.parse = parse;
	});
define(
	'handlebars/compiler/javascript-compiler',["../base","exports"],
	function(__dependency1__, __exports__) {

		var COMPILER_REVISION = __dependency1__.COMPILER_REVISION;
		var REVISION_CHANGES = __dependency1__.REVISION_CHANGES;
		var log = __dependency1__.log;

		function Literal(value) {
			this.value = value;
		}

		function JavaScriptCompiler() {}

		JavaScriptCompiler.prototype = {
			// PUBLIC API: You can override these methods in a subclass to provide
			// alternative compiled forms for name lookup and buffering semantics
			nameLookup: function(parent, name /* , type*/) {
				if (/^[0-9]+$/.test(name)) {
					return parent + "[" + name + "]";
				} else if (JavaScriptCompiler.isValidJavaScriptVariableName(name)) {
					return parent + "." + name;
				}
				else {
					return parent + "['" + name + "']";
				}
			},

			appendToBuffer: function(string) {
				if (this.environment.isSimple) {
					return "return " + string + ";";
				} else {
					return {
						appendToBuffer: true,
						content: string,
						toString: function() { return "buffer += " + string + ";"; }
					};
				}
			},

			initializeBuffer: function() {
				return this.quotedString("");
			},

			namespace: "Handlebars",
			// END PUBLIC API

			compile: function(environment, options, context, asObject) {
				this.environment = environment;
				this.options = options || {};

				log('debug', this.environment.disassemble() + "\n\n");

				this.name = this.environment.name;
				this.isChild = !!context;
				this.context = context || {
					programs: [],
					environments: [],
					aliases: { }
				};

				this.preamble();

				this.stackSlot = 0;
				this.stackVars = [];
				this.registers = { list: [] };
				this.compileStack = [];
				this.inlineStack = [];

				this.compileChildren(environment, options);

				var opcodes = environment.opcodes, opcode;

				this.i = 0;

				for(var l=opcodes.length; this.i<l; this.i++) {
					opcode = opcodes[this.i];

					if(opcode.opcode === 'DECLARE') {
						this[opcode.name] = opcode.value;
					} else {
						this[opcode.opcode].apply(this, opcode.args);
					}
				}

				return this.createFunctionContext(asObject);
			},

			nextOpcode: function() {
				var opcodes = this.environment.opcodes;
				return opcodes[this.i + 1];
			},

			eat: function() {
				this.i = this.i + 1;
			},

			preamble: function() {
				var out = [];

				if (!this.isChild) {
					var namespace = this.namespace;

					var copies = "helpers = this.merge(helpers, " + namespace + ".helpers);";
					if (this.environment.usePartial) { copies = copies + " partials = this.merge(partials, " + namespace + ".partials);"; }
					if (this.options.data) { copies = copies + " data = data || {};"; }
					out.push(copies);
				} else {
					out.push('');
				}

				if (!this.environment.isSimple) {
					out.push(", buffer = " + this.initializeBuffer());
				} else {
					out.push("");
				}

				// track the last context pushed into place to allow skipping the
				// getContext opcode when it would be a noop
				this.lastContext = 0;
				this.source = out;
			},

			createFunctionContext: function(asObject) {
				var locals = this.stackVars.concat(this.registers.list);

				if(locals.length > 0) {
					this.source[1] = this.source[1] + ", " + locals.join(", ");
				}

				// Generate minimizer alias mappings
				if (!this.isChild) {
					for (var alias in this.context.aliases) {
						if (this.context.aliases.hasOwnProperty(alias)) {
							this.source[1] = this.source[1] + ', ' + alias + '=' + this.context.aliases[alias];
						}
					}
				}

				if (this.source[1]) {
					this.source[1] = "var " + this.source[1].substring(2) + ";";
				}

				// Merge children
				if (!this.isChild) {
					this.source[1] += '\n' + this.context.programs.join('\n') + '\n';
				}

				if (!this.environment.isSimple) {
					this.source.push("return buffer;");
				}

				var params = this.isChild ? ["depth0", "data"] : ["Handlebars", "depth0", "helpers", "partials", "data"];

				for(var i=0, l=this.environment.depths.list.length; i<l; i++) {
					params.push("depth" + this.environment.depths.list[i]);
				}

				// Perform a second pass over the output to merge content when possible
				var source = this.mergeSource();

				if (!this.isChild) {
					var revision = COMPILER_REVISION,
							versions = REVISION_CHANGES[revision];
					source = "this.compilerInfo = ["+revision+",'"+versions+"'];\n"+source;
				}

				if (asObject) {
					params.push(source);

					return Function.apply(this, params);
				} else {
					var functionSource = 'function ' + (this.name || '') + '(' + params.join(',') + ') {\n  ' + source + '}';
					log('debug', functionSource + "\n\n");
					return functionSource;
				}
			},
			mergeSource: function() {
				// WARN: We are not handling the case where buffer is still populated as the source should
				// not have buffer append operations as their final action.
				var source = '',
						buffer;
				for (var i = 0, len = this.source.length; i < len; i++) {
					var line = this.source[i];
					if (line.appendToBuffer) {
						if (buffer) {
							buffer = buffer + '\n    + ' + line.content;
						} else {
							buffer = line.content;
						}
					} else {
						if (buffer) {
							source += 'buffer += ' + buffer + ';\n  ';
							buffer = undefined;
						}
						source += line + '\n  ';
					}
				}
				return source;
			},

			// [blockValue]
			//
			// On stack, before: hash, inverse, program, value
			// On stack, after: return value of blockHelperMissing
			//
			// The purpose of this opcode is to take a block of the form
			// `{{#foo}}...{{/foo}}`, resolve the value of `foo`, and
			// replace it on the stack with the result of properly
			// invoking blockHelperMissing.
			blockValue: function() {
				this.context.aliases.blockHelperMissing = 'helpers.blockHelperMissing';

				var params = ["depth0"];
				this.setupParams(0, params);

				this.replaceStack(function(current) {
					params.splice(1, 0, current);
					return "blockHelperMissing.call(" + params.join(", ") + ")";
				});
			},

			// [ambiguousBlockValue]
			//
			// On stack, before: hash, inverse, program, value
			// Compiler value, before: lastHelper=value of last found helper, if any
			// On stack, after, if no lastHelper: same as [blockValue]
			// On stack, after, if lastHelper: value
			ambiguousBlockValue: function() {
				this.context.aliases.blockHelperMissing = 'helpers.blockHelperMissing';

				var params = ["depth0"];
				this.setupParams(0, params);

				var current = this.topStack();
				params.splice(1, 0, current);

				// Use the options value generated from the invocation
				params[params.length-1] = 'options';

				this.source.push("if (!" + this.lastHelper + ") { " + current + " = blockHelperMissing.call(" + params.join(", ") + "); }");
			},

			// [appendContent]
			//
			// On stack, before: ...
			// On stack, after: ...
			//
			// Appends the string value of `content` to the current buffer
			appendContent: function(content) {
				this.source.push(this.appendToBuffer(this.quotedString(content)));
			},

			// [append]
			//
			// On stack, before: value, ...
			// On stack, after: ...
			//
			// Coerces `value` to a String and appends it to the current buffer.
			//
			// If `value` is truthy, or 0, it is coerced into a string and appended
			// Otherwise, the empty string is appended
			append: function() {
				// Force anything that is inlined onto the stack so we don't have duplication
				// when we examine local
				this.flushInline();
				var local = this.popStack();
				this.source.push("if(" + local + " || " + local + " === 0) { " + this.appendToBuffer(local) + " }");
				if (this.environment.isSimple) {
					this.source.push("else { " + this.appendToBuffer("''") + " }");
				}
			},

			// [appendEscaped]
			//
			// On stack, before: value, ...
			// On stack, after: ...
			//
			// Escape `value` and append it to the buffer
			appendEscaped: function() {
				this.context.aliases.escapeExpression = 'this.escapeExpression';

				this.source.push(this.appendToBuffer("escapeExpression(" + this.popStack() + ")"));
			},

			// [getContext]
			//
			// On stack, before: ...
			// On stack, after: ...
			// Compiler value, after: lastContext=depth
			//
			// Set the value of the `lastContext` compiler value to the depth
			getContext: function(depth) {
				if(this.lastContext !== depth) {
					this.lastContext = depth;
				}
			},

			// [lookupOnContext]
			//
			// On stack, before: ...
			// On stack, after: currentContext[name], ...
			//
			// Looks up the value of `name` on the current context and pushes
			// it onto the stack.
			lookupOnContext: function(name) {
				this.push(this.nameLookup('depth' + this.lastContext, name, 'context'));
			},

			// [pushContext]
			//
			// On stack, before: ...
			// On stack, after: currentContext, ...
			//
			// Pushes the value of the current context onto the stack.
			pushContext: function() {
				this.pushStackLiteral('depth' + this.lastContext);
			},

			// [resolvePossibleLambda]
			//
			// On stack, before: value, ...
			// On stack, after: resolved value, ...
			//
			// If the `value` is a lambda, replace it on the stack by
			// the return value of the lambda
			resolvePossibleLambda: function() {
				this.context.aliases.functionType = '"function"';

				this.replaceStack(function(current) {
					return "typeof " + current + " === functionType ? " + current + ".apply(depth0) : " + current;
				});
			},

			// [lookup]
			//
			// On stack, before: value, ...
			// On stack, after: value[name], ...
			//
			// Replace the value on the stack with the result of looking
			// up `name` on `value`
			lookup: function(name) {
				this.replaceStack(function(current) {
					return current + " == null || " + current + " === false ? " + current + " : " + this.nameLookup(current, name, 'context');
				});
			},

			// [lookupData]
			//
			// On stack, before: ...
			// On stack, after: data, ...
			//
			// Push the data lookup operator
			lookupData: function() {
				this.push('data');
			},

			// [pushStringParam]
			//
			// On stack, before: ...
			// On stack, after: string, currentContext, ...
			//
			// This opcode is designed for use in string mode, which
			// provides the string value of a parameter along with its
			// depth rather than resolving it immediately.
			pushStringParam: function(string, type) {
				this.pushStackLiteral('depth' + this.lastContext);

				this.pushString(type);

				if (typeof string === 'string') {
					this.pushString(string);
				} else {
					this.pushStackLiteral(string);
				}
			},

			emptyHash: function() {
				this.pushStackLiteral('{}');

				if (this.options.stringParams) {
					this.register('hashTypes', '{}');
					this.register('hashContexts', '{}');
				}
			},
			pushHash: function() {
				this.hash = {values: [], types: [], contexts: []};
			},
			popHash: function() {
				var hash = this.hash;
				this.hash = undefined;

				if (this.options.stringParams) {
					this.register('hashContexts', '{' + hash.contexts.join(',') + '}');
					this.register('hashTypes', '{' + hash.types.join(',') + '}');
				}
				this.push('{\n    ' + hash.values.join(',\n    ') + '\n  }');
			},

			// [pushString]
			//
			// On stack, before: ...
			// On stack, after: quotedString(string), ...
			//
			// Push a quoted version of `string` onto the stack
			pushString: function(string) {
				this.pushStackLiteral(this.quotedString(string));
			},

			// [push]
			//
			// On stack, before: ...
			// On stack, after: expr, ...
			//
			// Push an expression onto the stack
			push: function(expr) {
				this.inlineStack.push(expr);
				return expr;
			},

			// [pushLiteral]
			//
			// On stack, before: ...
			// On stack, after: value, ...
			//
			// Pushes a value onto the stack. This operation prevents
			// the compiler from creating a temporary variable to hold
			// it.
			pushLiteral: function(value) {
				this.pushStackLiteral(value);
			},

			// [pushProgram]
			//
			// On stack, before: ...
			// On stack, after: program(guid), ...
			//
			// Push a program expression onto the stack. This takes
			// a compile-time guid and converts it into a runtime-accessible
			// expression.
			pushProgram: function(guid) {
				if (guid != null) {
					this.pushStackLiteral(this.programExpression(guid));
				} else {
					this.pushStackLiteral(null);
				}
			},

			// [invokeHelper]
			//
			// On stack, before: hash, inverse, program, params..., ...
			// On stack, after: result of helper invocation
			//
			// Pops off the helper's parameters, invokes the helper,
			// and pushes the helper's return value onto the stack.
			//
			// If the helper is not found, `helperMissing` is called.
			invokeHelper: function(paramSize, name) {
				this.context.aliases.helperMissing = 'helpers.helperMissing';

				var helper = this.lastHelper = this.setupHelper(paramSize, name, true);
				var nonHelper = this.nameLookup('depth' + this.lastContext, name, 'context');

				this.push(helper.name + ' || ' + nonHelper);
				this.replaceStack(function(name) {
					return name + ' ? ' + name + '.call(' +
							helper.callParams + ") " + ": helperMissing.call(" +
							helper.helperMissingParams + ")";
				});
			},

			// [invokeKnownHelper]
			//
			// On stack, before: hash, inverse, program, params..., ...
			// On stack, after: result of helper invocation
			//
			// This operation is used when the helper is known to exist,
			// so a `helperMissing` fallback is not required.
			invokeKnownHelper: function(paramSize, name) {
				var helper = this.setupHelper(paramSize, name);
				this.push(helper.name + ".call(" + helper.callParams + ")");
			},

			// [invokeAmbiguous]
			//
			// On stack, before: hash, inverse, program, params..., ...
			// On stack, after: result of disambiguation
			//
			// This operation is used when an expression like `{{foo}}`
			// is provided, but we don't know at compile-time whether it
			// is a helper or a path.
			//
			// This operation emits more code than the other options,
			// and can be avoided by passing the `knownHelpers` and
			// `knownHelpersOnly` flags at compile-time.
			invokeAmbiguous: function(name, helperCall) {
				this.context.aliases.functionType = '"function"';

				this.pushStackLiteral('{}');    // Hash value
				var helper = this.setupHelper(0, name, helperCall);

				var helperName = this.lastHelper = this.nameLookup('helpers', name, 'helper');

				var nonHelper = this.nameLookup('depth' + this.lastContext, name, 'context');
				var nextStack = this.nextStack();

				this.source.push('if (' + nextStack + ' = ' + helperName + ') { ' + nextStack + ' = ' + nextStack + '.call(' + helper.callParams + '); }');
				this.source.push('else { ' + nextStack + ' = ' + nonHelper + '; ' + nextStack + ' = typeof ' + nextStack + ' === functionType ? ' + nextStack + '.apply(depth0) : ' + nextStack + '; }');
			},

			// [invokePartial]
			//
			// On stack, before: context, ...
			// On stack after: result of partial invocation
			//
			// This operation pops off a context, invokes a partial with that context,
			// and pushes the result of the invocation back.
			invokePartial: function(name) {
				var params = [this.nameLookup('partials', name, 'partial'), "'" + name + "'", this.popStack(), "helpers", "partials"];

				if (this.options.data) {
					params.push("data");
				}

				this.context.aliases.self = "this";
				this.push("self.invokePartial(" + params.join(", ") + ")");
			},

			// [assignToHash]
			//
			// On stack, before: value, hash, ...
			// On stack, after: hash, ...
			//
			// Pops a value and hash off the stack, assigns `hash[key] = value`
			// and pushes the hash back onto the stack.
			assignToHash: function(key) {
				var value = this.popStack(),
						context,
						type;

				if (this.options.stringParams) {
					type = this.popStack();
					context = this.popStack();
				}

				var hash = this.hash;
				if (context) {
					hash.contexts.push("'" + key + "': " + context);
				}
				if (type) {
					hash.types.push("'" + key + "': " + type);
				}
				hash.values.push("'" + key + "': (" + value + ")");
			},

			// HELPERS

			compiler: JavaScriptCompiler,

			compileChildren: function(environment, options) {
				var children = environment.children, child, compiler;

				for(var i=0, l=children.length; i<l; i++) {
					child = children[i];
					compiler = new this.compiler();

					var index = this.matchExistingProgram(child);

					if (index == null) {
						this.context.programs.push('');     // Placeholder to prevent name conflicts for nested children
						index = this.context.programs.length;
						child.index = index;
						child.name = 'program' + index;
						this.context.programs[index] = compiler.compile(child, options, this.context);
						this.context.environments[index] = child;
					} else {
						child.index = index;
						child.name = 'program' + index;
					}
				}
			},
			matchExistingProgram: function(child) {
				for (var i = 0, len = this.context.environments.length; i < len; i++) {
					var environment = this.context.environments[i];
					if (environment && environment.equals(child)) {
						return i;
					}
				}
			},

			programExpression: function(guid) {
				this.context.aliases.self = "this";

				if(guid == null) {
					return "self.noop";
				}

				var child = this.environment.children[guid],
						depths = child.depths.list, depth;

				var programParams = [child.index, child.name, "data"];

				for(var i=0, l = depths.length; i<l; i++) {
					depth = depths[i];

					if(depth === 1) { programParams.push("depth0"); }
					else { programParams.push("depth" + (depth - 1)); }
				}

				return (depths.length === 0 ? "self.program(" : "self.programWithDepth(") + programParams.join(", ") + ")";
			},

			register: function(name, val) {
				this.useRegister(name);
				this.source.push(name + " = " + val + ";");
			},

			useRegister: function(name) {
				if(!this.registers[name]) {
					this.registers[name] = true;
					this.registers.list.push(name);
				}
			},

			pushStackLiteral: function(item) {
				return this.push(new Literal(item));
			},

			pushStack: function(item) {
				this.flushInline();

				var stack = this.incrStack();
				if (item) {
					this.source.push(stack + " = " + item + ";");
				}
				this.compileStack.push(stack);
				return stack;
			},

			replaceStack: function(callback) {
				var prefix = '',
						inline = this.isInline(),
						stack;

				// If we are currently inline then we want to merge the inline statement into the
				// replacement statement via ','
				if (inline) {
					var top = this.popStack(true);

					if (top instanceof Literal) {
						// Literals do not need to be inlined
						stack = top.value;
					} else {
						// Get or create the current stack name for use by the inline
						var name = this.stackSlot ? this.topStackName() : this.incrStack();

						prefix = '(' + this.push(name) + ' = ' + top + '),';
						stack = this.topStack();
					}
				} else {
					stack = this.topStack();
				}

				var item = callback.call(this, stack);

				if (inline) {
					if (this.inlineStack.length || this.compileStack.length) {
						this.popStack();
					}
					this.push('(' + prefix + item + ')');
				} else {
					// Prevent modification of the context depth variable. Through replaceStack
					if (!/^stack/.test(stack)) {
						stack = this.nextStack();
					}

					this.source.push(stack + " = (" + prefix + item + ");");
				}
				return stack;
			},

			nextStack: function() {
				return this.pushStack();
			},

			incrStack: function() {
				this.stackSlot++;
				if(this.stackSlot > this.stackVars.length) { this.stackVars.push("stack" + this.stackSlot); }
				return this.topStackName();
			},
			topStackName: function() {
				return "stack" + this.stackSlot;
			},
			flushInline: function() {
				var inlineStack = this.inlineStack;
				if (inlineStack.length) {
					this.inlineStack = [];
					for (var i = 0, len = inlineStack.length; i < len; i++) {
						var entry = inlineStack[i];
						if (entry instanceof Literal) {
							this.compileStack.push(entry);
						} else {
							this.pushStack(entry);
						}
					}
				}
			},
			isInline: function() {
				return this.inlineStack.length;
			},

			popStack: function(wrapped) {
				var inline = this.isInline(),
						item = (inline ? this.inlineStack : this.compileStack).pop();

				if (!wrapped && (item instanceof Literal)) {
					return item.value;
				} else {
					if (!inline) {
						this.stackSlot--;
					}
					return item;
				}
			},

			topStack: function(wrapped) {
				var stack = (this.isInline() ? this.inlineStack : this.compileStack),
						item = stack[stack.length - 1];

				if (!wrapped && (item instanceof Literal)) {
					return item.value;
				} else {
					return item;
				}
			},

			quotedString: function(str) {
				return '"' + str
					.replace(/\\/g, '\\\\')
					.replace(/"/g, '\\"')
					.replace(/\n/g, '\\n')
					.replace(/\r/g, '\\r')
					.replace(/\u2028/g, '\\u2028')   // Per Ecma-262 7.3 + 7.8.4
					.replace(/\u2029/g, '\\u2029') + '"';
			},

			setupHelper: function(paramSize, name, missingParams) {
				var params = [];
				this.setupParams(paramSize, params, missingParams);
				var foundHelper = this.nameLookup('helpers', name, 'helper');

				return {
					params: params,
					name: foundHelper,
					callParams: ["depth0"].concat(params).join(", "),
					helperMissingParams: missingParams && ["depth0", this.quotedString(name)].concat(params).join(", ")
				};
			},

			// the params and contexts arguments are passed in arrays
			// to fill in
			setupParams: function(paramSize, params, useRegister) {
				var options = [], contexts = [], types = [], param, inverse, program;

				options.push("hash:" + this.popStack());

				inverse = this.popStack();
				program = this.popStack();

				// Avoid setting fn and inverse if neither are set. This allows
				// helpers to do a check for `if (options.fn)`
				if (program || inverse) {
					if (!program) {
						this.context.aliases.self = "this";
						program = "self.noop";
					}

					if (!inverse) {
					 this.context.aliases.self = "this";
						inverse = "self.noop";
					}

					options.push("inverse:" + inverse);
					options.push("fn:" + program);
				}

				for(var i=0; i<paramSize; i++) {
					param = this.popStack();
					params.push(param);

					if(this.options.stringParams) {
						types.push(this.popStack());
						contexts.push(this.popStack());
					}
				}

				if (this.options.stringParams) {
					options.push("contexts:[" + contexts.join(",") + "]");
					options.push("types:[" + types.join(",") + "]");
					options.push("hashContexts:hashContexts");
					options.push("hashTypes:hashTypes");
				}

				if(this.options.data) {
					options.push("data:data");
				}

				options = "{" + options.join(",") + "}";
				if (useRegister) {
					this.register('options', options);
					params.push('options');
				} else {
					params.push(options);
				}
				return params.join(", ");
			}
		};

		var reservedWords = (
			"break else new var" +
			" case finally return void" +
			" catch for switch while" +
			" continue function this with" +
			" default if throw" +
			" delete in try" +
			" do instanceof typeof" +
			" abstract enum int short" +
			" boolean export interface static" +
			" byte extends long super" +
			" char final native synchronized" +
			" class float package throws" +
			" const goto private transient" +
			" debugger implements protected volatile" +
			" double import public let yield"
		).split(" ");

		var compilerWords = JavaScriptCompiler.RESERVED_WORDS = {};

		for(var i=0, l=reservedWords.length; i<l; i++) {
			compilerWords[reservedWords[i]] = true;
		}

		JavaScriptCompiler.isValidJavaScriptVariableName = function(name) {
			if(!JavaScriptCompiler.RESERVED_WORDS[name] && /^[a-zA-Z_$][0-9a-zA-Z_$]+$/.test(name)) {
				return true;
			}
			return false;
		};

		__exports__['default'] = JavaScriptCompiler;
	});
define(
	'handlebars/compiler/compiler',["../exception","./base","./javascript-compiler","./ast","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __dependency4__, __exports__) {

		var Exception = __dependency1__['default'];
		var parse = __dependency2__.parse;
		var JavaScriptCompiler = __dependency3__['default'];
		var AST = __dependency4__;

		function Compiler() {}

		__exports__.Compiler = Compiler;// the foundHelper register will disambiguate helper lookup from finding a
		// function in a context. This is necessary for mustache compatibility, which
		// requires that context functions in blocks are evaluated by blockHelperMissing,
		// and then proceed as if the resulting value was provided to blockHelperMissing.

		Compiler.prototype = {
			compiler: Compiler,

			disassemble: function() {
				var opcodes = this.opcodes, opcode, out = [], params, param;

				for (var i=0, l=opcodes.length; i<l; i++) {
					opcode = opcodes[i];

					if (opcode.opcode === 'DECLARE') {
						out.push("DECLARE " + opcode.name + "=" + opcode.value);
					} else {
						params = [];
						for (var j=0; j<opcode.args.length; j++) {
							param = opcode.args[j];
							if (typeof param === "string") {
								param = "\"" + param.replace("\n", "\\n") + "\"";
							}
							params.push(param);
						}
						out.push(opcode.opcode + " " + params.join(" "));
					}
				}

				return out.join("\n");
			},

			equals: function(other) {
				var len = this.opcodes.length;
				if (other.opcodes.length !== len) {
					return false;
				}

				for (var i = 0; i < len; i++) {
					var opcode = this.opcodes[i],
							otherOpcode = other.opcodes[i];
					if (opcode.opcode !== otherOpcode.opcode || opcode.args.length !== otherOpcode.args.length) {
						return false;
					}
					for (var j = 0; j < opcode.args.length; j++) {
						if (opcode.args[j] !== otherOpcode.args[j]) {
							return false;
						}
					}
				}

				len = this.children.length;
				if (other.children.length !== len) {
					return false;
				}
				for (i = 0; i < len; i++) {
					if (!this.children[i].equals(other.children[i])) {
						return false;
					}
				}

				return true;
			},

			guid: 0,

			compile: function(program, options) {
				this.children = [];
				this.depths = {list: []};
				this.options = options;

				// These changes will propagate to the other compiler components
				var knownHelpers = this.options.knownHelpers;
				this.options.knownHelpers = {
					'helperMissing': true,
					'blockHelperMissing': true,
					'each': true,
					'if': true,
					'unless': true,
					'with': true,
					'log': true
				};
				if (knownHelpers) {
					for (var name in knownHelpers) {
						this.options.knownHelpers[name] = knownHelpers[name];
					}
				}

				return this.program(program);
			},

			accept: function(node) {
				return this[node.type](node);
			},

			program: function(program) {
				var statements = program.statements, statement;
				this.opcodes = [];

				for(var i=0, l=statements.length; i<l; i++) {
					statement = statements[i];
					this[statement.type](statement);
				}
				this.isSimple = l === 1;

				this.depths.list = this.depths.list.sort(function(a, b) {
					return a - b;
				});

				return this;
			},

			compileProgram: function(program) {
				var result = new this.compiler().compile(program, this.options);
				var guid = this.guid++, depth;

				this.usePartial = this.usePartial || result.usePartial;

				this.children[guid] = result;

				for(var i=0, l=result.depths.list.length; i<l; i++) {
					depth = result.depths.list[i];

					if(depth < 2) { continue; }
					else { this.addDepth(depth - 1); }
				}

				return guid;
			},

			block: function(block) {
				var mustache = block.mustache,
						program = block.program,
						inverse = block.inverse;

				if (program) {
					program = this.compileProgram(program);
				}

				if (inverse) {
					inverse = this.compileProgram(inverse);
				}

				var type = this.classifyMustache(mustache);

				if (type === "helper") {
					this.helperMustache(mustache, program, inverse);
				} else if (type === "simple") {
					this.simpleMustache(mustache);

					// now that the simple mustache is resolved, we need to
					// evaluate it by executing `blockHelperMissing`
					this.opcode('pushProgram', program);
					this.opcode('pushProgram', inverse);
					this.opcode('emptyHash');
					this.opcode('blockValue');
				} else {
					this.ambiguousMustache(mustache, program, inverse);

					// now that the simple mustache is resolved, we need to
					// evaluate it by executing `blockHelperMissing`
					this.opcode('pushProgram', program);
					this.opcode('pushProgram', inverse);
					this.opcode('emptyHash');
					this.opcode('ambiguousBlockValue');
				}

				this.opcode('append');
			},

			hash: function(hash) {
				var pairs = hash.pairs, pair, val;

				this.opcode('pushHash');

				for(var i=0, l=pairs.length; i<l; i++) {
					pair = pairs[i];
					val  = pair[1];

					if (this.options.stringParams) {
						if(val.depth) {
							this.addDepth(val.depth);
						}
						this.opcode('getContext', val.depth || 0);
						this.opcode('pushStringParam', val.stringModeValue, val.type);
					} else {
						this.accept(val);
					}

					this.opcode('assignToHash', pair[0]);
				}
				this.opcode('popHash');
			},

			partial: function(partial) {
				var partialName = partial.partialName;
				this.usePartial = true;

				if(partial.context) {
					this.ID(partial.context);
				} else {
					this.opcode('push', 'depth0');
				}

				this.opcode('invokePartial', partialName.name);
				this.opcode('append');
			},

			content: function(content) {
				this.opcode('appendContent', content.string);
			},

			mustache: function(mustache) {
				var options = this.options;
				var type = this.classifyMustache(mustache);

				if (type === "simple") {
					this.simpleMustache(mustache);
				} else if (type === "helper") {
					this.helperMustache(mustache);
				} else {
					this.ambiguousMustache(mustache);
				}

				if(mustache.escaped && !options.noEscape) {
					this.opcode('appendEscaped');
				} else {
					this.opcode('append');
				}
			},

			ambiguousMustache: function(mustache, program, inverse) {
				var id = mustache.id,
						name = id.parts[0],
						isBlock = program != null || inverse != null;

				this.opcode('getContext', id.depth);

				this.opcode('pushProgram', program);
				this.opcode('pushProgram', inverse);

				this.opcode('invokeAmbiguous', name, isBlock);
			},

			simpleMustache: function(mustache) {
				var id = mustache.id;

				if (id.type === 'DATA') {
					this.DATA(id);
				} else if (id.parts.length) {
					this.ID(id);
				} else {
					// Simplified ID for `this`
					this.addDepth(id.depth);
					this.opcode('getContext', id.depth);
					this.opcode('pushContext');
				}

				this.opcode('resolvePossibleLambda');
			},

			helperMustache: function(mustache, program, inverse) {
				var params = this.setupFullMustacheParams(mustache, program, inverse),
						name = mustache.id.parts[0];

				if (this.options.knownHelpers[name]) {
					this.opcode('invokeKnownHelper', params.length, name);
				} else if (this.options.knownHelpersOnly) {
					throw new Error("You specified knownHelpersOnly, but used the unknown helper " + name);
				} else {
					this.opcode('invokeHelper', params.length, name);
				}
			},

			ID: function(id) {
				this.addDepth(id.depth);
				this.opcode('getContext', id.depth);

				var name = id.parts[0];
				if (!name) {
					this.opcode('pushContext');
				} else {
					this.opcode('lookupOnContext', id.parts[0]);
				}

				for(var i=1, l=id.parts.length; i<l; i++) {
					this.opcode('lookup', id.parts[i]);
				}
			},

			DATA: function(data) {
				this.options.data = true;
				if (data.id.isScoped || data.id.depth) {
					throw new Exception('Scoped data references are not supported: ' + data.original);
				}

				this.opcode('lookupData');
				var parts = data.id.parts;
				for(var i=0, l=parts.length; i<l; i++) {
					this.opcode('lookup', parts[i]);
				}
			},

			STRING: function(string) {
				this.opcode('pushString', string.string);
			},

			INTEGER: function(integer) {
				this.opcode('pushLiteral', integer.integer);
			},

			BOOLEAN: function(bool) {
				this.opcode('pushLiteral', bool.bool);
			},

			comment: function() {},

			// HELPERS
			opcode: function(name) {
				this.opcodes.push({ opcode: name, args: [].slice.call(arguments, 1) });
			},

			declare: function(name, value) {
				this.opcodes.push({ opcode: 'DECLARE', name: name, value: value });
			},

			addDepth: function(depth) {
				if(isNaN(depth)) { throw new Error("EWOT"); }
				if(depth === 0) { return; }

				if(!this.depths[depth]) {
					this.depths[depth] = true;
					this.depths.list.push(depth);
				}
			},

			classifyMustache: function(mustache) {
				var isHelper   = mustache.isHelper;
				var isEligible = mustache.eligibleHelper;
				var options    = this.options;

				// if ambiguous, we can possibly resolve the ambiguity now
				if (isEligible && !isHelper) {
					var name = mustache.id.parts[0];

					if (options.knownHelpers[name]) {
						isHelper = true;
					} else if (options.knownHelpersOnly) {
						isEligible = false;
					}
				}

				if (isHelper) { return "helper"; }
				else if (isEligible) { return "ambiguous"; }
				else { return "simple"; }
			},

			pushParams: function(params) {
				var i = params.length, param;

				while(i--) {
					param = params[i];

					if(this.options.stringParams) {
						if(param.depth) {
							this.addDepth(param.depth);
						}

						this.opcode('getContext', param.depth || 0);
						this.opcode('pushStringParam', param.stringModeValue, param.type);
					} else {
						this[param.type](param);
					}
				}
			},

			setupMustacheParams: function(mustache) {
				var params = mustache.params;
				this.pushParams(params);

				if(mustache.hash) {
					this.hash(mustache.hash);
				} else {
					this.opcode('emptyHash');
				}

				return params;
			},

			// this will replace setupMustacheParams when we're done
			setupFullMustacheParams: function(mustache, program, inverse) {
				var params = mustache.params;
				this.pushParams(params);

				this.opcode('pushProgram', program);
				this.opcode('pushProgram', inverse);

				if(mustache.hash) {
					this.hash(mustache.hash);
				} else {
					this.opcode('emptyHash');
				}

				return params;
			}
		};

		function precompile(input, options) {
			if (input == null || (typeof input !== 'string' && input.constructor !== AST.ProgramNode)) {
				throw new Exception("You must pass a string or Handlebars AST to Handlebars.precompile. You passed " + input);
			}

			options = options || {};
			if (!('data' in options)) {
				options.data = true;
			}

			var ast = parse(input);
			var environment = new Compiler().compile(ast, options);
			return new JavaScriptCompiler().compile(environment, options);
		}

		__exports__.precompile = precompile;function compile(input, options, env) {
			if (input == null || (typeof input !== 'string' && input.constructor !== AST.ProgramNode)) {
				throw new Exception("You must pass a string or Handlebars AST to Handlebars.compile. You passed " + input);
			}

			options = options || {};

			if (!('data' in options)) {
				options.data = true;
			}

			var compiled;

			function compileInput() {
				var ast = parse(input);
				var environment = new Compiler().compile(ast, options);
				var templateSpec = new JavaScriptCompiler().compile(environment, options, undefined, true);
				return env.template(templateSpec);
			}

			// Template is only compiled on first use and cached after that point.
			return function(context, options) {
				if (!compiled) {
					compiled = compileInput();
				}
				return compiled.call(this, context, options);
			};
		}

		__exports__.compile = compile;
	});
define(
	'handlebars',["./handlebars.runtime","./handlebars/compiler/ast","./handlebars/compiler/base","./handlebars/compiler/compiler","./handlebars/compiler/javascript-compiler","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __dependency4__, __dependency5__, __exports__) {

		var Handlebars = __dependency1__['default'];

		// Compiler imports
		var AST = __dependency2__;
		var Parser = __dependency3__.parser;
		var parse = __dependency3__.parse;
		var Compiler = __dependency4__.Compiler;
		var compile = __dependency4__.compile;
		var precompile = __dependency4__.precompile;
		var JavaScriptCompiler = __dependency5__['default'];

		var _create = Handlebars.create;
		var create = function() {
			var hb = _create();

			hb.compile = function(input, options) {
				return compile(input, options, hb);
			};
			hb.precompile = precompile;

			hb.AST = AST;
			hb.Compiler = Compiler;
			hb.JavaScriptCompiler = JavaScriptCompiler;
			hb.Parser = Parser;
			hb.parse = parse;

			return hb;
		};

		Handlebars = create();
		Handlebars.create = create;

		__exports__['default'] = Handlebars;
	});
/* jshint ignore:end */
})();



(function() {
define("htmlbars",
	["htmlbars/parser","htmlbars/ast","htmlbars/compiler","htmlbars/helpers","htmlbars/macros","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __dependency4__, __dependency5__, __exports__) {
		"use strict";
		var preprocess = __dependency1__.preprocess;
		var HTMLElement = __dependency2__.HTMLElement;
		var BlockElement = __dependency2__.BlockElement;
		var compile = __dependency3__.compile;
		var registerHelper = __dependency4__.registerHelper;
		var removeHelper = __dependency4__.removeHelper;
		var registerMacro = __dependency5__.registerMacro;
		var removeMacro = __dependency5__.removeMacro;

		__exports__.preprocess = preprocess;
		__exports__.compile = compile;
		__exports__.HTMLElement = HTMLElement;
		__exports__.BlockElement = BlockElement;
		__exports__.removeHelper = removeHelper;
		__exports__.registerHelper = registerHelper;
		__exports__.removeMacro = removeMacro;
		__exports__.registerMacro = registerMacro;
	});
define("htmlbars/ast",
	["handlebars/compiler/ast","exports"],
	function(__dependency1__, __exports__) {
		"use strict";
		var MustacheNode = __dependency1__.MustacheNode;

		function HTMLElement(tag, attributes, children, helpers) {
			this.tag = tag;
			this.attributes = attributes || [];
			this.children = children || [];
			this.helpers = helpers || [];

			if (!attributes) { return; }

			for (var i=0, l=attributes.length; i<l; i++) {
				var attribute = attributes[i];
				attributes[attribute[0]] = attribute[1];
			}
		}

		function appendChild(node) {
			var len = this.children.length,
					lastNode = len > 0 ? this.children[len - 1] : null;

			// Back to back MustacheNodes need an empty text node delimiter
			if (lastNode && node instanceof MustacheNode && lastNode instanceof MustacheNode) {
				this.children.push('');
			}

			this.children.push(node);
		}

		HTMLElement.prototype = {
			appendChild: appendChild,

			removeAttr: function(name) {
				var attributes = this.attributes, attribute;
				delete attributes[name];
				for (var i=0, l=attributes.length; i<l; i++) {
					attribute = attributes[i];
					if (attribute[0] === name) {
						attributes.splice(i, 1);
						break;
					}
				}
			},

			getAttr: function(name) {
				var attributes = this.attributes;
				if (attributes.length !== 1 || attributes[0] instanceof MustacheNode) { return; }
				return attributes[name][0];
			}
		};

		function BlockElement(helper, children) {
			this.helper = helper;
			this.children = children || [];
		}

		BlockElement.prototype.appendChild = appendChild;

		__exports__.HTMLElement = HTMLElement;
		__exports__.BlockElement = BlockElement;
	});
define("htmlbars/compiler",
	["htmlbars/parser","htmlbars/compiler/template","htmlbars/runtime/dom_helpers","htmlbars/runtime/range","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __dependency4__, __exports__) {
		"use strict";
		/*jshint evil:true*/
		var preprocess = __dependency1__.preprocess;
		var TemplateCompiler = __dependency2__.TemplateCompiler;
		var domHelpers = __dependency3__.domHelpers;
		var Range = __dependency4__.Range;

		function compile(string, options) {
			return compileSpec(string, options)(domHelpers(), Range);
		}

		__exports__.compile = compile;function compileSpec(string, options) {
			var ast = preprocess(string, options);
			var compiler = new TemplateCompiler();
			var program = compiler.compile(ast);
			return new Function("dom", "Range", "return " + program);
		}

		__exports__.compileSpec = compileSpec;
	});
define("htmlbars/compiler/ast_walker",
	["htmlbars/ast","exports"],
	function(__dependency1__, __exports__) {
		"use strict";
		var HTMLElement = __dependency1__.HTMLElement;
		var BlockElement = __dependency1__.BlockElement;

		function Frame(children, parent, isBlock) {
			this.parent = parent;
			this.children = children;
			this.length = children.length;

			// cursor
			this.pos = this.length-1;
			this.inverse = false;
			this.close = false;

			// block tracking
			this.isBlock = isBlock;
			this.block = isBlock ? this : parent.block;
			this.stack = isBlock ? [['endTemplate']] : null;
			this.count = 0;
		}

		Frame.prototype.next = function() {
			var node;
			while (this.pos >= 0) {
				node = this.children[this.pos];
				if (this.inverse) {
					this.inverse = false;
					this.pos--;
					this.block.count++;
					return new Frame(node.children, this, true);
				}
				if (typeof node === 'string') {
					this.block.stack.push(['text', node, this.pos, this.length]);
				} else if (node instanceof BlockElement) {
					this.block.stack.push(['block', node, this.pos, this.length]);
					this.inverse = true;
					this.block.count++;
					return new Frame(node.inverse, this, true);
				} else if (node instanceof HTMLElement) {
					if (this.close) {
						this.close = false;
						this.block.stack.push(['openElement', node, this.pos, this.length]);
					} else {
						this.close = true;
						this.block.stack.push(['closeElement', node, this.pos, this.length]);
						return new Frame(node.children, this, false);
					}
				} else {
					this.block.stack.push(['node', node, this.pos, this.length]);
				}
				this.pos--;
			}
			if (this.isBlock) {
				this.block.stack.push(['startTemplate', this.block.count]);
			}
			return null;
		};

		function ASTWalker(compiler) {
			this.compiler = compiler;
		}

		__exports__.ASTWalker = ASTWalker;// Walks tree backwards depth first so that child
		// templates can be push onto stack then popped
		// off for its parent.
		ASTWalker.prototype.visit = function (children) {
			var frame = new Frame(children, null, true), next;
			while (frame) {
				next = frame.next();
				if (next === null) {
					if (frame.isBlock) {
						this.send(frame.stack);
					}
					frame = frame.parent;
				} else {
					frame = next;
				}
			}
		};

		ASTWalker.prototype.send = function(stack) {
			var compiler = this.compiler, tuple, name;
			while(tuple = stack.pop()) {
				name = tuple.shift();
				compiler[name].apply(compiler, tuple);
			}
		};

		// compiler.startTemplate(childBlockCount);
		// compiler.endTemplate();
		// compiler.block(block, index, length);
		// compiler.openElement(element, index, length);
		// compiler.text(text, index, length);
		// compiler.closeElement(element, index, length);
		// compiler.node(node, index, length)
	});
define("htmlbars/compiler/attr",
	["htmlbars/compiler/utils","htmlbars/compiler/helpers","htmlbars/compiler/invoke","htmlbars/compiler/stack","htmlbars/compiler/quoting","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __dependency4__, __dependency5__, __exports__) {
		"use strict";
		var processOpcodes = __dependency1__.processOpcodes;
		var prepareHelper = __dependency2__.prepareHelper;
		var helper = __dependency3__.helper;
		var popStack = __dependency4__.popStack;
		var pushStack = __dependency4__.pushStack;
		var string = __dependency5__.string;
		var hash = __dependency5__.hash;
		var quotedArray = __dependency5__.quotedArray;

		function AttrCompiler() {}

		var attrCompiler = AttrCompiler.prototype;

		attrCompiler.compile = function(opcodes, options) {
			this.output = [];
			this.stackNumber = 0;
			this.stack = [];

			this.preamble();
			processOpcodes(this, opcodes);
			this.postamble();

			/*jshint evil:true*/
			return new Function('context', 'options', this.output.join("\n"));
		};

		attrCompiler.preamble = function() {
			this.push("var buffer = []");
		};

		attrCompiler.postamble = function() {
			this.push("return buffer.join('')");
		};

		attrCompiler.content = function(str) {
			this.push("buffer.push(" + string(str) +")");
		};

		attrCompiler.dynamic = function(parts, escaped) {
			this.push(helper('resolveInAttr', 'context', quotedArray(parts), 'buffer', 'options'));
		};

		attrCompiler.ambiguous = function(string, escaped) {
			this.push(helper('ambiguousAttr', 'context', quotedArray([string]), 'buffer', 'options'));
		};

		attrCompiler.helper = function(name, size, escaped) {
			var prepared = prepareHelper(this.stack, size);
			prepared.options.push('setAttribute:options.setAttribute');

			this.push(helper('helperAttr', 'context', string(name), prepared.args, 'buffer', hash(prepared.options)));
		};

		attrCompiler.appendText = function() {
			// noop
		};

		attrCompiler.program = function() {
			pushStack(this.stack, null);
			pushStack(this.stack, null);
		};

		attrCompiler.id = function(parts) {
			pushStack(this.stack, string('id'));
			pushStack(this.stack, string(parts[0]));
		};

		attrCompiler.literal = function(literal) {
			pushStack(this.stack, string(typeof literal));
			pushStack(this.stack, literal);
		};

		attrCompiler.string = function(str) {
			pushStack(this.stack, string('string'));
			pushStack(this.stack, string(str));
		};

		attrCompiler.stackLiteral = function(literal) {
			pushStack(this.stack, literal);
		};

		attrCompiler.push = function(string) {
			this.output.push(string + ";");
		};

		__exports__.AttrCompiler = AttrCompiler;
	});
define("htmlbars/compiler/compile",
	["htmlbars/compiler/pass1","htmlbars/compiler/pass2","exports"],
	function(__dependency1__, __dependency2__, __exports__) {
		"use strict";
		var Compiler1 = __dependency1__.Compiler1;
		var Compiler2 = __dependency2__.Compiler2;

		function compileAST(ast, options) {
			var compiler1 = new Compiler1(compileAST, options),
					compiler2 = new Compiler2(options);

			var opcodes = compiler1.compile(ast);
			return compiler2.compile(opcodes, {
				children: compiler1.children
			});
		}

		__exports__.compileAST = compileAST;
	});
define("htmlbars/compiler/elements",
	["exports"],
	function(__exports__) {
		"use strict";
		function pushElement(compiler) {
			return "element" + (++compiler.elementNumber);
		}

		__exports__.pushElement = pushElement;function popElement(compiler) {
			return "element" + (compiler.elementNumber--);
		}

		__exports__.popElement = popElement;function topElement(compiler) {
			return "element" + compiler.elementNumber;
		}
		__exports__.topElement = topElement;
	});
define("htmlbars/compiler/fragment",
	["htmlbars/compiler/utils","htmlbars/compiler/quoting","exports"],
	function(__dependency1__, __dependency2__, __exports__) {
		"use strict";
		var processOpcodes = __dependency1__.processOpcodes;
		var string = __dependency2__.string;

		function FragmentCompiler() {
			this.fn = null;
			this.depth = 0;
		}

		__exports__.FragmentCompiler = FragmentCompiler;FragmentCompiler.prototype.compile = function(opcodes) {
			this.depth = 0;
			this.fn =
				'function build() {\n' +
				'  var frag = el0 = dom.createDocumentFragment();\n';

			processOpcodes(this, opcodes);

			this.fn +=
				'  return frag;\n'+
				'}\n';

			return this.fn;
		};

		FragmentCompiler.prototype.openElement = function(tagName) {
			var el = 'el'+(++this.depth);
			this.fn += '  var '+el+' = dom.createElement('+string(tagName)+');\n';
		};

		FragmentCompiler.prototype.setAttribute = function(name, value) {
			var el = 'el'+this.depth;
			this.fn += '  dom.setAttribute('+el+','+string(name)+','+string(value)+');\n';
		};

		FragmentCompiler.prototype.text = function(str) {
			var el = 'el'+this.depth;
			this.fn += '  dom.appendText('+el+','+string(str)+');\n';
		};

		FragmentCompiler.prototype.closeElement = function() {
			var child = 'el'+(this.depth--);
			var el = 'el'+this.depth;
			this.fn += '  '+el+'.appendChild('+child+');\n';
		};
	});
define("htmlbars/compiler/fragment2",
	["htmlbars/compiler/utils","htmlbars/compiler/helpers","htmlbars/compiler/invoke","htmlbars/compiler/elements","htmlbars/compiler/stack","htmlbars/compiler/quoting","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __dependency4__, __dependency5__, __dependency6__, __exports__) {
		"use strict";
		/*jshint evil:true*/

		var processOpcodes = __dependency1__.processOpcodes;
		var prepareHelper = __dependency2__.prepareHelper;
		var call = __dependency3__.call;
		var helper = __dependency3__.helper;
		var pushElement = __dependency4__.pushElement;
		var popElement = __dependency4__.popElement;
		var topElement = __dependency4__.topElement;
		var pushStack = __dependency5__.pushStack;
		var popStack = __dependency5__.popStack;
		var string = __dependency6__.string;
		var quotedArray = __dependency6__.quotedArray;
		var hash = __dependency6__.hash;

		function Fragment2() {}

		var compiler2 = Fragment2.prototype;

		compiler2.compile = function(opcodeTree) {
			this.output = [];
			this.elementNumber = 0;

			this.output.push("return function template() {");
			this.preamble();
			processOpcodes(this, opcodeTree.opcodes);
			this.postamble();
			this.output.push("};");

			var childCompiler = new Fragment2();
			return {
				fn: new Function('dom', this.output.join("\n")),
				children: opcodeTree.children.map(function (opcodes) {
					return childCompiler.compile(opcodes);
				})
			};
		};

		compiler2.preamble = function() {
			this.push("var element0, el");
			this.push("var frag = element0 = dom.createDocumentFragment()");
		};

		compiler2.postamble = function() {
			this.output.push("return frag;");
		};

		compiler2.program = function(programId, inverseId) {
			pushStack(this.stack, inverseId);
			pushStack(this.stack, programId);
		};

		compiler2.content = function(str) {
			this.push(helper('appendText', this.el(), string(str)));
		};

		compiler2.push = function(string) {
			this.output.push(string + ";");
		};

		compiler2.el = function() {
			return topElement(this);
		};

		compiler2.openElement = function(tagName) {
			var elRef = pushElement(this);
			this.push("var " + elRef + " = el = " + call('dom.createElement', string(tagName)));
		};

		compiler2.setAttribute = function(name, value) {
			this.push(call('dom.setAttribute', 'el', string(name), string(value)));
		};

		compiler2.closeElement = function() {
			var elRef = popElement(this);
			this.push(call([this.el(), 'appendChild'], elRef));
		};

		__exports__.Fragment2 = Fragment2;
	});
define("htmlbars/compiler/fragment_opcode",
	["./ast_walker","exports"],
	function(__dependency1__, __exports__) {
		"use strict";
		var ASTWalker = __dependency1__.ASTWalker;

		function FragmentOpcodeCompiler() {
			this.opcodes = [];
		}

		FragmentOpcodeCompiler.prototype.compile = function(ast) {
			var astWalker = new ASTWalker(this);
			astWalker.visit(ast);
			return this.opcodes;
		};

		FragmentOpcodeCompiler.prototype.opcode = function(type, params) {
			this.opcodes.push([type, params]);
		};

		FragmentOpcodeCompiler.prototype.text = function(string) {
			this.opcode('text', [string]);
		};

		FragmentOpcodeCompiler.prototype.openElement = function(element) {
			this.opcode('openElement', [element.tag]);

			element.attributes.forEach(function(attribute) {
				this.attribute(attribute);
			}, this);
		};

		FragmentOpcodeCompiler.prototype.closeElement = function(element) {
			this.opcode('closeElement', [element.tag]);
		};

		FragmentOpcodeCompiler.prototype.startTemplate = function() {
			this.opcodes.length = 0;
		};

		FragmentOpcodeCompiler.prototype.endTemplate = function() {};

		FragmentOpcodeCompiler.prototype.node = function () {};

		FragmentOpcodeCompiler.prototype.block = function () {};

		FragmentOpcodeCompiler.prototype.attribute = function(attribute) {
			var name = attribute[0], value = attribute[1];
			if (value.length === 1 && typeof value[0] === 'string') {
				this.opcode('setAttribute', [name, value[0]]);
			}
		};

		__exports__.FragmentOpcodeCompiler = FragmentOpcodeCompiler;
	});
define("htmlbars/compiler/helpers",
	["htmlbars/compiler/quoting","exports"],
	function(__dependency1__, __exports__) {
		"use strict";
		var array = __dependency1__.array;
		var hash = __dependency1__.hash;
		var string = __dependency1__.string;

		function prepareHelper(stack, size) {
			var args = [],
					types = [],
					hashPairs = [],
					hashTypes = [],
					keyName,
					i;

			var hashSize = stack.pop();

			for (i=0; i<hashSize; i++) {
				keyName = stack.pop();
				hashPairs.unshift(keyName + ':' + stack.pop());
				hashTypes.unshift(keyName + ':' + stack.pop());
			}

			for (i=0; i<size; i++) {
				args.unshift(stack.pop());
				types.unshift(stack.pop());
			}

			var programId = stack.pop();
			var inverseId = stack.pop();

			var options = ['types:' + array(types), 'hashTypes:' + hash(hashTypes), 'hash:' + hash(hashPairs)];

			if (programId !== null) {
				options.push('render:child' + programId);
			}

			if (inverseId !== null) {
				options.push('inverse:child' + inverseId);
			}

			return {
				options: options,
				args: array(args),
			};
		}

		__exports__.prepareHelper = prepareHelper;
	});
define("htmlbars/compiler/hydration",
	["htmlbars/compiler/utils","htmlbars/compiler/helpers","htmlbars/compiler/quoting","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __exports__) {
		"use strict";
		var processOpcodes = __dependency1__.processOpcodes;
		var prepareHelper = __dependency2__.prepareHelper;
		var string = __dependency3__.string;
		var quotedArray = __dependency3__.quotedArray;
		var hash = __dependency3__.hash;
		var array = __dependency3__.array;

		function HydrationCompiler() {
			this.stack = [];
			this.mustaches = [];
		}

		var prototype = HydrationCompiler.prototype;

		prototype.compile = function(opcodes, childTemplates) {
			this.stack.length = 0;
			this.mustaches.length = 0;

			processOpcodes(this, opcodes);

			var fn =  'function hydrate(fragment) {\n';
			for (var i=0, l=childTemplates.length; i<l; i++) {
				fn +=   '  var child' + i + '=' + childTemplates[i] + ';\n';
			}
			fn +=     '  return [\n' +
								'  ' + this.mustaches.join(',\n  ') + '\n' +
								'  ];\n' +
								'}\n';

			return fn;
		};

		prototype.program = function(programId, inverseId) {
			this.stack.push(inverseId);
			this.stack.push(programId);
		};

		prototype.id = function(parts) {
			this.stack.push(string('id'));
			this.stack.push(string(parts.join('.')));
		};

		prototype.literal = function(literal) {
			this.stack.push(string(typeof literal));
			this.stack.push(literal);
		};

		prototype.stringLiteral = function(str) {
			this.stack.push(string('string'));
			this.stack.push(string(str));
		};

		prototype.stackLiteral = function(literal) {
			this.stack.push(literal);
		};

		prototype.helper = function(name, size, escaped, parentPath, startIndex, endIndex) {
			var prepared = prepareHelper(this.stack, size);
			prepared.options.push('escaped:'+escaped);
			this.pushMustacheRange(string(name), prepared.args, prepared.options, parentPath, startIndex, endIndex);
		};

		prototype.ambiguous = function(str, escaped, parentPath, startIndex, endIndex) {
			this.pushMustacheRange(string(str), 'null', ['escaped:'+escaped], parentPath, startIndex, endIndex);
		};

		prototype.ambiguousAttr = function(str, escaped) {
			this.stack.push('['+string(str)+', null, {escaped:'+escaped+'}]');
		};

		prototype.helperAttr = function(name, size, escaped, elementPath) {
			var prepared = prepareHelper(this.stack, size);
			prepared.options.push('escaped:'+escaped);

			this.stack.push('['+string(name)+','+prepared.args+','+ hash(prepared.options)+']');
		};

		prototype.string = function(str) {
			this.stack.push(string(str));
		};

		prototype.attribute = function(name, size, elementPath) {
			var args = [];
			for (var i = 0; i < size; i++) {
				args.push(this.stack.pop());
			}

			var element = "fragment";
			for (i=0; i<elementPath.length; i++) {
				element += ".childNodes["+elementPath[i]+"]";
			}
			var pairs = ['element:'+element, 'name:'+string(name)];
			this.mustaches.push('["ATTRIBUTE", ['+ args +'],'+hash(pairs)+']');
		};

		prototype.nodeHelper = function(name, size, elementPath) {
			var prepared = prepareHelper(this.stack, size);
			this.pushMustacheInNode(string(name), prepared.args, prepared.options, elementPath);
		};

		prototype.pushMustacheRange = function(name, args, pairs, parentPath, startIndex, endIndex) {
			var parent = "fragment";
			for (var i=0; i<parentPath.length; i++) {
				parent += ".childNodes["+parentPath[i]+"]";
			}
			var range = "Range.create("+parent+","+
				(startIndex === null ? "null" : startIndex)+","+
				(endIndex === null ? "null" : endIndex)+")";

			pairs.push('range:'+range);

			this.mustaches.push('['+name+','+args+','+hash(pairs)+']');
		};

		prototype.pushMustacheInNode = function(name, args, pairs, elementPath) {
			var element = "fragment";
			for (var i=0; i<elementPath.length; i++) {
				element += ".childNodes["+elementPath[i]+"]";
			}
			pairs.push('element:'+element);
			this.mustaches.push('['+name+','+args+','+hash(pairs)+']');
		};

		__exports__.HydrationCompiler = HydrationCompiler;
	});
define("htmlbars/compiler/hydration2",
	["htmlbars/compiler/utils","htmlbars/compiler/helpers","htmlbars/compiler/invoke","htmlbars/compiler/stack","htmlbars/compiler/quoting","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __dependency4__, __dependency5__, __exports__) {
		"use strict";
		/*jshint evil:true*/

		var processOpcodes = __dependency1__.processOpcodes;
		var prepareHelper = __dependency2__.prepareHelper;
		var call = __dependency3__.call;
		var helper = __dependency3__.helper;
		var pushStack = __dependency4__.pushStack;
		var popStack = __dependency4__.popStack;
		var string = __dependency5__.string;
		var quotedArray = __dependency5__.quotedArray;
		var hash = __dependency5__.hash;
		var array = __dependency5__.array;

		function Hydration2() {}

		var prototype = Hydration2.prototype;

		prototype.compile = function(opcodeTree) {
			this.output = [];
			this.stack = [];

			this.output.push("return function hydrate(fragment, childTemplates) {");

			this.mustaches = [];

			processOpcodes(this, opcodeTree.opcodes);

			this.output.push("return [\n"+this.mustaches.join(",\n")+"\n];");
			this.output.push("};");

			var childCompiler = new Hydration2();

			return {
				fn: new Function("Range", this.output.join("\n")),
				children: opcodeTree.children.map(function (opcodes) {
					return childCompiler.compile(opcodes);
				})
			};
		};

		prototype.push = function(string) {
			this.output.push(string + ";");
		};

		prototype.program = function(programId, inverseId) {
			this.stack.push(inverseId);
			this.stack.push(programId);
		};

		prototype.id = function(parts) {
			pushStack(this.stack, string('id'));
			pushStack(this.stack, string(parts.join('.')));
		};

		prototype.literal = function(literal) {
			pushStack(this.stack, string(typeof literal));
			pushStack(this.stack, literal);
		};

		prototype.stackLiteral = function(literal) {
			pushStack(this.stack, literal);
		};

		prototype.string = function(str) {
			pushStack(this.stack, string('string'));
			pushStack(this.stack, string(str));
		};

		prototype.content = function(str) {
			pushStack(this.stack, string(str));
		};

		prototype.helper = function(name, size, escaped, parentPath, startIndex, endIndex) {
			var prepared = prepareHelper(this.stack, size);
			prepared.options.push('escaped:'+escaped);
			this.pushMustacheRange(string(name), prepared.args, prepared.options, parentPath, startIndex, endIndex);
		};

		prototype.ambiguous = function(str, escaped, parentPath, startIndex, endIndex) {
			this.pushMustacheRange(string(str), 'null', ['escaped:'+escaped], parentPath, startIndex, endIndex);
		};

		prototype.ambiguousAttr = function(str, escaped) {
			pushStack(this.stack, '['+string(str)+', null, {escaped:'+escaped+'}]');
		};

		prototype.helperAttr = function(name, size, escaped, elementPath) {
			var prepared = prepareHelper(this.stack, size);
			prepared.options.push('escaped:'+escaped);

			pushStack(this.stack, '['+string(name)+','+prepared.args+','+ hash(prepared.options)+']');
		};

		prototype.attribute = function(name, size, elementPath) {
			var args = [];
			for (var i = 0; i < size; i++) {
				args.unshift(popStack(this.stack));
			}

			var element = "fragment";
			for (i=0; i<elementPath.length; i++) {
				element += ".childNodes["+elementPath[i]+"]";
			}
			var pairs = ['element:'+element, 'name:'+string(name)];
			this.mustaches.push('["ATTRIBUTE", ['+ args +'],'+hash(pairs)+']');
		};

		prototype.nodeHelper = function(name, size, elementPath) {
			var prepared = prepareHelper(this.stack, size);
			this.pushMustacheInNode(string(name), prepared.args, prepared.options, elementPath);
		};

		prototype.pushMustacheRange = function(name, args, pairs, parentPath, startIndex, endIndex) {
			var parent = "fragment";
			for (var i=0; i<parentPath.length; i++) {
				parent += ".childNodes["+parentPath[i]+"]";
			}
			var range = "Range.create("+parent+","+
				(startIndex === null ? "null" : startIndex)+","+
				(endIndex === null ? "null" : endIndex)+")";

			pairs.push('range:'+range);

			this.mustaches.push('['+name+','+args+','+hash(pairs)+']');
		};

		prototype.pushMustacheInNode = function(name, args, pairs, elementPath) {
			var element = "fragment";
			for (var i=0; i<elementPath.length; i++) {
				element += ".childNodes["+elementPath[i]+"]";
			}
			pairs.push('element:'+element);
			this.mustaches.push('['+name+','+args+','+hash(pairs)+']');
		};

		__exports__.Hydration2 = Hydration2;
	});
define("htmlbars/compiler/hydration_attr",
	["htmlbars/compiler/utils","htmlbars/compiler/helpers","htmlbars/compiler/invoke","htmlbars/compiler/stack","htmlbars/compiler/quoting","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __dependency4__, __dependency5__, __exports__) {
		"use strict";
		var processOpcodes = __dependency1__.processOpcodes;
		var prepareHelper = __dependency2__.prepareHelper;
		var helper = __dependency3__.helper;
		var popStack = __dependency4__.popStack;
		var pushStack = __dependency4__.pushStack;
		var string = __dependency5__.string;
		var hash = __dependency5__.hash;
		var quotedArray = __dependency5__.quotedArray;

		function HydrationAttrCompiler() {}

		var attrCompiler = HydrationAttrCompiler.prototype;

		attrCompiler.compile = function(opcodes, options) {
			this.output = [];
			this.stackNumber = 0;
			this.stack = [];

			// this.preamble();
			processOpcodes(this, opcodes);
			// this.postamble();

			/*jshint evil:true*/
			return opcodes;
		};

		attrCompiler.content = function(str) {
			pushStack(this.stack, string('string'));
			pushStack(this.stack, string(str));
		};

		attrCompiler.ambiguous = function(str, escaped) {
			pushStack(this.stack, string('string'));
			pushStack(this.stack, string(str));

			// this.push(helper('ambiguousAttr', 'context', quotedArray([string]), 'buffer', 'options'));
		};

		attrCompiler.helper = function(name, size, escaped) {
			var prepared = prepareHelper(this.stack, size);
			prepared.options.push('setAttribute:options.setAttribute');

			this.push(helper('helperAttr', 'context', string(name), prepared.args, 'buffer', hash(prepared.options)));
		};

		attrCompiler.appendText = function() {
			// noop
		};

		attrCompiler.program = function() {
			pushStack(this.stack, null);
			pushStack(this.stack, null);
		};

		attrCompiler.id = function(parts) {
			pushStack(this.stack, string('id'));
			pushStack(this.stack, string(parts[0]));
		};

		attrCompiler.literal = function(literal) {
			pushStack(this.stack, string(typeof literal));
			pushStack(this.stack, literal);
		};

		attrCompiler.string = function(str) {
			pushStack(this.stack, string('string'));
			pushStack(this.stack, string(str));
		};

		attrCompiler.stackLiteral = function(literal) {
			pushStack(this.stack, literal);
		};

		attrCompiler.push = function(string) {
			this.output.push(string + ";");
		};

		__exports__.HydrationAttrCompiler = HydrationAttrCompiler;
	});
define("htmlbars/compiler/hydration_opcode",
	["./ast_walker","exports"],
	function(__dependency1__, __exports__) {
		"use strict";
		var ASTWalker = __dependency1__.ASTWalker;

		function HydrationOpcodeCompiler() {
			this.opcodes = [];
			this.paths = [];
			this.templateId = 0;
			this.currentDOMChildIndex = 0;
		}

		HydrationOpcodeCompiler.prototype.compile = function(ast) {
			var astWalker = new ASTWalker(this);
			astWalker.visit(ast);
			return this.opcodes;
		};

		HydrationOpcodeCompiler.prototype.startTemplate = function() {
			this.opcodes.length = 0;
			this.paths.length = 0;
			this.templateId = 0;
			this.currentDOMChildIndex = -1;
		};

		HydrationOpcodeCompiler.prototype.endTemplate = function() {};

		HydrationOpcodeCompiler.prototype.text = function(string) {
			++this.currentDOMChildIndex;
		};

		HydrationOpcodeCompiler.prototype.openElement = function(element) {
			this.paths.push(++this.currentDOMChildIndex);
			this.currentDOMChildIndex = -1;

			element.attributes.forEach(function(attribute) {
				this.attribute(attribute);
			}, this);

			element.helpers.forEach(function(helper) {
				this.nodeHelper(helper);
			}, this);
		};

		HydrationOpcodeCompiler.prototype.closeElement = function(element) {
			this.currentDOMChildIndex = this.paths.pop();
		};

		HydrationOpcodeCompiler.prototype.node = function (node, childIndex, childrenLength) {
			this[node.type](node, childIndex, childrenLength);
		};

		HydrationOpcodeCompiler.prototype.block = function(block, childIndex, childrenLength) {
			var currentDOMChildIndex = this.currentDOMChildIndex,
					mustache = block.helper;

			var start = (currentDOMChildIndex < 0 ? null : currentDOMChildIndex),
					end = (childIndex === childrenLength - 1 ? null : currentDOMChildIndex + 1);

			this.opcode('program', this.templateId++, this.templateId++);
			processParams(this, mustache.params);
			processHash(this, mustache.hash);
			this.opcode('helper', mustache.id.string, mustache.params.length, mustache.escaped, this.paths.slice(), start, end);
		};

		HydrationOpcodeCompiler.prototype.opcode = function(type) {
			var params = [].slice.call(arguments, 1);
			this.opcodes.push([type, params]);
		};

		HydrationOpcodeCompiler.prototype.attribute = function(attribute) {
			var name = attribute[0], value = attribute[1];

			if (value.length === 0 || (value.length === 1 && typeof value[0] === 'string')) {
				return;
			}

			var node;
			for (var i = value.length - 1; i >= 0; i--) {
				node = value[i];

				if (typeof node === 'string') {
					this.string(node);
				} else {
					this[node.type + 'InAttr'](node);
				}
			}

			this.opcode('attribute', name, value.length, this.paths.slice());
		};

		HydrationOpcodeCompiler.prototype.nodeHelper = function(mustache) {
			this.opcode('program', null, null);
			processParams(this, mustache.params);
			processHash(this, mustache.hash);
			this.opcode('nodeHelper', mustache.id.string, mustache.params.length, this.paths.slice());
		};

		HydrationOpcodeCompiler.prototype.mustache = function(mustache, childIndex, childrenLength) {
			var currentDOMChildIndex = this.currentDOMChildIndex;

			var start = (currentDOMChildIndex < 0 ? null : currentDOMChildIndex),
					end = (childIndex === childrenLength - 1 ? null : currentDOMChildIndex + 1);

			if (mustache.isHelper) {
				this.opcode('program', null, null);
				processParams(this, mustache.params);
				processHash(this, mustache.hash);
				this.opcode('helper', mustache.id.string, mustache.params.length, mustache.escaped, this.paths.slice(), start, end);
			} else {
				this.opcode('ambiguous', mustache.id.string, mustache.escaped, this.paths.slice(), start, end);
			}
		};

		HydrationOpcodeCompiler.prototype.string = function(str) {
			this.opcode('string', str);
		};

		HydrationOpcodeCompiler.prototype.mustacheInAttr = function(mustache) {
			if (mustache.isHelper) {
				this.opcode('program', null, null);
				processParams(this, mustache.params);
				processHash(this, mustache.hash);
				this.opcode('helperAttr', mustache.id.string, mustache.params.length, mustache.escaped);
			} else {
				this.opcode('ambiguousAttr', mustache.id.string, mustache.escaped);
			}
		};

		HydrationOpcodeCompiler.prototype.ID = function(id) {
			this.opcode('id', id.parts);
		};

		HydrationOpcodeCompiler.prototype.STRING = function(string) {
			this.opcode('stringLiteral', string.stringModeValue);
		};

		HydrationOpcodeCompiler.prototype.BOOLEAN = function(boolean) {
			this.opcode('literal', boolean.stringModeValue);
		};

		HydrationOpcodeCompiler.prototype.INTEGER = function(integer) {
			this.opcode('literal', integer.stringModeValue);
		};

		function processParams(compiler, params) {
			params.forEach(function(param) {
				compiler[param.type](param);
			});
		}

		function processHash(compiler, hash) {
			if (hash) {
				hash.pairs.forEach(function(pair) {
					var name = pair[0], param = pair[1];
					compiler[param.type](param);
					compiler.opcode('stackLiteral', name);
				});
				compiler.opcode('stackLiteral', hash.pairs.length);
			} else {
				compiler.opcode('stackLiteral', 0);
			}
		}

		__exports__.HydrationOpcodeCompiler = HydrationOpcodeCompiler;
	});
define("htmlbars/compiler/invoke",
	["exports"],
	function(__exports__) {
		"use strict";
		function call(func) {
			if (typeof func.join === 'function') {
				func = func.join('.');
			}

			var params = [].slice.call(arguments, 1);
			return func + "(" + params.join(", ") + ")";
		}

		__exports__.call = call;

		function helper() {
			var args = [].slice.call(arguments, 0);
			args[0] = 'dom.' + args[0];
			return call.apply(this, args);
		}
		__exports__.helper = helper;
	});
define("htmlbars/compiler/pass1",
	["htmlbars/utils","htmlbars/ast","htmlbars/compiler/attr","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __exports__) {
		"use strict";
		var merge = __dependency1__.merge;
		var HTMLElement = __dependency2__.HTMLElement;
		var BlockElement = __dependency2__.BlockElement;
		var AttrCompiler = __dependency3__.AttrCompiler;

		function compileAttr(ast, options) {
			var compiler1 = new Compiler1(options),
					attrCompiler = new AttrCompiler(options);

			var opcodes = compiler1.compile(ast);
			return attrCompiler.compile(opcodes);
		}

		function Compiler1(compileAST, options) {
			this.compileAST = compileAST;
			this.options = options || {};

			var knownHelpers = {
				'helperMissing': true,
				'blockHelperMissing': true,
				'each': true,
				'if': true,
				'unless': true,
				'with': true,
				'log': true
			};

			this.options.knownHelpers = this.options.knownHelpers || {};
			merge(knownHelpers, this.options.knownHelpers);
		}

		var compiler1 = Compiler1.prototype;

		compiler1.compile = function(ast) {
			this.opcodes = [];
			this.opcodes2 = [];
			this.paths = [];
			this.children = [];
			processChildren(this, ast);
			return this.opcodes;
		};

		function processChildren(compiler, children) {
			var node, lastNode, currentDOMChildIndex = -1;

			for (var i=0, l=children.length; i<l; i++) {
				node = children[i];

				if (typeof node === 'string') {
					++currentDOMChildIndex;
					compiler.string(node);
				} else if (node instanceof HTMLElement) {
					compiler.paths.push(++currentDOMChildIndex);
					compiler.element(node);
					compiler.paths.pop();
				} else if (node instanceof BlockElement) {
					compiler.block(node);
				} else {
					if (lastNode && lastNode.type === node.type) {
						++currentDOMChildIndex;
						compiler.string();
					}
					compiler[node.type](node, i, l, currentDOMChildIndex);
				}

				lastNode = node;
			}
		}

		compiler1.block = function(block) {
			var program = this.compileAST(block.children, this.options),
					inverse = this.compileAST(block.inverse, this.options),
					mustache = block.helper;

			this.children.push(program);
			var programId = this.children.length - 1;

			this.children.push(inverse);
			var inverseId = this.children.length - 1;

			this.opcode('program', programId, inverseId);
			processParams(this, mustache.params);
			processHash(this, mustache.hash);
			this.opcode('helper', mustache.id.string, mustache.params.length, mustache.escaped);
			this.opcode('appendFragment');
		};

		compiler1.opcode = function(type) {
			var params = [].slice.call(arguments, 1);
			this.opcodes.push({ type: type, params: params });
		};

		compiler1.opcode2 = function() {
			var params = [].slice.call(arguments);
			this.opcodes2.push(params);
		};

		compiler1.string = function(string) {
			this.opcode('content', string);
		};

		compiler1.element = function(element) {
			this.opcode('openElement', element.tag);

			element.attributes.forEach(function(attribute) {
				this.attribute(attribute);
			}, this);

			element.helpers.forEach(function(helper) {
				this.nodeHelper(helper);
			}, this);

			processChildren(this, element.children);

			this.opcode('closeElement');
		};

		compiler1.attribute = function(attribute) {
			var name = attribute[0],
					value = attribute[1];

			var program = compileAttr(value);
			this.children.push(program);

			this.opcode('attribute', name, this.children.length - 1);
			return;
		};

		compiler1.nodeHelper = function(mustache) {
			this.opcode('program', null);
			processParams(this, mustache.params);
			processHash(this, mustache.hash);
			this.opcode('nodeHelper', mustache.id.string, mustache.params.length);
		};

		compiler1.mustache = function(mustache, childIndex, childrenLength, currentDOMChildIndex) {
			var type = classifyMustache(mustache, this.options);

			if (type === 'simple') {
				this.opcode('dynamic', mustache.id.parts, mustache.escaped);
			} else if (type === 'ambiguous') {
				this.opcode('ambiguous', mustache.id.string, mustache.escaped);
			} else {
				this.opcode('program', null);
				processParams(this, mustache.params);
				processHash(this, mustache.hash);
				this.opcode('helper', mustache.id.string, mustache.params.length, mustache.escaped);
			}

			var start = (currentDOMChildIndex < 0 ? null : currentDOMChildIndex),
					end = (childIndex === childrenLength - 1 ? null : currentDOMChildIndex + 1);
			this.opcode2(mustache.id.string, this.paths.slice(), start, end);

			appendMustache(this, mustache);
		};

		compiler1.ID = function(id) {
			this.opcode('id', id.parts);
		};

		compiler1.STRING = function(string) {
			this.opcode('string', string.stringModeValue);
		};

		compiler1.BOOLEAN = function(boolean) {
			this.opcode('literal', boolean.stringModeValue);
		};

		compiler1.INTEGER = function(integer) {
			this.opcode('literal', integer.stringModeValue);
		};

		function classifyMustache(mustache, options) {
			var isHelper   = mustache.isHelper;
			var isEligible = mustache.eligibleHelper;

			// if ambiguous, we can possibly resolve the ambiguity now
			if (isEligible && !isHelper) {
				var name = mustache.id.parts[0];

				if (options.knownHelpers[name]) {
					isHelper = true;
				} else if (options.knownHelpersOnly) {
					isEligible = false;
				}
			}

			if (isHelper) { return "helper"; }
			else if (isEligible) { return "ambiguous"; }
			else { return "simple"; }
		}

		function processParams(compiler, params) {
			params.forEach(function(param) {
				compiler[param.type](param);
			});
		}

		function processHash(compiler, hash) {
			if (hash) {
				hash.pairs.forEach(function(pair) {
					var name = pair[0], param = pair[1];
					compiler[param.type](param);
					compiler.opcode('stackLiteral', name);
				});
				compiler.opcode('stackLiteral', hash.pairs.length);
			} else {
				compiler.opcode('stackLiteral', 0);
			}
		}

		function appendMustache(compiler, mustache) {
			if (mustache.escaped) {
				compiler.opcode('appendText');
			} else {
				compiler.opcode('appendHTML');
			}
		}

		__exports__.Compiler1 = Compiler1;
	});
define("htmlbars/compiler/pass2",
	["htmlbars/compiler/utils","htmlbars/compiler/helpers","htmlbars/compiler/invoke","htmlbars/compiler/elements","htmlbars/compiler/stack","htmlbars/compiler/quoting","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __dependency4__, __dependency5__, __dependency6__, __exports__) {
		"use strict";
		/*jshint evil:true*/

		var processOpcodes = __dependency1__.processOpcodes;
		var prepareHelper = __dependency2__.prepareHelper;
		var call = __dependency3__.call;
		var helper = __dependency3__.helper;
		var pushElement = __dependency4__.pushElement;
		var popElement = __dependency4__.popElement;
		var topElement = __dependency4__.topElement;
		var pushStack = __dependency5__.pushStack;
		var popStack = __dependency5__.popStack;
		var string = __dependency6__.string;
		var quotedArray = __dependency6__.quotedArray;
		var hash = __dependency6__.hash;

		function Compiler2() {}

		var compiler2 = Compiler2.prototype;

		compiler2.compile = function(opcodes, options) {
			this.output = [];
			this.elementNumber = 0;
			this.stackNumber = 0;
			this.stack = [];
			this.children = options.children;

			this.output.push("return function template(context, options) {");
			this.preamble();
			processOpcodes(this, opcodes);
			this.postamble();
			this.output.push("};");

			// console.debug(this.output.join("\n"));

			// have the generated function close over the DOM helpers
			return new Function('dom', this.output.join("\n"));
		};

		compiler2.preamble = function() {
			this.children.forEach(function(child, i) {
				this.push("var child" + i + " = " + child.toString());
			}, this);

			this.push("var element0, el");
			this.push("var frag = element0 = dom.createDocumentFragment()");
		};

		compiler2.postamble = function() {
			this.output.push("return frag;");
		};

		compiler2.program = function(programId, inverseId) {
			pushStack(this.stack, inverseId);
			pushStack(this.stack, programId);
		};

		compiler2.content = function(str) {
			this.push(helper('appendText', this.el(), string(str)));
		};

		compiler2.push = function(string) {
			this.output.push(string + ";");
		};

		compiler2.el = function() {
			return topElement(this);
		};

		compiler2.id = function(parts) {
			pushStack(this.stack, string('id'));
			pushStack(this.stack, quotedArray(parts));
		};

		compiler2.literal = function(literal) {
			pushStack(this.stack, string(typeof literal));
			pushStack(this.stack, literal);
		};

		compiler2.stackLiteral = function(literal) {
			pushStack(this.stack, literal);
		};

		compiler2.string = function(str) {
			pushStack(this.stack, string('string'));
			pushStack(this.stack, string(str));
		};

		compiler2.appendText = function() {
			this.push(helper('appendText', this.el(), popStack(this.stack)));
		};

		compiler2.appendHTML = function() {
			this.push(helper('appendHTML', this.el(), popStack(this.stack)));
		};

		compiler2.appendFragment = function() {
			this.push(helper('appendFragment', this.el(), popStack(this.stack)));
		};

		compiler2.openElement = function(tagName) {
			var elRef = pushElement(this);
			this.push("var " + elRef + " = el = " + call('dom.createElement', string(tagName)));
		};

		compiler2.attribute = function(name, child) {
			var invokeSetAttribute = call(['el', 'setAttribute'], string(name), 'value');
			var setAttribute = 'function setAttribute(value) { ' + invokeSetAttribute + '}';
			var options = hash(['setAttribute:' + setAttribute]);
			pushStack(this.stack, call('child' + child, 'context', options));

			this.push(call('dom.setAttribute', 'el', string(name), popStack(this.stack), hash(['context:context'])));
		};

		compiler2.closeElement = function() {
			var elRef = popElement(this);
			this.push(call([this.el(), 'appendChild'], elRef));
		};

		compiler2.dynamic = function(parts, escaped) {
			pushStack(this.stack, helper('resolveContents', 'context', quotedArray(parts), this.el(), escaped));
		};

		compiler2.ambiguous = function(str, escaped) {
			pushStack(this.stack, helper('ambiguousContents', this.el(), 'context', string(str), escaped));
		};

		compiler2.helper = function(name, size, escaped) {
			var prepared = prepareHelper(this.stack, size);
			pushStack(this.stack, helper('helperContents', string(name), this.el(), 'context', prepared.args, hash(prepared.options)));
		};

		compiler2.nodeHelper = function(name, size) {
			var prepared = prepareHelper(this.stack, size);
			this.push(helper('helperContents', string(name), this.el(), 'context', prepared.args, hash(prepared.options)));
		};

		__exports__.Compiler2 = Compiler2;
	});
define("htmlbars/compiler/quoting",
	["exports"],
	function(__exports__) {
		"use strict";
		function escapeString(str) {
			return str.replace(/'/g, "\\'");
		}

		__exports__.escapeString = escapeString;

		function string(str) {
			return "'" + escapeString(str) + "'";
		}

		__exports__.string = string;

		function array(a) {
			if (a.length === 0) { return "null"; }
			return "[" + a + "]";
		}

		__exports__.array = array;

		function quotedArray(list) {
			return array(list.map(string).join(", "));
		}

		__exports__.quotedArray = quotedArray;function hash(pairs) {
			if (pairs.length === 0) { return "null"; }
			return "{" + pairs.join(",") + "}";
		}

		__exports__.hash = hash;
	});
define("htmlbars/compiler/stack",
	["exports"],
	function(__exports__) {
		"use strict";
		// this file exists in anticipation of a more involved
		// stack implementation involving temporary variables

		function pushStack(stack, literal) {
			stack.push(literal);
		}

		__exports__.pushStack = pushStack;function popStack(stack) {
			return stack.pop();
		}

		__exports__.popStack = popStack;
	});
define("htmlbars/compiler/template",
	["./fragment_opcode","./fragment","./hydration_opcode","./hydration","./ast_walker","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __dependency4__, __dependency5__, __exports__) {
		"use strict";
		var FragmentOpcodeCompiler = __dependency1__.FragmentOpcodeCompiler;
		var FragmentCompiler = __dependency2__.FragmentCompiler;
		var HydrationOpcodeCompiler = __dependency3__.HydrationOpcodeCompiler;
		var HydrationCompiler = __dependency4__.HydrationCompiler;
		var ASTWalker = __dependency5__.ASTWalker;

		function TemplateCompiler() {
			this.fragmentOpcodeCompiler = new FragmentOpcodeCompiler();
			this.fragmentCompiler = new FragmentCompiler();
			this.hydrationOpcodeCompiler = new HydrationOpcodeCompiler();
			this.hydrationCompiler = new HydrationCompiler();
			this.templates = [];
			this.childTemplates = [];
		}

		__exports__.TemplateCompiler = TemplateCompiler;TemplateCompiler.prototype.compile = function(ast) {
			var astWalker = new ASTWalker(this);
			astWalker.visit(ast);
			return this.templates.pop();
		};

		TemplateCompiler.prototype.startTemplate = function(childCount) {
			this.fragmentOpcodeCompiler.startTemplate();
			this.hydrationOpcodeCompiler.startTemplate();

			this.childTemplates.length = 0;
			while(childCount--) {
				this.childTemplates.push(this.templates.pop());
			}
		};

		TemplateCompiler.prototype.endTemplate = function() {
			this.fragmentOpcodeCompiler.endTemplate();
			this.hydrationOpcodeCompiler.endTemplate();

			// function build(dom) { return fragment; }
			var fragmentProgram = this.fragmentCompiler.compile(
				this.fragmentOpcodeCompiler.opcodes
			);

			// function hydrate(fragment) { return mustaches; }
			var hydrationProgram = this.hydrationCompiler.compile(
				this.hydrationOpcodeCompiler.opcodes, this.childTemplates
			);

			var template =
				'(function (){\n' +
					fragmentProgram +
					hydrationProgram +
				'var cachedFragment = null;\n' +
				'return function template(context, options) {\n' +
				'  if (cachedFragment === null) {\n' +
				'    cachedFragment = build(dom);\n' +
				'  }\n' +
				'  var clone = cachedFragment.cloneNode(true);\n' +
				'  var mustaches = hydrate(clone);\n' +
				'  var helpers = options && options.helpers || {};\n' +
				'  var mustache;\n' +
				'  for (var i = 0, l = mustaches.length; i < l; i++) {\n' +
				'    mustache = mustaches[i];\n' +
				'    var name = mustache[0],\n' +
				'        params = mustache[1],\n' +
				'        helperOptions = mustache[2];\n' +
				'    helperOptions.helpers = helpers;\n' +
				'    helperOptions.data = options && options.data;\n' +
				'    if (!helperOptions.element) {\n' +
				'      helperOptions.element = helperOptions.range;\n' +
				'    }\n' +
				'    if (name === "ATTRIBUTE") {\n' +
				'      helpers.ATTRIBUTE(context, helperOptions.name, params, helperOptions);\n' +
				'    } else {\n' +
				'      helpers.RESOLVE(context, name, params, helperOptions);\n' +
				'    }\n' +
				'  }\n' +
				'  return clone;\n' +
				'};\n' +
				'}())';

			this.templates.push(template);
		};

		TemplateCompiler.prototype.openElement = function(element, i, l) {
			this.fragmentOpcodeCompiler.openElement(element, i, l);
			this.hydrationOpcodeCompiler.openElement(element, i, l);
		};

		TemplateCompiler.prototype.closeElement = function(element, i, l) {
			this.fragmentOpcodeCompiler.closeElement(element, i, l);
			this.hydrationOpcodeCompiler.closeElement(element, i, l);
		};

		TemplateCompiler.prototype.block = function(block, i, l) {
			this.fragmentOpcodeCompiler.block(block, i, l);
			this.hydrationOpcodeCompiler.block(block, i, l);
		};

		TemplateCompiler.prototype.text = function(string, i, l) {
			this.fragmentOpcodeCompiler.text(string, i, l);
			this.hydrationOpcodeCompiler.text(string, i, l);
		};

		TemplateCompiler.prototype.node = function (node, i, l) {
			this.fragmentOpcodeCompiler.node(node, i, l);
			this.hydrationOpcodeCompiler.node(node, i, l);
		};
	});
define("htmlbars/compiler/utils",
	["exports"],
	function(__exports__) {
		"use strict";
		function processOpcodes(compiler, opcodes) {
			for (var i=0, l=opcodes.length; i<l; i++) {
				var method = opcodes[i][0];
				var params = opcodes[i][1];
				compiler[method].apply(compiler, params);
			}
		}

		__exports__.processOpcodes = processOpcodes;
	});
define("htmlbars/helpers",
	["exports"],
	function(__exports__) {
		"use strict";
		var helpers = {};

		function registerHelper(name, callback) {
			helpers[name] = callback;
		}

		__exports__.registerHelper = registerHelper;function removeHelper(name) {
			delete helpers[name];
		}

		__exports__.removeHelper = removeHelper;__exports__.helpers = helpers;
	});
define("htmlbars/html-parser/process-token",
	["htmlbars/ast","simple-html-tokenizer","exports"],
	function(__dependency1__, __dependency2__, __exports__) {
		"use strict";
		var HTMLElement = __dependency1__.HTMLElement;
		var BlockElement = __dependency1__.BlockElement;
		var Chars = __dependency2__.Chars;
		var StartTag = __dependency2__.StartTag;
		var EndTag = __dependency2__.EndTag;

		/**
			@param {String} state the current state of the tokenizer
			@param {Array} stack the element stack
			@token {Token} token the current token being built
			@child {Token|Mustache|Block} child the new token to insert into the AST
		*/
		function processToken(state, stack, token, child, macros) {
			// EOF
			if (child === undefined) { return; }
			return handlers[child.type](child, currentElement(stack), stack, token, state, macros);
		}

		__exports__.processToken = processToken;function currentElement(stack) {
			return stack[stack.length - 1];
		}

		// This table maps from the state names in the tokenizer to a smaller
		// number of states that control how mustaches are handled
		var states = {
			"attributeValueDoubleQuoted": "attr",
			"attributeValueSingleQuoted": "attr",
			"attributeValueUnquoted": "attr",
			"beforeAttributeName": "in-tag"
		};

		var voidTagNames = "area base br col command embed hr img input keygen link meta param source track wbr";
		var voidMap = {};

		voidTagNames.split(" ").forEach(function(tagName) {
			voidMap[tagName] = true;
		});

		// Except for `mustache`, all tokens are only allowed outside of
		// a start or end tag.
		var handlers = {
			Chars: function(token, current) {
				current.appendChild(token.chars);
			},

			StartTag: function(tag, current, stack) {
				var element = new HTMLElement(tag.tagName, tag.attributes, [], tag.helpers);
				stack.push(element);

				if (voidMap.hasOwnProperty(tag.tagName)) {
					this.EndTag(tag, element, stack);
				}
			},

			block: function(block, current, stack) {
				stack.push(new BlockElement(block.mustache));
			},

			mustache: function(mustache, current, stack, token, state) {
				switch(states[state]) {
					case "attr":
						token.addToAttributeValue(mustache);
						return;
					case "in-tag":
						token.addTagHelper(mustache);
						return;
					default:
						current.appendChild(mustache);
				}
			},

			EndTag: function(tag, current, stack, token, state, macros) {
				if (current.tag !== tag.tagName) {
					throw new Error("Closing tag " + tag.tagName + " did not match last open tag " + current.tag);
				}

				var value = config.processHTMLMacros(current, macros);
				stack.pop();

				if (value === 'veto') { return; }

				var parent = currentElement(stack);
				parent.appendChild(value || current);
			}
		};

		var config = {
			processHTMLMacros: function() {}
		};

		__exports__.config = config;
	});
define("htmlbars/macros",
	["htmlbars/html-parser/process-token","htmlbars/ast","exports"],
	function(__dependency1__, __dependency2__, __exports__) {
		"use strict";
		var config = __dependency1__.config;
		var HTMLElement = __dependency2__.HTMLElement;

		var htmlMacros = {};

		function registerMacro(name, test, mutate) {
			htmlMacros[name] = { test: test, mutate: mutate };
		}

		__exports__.registerMacro = registerMacro;function removeMacro(name) {
			delete htmlMacros[name];
		}

		__exports__.removeMacro = removeMacro;function processHTMLMacros(element, macros) {
			var mutated, newElement;

			macros = macros || htmlMacros;

			for (var prop in htmlMacros) {
				var macro = htmlMacros[prop];
				if (macro.test(element)) {
					newElement = macro.mutate(element);
					if (newElement === undefined) { newElement = element; }
					mutated = true;
					break;
				}
			}

			if (!mutated) {
				return element;
			} else if (newElement instanceof HTMLElement) {
				return processHTMLMacros(newElement);
			} else {
				return newElement;
			}
		}

		// configure the HTML Parser
		config.processHTMLMacros = processHTMLMacros;
	});
define("htmlbars/parser",
	["simple-html-tokenizer","htmlbars/ast","htmlbars/html-parser/process-token","handlebars","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __dependency4__, __exports__) {
		"use strict";
		var Tokenizer = __dependency1__.Tokenizer;
		var Chars = __dependency1__.Chars;
		var StartTag = __dependency1__.StartTag;
		var EndTag = __dependency1__.EndTag;
		var HTMLElement = __dependency2__.HTMLElement;
		var BlockElement = __dependency2__.BlockElement;
		var processToken = __dependency3__.processToken;
		var Handlebars = __dependency4__["default"];

		function Visitor() {}

		Visitor.prototype = {
			constructor: Visitor,

			accept: function(node) {
				return this[node.type](node);
			}
		};

		function preprocess(html, options) {
			var ast = Handlebars.parse(html);
			return new HTMLProcessor(options || {}).accept(ast);
		}

		__exports__.preprocess = preprocess;function HTMLProcessor(options) {
			// document fragment
			this.elementStack = [new HTMLElement()];
			this.tokenizer = new Tokenizer('');
			this.macros = options.macros;
		}

		// TODO: ES3 polyfill
		var processor = HTMLProcessor.prototype = Object.create(Visitor.prototype);

		processor.program = function(program) {
			var statements = program.statements;

			for (var i=0, l=statements.length; i<l; i++) {
				this.accept(statements[i]);
			}

			process(this, this.tokenizer.tokenizeEOF());

			// return the children of the top-level document fragment
			return this.elementStack[0].children;
		};

		processor.block = function(block) {
			switchToHandlebars(this);

			process(this, block);

			if (block.program) {
				this.accept(block.program);
			}

			this.tokenizer.token = null;
			this.elementStack.push(new BlockElement());

			if (block.inverse) {
				this.accept(block.inverse);
			}

			var inverse = this.elementStack.pop();
			var blockNode = this.elementStack.pop();

			blockNode.inverse = inverse.children;

			var el = currentElement(this),
					len = el.children.length,
					lastNode;

			if (len > 0) {
				lastNode = el.children[len - 1];
			}

			// Back to back BlockElements need an empty text node delimiter
			if (lastNode && blockNode instanceof BlockElement && lastNode instanceof BlockElement) {
				el.children.push('');
			}

			el.children.push(blockNode);
		};

		processor.content = function(content) {
			var tokens = this.tokenizer.tokenizePart(content.string);

			return tokens.forEach(function(token) {
				process(this, token);
			}, this);
		};

		processor.mustache = function(mustache) {
			switchToHandlebars(this);

			process(this, mustache);
		};

		function switchToHandlebars(compiler) {
			var token = compiler.tokenizer.token;

			// TODO: Monkey patch Chars.addChar like attributes
			if (token instanceof Chars) {
				process(compiler, token);
				compiler.tokenizer.token = null;
			}
		}

		function process(compiler, token) {
			var tokenizer = compiler.tokenizer;
			processToken(tokenizer.state, compiler.elementStack, tokenizer.token, token, compiler.macros);
		}

		function currentElement(processor) {
			var elementStack = processor.elementStack;
			return elementStack[elementStack.length - 1];
		}

		StartTag.prototype.addToAttributeValue = function(char) {
			var value = this.currentAttribute[1] = this.currentAttribute[1] || [];

			if (value.length && typeof value[value.length - 1] === 'string' && typeof char === 'string') {
				value[value.length - 1] += char;
			} else {
				value.push(char);
			}
		};

		StartTag.prototype.addTagHelper = function(helper) {
			var helpers = this.helpers = this.helpers || [];

			helpers.push(helper);
		};
	});
define("htmlbars/runtime",
	["htmlbars/runtime/dom_helpers","htmlbars/runtime/range","exports"],
	function(__dependency1__, __dependency2__, __exports__) {
		"use strict";
		var domHelpers = __dependency1__.domHelpers;
		var Range = __dependency2__.Range;

		function hydrate(spec, options) {
			return spec(domHelpers(options && options.extensions), Range);
		}

		__exports__.hydrate = hydrate;
	});
define("htmlbars/runtime/dom_helpers",
	["htmlbars/utils","exports"],
	function(__dependency1__, __exports__) {
		"use strict";
		var merge = __dependency1__.merge;

		function domHelpers(extensions) {
			var base = {
				appendText: function(element, text) {
					element.appendChild(document.createTextNode(text));
				},

				setAttribute: function(element, name, value) {
					element.setAttribute(name, value);
				},

				createElement: function(tagName) {
					return document.createElement(tagName);
				},

				createDocumentFragment: function() {
					return document.createDocumentFragment();
				}
			};

			return extensions ? merge(extensions, base) : base;
		}

		__exports__.domHelpers = domHelpers;
	});
define("htmlbars/runtime/helpers",
	["exports"],
	function(__exports__) {
		"use strict";
		function RESOLVE(context, path, params, options) {
			var helper = options.helpers[path];
			if (helper) {
				var ret = helper(context, params, options);
				if (ret) {
					options.range.appendText(ret);
				}
			} else {
				var value = context[path];

				options.range.clear();
				if (options.escaped) {
					options.range.appendText(value);
				} else {
					options.range.appendHTML(value);
				}
			}
		}

		__exports__.RESOLVE = RESOLVE;function RESOLVE_IN_ATTR(context, path, params, options) {
			var helpers = options.helpers,
					helper = helpers[path];

			if (helper) {
				return helper(context, params, options);
			} else {
				return context[path];
			}
		}

		__exports__.RESOLVE_IN_ATTR = RESOLVE_IN_ATTR;function ATTRIBUTE(context, name, params, options) {

			var helpers = options.helpers,
					buffer = [];

			params.forEach(function(node) {
				if (typeof node === 'string') {
					buffer.push(node);
				} else {
					var helperOptions = node[2];
					helperOptions.helpers = helpers;
					var ret = helpers.RESOLVE_IN_ATTR(context, node[0], node[1], helperOptions);
					if (ret) { buffer.push(ret); }
				}
			});

			if (buffer.length) {
				options.element.setAttribute(name, buffer.join(''));
			}
		}

		__exports__.ATTRIBUTE = ATTRIBUTE;
	});
define("htmlbars/runtime/range",
	["exports"],
	function(__exports__) {
		"use strict";
		function Range(parent, start, end) {
			// if fragment, we need to ensure start and end
			// to track where we get inserted to
			if (parent.nodeType === 11) {
				if (start === null) {
					start = parent.ownerDocument.createTextNode('');
					parent.insertBefore(start, parent.firstChild);
				}
				if (end === null) {
					end = parent.ownerDocument.createTextNode('');
					parent.insertBefore(end, null);
				}
			}

			this.parent = parent;
			this.start = start;
			this.end = end;
		}

		__exports__.Range = Range;Range.create = function (parent, startIndex, endIndex) {
			var start = startIndex === null ? null : parent.childNodes[startIndex],
					end = endIndex === null ? null : parent.childNodes[endIndex];
			return new Range(parent, start, end);
		};

		Range.prototype = {
			checkParent: function () {
				if (this.parent !== this.start.parentNode) {
					this.parent = this.start.parentNode;
				}
			},
			clear: function() {
				if (this.parent.nodeType === 11) this.checkParent();

				var parent = this.parent,
						start = this.start,
						end = this.end,
						current, previous;

				if (end === null) {
					current = parent.lastChild;
				} else {
					current = end.previousSibling;
				}

				while (current !== null && current !== start) {
					previous = current.previousSibling;
					parent.removeChild(current);
					current = previous;
				}
			},
			replace: function(node) {
				this.clear();
				this.parent.insertBefore(node, this.end);
			},
			appendChild: function(node) {
				if (this.parent.nodeType === 11) this.checkParent();

				this.parent.insertBefore(node, this.end);
			},
			appendChildren: function(nodeList) {
				if (this.parent.nodeType === 11) this.checkParent();

				var parent = this.parent,
						ref = this.end,
						i = nodeList.length,
						node;
				while (i--) {
					node = nodeList[i];
					parent.insertBefore(node, ref);
					ref = node;
				}
			},
			appendText: function (str) {
				this.start.nodeValue = str;
				// if (this.parent.nodeType === 11) this.checkParent();

				// var parent = this.parent;
				// parent.insertBefore(parent.ownerDocument.createTextNode(str), this.end);
			},
			appendHTML: function (html) {
				if (this.parent.nodeType === 11) this.checkParent();

				var parent = this.parent, element;
				if (parent.nodeType === 11) {
					/* TODO require templates always have a contextual element
						 instead of element0 = frag */
					element = parent.ownerDocument.createElement('div');
				} else {
					element = parent.cloneNode(false);
				}
				element.innerHTML = html;
				this.appendChildren(element.childNodes);
			}
		};
	});
define("htmlbars/utils",
	["exports"],
	function(__exports__) {
		"use strict";
		function merge(options, defaults) {
			for (var prop in defaults) {
				if (options.hasOwnProperty(prop)) { continue; }
				options[prop] = defaults[prop];
			}
			return options;
		}

		__exports__.merge = merge;
	});
define("simple-html-tokenizer",
	["exports"],
	function(__exports__) {
		"use strict";
		/*jshint boss:true*/

		var objectCreate = Object.create || function(obj) {
			function F() {}
			F.prototype = obj;
			return new F();
		};

		function isSpace(char) {
			return (/[\n\r\t ]/).test(char);
		}

		function isAlpha(char) {
			return (/[A-Za-z]/).test(char);
		}

		function Tokenizer(input) {
			this.input = input;
			this.char = 0;
			this.state = 'data';
			this.token = null;
		}

		Tokenizer.prototype = {
			tokenize: function() {
				var tokens = [], token;

				while (true) {
					token = this.lex();
					if (token === 'EOF') { break; }
					if (token) { tokens.push(token); }
				}

				if (this.token) {
					tokens.push(this.token);
				}

				return tokens;
			},

			tokenizePart: function(string) {
				this.input += string;
				var tokens = [], token;

				while (this.char < this.input.length) {
					token = this.lex();
					if (token) { tokens.push(token); }
				}

				this.tokens = (this.tokens || []).concat(tokens);
				return tokens;
			},

			tokenizeEOF: function() {
				if (this.token) {
					return this.token;
				}
			},

			tag: function(Type, char) {
				char = char.toLowerCase();

				var lastToken = this.token;
				this.token = new Type(char);
				this.state = 'tagName';
				return lastToken;
			},

			selfClosing: function() {
				this.token.selfClosing = true;
			},

			attribute: function(char) {
				this.token.startAttribute(char);
				this.state = 'attributeName';
			},

			addToAttributeName: function(char) {
				this.token.addToAttributeName(char.toLowerCase());
			},

			addToAttributeValue: function(char) {
				this.token.addToAttributeValue(char);
			},

			commentStart: function() {
				var lastToken = this.token;
				this.token = new CommentToken();
				this.state = 'commentStart';
				return lastToken;
			},

			addToComment: function(char) {
				this.token.addChar(char);
			},

			emitData: function() {
				var lastToken = this.token;
				this.token = null;
				this.state = 'tagOpen';
				return lastToken;
			},

			emitToken: function() {
				var lastToken = this.token.finalize();
				this.token = null;
				this.state = 'data';
				return lastToken;
			},

			addData: function(char) {
				if (this.token === null) {
					this.token = new Chars();
				}

				this.token.addChar(char);
			},

			lex: function() {
				var char = this.input.charAt(this.char++);

				if (char) {
					// console.log(this.state, char);
					return this.states[this.state].call(this, char);
				} else {
					return 'EOF';
				}
			},

			states: {
				data: function(char) {
					if (char === "<") {
						return this.emitData();
					} else {
						this.addData(char);
					}
				},

				tagOpen: function(char) {
					if (char === "!") {
						this.state = 'markupDeclaration';
					} else if (char === "/") {
						this.state = 'endTagOpen';
					} else if (!isSpace(char)) {
						return this.tag(StartTag, char);
					}
				},

				markupDeclaration: function(char) {
					if (char === "-" && this.input[this.char] === "-") {
						this.char++;
						this.commentStart();
					}
				},

				commentStart: function(char) {
					if (char === "-") {
						this.state = 'commentStartDash';
					} else if (char === ">") {
						return this.emitToken();
					} else {
						this.addToComment(char);
						this.state = 'comment';
					}
				},

				commentStartDash: function(char) {
					if (char === "-") {
						this.state = 'commentEnd';
					} else if (char === ">") {
						return this.emitToken();
					} else {
						this.addToComment("-");
						this.state = 'comment';
					}
				},

				comment: function(char) {
					if (char === "-") {
						this.state = 'commentEndDash';
					} else {
						this.addToComment(char);
					}
				},

				commentEndDash: function(char) {
					if (char === "-") {
						this.state = 'commentEnd';
					} else {
						this.addToComment('-' + char);
						this.state = 'comment';
					}
				},

				commentEnd: function(char) {
					if (char === ">") {
						return this.emitToken();
					}
				},

				tagName: function(char) {
					if (isSpace(char)) {
						this.state = 'beforeAttributeName';
					} else if(/[A-Za-z]/.test(char)) {
						this.token.addToTagName(char);
					} else if (char === ">") {
						return this.emitToken();
					}
				},

				beforeAttributeName: function(char) {
					if (isSpace(char)) {
						return;
					} else if (char === "/") {
						this.state = 'selfClosingStartTag';
					} else if (char === ">") {
						return this.emitToken();
					} else {
						this.attribute(char);
					}
				},

				attributeName: function(char) {
					if (isSpace(char)) {
						this.state = 'afterAttributeName';
					} else if (char === "/") {
						this.state = 'selfClosingStartTag';
					} else if (char === "=") {
						this.state = 'beforeAttributeValue';
					} else if (char === ">") {
						return this.emitToken();
					} else {
						this.addToAttributeName(char);
					}
				},

				beforeAttributeValue: function(char) {
					if (isSpace(char)) {
						return;
					} else if (char === '"') {
						this.state = 'attributeValueDoubleQuoted';
					} else if (char === "'") {
						this.state = 'attributeValueSingleQuoted';
					} else if (char === ">") {
						return this.emitToken();
					} else {
						this.state = 'attributeValueUnquoted';
						this.addToAttributeValue(char);
					}
				},

				attributeValueDoubleQuoted: function(char) {
					if (char === '"') {
						this.state = 'afterAttributeValueQuoted';
					} else {
						this.addToAttributeValue(char);
					}
				},

				attributeValueSingleQuoted: function(char) {
					if (char === "'") {
						this.state = 'afterAttributeValueQuoted';
					} else {
						this.addToAttributeValue(char);
					}
				},

				attributeValueUnquoted: function(char) {
					if (isSpace(char)) {
						this.state = 'beforeAttributeName';
					} else if (char === ">") {
						return this.emitToken();
					} else {
						this.addToAttributeValue(char);
					}
				},

				afterAttributeValueQuoted: function(char) {
					if (isSpace(char)) {
						this.state = 'beforeAttributeName';
					} else if (char === "/") {
						this.state = 'selfClosingStartTag';
					} else if (char === ">") {
						return this.emitToken();
					} else {
						this.char--;
						this.state = 'beforeAttributeName';
					}
				},

				selfClosingStartTag: function(char) {
					if (char === ">") {
						this.selfClosing();
						return this.emitToken();
					} else {
						this.char--;
						this.state = 'beforeAttributeName';
					}
				},

				endTagOpen: function(char) {
					if (isAlpha(char)) {
						this.tag(EndTag, char);
					}
				}
			}
		};

		function Tag(tagName, attributes, options) {
			this.tagName = tagName || "";
			this.attributes = attributes || [];
			this.selfClosing = options ? options.selfClosing : false;
		}

		Tag.prototype = {
			constructor: Tag,

			addToTagName: function(char) {
				this.tagName += char;
			},

			startAttribute: function(char) {
				this.currentAttribute = [char.toLowerCase(), null];
				this.attributes.push(this.currentAttribute);
			},

			addToAttributeName: function(char) {
				this.currentAttribute[0] += char;
			},

			addToAttributeValue: function(char) {
				this.currentAttribute[1] = this.currentAttribute[1] || "";
				this.currentAttribute[1] += char;
			},

			finalize: function() {
				delete this.currentAttribute;
				return this;
			}
		};

		function StartTag() {
			Tag.apply(this, arguments);
		}

		StartTag.prototype = objectCreate(Tag.prototype);
		StartTag.prototype.type = 'StartTag';
		StartTag.prototype.constructor = StartTag;

		StartTag.prototype.toHTML = function() {
			return config.generateTag(this);
		};

		function generateTag(tag) {
			var out = "<";
			out += tag.tagName;

			if (tag.attributes.length) {
				out += " " + config.generateAttributes(tag.attributes);
			}

			out += ">";

			return out;
		}

		function generateAttributes(attributes) {
			var out = [], attribute, attrString, value;

			for (var i=0, l=attributes.length; i<l; i++) {
				attribute = attributes[i];

				out.push(config.generateAttribute.apply(this, attribute));
			}

			return out.join(" ");
		}

		function generateAttribute(name, value) {
			var attrString = name;

			if (value) {
				value = value.replace(/"/, '\\"');
				attrString += "=\"" + value + "\"";
			}

			return attrString;
		}

		function EndTag() {
			Tag.apply(this, arguments);
		}

		EndTag.prototype = objectCreate(Tag.prototype);
		EndTag.prototype.type = 'EndTag';
		EndTag.prototype.constructor = EndTag;

		EndTag.prototype.toHTML = function() {
			var out = "</";
			out += this.tagName;
			out += ">";

			return out;
		};

		function Chars(chars) {
			this.chars = chars || "";
		}

		Chars.prototype = {
			type: 'Chars',
			constructor: Chars,

			addChar: function(char) {
				this.chars += char;
			},

			toHTML: function() {
				return this.chars;
			}
		};

		function CommentToken() {
			this.chars = "";
		}

		CommentToken.prototype = {
			type: 'CommentToken',
			constructor: CommentToken,

			finalize: function() { return this; },

			addChar: function(char) {
				this.chars += char;
			},

			toHTML: function() {
				return "<!--" + this.chars + "-->";
			}
		};

		function tokenize(input) {
			var tokenizer = new Tokenizer(input);
			return tokenizer.tokenize();
		}

		function generate(tokens) {
			var output = "";

			for (var i=0, l=tokens.length; i<l; i++) {
				output += tokens[i].toHTML();
			}

			return output;
		}

		var config = {
			generateAttributes: generateAttributes,
			generateAttribute: generateAttribute,
			generateTag: generateTag
		};

		var original = {
			generateAttributes: generateAttributes,
			generateAttribute: generateAttribute,
			generateTag: generateTag
		};

		function configure(name, value) {
			config[name] = value;
		}

		__exports__.Tokenizer = Tokenizer;
		__exports__.tokenize = tokenize;
		__exports__.generate = generate;
		__exports__.configure = configure;
		__exports__.original = original;
		__exports__.StartTag = StartTag;
		__exports__.EndTag = EndTag;
		__exports__.Chars = Chars;
		__exports__.CommentToken = CommentToken;
	});
//
//# sourceMappingURL=htmlbars-0.1.0.amd.js.map
})();



(function() {
define("bound-templates",
	["htmlbars/compiler","bound-templates/stream","bound-templates/runtime","htmlbars/utils","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __dependency4__, __exports__) {
		"use strict";
		var htmlbarsCompile = __dependency1__.compile;
		var Stream = __dependency2__.Stream;
		var RESOLVE = __dependency3__.RESOLVE;
		var RESOLVE_IN_ATTR = __dependency3__.RESOLVE_IN_ATTR;
		var ATTRIBUTE = __dependency3__.ATTRIBUTE;
		var merge = __dependency4__.merge;

		function compile(string, options) {
			return htmlbarsCompile(string, options);
		}

		__exports__.compile = compile;__exports__.Stream = Stream;
	});

define("bound-templates/compiler",
	["htmlbars/runtime","htmlbars/utils","bound-templates/stream","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __exports__) {
		"use strict";
		var hydrateTemplate = __dependency1__.hydrate;
		var merge = __dependency2__.merge;
		var whenChanged = __dependency3__.whenChanged;

		function resolveHTML(model, parts, options) {
			var stream = new options.dom.PathObserver(model, parts.join(".")),
					range = new Range(options.element, options.dom);

			range.bind('innerHTML', stream);
			options.dom.appendRange(options.element, range);
		}

		var defaultHelpers = {
			RESOLVE: function(parts, options) {
				if (!options.escaped) {
					return resolveHTML(this, parts, options);
				}

				var stream = new options.dom.PathObserver(this, parts.join(".")),
						textNode = new options.dom.TextNode("");

				textNode.bind('textContent', stream);
				options.append(textNode);
			},

			RESOLVE_IN_ATTR: function(parts, options) {
				return new options.dom.PathObserver(this, parts.join("."));
			}
		};

		function hydrate(spec, options) {
			options = options || {};

			var helpers = options.helpers = options.helpers || {};
			var extensions = options.extension = options.extensions || {};

			merge(helpers, defaultHelpers);
			merge(extensions, defaultExtensions);

			return hydrateTemplate(spec, options);
		}

		__exports__.hydrate = hydrate;
	});

define("bound-templates/runtime",
	["bound-templates/stream","exports"],
	function(__dependency1__, __exports__) {
		"use strict";
		var Stream = __dependency1__["default"];

		function streamifyArgs(context, params, options) {
			var helpers = options.helpers;

			// Convert ID params to streams
			if (params)
				for (var i = 0, l = params.length; i < l; i++) {
					if (options.types[i] === 'id') {
						params[i] = helpers.STREAM_FOR(context, params[i]);
					}
				}

			// Convert hash ID values to streams
			var hash = options.hash,
					hashTypes = options.hashTypes;
			if (hash) {
				for (var key in hash) {
					if (hashTypes[key] === 'id') {
						hash[key] = helpers.STREAM_FOR(context, hash[key]);
					}
				}
			}
		}

		function RESOLVE(context, path, params, options) {
			var helpers = options.helpers,
					helper = helpers[path];
			if (helper) {
				streamifyArgs(context, params, options);

				var fragmentStream = helper(params, options);
				if (fragmentStream) {
					fragmentStream.subscribe(function(value) {
						options.range.replace(value);
					});
				}
			} else {
				var stream = helpers.STREAM_FOR(context, path);

				stream.subscribe(function(value) {
					options.range.clear();
					if (options.escaped) {
						options.range.appendText(value);
					} else {
						options.range.appendHTML(value);
					}
				});
			}
		}

		__exports__.RESOLVE = RESOLVE;// FIXME
		function AttributeBuilder() {
			var self = this;

			this.parts = [];
			this.values = [];
			this.next = null;

			this.stream = new Stream(function(next) {
				self.next = next;
			});
		}

		AttributeBuilder.prototype = {
			stream: null,

			string: function() {
				return this.values.join('');
			},

			pushStatic: function(value) {
				this.parts.push(value);
				this.values.push(value);
			},

			pushStream: function(stream) {
				var builder = this,
						streamIndex = this.parts.length;

				this.parts.push(stream);
				this.values.push('');

				stream.subscribe(function(value) {
					builder.updateValueAt(streamIndex, value);
				});
			},

			updateValueAt: function(streamIndex, value) {
				this.values[streamIndex] = value;
				this.next(this.string());
			},

			subscribe: function(next) {
				var unsubscribe = this.stream.subscribe.apply(this.stream, arguments);
				next(this.string());
				return unsubscribe;
			}
		};

		function ATTRIBUTE(context, name, params, options) {
			var helpers = options.helpers,
					builder = new AttributeBuilder(name); // TODO: make this hookable

			params.forEach(function(node) {
				if (typeof node === 'string') {
					builder.pushStatic(node);
				} else {
					var helperOptions = node[2];
					helperOptions.helpers = helpers;

					// TODO: support attributes returning more than streams
					var stream = helpers.RESOLVE_IN_ATTR(context, node[0], node[1], helperOptions);
					builder.pushStream(stream);
				}
			});

			builder.subscribe(function(value) {
				Ember.run.scheduleOnce('render', options.element, options.element.setAttribute, name, value);
			});
		}

		__exports__.ATTRIBUTE = ATTRIBUTE;function RESOLVE_IN_ATTR(context, path, params, options) {
			var helpers = options.helpers,
					helper = helpers[path];

			if (helper) {
				streamifyArgs(context, params, options);
				return helper(params, options);
			} else {
				return helpers.STREAM_FOR(context, path);
			}
		}

		__exports__.RESOLVE_IN_ATTR = RESOLVE_IN_ATTR;
	});

define("bound-templates/stream",
	["exports"],
	function(__exports__) {
		"use strict";
		/**
			@function Stream
			@param {Function[Next, Error, Complete]->void} callback

			Creates a new stream. Calls the callback with functions that will
			invoke the `next`, `error` and `complete` callbacks on subscribers.

			Example:

			```js
			var interval = new Stream(function(next, error, complete) {
				setInterval(function() {
					next("tick");
				}, 1000);
			});

			interval.subscribe(function(val) {
				// this will get triggered every second with the value "tick"
			});
			```

			The `subscribe` method on the newly created stream returns a function
			that can be used to unsubscribe.
		*/
		function Stream(callback) {
			var subscribers = [];

			function next(value) {
				subscribers.forEach(function(sub) { if (sub.next) sub.next(value); });
			}

			function complete() {
				subscribers.forEach(function(sub) { if (sub.complete) sub.complete(); });
			}

			function error(reason) {
				subscribers.forEach(function(sub) { if (sub.error) sub.error(reason); });
			}

			this.subscribe = function(next, error, complete) {
				var subscriber = { next: next, error: error, complete: complete };
				subscribers.push(subscriber);

				return function() {
					remove(subscribers, subscriber);
				};
			};

			callback.call(this, next, error, complete);
		}

		__exports__["default"] = Stream;

		function lazy(subscribeCallback) {
			return new Stream(function(next, error, complete) {
				var subscribe = this.subscribe;

				this.subscribe = function() {
					var unsubscribe = subscribe.apply(this, arguments);
					subscribeCallback(next, error, complete);
					return unsubscribe;
				};
			});
		}

		__exports__.lazy = lazy;function lifecycle(callbacks) {
			return new Stream(function(next, error, complete) {
				var subscribe = this.subscribe;

				var subscribers = 0;

				this.subscribe = function() {
					var unsubscribe = subscribe.apply(this, arguments);
					if (subscribers++ === 0) {
						callbacks.activate.call(this);
					}

					return function() {
						unsubscribe();
						if (--subscribers === 0) {
							callbacks.deactivate.call(this);
						}
					};
				};
			});
		}

		__exports__.lifecycle = lifecycle;function map(parent, callback, binding) {
			return lazy(function(next, error, complete) {
				parent.subscribe(function(value) {
					next(callback.call(binding, value));
				}, error, complete);
			});
		}

		__exports__.map = map;function currentValue(parent) {
			return lazy(function(next, error, complete) {
				var current;

				parent.subscribe(function(value) {
					current = value;
					next(value);
				}, error, complete);
			});
		}

		__exports__.currentValue = currentValue;function whenChanged(parent) {
			return lazy(function(next, error, complete) {
				var current;

				parent.subscribe(function(value) {
					if (current === value) return;

					current = value;
					next(value);
				}, error, complete);
			});
		}

		__exports__.whenChanged = whenChanged;function zipLatest(first, second, callback) {
			var subscriptions = [];
			var values = [], completed = [];

			var zipped = lazy(function(next, error, complete, subscription) {
				subscriptions.push(subscription);

				subscribe(first, 0);
				subscribe(second, 1);

				function subscribe(stream, position) {
					completed[position] = false;

					return stream.subscribe(function(value) {
						values[position] = value;
						next(values);
					}, error, function() {
						completed[position] = true;
						possiblyComplete();
					});
				}

				function possiblyComplete() {
					if (completed.every(function(value) { return value; })) complete();
				}
			});

			if (callback) {
				return map(zipped, function(values) {
					return callback.apply(this, values);
				});
			} else {
				return zipped;
			}
		}

		__exports__.zipLatest = zipLatest;function remove(array, object) {
			var index = array.indexOf(object);
			if (index === -1) return;
			array.splice(index, 1);
		}
	});
})();



(function() {
Ember.HTMLBars = Ember.HTMLBars || {};

var HTMLBars = requireModule('htmlbars'),
		BoundTemplates = requireModule('bound-templates');

var get = Ember.get,
		addObserver = Ember.addObserver,
		removeObserver = Ember.removeObserver;

var queues = Ember.run.queues,
		indexOf = Ember.ArrayPolyfills.indexOf;
queues.splice(indexOf.call(queues, 'actions')+1, 0, 'render', 'afterRender');

Ember.HTMLBars.compile = function(string, options) {
	return BoundTemplates.compile(string, options);
};

Ember.HTMLBars.STREAM_FOR = function STREAM_FOR(context, path) {
	if (context.isView) {
		return context.streamFor(path);
	} else {
		return new EmberObserverStream(context, path);
	}
};

function EmberObserverStream(obj, path) {
	this.obj = obj;
	this.path = path;

	addObserver(obj, path, this, 'didChange');
	this.lastValue = this.getValue();
}

EmberObserverStream.prototype = {
	obj: null,
	path: null,
	lastValue: null,

	next: null,
	error: null,
	complete: null,

	getValue: function() {
		return get(this.obj, this.path);
	},

	subscribe: function(next, error, complete) {
		this.next = next;
		this.error = error;
		this.complete = complete;

		next(this.lastValue);
	},

	didChange: function() {
		this.next(this.lastValue = this.getValue());
	},

	destroy: function() {
		removeObserver(this.obj, this.path, this, 'didChange');
		this.obj = this.path = this.lastValue = null;
		this.next = this.error = this.complete = null;
	}
};


// SimpleObservableArrayMixin: the insanely faster way of observing arrays
var SimpleObservableArrayMixin = Ember.Mixin.create({
	pushObject: function(obj) {
		this.replace(this.length, 0, [obj]);
	},

	replace: function(idx, amt, objects) {
		// if we replaced exactly the same number of items, then pass only the
		// replaced range. Otherwise, pass the full remaining array length
		// since everything has shifted
		var len = objects ? objects.length : 0;
		if (len === 0) {
			this.splice(idx, amt);
		} else {
			Ember.EnumerableUtils._replace(this, idx, amt, objects);
		}
		this.arrayContentDidChange(idx, amt, len);
		return this;
	},

	arrayContentDidChange: function(startIdx, removeAmt, addAmt) {
		// if no args are passed assume everything changes
		if (startIdx === undefined) {
			startIdx = 0;
			removeAmt = addAmt = -1;
		} else {
			if (removeAmt === undefined) removeAmt =- 1;
			if (addAmt    === undefined) addAmt =- 1;
		}

		Ember.sendEvent(this, '@array:change', [this, startIdx, removeAmt, addAmt]);

		// var length      = get(this, 'length'),
		//     cachedFirst = cacheFor(this, 'firstObject'),
		//     cachedLast  = cacheFor(this, 'lastObject');
		// if (this.objectAt(0) !== cachedFirst) {
		//   Ember.propertyWillChange(this, 'firstObject');
		//   Ember.propertyDidChange(this, 'firstObject');
		// }
		// if (this.objectAt(length-1) !== cachedLast) {
		//   Ember.propertyWillChange(this, 'lastObject');
		//   Ember.propertyDidChange(this, 'lastObject');
		// }

		return this;
	},

	addArrayObserver: function(target) {
		Ember.addListener(this, '@array:change', target, 'arrayDidChange');
		return this;
	},

	removeArrayObserver: function(target) {
		Ember.removeListener(this, '@array:change', target, 'arrayDidChange');
		return this;
	}
});

Ember.HTMLBars.A = function HTMLBarsA(arr) {
	if (typeof arr === 'undefined') { arr = []; }
	return SimpleObservableArrayMixin.detect(arr) ? arr : SimpleObservableArrayMixin.apply(arr);
};

var ArrayObserverStream = Ember.HTMLBars.ArrayObserverStream = function ArrayObserverStream(obj) {
	if (obj) { this.updateObj(obj); }
};

ArrayObserverStream.prototype = {
	obj: null,

	next: null,
	error: null,
	complete: null,

	updateObj: function(newObj) {
		newObj = Ember.HTMLBars.A(newObj);

		var oldLength = 0;
		if (this.obj) {
			oldLength = this.obj.length;
			this.obj.removeArrayObserver(this);
		}
		this.obj = newObj;
		if (newObj) { newObj.addArrayObserver(this); }
		this.arrayDidChange(newObj, 0, oldLength, newObj.length);
	},

	subscribe: function(next, error, complete) {
		this.next = next;
		this.error = error;
		this.complete = complete;

		// TODO: publish whole array?
		// next(this.lastValue);
	},

	arrayWillChange: function(content, start, removed, added) {},
	arrayDidChange: function(content, start, removed, added) {
		this.next({obj: content, start: start, removed: removed, added: added});
	},

	destroy: function() {
		this.updateObj(null);
		this.next = this.error = this.complete = null;
	}
};
})();



(function() {

})();



(function() {

})();



(function() {

})();



(function() {

})();



(function() {

})();



(function() {

})();



(function() {
// debugger
// loc
// log
})();



(function() {

})();



(function() {

})();



(function() {

})();



(function() {

})();



(function() {

})();



(function() {

})();



(function() {

})();



(function() {

})();



(function() {

})();



(function() {

})();



(function() {
var get = Ember.get,
		set = Ember.set;

var Range = requireModule('htmlbars/runtime/range').Range,
		Utils = Ember.Utils,
		finishChains = Ember.finishChains,
		META_KEY = Ember.META_KEY,
		GUID_KEY = Ember.GUID_KEY,
		viewGuid = 0;

var View = Ember.HTMLBars.View = function View(template, parentView, context) {
	this[GUID_KEY] = viewGuid++;
	this.parentView = parentView;
	this.context = context || parentView && parentView.context || this;
	this.template = template;
	// this.streams = {};
	// this.childViews = [];
	// this.classNames = this.classNames.slice();
	// Utils.inheritMeta(this);
	// finishChains(this);
};

var BoundTemplatesRuntime = requireModule('bound-templates/runtime');

var defaultOptions = {
	data: {view: null},

	helpers: {
		STREAM_FOR: Ember.HTMLBars.STREAM_FOR,
		RESOLVE: BoundTemplatesRuntime.RESOLVE,
		ATTRIBUTE: BoundTemplatesRuntime.ATTRIBUTE,
		RESOLVE_IN_ATTR: BoundTemplatesRuntime.RESOLVE_IN_ATTR,

		view: function(params, options) {
			options.data.view.createChildView(View, options.render);
		},

		each: function(params, options) {
			var view = options.data.view,
					template = function(context, templateOptions) {
						options.data = templateOptions.data;
						return options.render(context, options);
					},
					eachView = view.createChildView(EachView, template);

			eachView.element = options.element;
			eachView.templateData = options.data;

			params[0].subscribe(function(value) {
				eachView.arrayStream.updateObj(value);
			});
			// return eachView.arrayStream;
		}
	}
};

View.DEFAULT_TEMPLATE_OPTIONS = defaultOptions;

View.prototype = {
	isView: true,
	tagName: 'div',
	elementId: null,
	element: null,
	classNames: ['ember-view'],
	template: null,

	parentView: null,
	childViews: null,
	context: null,
	streams: null,

	toString: function() {
		return "<HTMLBars.View:" + this[GUID_KEY] + ">";
	},

	render: function(parentEl) {
		var templateOptions = {helpers: defaultOptions.helpers, data: {view: this}},
				fragment = this.template(this, templateOptions),
				childViews = this.childViews,
				classNames = this.classNames,
				childView, i, l;

		if (this.isVirtual) {
			return this._renderVirtual(parentEl, fragment, childViews);
		} else {
			var el = this.element = document.createElement(this.tagName);
			if (this.elementId) { el.setAttribute('id', this.elementId); }
			if (classNames && classNames.length === 1) {
				el.setAttribute('class', this.classNames[0]);
			} else if (classNames && classNames.length > 1) {
				el.setAttribute('class', this.classNames.join(' '));
			}

			el.appendChild(fragment);
			if (parentEl) { parentEl.appendChild(el); }
			if (!childViews) { return el; }
			for (i = 0, l = childViews.length; i < l; i++) {
				childView = childViews[i];
				childView.render(el);
			}
			return el;
		}
	},

	_renderVirtual: function(parentEl, fragment, childViews) {
		var range = new Range(parentEl.parent, fragment.firstChild, fragment.lastChild),
				childView, i, l;
		this.element = range;
		parentEl.appendChild(fragment);
		if (!childViews) { return parentEl; }
		for (i = 0, l = childViews.length; i < l; i++) {
			childView = childViews[i];
			childView.render(range);
		}
		return parentEl;
	},

	createChildView: function(ViewClass, template, context) {
		ViewClass = ViewClass || View;
		var childViews = this.childViews,
				childView = new ViewClass(template, this, context);
		if (!childViews) {
			childViews = this.childViews = [childView];
		} else {
			childViews.push(childView); // FIXME: this should be done by appendChild
		}
		return childView;
	},

	append: function() {
		document.body.appendChild(this.element);
	},

	appendTo: function(el) {
		el.appendChild(this.element);
	},

	streamFor: function(path) {
		var streams = this.streams;
		if (!streams) { streams = this.streams = {}; }
		var stream = streams[path];
		if (stream) { return stream; }
		stream = streams[path] = new ViewManagedStream();

		// handle {{this}} - comes through as empty string
		var context = path === '' ? this : this.context;
		path = path === '' ? 'context' : path;
		Ember.addObserver(context, path, this, 'streamPropertyDidChange');
		stream.next(get(context, path));
		return stream;
	},

	_previousContext: null, // used to avoid double looping streams
	contextWillChange: function() {
		this._previousContext = this.context;
	},

	contextDidChange: function() {
		var previousContext = this._previousContext,
				context = this.context,
				streams = this.streams,
				observerObj,
				observerPath;
		for (var path in streams) {
			observerObj = path === '' ? this : context;
			observerPath = path === '' ? 'context' : path;
			Ember.removeObserver((path === '' ? this : previousContext), observerPath, this, 'streamPropertyDidChange');
			Ember.addObserver(observerObj, observerPath, this, 'streamPropertyDidChange');
			streams[path].next(get(observerObj, observerPath));
		}
		this._previousContext = null;

		// Notifying children manually avoids chains, which saves us a lot of upfront work
		var childViews = this.childViews;
		if (!childViews) { return; }
		for (var i = 0, l = childViews.length; i < l; i++) {
			childViews[i].parentViewContextDidChange(context);
		}
	},

	streamPropertyDidChange: function(obj, path) {
		var streams = this.streams,
				stream = streams[(obj === this && path === 'context' ? '' : path)];
		stream.next(get(obj, path));
	},

	parentViewContextDidChange: function(parentContext) {
		set(this, 'context', parentContext);
	},

	destroy: function() {
		this.element = this.template = this.parentView = this.childViews = this.context = this.streams = null;
	}
};

// View.prototype[META_KEY] = Ember.platform.defineProperty(View.prototype, META_KEY, Ember.META_DESC);
// View.prototype[GUID_KEY] = Ember.platform.defineProperty(View.prototype, GUID_KEY, Ember.GUID_DESC);
View.prototype[META_KEY] = null;
View.prototype[GUID_KEY] = viewGuid++;
Ember.addBeforeObserver(View.prototype, 'context', null, 'contextWillChange');
Ember.addObserver(View.prototype, 'context', null, 'contextDidChange');
// Ember.addObserver(View.prototype, 'parentView.context', null, 'parentViewContextDidChange');

// Do we still need to do this if we're avoiding chains?
// View.prototype[Ember.META_KEY].proto = View.prototype;

// Turns out simple properties and observers wins perf wise over a CP for context
// Ember.defineProperty(View.prototype, 'context', Ember.computed(function(/*key, value*/) {
//   // if (arguments.length === 2) { return value; }
//   // TODO: controller
//   var parentView = this.parentView;
//   return get(parentView, 'context') || this;
// }));

var VirtualView = Ember.HTMLBars.VirtualView = function VirtualView(template, parentView, context) {
	View.call(this, template, parentView, context);
	this.isVirtual = true;
	this.tagName = null;
};

VirtualView.prototype = Object.create(View.prototype);

// Ember.merge(VirtualView.prototype, {
// });

var EachView = Ember.HTMLBars.EachView = function EachView(template, parentView, items) {
	var self = this;
	items = Ember.HTMLBars.A(items);
	View.call(this, template, parentView, items);
	this.arrayStream = new Ember.HTMLBars.ArrayObserverStream();
	this.arrayStream.subscribe(function(value) {
		Ember.run.schedule('render', self, 'arrayDidChange', value.obj, value.start, value.removed, value.added);
	});
	this.contextDidChange();
};

EachView.prototype = Object.create(View.prototype);

Ember.merge(EachView.prototype, {
	isVirtual: true,
	tagName: null,

	render: function(parentEl) {
		var el = this.element,
				childViews = this.childViews,
				childView;

		if (!childViews) { return; }
		for (var i = 0, l = childViews.length; i < l; i++) {
			childView = childViews[i];
			childView.render(el);
		}
	},

	createChildView: function(ViewClass, template, context) {
		ViewClass = ViewClass || View;
		var childView = new ViewClass(template, this, context);
		return childView;
	},

	contextWillChange: function() {},
	contextDidChange: function() {
		var context = this.context;
		if (context) {
			this.arrayStream.updateObj(context);
		}
	},

	// arrayWillChange: function(content, start, removed, added) {

	// },

	arrayDidChange: function(content, start, removed, added) {
		// teardown old views
		var childViews = this.childViews, childView, idx;

		if (childViews) {
			for (idx = start; idx < start+removed; idx++) {
				childView = childViews[idx];
				childView.element.clear();
				childView.destroy();
			}
		}

		var spliceArgs = childViews ? [start, removed] : new Array(added);

		for (idx = start; idx < start+added; idx++) {
			var item = content[idx];
			childView = this.createChildView(VirtualView, this.template, item);
			spliceArgs.push(childView);
			childView.render(this.element);
		}

		if (childViews) {
			childViews.splice.apply(childViews, spliceArgs);
		} else {
			this.childViews = spliceArgs;
		}
	}
});

function ViewManagedStream() {}

ViewManagedStream.prototype = {
	subscribers: null,
	lastValue: null,

	subscribe: function(next, error, complete) {
		var subscribers = this.subscribers,
				subscriber = { next: next, error: error, complete: complete };

		if (!subscribers) {
			subscribers = this.subscribers = [subscriber];
		} else {
			subscribers.push(subscriber);
		}

		next(this.lastValue);
	},

	next: function next(value) {
		var subscribers = this.subscribers,
				sub;
		this.lastValue = value;
		if (!subscribers) { return; }

		for (var i = 0, l = subscribers.length; i < l; i++) {
			sub = subscribers[i];
			if (sub.next) { sub.next(value); }
		}
	},

	complete: function complete() {
		this.subscribers.forEach(function(sub) { if (sub.complete) sub.complete(); });
	},

	error: function error(reason) {
		this.subscribers.forEach(function(sub) { if (sub.error) sub.error(reason); });
	}
};
})();



(function() {
// just for testing right now

})();

(function() {
define("route-recognizer",
	["exports"],
	function(__exports__) {
		"use strict";
		var specials = [
			'/', '.', '*', '+', '?', '|',
			'(', ')', '[', ']', '{', '}', '\\'
		];

		var escapeRegex = new RegExp('(\\' + specials.join('|\\') + ')', 'g');

		// A Segment represents a segment in the original route description.
		// Each Segment type provides an `eachChar` and `regex` method.
		//
		// The `eachChar` method invokes the callback with one or more character
		// specifications. A character specification consumes one or more input
		// characters.
		//
		// The `regex` method returns a regex fragment for the segment. If the
		// segment is a dynamic of star segment, the regex fragment also includes
		// a capture.
		//
		// A character specification contains:
		//
		// * `validChars`: a String with a list of all valid characters, or
		// * `invalidChars`: a String with a list of all invalid characters
		// * `repeat`: true if the character specification can repeat

		function StaticSegment(string) { this.string = string; }
		StaticSegment.prototype = {
			eachChar: function(callback) {
				var string = this.string, ch;

				for (var i=0, l=string.length; i<l; i++) {
					ch = string.charAt(i);
					callback({ validChars: ch });
				}
			},

			regex: function() {
				return this.string.replace(escapeRegex, '\\$1');
			},

			generate: function() {
				return this.string;
			}
		};

		function DynamicSegment(name) { this.name = name; }
		DynamicSegment.prototype = {
			eachChar: function(callback) {
				callback({ invalidChars: "/", repeat: true });
			},

			regex: function() {
				return "([^/]+)";
			},

			generate: function(params) {
				return params[this.name];
			}
		};

		function StarSegment(name) { this.name = name; }
		StarSegment.prototype = {
			eachChar: function(callback) {
				callback({ invalidChars: "", repeat: true });
			},

			regex: function() {
				return "(.+)";
			},

			generate: function(params) {
				return params[this.name];
			}
		};

		function EpsilonSegment() {}
		EpsilonSegment.prototype = {
			eachChar: function() {},
			regex: function() { return ""; },
			generate: function() { return ""; }
		};

		function parse(route, names, types) {
			// normalize route as not starting with a "/". Recognition will
			// also normalize.
			if (route.charAt(0) === "/") { route = route.substr(1); }

			var segments = route.split("/"), results = [];

			for (var i=0, l=segments.length; i<l; i++) {
				var segment = segments[i], match;

				if (match = segment.match(/^:([^\/]+)$/)) {
					results.push(new DynamicSegment(match[1]));
					names.push(match[1]);
					types.dynamics++;
				} else if (match = segment.match(/^\*([^\/]+)$/)) {
					results.push(new StarSegment(match[1]));
					names.push(match[1]);
					types.stars++;
				} else if(segment === "") {
					results.push(new EpsilonSegment());
				} else {
					results.push(new StaticSegment(segment));
					types.statics++;
				}
			}

			return results;
		}

		// A State has a character specification and (`charSpec`) and a list of possible
		// subsequent states (`nextStates`).
		//
		// If a State is an accepting state, it will also have several additional
		// properties:
		//
		// * `regex`: A regular expression that is used to extract parameters from paths
		//   that reached this accepting state.
		// * `handlers`: Information on how to convert the list of captures into calls
		//   to registered handlers with the specified parameters
		// * `types`: How many static, dynamic or star segments in this route. Used to
		//   decide which route to use if multiple registered routes match a path.
		//
		// Currently, State is implemented naively by looping over `nextStates` and
		// comparing a character specification against a character. A more efficient
		// implementation would use a hash of keys pointing at one or more next states.

		function State(charSpec) {
			this.charSpec = charSpec;
			this.nextStates = [];
		}

		State.prototype = {
			get: function(charSpec) {
				var nextStates = this.nextStates;

				for (var i=0, l=nextStates.length; i<l; i++) {
					var child = nextStates[i];

					var isEqual = child.charSpec.validChars === charSpec.validChars;
					isEqual = isEqual && child.charSpec.invalidChars === charSpec.invalidChars;

					if (isEqual) { return child; }
				}
			},

			put: function(charSpec) {
				var state;

				// If the character specification already exists in a child of the current
				// state, just return that state.
				if (state = this.get(charSpec)) { return state; }

				// Make a new state for the character spec
				state = new State(charSpec);

				// Insert the new state as a child of the current state
				this.nextStates.push(state);

				// If this character specification repeats, insert the new state as a child
				// of itself. Note that this will not trigger an infinite loop because each
				// transition during recognition consumes a character.
				if (charSpec.repeat) {
					state.nextStates.push(state);
				}

				// Return the new state
				return state;
			},

			// Find a list of child states matching the next character
			match: function(ch) {
				// DEBUG "Processing `" + ch + "`:"
				var nextStates = this.nextStates,
						child, charSpec, chars;

				// DEBUG "  " + debugState(this)
				var returned = [];

				for (var i=0, l=nextStates.length; i<l; i++) {
					child = nextStates[i];

					charSpec = child.charSpec;

					if (typeof (chars = charSpec.validChars) !== 'undefined') {
						if (chars.indexOf(ch) !== -1) { returned.push(child); }
					} else if (typeof (chars = charSpec.invalidChars) !== 'undefined') {
						if (chars.indexOf(ch) === -1) { returned.push(child); }
					}
				}

				return returned;
			}

			/** IF DEBUG
			, debug: function() {
				var charSpec = this.charSpec,
						debug = "[",
						chars = charSpec.validChars || charSpec.invalidChars;

				if (charSpec.invalidChars) { debug += "^"; }
				debug += chars;
				debug += "]";

				if (charSpec.repeat) { debug += "+"; }

				return debug;
			}
			END IF **/
		};

		/** IF DEBUG
		function debug(log) {
			console.log(log);
		}

		function debugState(state) {
			return state.nextStates.map(function(n) {
				if (n.nextStates.length === 0) { return "( " + n.debug() + " [accepting] )"; }
				return "( " + n.debug() + " <then> " + n.nextStates.map(function(s) { return s.debug() }).join(" or ") + " )";
			}).join(", ")
		}
		END IF **/

		// This is a somewhat naive strategy, but should work in a lot of cases
		// A better strategy would properly resolve /posts/:id/new and /posts/edit/:id
		function sortSolutions(states) {
			return states.sort(function(a, b) {
				if (a.types.stars !== b.types.stars) { return a.types.stars - b.types.stars; }
				if (a.types.dynamics !== b.types.dynamics) { return a.types.dynamics - b.types.dynamics; }
				if (a.types.statics !== b.types.statics) { return b.types.statics - a.types.statics; }

				return 0;
			});
		}

		function recognizeChar(states, ch) {
			var nextStates = [];

			for (var i=0, l=states.length; i<l; i++) {
				var state = states[i];

				nextStates = nextStates.concat(state.match(ch));
			}

			return nextStates;
		}

		var oCreate = Object.create || function(proto) {
			function F() {}
			F.prototype = proto;
			return new F();
		};

		function RecognizeResults(queryParams) {
			this.queryParams = queryParams || {};
		}
		RecognizeResults.prototype = oCreate({
			splice: Array.prototype.splice,
			slice:  Array.prototype.slice,
			push:   Array.prototype.push,
			length: 0,
			queryParams: null
		});

		function findHandler(state, path, queryParams) {
			var handlers = state.handlers, regex = state.regex;
			var captures = path.match(regex), currentCapture = 1;
			var result = new RecognizeResults(queryParams);

			for (var i=0, l=handlers.length; i<l; i++) {
				var handler = handlers[i], names = handler.names, params = {};

				for (var j=0, m=names.length; j<m; j++) {
					params[names[j]] = captures[currentCapture++];
				}

				result.push({ handler: handler.handler, params: params, isDynamic: !!names.length });
			}

			return result;
		}

		function addSegment(currentState, segment) {
			segment.eachChar(function(ch) {
				var state;

				currentState = currentState.put(ch);
			});

			return currentState;
		}

		// The main interface

		var RouteRecognizer = function() {
			this.rootState = new State();
			this.names = {};
		};


		RouteRecognizer.prototype = {
			add: function(routes, options) {
				var currentState = this.rootState, regex = "^",
						types = { statics: 0, dynamics: 0, stars: 0 },
						handlers = [], allSegments = [], name;

				var isEmpty = true;

				for (var i=0, l=routes.length; i<l; i++) {
					var route = routes[i], names = [];

					var segments = parse(route.path, names, types);

					allSegments = allSegments.concat(segments);

					for (var j=0, m=segments.length; j<m; j++) {
						var segment = segments[j];

						if (segment instanceof EpsilonSegment) { continue; }

						isEmpty = false;

						// Add a "/" for the new segment
						currentState = currentState.put({ validChars: "/" });
						regex += "/";

						// Add a representation of the segment to the NFA and regex
						currentState = addSegment(currentState, segment);
						regex += segment.regex();
					}

					var handler = { handler: route.handler, names: names };
					handlers.push(handler);
				}

				if (isEmpty) {
					currentState = currentState.put({ validChars: "/" });
					regex += "/";
				}

				currentState.handlers = handlers;
				currentState.regex = new RegExp(regex + "$");
				currentState.types = types;

				if (name = options && options.as) {
					this.names[name] = {
						segments: allSegments,
						handlers: handlers
					};
				}
			},

			handlersFor: function(name) {
				var route = this.names[name], result = [];
				if (!route) { throw new Error("There is no route named " + name); }

				for (var i=0, l=route.handlers.length; i<l; i++) {
					result.push(route.handlers[i]);
				}

				return result;
			},

			hasRoute: function(name) {
				return !!this.names[name];
			},

			generate: function(name, params) {
				var route = this.names[name], output = "";
				if (!route) { throw new Error("There is no route named " + name); }

				var segments = route.segments;

				for (var i=0, l=segments.length; i<l; i++) {
					var segment = segments[i];

					if (segment instanceof EpsilonSegment) { continue; }

					output += "/";
					output += segment.generate(params);
				}

				if (output.charAt(0) !== '/') { output = '/' + output; }

				if (params && params.queryParams) {
					output += this.generateQueryString(params.queryParams, route.handlers);
				}

				return output;
			},

			generateQueryString: function(params, handlers) {
				var pairs = [];
				for(var key in params) {
					if (params.hasOwnProperty(key)) {
						var value = params[key];
						if (value === false || value == null) {
							continue;
						}
						var pair = key;
						if (Array.isArray(value)) {
							for (var i = 0, l = value.length; i < l; i++) {
								var arrayPair = key + '[]' + '=' + encodeURIComponent(value[i]);
								pairs.push(arrayPair);
							}
						}
						else if (value !== true) {
							pair += "=" + encodeURIComponent(value);
							pairs.push(pair);
						} else {
							pairs.push(pair);
						}
					}
				}

				if (pairs.length === 0) { return ''; }

				return "?" + pairs.join("&");
			},

			parseQueryString: function(queryString) {
				var pairs = queryString.split("&"), queryParams = {};
				for(var i=0; i < pairs.length; i++) {
					var pair      = pairs[i].split('='),
							key       = decodeURIComponent(pair[0]),
							keyLength = key.length,
							isArray = false,
							value;
					if (pair.length === 1) {
						value = true;
					} else {
						//Handle arrays
						if (keyLength > 2 && key.slice(keyLength -2) === '[]') {
							isArray = true;
							key = key.slice(0, keyLength - 2);
							if(!queryParams[key]) {
								queryParams[key] = [];
							}
						}
						value = pair[1] ? decodeURIComponent(pair[1]) : '';
					}
					if (isArray) {
						queryParams[key].push(value);
					} else {
						queryParams[key] = value;
					}

				}
				return queryParams;
			},

			recognize: function(path) {
				var states = [ this.rootState ],
						pathLen, i, l, queryStart, queryParams = {};

				queryStart = path.indexOf('?');
				if (queryStart !== -1) {
					var queryString = path.substr(queryStart + 1, path.length);
					path = path.substr(0, queryStart);
					queryParams = this.parseQueryString(queryString);
				}

				// DEBUG GROUP path

				if (path.charAt(0) !== "/") { path = "/" + path; }

				pathLen = path.length;
				if (pathLen > 1 && path.charAt(pathLen - 1) === "/") {
					path = path.substr(0, pathLen - 1);
				}

				for (i=0, l=path.length; i<l; i++) {
					states = recognizeChar(states, path.charAt(i));
					if (!states.length) { break; }
				}

				// END DEBUG GROUP

				var solutions = [];
				for (i=0, l=states.length; i<l; i++) {
					if (states[i].handlers) { solutions.push(states[i]); }
				}

				states = sortSolutions(solutions);

				var state = solutions[0];

				if (state && state.handlers) {
					return findHandler(state, path, queryParams);
				}
			}
		};

		__exports__["default"] = RouteRecognizer;

		function Target(path, matcher, delegate) {
			this.path = path;
			this.matcher = matcher;
			this.delegate = delegate;
		}

		Target.prototype = {
			to: function(target, callback) {
				var delegate = this.delegate;

				if (delegate && delegate.willAddRoute) {
					target = delegate.willAddRoute(this.matcher.target, target);
				}

				this.matcher.add(this.path, target);

				if (callback) {
					if (callback.length === 0) { throw new Error("You must have an argument in the function passed to `to`"); }
					this.matcher.addChild(this.path, target, callback, this.delegate);
				}
				return this;
			}
		};

		function Matcher(target) {
			this.routes = {};
			this.children = {};
			this.target = target;
		}

		Matcher.prototype = {
			add: function(path, handler) {
				this.routes[path] = handler;
			},

			addChild: function(path, target, callback, delegate) {
				var matcher = new Matcher(target);
				this.children[path] = matcher;

				var match = generateMatch(path, matcher, delegate);

				if (delegate && delegate.contextEntered) {
					delegate.contextEntered(target, match);
				}

				callback(match);
			}
		};

		function generateMatch(startingPath, matcher, delegate) {
			return function(path, nestedCallback) {
				var fullPath = startingPath + path;

				if (nestedCallback) {
					nestedCallback(generateMatch(fullPath, matcher, delegate));
				} else {
					return new Target(startingPath + path, matcher, delegate);
				}
			};
		}

		function addRoute(routeArray, path, handler) {
			var len = 0;
			for (var i=0, l=routeArray.length; i<l; i++) {
				len += routeArray[i].path.length;
			}

			path = path.substr(len);
			var route = { path: path, handler: handler };
			routeArray.push(route);
		}

		function eachRoute(baseRoute, matcher, callback, binding) {
			var routes = matcher.routes;

			for (var path in routes) {
				if (routes.hasOwnProperty(path)) {
					var routeArray = baseRoute.slice();
					addRoute(routeArray, path, routes[path]);

					if (matcher.children[path]) {
						eachRoute(routeArray, matcher.children[path], callback, binding);
					} else {
						callback.call(binding, routeArray);
					}
				}
			}
		}

		RouteRecognizer.prototype.map = function(callback, addRouteCallback) {
			var matcher = new Matcher();

			callback(generateMatch("", matcher, this.delegate));

			eachRoute([], matcher, function(route) {
				if (addRouteCallback) { addRouteCallback(this, route); }
				else { this.add(route); }
			}, this);
		};
	});

})();



(function() {
define("router/handler-info",
	["./utils","rsvp","exports"],
	function(__dependency1__, __dependency2__, __exports__) {
		"use strict";
		var bind = __dependency1__.bind;
		var merge = __dependency1__.merge;
		var oCreate = __dependency1__.oCreate;
		var serialize = __dependency1__.serialize;
		var resolve = __dependency2__.resolve;

		function HandlerInfo(props) {
			if (props) {
				merge(this, props);
			}
		}

		HandlerInfo.prototype = {
			name: null,
			handler: null,
			params: null,
			context: null,

			log: function(payload, message) {
				if (payload.log) {
					payload.log(this.name + ': ' + message);
				}
			},

			resolve: function(async, shouldContinue, payload) {
				var checkForAbort  = bind(this.checkForAbort,      this, shouldContinue),
						beforeModel    = bind(this.runBeforeModelHook, this, async, payload),
						model          = bind(this.getModel,           this, async, payload),
						afterModel     = bind(this.runAfterModelHook,  this, async, payload),
						becomeResolved = bind(this.becomeResolved,     this, payload);

				return resolve().then(checkForAbort)
														 .then(beforeModel)
														 .then(checkForAbort)
														 .then(model)
														 .then(checkForAbort)
														 .then(afterModel)
														 .then(checkForAbort)
														 .then(becomeResolved);
			},

			runBeforeModelHook: function(async, payload) {
				if (payload.trigger) {
					payload.trigger(true, 'willResolveModel', payload, this.handler);
				}
				return this.runSharedModelHook(async, payload, 'beforeModel', []);
			},

			runAfterModelHook: function(async, payload, resolvedModel) {
				// Stash the resolved model on the payload.
				// This makes it possible for users to swap out
				// the resolved model in afterModel.
				var name = this.name;
				this.stashResolvedModel(payload, resolvedModel);

				return this.runSharedModelHook(async, payload, 'afterModel', [resolvedModel])
									 .then(function() {
										 // Ignore the fulfilled value returned from afterModel.
										 // Return the value stashed in resolvedModels, which
										 // might have been swapped out in afterModel.
										 return payload.resolvedModels[name];
									 });
			},

			runSharedModelHook: function(async, payload, hookName, args) {
				this.log(payload, "calling " + hookName + " hook");

				if (this.queryParams) {
					args.push(this.queryParams);
				}
				args.push(payload);

				var handler = this.handler;
				return async(function() {
					return handler[hookName] && handler[hookName].apply(handler, args);
				});
			},

			getModel: function(payload) {
				throw new Error("This should be overridden by a subclass of HandlerInfo");
			},

			checkForAbort: function(shouldContinue, promiseValue) {
				return resolve(shouldContinue()).then(function() {
					// We don't care about shouldContinue's resolve value;
					// pass along the original value passed to this fn.
					return promiseValue;
				});
			},

			stashResolvedModel: function(payload, resolvedModel) {
				payload.resolvedModels = payload.resolvedModels || {};
				payload.resolvedModels[this.name] = resolvedModel;
			},

			becomeResolved: function(payload, resolvedContext) {
				var params = this.params || serialize(this.handler, resolvedContext, this.names);

				if (payload) {
					this.stashResolvedModel(payload, resolvedContext);
					payload.params = payload.params || {};
					payload.params[this.name] = params;
				}

				return new ResolvedHandlerInfo({
					context: resolvedContext,
					name: this.name,
					handler: this.handler,
					params: params
				});
			},

			shouldSupercede: function(other) {
				// Prefer this newer handlerInfo over `other` if:
				// 1) The other one doesn't exist
				// 2) The names don't match
				// 3) This handler has a context that doesn't match
				//    the other one (or the other one doesn't have one).
				// 4) This handler has parameters that don't match the other.
				if (!other) { return true; }

				var contextsMatch = (other.context === this.context);
				return other.name !== this.name ||
							 (this.hasOwnProperty('context') && !contextsMatch) ||
							 (this.hasOwnProperty('params') && !paramsMatch(this.params, other.params));
			}
		};

		function ResolvedHandlerInfo(props) {
			HandlerInfo.call(this, props);
		}

		ResolvedHandlerInfo.prototype = oCreate(HandlerInfo.prototype);
		ResolvedHandlerInfo.prototype.resolve = function(async, shouldContinue, payload) {
			// A ResolvedHandlerInfo just resolved with itself.
			if (payload && payload.resolvedModels) {
				payload.resolvedModels[this.name] = this.context;
			}
			return resolve(this);
		};

		// These are generated by URL transitions and
		// named transitions for non-dynamic route segments.
		function UnresolvedHandlerInfoByParam(props) {
			HandlerInfo.call(this, props);
			this.params = this.params || {};
		}

		UnresolvedHandlerInfoByParam.prototype = oCreate(HandlerInfo.prototype);
		UnresolvedHandlerInfoByParam.prototype.getModel = function(async, payload) {
			var fullParams = this.params;
			if (payload && payload.queryParams) {
				fullParams = {};
				merge(fullParams, this.params);
				fullParams.queryParams = payload.queryParams;
			}

			var hookName = typeof this.handler.deserialize === 'function' ?
										 'deserialize' : 'model';

			return this.runSharedModelHook(async, payload, hookName, [fullParams]);
		};


		// These are generated only for named transitions
		// with dynamic route segments.
		function UnresolvedHandlerInfoByObject(props) {
			HandlerInfo.call(this, props);
		}

		UnresolvedHandlerInfoByObject.prototype = oCreate(HandlerInfo.prototype);
		UnresolvedHandlerInfoByObject.prototype.getModel = function(async, payload) {
			this.log(payload, this.name + ": resolving provided model");
			return resolve(this.context);
		};

		function paramsMatch(a, b) {
			if ((!a) ^ (!b)) {
				// Only one is null.
				return false;
			}

			if (!a) {
				// Both must be null.
				return true;
			}

			// Note: this assumes that both params have the same
			// number of keys, but since we're comparing the
			// same handlers, they should.
			for (var k in a) {
				if (a.hasOwnProperty(k) && a[k] !== b[k]) {
					return false;
				}
			}
			return true;
		}

		__exports__.HandlerInfo = HandlerInfo;
		__exports__.ResolvedHandlerInfo = ResolvedHandlerInfo;
		__exports__.UnresolvedHandlerInfoByParam = UnresolvedHandlerInfoByParam;
		__exports__.UnresolvedHandlerInfoByObject = UnresolvedHandlerInfoByObject;
	});
define("router/router",
	["route-recognizer","rsvp","./utils","./transition-state","./transition","./transition-intent/named-transition-intent","./transition-intent/url-transition-intent","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __dependency4__, __dependency5__, __dependency6__, __dependency7__, __exports__) {
		"use strict";
		var RouteRecognizer = __dependency1__["default"];
		var resolve = __dependency2__.resolve;
		var reject = __dependency2__.reject;
		var async = __dependency2__.async;
		var Promise = __dependency2__.Promise;
		var trigger = __dependency3__.trigger;
		var log = __dependency3__.log;
		var slice = __dependency3__.slice;
		var forEach = __dependency3__.forEach;
		var merge = __dependency3__.merge;
		var serialize = __dependency3__.serialize;
		var extractQueryParams = __dependency3__.extractQueryParams;
		var getChangelist = __dependency3__.getChangelist;
		var TransitionState = __dependency4__.TransitionState;
		var logAbort = __dependency5__.logAbort;
		var Transition = __dependency5__.Transition;
		var TransitionAborted = __dependency5__.TransitionAborted;
		var NamedTransitionIntent = __dependency6__.NamedTransitionIntent;
		var URLTransitionIntent = __dependency7__.URLTransitionIntent;

		var pop = Array.prototype.pop;

		function Router() {
			this.recognizer = new RouteRecognizer();
			this.reset();
		}

		Router.prototype = {

			/**
				The main entry point into the router. The API is essentially
				the same as the `map` method in `route-recognizer`.

				This method extracts the String handler at the last `.to()`
				call and uses it as the name of the whole route.

				@param {Function} callback
			*/
			map: function(callback) {
				this.recognizer.delegate = this.delegate;

				this.recognizer.map(callback, function(recognizer, route) {
					var lastHandler = route[route.length - 1].handler;
					var args = [route, { as: lastHandler }];
					recognizer.add.apply(recognizer, args);
				});
			},

			hasRoute: function(route) {
				return this.recognizer.hasRoute(route);
			},

			// NOTE: this doesn't really belong here, but here
			// it shall remain until our ES6 transpiler can
			// handle cyclical deps.
			transitionByIntent: function(intent, isIntermediate) {

				var wasTransitioning = !!this.activeTransition;
				var oldState = wasTransitioning ? this.activeTransition.state : this.state;
				var newTransition;
				var router = this;

				try {
					var newState = intent.applyToState(oldState, this.recognizer, this.getHandler, isIntermediate);

					if (handlerInfosEqual(newState.handlerInfos, oldState.handlerInfos)) {

						// This is a no-op transition. See if query params changed.
						var queryParamChangelist = getChangelist(oldState.queryParams, newState.queryParams);
						if (queryParamChangelist) {

							// This is a little hacky but we need some way of storing
							// changed query params given that no activeTransition
							// is guaranteed to have occurred.
							this._changedQueryParams = queryParamChangelist.changed;
							trigger(this, newState.handlerInfos, true, ['queryParamsDidChange', queryParamChangelist.changed, queryParamChangelist.all, queryParamChangelist.removed]);
							this._changedQueryParams = null;

							if (!wasTransitioning && this.activeTransition) {
								// One of the handlers in queryParamsDidChange
								// caused a transition. Just return that transition.
								return this.activeTransition;
							} else {
								// Running queryParamsDidChange didn't change anything.
								// Just update query params and be on our way.
								oldState.queryParams = finalizeQueryParamChange(this, newState.handlerInfos, newState.queryParams);

								// We have to return a noop transition that will
								// perform a URL update at the end. This gives
								// the user the ability to set the url update
								// method (default is replaceState).
								newTransition = new Transition(this);
								newTransition.urlMethod = 'replace';
								newTransition.promise = newTransition.promise.then(function(result) {
									updateURL(newTransition, oldState, true);
									if (router.didTransition) {
										router.didTransition(router.currentHandlerInfos);
									}
									return result;
								});
								return newTransition;
							}
						}

						// No-op. No need to create a new transition.
						return new Transition(this);
					}

					if (isIntermediate) {
						setupContexts(this, newState);
						return;
					}

					// Create a new transition to the destination route.
					newTransition = new Transition(this, intent, newState);

					// Abort and usurp any previously active transition.
					if (this.activeTransition) {
						this.activeTransition.abort();
					}
					this.activeTransition = newTransition;

					// Transition promises by default resolve with resolved state.
					// For our purposes, swap out the promise to resolve
					// after the transition has been finalized.
					newTransition.promise = newTransition.promise.then(function(result) {
						return router.async(function() {
							return finalizeTransition(newTransition, result.state);
						});
					});

					if (!wasTransitioning) {
						trigger(this, this.state.handlerInfos, true, ['willTransition', newTransition]);
					}

					return newTransition;
				} catch(e) {
					return new Transition(this, intent, null, e);
				}
			},

			/**
				Clears the current and target route handlers and triggers exit
				on each of them starting at the leaf and traversing up through
				its ancestors.
			*/
			reset: function() {
				if (this.state) {
					forEach(this.state.handlerInfos, function(handlerInfo) {
						var handler = handlerInfo.handler;
						if (handler.exit) {
							handler.exit();
						}
					});
				}

				this.state = new TransitionState();
				this.currentHandlerInfos = null;
			},

			activeTransition: null,

			/**
				var handler = handlerInfo.handler;
				The entry point for handling a change to the URL (usually
				via the back and forward button).

				Returns an Array of handlers and the parameters associated
				with those parameters.

				@param {String} url a URL to process

				@return {Array} an Array of `[handler, parameter]` tuples
			*/
			handleURL: function(url) {
				// Perform a URL-based transition, but don't change
				// the URL afterward, since it already happened.
				var args = slice.call(arguments);
				if (url.charAt(0) !== '/') { args[0] = '/' + url; }

				return doTransition(this, args).method('replaceQuery');
			},

			/**
				Hook point for updating the URL.

				@param {String} url a URL to update to
			*/
			updateURL: function() {
				throw new Error("updateURL is not implemented");
			},

			/**
				Hook point for replacing the current URL, i.e. with replaceState

				By default this behaves the same as `updateURL`

				@param {String} url a URL to update to
			*/
			replaceURL: function(url) {
				this.updateURL(url);
			},

			/**
				Transition into the specified named route.

				If necessary, trigger the exit callback on any handlers
				that are no longer represented by the target route.

				@param {String} name the name of the route
			*/
			transitionTo: function(name) {
				return doTransition(this, arguments);
			},

			intermediateTransitionTo: function(name) {
				doTransition(this, arguments, true);
			},

			refresh: function(pivotHandler) {


				var state = this.activeTransition ? this.activeTransition.state : this.state;
				var handlerInfos = state.handlerInfos;
				var params = {};
				for (var i = 0, len = handlerInfos.length; i < len; ++i) {
					var handlerInfo = handlerInfos[i];
					params[handlerInfo.name] = handlerInfo.params || {};
				}

				log(this, "Starting a refresh transition");
				var intent = new NamedTransitionIntent({
					name: handlerInfos[handlerInfos.length - 1].name,
					pivotHandler: pivotHandler || handlerInfos[0].handler,
					contexts: [], // TODO collect contexts...?
					queryParams: this._changedQueryParams || state.queryParams || {}
				});

				return this.transitionByIntent(intent, false);
			},

			/**
				Identical to `transitionTo` except that the current URL will be replaced
				if possible.

				This method is intended primarily for use with `replaceState`.

				@param {String} name the name of the route
			*/
			replaceWith: function(name) {
				return doTransition(this, arguments).method('replace');
			},

			/**
				Take a named route and context objects and generate a
				URL.

				@param {String} name the name of the route to generate
					a URL for
				@param {...Object} objects a list of objects to serialize

				@return {String} a URL
			*/
			generate: function(handlerName) {

				var partitionedArgs = extractQueryParams(slice.call(arguments, 1)),
					suppliedParams = partitionedArgs[0],
					queryParams = partitionedArgs[1];

				// Construct a TransitionIntent with the provided params
				// and apply it to the present state of the router.
				var intent = new NamedTransitionIntent({ name: handlerName, contexts: suppliedParams });
				var state = intent.applyToState(this.state, this.recognizer, this.getHandler);
				var params = {};

				for (var i = 0, len = state.handlerInfos.length; i < len; ++i) {
					var handlerInfo = state.handlerInfos[i];
					var handlerParams = handlerInfo.params ||
															serialize(handlerInfo.handler, handlerInfo.context, handlerInfo.names);
					merge(params, handlerParams);
				}
				params.queryParams = queryParams;

				return this.recognizer.generate(handlerName, params);
			},

			isActive: function(handlerName) {

				var partitionedArgs   = extractQueryParams(slice.call(arguments, 1)),
						contexts          = partitionedArgs[0],
						queryParams       = partitionedArgs[1],
						activeQueryParams  = this.state.queryParams;

				var targetHandlerInfos = this.state.handlerInfos,
						found = false, names, object, handlerInfo, handlerObj, i, len;

				if (!targetHandlerInfos.length) { return false; }

				var targetHandler = targetHandlerInfos[targetHandlerInfos.length - 1].name;
				var recogHandlers = this.recognizer.handlersFor(targetHandler);

				var index = 0;
				for (len = recogHandlers.length; index < len; ++index) {
					handlerInfo = targetHandlerInfos[index];
					if (handlerInfo.name === handlerName) { break; }
				}

				if (index === recogHandlers.length) {
					// The provided route name isn't even in the route hierarchy.
					return false;
				}

				var state = new TransitionState();
				state.handlerInfos = targetHandlerInfos.slice(0, index + 1);
				recogHandlers = recogHandlers.slice(0, index + 1);

				var intent = new NamedTransitionIntent({
					name: targetHandler,
					contexts: contexts
				});

				var newState = intent.applyToHandlers(state, recogHandlers, this.getHandler, targetHandler, true, true);

				return handlerInfosEqual(newState.handlerInfos, state.handlerInfos) &&
							 !getChangelist(activeQueryParams, queryParams);
			},

			trigger: function(name) {
				var args = slice.call(arguments);
				trigger(this, this.currentHandlerInfos, false, args);
			},

			/**
				@private

				Pluggable hook for possibly running route hooks
				in a try-catch escaping manner.

				@param {Function} callback the callback that will
													be asynchronously called

				@return {Promise} a promise that fulfills with the
													value returned from the callback
			 */
			async: function(callback) {
				return new Promise(function(resolve) {
					resolve(callback());
				});
			},

			/**
				Hook point for logging transition status updates.

				@param {String} message The message to log.
			*/
			log: null
		};

		/**
			@private

			Takes an Array of `HandlerInfo`s, figures out which ones are
			exiting, entering, or changing contexts, and calls the
			proper handler hooks.

			For example, consider the following tree of handlers. Each handler is
			followed by the URL segment it handles.

			```
			|~index ("/")
			| |~posts ("/posts")
			| | |-showPost ("/:id")
			| | |-newPost ("/new")
			| | |-editPost ("/edit")
			| |~about ("/about/:id")
			```

			Consider the following transitions:

			1. A URL transition to `/posts/1`.
				 1. Triggers the `*model` callbacks on the
						`index`, `posts`, and `showPost` handlers
				 2. Triggers the `enter` callback on the same
				 3. Triggers the `setup` callback on the same
			2. A direct transition to `newPost`
				 1. Triggers the `exit` callback on `showPost`
				 2. Triggers the `enter` callback on `newPost`
				 3. Triggers the `setup` callback on `newPost`
			3. A direct transition to `about` with a specified
				 context object
				 1. Triggers the `exit` callback on `newPost`
						and `posts`
				 2. Triggers the `serialize` callback on `about`
				 3. Triggers the `enter` callback on `about`
				 4. Triggers the `setup` callback on `about`

			@param {Router} transition
			@param {TransitionState} newState
		*/
		function setupContexts(router, newState, transition) {
			var partition = partitionHandlers(router.state, newState);

			forEach(partition.exited, function(handlerInfo) {
				var handler = handlerInfo.handler;
				delete handler.context;
				if (handler.exit) { handler.exit(); }
			});

			var oldState = router.oldState = router.state;
			router.state = newState;
			var currentHandlerInfos = router.currentHandlerInfos = partition.unchanged.slice();

			try {
				forEach(partition.updatedContext, function(handlerInfo) {
					return handlerEnteredOrUpdated(currentHandlerInfos, handlerInfo, false, transition);
				});

				forEach(partition.entered, function(handlerInfo) {
					return handlerEnteredOrUpdated(currentHandlerInfos, handlerInfo, true, transition);
				});
			} catch(e) {
				router.state = oldState;
				router.currentHandlerInfos = oldState.handlerInfos;
				throw e;
			}

			router.state.queryParams = finalizeQueryParamChange(router, currentHandlerInfos, newState.queryParams);
		}


		/**
			@private

			Helper method used by setupContexts. Handles errors or redirects
			that may happen in enter/setup.
		*/
		function handlerEnteredOrUpdated(currentHandlerInfos, handlerInfo, enter, transition) {

			var handler = handlerInfo.handler,
					context = handlerInfo.context;

			if (enter && handler.enter) { handler.enter(transition); }
			if (transition && transition.isAborted) {
				throw new TransitionAborted();
			}

			handler.context = context;
			if (handler.contextDidChange) { handler.contextDidChange(); }

			if (handler.setup) { handler.setup(context, transition); }
			if (transition && transition.isAborted) {
				throw new TransitionAborted();
			}

			currentHandlerInfos.push(handlerInfo);

			return true;
		}


		/**
			@private

			This function is called when transitioning from one URL to
			another to determine which handlers are no longer active,
			which handlers are newly active, and which handlers remain
			active but have their context changed.

			Take a list of old handlers and new handlers and partition
			them into four buckets:

			* unchanged: the handler was active in both the old and
				new URL, and its context remains the same
			* updated context: the handler was active in both the
				old and new URL, but its context changed. The handler's
				`setup` method, if any, will be called with the new
				context.
			* exited: the handler was active in the old URL, but is
				no longer active.
			* entered: the handler was not active in the old URL, but
				is now active.

			The PartitionedHandlers structure has four fields:

			* `updatedContext`: a list of `HandlerInfo` objects that
				represent handlers that remain active but have a changed
				context
			* `entered`: a list of `HandlerInfo` objects that represent
				handlers that are newly active
			* `exited`: a list of `HandlerInfo` objects that are no
				longer active.
			* `unchanged`: a list of `HanderInfo` objects that remain active.

			@param {Array[HandlerInfo]} oldHandlers a list of the handler
				information for the previous URL (or `[]` if this is the
				first handled transition)
			@param {Array[HandlerInfo]} newHandlers a list of the handler
				information for the new URL

			@return {Partition}
		*/
		function partitionHandlers(oldState, newState) {
			var oldHandlers = oldState.handlerInfos;
			var newHandlers = newState.handlerInfos;

			var handlers = {
						updatedContext: [],
						exited: [],
						entered: [],
						unchanged: []
					};

			var handlerChanged, contextChanged, queryParamsChanged, i, l;

			for (i=0, l=newHandlers.length; i<l; i++) {
				var oldHandler = oldHandlers[i], newHandler = newHandlers[i];

				if (!oldHandler || oldHandler.handler !== newHandler.handler) {
					handlerChanged = true;
				}

				if (handlerChanged) {
					handlers.entered.push(newHandler);
					if (oldHandler) { handlers.exited.unshift(oldHandler); }
				} else if (contextChanged || oldHandler.context !== newHandler.context || queryParamsChanged) {
					contextChanged = true;
					handlers.updatedContext.push(newHandler);
				} else {
					handlers.unchanged.push(oldHandler);
				}
			}

			for (i=newHandlers.length, l=oldHandlers.length; i<l; i++) {
				handlers.exited.unshift(oldHandlers[i]);
			}

			return handlers;
		}

		function updateURL(transition, state, inputUrl) {
			var urlMethod = transition.urlMethod;

			if (!urlMethod) {
				return;
			}

			var router = transition.router,
					handlerInfos = state.handlerInfos,
					handlerName = handlerInfos[handlerInfos.length - 1].name,
					params = {};

			for (var i = handlerInfos.length - 1; i >= 0; --i) {
				var handlerInfo = handlerInfos[i];
				merge(params, handlerInfo.params);
				if (handlerInfo.handler.inaccessibleByURL) {
					urlMethod = null;
				}
			}

			if (urlMethod) {
				params.queryParams = state.queryParams;
				var url = router.recognizer.generate(handlerName, params);

				if (urlMethod === 'replaceQuery') {
					if (url !== inputUrl) {
						router.replaceURL(url);
					}
				} else if (urlMethod === 'replace') {
					router.replaceURL(url);
				} else {
					router.updateURL(url);
				}
			}
		}

		/**
			@private

			Updates the URL (if necessary) and calls `setupContexts`
			to update the router's array of `currentHandlerInfos`.
		 */
		function finalizeTransition(transition, newState) {

			try {
				log(transition.router, transition.sequence, "Resolved all models on destination route; finalizing transition.");

				var router = transition.router,
						handlerInfos = newState.handlerInfos,
						seq = transition.sequence;

				// Run all the necessary enter/setup/exit hooks
				setupContexts(router, newState, transition);

				// Check if a redirect occurred in enter/setup
				if (transition.isAborted) {
					// TODO: cleaner way? distinguish b/w targetHandlerInfos?
					router.state.handlerInfos = router.currentHandlerInfos;
					return reject(logAbort(transition));
				}

				updateURL(transition, newState, transition.intent.url);

				transition.isActive = false;
				router.activeTransition = null;

				trigger(router, router.currentHandlerInfos, true, ['didTransition']);

				if (router.didTransition) {
					router.didTransition(router.currentHandlerInfos);
				}

				log(router, transition.sequence, "TRANSITION COMPLETE.");

				// Resolve with the final handler.
				return handlerInfos[handlerInfos.length - 1].handler;
			} catch(e) {
				if (!(e instanceof TransitionAborted)) {
					//var erroneousHandler = handlerInfos.pop();
					var infos = transition.state.handlerInfos;
					transition.trigger(true, 'error', e, transition, infos[infos.length-1]);
					transition.abort();
				}

				throw e;
			}
		}

		/**
			@private

			Begins and returns a Transition based on the provided
			arguments. Accepts arguments in the form of both URL
			transitions and named transitions.

			@param {Router} router
			@param {Array[Object]} args arguments passed to transitionTo,
				replaceWith, or handleURL
		*/
		function doTransition(router, args, isIntermediate) {
			// Normalize blank transitions to root URL transitions.
			var name = args[0] || '/';

			var lastArg = args[args.length-1];
			var queryParams = {};
			if (lastArg && lastArg.hasOwnProperty('queryParams')) {
				queryParams = pop.call(args).queryParams;
			}

			var intent;
			if (args.length === 0) {

				log(router, "Updating query params");

				// A query param update is really just a transition
				// into the route you're already on.
				var handlerInfos = router.state.handlerInfos;
				intent = new NamedTransitionIntent({
					name: handlerInfos[handlerInfos.length - 1].name,
					contexts: [],
					queryParams: queryParams
				});

			} else if (name.charAt(0) === '/') {

				log(router, "Attempting URL transition to " + name);
				intent = new URLTransitionIntent({ url: name });

			} else {

				log(router, "Attempting transition to " + name);
				intent = new NamedTransitionIntent({
					name: args[0],
					contexts: slice.call(args, 1),
					queryParams: queryParams
				});
			}

			return router.transitionByIntent(intent, isIntermediate);
		}

		function handlerInfosEqual(handlerInfos, otherHandlerInfos) {
			if (handlerInfos.length !== otherHandlerInfos.length) {
				return false;
			}

			for (var i = 0, len = handlerInfos.length; i < len; ++i) {
				if (handlerInfos[i] !== otherHandlerInfos[i]) {
					return false;
				}
			}
			return true;
		}

		function finalizeQueryParamChange(router, resolvedHandlers, newQueryParams) {
			// We fire a finalizeQueryParamChange event which
			// gives the new route hierarchy a chance to tell
			// us which query params it's consuming and what
			// their final values are. If a query param is
			// no longer consumed in the final route hierarchy,
			// its serialized segment will be removed
			// from the URL.
			var finalQueryParamsArray = [];
			trigger(router, resolvedHandlers, true, ['finalizeQueryParamChange', newQueryParams, finalQueryParamsArray]);

			var finalQueryParams = {};
			for (var i = 0, len = finalQueryParamsArray.length; i < len; ++i) {
				var qp = finalQueryParamsArray[i];
				finalQueryParams[qp.key] = qp.value;
			}
			return finalQueryParams;
		}

		__exports__.Router = Router;
	});
define("router/transition-intent",
	["./utils","exports"],
	function(__dependency1__, __exports__) {
		"use strict";
		var merge = __dependency1__.merge;

		function TransitionIntent(props) {
			if (props) {
				merge(this, props);
			}
			this.data = this.data || {};
		}

		TransitionIntent.prototype.applyToState = function(oldState) {
			// Default TransitionIntent is a no-op.
			return oldState;
		};

		__exports__.TransitionIntent = TransitionIntent;
	});
define("router/transition-intent/named-transition-intent",
	["../transition-intent","../transition-state","../handler-info","../utils","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __dependency4__, __exports__) {
		"use strict";
		var TransitionIntent = __dependency1__.TransitionIntent;
		var TransitionState = __dependency2__.TransitionState;
		var UnresolvedHandlerInfoByParam = __dependency3__.UnresolvedHandlerInfoByParam;
		var UnresolvedHandlerInfoByObject = __dependency3__.UnresolvedHandlerInfoByObject;
		var isParam = __dependency4__.isParam;
		var forEach = __dependency4__.forEach;
		var extractQueryParams = __dependency4__.extractQueryParams;
		var oCreate = __dependency4__.oCreate;
		var merge = __dependency4__.merge;

		function NamedTransitionIntent(props) {
			TransitionIntent.call(this, props);
		}

		NamedTransitionIntent.prototype = oCreate(TransitionIntent.prototype);
		NamedTransitionIntent.prototype.applyToState = function(oldState, recognizer, getHandler, isIntermediate) {

			var partitionedArgs     = extractQueryParams([this.name].concat(this.contexts)),
				pureArgs              = partitionedArgs[0],
				queryParams           = partitionedArgs[1],
				handlers              = recognizer.handlersFor(pureArgs[0]);

			var targetRouteName = handlers[handlers.length-1].handler;

			return this.applyToHandlers(oldState, handlers, getHandler, targetRouteName, isIntermediate);
		};

		NamedTransitionIntent.prototype.applyToHandlers = function(oldState, handlers, getHandler, targetRouteName, isIntermediate, checkingIfActive) {

			var i;
			var newState = new TransitionState();
			var objects = this.contexts.slice(0);

			var invalidateIndex = handlers.length;
			var nonDynamicIndexes = [];

			// Pivot handlers are provided for refresh transitions
			if (this.pivotHandler) {
				for (i = 0; i < handlers.length; ++i) {
					if (getHandler(handlers[i].handler) === this.pivotHandler) {
						invalidateIndex = i;
						break;
					}
				}
			}

			var pivotHandlerFound = !this.pivotHandler;

			for (i = handlers.length - 1; i >= 0; --i) {
				var result = handlers[i];
				var name = result.handler;
				var handler = getHandler(name);

				var oldHandlerInfo = oldState.handlerInfos[i];
				var newHandlerInfo = null;

				if (result.names.length > 0) {
					if (i >= invalidateIndex) {
						newHandlerInfo = this.createParamHandlerInfo(name, handler, result.names, objects, oldHandlerInfo);
					} else {
						newHandlerInfo = this.getHandlerInfoForDynamicSegment(name, handler, result.names, objects, oldHandlerInfo, targetRouteName);
					}
				} else {
					// This route has no dynamic segment.
					// Therefore treat as a param-based handlerInfo
					// with empty params. This will cause the `model`
					// hook to be called with empty params, which is desirable.
					newHandlerInfo = this.createParamHandlerInfo(name, handler, result.names, objects, oldHandlerInfo);
					nonDynamicIndexes.unshift(i);
				}

				if (checkingIfActive) {
					// If we're performing an isActive check, we want to
					// serialize URL params with the provided context, but
					// ignore mismatches between old and new context.
					newHandlerInfo = newHandlerInfo.becomeResolved(null, newHandlerInfo.context);
					var oldContext = oldHandlerInfo && oldHandlerInfo.context;
					if (result.names.length > 0 && newHandlerInfo.context === oldContext) {
						// If contexts match in isActive test, assume params also match.
						// This allows for flexibility in not requiring that every last
						// handler provide a `serialize` method
						newHandlerInfo.params = oldHandlerInfo && oldHandlerInfo.params;
					}
					newHandlerInfo.context = oldContext;
				}

				var handlerToUse = oldHandlerInfo;
				if (i >= invalidateIndex || newHandlerInfo.shouldSupercede(oldHandlerInfo)) {
					invalidateIndex = Math.min(i, invalidateIndex);
					handlerToUse = newHandlerInfo;
				}

				if (isIntermediate && !checkingIfActive) {
					handlerToUse = handlerToUse.becomeResolved(null, handlerToUse.context);
				}

				newState.handlerInfos.unshift(handlerToUse);
			}

			if (objects.length > 0) {
				throw new Error("More context objects were passed than there are dynamic segments for the route: " + targetRouteName);
			}

			if (!isIntermediate) {
				this.invalidateNonDynamicHandlers(newState.handlerInfos, nonDynamicIndexes, invalidateIndex);
			}

			merge(newState.queryParams, oldState.queryParams);
			merge(newState.queryParams, this.queryParams || {});

			return newState;
		};

		NamedTransitionIntent.prototype.invalidateNonDynamicHandlers = function(handlerInfos, indexes, invalidateIndex) {
			forEach(indexes, function(i) {
				if (i >= invalidateIndex) {
					var handlerInfo = handlerInfos[i];
					handlerInfos[i] = new UnresolvedHandlerInfoByParam({
						name: handlerInfo.name,
						handler: handlerInfo.handler,
						params: {}
					});
				}
			});
		};

		NamedTransitionIntent.prototype.getHandlerInfoForDynamicSegment = function(name, handler, names, objects, oldHandlerInfo, targetRouteName) {

			var numNames = names.length;
			var objectToUse;
			if (objects.length > 0) {

				// Use the objects provided for this transition.
				objectToUse = objects[objects.length - 1];
				if (isParam(objectToUse)) {
					return this.createParamHandlerInfo(name, handler, names, objects, oldHandlerInfo);
				} else {
					objects.pop();
				}
			} else if (oldHandlerInfo && oldHandlerInfo.name === name) {
				// Reuse the matching oldHandlerInfo
				return oldHandlerInfo;
			} else {
				// Ideally we should throw this error to provide maximal
				// information to the user that not enough context objects
				// were provided, but this proves too cumbersome in Ember
				// in cases where inner template helpers are evaluated
				// before parent helpers un-render, in which cases this
				// error somewhat prematurely fires.
				//throw new Error("Not enough context objects were provided to complete a transition to " + targetRouteName + ". Specifically, the " + name + " route needs an object that can be serialized into its dynamic URL segments [" + names.join(', ') + "]");
				return oldHandlerInfo;
			}

			return new UnresolvedHandlerInfoByObject({
				name: name,
				handler: handler,
				context: objectToUse,
				names: names
			});
		};

		NamedTransitionIntent.prototype.createParamHandlerInfo = function(name, handler, names, objects, oldHandlerInfo) {
			var params = {};

			// Soak up all the provided string/numbers
			var numNames = names.length;
			while (numNames--) {

				// Only use old params if the names match with the new handler
				var oldParams = (oldHandlerInfo && name === oldHandlerInfo.name && oldHandlerInfo.params) || {};

				var peek = objects[objects.length - 1];
				var paramName = names[numNames];
				if (isParam(peek)) {
					params[paramName] = "" + objects.pop();
				} else {
					// If we're here, this means only some of the params
					// were string/number params, so try and use a param
					// value from a previous handler.
					if (oldParams.hasOwnProperty(paramName)) {
						params[paramName] = oldParams[paramName];
					} else {
						throw new Error("You didn't provide enough string/numeric parameters to satisfy all of the dynamic segments for route " + name);
					}
				}
			}

			return new UnresolvedHandlerInfoByParam({
				name: name,
				handler: handler,
				params: params
			});
		};

		__exports__.NamedTransitionIntent = NamedTransitionIntent;
	});
define("router/transition-intent/url-transition-intent",
	["../transition-intent","../transition-state","../handler-info","../utils","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __dependency4__, __exports__) {
		"use strict";
		var TransitionIntent = __dependency1__.TransitionIntent;
		var TransitionState = __dependency2__.TransitionState;
		var UnresolvedHandlerInfoByParam = __dependency3__.UnresolvedHandlerInfoByParam;
		var oCreate = __dependency4__.oCreate;
		var merge = __dependency4__.merge;

		function URLTransitionIntent(props) {
			TransitionIntent.call(this, props);
		}

		URLTransitionIntent.prototype = oCreate(TransitionIntent.prototype);
		URLTransitionIntent.prototype.applyToState = function(oldState, recognizer, getHandler) {
			var newState = new TransitionState();

			var results = recognizer.recognize(this.url),
					queryParams = {},
					i, len;

			if (!results) {
				throw new UnrecognizedURLError(this.url);
			}

			var statesDiffer = false;

			for (i = 0, len = results.length; i < len; ++i) {
				var result = results[i];
				var name = result.handler;
				var handler = getHandler(name);

				if (handler.inaccessibleByURL) {
					throw new UnrecognizedURLError(this.url);
				}

				var newHandlerInfo = new UnresolvedHandlerInfoByParam({
					name: name,
					handler: handler,
					params: result.params
				});

				var oldHandlerInfo = oldState.handlerInfos[i];
				if (statesDiffer || newHandlerInfo.shouldSupercede(oldHandlerInfo)) {
					statesDiffer = true;
					newState.handlerInfos[i] = newHandlerInfo;
				} else {
					newState.handlerInfos[i] = oldHandlerInfo;
				}
			}

			merge(newState.queryParams, results.queryParams);

			return newState;
		};

		/**
			Promise reject reasons passed to promise rejection
			handlers for failed transitions.
		 */
		function UnrecognizedURLError(message) {
			this.message = (message || "UnrecognizedURLError");
			this.name = "UnrecognizedURLError";
		}

		__exports__.URLTransitionIntent = URLTransitionIntent;
	});
define("router/transition-state",
	["./handler-info","./utils","rsvp","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __exports__) {
		"use strict";
		var ResolvedHandlerInfo = __dependency1__.ResolvedHandlerInfo;
		var forEach = __dependency2__.forEach;
		var resolve = __dependency3__.resolve;

		function TransitionState(other) {
			this.handlerInfos = [];
			this.queryParams = {};
			this.params = {};
		}

		TransitionState.prototype = {
			handlerInfos: null,
			queryParams: null,
			params: null,

			resolve: function(async, shouldContinue, payload) {

				// First, calculate params for this state. This is useful
				// information to provide to the various route hooks.
				var params = this.params;
				forEach(this.handlerInfos, function(handlerInfo) {
					params[handlerInfo.name] = handlerInfo.params || {};
				});

				payload = payload || {};
				payload.resolveIndex = 0;

				var currentState = this;
				var wasAborted = false;

				// The prelude RSVP.resolve() asyncs us into the promise land.
				return resolve().then(resolveOneHandlerInfo)['catch'](handleError);

				function innerShouldContinue() {
					return resolve(shouldContinue())['catch'](function(reason) {
						// We distinguish between errors that occurred
						// during resolution (e.g. beforeModel/model/afterModel),
						// and aborts due to a rejecting promise from shouldContinue().
						wasAborted = true;
						throw reason;
					});
				}

				function handleError(error) {
					// This is the only possible
					// reject value of TransitionState#resolve
					throw {
						error: error,
						handlerWithError: currentState.handlerInfos[payload.resolveIndex].handler,
						wasAborted: wasAborted,
						state: currentState
					};
				}

				function proceed(resolvedHandlerInfo) {
					// Swap the previously unresolved handlerInfo with
					// the resolved handlerInfo
					currentState.handlerInfos[payload.resolveIndex++] = resolvedHandlerInfo;

					// Call the redirect hook. The reason we call it here
					// vs. afterModel is so that redirects into child
					// routes don't re-run the model hooks for this
					// already-resolved route.
					var handler = resolvedHandlerInfo.handler;
					if (handler && handler.redirect) {
						handler.redirect(resolvedHandlerInfo.context, payload);
					}

					// Proceed after ensuring that the redirect hook
					// didn't abort this transition by transitioning elsewhere.
					return innerShouldContinue().then(resolveOneHandlerInfo);
				}

				function resolveOneHandlerInfo() {
					if (payload.resolveIndex === currentState.handlerInfos.length) {
						// This is is the only possible
						// fulfill value of TransitionState#resolve
						return {
							error: null,
							state: currentState
						};
					}

					var handlerInfo = currentState.handlerInfos[payload.resolveIndex];

					return handlerInfo.resolve(async, innerShouldContinue, payload)
														.then(proceed);
				}
			}
		};

		__exports__.TransitionState = TransitionState;
	});
define("router/transition",
	["rsvp","./handler-info","./utils","exports"],
	function(__dependency1__, __dependency2__, __dependency3__, __exports__) {
		"use strict";
		var reject = __dependency1__.reject;
		var resolve = __dependency1__.resolve;
		var ResolvedHandlerInfo = __dependency2__.ResolvedHandlerInfo;
		var trigger = __dependency3__.trigger;
		var slice = __dependency3__.slice;
		var log = __dependency3__.log;

		/**
			@private

			A Transition is a thennable (a promise-like object) that represents
			an attempt to transition to another route. It can be aborted, either
			explicitly via `abort` or by attempting another transition while a
			previous one is still underway. An aborted transition can also
			be `retry()`d later.
		 */
		function Transition(router, intent, state, error) {
			var transition = this;
			this.state = state || router.state;
			this.intent = intent;
			this.router = router;
			this.data = this.intent && this.intent.data || {};
			this.resolvedModels = {};
			this.queryParams = {};

			if (error) {
				this.promise = reject(error);
				return;
			}

			if (state) {
				this.params = state.params;
				this.queryParams = state.queryParams;

				var len = state.handlerInfos.length;
				if (len) {
					this.targetName = state.handlerInfos[state.handlerInfos.length-1].name;
				}

				for (var i = 0; i < len; ++i) {
					var handlerInfo = state.handlerInfos[i];
					if (!(handlerInfo instanceof ResolvedHandlerInfo)) {
						break;
					}
					this.pivotHandler = handlerInfo.handler;
				}

				this.sequence = Transition.currentSequence++;
				this.promise = state.resolve(router.async, checkForAbort, this)['catch'](function(result) {
					if (result.wasAborted) {
						throw logAbort(transition);
					} else {
						transition.trigger('error', result.error, transition, result.handlerWithError);
						transition.abort();
						throw result.error;
					}
				});
			} else {
				this.promise = resolve(this.state);
				this.params = {};
			}

			function checkForAbort() {
				if (transition.isAborted) {
					return reject();
				}
			}
		}

		Transition.currentSequence = 0;

		Transition.prototype = {
			targetName: null,
			urlMethod: 'update',
			intent: null,
			params: null,
			pivotHandler: null,
			resolveIndex: 0,
			handlerInfos: null,
			resolvedModels: null,
			isActive: true,
			state: null,

			/**
				@public

				The Transition's internal promise. Calling `.then` on this property
				is that same as calling `.then` on the Transition object itself, but
				this property is exposed for when you want to pass around a
				Transition's promise, but not the Transition object itself, since
				Transition object can be externally `abort`ed, while the promise
				cannot.
			 */
			promise: null,

			/**
				@public

				Custom state can be stored on a Transition's `data` object.
				This can be useful for decorating a Transition within an earlier
				hook and shared with a later hook. Properties set on `data` will
				be copied to new transitions generated by calling `retry` on this
				transition.
			 */
			data: null,

			/**
				@public

				A standard promise hook that resolves if the transition
				succeeds and rejects if it fails/redirects/aborts.

				Forwards to the internal `promise` property which you can
				use in situations where you want to pass around a thennable,
				but not the Transition itself.

				@param {Function} success
				@param {Function} failure
			 */
			then: function(success, failure) {
				return this.promise.then(success, failure);
			},

			/**
				@public

				Aborts the Transition. Note you can also implicitly abort a transition
				by initiating another transition while a previous one is underway.
			 */
			abort: function() {
				if (this.isAborted) { return this; }
				log(this.router, this.sequence, this.targetName + ": transition was aborted");
				this.isAborted = true;
				this.isActive = false;
				this.router.activeTransition = null;
				return this;
			},

			/**
				@public

				Retries a previously-aborted transition (making sure to abort the
				transition if it's still active). Returns a new transition that
				represents the new attempt to transition.
			 */
			retry: function() {
				// TODO: add tests for merged state retry()s
				this.abort();
				return this.router.transitionByIntent(this.intent, false);
			},

			/**
				@public

				Sets the URL-changing method to be employed at the end of a
				successful transition. By default, a new Transition will just
				use `updateURL`, but passing 'replace' to this method will
				cause the URL to update using 'replaceWith' instead. Omitting
				a parameter will disable the URL change, allowing for transitions
				that don't update the URL at completion (this is also used for
				handleURL, since the URL has already changed before the
				transition took place).

				@param {String} method the type of URL-changing method to use
					at the end of a transition. Accepted values are 'replace',
					falsy values, or any other non-falsy value (which is
					interpreted as an updateURL transition).

				@return {Transition} this transition
			 */
			method: function(method) {
				this.urlMethod = method;
				return this;
			},

			/**
				@public

				Fires an event on the current list of resolved/resolving
				handlers within this transition. Useful for firing events
				on route hierarchies that haven't fully been entered yet.

				Note: This method is also aliased as `send`

				@param {Boolean} ignoreFailure the name of the event to fire
				@param {String} name the name of the event to fire
			 */
			trigger: function (ignoreFailure) {
				var args = slice.call(arguments);
				if (typeof ignoreFailure === 'boolean') {
					args.shift();
				} else {
					// Throw errors on unhandled trigger events by default
					ignoreFailure = false;
				}
				trigger(this.router, this.state.handlerInfos.slice(0, this.resolveIndex + 1), ignoreFailure, args);
			},

			/**
				@public

				Transitions are aborted and their promises rejected
				when redirects occur; this method returns a promise
				that will follow any redirects that occur and fulfill
				with the value fulfilled by any redirecting transitions
				that occur.

				@return {Promise} a promise that fulfills with the same
					value that the final redirecting transition fulfills with
			 */
			followRedirects: function() {
				var router = this.router;
				return this.promise['catch'](function(reason) {
					if (router.activeTransition) {
						return router.activeTransition.followRedirects();
					}
					throw reason;
				});
			},

			toString: function() {
				return "Transition (sequence " + this.sequence + ")";
			},

			/**
				@private
			 */
			log: function(message) {
				log(this.router, this.sequence, message);
			}
		};

		// Alias 'trigger' as 'send'
		Transition.prototype.send = Transition.prototype.trigger;

		/**
			@private

			Logs and returns a TransitionAborted error.
		 */
		function logAbort(transition) {
			log(transition.router, transition.sequence, "detected abort.");
			return new TransitionAborted();
		}

		function TransitionAborted(message) {
			this.message = (message || "TransitionAborted");
			this.name = "TransitionAborted";
		}

		__exports__.Transition = Transition;
		__exports__.logAbort = logAbort;
		__exports__.TransitionAborted = TransitionAborted;
	});
define("router/utils",
	["exports"],
	function(__exports__) {
		"use strict";
		var slice = Array.prototype.slice;

		function merge(hash, other) {
			for (var prop in other) {
				if (other.hasOwnProperty(prop)) { hash[prop] = other[prop]; }
			}
		}

		var oCreate = Object.create || function(proto) {
			function F() {}
			F.prototype = proto;
			return new F();
		};

		/**
			@private

			Extracts query params from the end of an array
		**/
		function extractQueryParams(array) {
			var len = (array && array.length), head, queryParams;

			if(len && len > 0 && array[len - 1] && array[len - 1].hasOwnProperty('queryParams')) {
				queryParams = array[len - 1].queryParams;
				head = slice.call(array, 0, len - 1);
				return [head, queryParams];
			} else {
				return [array, null];
			}
		}

		/**
			@private
		 */
		function log(router, sequence, msg) {
			if (!router.log) { return; }

			if (arguments.length === 3) {
				router.log("Transition #" + sequence + ": " + msg);
			} else {
				msg = sequence;
				router.log(msg);
			}
		}

		function bind(fn, context) {
			var boundArgs = arguments;
			return function(value) {
				var args = slice.call(boundArgs, 2);
				args.push(value);
				return fn.apply(context, args);
			};
		}

		function isParam(object) {
			return (typeof object === "string" || object instanceof String || typeof object === "number" || object instanceof Number);
		}


		function forEach(array, callback) {
			for (var i=0, l=array.length; i<l && false !== callback(array[i]); i++) { }
		}

		/**
			@private

			Serializes a handler using its custom `serialize` method or
			by a default that looks up the expected property name from
			the dynamic segment.

			@param {Object} handler a router handler
			@param {Object} model the model to be serialized for this handler
			@param {Array[Object]} names the names array attached to an
				handler object returned from router.recognizer.handlersFor()
		*/
		function serialize(handler, model, names) {
			var object = {};
			if (isParam(model)) {
				object[names[0]] = model;
				return object;
			}

			// Use custom serialize if it exists.
			if (handler.serialize) {
				return handler.serialize(model, names);
			}

			if (names.length !== 1) { return; }

			var name = names[0];

			if (/_id$/.test(name)) {
				object[name] = model.id;
			} else {
				object[name] = model;
			}
			return object;
		}

		function trigger(router, handlerInfos, ignoreFailure, args) {
			if (router.triggerEvent) {
				router.triggerEvent(handlerInfos, ignoreFailure, args);
				return;
			}

			var name = args.shift();

			if (!handlerInfos) {
				if (ignoreFailure) { return; }
				throw new Error("Could not trigger event '" + name + "'. There are no active handlers");
			}

			var eventWasHandled = false;

			for (var i=handlerInfos.length-1; i>=0; i--) {
				var handlerInfo = handlerInfos[i],
						handler = handlerInfo.handler;

				if (handler.events && handler.events[name]) {
					if (handler.events[name].apply(handler, args) === true) {
						eventWasHandled = true;
					} else {
						return;
					}
				}
			}

			if (!eventWasHandled && !ignoreFailure) {
				throw new Error("Nothing handled the event '" + name + "'.");
			}
		}


		function getChangelist(oldObject, newObject) {
			var key;
			var results = {
				all: {},
				changed: {},
				removed: {}
			};

			merge(results.all, newObject);

			var didChange = false;

			// Calculate removals
			for (key in oldObject) {
				if (oldObject.hasOwnProperty(key)) {
					if (!newObject.hasOwnProperty(key)) {
						didChange = true;
						results.removed[key] = oldObject[key];
					}
				}
			}

			// Calculate changes
			for (key in newObject) {
				if (newObject.hasOwnProperty(key)) {
					if (oldObject[key] !== newObject[key]) {
						results.changed[key] = newObject[key];
						didChange = true;
					}
				}
			}

			return didChange && results;
		}

		__exports__.trigger = trigger;
		__exports__.log = log;
		__exports__.oCreate = oCreate;
		__exports__.merge = merge;
		__exports__.extractQueryParams = extractQueryParams;
		__exports__.bind = bind;
		__exports__.isParam = isParam;
		__exports__.forEach = forEach;
		__exports__.slice = slice;
		__exports__.serialize = serialize;
		__exports__.getChangelist = getChangelist;
	});
define("router",
	["./router/router","exports"],
	function(__dependency1__, __exports__) {
		"use strict";
		var Router = __dependency1__.Router;

		__exports__.Router = Router;
	});
})();



(function() {
/**
@module ember
@submodule ember-routing
*/

function DSL(name) {
	this.parent = name;
	this.matches = [];
}

DSL.prototype = {
	resource: function(name, options, callback) {
		if (arguments.length === 2 && typeof options === 'function') {
			callback = options;
			options = {};
		}

		if (arguments.length === 1) {
			options = {};
		}

		if (typeof options.path !== 'string') {
			options.path = "/" + name;
		}

		if (callback) {
			var dsl = new DSL(name);
			route(dsl, 'loading');
			route(dsl, 'error', { path: "/_unused_dummy_error_path_route_" + name + "/:error" });
			callback.call(dsl);
			this.push(options.path, name, dsl.generate(), options.queryParams);
		} else {
			this.push(options.path, name, null, options.queryParams);
		}


		if (Ember.FEATURES.isEnabled("ember-routing-named-substates")) {
			// For namespace-preserving nested resource (e.g. resource('foo.bar') within
			// resource('foo')) we only want to use the last route name segment to determine
			// the names of the error/loading substates (e.g. 'bar_loading')
			name = name.split('.').pop();
			route(this, name + '_loading');
			route(this, name + '_error', { path: "/_unused_dummy_error_path_route_" + name + "/:error" });
		}
	},

	push: function(url, name, callback, queryParams) {
		var parts = name.split('.');
		if (url === "" || url === "/" || parts[parts.length-1] === "index") { this.explicitIndex = true; }

		this.matches.push([url, name, callback, queryParams]);
	},

	route: function(name, options) {
		route(this, name, options);
		if (Ember.FEATURES.isEnabled("ember-routing-named-substates")) {
			route(this, name + '_loading');
			route(this, name + '_error', { path: "/_unused_dummy_error_path_route_" + name + "/:error" });
		}
	},

	generate: function() {
		var dslMatches = this.matches;

		if (!this.explicitIndex) {
			this.route("index", { path: "/" });
		}

		return function(match) {
			for (var i=0, l=dslMatches.length; i<l; i++) {
				var dslMatch = dslMatches[i];
				var matchObj = match(dslMatch[0]).to(dslMatch[1], dslMatch[2]);
			}
		};
	}
};

function route(dsl, name, options) {

	options = options || {};

	if (typeof options.path !== 'string') {
		options.path = "/" + name;
	}

	if (dsl.parent && dsl.parent !== 'application') {
		name = dsl.parent + "." + name;
	}

	dsl.push(options.path, name, null, options.queryParams);
}

DSL.map = function(callback) {
	var dsl = new DSL();
	callback.call(dsl);
	return dsl;
};

Ember.RouterDSL = DSL;

})();



(function() {
var get = Ember.get;

/**
@module ember
@submodule ember-routing
*/

/**

	Finds a controller instance.

	@for Ember
	@method controllerFor
	@private
*/
Ember.controllerFor = function(container, controllerName, lookupOptions) {
	return container.lookup('controller:' + controllerName, lookupOptions);
};

/**
	Generates a controller factory

	The type of the generated controller factory is derived
	from the context. If the context is an array an array controller
	is generated, if an object, an object controller otherwise, a basic
	controller is generated.

	You can customize your generated controllers by defining
	`App.ObjectController` or `App.ArrayController`.

	@for Ember
	@method generateControllerFactory
	@private
*/
Ember.generateControllerFactory = function(container, controllerName, context) {
	var Factory, fullName, instance, name, factoryName, controllerType;

	if (context && Ember.isArray(context)) {
		controllerType = 'array';
	} else if (context) {
		controllerType = 'object';
	} else {
		controllerType = 'basic';
	}

	factoryName = 'controller:' + controllerType;

	Factory = container.lookupFactory(factoryName).extend({
		isGenerated: true,
		toString: function() {
			return "(generated " + controllerName + " controller)";
		}
	});

	fullName = 'controller:' + controllerName;

	container.register(fullName,  Factory);

	return Factory;
};

/**
	Generates and instantiates a controller.

	The type of the generated controller factory is derived
	from the context. If the context is an array an array controller
	is generated, if an object, an object controller otherwise, a basic
	controller is generated.

	@for Ember
	@method generateController
	@private
*/
Ember.generateController = function(container, controllerName, context) {
	Ember.generateControllerFactory(container, controllerName, context);
	var fullName = 'controller:' + controllerName;
	var instance = container.lookup(fullName);

	if (get(instance, 'namespace.LOG_ACTIVE_GENERATION')) {
			}

	return instance;
};

})();



(function() {
/**
@module ember
@submodule ember-routing
*/

var routerJsModule = requireModule("router");
var Router = routerJsModule.Router;
var Transition = routerJsModule.Transition;
var get = Ember.get, set = Ember.set, fmt = Ember.String.fmt;
var defineProperty = Ember.defineProperty;
var slice = Array.prototype.slice;
var forEach = Ember.EnumerableUtils.forEach;

var DefaultView = Ember._MetamorphView;
/**
	The `Ember.Router` class manages the application state and URLs. Refer to
	the [routing guide](http://emberjs.com/guides/routing/) for documentation.

	@class Router
	@namespace Ember
	@extends Ember.Object
*/
Ember.Router = Ember.Object.extend(Ember.Evented, {
	/**
		The `location` property determines the type of URL's that your
		application will use.

		The following location types are currently available:

		* `hash`
		* `history`
		* `none`

		@property location
		@default 'hash'
		@see {Ember.Location}
	*/
	location: 'hash',

	init: function() {
		this.router = this.constructor.router || this.constructor.map(Ember.K);
		this._activeViews = {};
		this._setupLocation();

		if (get(this, 'namespace.LOG_TRANSITIONS_INTERNAL')) {
			this.router.log = Ember.Logger.debug;
		}
	},

	/**
		Represents the current URL.

		@method url
		@returns {String} The current URL.
	*/
	url: Ember.computed(function() {
		return get(this, 'location').getURL();
	}),

	/**
		Initializes the current router instance and sets up the change handling
		event listeners used by the instances `location` implementation.

		@method startRouting
		@private
	*/
	startRouting: function() {
		this.router = this.router || this.constructor.map(Ember.K);

		var router = this.router,
				location = get(this, 'location'),
				container = this.container,
				self = this;

		this._setupRouter(router, location);

		container.register('view:default', DefaultView);
		container.register('view:toplevel', Ember.View.extend());

		location.onUpdateURL(function(url) {
			self.handleURL(url);
		});

		this.handleURL(location.getURL());
	},

	/**
		Handles updating the paths and notifying any listeners of the URL
		change.

		Triggers the router level `didTransition` hook.

		@method didTransition
		@private
	*/
	didTransition: function(infos) {
		updatePaths(this);

		this._cancelLoadingEvent();

		this.notifyPropertyChange('url');

		// Put this in the runloop so url will be accurate. Seems
		// less surprising than didTransition being out of sync.
		Ember.run.once(this, this.trigger, 'didTransition');

		if (get(this, 'namespace').LOG_TRANSITIONS) {
			Ember.Logger.log("Transitioned into '" + Ember.Router._routePath(infos) + "'");
		}
	},

	handleURL: function(url) {
		return this._doTransition('handleURL', [url]);
	},

	transitionTo: function() {
		return this._doTransition('transitionTo', arguments);
	},

	intermediateTransitionTo: function() {
		this.router.intermediateTransitionTo.apply(this.router, arguments);

		updatePaths(this);

		var infos = this.router.currentHandlerInfos;
		if (get(this, 'namespace').LOG_TRANSITIONS) {
			Ember.Logger.log("Intermediate-transitioned into '" + Ember.Router._routePath(infos) + "'");
		}
	},

	replaceWith: function() {
		return this._doTransition('replaceWith', arguments);
	},

	generate: function() {
		var url = this.router.generate.apply(this.router, arguments);
		return this.location.formatURL(url);
	},

	/**
		Determines if the supplied route is currently active.

		@method isActive
		@param routeName
		@returns {Boolean}
		@private
	*/
	isActive: function(routeName) {
		var router = this.router;
		return router.isActive.apply(router, arguments);
	},

	send: function(name, context) {
		this.router.trigger.apply(this.router, arguments);
	},

	/**
		Does this router instance have the given route.

		@method hasRoute
		@returns {Boolean}
		@private
	*/
	hasRoute: function(route) {
		return this.router.hasRoute(route);
	},

	/**
		Resets the state of the router by clearing the current route
		handlers and deactivating them.

		@private
		@method reset
	 */
	reset: function() {
		this.router.reset();
	},

	_lookupActiveView: function(templateName) {
		var active = this._activeViews[templateName];
		return active && active[0];
	},

	_connectActiveView: function(templateName, view) {
		var existing = this._activeViews[templateName];

		if (existing) {
			existing[0].off('willDestroyElement', this, existing[1]);
		}

		var disconnect = function() {
			delete this._activeViews[templateName];
		};

		this._activeViews[templateName] = [view, disconnect];
		view.one('willDestroyElement', this, disconnect);
	},

	_setupLocation: function() {
		var location = get(this, 'location'),
				rootURL = get(this, 'rootURL');

		if ('string' === typeof location && this.container) {
			var resolvedLocation = this.container.lookup('location:' + location);

			if ('undefined' !== typeof resolvedLocation) {
				location = set(this, 'location', resolvedLocation);
			} else {
				// Allow for deprecated registration of custom location API's
				var options = {implementation: location};

				location = set(this, 'location', Ember.Location.create(options));
			}
		}

		if (typeof rootURL === 'string') {
			location.rootURL = rootURL;
		}

		// ensure that initState is called AFTER the rootURL is set on
		// the location instance
		if (typeof location.initState === 'function') { location.initState(); }
	},

	_getHandlerFunction: function() {
		var seen = {}, container = this.container,
				DefaultRoute = container.lookupFactory('route:basic'),
				self = this;

		return function(name) {
			var routeName = 'route:' + name,
					handler = container.lookup(routeName);

			if (seen[name]) { return handler; }

			seen[name] = true;

			if (!handler) {
				container.register(routeName, DefaultRoute.extend());
				handler = container.lookup(routeName);

				if (get(self, 'namespace.LOG_ACTIVE_GENERATION')) {
									}
			}

			handler.routeName = name;
			return handler;
		};
	},

	_setupRouter: function(router, location) {
		var lastURL, emberRouter = this;

		router.getHandler = this._getHandlerFunction();

		var doUpdateURL = function() {
			location.setURL(lastURL);
		};

		router.updateURL = function(path) {
			lastURL = path;
			Ember.run.once(doUpdateURL);
		};

		if (location.replaceURL) {
			var doReplaceURL = function() {
				location.replaceURL(lastURL);
			};

			router.replaceURL = function(path) {
				lastURL = path;
				Ember.run.once(doReplaceURL);
			};
		}

		router.didTransition = function(infos) {
			emberRouter.didTransition(infos);
		};
	},

	_doTransition: function(method, args) {
		// Normalize blank route to root URL.
		args = slice.call(args);
		args[0] = args[0] || '/';

		var passedName = args[0], name, self = this,
			isQueryParamsOnly = false, queryParams;

		if (Ember.FEATURES.isEnabled("query-params-new")) {
			if (args[args.length - 1].hasOwnProperty('queryParams')) {
				if (args.length === 1) {
					isQueryParamsOnly = true;
				}
				queryParams = args[args.length - 1].queryParams;
			}
		}

		if (!isQueryParamsOnly && passedName.charAt(0) !== '/') {
			if (!this.router.hasRoute(passedName)) {
				name = args[0] = passedName + '.index';
			} else {
				name = passedName;
			}

					}

		if (queryParams) {
			// router.js expects queryParams to be passed in in
			// their final serialized form, so we need to translate.

			if (!name) {
				// Need to determine destination route name.
				var handlerInfos = this.router.activeTransition ?
													 this.router.activeTransition.state.handlerInfos :
													 this.router.state.handlerInfos;
				name = handlerInfos[handlerInfos.length - 1].name;
				args.unshift(name);
			}

			var qpMappings = this._queryParamNamesFor(name);
			Ember.Router._translateQueryParams(queryParams, qpMappings.translations, name);
			for (var key in queryParams) {
				if (key in qpMappings.queryParams) {
					var value = queryParams[key];
					delete queryParams[key];
					queryParams[qpMappings.queryParams[key]] = value;
				}
			}
		}

		var transitionPromise = this.router[method].apply(this.router, args);

		transitionPromise.then(null, function(error) {
			if (error && error.name === "UnrecognizedURLError") {
							}
		}, 'Ember: Check for Router unrecognized URL error');

		// We want to return the configurable promise object
		// so that callers of this function can use `.method()` on it,
		// which obviously doesn't exist for normal RSVP promises.
		return transitionPromise;
	},

	_scheduleLoadingEvent: function(transition, originRoute) {
		this._cancelLoadingEvent();
		this._loadingStateTimer = Ember.run.scheduleOnce('routerTransitions', this, '_fireLoadingEvent', transition, originRoute);
	},

	_fireLoadingEvent: function(transition, originRoute) {
		if (!this.router.activeTransition) {
			// Don't fire an event if we've since moved on from
			// the transition that put us in a loading state.
			return;
		}

		transition.trigger(true, 'loading', transition, originRoute);
	},

	_cancelLoadingEvent: function () {
		if (this._loadingStateTimer) {
			Ember.run.cancel(this._loadingStateTimer);
		}
		this._loadingStateTimer = null;
	},

	_queryParamNamesFor: function(routeName) {

		// TODO: add caching

		routeName = this.router.hasRoute(routeName) ? routeName : routeName + '.index';

		var handlerInfos = this.router.recognizer.handlersFor(routeName);
		var result = { queryParams: Ember.create(null), translations: Ember.create(null) };
		var routerjs = this.router;
		forEach(handlerInfos, function(recogHandler) {
			var route = routerjs.getHandler(recogHandler.handler);
			getQueryParamsForRoute(route, result);
		});

		return result;
	},

	_queryParamNamesForSingle: function(routeName) {

		// TODO: add caching

		var result = { queryParams: Ember.create(null), translations: Ember.create(null) };
		var route = this.router.getHandler(routeName);

		getQueryParamsForRoute(route, result);

		return result;
	},

	/**
		@private

		Utility function for fetching all the current query params
		values from a controller.
	 */
	_queryParamOverrides: function(results, queryParams, callback) {
		for (var name in queryParams) {
			var parts = name.split(':');
			var controller = this.container.lookup('controller:' + parts[0]);

			// Now assign the final URL-serialized key-value pair,
			// e.g. "foo[propName]": "value"
			results[queryParams[name]] = get(controller, parts[1]);

			if (callback) {
				// Give callback a chance to override.
				callback(name, queryParams[name], name);
			}
		}
	}
});

/**
	@private
 */
function getQueryParamsForRoute(route, result) {
	var controllerName = route.controllerName || route.routeName,
			controller = route.controllerFor(controllerName, true);

	if (controller && controller.queryParams) {
		forEach(controller.queryParams, function(propName) {

			var parts = propName.split(':');

			var urlKeyName;
			if (parts.length > 1) {
				urlKeyName = parts[1];
			} else {
				// TODO: use _queryParamScope here?
				if (controllerName !== 'application') {
					urlKeyName = controllerName + '[' + propName + ']';
				} else {
					urlKeyName = propName;
				}
			}

			var controllerFullname = controllerName + ':' + propName;

			result.queryParams[controllerFullname] = urlKeyName;
			result.translations[parts[0]] = controllerFullname;
		});
	}
}

/**
	Helper function for iterating root-ward, starting
	from (but not including) the provided `originRoute`.

	Returns true if the last callback fired requested
	to bubble upward.

	@private
 */
function forEachRouteAbove(originRoute, transition, callback) {
	var handlerInfos = transition.state.handlerInfos,
			originRouteFound = false;

	for (var i = handlerInfos.length - 1; i >= 0; --i) {
		var handlerInfo = handlerInfos[i],
				route = handlerInfo.handler;

		if (!originRouteFound) {
			if (originRoute === route) {
				originRouteFound = true;
			}
			continue;
		}

		if (callback(route, handlerInfos[i + 1].handler) !== true) {
			return false;
		}
	}
	return true;
}

// These get invoked when an action bubbles above ApplicationRoute
// and are not meant to be overridable.
var defaultActionHandlers = {

	willResolveModel: function(transition, originRoute) {
		originRoute.router._scheduleLoadingEvent(transition, originRoute);
	},

	error: function(error, transition, originRoute) {
		// Attempt to find an appropriate error substate to enter.
		var router = originRoute.router;

		var tryTopLevel = forEachRouteAbove(originRoute, transition, function(route, childRoute) {
			var childErrorRouteName = findChildRouteName(route, childRoute, 'error');
			if (childErrorRouteName) {
				router.intermediateTransitionTo(childErrorRouteName, error);
				return;
			}
			return true;
		});

		if (tryTopLevel) {
			// Check for top-level error state to enter.
			if (routeHasBeenDefined(originRoute.router, 'application_error')) {
				router.intermediateTransitionTo('application_error', error);
				return;
			}
		} else {
			// Don't fire an assertion if we found an error substate.
			return;
		}

		Ember.Logger.error('Error while loading route: ' + (error && error.stack));
	},

	loading: function(transition, originRoute) {
		// Attempt to find an appropriate loading substate to enter.
		var router = originRoute.router;

		var tryTopLevel = forEachRouteAbove(originRoute, transition, function(route, childRoute) {
			var childLoadingRouteName = findChildRouteName(route, childRoute, 'loading');

			if (childLoadingRouteName) {
				router.intermediateTransitionTo(childLoadingRouteName);
				return;
			}

			// Don't bubble above pivot route.
			if (transition.pivotHandler !== route) {
				return true;
			}
		});

		if (tryTopLevel) {
			// Check for top-level loading state to enter.
			if (routeHasBeenDefined(originRoute.router, 'application_loading')) {
				router.intermediateTransitionTo('application_loading');
				return;
			}
		}
	}
};

function findChildRouteName(parentRoute, originatingChildRoute, name) {
	var router = parentRoute.router,
			childName,
			targetChildRouteName = originatingChildRoute.routeName.split('.').pop(),
			namespace = parentRoute.routeName === 'application' ? '' : parentRoute.routeName + '.';

	if (Ember.FEATURES.isEnabled("ember-routing-named-substates")) {
		// First, try a named loading state, e.g. 'foo_loading'
		childName = namespace + targetChildRouteName + '_' + name;
		if (routeHasBeenDefined(router, childName)) {
			return childName;
		}
	}

	// Second, try general loading state, e.g. 'loading'
	childName = namespace + name;
	if (routeHasBeenDefined(router, childName)) {
		return childName;
	}
}

function routeHasBeenDefined(router, name) {
	var container = router.container;
	return router.hasRoute(name) &&
				 (container.has('template:' + name) || container.has('route:' + name));
}

function triggerEvent(handlerInfos, ignoreFailure, args) {
	var name = args.shift();

	if (!handlerInfos) {
		if (ignoreFailure) { return; }
		throw new Ember.Error("Can't trigger action '" + name + "' because your app hasn't finished transitioning into its first route. To trigger an action on destination routes during a transition, you can call `.send()` on the `Transition` object passed to the `model/beforeModel/afterModel` hooks.");
	}

	var eventWasHandled = false;

	for (var i = handlerInfos.length - 1; i >= 0; i--) {
		var handlerInfo = handlerInfos[i],
				handler = handlerInfo.handler;

		if (handler._actions && handler._actions[name]) {
			if (handler._actions[name].apply(handler, args) === true) {
				eventWasHandled = true;
			} else {
				return;
			}
		}
	}

	if (defaultActionHandlers[name]) {
		defaultActionHandlers[name].apply(null, args);
		return;
	}

	if (!eventWasHandled && !ignoreFailure) {
		throw new Ember.Error("Nothing handled the action '" + name + "'. If you did handle the action, this error can be caused by returning true from an action handler in a controller, causing the action to bubble.");
	}
}

function updatePaths(router) {
	var appController = router.container.lookup('controller:application');

	if (!appController) {
		// appController might not exist when top-level loading/error
		// substates have been entered since ApplicationRoute hasn't
		// actually been entered at that point.
		return;
	}

	var infos = router.router.currentHandlerInfos,
			path = Ember.Router._routePath(infos);

	if (!('currentPath' in appController)) {
		defineProperty(appController, 'currentPath');
	}

	set(appController, 'currentPath', path);

	if (!('currentRouteName' in appController)) {
		defineProperty(appController, 'currentRouteName');
	}

	set(appController, 'currentRouteName', infos[infos.length - 1].name);
}

Ember.Router.reopenClass({
	router: null,
	map: function(callback) {
		var router = this.router;
		if (!router) {
			router = new Router();
			router.callbacks = [];
			router.triggerEvent = triggerEvent;
			this.reopenClass({ router: router });
		}

		var dsl = Ember.RouterDSL.map(function() {
			this.resource('application', { path: "/" }, function() {
				for (var i=0; i < router.callbacks.length; i++) {
					router.callbacks[i].call(this);
				}
				callback.call(this);
			});
		});

		router.callbacks.push(callback);
		router.map(dsl.generate());
		return router;
	},

	_routePath: function(handlerInfos) {
		var path = [];

		// We have to handle coalescing resource names that
		// are prefixed with their parent's names, e.g.
		// ['foo', 'foo.bar.baz'] => 'foo.bar.baz', not 'foo.foo.bar.baz'

		function intersectionMatches(a1, a2) {
			for (var i = 0, len = a1.length; i < len; ++i) {
				if (a1[i] !== a2[i]) {
					return false;
				}
			}
			return true;
		}

		for (var i=1, l=handlerInfos.length; i<l; i++) {
			var name = handlerInfos[i].name,
					nameParts = name.split("."),
					oldNameParts = slice.call(path);

			while (oldNameParts.length) {
				if (intersectionMatches(oldNameParts, nameParts)) {
					break;
				}
				oldNameParts.shift();
			}

			path.push.apply(path, nameParts.slice(oldNameParts.length));
		}

		return path.join(".");
	},

	_translateQueryParams: function(queryParams, translations, routeName) {
		for (var name in queryParams) {
			if (!queryParams.hasOwnProperty(name)) { continue; }

			if (name in translations) {
				queryParams[translations[name]] = queryParams[name];
				delete queryParams[name];
			} else {
							}
		}
	}
});



})();



(function() {
/**
@module ember
@submodule ember-routing
*/

var get = Ember.get, set = Ember.set,
		getProperties = Ember.getProperties,
		classify = Ember.String.classify,
		fmt = Ember.String.fmt,
		a_forEach = Ember.EnumerableUtils.forEach,
		a_replace = Ember.EnumerableUtils.replace;


/**
	The `Ember.Route` class is used to define individual routes. Refer to
	the [routing guide](http://emberjs.com/guides/routing/) for documentation.

	@class Route
	@namespace Ember
	@extends Ember.Object
	@uses Ember.ActionHandler
*/
Ember.Route = Ember.Object.extend(Ember.ActionHandler, {

	/**
		@private

		@method exit
	*/
	exit: function() {
		if (Ember.FEATURES.isEnabled("query-params-new")) {
			this.controller._deactivateQueryParamObservers();
		}
		this.deactivate();
		this.teardownViews();
	},

	/**
		@private

		@method enter
	*/
	enter: function() {
		this.activate();
	},

	/**
		The collection of functions, keyed by name, available on this route as
		action targets.

		These functions will be invoked when a matching `{{action}}` is triggered
		from within a template and the application's current route is this route.

		Actions can also be invoked from other parts of your application via `Route#send`
		or `Controller#send`.

		The `actions` hash will inherit action handlers from
		the `actions` hash defined on extended Route parent classes
		or mixins rather than just replace the entire hash, e.g.:

		```js
		App.CanDisplayBanner = Ember.Mixin.create({
			actions: {
				displayBanner: function(msg) {
					// ...
				}
			}
		});

		App.WelcomeRoute = Ember.Route.extend(App.CanDisplayBanner, {
			actions: {
				playMusic: function() {
					// ...
				}
			}
		});

		// `WelcomeRoute`, when active, will be able to respond
		// to both actions, since the actions hash is merged rather
		// then replaced when extending mixins / parent classes.
		this.send('displayBanner');
		this.send('playMusic');
		```

		Within a route's action handler, the value of the `this` context
		is the Route object:

		```js
		App.SongRoute = Ember.Route.extend({
			actions: {
				myAction: function() {
					this.controllerFor("song");
					this.transitionTo("other.route");
					...
				}
			}
		});
		```

		It is also possible to call `this._super()` from within an
		action handler if it overrides a handler defined on a parent
		class or mixin:

		Take for example the following routes:

		```js
		App.DebugRoute = Ember.Mixin.create({
			actions: {
				debugRouteInformation: function() {
					console.debug("trololo");
				}
			}
		});

		App.AnnoyingDebugRoute = Ember.Route.extend(App.DebugRoute, {
			actions: {
				debugRouteInformation: function() {
					// also call the debugRouteInformation of mixed in App.DebugRoute
					this._super();

					// show additional annoyance
					window.alert(...);
				}
			}
		});
		```

		## Bubbling

		By default, an action will stop bubbling once a handler defined
		on the `actions` hash handles it. To continue bubbling the action,
		you must return `true` from the handler:

		```js
		App.Router.map(function() {
			this.resource("album", function() {
				this.route("song");
			});
		});

		App.AlbumRoute = Ember.Route.extend({
			actions: {
				startPlaying: function() {
				}
			}
		});

		App.AlbumSongRoute = Ember.Route.extend({
			actions: {
				startPlaying: function() {
					// ...

					if (actionShouldAlsoBeTriggeredOnParentRoute) {
						return true;
					}
				}
			}
		});
		```

		## Built-in actions

		There are a few built-in actions pertaining to transitions that you
		can use to customize transition behavior: `willTransition` and
		`error`.

		### `willTransition`

		The `willTransition` action is fired at the beginning of any
		attempted transition with a `Transition` object as the sole
		argument. This action can be used for aborting, redirecting,
		or decorating the transition from the currently active routes.

		A good example is preventing navigation when a form is
		half-filled out:

		```js
		App.ContactFormRoute = Ember.Route.extend({
			actions: {
				willTransition: function(transition) {
					if (this.controller.get('userHasEnteredData')) {
						this.controller.displayNavigationConfirm();
						transition.abort();
					}
				}
			}
		});
		```

		You can also redirect elsewhere by calling
		`this.transitionTo('elsewhere')` from within `willTransition`.
		Note that `willTransition` will not be fired for the
		redirecting `transitionTo`, since `willTransition` doesn't
		fire when there is already a transition underway. If you want
		subsequent `willTransition` actions to fire for the redirecting
		transition, you must first explicitly call
		`transition.abort()`.

		### `error`

		When attempting to transition into a route, any of the hooks
		may return a promise that rejects, at which point an `error`
		action will be fired on the partially-entered routes, allowing
		for per-route error handling logic, or shared error handling
		logic defined on a parent route.

		Here is an example of an error handler that will be invoked
		for rejected promises from the various hooks on the route,
		as well as any unhandled errors from child routes:

		```js
		App.AdminRoute = Ember.Route.extend({
			beforeModel: function() {
				return Ember.RSVP.reject("bad things!");
			},

			actions: {
				error: function(error, transition) {
					// Assuming we got here due to the error in `beforeModel`,
					// we can expect that error === "bad things!",
					// but a promise model rejecting would also
					// call this hook, as would any errors encountered
					// in `afterModel`.

					// The `error` hook is also provided the failed
					// `transition`, which can be stored and later
					// `.retry()`d if desired.

					this.transitionTo('login');
				}
			}
		});
		```

		`error` actions that bubble up all the way to `ApplicationRoute`
		will fire a default error handler that logs the error. You can
		specify your own global default error handler by overriding the
		`error` handler on `ApplicationRoute`:

		```js
		App.ApplicationRoute = Ember.Route.extend({
			actions: {
				error: function(error, transition) {
					this.controllerFor('banner').displayError(error.message);
				}
			}
		});
		```

		@property actions
		@type Hash
		@default null
	*/
	_actions: {
		finalizeQueryParamChange: function(params, finalParams) {
			if (Ember.FEATURES.isEnabled("query-params-new")) {
				// In this hook we receive a list of raw URL query
				// param changes. We need to take any

				var controller = this.controller;
				var changes = controller._queryParamChangesDuringSuspension;
				var queryParams = get(controller, '_queryParamHash');

				// Loop through all the query params that
				// this controller knows about.
				for (var k in queryParams) {
					if (queryParams.hasOwnProperty(k)) {

						// Do a reverse lookup to see if the changed query
						// param URL key corresponds to a QP property on
						// this controller.
						if (queryParams[k] in params) {
							// Update this controller property in a way that
							// won't fire observers.
							controller._finalizingQueryParams = true;
							if (!changes || !(k in changes)) {
								// Only update the controller if the query param
								// value wasn't overriden in setupController.

								// Arrays coming from router.js should be Emberized.
								var newValue = params[queryParams[k]];
								newValue = Ember.isArray(newValue) ? Ember.A(newValue) : newValue;
								set(controller, k, newValue);
							}
							controller._finalizingQueryParams = false;

							// Delete from params so that child routes
							// don't also try to respond to changes to
							// non-fully-qualified query param name changes.
							delete params[queryParams[k]];
						}

						// Query params are ordered. This action bubbles up
						// the route hierarchy so we unshift so that the final
						// order of query params goes from root to leaf.
						finalParams.unshift({
							key: queryParams[k],
							value: get(controller, k)
						});
					}
				}

				controller._queryParamChangesDuringSuspension = null;

				// Bubble so that parent routes can claim QPs.
				return true;
			}
		}
	},

	/**
		@deprecated

		Please use `actions` instead.
		@method events
	*/
	events: null,

	mergedProperties: ['events'],

	/**
		This hook is executed when the router completely exits this route. It is
		not executed when the model for the route changes.

		@method deactivate
	*/
	deactivate: Ember.K,

	/**
		This hook is executed when the router enters the route. It is not executed
		when the model for the route changes.

		@method activate
	*/
	activate: Ember.K,

	/**
		Transition into another route. Optionally supply model(s) for the
		route in question. If multiple models are supplied they will be applied
		last to first recursively up the resource tree (see Multiple Models Example
		below). The model(s) will be serialized into the URL using the appropriate
		route's `serialize` hook. See also 'replaceWith'.

		Simple Transition Example

		```javascript
		App.Router.map(function() {
			this.route("index");
			this.route("secret");
			this.route("fourOhFour", { path: "*:"});
		});

		App.IndexRoute = Ember.Route.extend({
			actions: {
				moveToSecret: function(context){
					if (authorized()){
						this.transitionTo('secret', context);
					}
						this.transitionTo('fourOhFour');
				}
			}
		});
		```

	 Transition to a nested route

	 ```javascript
	 App.Router.map(function() {
		 this.resource('articles', { path: '/articles' }, function() {
			 this.route('new');
		 });
	 });

	 App.IndexRoute = Ember.Route.extend({
		 actions: {
			 transitionToNewArticle: function() {
				 this.transitionTo('articles.new');
			 }
		 }
	 });
	 ```

		Multiple Models Example

		```javascript
		App.Router.map(function() {
			this.route("index");
			this.resource('breakfast', {path:':breakfastId'}, function(){
				this.resource('cereal', {path: ':cerealId'});
			});
		});

		App.IndexRoute = Ember.Route.extend({
			actions: {
				moveToChocolateCereal: function(){
					var cereal = { cerealId: "ChocolateYumminess"},
							breakfast = {breakfastId: "CerealAndMilk"};

					this.transitionTo('cereal', breakfast, cereal);
				}
			}
		});

		@method transitionTo
		@param {String} name the name of the route
		@param {...Object} models the model(s) to be used while transitioning
		to the route.
		@return {Transition} the transition object associated with this
			attempted transition
	*/
	transitionTo: function(name, context) {
		var router = this.router;
		return router.transitionTo.apply(router, arguments);
	},

	/**
		Perform a synchronous transition into another route without attempting
		to resolve promises, update the URL, or abort any currently active
		asynchronous transitions (i.e. regular transitions caused by
		`transitionTo` or URL changes).

		This method is handy for performing intermediate transitions on the
		way to a final destination route, and is called internally by the
		default implementations of the `error` and `loading` handlers.

		@method intermediateTransitionTo
		@param {String} name the name of the route
		@param {...Object} models the model(s) to be used while transitioning
		to the route.
	 */
	intermediateTransitionTo: function() {
		var router = this.router;
		router.intermediateTransitionTo.apply(router, arguments);
	},

	/**
		Refresh the model on this route and any child routes, firing the
		`beforeModel`, `model`, and `afterModel` hooks in a similar fashion
		to how routes are entered when transitioning in from other route.
		The current route params (e.g. `article_id`) will be passed in
		to the respective model hooks, and if a different model is returned,
		`setupController` and associated route hooks will re-fire as well.

		An example usage of this method is re-querying the server for the
		latest information using the same parameters as when the route
		was first entered.

		Note that this will cause `model` hooks to fire even on routes
		that were provided a model object when the route was initially
		entered.

		@method refresh
		@return {Transition} the transition object associated with this
			attempted transition
	 */
	refresh: function() {
		return this.router.router.refresh(this).method('replace');
	},

	/**
		Transition into another route while replacing the current URL, if possible.
		This will replace the current history entry instead of adding a new one.
		Beside that, it is identical to `transitionTo` in all other respects. See
		'transitionTo' for additional information regarding multiple models.

		Example

		```javascript
		App.Router.map(function() {
			this.route("index");
			this.route("secret");
		});

		App.SecretRoute = Ember.Route.extend({
			afterModel: function() {
				if (!authorized()){
					this.replaceWith('index');
				}
			}
		});
		```

		@method replaceWith
		@param {String} name the name of the route
		@param {...Object} models the model(s) to be used while transitioning
		to the route.
		@return {Transition} the transition object associated with this
			attempted transition
	*/
	replaceWith: function() {
		var router = this.router;
		return router.replaceWith.apply(router, arguments);
	},

	/**
		Sends an action to the router, which will delegate it to the currently
		active route hierarchy per the bubbling rules explained under `actions`.

		Example

		```javascript
		App.Router.map(function() {
			this.route("index");
		});

		App.ApplicationRoute = Ember.Route.extend({
			actions: {
				track: function(arg) {
					console.log(arg, 'was clicked');
				}
			}
		});

		App.IndexRoute = Ember.Route.extend({
			actions: {
				trackIfDebug: function(arg) {
					if (debug) {
						this.send('track', arg);
					}
				}
			}
		});
		```

		@method send
		@param {String} name the name of the action to trigger
		@param {...*} args
	*/
	send: function() {
		return this.router.send.apply(this.router, arguments);
	},

	/**
		This hook is the entry point for router.js

		@private
		@method setup
	*/
	setup: function(context, transition) {
		var controllerName = this.controllerName || this.routeName,
				controller = this.controllerFor(controllerName, true);
		if (!controller) {
			controller =  this.generateController(controllerName, context);
		}

		// Assign the route's controller so that it can more easily be
		// referenced in action handlers
		this.controller = controller;

		if (Ember.FEATURES.isEnabled("query-params-new")) {
			// TODO: configurable _queryParamScope
			if (controllerName !== 'application') {
				this.controller._queryParamScope = controllerName;
			}
			this.controller._activateQueryParamObservers();
		}

		if (this.setupControllers) {
						this.setupControllers(controller, context);
		} else {

			if (Ember.FEATURES.isEnabled("query-params-new")) {
				// Prevent updates to query params in setupController
				// from firing another transition. Updating QPs in
				// setupController will only affect the final
				// generated URL.
				controller._finalizingQueryParams = true;
				controller._queryParamChangesDuringSuspension = {};
				this.setupController(controller, context, transition);
				controller._finalizingQueryParams = false;
			} else {
				this.setupController(controller, context);
			}
		}

		if (this.renderTemplates) {
						this.renderTemplates(context);
		} else {
			this.renderTemplate(controller, context);
		}
	},

	/**
		This hook is the first of the route entry validation hooks
		called when an attempt is made to transition into a route
		or one of its children. It is called before `model` and
		`afterModel`, and is appropriate for cases when:

		1) A decision can be made to redirect elsewhere without
			 needing to resolve the model first.
		2) Any async operations need to occur first before the
			 model is attempted to be resolved.

		This hook is provided the current `transition` attempt
		as a parameter, which can be used to `.abort()` the transition,
		save it for a later `.retry()`, or retrieve values set
		on it from a previous hook. You can also just call
		`this.transitionTo` to another route to implicitly
		abort the `transition`.

		You can return a promise from this hook to pause the
		transition until the promise resolves (or rejects). This could
		be useful, for instance, for retrieving async code from
		the server that is required to enter a route.

		```js
		App.PostRoute = Ember.Route.extend({
			beforeModel: function(transition) {
				if (!App.Post) {
					return Ember.$.getScript('/models/post.js');
				}
			}
		});
		```

		If `App.Post` doesn't exist in the above example,
		`beforeModel` will use jQuery's `getScript`, which
		returns a promise that resolves after the server has
		successfully retrieved and executed the code from the
		server. Note that if an error were to occur, it would
		be passed to the `error` hook on `Ember.Route`, but
		it's also possible to handle errors specific to
		`beforeModel` right from within the hook (to distinguish
		from the shared error handling behavior of the `error`
		hook):

		```js
		App.PostRoute = Ember.Route.extend({
			beforeModel: function(transition) {
				if (!App.Post) {
					var self = this;
					return Ember.$.getScript('post.js').then(null, function(e) {
						self.transitionTo('help');

						// Note that the above transitionTo will implicitly
						// halt the transition. If you were to return
						// nothing from this promise reject handler,
						// according to promise semantics, that would
						// convert the reject into a resolve and the
						// transition would continue. To propagate the
						// error so that it'd be handled by the `error`
						// hook, you would have to either
						return Ember.RSVP.reject(e);
					});
				}
			}
		});
		```

		@method beforeModel
		@param {Transition} transition
		@param {Object} queryParams the active query params for this route
		@return {Promise} if the value returned from this hook is
			a promise, the transition will pause until the transition
			resolves. Otherwise, non-promise return values are not
			utilized in any way.
	*/
	beforeModel: Ember.K,

	/**
		This hook is called after this route's model has resolved.
		It follows identical async/promise semantics to `beforeModel`
		but is provided the route's resolved model in addition to
		the `transition`, and is therefore suited to performing
		logic that can only take place after the model has already
		resolved.

		```js
		App.PostsRoute = Ember.Route.extend({
			afterModel: function(posts, transition) {
				if (posts.length === 1) {
					this.transitionTo('post.show', posts[0]);
				}
			}
		});
		```

		Refer to documentation for `beforeModel` for a description
		of transition-pausing semantics when a promise is returned
		from this hook.

		@method afterModel
		@param {Object} resolvedModel the value returned from `model`,
			or its resolved value if it was a promise
		@param {Transition} transition
		@param {Object} queryParams the active query params for this handler
		@return {Promise} if the value returned from this hook is
			a promise, the transition will pause until the transition
			resolves. Otherwise, non-promise return values are not
			utilized in any way.
	 */
	afterModel: Ember.K,

	/**
		A hook you can implement to optionally redirect to another route.

		If you call `this.transitionTo` from inside of this hook, this route
		will not be entered in favor of the other hook.

		`redirect` and `afterModel` behave very similarly and are
		called almost at the same time, but they have an important
		distinction in the case that, from one of these hooks, a
		redirect into a child route of this route occurs: redirects
		from `afterModel` essentially invalidate the current attempt
		to enter this route, and will result in this route's `beforeModel`,
		`model`, and `afterModel` hooks being fired again within
		the new, redirecting transition. Redirects that occur within
		the `redirect` hook, on the other hand, will _not_ cause
		these hooks to be fired again the second time around; in
		other words, by the time the `redirect` hook has been called,
		both the resolved model and attempted entry into this route
		are considered to be fully validated.

		@method redirect
		@param {Object} model the model for this route
	*/
	redirect: Ember.K,

	/**
		Called when the context is changed by router.js.

		@private
		@method contextDidChange
	*/
	contextDidChange: function() {
		this.currentModel = this.context;
	},

	/**
		A hook you can implement to convert the URL into the model for
		this route.

		```js
		App.Router.map(function() {
			this.resource('post', {path: '/posts/:post_id'});
		});
		```

		The model for the `post` route is `App.Post.find(params.post_id)`.

		By default, if your route has a dynamic segment ending in `_id`:

		* The model class is determined from the segment (`post_id`'s
			class is `App.Post`)
		* The find method is called on the model class with the value of
			the dynamic segment.

		Note that for routes with dynamic segments, this hook is only
		executed when entered via the URL. If the route is entered
		through a transition (e.g. when using the `link-to` Handlebars
		helper), then a model context is already provided and this hook
		is not called. Routes without dynamic segments will always
		execute the model hook.

		This hook follows the asynchronous/promise semantics
		described in the documentation for `beforeModel`. In particular,
		if a promise returned from `model` fails, the error will be
		handled by the `error` hook on `Ember.Route`.

		Example

		```js
		App.PostRoute = Ember.Route.extend({
			model: function(params) {
				return App.Post.find(params.post_id);
			}
		});
		```

		@method model
		@param {Object} params the parameters extracted from the URL
		@param {Transition} transition
		@param {Object} queryParams the query params for this route
		@return {Object|Promise} the model for this route. If
			a promise is returned, the transition will pause until
			the promise resolves, and the resolved value of the promise
			will be used as the model for this route.
	*/
	model: function(params, transition) {
		var match, name, sawParams, value;

		for (var prop in params) {
			if (prop === 'queryParams') { continue; }

			if (match = prop.match(/^(.*)_id$/)) {
				name = match[1];
				value = params[prop];
			}
			sawParams = true;
		}

		if (!name && sawParams) { return params; }
		else if (!name) { return; }

		return this.findModel(name, value);
	},

	/**
		@private

		Router.js hook.
	 */
	deserialize: function(params, transition) {
		if (Ember.FEATURES.isEnabled("query-params-new")) {
			return this.model(this.paramsFor(this.routeName), transition);
		} else {
			return this.model(params, transition);
		}
	},

	/**

		@method findModel
		@param {String} type the model type
		@param {Object} value the value passed to find
	*/
	findModel: function(){
		var store = get(this, 'store');
		return store.find.apply(store, arguments);
	},

	/**
		Store property provides a hook for data persistence libraries to inject themselves.

		By default, this store property provides the exact same functionality previously
		in the model hook.

		Currently, the required interface is:

		`store.find(modelName, findArguments)`

		@method store
		@param {Object} store
	*/
	store: Ember.computed(function(){
		var container = this.container;
		var routeName = this.routeName;
		var namespace = get(this, 'router.namespace');

		return {
			find: function(name, value) {
				var modelClass = container.lookupFactory('model:' + name);


				return modelClass.find(value);
			}
		};
	}),

	/**
		A hook you can implement to convert the route's model into parameters
		for the URL.

		```js
		App.Router.map(function() {
			this.resource('post', {path: '/posts/:post_id'});
		});

		App.PostRoute = Ember.Route.extend({
			model: function(params) {
				// the server returns `{ id: 12 }`
				return jQuery.getJSON("/posts/" + params.post_id);
			},

			serialize: function(model) {
				// this will make the URL `/posts/12`
				return { post_id: model.id };
			}
		});
		```

		The default `serialize` method will insert the model's `id` into the
		route's dynamic segment (in this case, `:post_id`) if the segment contains '_id'.
		If the route has multiple dynamic segments or does not contain '_id', `serialize`
		will return `Ember.getProperties(model, params)`

		This method is called when `transitionTo` is called with a context
		in order to populate the URL.

		@method serialize
		@param {Object} model the route's model
		@param {Array} params an Array of parameter names for the current
			route (in the example, `['post_id']`.
		@return {Object} the serialized parameters
	*/
	serialize: function(model, params) {
		if (params.length < 1) { return; }
		if (!model) { return; }

		var name = params[0], object = {};

		if (/_id$/.test(name) && params.length === 1) {
			object[name] = get(model, "id");
		} else {
			object = getProperties(model, params);
		}

		return object;
	},

	/**
		A hook you can use to setup the controller for the current route.

		This method is called with the controller for the current route and the
		model supplied by the `model` hook.

		By default, the `setupController` hook sets the `content` property of
		the controller to the `model`.

		This means that your template will get a proxy for the model as its
		context, and you can act as though the model itself was the context.

		The provided controller will be one resolved based on the name
		of this route.

		If no explicit controller is defined, Ember will automatically create
		an appropriate controller for the model.

		* if the model is an `Ember.Array` (including record arrays from Ember
			Data), the controller is an `Ember.ArrayController`.
		* otherwise, the controller is an `Ember.ObjectController`.

		As an example, consider the router:

		```js
		App.Router.map(function() {
			this.resource('post', {path: '/posts/:post_id'});
		});
		```

		For the `post` route, a controller named `App.PostController` would
		be used if it is defined. If it is not defined, an `Ember.ObjectController`
		instance would be used.

		Example

		```js
		App.PostRoute = Ember.Route.extend({
			setupController: function(controller, model) {
				controller.set('model', model);
			}
		});
		```

		@method setupController
		@param {Controller} controller instance
		@param {Object} model
	*/
	setupController: function(controller, context, transition) {
		if (controller && (context !== undefined)) {
			set(controller, 'model', context);
		}
	},

	/**
		Returns the controller for a particular route or name.

		The controller instance must already have been created, either through entering the
		associated route or using `generateController`.

		```js
		App.PostRoute = Ember.Route.extend({
			setupController: function(controller, post) {
				this._super(controller, post);
				this.controllerFor('posts').set('currentPost', post);
			}
		});
		```

		@method controllerFor
		@param {String} name the name of the route or controller
		@return {Ember.Controller}
	*/
	controllerFor: function(name, _skipAssert) {
		var container = this.container,
				route = container.lookup('route:'+name),
				controller;

		if (route && route.controllerName) {
			name = route.controllerName;
		}

		controller = container.lookup('controller:' + name);

		// NOTE: We're specifically checking that skipAssert is true, because according
		//   to the old API the second parameter was model. We do not want people who
		//   passed a model to skip the assertion.

		return controller;
	},

	/**
		Generates a controller for a route.

		If the optional model is passed then the controller type is determined automatically,
		e.g., an ArrayController for arrays.

		Example

		```js
		App.PostRoute = Ember.Route.extend({
			setupController: function(controller, post) {
				this._super(controller, post);
				this.generateController('posts', post);
			}
		});
		```

		@method generateController
		@param {String} name the name of the controller
		@param {Object} model the model to infer the type of the controller (optional)
	*/
	generateController: function(name, model) {
		var container = this.container;

		model = model || this.modelFor(name);

		return Ember.generateController(container, name, model);
	},

	/**
		Returns the model of a parent (or any ancestor) route
		in a route hierarchy.  During a transition, all routes
		must resolve a model object, and if a route
		needs access to a parent route's model in order to
		resolve a model (or just reuse the model from a parent),
		it can call `this.modelFor(theNameOfParentRoute)` to
		retrieve it.

		Example

		```js
		App.Router.map(function() {
				this.resource('post', { path: '/post/:post_id' }, function() {
						this.resource('comments');
				});
		});

		App.CommentsRoute = Ember.Route.extend({
				afterModel: function() {
						this.set('post', this.modelFor('post'));
				}
		});
		```

		@method modelFor
		@param {String} name the name of the route
		@return {Object} the model object
	*/
	modelFor: function(name) {

		var route = this.container.lookup('route:' + name),
				transition = this.router.router.activeTransition;

		// If we are mid-transition, we want to try and look up
		// resolved parent contexts on the current transitionEvent.
		if (transition) {
			var modelLookupName = (route && route.routeName) || name;
			if (transition.resolvedModels.hasOwnProperty(modelLookupName)) {
				return transition.resolvedModels[modelLookupName];
			}
		}

		return route && route.currentModel;
	},

	/**
		A hook you can use to render the template for the current route.

		This method is called with the controller for the current route and the
		model supplied by the `model` hook. By default, it renders the route's
		template, configured with the controller for the route.

		This method can be overridden to set up and render additional or
		alternative templates.

		```js
		App.PostsRoute = Ember.Route.extend({
			renderTemplate: function(controller, model) {
				var favController = this.controllerFor('favoritePost');

				// Render the `favoritePost` template into
				// the outlet `posts`, and display the `favoritePost`
				// controller.
				this.render('favoritePost', {
					outlet: 'posts',
					controller: favController
				});
			}
		});
		```

		@method renderTemplate
		@param {Object} controller the route's controller
		@param {Object} model the route's model
	*/
	renderTemplate: function(controller, model) {
		this.render();
	},

	/**
		Renders a template into an outlet.

		This method has a number of defaults, based on the name of the
		route specified in the router.

		For example:

		```js
		App.Router.map(function() {
			this.route('index');
			this.resource('post', {path: '/posts/:post_id'});
		});

		App.PostRoute = App.Route.extend({
			renderTemplate: function() {
				this.render();
			}
		});
		```

		The name of the `PostRoute`, as defined by the router, is `post`.

		By default, render will:

		* render the `post` template
		* with the `post` view (`PostView`) for event handling, if one exists
		* and the `post` controller (`PostController`), if one exists
		* into the `main` outlet of the `application` template

		You can override this behavior:

		```js
		App.PostRoute = App.Route.extend({
			renderTemplate: function() {
				this.render('myPost', {   // the template to render
					into: 'index',          // the template to render into
					outlet: 'detail',       // the name of the outlet in that template
					controller: 'blogPost'  // the controller to use for the template
				});
			}
		});
		```

		Remember that the controller's `content` will be the route's model. In
		this case, the default model will be `App.Post.find(params.post_id)`.

		@method render
		@param {String} name the name of the template to render
		@param {Object} options the options
	*/
	render: function(name, options) {

		var namePassed = !!name;

		if (typeof name === 'object' && !options) {
			options = name;
			name = this.routeName;
		}

		options = options || {};

		var templateName;

		if (name) {
			name = name.replace(/\//g, '.');
			templateName = name;
		} else {
			name = this.routeName;
			templateName = this.templateName || name;
		}

		var viewName = options.view || this.viewName || name;

		var container = this.container,
				view = container.lookup('view:' + viewName),
				template = view ? view.get('template') : null;

		if (!template) {
			template = container.lookup('template:' + templateName);
		}

		if (!view && !template) {
						if (get(this.router, 'namespace.LOG_VIEW_LOOKUPS')) {
							}
			return;
		}

		options = normalizeOptions(this, name, template, options);
		view = setupView(view, container, options);

		if (options.outlet === 'main') { this.lastRenderedTemplate = name; }

		appendView(this, view, options);
	},

	/**
		Disconnects a view that has been rendered into an outlet.

		You may pass any or all of the following options to `disconnectOutlet`:

		* `outlet`: the name of the outlet to clear (default: 'main')
		* `parentView`: the name of the view containing the outlet to clear
			 (default: the view rendered by the parent route)

		Example:

		```js
		App.ApplicationRoute = App.Route.extend({
			actions: {
				showModal: function(evt) {
					this.render(evt.modalName, {
						outlet: 'modal',
						into: 'application'
					});
				},
				hideModal: function(evt) {
					this.disconnectOutlet({
						outlet: 'modal',
						parentView: 'application'
					});
				}
			}
		});
		```

		@method disconnectOutlet
		@param {Object} options the options
	*/
	disconnectOutlet: function(options) {
		options = options || {};
		options.parentView = options.parentView ? options.parentView.replace(/\//g, '.') : parentTemplate(this);
		options.outlet = options.outlet || 'main';

		var parentView = this.router._lookupActiveView(options.parentView);
		parentView.disconnectOutlet(options.outlet);
	},

	willDestroy: function() {
		this.teardownViews();
	},

	/**
		@private

		@method teardownViews
	*/
	teardownViews: function() {
		// Tear down the top level view
		if (this.teardownTopLevelView) { this.teardownTopLevelView(); }

		// Tear down any outlets rendered with 'into'
		var teardownOutletViews = this.teardownOutletViews || [];
		a_forEach(teardownOutletViews, function(teardownOutletView) {
			teardownOutletView();
		});

		delete this.teardownTopLevelView;
		delete this.teardownOutletViews;
		delete this.lastRenderedTemplate;
	}
});


if (Ember.FEATURES.isEnabled("query-params-new")) {
	Ember.Route.reopen({
		paramsFor: function(name) {
			var route = this.container.lookup('route:' + name);

			if (!route) {
				return {};
			}

			var transition = this.router.router.activeTransition;
			var queryParamsHash = this.router._queryParamNamesForSingle(route.routeName);

			var params, queryParams;
			if (transition) {
				params = transition.params[name] || {};
				queryParams = transition.queryParams;
			} else {
				var state = this.router.router.state;
				params = state.params[name] || {};
				queryParams = state.queryParams;
			}

			this.router._queryParamOverrides(params, queryParamsHash.queryParams, function(name, resultsName, colonized) {
				// Replace the controller-supplied value with more up
				// to date values (e.g. from an incoming transition).
				var value = (resultsName in queryParams) ?
										queryParams[resultsName]  :  params[resultsName];
				delete params[resultsName];
				params[colonized.split(':').pop()] = value;
			});

			return params;
		}
	});
}

function parentRoute(route) {
	var handlerInfos = route.router.router.state.handlerInfos;

	if (!handlerInfos) { return; }

	var parent, current;

	for (var i=0, l=handlerInfos.length; i<l; i++) {
		current = handlerInfos[i].handler;
		if (current === route) { return parent; }
		parent = current;
	}
}

function parentTemplate(route) {
	var parent = parentRoute(route), template;

	if (!parent) { return; }

	if (template = parent.lastRenderedTemplate) {
		return template;
	} else {
		return parentTemplate(parent);
	}
}

function normalizeOptions(route, name, template, options) {
	options = options || {};
	options.into = options.into ? options.into.replace(/\//g, '.') : parentTemplate(route);
	options.outlet = options.outlet || 'main';
	options.name = name;
	options.template = template;
	options.LOG_VIEW_LOOKUPS = get(route.router, 'namespace.LOG_VIEW_LOOKUPS');


	var controller = options.controller, namedController;

	if (options.controller) {
		controller = options.controller;
	} else if (namedController = route.container.lookup('controller:' + name)) {
		controller = namedController;
	} else {
		controller = route.controllerName || route.routeName;
	}

	if (typeof controller === 'string') {
		var controllerName = controller;
		controller = route.container.lookup('controller:' + controllerName);
		if (!controller) {
			throw new Ember.Error("You passed `controller: '" + controllerName + "'` into the `render` method, but no such controller could be found.");
		}
	}

	options.controller = controller;

	return options;
}

function setupView(view, container, options) {
	if (view) {
		if (options.LOG_VIEW_LOOKUPS) {
					}
	} else {
		var defaultView = options.into ? 'view:default' : 'view:toplevel';
		view = container.lookup(defaultView);
		if (options.LOG_VIEW_LOOKUPS) {
					}
	}

	if (!get(view, 'templateName')) {
		set(view, 'template', options.template);

		set(view, '_debugTemplateName', options.name);
	}

	set(view, 'renderedName', options.name);
	set(view, 'controller', options.controller);

	return view;
}

function appendView(route, view, options) {
	if (options.into) {
		var parentView = route.router._lookupActiveView(options.into);
		var teardownOutletView = generateOutletTeardown(parentView, options.outlet);
		if (!route.teardownOutletViews) { route.teardownOutletViews = []; }
		a_replace(route.teardownOutletViews, 0, 0, [teardownOutletView]);
		parentView.connectOutlet(options.outlet, view);
	} else {
		var rootElement = get(route, 'router.namespace.rootElement');
		// tear down view if one is already rendered
		if (route.teardownTopLevelView) {
			route.teardownTopLevelView();
		}
		route.router._connectActiveView(options.name, view);
		route.teardownTopLevelView = generateTopLevelTeardown(view);
		view.appendTo(rootElement);
	}
}

function generateTopLevelTeardown(view) {
	return function() { view.destroy(); };
}

function generateOutletTeardown(parentView, outlet) {
	return function() { parentView.disconnectOutlet(outlet); };
}

})();



(function() {

})();



(function() {
Ember.onLoad('Ember.Handlebars', function() {
	var handlebarsResolve = Ember.Handlebars.resolveParams,
			map = Ember.ArrayPolyfills.map,
			get = Ember.get,
			handlebarsGet = Ember.Handlebars.get;

	function resolveParams(context, params, options) {
		return map.call(resolvePaths(context, params, options), function(path, i) {
			if (null === path) {
				// Param was string/number, not a path, so just return raw string/number.
				return params[i];
			} else {
				return handlebarsGet(context, path, options);
			}
		});
	}

	function resolvePaths(context, params, options) {
		var resolved = handlebarsResolve(context, params, options),
				types = options.types;

		return map.call(resolved, function(object, i) {
			if (types[i] === 'ID') {
				return unwrap(object, params[i]);
			} else {
				return null;
			}
		});

		function unwrap(object, path) {
			if (path === 'controller') { return path; }

			if (Ember.ControllerMixin.detect(object)) {
				return unwrap(get(object, 'model'), path ? path + '.model' : 'model');
			} else {
				return path;
			}
		}
	}

	Ember.Router.resolveParams = resolveParams;
	Ember.Router.resolvePaths = resolvePaths;
});

})();



(function() {
/**
@module ember
@submodule ember-routing
*/

var get = Ember.get, set = Ember.set, fmt = Ember.String.fmt;

var slice = Array.prototype.slice;
Ember.onLoad('Ember.Handlebars', function(Handlebars) {

	var QueryParams = Ember.Object.extend({
		values: null
	});

	var resolveParams = Ember.Router.resolveParams,
			translateQueryParams = Ember.Router._translateQueryParams,
			resolvePaths  = Ember.Router.resolvePaths,
			isSimpleClick = Ember.ViewUtils.isSimpleClick;

	function fullRouteName(router, name) {
		var nameWithIndex;
		if (!router.hasRoute(name)) {
			nameWithIndex = name + '.index';
						name = nameWithIndex;
		}

		return name;
	}

	function getResolvedPaths(options) {

		var types = options.options.types,
				data = options.options.data;

		return resolvePaths(options.context, options.params, { types: types, data: data });
	}

	/**
		`Ember.LinkView` renders an element whose `click` event triggers a
		transition of the application's instance of `Ember.Router` to
		a supplied route by name.

		Instances of `LinkView` will most likely be created through
		the `link-to` Handlebars helper, but properties of this class
		can be overridden to customize application-wide behavior.

		@class LinkView
		@namespace Ember
		@extends Ember.View
		@see {Handlebars.helpers.link-to}
	**/
	var LinkView = Ember.LinkView = Ember.View.extend({
		tagName: 'a',
		currentWhen: null,

		/**
			Sets the `title` attribute of the `LinkView`'s HTML element.

			@property title
			@default null
		**/
		title: null,

		/**
			Sets the `rel` attribute of the `LinkView`'s HTML element.

			@property rel
			@default null
		**/
		rel: null,

		/**
			The CSS class to apply to `LinkView`'s element when its `active`
			property is `true`.

			@property activeClass
			@type String
			@default active
		**/
		activeClass: 'active',

		/**
			The CSS class to apply to `LinkView`'s element when its `loading`
			property is `true`.

			@property loadingClass
			@type String
			@default loading
		**/
		loadingClass: 'loading',

		/**
			The CSS class to apply to a `LinkView`'s element when its `disabled`
			property is `true`.

			@property disabledClass
			@type String
			@default disabled
		**/
		disabledClass: 'disabled',
		_isDisabled: false,

		/**
			Determines whether the `LinkView` will trigger routing via
			the `replaceWith` routing strategy.

			@property replace
			@type Boolean
			@default false
		**/
		replace: false,

		/**
			By default the `{{link-to}}` helper will bind to the `href` and
			`title` attributes. It's discourage that you override these defaults,
			however you can push onto the array if needed.

			@property attributeBindings
			@type Array | String
			@default ['href', 'title', 'rel']
		 **/
		attributeBindings: ['href', 'title', 'rel'],

		/**
			By default the `{{link-to}}` helper will bind to the `active`, `loading`, and
			`disabled` classes. It is discouraged to override these directly.

			@property classNameBindings
			@type Array
			@default ['active', 'loading', 'disabled']
		 **/
		classNameBindings: ['active', 'loading', 'disabled'],

		/**
			By default the `{{link-to}}` helper responds to the `click` event. You
			can override this globally by setting this property to your custom
			event name.

			This is particularly useful on mobile when one wants to avoid the 300ms
			click delay using some sort of custom `tap` event.

			@property eventName
			@type String
			@default click
		*/
		eventName: 'click',

		// this is doc'ed here so it shows up in the events
		// section of the API documentation, which is where
		// people will likely go looking for it.
		/**
			Triggers the `LinkView`'s routing behavior. If
			`eventName` is changed to a value other than `click`
			the routing behavior will trigger on that custom event
			instead.

			@event click
		**/

		/**
			An overridable method called when LinkView objects are instantiated.

			Example:

			```javascript
			App.MyLinkView = Ember.LinkView.extend({
				init: function() {
					this._super();
					Ember.Logger.log('Event is ' + this.get('eventName'));
				}
			});
			```

			NOTE: If you do override `init` for a framework class like `Ember.View` or
			`Ember.ArrayController`, be sure to call `this._super()` in your
			`init` declaration! If you don't, Ember may not have an opportunity to
			do important setup work, and you'll see strange behavior in your
			application.

			@method init
		*/
		init: function() {
			this._super.apply(this, arguments);

			// Map desired event name to invoke function
			var eventName = get(this, 'eventName'), i;
			this.on(eventName, this, this._invoke);
		},

		/**
			This method is invoked by observers installed during `init` that fire
			whenever the params change

			@private
			@method _paramsChanged
		 */
		_paramsChanged: function() {
			this.notifyPropertyChange('resolvedParams');
		},

		/**
		 This is called to setup observers that will trigger a rerender.

		 @private
		 @method _setupPathObservers
		**/
		_setupPathObservers: function(){
			var helperParameters = this.parameters,
					linkTextPath     = helperParameters.options.linkTextPath,
					paths = getResolvedPaths(helperParameters),
					length = paths.length,
					path, i, normalizedPath;

			if (linkTextPath) {
				normalizedPath = Ember.Handlebars.normalizePath(helperParameters.context, linkTextPath, helperParameters.options.data);
				this.registerObserver(normalizedPath.root, normalizedPath.path, this, this.rerender);
			}

			for(i=0; i < length; i++) {
				path = paths[i];
				if (null === path) {
					// A literal value was provided, not a path, so nothing to observe.
					continue;
				}

				normalizedPath = Ember.Handlebars.normalizePath(helperParameters.context, path, helperParameters.options.data);
				this.registerObserver(normalizedPath.root, normalizedPath.path, this, this._paramsChanged);
			}

			var queryParamsObject = this.queryParamsObject;
			if (queryParamsObject) {
				var values = queryParamsObject.values;

				// Install observers for all of the hash options
				// provided in the (query-params) subexpression.
				for (var k in values) {
					if (!values.hasOwnProperty(k)) { continue; }

					if (queryParamsObject.types[k] === 'ID') {
						normalizedPath = Ember.Handlebars.normalizePath(helperParameters.context, values[k], helperParameters.options.data);
						this.registerObserver(normalizedPath.root, normalizedPath.path, this, this._paramsChanged);
					}
				}
			}
		},

		afterRender: function(){
			this._super.apply(this, arguments);
			this._setupPathObservers();
		},

		/**
			Even though this isn't a virtual view, we want to treat it as if it is
			so that you can access the parent with {{view.prop}}

			@private
			@method concreteView
		**/
		concreteView: Ember.computed(function() {
			return get(this, 'parentView');
		}).property('parentView'),

		/**

			Accessed as a classname binding to apply the `LinkView`'s `disabledClass`
			CSS `class` to the element when the link is disabled.

			When `true` interactions with the element will not trigger route changes.
			@property disabled
		*/
		disabled: Ember.computed(function computeLinkViewDisabled(key, value) {
			if (value !== undefined) { this.set('_isDisabled', value); }

			return value ? get(this, 'disabledClass') : false;
		}),

		/**
			Accessed as a classname binding to apply the `LinkView`'s `activeClass`
			CSS `class` to the element when the link is active.

			A `LinkView` is considered active when its `currentWhen` property is `true`
			or the application's current route is the route the `LinkView` would trigger
			transitions into.

			@property active
		**/
		active: Ember.computed(function computeLinkViewActive() {
			if (get(this, 'loading')) { return false; }

			var router = get(this, 'router'),
					routeArgs = get(this, 'routeArgs'),
					contexts = routeArgs.slice(1),
					resolvedParams = get(this, 'resolvedParams'),
					currentWhen = this.currentWhen || resolvedParams[0],
					currentWithIndex = currentWhen + '.index',
					isActive = router.isActive.apply(router, [currentWhen].concat(contexts)) ||
										 router.isActive.apply(router, [currentWithIndex].concat(contexts));

			if (isActive) { return get(this, 'activeClass'); }
		}).property('resolvedParams', 'routeArgs'),

		/**
			Accessed as a classname binding to apply the `LinkView`'s `loadingClass`
			CSS `class` to the element when the link is loading.

			A `LinkView` is considered loading when it has at least one
			parameter whose value is currently null or undefined. During
			this time, clicking the link will perform no transition and
			emit a warning that the link is still in a loading state.

			@property loading
		**/
		loading: Ember.computed(function computeLinkViewLoading() {
			if (!get(this, 'routeArgs')) { return get(this, 'loadingClass'); }
		}).property('routeArgs'),

		/**
			Returns the application's main router from the container.

			@private
			@property router
		**/
		router: Ember.computed(function() {
			return get(this, 'controller').container.lookup('router:main');
		}),

		/**
			Event handler that invokes the link, activating the associated route.

			@private
			@method _invoke
			@param {Event} event
		*/
		_invoke: function(event) {
			if (!isSimpleClick(event)) { return true; }

			if (this.preventDefault !== false) { event.preventDefault(); }
			if (this.bubbles === false) { event.stopPropagation(); }

			if (get(this, '_isDisabled')) { return false; }

			if (get(this, 'loading')) {
				Ember.Logger.warn("This link-to is in an inactive loading state because at least one of its parameters presently has a null/undefined value, or the provided route name is invalid.");
				return false;
			}

			var router = get(this, 'router'),
					routeArgs = get(this, 'routeArgs');

			var transition;
			if (get(this, 'replace')) {
				transition = router.replaceWith.apply(router, routeArgs);
			} else {
				transition = router.transitionTo.apply(router, routeArgs);
			}

			// Schedule eager URL update, but after we've given the transition
			// a chance to synchronously redirect.
			if (Ember.FEATURES.isEnabled("ember-eager-url-update")) {
				Ember.run.scheduleOnce('routerTransitions', this, this._eagerUpdateUrl, transition, this.get('href'));
			}
		},

		/**
			@private
		 */
		_eagerUpdateUrl: function(transition, href) {
			if (!transition.isActive || !transition.urlMethod) {
				// transition was aborted, already ran to completion,
				// or it has a null url-updated method.
				return;
			}

			// Re-use the routerjs hooks set up by the Ember router.
			var routerjs = get(this, 'router.router');
			if (transition.urlMethod === 'update') {
				routerjs.updateURL(href);
			} else if (transition.urlMethod === 'replace') {
				routerjs.replaceURL(href);
			}

			// Prevent later update url refire.
			transition.method(null);
		},

		/**
			Computed property that returns an array of the
			resolved parameters passed to the `link-to` helper,
			e.g.:

			```hbs
			{{link-to a b '123' c}}
			```

			will generate a `resolvedParams` of:

			```js
			[aObject, bObject, '123', cObject]
			```

			@private
			@property
			@return {Array}
		 */
		resolvedParams: Ember.computed(function() {
			var parameters = this.parameters,
					options = parameters.options,
					types = options.types,
					data = options.data;

			if (parameters.params.length === 0) {
				var appController = this.container.lookup('controller:application');
				return [get(appController, 'currentRouteName')];
			} else {
				return resolveParams(parameters.context, parameters.params, { types: types, data: data });
			}

			// Original implementation if query params not enabled
			return resolveParams(parameters.context, parameters.params, { types: types, data: data });
		}).property('router.url'),

		/**
			Computed property that returns the current route name and
			any dynamic segments.

			@private
			@property
			@return {Array} An array with the route name and any dynamic segments
		 */
		routeArgs: Ember.computed(function computeLinkViewRouteArgs() {
			var resolvedParams = get(this, 'resolvedParams').slice(0),
					router = get(this, 'router'),
					namedRoute = resolvedParams[0];

			if (!namedRoute) { return; }

			namedRoute = fullRouteName(router, namedRoute);
			resolvedParams[0] = namedRoute;

			for (var i = 1, len = resolvedParams.length; i < len; ++i) {
				var param = resolvedParams[i];
				if (param === null || typeof param === 'undefined') {
					// If contexts aren't present, consider the linkView unloaded.
					return;
				}
			}

			if (Ember.FEATURES.isEnabled("query-params-new")) {
				resolvedParams.push({ queryParams: get(this, 'queryParams') });
			}

			return resolvedParams;
		}).property('resolvedParams', 'queryParams'),

		queryParamsObject: null,
		queryParams: Ember.computed(function computeLinkViewQueryParams() {

			var queryParamsObject = get(this, 'queryParamsObject'),
					suppliedParams = {};

			if (queryParamsObject) {
				Ember.merge(suppliedParams, queryParamsObject.values);
			}

			var resolvedParams = get(this, 'resolvedParams'),
					router = get(this, 'router'),
					routeName = resolvedParams[0],
					paramsForRoute = router._queryParamNamesFor(routeName),
					queryParams = paramsForRoute.queryParams,
					translations = paramsForRoute.translations,
					paramsForRecognizer = {};

			// Normalize supplied params into their long-form name
			// e.g. 'foo' -> 'controllername:foo'
			translateQueryParams(suppliedParams, translations, routeName);

			var helperParameters = this.parameters;
			router._queryParamOverrides(paramsForRecognizer, queryParams, function(name, resultsName) {
				if (!(name in suppliedParams)) { return; }

				var parts = name.split(':');

				var type = queryParamsObject.types[parts[1]];

				var value;
				if (type === 'ID') {
					var normalizedPath = Ember.Handlebars.normalizePath(helperParameters.context, suppliedParams[name], helperParameters.options.data);
					value = Ember.Handlebars.get(normalizedPath.root, normalizedPath.path, helperParameters.options);
				} else {
					value = suppliedParams[name];
				}

				delete suppliedParams[name];

				paramsForRecognizer[resultsName] = value;
			});

			return paramsForRecognizer;
		}).property('resolvedParams.[]'),

		/**
			Sets the element's `href` attribute to the url for
			the `LinkView`'s targeted route.

			If the `LinkView`'s `tagName` is changed to a value other
			than `a`, this property will be ignored.

			@property href
		**/
		href: Ember.computed(function computeLinkViewHref() {
			if (get(this, 'tagName') !== 'a') { return; }

			var router = get(this, 'router'),
					routeArgs = get(this, 'routeArgs');

			return routeArgs ? router.generate.apply(router, routeArgs) : get(this, 'loadingHref');
		}).property('routeArgs'),

		/**
			The default href value to use while a link-to is loading.
			Only applies when tagName is 'a'

			@property loadingHref
			@type String
			@default #
		*/
		loadingHref: '#'
	});

	LinkView.toString = function() { return "LinkView"; };

	/**
		The `{{link-to}}` helper renders a link to the supplied
		`routeName` passing an optionally supplied model to the
		route as its `model` context of the route. The block
		for `{{link-to}}` becomes the innerHTML of the rendered
		element:

		```handlebars
		{{#link-to 'photoGallery'}}
			Great Hamster Photos
		{{/link-to}}
		```

		```html
		<a href="/hamster-photos">
			Great Hamster Photos
		</a>
		```

		### Supplying a tagName
		By default `{{link-to}}` renders an `<a>` element. This can
		be overridden for a single use of `{{link-to}}` by supplying
		a `tagName` option:

		```handlebars
		{{#link-to 'photoGallery' tagName="li"}}
			Great Hamster Photos
		{{/link-to}}
		```

		```html
		<li>
			Great Hamster Photos
		</li>
		```

		To override this option for your entire application, see
		"Overriding Application-wide Defaults".

		### Disabling the `link-to` helper
		By default `{{link-to}}` is enabled.
		any passed value to `disabled` helper property will disable the `link-to` helper.

		static use: the `disabled` option:

		```handlebars
		{{#link-to 'photoGallery' disabled=true}}
			Great Hamster Photos
		{{/link-to}}
		```

		dynamic use: the `disabledWhen` option:

		```handlebars
		{{#link-to 'photoGallery' disabledWhen=controller.someProperty}}
			Great Hamster Photos
		{{/link-to}}
		```

		any passed value to `disabled` will disable it except `undefined`.
		to ensure that only `true` disable the `link-to` helper you can
		override the global behaviour of `Ember.LinkView`.

		```javascript
		Ember.LinkView.reopen({
			disabled: Ember.computed(function(key, value) {
				if (value !== undefined) {
					this.set('_isDisabled', value === true);
				}
				return value === true ? get(this, 'disabledClass') : false;
			})
		});
		```

		see "Overriding Application-wide Defaults" for more.

		### Handling `href`
		`{{link-to}}` will use your application's Router to
		fill the element's `href` property with a url that
		matches the path to the supplied `routeName` for your
		routers's configured `Location` scheme, which defaults
		to Ember.HashLocation.

		### Handling current route
		`{{link-to}}` will apply a CSS class name of 'active'
		when the application's current route matches
		the supplied routeName. For example, if the application's
		current route is 'photoGallery.recent' the following
		use of `{{link-to}}`:

		```handlebars
		{{#link-to 'photoGallery.recent'}}
			Great Hamster Photos from the last week
		{{/link-to}}
		```

		will result in

		```html
		<a href="/hamster-photos/this-week" class="active">
			Great Hamster Photos
		</a>
		```

		The CSS class name used for active classes can be customized
		for a single use of `{{link-to}}` by passing an `activeClass`
		option:

		```handlebars
		{{#link-to 'photoGallery.recent' activeClass="current-url"}}
			Great Hamster Photos from the last week
		{{/link-to}}
		```

		```html
		<a href="/hamster-photos/this-week" class="current-url">
			Great Hamster Photos
		</a>
		```

		To override this option for your entire application, see
		"Overriding Application-wide Defaults".

		### Supplying a model
		An optional model argument can be used for routes whose
		paths contain dynamic segments. This argument will become
		the model context of the linked route:

		```javascript
		App.Router.map(function() {
			this.resource("photoGallery", {path: "hamster-photos/:photo_id"});
		});
		```

		```handlebars
		{{#link-to 'photoGallery' aPhoto}}
			{{aPhoto.title}}
		{{/link-to}}
		```

		```html
		<a href="/hamster-photos/42">
			Tomster
		</a>
		```

		### Supplying multiple models
		For deep-linking to route paths that contain multiple
		dynamic segments, multiple model arguments can be used.
		As the router transitions through the route path, each
		supplied model argument will become the context for the
		route with the dynamic segments:

		```javascript
		App.Router.map(function() {
			this.resource("photoGallery", {path: "hamster-photos/:photo_id"}, function() {
				this.route("comment", {path: "comments/:comment_id"});
			});
		});
		```
		This argument will become the model context of the linked route:

		```handlebars
		{{#link-to 'photoGallery.comment' aPhoto comment}}
			{{comment.body}}
		{{/link-to}}
		```

		```html
		<a href="/hamster-photos/42/comment/718">
			A+++ would snuggle again.
		</a>
		```

		### Supplying an explicit dynamic segment value
		If you don't have a model object available to pass to `{{link-to}}`,
		an optional string or integer argument can be passed for routes whose
		paths contain dynamic segments. This argument will become the value
		of the dynamic segment:

		```javascript
		App.Router.map(function() {
			this.resource("photoGallery", {path: "hamster-photos/:photo_id"});
		});
		```

		```handlebars
		{{#link-to 'photoGallery' aPhotoId}}
			{{aPhoto.title}}
		{{/link-to}}
		```

		```html
		<a href="/hamster-photos/42">
			Tomster
		</a>
		```

		When transitioning into the linked route, the `model` hook will
		be triggered with parameters including this passed identifier.

		### Allowing Default Action

	 By default the `{{link-to}}` helper prevents the default browser action
	 by calling `preventDefault()` as this sort of action bubbling is normally
	 handled internally and we do not want to take the browser to a new URL (for
	 example).

	 If you need to override this behavior specify `preventDefault=false` in
	 your template:

		```handlebars
		{{#link-to 'photoGallery' aPhotoId preventDefault=false}}
			{{aPhotoId.title}}
		{{/link-to}}
		```

		### Overriding attributes
		You can override any given property of the Ember.LinkView
		that is generated by the `{{link-to}}` helper by passing
		key/value pairs, like so:

		```handlebars
		{{#link-to  aPhoto tagName='li' title='Following this link will change your life' classNames='pic sweet'}}
			Uh-mazing!
		{{/link-to}}
		```

		See [Ember.LinkView](/api/classes/Ember.LinkView.html) for a
		complete list of overrideable properties. Be sure to also
		check out inherited properties of `LinkView`.

		### Overriding Application-wide Defaults
		``{{link-to}}`` creates an instance of Ember.LinkView
		for rendering. To override options for your entire
		application, reopen Ember.LinkView and supply the
		desired values:

		``` javascript
		Ember.LinkView.reopen({
			activeClass: "is-active",
			tagName: 'li'
		})
		```

		It is also possible to override the default event in
		this manner:

		``` javascript
		Ember.LinkView.reopen({
			eventName: 'customEventName'
		});
		```

		@method link-to
		@for Ember.Handlebars.helpers
		@param {String} routeName
		@param {Object} [context]*
		@param [options] {Object} Handlebars key/value pairs of options, you can override any property of Ember.LinkView
		@return {String} HTML string
		@see {Ember.LinkView}
	*/
	Ember.Handlebars.registerHelper('link-to', function linkToHelper(name) {
		var options = slice.call(arguments, -1)[0],
				params = slice.call(arguments, 0, -1),
				hash = options.hash;

		if (params[params.length - 1] instanceof QueryParams) {
			hash.queryParamsObject = params.pop();
		}

		hash.disabledBinding = hash.disabledWhen;

		if (!options.fn) {
			var linkTitle = params.shift();
			var linkType = options.types.shift();
			var context = this;
			if (linkType === 'ID') {
				options.linkTextPath = linkTitle;
				options.fn = function() {
					return Ember.Handlebars.get(context, linkTitle, options);
				};
			} else {
				options.fn = function() {
					return linkTitle;
				};
			}
		}

		hash.parameters = {
			context: this,
			options: options,
			params: params
		};

		return Ember.Handlebars.helpers.view.call(this, LinkView, options);
	});


	if (Ember.FEATURES.isEnabled("query-params-new")) {
		Ember.Handlebars.registerHelper('query-params', function queryParamsHelper(options) {

			return QueryParams.create({
				values: options.hash,
				types: options.hashTypes
			});
		});
	}

	/**
		See [link-to](/api/classes/Ember.Handlebars.helpers.html#method_link-to)

		@method linkTo
		@for Ember.Handlebars.helpers
		@deprecated
		@param {String} routeName
		@param {Object} [context]*
		@return {String} HTML string
	*/
	Ember.Handlebars.registerHelper('linkTo', function linkToHelper() {
				return Ember.Handlebars.helpers['link-to'].apply(this, arguments);
	});
});



})();



(function() {
/**
@module ember
@submodule ember-routing
*/

var get = Ember.get, set = Ember.set;
Ember.onLoad('Ember.Handlebars', function(Handlebars) {
	/**
	@module ember
	@submodule ember-routing
	*/

	Handlebars.OutletView = Ember.ContainerView.extend(Ember._Metamorph);

	/**
		The `outlet` helper is a placeholder that the router will fill in with
		the appropriate template based on the current state of the application.

		``` handlebars
		{{outlet}}
		```

		By default, a template based on Ember's naming conventions will be rendered
		into the `outlet` (e.g. `App.PostsRoute` will render the `posts` template).

		You can render a different template by using the `render()` method in the
		route's `renderTemplate` hook. The following will render the `favoritePost`
		template into the `outlet`.

		``` javascript
		App.PostsRoute = Ember.Route.extend({
			renderTemplate: function() {
				this.render('favoritePost');
			}
		});
		```

		You can create custom named outlets for more control.

		``` handlebars
		{{outlet 'favoritePost'}}
		{{outlet 'posts'}}
		```

		Then you can define what template is rendered into each outlet in your
		route.


		``` javascript
		App.PostsRoute = Ember.Route.extend({
			renderTemplate: function() {
				this.render('favoritePost', { outlet: 'favoritePost' });
				this.render('posts', { outlet: 'posts' });
			}
		});
		```

		You can specify the view that the outlet uses to contain and manage the
		templates rendered into it.

		``` handlebars
		{{outlet view='sectionContainer'}}
		```

		``` javascript
		App.SectionContainer = Ember.ContainerView.extend({
			tagName: 'section',
			classNames: ['special']
		});
		```

		@method outlet
		@for Ember.Handlebars.helpers
		@param {String} property the property on the controller
			that holds the view for this outlet
		@return {String} HTML string
	*/
	Handlebars.registerHelper('outlet', function outletHelper(property, options) {

		var outletSource,
				container,
				viewName,
				viewClass,
				viewFullName;

		if (property && property.data && property.data.isRenderData) {
			options = property;
			property = 'main';
		}

		container = options.data.view.container;

		outletSource = options.data.view;
		while (!outletSource.get('template.isTop')) {
			outletSource = outletSource.get('_parentView');
		}

		// provide controller override
		viewName = options.hash.view;

		if (viewName) {
			viewFullName = 'view:' + viewName;
								}

		viewClass = viewName ? container.lookupFactory(viewFullName) : options.hash.viewClass || Handlebars.OutletView;

		options.data.view.set('outletSource', outletSource);
		options.hash.currentViewBinding = '_view.outletSource._outlets.' + property;

		return Handlebars.helpers.view.call(this, viewClass, options);
	});
});

})();



(function() {
/**
@module ember
@submodule ember-routing
*/

var get = Ember.get, set = Ember.set;
Ember.onLoad('Ember.Handlebars', function(Handlebars) {

	/**
		Calling ``{{render}}`` from within a template will insert another
		template that matches the provided name. The inserted template will
		access its properties on its own controller (rather than the controller
		of the parent template).

		If a view class with the same name exists, the view class also will be used.

		Note: A given controller may only be used *once* in your app in this manner.
		A singleton instance of the controller will be created for you.

		Example:

		```javascript
		App.NavigationController = Ember.Controller.extend({
			who: "world"
		});
		```

		```handlebars
		<!-- navigation.hbs -->
		Hello, {{who}}.
		```

		```handelbars
		<!-- application.hbs -->
		<h1>My great app</h1>
		{{render "navigation"}}
		```

		```html
		<h1>My great app</h1>
		<div class='ember-view'>
			Hello, world.
		</div>
		```

		Optionally you may provide a second argument: a property path
		that will be bound to the `model` property of the controller.

		If a `model` property path is specified, then a new instance of the
		controller will be created and `{{render}}` can be used multiple times
		with the same name.

	 For example if you had this `author` template.

	 ```handlebars
<div class="author">
	Written by {{firstName}} {{lastName}}.
	Total Posts: {{postCount}}
</div>
	```

	You could render it inside the `post` template using the `render` helper.

	```handlebars
<div class="post">
	<h1>{{title}}</h1>
	<div>{{body}}</div>
	{{render "author" author}}
</div>
	 ```

		@method render
		@for Ember.Handlebars.helpers
		@param {String} name
		@param {Object?} contextString
		@param {Hash} options
		@return {String} HTML string
	*/
	Ember.Handlebars.registerHelper('render', function renderHelper(name, contextString, options) {
		var length = arguments.length;

		var contextProvided = length === 3,
				container, router, controller, view, context, lookupOptions;

		container = (options || contextString).data.keywords.controller.container;
		router = container.lookup('router:main');

		if (length === 2) {
			// use the singleton controller
			options = contextString;
			contextString = undefined;
					} else if (length === 3) {
			// create a new controller
			context = Ember.Handlebars.get(options.contexts[1], contextString, options);
		} else {
			throw Ember.Error("You must pass a templateName to render");
		}


		// # legacy namespace
		name = name.replace(/\//g, '.');
		// \ legacy slash as namespace support


		view = container.lookup('view:' + name) || container.lookup('view:default');

		// provide controller override
		var controllerName = options.hash.controller || name;
		var controllerFullName = 'controller:' + controllerName;

		if (options.hash.controller) {
					}

		var parentController = options.data.keywords.controller;

		// choose name
		if (length > 2) {
			var factory = container.lookupFactory(controllerFullName) ||
										Ember.generateControllerFactory(container, controllerName, context);

			controller = factory.create({
				model: context,
				parentController: parentController,
				target: parentController
			});

		} else {
			controller = container.lookup(controllerFullName) ||
									 Ember.generateController(container, controllerName);

			controller.setProperties({
				target: parentController,
				parentController: parentController
			});
		}

		var root = options.contexts[1];

		if (root) {
			view.registerObserver(root, contextString, function() {
				controller.set('model', Ember.Handlebars.get(root, contextString, options));
			});
		}

		options.hash.viewName = Ember.String.camelize(name);

		var templateName = 'template:' + name;
				options.hash.template = container.lookup(templateName);

		options.hash.controller = controller;

		if (router && !context) {
			router._connectActiveView(name, view);
		}

		Ember.Handlebars.helpers.view.call(this, view, options);
	});
});

})();



(function() {
/**
@module ember
@submodule ember-routing
*/
Ember.onLoad('Ember.Handlebars', function(Handlebars) {

	var resolveParams = Ember.Router.resolveParams,
			isSimpleClick = Ember.ViewUtils.isSimpleClick;

	var EmberHandlebars = Ember.Handlebars,
			handlebarsGet = EmberHandlebars.get,
			SafeString = EmberHandlebars.SafeString,
			forEach = Ember.ArrayPolyfills.forEach,
			get = Ember.get,
			a_slice = Array.prototype.slice;

	function args(options, actionName) {
		var ret = [];
		if (actionName) { ret.push(actionName); }

		var types = options.options.types.slice(1),
				data = options.options.data;

		return ret.concat(resolveParams(options.context, options.params, { types: types, data: data }));
	}

	var ActionHelper = EmberHandlebars.ActionHelper = {
		registeredActions: {}
	};

	var keys = ["alt", "shift", "meta", "ctrl"];

	var POINTER_EVENT_TYPE_REGEX = /^click|mouse|touch/;

	var isAllowedEvent = function(event, allowedKeys) {
		if (typeof allowedKeys === "undefined") {
			if (POINTER_EVENT_TYPE_REGEX.test(event.type)) {
				return isSimpleClick(event);
			} else {
				allowedKeys = '';
			}
		}

		if (allowedKeys.indexOf("any") >= 0) {
			return true;
		}

		var allowed = true;

		forEach.call(keys, function(key) {
			if (event[key + "Key"] && allowedKeys.indexOf(key) === -1) {
				allowed = false;
			}
		});

		return allowed;
	};

	ActionHelper.registerAction = function(actionName, options, allowedKeys) {
		var actionId = (++Ember.uuid).toString();

		ActionHelper.registeredActions[actionId] = {
			eventName: options.eventName,
			handler: function handleRegisteredAction(event) {
				if (!isAllowedEvent(event, allowedKeys)) { return true; }

				if (options.preventDefault !== false) {
					event.preventDefault();
				}

				if (options.bubbles === false) {
					event.stopPropagation();
				}

				var target = options.target;

				if (target.target) {
					target = handlebarsGet(target.root, target.target, target.options);
				} else {
					target = target.root;
				}

				Ember.run(function runRegisteredAction() {
					if (target.send) {
						target.send.apply(target, args(options.parameters, actionName));
					} else {
												target[actionName].apply(target, args(options.parameters));
					}
				});
			}
		};

		options.view.on('willClearRender', function() {
			delete ActionHelper.registeredActions[actionId];
		});

		return actionId;
	};

	/**
		The `{{action}}` helper registers an HTML element within a template for DOM
		event handling and forwards that interaction to the templates's controller
		or supplied `target` option (see 'Specifying a Target').

		If the controller does not implement the event, the event is sent
		to the current route, and it bubbles up the route hierarchy from there.

		User interaction with that element will invoke the supplied action name on
		the appropriate target.

		Given the following application Handlebars template on the page

		```handlebars
		<div {{action 'anActionName'}}>
			click me
		</div>
		```

		And application code

		```javascript
		App.ApplicationController = Ember.Controller.extend({
			actions: {
				anActionName: function() {
				}
			}
		});
		```

		Will result in the following rendered HTML

		```html
		<div class="ember-view">
			<div data-ember-action="1">
				click me
			</div>
		</div>
		```

		Clicking "click me" will trigger the `anActionName` action of the
		`App.ApplicationController`. In this case, no additional parameters will be passed.

		If you provide additional parameters to the helper:

		```handlebars
		<button {{action 'edit' post}}>Edit</button>
		```

		Those parameters will be passed along as arguments to the JavaScript
		function implementing the action.

		### Event Propagation

		Events triggered through the action helper will automatically have
		`.preventDefault()` called on them. You do not need to do so in your event
		handlers. If you need to allow event propagation (to handle file inputs for
		example) you can supply the `preventDefault=false` option to the `{{action}}` helper:

		```handlebars
		<div {{action "sayHello" preventDefault=false}}>
			<input type="file" />
			<input type="checkbox" />
		</div>
		```

		To disable bubbling, pass `bubbles=false` to the helper:

		```handlebars
		<button {{action 'edit' post bubbles=false}}>Edit</button>
		```

		If you need the default handler to trigger you should either register your
		own event handler, or use event methods on your view class. See [Ember.View](/api/classes/Ember.View.html)
		'Responding to Browser Events' for more information.

		### Specifying DOM event type

		By default the `{{action}}` helper registers for DOM `click` events. You can
		supply an `on` option to the helper to specify a different DOM event name:

		```handlebars
		<div {{action "anActionName" on="doubleClick"}}>
			click me
		</div>
		```

		See `Ember.View` 'Responding to Browser Events' for a list of
		acceptable DOM event names.

		NOTE: Because `{{action}}` depends on Ember's event dispatch system it will
		only function if an `Ember.EventDispatcher` instance is available. An
		`Ember.EventDispatcher` instance will be created when a new `Ember.Application`
		is created. Having an instance of `Ember.Application` will satisfy this
		requirement.

		### Specifying whitelisted modifier keys

		By default the `{{action}}` helper will ignore click event with pressed modifier
		keys. You can supply an `allowedKeys` option to specify which keys should not be ignored.

		```handlebars
		<div {{action "anActionName" allowedKeys="alt"}}>
			click me
		</div>
		```

		This way the `{{action}}` will fire when clicking with the alt key pressed down.

		Alternatively, supply "any" to the `allowedKeys` option to accept any combination of modifier keys.

		```handlebars
		<div {{action "anActionName" allowedKeys="any"}}>
			click me with any key pressed
		</div>
		```

		### Specifying a Target

		There are several possible target objects for `{{action}}` helpers:

		In a typical Ember application, where views are managed through use of the
		`{{outlet}}` helper, actions will bubble to the current controller, then
		to the current route, and then up the route hierarchy.

		Alternatively, a `target` option can be provided to the helper to change
		which object will receive the method call. This option must be a path
		to an object, accessible in the current context:

		```handlebars
		{{! the application template }}
		<div {{action "anActionName" target=view}}>
			click me
		</div>
		```

		```javascript
		App.ApplicationView = Ember.View.extend({
			actions: {
				anActionName: function(){}
			}
		});

		```

		### Additional Parameters

		You may specify additional parameters to the `{{action}}` helper. These
		parameters are passed along as the arguments to the JavaScript function
		implementing the action.

		```handlebars
		{{#each person in people}}
			<div {{action "edit" person}}>
				click me
			</div>
		{{/each}}
		```

		Clicking "click me" will trigger the `edit` method on the current controller
		with the value of `person` as a parameter.

		@method action
		@for Ember.Handlebars.helpers
		@param {String} actionName
		@param {Object} [context]*
		@param {Hash} options
	*/
	EmberHandlebars.registerHelper('action', function actionHelper(actionName) {
		var options = arguments[arguments.length - 1],
				contexts = a_slice.call(arguments, 1, -1);

		var hash = options.hash,
				controller;

		// create a hash to pass along to registerAction
		var action = {
			eventName: hash.on || "click"
		};

		action.parameters = {
			context: this,
			options: options,
			params: contexts
		};

		action.view = options.data.view;

		var root, target;

		if (hash.target) {
			root = this;
			target = hash.target;
		} else if (controller = options.data.keywords.controller) {
			root = controller;
		}

		action.target = { root: root, target: target, options: options };
		action.bubbles = hash.bubbles;
		action.preventDefault = hash.preventDefault;

		var actionId = ActionHelper.registerAction(actionName, action, hash.allowedKeys);
		return new SafeString('data-ember-action="' + actionId + '"');
	});

});

})();



(function() {

})();



(function() {
/**
@module ember
@submodule ember-routing
*/

var get = Ember.get, set = Ember.set,
		map = Ember.EnumerableUtils.map;

var queuedQueryParamChanges = {};

Ember.ControllerMixin.reopen({
	/**
		Transition the application into another route. The route may
		be either a single route or route path:

		```javascript
		aController.transitionToRoute('blogPosts');
		aController.transitionToRoute('blogPosts.recentEntries');
		```

		Optionally supply a model for the route in question. The model
		will be serialized into the URL using the `serialize` hook of
		the route:

		```javascript
		aController.transitionToRoute('blogPost', aPost);
		```

		Multiple models will be applied last to first recursively up the
		resource tree.

		```javascript
		this.resource('blogPost', {path:':blogPostId'}, function(){
			this.resource('blogComment', {path: ':blogCommentId'});
		});

		aController.transitionToRoute('blogComment', aPost, aComment);
		```

		See also 'replaceRoute'.

		@param {String} name the name of the route
		@param {...Object} models the model(s) to be used while transitioning
		to the route.
		@for Ember.ControllerMixin
		@method transitionToRoute
	*/
	transitionToRoute: function() {
		// target may be either another controller or a router
		var target = get(this, 'target'),
				method = target.transitionToRoute || target.transitionTo;
		return method.apply(target, arguments);
	},

	/**
		@deprecated
		@for Ember.ControllerMixin
		@method transitionTo
	*/
	transitionTo: function() {
				return this.transitionToRoute.apply(this, arguments);
	},

	/**
		Transition into another route while replacing the current URL, if possible.
		This will replace the current history entry instead of adding a new one.
		Beside that, it is identical to `transitionToRoute` in all other respects.

		```javascript
		aController.replaceRoute('blogPosts');
		aController.replaceRoute('blogPosts.recentEntries');
		```

		Optionally supply a model for the route in question. The model
		will be serialized into the URL using the `serialize` hook of
		the route:

		```javascript
		aController.replaceRoute('blogPost', aPost);
		```

		Multiple models will be applied last to first recursively up the
		resource tree.

		```javascript
		this.resource('blogPost', {path:':blogPostId'}, function(){
			this.resource('blogComment', {path: ':blogCommentId'});
		});

		aController.replaceRoute('blogComment', aPost, aComment);
		```

		@param {String} name the name of the route
		@param {...Object} models the model(s) to be used while transitioning
		to the route.
		@for Ember.ControllerMixin
		@method replaceRoute
	*/
	replaceRoute: function() {
		// target may be either another controller or a router
		var target = get(this, 'target'),
				method = target.replaceRoute || target.replaceWith;
		return method.apply(target, arguments);
	},

	/**
		@deprecated
		@for Ember.ControllerMixin
		@method replaceWith
	*/
	replaceWith: function() {
				return this.replaceRoute.apply(this, arguments);
	}
});

if (Ember.FEATURES.isEnabled("query-params-new")) {
	Ember.ControllerMixin.reopen({

		concatenatedProperties: ['queryParams'],

		queryParams: null,

		_queryParamScope: null,

		_finalizingQueryParams: false,
		_queryParamHash: Ember.computed(function computeQueryParamHash() {

			// Given: queryParams: ['foo', 'bar:baz'] on controller:thing
			// _queryParamHash should yield: { 'foo': 'thing[foo]' }

			var result = {};
			var queryParams = this.queryParams;
			if (!queryParams) {
				return result;
			}

			for (var i = 0, len = queryParams.length; i < len; ++i) {
				var full = queryParams[i];
				var parts = full.split(':');
				var key = parts[0];
				var urlKey = parts[1];
				if (!urlKey) {
					if (this._queryParamScope) {
						urlKey = this._queryParamScope + '[' + key + ']';
					} else {
						urlKey = key;
					}
				}
				result[key] = urlKey;
			}

			return result;
		}),

		_activateQueryParamObservers: function() {
			var queryParams = get(this, '_queryParamHash');

			for (var k in queryParams) {
				if (queryParams.hasOwnProperty(k)) {
					this.addObserver(k, this, this._queryParamChanged);
					this.addObserver(k + '.[]', this, this._queryParamChanged);
				}
			}
		},

		_deactivateQueryParamObservers: function() {
			var queryParams = get(this, '_queryParamHash');

			for (var k in queryParams) {
				if (queryParams.hasOwnProperty(k)) {
					this.removeObserver(k, this, this._queryParamChanged);
					this.removeObserver(k + '.[]', this, this._queryParamChanged);
				}
			}
		},

		_queryParamChanged: function(controller, key) {
			// Normalize array observer firings.
			if (key.substr(-3) === '.[]') {
				key = key.substr(0, key.length-3);
			}

			if (this._finalizingQueryParams) {
				var changes = this._queryParamChangesDuringSuspension;
				if (changes) {
					changes[key] = true;
				}
				return;
			}

			var queryParams = get(this, '_queryParamHash');
			queuedQueryParamChanges[queryParams[key]] = Ember.copy(get(this, key));
			Ember.run.once(this, this._fireQueryParamTransition);
		},

		_fireQueryParamTransition: function() {
			this.transitionToRoute({ queryParams: queuedQueryParamChanges });
			queuedQueryParamChanges = {};
		},

		_queryParamChangesDuringSuspension: null
	});
}

})();



(function() {
/**
@module ember
@submodule ember-routing
*/

var get = Ember.get, set = Ember.set;

if (Ember.View) {
Ember.View.reopen({

	/**
		Sets the private `_outlets` object on the view.

		@method init
	 */
	init: function() {
		set(this, '_outlets', {});
		this._super();
	},

	/**
		Manually fill any of a view's `{{outlet}}` areas with the
		supplied view.

		Example

		```javascript
		var MyView = Ember.View.extend({
			template: Ember.Handlebars.compile('Child view: {{outlet "main"}} ')
		});
		var myView = MyView.create();
		myView.appendTo('body');
		// The html for myView now looks like:
		// <div id="ember228" class="ember-view">Child view: </div>

		var FooView = Ember.View.extend({
			template: Ember.Handlebars.compile('<h1>Foo</h1> ')
		});
		var fooView = FooView.create();
		myView.connectOutlet('main', fooView);
		// The html for myView now looks like:
		// <div id="ember228" class="ember-view">Child view:
		//   <div id="ember234" class="ember-view"><h1>Foo</h1> </div>
		// </div>
		```
		@method connectOutlet
		@param  {String} outletName A unique name for the outlet
		@param  {Object} view       An Ember.View
	 */
	connectOutlet: function(outletName, view) {
		if (this._pendingDisconnections) {
			delete this._pendingDisconnections[outletName];
		}

		if (this._hasEquivalentView(outletName, view)) {
			view.destroy();
			return;
		}

		var outlets = get(this, '_outlets'),
				container = get(this, 'container'),
				router = container && container.lookup('router:main'),
				renderedName = get(view, 'renderedName');

		set(outlets, outletName, view);

		if (router && renderedName) {
			router._connectActiveView(renderedName, view);
		}
	},

	/**
		Determines if the view has already been created by checking if
		the view has the same constructor, template, and context as the
		view in the `_outlets` object.

		@private
		@method _hasEquivalentView
		@param  {String} outletName The name of the outlet we are checking
		@param  {Object} view       An Ember.View
		@return {Boolean}
	 */
	_hasEquivalentView: function(outletName, view) {
		var existingView = get(this, '_outlets.'+outletName);
		return existingView &&
			existingView.constructor === view.constructor &&
			existingView.get('template') === view.get('template') &&
			existingView.get('context') === view.get('context');
	},

	/**
		Removes an outlet from the view.

		Example

		```javascript
		var MyView = Ember.View.extend({
			template: Ember.Handlebars.compile('Child view: {{outlet "main"}} ')
		});
		var myView = MyView.create();
		myView.appendTo('body');
		// myView's html:
		// <div id="ember228" class="ember-view">Child view: </div>

		var FooView = Ember.View.extend({
			template: Ember.Handlebars.compile('<h1>Foo</h1> ')
		});
		var fooView = FooView.create();
		myView.connectOutlet('main', fooView);
		// myView's html:
		// <div id="ember228" class="ember-view">Child view:
		//   <div id="ember234" class="ember-view"><h1>Foo</h1> </div>
		// </div>

		myView.disconnectOutlet('main');
		// myView's html:
		// <div id="ember228" class="ember-view">Child view: </div>
		```

		@method disconnectOutlet
		@param  {String} outletName The name of the outlet to be removed
	 */
	disconnectOutlet: function(outletName) {
		if (!this._pendingDisconnections) {
			this._pendingDisconnections = {};
		}
		this._pendingDisconnections[outletName] = true;
		Ember.run.once(this, '_finishDisconnections');
	},

	/**
		Gets an outlet that is pending disconnection and then
		nullifys the object on the `_outlet` object.

		@private
		@method _finishDisconnections
	 */
	_finishDisconnections: function() {
		var outlets = get(this, '_outlets');
		var pendingDisconnections = this._pendingDisconnections;
		this._pendingDisconnections = null;

		for (var outletName in pendingDisconnections) {
			set(outlets, outletName, null);
		}
	}
});
}
})();



(function() {
/**
@module ember
@submodule ember-views
*/

// Add a new named queue after the 'actions' queue (where RSVP promises
// resolve), which is used in router transitions to prevent unnecessary
// loading state entry if all context promises resolve on the
// 'actions' queue first.

var queues = Ember.run.queues,
		indexOf = Ember.ArrayPolyfills.indexOf;
queues.splice(indexOf.call(queues, 'actions') + 1, 0, 'routerTransitions');

})();



(function() {
/**
@module ember
@submodule ember-routing
*/

var get = Ember.get, set = Ember.set;

/**
	Ember.Location returns an instance of the correct implementation of
	the `location` API.

	## Implementations

	You can pass an implementation name (`hash`, `history`, `none`) to force a
	particular implementation to be used in your application.

	### HashLocation

	Using `HashLocation` results in URLs with a `#` (hash sign) separating the
	server side URL portion of the URL from the portion that is used by Ember.
	This relies upon the `hashchange` event existing in the browser.

	Example:

	```javascript
	App.Router.map(function() {
		this.resource('posts', function() {
			this.route('new');
		});
	});

	App.Router.reopen({
		location: 'hash'
	});
	```

	This will result in a posts.new url of `/#/posts/new`.

	### HistoryLocation

	Using `HistoryLocation` results in URLs that are indistinguishable from a
	standard URL. This relies upon the browser's `history` API.

	Example:

	```javascript
	App.Router.map(function() {
		this.resource('posts', function() {
			this.route('new');
		});
	});

	App.Router.reopen({
		location: 'history'
	});
	```

	This will result in a posts.new url of `/posts/new`.

	### NoneLocation

	Using `NoneLocation` causes Ember to not store the applications URL state
	in the actual URL. This is generally used for testing purposes, and is one
	of the changes made when calling `App.setupForTesting()`.

	## Location API

	Each location implementation must provide the following methods:

	* implementation: returns the string name used to reference the implementation.
	* getURL: returns the current URL.
	* setURL(path): sets the current URL.
	* replaceURL(path): replace the current URL (optional).
	* onUpdateURL(callback): triggers the callback when the URL changes.
	* formatURL(url): formats `url` to be placed into `href` attribute.

	Calling setURL or replaceURL will not trigger onUpdateURL callbacks.

	@class Location
	@namespace Ember
	@static
*/
Ember.Location = {
	/**
	 This is deprecated in favor of using the container to lookup the location
	 implementation as desired.

	 For example:

	 ```javascript
	 // Given a location registered as follows:
	 container.register('location:history-test', HistoryTestLocation);

	 // You could create a new instance via:
	 container.lookup('location:history-test');
	 ```

		@method create
		@param {Object} options
		@return {Object} an instance of an implementation of the `location` API
		@deprecated Use the container to lookup the location implementation that you
		need.
	*/
	create: function(options) {
		var implementation = options && options.implementation;

		var implementationClass = this.implementations[implementation];

		return implementationClass.create.apply(implementationClass, arguments);
	},

	/**
	 This is deprecated in favor of using the container to register the
	 location implementation as desired.

	 Example:

	 ```javascript
	 Application.initializer({
		name: "history-test-location",

		initialize: function(container, application) {
			application.register('location:history-test', HistoryTestLocation);
		}
	 });
	 ```

	 @method registerImplementation
	 @param {String} name
	 @param {Object} implementation of the `location` API
	 @deprecated Register your custom location implementation with the
	 container directly.
	*/
	registerImplementation: function(name, implementation) {

		this.implementations[name] = implementation;
	},

	implementations: {}
};

})();



(function() {
/**
@module ember
@submodule ember-routing
*/

var get = Ember.get, set = Ember.set;

/**
	Ember.NoneLocation does not interact with the browser. It is useful for
	testing, or when you need to manage state with your Router, but temporarily
	don't want it to muck with the URL (for example when you embed your
	application in a larger page).

	@class NoneLocation
	@namespace Ember
	@extends Ember.Object
*/
Ember.NoneLocation = Ember.Object.extend({
	implementation: 'none',
	path: '',

	/**
		Returns the current path.

		@private
		@method getURL
		@return {String} path
	*/
	getURL: function() {
		return get(this, 'path');
	},

	/**
		Set the path and remembers what was set. Using this method
		to change the path will not invoke the `updateURL` callback.

		@private
		@method setURL
		@param path {String}
	*/
	setURL: function(path) {
		set(this, 'path', path);
	},

	/**
		Register a callback to be invoked when the path changes. These
		callbacks will execute when the user presses the back or forward
		button, but not after `setURL` is invoked.

		@private
		@method onUpdateURL
		@param callback {Function}
	*/
	onUpdateURL: function(callback) {
		this.updateCallback = callback;
	},

	/**
		Sets the path and calls the `updateURL` callback.

		@private
		@method handleURL
		@param callback {Function}
	*/
	handleURL: function(url) {
		set(this, 'path', url);
		this.updateCallback(url);
	},

	/**
		Given a URL, formats it to be placed into the page as part
		of an element's `href` attribute.

		This is used, for example, when using the {{action}} helper
		to generate a URL based on an event.

		@private
		@method formatURL
		@param url {String}
		@return {String} url
	*/
	formatURL: function(url) {
		// The return value is not overly meaningful, but we do not want to throw
		// errors when test code renders templates containing {{action href=true}}
		// helpers.
		return url;
	}
});

})();



(function() {
/**
@module ember
@submodule ember-routing
*/

var get = Ember.get, set = Ember.set;

/**
	`Ember.HashLocation` implements the location API using the browser's
	hash. At present, it relies on a `hashchange` event existing in the
	browser.

	@class HashLocation
	@namespace Ember
	@extends Ember.Object
*/
Ember.HashLocation = Ember.Object.extend({
	implementation: 'hash',

	init: function() {
		set(this, 'location', get(this, 'location') || window.location);
	},

	/**
		Returns the current `location.hash`, minus the '#' at the front.

		@private
		@method getURL
	*/
	getURL: function() {
		if (Ember.FEATURES.isEnabled("query-params-new")) {
			// location.hash is not used because it is inconsistently
			// URL-decoded between browsers.
			var href = get(this, 'location').href,
				hashIndex = href.indexOf('#');

			if ( hashIndex === -1 ) {
				return "";
			} else {
				return href.substr(hashIndex + 1);
			}
		}
		// Default implementation without feature flag enabled
		return get(this, 'location').hash.substr(1);
	},

	/**
		Set the `location.hash` and remembers what was set. This prevents
		`onUpdateURL` callbacks from triggering when the hash was set by
		`HashLocation`.

		@private
		@method setURL
		@param path {String}
	*/
	setURL: function(path) {
		get(this, 'location').hash = path;
		set(this, 'lastSetURL', path);
	},

	/**
		Uses location.replace to update the url without a page reload
		or history modification.

		@private
		@method replaceURL
		@param path {String}
	*/
	replaceURL: function(path) {
		get(this, 'location').replace('#' + path);
		set(this, 'lastSetURL', path);
	},

	/**
		Register a callback to be invoked when the hash changes. These
		callbacks will execute when the user presses the back or forward
		button, but not after `setURL` is invoked.

		@private
		@method onUpdateURL
		@param callback {Function}
	*/
	onUpdateURL: function(callback) {
		var self = this;
		var guid = Ember.guidFor(this);

		Ember.$(window).on('hashchange.ember-location-'+guid, function() {
			Ember.run(function() {
				var path = location.hash.substr(1);
				if (get(self, 'lastSetURL') === path) { return; }

				set(self, 'lastSetURL', null);

				callback(path);
			});
		});
	},

	/**
		Given a URL, formats it to be placed into the page as part
		of an element's `href` attribute.

		This is used, for example, when using the {{action}} helper
		to generate a URL based on an event.

		@private
		@method formatURL
		@param url {String}
	*/
	formatURL: function(url) {
		return '#'+url;
	},

	/**
		Cleans up the HashLocation event listener.

		@private
		@method willDestroy
	*/
	willDestroy: function() {
		var guid = Ember.guidFor(this);

		Ember.$(window).off('hashchange.ember-location-'+guid);
	}
});

})();



(function() {
/**
@module ember
@submodule ember-routing
*/

var get = Ember.get, set = Ember.set;
var popstateFired = false;
var supportsHistoryState = window.history && 'state' in window.history;

/**
	Ember.HistoryLocation implements the location API using the browser's
	history.pushState API.

	@class HistoryLocation
	@namespace Ember
	@extends Ember.Object
*/
Ember.HistoryLocation = Ember.Object.extend({
	implementation: 'history',

	init: function() {
		set(this, 'location', get(this, 'location') || window.location);
		set(this, 'baseURL', Ember.$('base').attr('href') || '');
	},

	/**
		Used to set state on first call to setURL

		@private
		@method initState
	*/
	initState: function() {
		set(this, 'history', get(this, 'history') || window.history);
		this.replaceState(this.formatURL(this.getURL()));
	},

	/**
		Will be pre-pended to path upon state change

		@property rootURL
		@default '/'
	*/
	rootURL: '/',

	/**
		Returns the current `location.pathname` without `rootURL`.

		@private
		@method getURL
		@return url {String}
	*/
	getURL: function() {
		var rootURL = get(this, 'rootURL'),
				location = get(this, 'location'),
				path = location.pathname,
				baseURL = get(this, 'baseURL');

		rootURL = rootURL.replace(/\/$/, '');
		baseURL = baseURL.replace(/\/$/, '');
		var url = path.replace(baseURL, '').replace(rootURL, '');

		if (Ember.FEATURES.isEnabled("query-params-new")) {
			var search = location.search || '';
			url += search;
		}

		return url;
	},

	/**
		Uses `history.pushState` to update the url without a page reload.

		@private
		@method setURL
		@param path {String}
	*/
	setURL: function(path) {
		var state = this.getState();
		path = this.formatURL(path);

		if (state && state.path !== path) {
			this.pushState(path);
		}
	},

	/**
		Uses `history.replaceState` to update the url without a page reload
		or history modification.

		@private
		@method replaceURL
		@param path {String}
	*/
	replaceURL: function(path) {
		var state = this.getState();
		path = this.formatURL(path);

		if (state && state.path !== path) {
			this.replaceState(path);
		}
	},

	/**
	 Get the current `history.state`
	 Polyfill checks for native browser support and falls back to retrieving
	 from a private _historyState variable

	 @private
	 @method getState
	 @return state {Object}
	*/
	getState: function() {
		return supportsHistoryState ? get(this, 'history').state : this._historyState;
	},

	/**
	 Pushes a new state.

	 @private
	 @method pushState
	 @param path {String}
	*/
	pushState: function(path) {
		var state = { path: path };

		get(this, 'history').pushState(state, null, path);

		// store state if browser doesn't support `history.state`
		if (!supportsHistoryState) {
			this._historyState = state;
		}

		// used for webkit workaround
		this._previousURL = this.getURL();
	},

	/**
	 Replaces the current state.

	 @private
	 @method replaceState
	 @param path {String}
	*/
	replaceState: function(path) {
		var state = { path: path };

		get(this, 'history').replaceState(state, null, path);

		// store state if browser doesn't support `history.state`
		if (!supportsHistoryState) {
			this._historyState = state;
		}

		// used for webkit workaround
		this._previousURL = this.getURL();
	},

	/**
		Register a callback to be invoked whenever the browser
		history changes, including using forward and back buttons.

		@private
		@method onUpdateURL
		@param callback {Function}
	*/
	onUpdateURL: function(callback) {
		var guid = Ember.guidFor(this),
				self = this;

		Ember.$(window).on('popstate.ember-location-'+guid, function(e) {
			// Ignore initial page load popstate event in Chrome
			if (!popstateFired) {
				popstateFired = true;
				if (self.getURL() === self._previousURL) { return; }
			}
			callback(self.getURL());
		});
	},

	/**
		Used when using `{{action}}` helper.  The url is always appended to the rootURL.

		@private
		@method formatURL
		@param url {String}
		@return formatted url {String}
	*/
	formatURL: function(url) {
		var rootURL = get(this, 'rootURL'),
				baseURL = get(this, 'baseURL');

		if (url !== '') {
			rootURL = rootURL.replace(/\/$/, '');
			baseURL = baseURL.replace(/\/$/, '');
		} else if(baseURL.match(/^\//) && rootURL.match(/^\//)) {
			baseURL = baseURL.replace(/\/$/, '');
		}

		return baseURL + rootURL + url;
	},

	/**
		Cleans up the HistoryLocation event listener.

		@private
		@method willDestroy
	*/
	willDestroy: function() {
		var guid = Ember.guidFor(this);

		Ember.$(window).off('popstate.ember-location-'+guid);
	}
});

})();



(function() {

})();



(function() {
/**
Ember Routing

@module ember
@submodule ember-routing
@requires ember-views
*/

})();

(function() {
function visit(vertex, fn, visited, path) {
	var name = vertex.name,
		vertices = vertex.incoming,
		names = vertex.incomingNames,
		len = names.length,
		i;
	if (!visited) {
		visited = {};
	}
	if (!path) {
		path = [];
	}
	if (visited.hasOwnProperty(name)) {
		return;
	}
	path.push(name);
	visited[name] = true;
	for (i = 0; i < len; i++) {
		visit(vertices[names[i]], fn, visited, path);
	}
	fn(vertex, path);
	path.pop();
}

function DAG() {
	this.names = [];
	this.vertices = {};
}

DAG.prototype.add = function(name) {
	if (!name) { return; }
	if (this.vertices.hasOwnProperty(name)) {
		return this.vertices[name];
	}
	var vertex = {
		name: name, incoming: {}, incomingNames: [], hasOutgoing: false, value: null
	};
	this.vertices[name] = vertex;
	this.names.push(name);
	return vertex;
};

DAG.prototype.map = function(name, value) {
	this.add(name).value = value;
};

DAG.prototype.addEdge = function(fromName, toName) {
	if (!fromName || !toName || fromName === toName) {
		return;
	}
	var from = this.add(fromName), to = this.add(toName);
	if (to.incoming.hasOwnProperty(fromName)) {
		return;
	}
	function checkCycle(vertex, path) {
		if (vertex.name === toName) {
			throw new Ember.Error("cycle detected: " + toName + " <- " + path.join(" <- "));
		}
	}
	visit(from, checkCycle);
	from.hasOutgoing = true;
	to.incoming[fromName] = from;
	to.incomingNames.push(fromName);
};

DAG.prototype.topsort = function(fn) {
	var visited = {},
		vertices = this.vertices,
		names = this.names,
		len = names.length,
		i, vertex;
	for (i = 0; i < len; i++) {
		vertex = vertices[names[i]];
		if (!vertex.hasOutgoing) {
			visit(vertex, fn, visited);
		}
	}
};

DAG.prototype.addEdges = function(name, value, before, after) {
	var i;
	this.map(name, value);
	if (before) {
		if (typeof before === 'string') {
			this.addEdge(name, before);
		} else {
			for (i = 0; i < before.length; i++) {
				this.addEdge(name, before[i]);
			}
		}
	}
	if (after) {
		if (typeof after === 'string') {
			this.addEdge(after, name);
		} else {
			for (i = 0; i < after.length; i++) {
				this.addEdge(after[i], name);
			}
		}
	}
};

Ember.DAG = DAG;

})();



(function() {
/**
@module ember
@submodule ember-application
*/

var get = Ember.get,
		classify = Ember.String.classify,
		capitalize = Ember.String.capitalize,
		decamelize = Ember.String.decamelize;

/**
	The DefaultResolver defines the default lookup rules to resolve
	container lookups before consulting the container for registered
	items:

* templates are looked up on `Ember.TEMPLATES`
* other names are looked up on the application after converting
	the name. For example, `controller:post` looks up
	`App.PostController` by default.
* there are some nuances (see examples below)

	### How Resolving Works

	The container calls this object's `resolve` method with the
	`fullName` argument.

	It first parses the fullName into an object using `parseName`.

	Then it checks for the presence of a type-specific instance
	method of the form `resolve[Type]` and calls it if it exists.
	For example if it was resolving 'template:post', it would call
	the `resolveTemplate` method.

	Its last resort is to call the `resolveOther` method.

	The methods of this object are designed to be easy to override
	in a subclass. For example, you could enhance how a template
	is resolved like so:

	```javascript
	App = Ember.Application.create({
		Resolver: Ember.DefaultResolver.extend({
			resolveTemplate: function(parsedName) {
				var resolvedTemplate = this._super(parsedName);
				if (resolvedTemplate) { return resolvedTemplate; }
				return Ember.TEMPLATES['not_found'];
			}
		})
	});
	```

	Some examples of how names are resolved:

	```
	'template:post' //=> Ember.TEMPLATES['post']
	'template:posts/byline' //=> Ember.TEMPLATES['posts/byline']
	'template:posts.byline' //=> Ember.TEMPLATES['posts/byline']
	'template:blogPost' //=> Ember.TEMPLATES['blogPost']
											//   OR
											//   Ember.TEMPLATES['blog_post']
	'controller:post' //=> App.PostController
	'controller:posts.index' //=> App.PostsIndexController
	'controller:blog/post' //=> Blog.PostController
	'controller:basic' //=> Ember.Controller
	'route:post' //=> App.PostRoute
	'route:posts.index' //=> App.PostsIndexRoute
	'route:blog/post' //=> Blog.PostRoute
	'route:basic' //=> Ember.Route
	'view:post' //=> App.PostView
	'view:posts.index' //=> App.PostsIndexView
	'view:blog/post' //=> Blog.PostView
	'view:basic' //=> Ember.View
	'foo:post' //=> App.PostFoo
	'model:post' //=> App.Post
	```

	@class DefaultResolver
	@namespace Ember
	@extends Ember.Object
*/
Ember.DefaultResolver = Ember.Object.extend({
	/**
		This will be set to the Application instance when it is
		created.

		@property namespace
	*/
	namespace: null,

	normalize: function(fullName) {
		var split = fullName.split(':', 2),
				type = split[0],
				name = split[1];


		if (type !== 'template') {
			var result = name;

			if (result.indexOf('.') > -1) {
				result = result.replace(/\.(.)/g, function(m) { return m.charAt(1).toUpperCase(); });
			}

			if (name.indexOf('_') > -1) {
				result = result.replace(/_(.)/g, function(m) { return m.charAt(1).toUpperCase(); });
			}

			return type + ':' + result;
		} else {
			return fullName;
		}
	},


	/**
		This method is called via the container's resolver method.
		It parses the provided `fullName` and then looks up and
		returns the appropriate template or class.

		@method resolve
		@param {String} fullName the lookup string
		@return {Object} the resolved factory
	*/
	resolve: function(fullName) {
		var parsedName = this.parseName(fullName),
				typeSpecificResolveMethod = this[parsedName.resolveMethodName];

		if (!parsedName.name || !parsedName.type) {
			throw new TypeError("Invalid fullName: `" + fullName + "`, must be of the form `type:name` ");
		}

		if (typeSpecificResolveMethod) {
			var resolved = typeSpecificResolveMethod.call(this, parsedName);
			if (resolved) { return resolved; }
		}
		return this.resolveOther(parsedName);
	},
	/**
		Convert the string name of the form "type:name" to
		a Javascript object with the parsed aspects of the name
		broken out.

		@protected
		@param {String} fullName the lookup string
		@method parseName
	*/
	parseName: function(fullName) {
		var nameParts = fullName.split(":"),
				type = nameParts[0], fullNameWithoutType = nameParts[1],
				name = fullNameWithoutType,
				namespace = get(this, 'namespace'),
				root = namespace;

		if (type !== 'template' && name.indexOf('/') !== -1) {
			var parts = name.split('/');
			name = parts[parts.length - 1];
			var namespaceName = capitalize(parts.slice(0, -1).join('.'));
			root = Ember.Namespace.byName(namespaceName);

					}

		return {
			fullName: fullName,
			type: type,
			fullNameWithoutType: fullNameWithoutType,
			name: name,
			root: root,
			resolveMethodName: "resolve" + classify(type)
		};
	},
	/**
		Look up the template in Ember.TEMPLATES

		@protected
		@param {Object} parsedName a parseName object with the parsed
			fullName lookup string
		@method resolveTemplate
	*/
	resolveTemplate: function(parsedName) {
		var templateName = parsedName.fullNameWithoutType.replace(/\./g, '/');

		if (Ember.TEMPLATES[templateName]) {
			return Ember.TEMPLATES[templateName];
		}

		templateName = decamelize(templateName);
		if (Ember.TEMPLATES[templateName]) {
			return Ember.TEMPLATES[templateName];
		}
	},
	/**
		Given a parseName object (output from `parseName`), apply
		the conventions expected by `Ember.Router`

		@protected
		@param {Object} parsedName a parseName object with the parsed
			fullName lookup string
		@method useRouterNaming
	*/
	useRouterNaming: function(parsedName) {
		parsedName.name = parsedName.name.replace(/\./g, '_');
		if (parsedName.name === 'basic') {
			parsedName.name = '';
		}
	},
	/**
		Lookup the controller using `resolveOther`

		@protected
		@param {Object} parsedName a parseName object with the parsed
			fullName lookup string
		@method resolveController
	*/
	resolveController: function(parsedName) {
		this.useRouterNaming(parsedName);
		return this.resolveOther(parsedName);
	},
	/**
		Lookup the route using `resolveOther`

		@protected
		@param {Object} parsedName a parseName object with the parsed
			fullName lookup string
		@method resolveRoute
	*/
	resolveRoute: function(parsedName) {
		this.useRouterNaming(parsedName);
		return this.resolveOther(parsedName);
	},
	/**
		Lookup the view using `resolveOther`

		@protected
		@param {Object} parsedName a parseName object with the parsed
			fullName lookup string
		@method resolveView
	*/
	resolveView: function(parsedName) {
		this.useRouterNaming(parsedName);
		return this.resolveOther(parsedName);
	},

	resolveHelper: function(parsedName) {
		return this.resolveOther(parsedName) || Ember.Handlebars.helpers[parsedName.fullNameWithoutType];
	},

	/**
		Lookup the model on the Application namespace

		@protected
		@param {Object} parsedName a parseName object with the parsed
			fullName lookup string
		@method resolveModel
	*/
	resolveModel: function(parsedName) {
		var className = classify(parsedName.name),
				factory = get(parsedName.root, className);

		 if (factory) { return factory; }
	},
	/**
		Look up the specified object (from parsedName) on the appropriate
		namespace (usually on the Application)

		@protected
		@param {Object} parsedName a parseName object with the parsed
			fullName lookup string
		@method resolveOther
	*/
	resolveOther: function(parsedName) {
		var className = classify(parsedName.name) + classify(parsedName.type),
				factory = get(parsedName.root, className);
		if (factory) { return factory; }
	},

	/**
		Returns a human-readable description for a fullName. Used by the
		Application namespace in assertions to describe the
		precise name of the class that Ember is looking for, rather than
		container keys.

		@protected
		@param {String} fullName the lookup string
		@method lookupDescription
	*/
	lookupDescription: function(fullName) {
		var parsedName = this.parseName(fullName);

		if (parsedName.type === 'template') {
			return "template at " + parsedName.fullNameWithoutType.replace(/\./g, '/');
		}

		var description = parsedName.root + "." + classify(parsedName.name);
		if (parsedName.type !== 'model') { description += classify(parsedName.type); }

		return description;
	},

	makeToString: function(factory, fullName) {
		return factory.toString();
	}
});

})();



(function() {
/**
@module ember
@submodule ember-application
*/

var get = Ember.get, set = Ember.set;

function DeprecatedContainer(container) {
	this._container = container;
}

DeprecatedContainer.deprecate = function(method) {
	return function() {
		var container = this._container;

				return container[method].apply(container, arguments);
	};
};

DeprecatedContainer.prototype = {
	_container: null,
	lookup: DeprecatedContainer.deprecate('lookup'),
	resolve: DeprecatedContainer.deprecate('resolve'),
	register: DeprecatedContainer.deprecate('register')
};

/**
	An instance of `Ember.Application` is the starting point for every Ember
	application. It helps to instantiate, initialize and coordinate the many
	objects that make up your app.

	Each Ember app has one and only one `Ember.Application` object. In fact, the
	very first thing you should do in your application is create the instance:

	```javascript
	window.App = Ember.Application.create();
	```

	Typically, the application object is the only global variable. All other
	classes in your app should be properties on the `Ember.Application` instance,
	which highlights its first role: a global namespace.

	For example, if you define a view class, it might look like this:

	```javascript
	App.MyView = Ember.View.extend();
	```

	By default, calling `Ember.Application.create()` will automatically initialize
	your application by calling the `Ember.Application.initialize()` method. If
	you need to delay initialization, you can call your app's `deferReadiness()`
	method. When you are ready for your app to be initialized, call its
	`advanceReadiness()` method.

	You can define a `ready` method on the `Ember.Application` instance, which
	will be run by Ember when the application is initialized.

	Because `Ember.Application` inherits from `Ember.Namespace`, any classes
	you create will have useful string representations when calling `toString()`.
	See the `Ember.Namespace` documentation for more information.

	While you can think of your `Ember.Application` as a container that holds the
	other classes in your application, there are several other responsibilities
	going on under-the-hood that you may want to understand.

	### Event Delegation

	Ember uses a technique called _event delegation_. This allows the framework
	to set up a global, shared event listener instead of requiring each view to
	do it manually. For example, instead of each view registering its own
	`mousedown` listener on its associated element, Ember sets up a `mousedown`
	listener on the `body`.

	If a `mousedown` event occurs, Ember will look at the target of the event and
	start walking up the DOM node tree, finding corresponding views and invoking
	their `mouseDown` method as it goes.

	`Ember.Application` has a number of default events that it listens for, as
	well as a mapping from lowercase events to camel-cased view method names. For
	example, the `keypress` event causes the `keyPress` method on the view to be
	called, the `dblclick` event causes `doubleClick` to be called, and so on.

	If there is a bubbling browser event that Ember does not listen for by
	default, you can specify custom events and their corresponding view method
	names by setting the application's `customEvents` property:

	```javascript
	App = Ember.Application.create({
		customEvents: {
			// add support for the paste event
			paste: "paste"
		}
	});
	```

	By default, the application sets up these event listeners on the document
	body. However, in cases where you are embedding an Ember application inside
	an existing page, you may want it to set up the listeners on an element
	inside the body.

	For example, if only events inside a DOM element with the ID of `ember-app`
	should be delegated, set your application's `rootElement` property:

	```javascript
	window.App = Ember.Application.create({
		rootElement: '#ember-app'
	});
	```

	The `rootElement` can be either a DOM element or a jQuery-compatible selector
	string. Note that *views appended to the DOM outside the root element will
	not receive events.* If you specify a custom root element, make sure you only
	append views inside it!

	To learn more about the advantages of event delegation and the Ember view
	layer, and a list of the event listeners that are setup by default, visit the
	[Ember View Layer guide](http://emberjs.com/guides/understanding-ember/the-view-layer/#toc_event-delegation).

	### Initializers

	Libraries on top of Ember can register additional initializers, like so:

	```javascript
	Ember.Application.initializer({
		name: "store",

		initialize: function(container, application) {
			container.register('store:main', application.Store);
		}
	});
	```

	### Routing

	In addition to creating your application's router, `Ember.Application` is
	also responsible for telling the router when to start routing. Transitions
	between routes can be logged with the `LOG_TRANSITIONS` flag, and more
	detailed intra-transition logging can be logged with
	the `LOG_TRANSITIONS_INTERNAL` flag:

	```javascript
	window.App = Ember.Application.create({
		LOG_TRANSITIONS: true, // basic logging of successful transitions
		LOG_TRANSITIONS_INTERNAL: true // detailed logging of all routing steps
	});
	```

	By default, the router will begin trying to translate the current URL into
	application state once the browser emits the `DOMContentReady` event. If you
	need to defer routing, you can call the application's `deferReadiness()`
	method. Once routing can begin, call the `advanceReadiness()` method.

	If there is any setup required before routing begins, you can implement a
	`ready()` method on your app that will be invoked immediately before routing
	begins.
	```

	@class Application
	@namespace Ember
	@extends Ember.Namespace
*/

var Application = Ember.Application = Ember.Namespace.extend(Ember.DeferredMixin, {

	/**
		The root DOM element of the Application. This can be specified as an
		element or a
		[jQuery-compatible selector string](http://api.jquery.com/category/selectors/).

		This is the element that will be passed to the Application's,
		`eventDispatcher`, which sets up the listeners for event delegation. Every
		view in your application should be a child of the element you specify here.

		@property rootElement
		@type DOMElement
		@default 'body'
	*/
	rootElement: 'body',

	/**
		The `Ember.EventDispatcher` responsible for delegating events to this
		application's views.

		The event dispatcher is created by the application at initialization time
		and sets up event listeners on the DOM element described by the
		application's `rootElement` property.

		See the documentation for `Ember.EventDispatcher` for more information.

		@property eventDispatcher
		@type Ember.EventDispatcher
		@default null
	*/
	eventDispatcher: null,

	/**
		The DOM events for which the event dispatcher should listen.

		By default, the application's `Ember.EventDispatcher` listens
		for a set of standard DOM events, such as `mousedown` and
		`keyup`, and delegates them to your application's `Ember.View`
		instances.

		If you would like additional bubbling events to be delegated to your
		views, set your `Ember.Application`'s `customEvents` property
		to a hash containing the DOM event name as the key and the
		corresponding view method name as the value. For example:

		```javascript
		App = Ember.Application.create({
			customEvents: {
				// add support for the paste event
				paste: "paste"
			}
		});
		```

		@property customEvents
		@type Object
		@default null
	*/
	customEvents: null,

	// Start off the number of deferrals at 1. This will be
	// decremented by the Application's own `initialize` method.
	_readinessDeferrals: 1,

	init: function() {
		if (!this.$) { this.$ = Ember.$; }
		this.__container__ = this.buildContainer();

		this.Router = this.defaultRouter();

		this._super();

		this.scheduleInitialize();

		Ember.libraries.registerCoreLibrary('Handlebars', Ember.Handlebars.VERSION);
		Ember.libraries.registerCoreLibrary('jQuery', Ember.$().jquery);

		if ( Ember.LOG_VERSION ) {
			Ember.LOG_VERSION = false; // we only need to see this once per Application#init
			var maxNameLength = Math.max.apply(this, Ember.A(Ember.libraries).mapBy("name.length"));

						Ember.libraries.each(function(name, version) {
				var spaces = new Array(maxNameLength - name.length + 1).join(" ");
							});
					}
	},

	/**
		Build the container for the current application.

		Also register a default application view in case the application
		itself does not.

		@private
		@method buildContainer
		@return {Ember.Container} the configured container
	*/
	buildContainer: function() {
		var container = this.__container__ = Application.buildContainer(this);

		return container;
	},

	/**
		If the application has not opted out of routing and has not explicitly
		defined a router, supply a default router for the application author
		to configure.

		This allows application developers to do:

		```javascript
		var App = Ember.Application.create();

		App.Router.map(function() {
			this.resource('posts');
		});
		```

		@private
		@method defaultRouter
		@return {Ember.Router} the default router
	*/

	defaultRouter: function() {
		if (this.Router === false) { return; }
		var container = this.__container__;

		if (this.Router) {
			container.unregister('router:main');
			container.register('router:main', this.Router);
		}

		return container.lookupFactory('router:main');
	},

	/**
		Automatically initialize the application once the DOM has
		become ready.

		The initialization itself is scheduled on the actions queue
		which ensures that application loading finishes before
		booting.

		If you are asynchronously loading code, you should call
		`deferReadiness()` to defer booting, and then call
		`advanceReadiness()` once all of your code has finished
		loading.

		@private
		@method scheduleInitialize
	*/
	scheduleInitialize: function() {
		var self = this;

		if (!this.$ || this.$.isReady) {
			Ember.run.schedule('actions', self, '_initialize');
		} else {
			this.$().ready(function runInitialize() {
				Ember.run(self, '_initialize');
			});
		}
	},

	/**
		Use this to defer readiness until some condition is true.

		Example:

		```javascript
		App = Ember.Application.create();
		App.deferReadiness();

		jQuery.getJSON("/auth-token", function(token) {
			App.token = token;
			App.advanceReadiness();
		});
		```

		This allows you to perform asynchronous setup logic and defer
		booting your application until the setup has finished.

		However, if the setup requires a loading UI, it might be better
		to use the router for this purpose.

		@method deferReadiness
	*/
	deferReadiness: function() {
						this._readinessDeferrals++;
	},

	/**
		Call `advanceReadiness` after any asynchronous setup logic has completed.
		Each call to `deferReadiness` must be matched by a call to `advanceReadiness`
		or the application will never become ready and routing will not begin.

		@method advanceReadiness
		@see {Ember.Application#deferReadiness}
	*/
	advanceReadiness: function() {
				this._readinessDeferrals--;

		if (this._readinessDeferrals === 0) {
			Ember.run.once(this, this.didBecomeReady);
		}
	},

	/**
		registers a factory for later injection

		Example:

		```javascript
		App = Ember.Application.create();

		App.Person  = Ember.Object.extend({});
		App.Orange  = Ember.Object.extend({});
		App.Email   = Ember.Object.extend({});
		App.session = Ember.Object.create({});

		App.register('model:user', App.Person, {singleton: false });
		App.register('fruit:favorite', App.Orange);
		App.register('communication:main', App.Email, {singleton: false});
		App.register('session', App.session, {instantiate: false});
		```

		@method register
		@param  fullName {String} type:name (e.g., 'model:user')
		@param  factory {Function} (e.g., App.Person)
		@param  options {String} (optional)
	**/
	register: function() {
		var container = this.__container__;
		container.register.apply(container, arguments);
	},
	/**
		defines an injection or typeInjection

		Example:

		```javascript
		App.inject(<full_name or type>, <property name>, <full_name>)
		App.inject('controller:application', 'email', 'model:email')
		App.inject('controller', 'source', 'source:main')
		```
		Please note that injections on models are currently disabled.
		This was done because ember-data was not ready for fully a container aware ecosystem.

		You can enable injections on models by setting `Ember.MODEL_FACTORY_INJECTIONS` flag to `true`
		If model factory injections are enabled, models should not be
		accessed globally (only through `container.lookupFactory('model:modelName'))`);

		@method inject
		@param  factoryNameOrType {String}
		@param  property {String}
		@param  injectionName {String}
	**/
	inject: function() {
		var container = this.__container__;
		container.injection.apply(container, arguments);
	},

	/**
		Calling initialize manually is not supported.

		Please see Ember.Application#advanceReadiness and
		Ember.Application#deferReadiness.

		@private
		@deprecated
		@method initialize
	 **/
	initialize: function() {
			},
	/**
		Initialize the application. This happens automatically.

		Run any initializers and run the application load hook. These hooks may
		choose to defer readiness. For example, an authentication hook might want
		to defer readiness until the auth token has been retrieved.

		@private
		@method _initialize
	*/
	_initialize: function() {
		if (this.isDestroyed) { return; }

		// At this point, the App.Router must already be assigned
		if (this.Router) {
			var container = this.__container__;
			container.unregister('router:main');
			container.register('router:main', this.Router);
		}

		this.runInitializers();
		Ember.runLoadHooks('application', this);

		// At this point, any initializers or load hooks that would have wanted
		// to defer readiness have fired. In general, advancing readiness here
		// will proceed to didBecomeReady.
		this.advanceReadiness();

		return this;
	},

	/**
		Reset the application. This is typically used only in tests. It cleans up
		the application in the following order:

		1. Deactivate existing routes
		2. Destroy all objects in the container
		3. Create a new application container
		4. Re-route to the existing url

		Typical Example:

		```javascript

		var App;

		Ember.run(function() {
			App = Ember.Application.create();
		});

		module("acceptance test", {
			setup: function() {
				App.reset();
			}
		});

		test("first test", function() {
			// App is freshly reset
		});

		test("first test", function() {
			// App is again freshly reset
		});
		```

		Advanced Example:

		Occasionally you may want to prevent the app from initializing during
		setup. This could enable extra configuration, or enable asserting prior
		to the app becoming ready.

		```javascript

		var App;

		Ember.run(function() {
			App = Ember.Application.create();
		});

		module("acceptance test", {
			setup: function() {
				Ember.run(function() {
					App.reset();
					App.deferReadiness();
				});
			}
		});

		test("first test", function() {
			ok(true, 'something before app is initialized');

			Ember.run(function() {
				App.advanceReadiness();
			});
			ok(true, 'something after app is initialized');
		});
		```

		@method reset
	**/
	reset: function() {
		this._readinessDeferrals = 1;

		function handleReset() {
			var router = this.__container__.lookup('router:main');
			router.reset();

			Ember.run(this.__container__, 'destroy');

			this.buildContainer();

			Ember.run.schedule('actions', this, function() {
				this._initialize();
			});
		}

		Ember.run.join(this, handleReset);
	},

	/**
		@private
		@method runInitializers
	*/
	runInitializers: function() {
		var initializers = get(this.constructor, 'initializers'),
				container = this.__container__,
				graph = new Ember.DAG(),
				namespace = this,
				name, initializer;

		for (name in initializers) {
			initializer = initializers[name];
			graph.addEdges(initializer.name, initializer.initialize, initializer.before, initializer.after);
		}

		graph.topsort(function (vertex) {
			var initializer = vertex.value;
						initializer(container, namespace);
		});
	},

	/**
		@private
		@method didBecomeReady
	*/
	didBecomeReady: function() {
		this.setupEventDispatcher();
		this.ready(); // user hook
		this.startRouting();

		if (!Ember.testing) {
			// Eagerly name all classes that are already loaded
			Ember.Namespace.processAll();
			Ember.BOOTED = true;
		}

		this.resolve(this);
	},

	/**
		Setup up the event dispatcher to receive events on the
		application's `rootElement` with any registered
		`customEvents`.

		@private
		@method setupEventDispatcher
	*/
	setupEventDispatcher: function() {
		var customEvents = get(this, 'customEvents'),
				rootElement = get(this, 'rootElement'),
				dispatcher = this.__container__.lookup('event_dispatcher:main');

		set(this, 'eventDispatcher', dispatcher);
		dispatcher.setup(customEvents, rootElement);
	},

	/**
		trigger a new call to `route` whenever the URL changes.
		If the application has a router, use it to route to the current URL, and

		@private
		@method startRouting
		@property router {Ember.Router}
	*/
	startRouting: function() {
		var router = this.__container__.lookup('router:main');
		if (!router) { return; }

		router.startRouting();
	},

	handleURL: function(url) {
		var router = this.__container__.lookup('router:main');

		router.handleURL(url);
	},

	/**
		Called when the Application has become ready.
		The call will be delayed until the DOM has become ready.

		@event ready
	*/
	ready: Ember.K,

	/**
		@deprecated Use 'Resolver' instead
		Set this to provide an alternate class to `Ember.DefaultResolver`


		@property resolver
	*/
	resolver: null,

	/**
		Set this to provide an alternate class to `Ember.DefaultResolver`

		@property resolver
	*/
	Resolver: null,

	willDestroy: function() {
		Ember.BOOTED = false;

		this.__container__.destroy();
	},

	initializer: function(options) {
		this.constructor.initializer(options);
	}
});

Ember.Application.reopenClass({
	initializers: {},
	initializer: function(initializer) {
		// If this is the first initializer being added to a subclass, we are going to reopen the class
		// to make sure we have a new `initializers` object, which extends from the parent class' using
		// prototypal inheritance. Without this, attempting to add initializers to the subclass would
		// pollute the parent class as well as other subclasses.
		if (this.superclass.initializers !== undefined && this.superclass.initializers === this.initializers) {
			this.reopenClass({
				initializers: Ember.create(this.initializers)
			});
		}


		this.initializers[initializer.name] = initializer;
	},

	/**
		This creates a container with the default Ember naming conventions.

		It also configures the container:

		* registered views are created every time they are looked up (they are
			not singletons)
		* registered templates are not factories; the registered value is
			returned directly.
		* the router receives the application as its `namespace` property
		* all controllers receive the router as their `target` and `controllers`
			properties
		* all controllers receive the application as their `namespace` property
		* the application view receives the application controller as its
			`controller` property
		* the application view receives the application template as its
			`defaultTemplate` property

		@private
		@method buildContainer
		@static
		@param {Ember.Application} namespace the application to build the
			container for.
		@return {Ember.Container} the built container
	*/
	buildContainer: function(namespace) {
		var container = new Ember.Container();

		Ember.Container.defaultContainer = new DeprecatedContainer(container);

		container.set = Ember.set;
		container.resolver  = resolverFor(namespace);
		container.normalize = container.resolver.normalize;
		container.describe  = container.resolver.describe;
		container.makeToString = container.resolver.makeToString;

		container.optionsForType('component', { singleton: false });
		container.optionsForType('view', { singleton: false });
		container.optionsForType('template', { instantiate: false });
		container.optionsForType('helper', { instantiate: false });

		container.register('application:main', namespace, { instantiate: false });

		container.register('controller:basic', Ember.Controller, { instantiate: false });
		container.register('controller:object', Ember.ObjectController, { instantiate: false });
		container.register('controller:array', Ember.ArrayController, { instantiate: false });
		container.register('route:basic', Ember.Route, { instantiate: false });
		container.register('event_dispatcher:main', Ember.EventDispatcher);

		container.register('router:main',  Ember.Router);
		container.injection('router:main', 'namespace', 'application:main');

		container.register('location:hash', Ember.HashLocation);
		container.register('location:history', Ember.HistoryLocation);
		container.register('location:none', Ember.NoneLocation);

		container.injection('controller', 'target', 'router:main');
		container.injection('controller', 'namespace', 'application:main');

		container.injection('route', 'router', 'router:main');

		return container;
	}
});

/**
	This function defines the default lookup rules for container lookups:

	* templates are looked up on `Ember.TEMPLATES`
	* other names are looked up on the application after classifying the name.
		For example, `controller:post` looks up `App.PostController` by default.
	* if the default lookup fails, look for registered classes on the container

	This allows the application to register default injections in the container
	that could be overridden by the normal naming convention.

	@private
	@method resolverFor
	@param {Ember.Namespace} namespace the namespace to look for classes
	@return {*} the resolved value for a given lookup
*/
function resolverFor(namespace) {
	if (namespace.get('resolver')) {
			}

	var ResolverClass = namespace.get('resolver') || namespace.get('Resolver') || Ember.DefaultResolver;
	var resolver = ResolverClass.create({
		namespace: namespace
	});

	function resolve(fullName) {
		return resolver.resolve(fullName);
	}

	resolve.describe = function(fullName) {
		return resolver.lookupDescription(fullName);
	};

	resolve.makeToString = function(factory, fullName) {
		return resolver.makeToString(factory, fullName);
	};

	resolve.normalize = function(fullName) {
		if (resolver.normalize) {
			return resolver.normalize(fullName);
		} else {
						return fullName;
		}
	};

	return resolve;
}

Ember.runLoadHooks('Ember.Application', Ember.Application);

})();



(function() {

})();



(function() {
/**
@module ember
@submodule ember-application
*/

var get = Ember.get, set = Ember.set;

function verifyNeedsDependencies(controller, container, needs) {
	var dependency, i, l, missing = [];

	for (i=0, l=needs.length; i<l; i++) {
		dependency = needs[i];


		if (dependency.indexOf(':') === -1) {
			dependency = "controller:" + dependency;
		}

		// Structure assert to still do verification but not string concat in production
		if (!container.has(dependency)) {
			missing.push(dependency);
		}
	}
	if (missing.length) {
		throw new Ember.Error(Ember.inspect(controller) + " needs [ " + missing.join(', ') + " ] but " + (missing.length > 1 ? 'they' : 'it') + " could not be found");
	}
}

var defaultControllersComputedProperty = Ember.computed(function() {
	var controller = this;

	return {
		needs: get(controller, 'needs'),
		container: get(controller, 'container'),
		unknownProperty: function(controllerName) {
			var needs = this.needs,
				dependency, i, l;
			for (i=0, l=needs.length; i<l; i++) {
				dependency = needs[i];
				if (dependency === controllerName) {
					return this.container.lookup('controller:' + controllerName);
				}
			}

			var errorMessage = Ember.inspect(controller) + '#needs does not include `' + controllerName + '`. To access the ' + controllerName + ' controller from ' + Ember.inspect(controller) + ', ' + Ember.inspect(controller) + ' should have a `needs` property that is an array of the controllers it has access to.';
			throw new ReferenceError(errorMessage);
		},
		setUnknownProperty: function (key, value) {
			throw new Error("You cannot overwrite the value of `controllers." + key + "` of " + Ember.inspect(controller));
		}
	};
});

/**
	@class ControllerMixin
	@namespace Ember
*/
Ember.ControllerMixin.reopen({
	concatenatedProperties: ['needs'],

	/**
		An array of other controller objects available inside
		instances of this controller via the `controllers`
		property:

		For example, when you define a controller:

		```javascript
		App.CommentsController = Ember.ArrayController.extend({
			needs: ['post']
		});
		```

		The application's single instance of these other
		controllers are accessible by name through the
		`controllers` property:

		```javascript
		this.get('controllers.post'); // instance of App.PostController
		```

		Given that you have a nested controller (nested resource):

		```javascript
		App.CommentsNewController = Ember.ObjectController.extend({
		});
		```

		When you define a controller that requires access to a nested one:

		```javascript
		App.IndexController = Ember.ObjectController.extend({
			needs: ['commentsNew']
		});
		```

		You will be able to get access to it:

		```javascript
		this.get('controllers.commentsNew'); // instance of App.CommentsNewController
		```

		This is only available for singleton controllers.

		@property {Array} needs
		@default []
	*/
	needs: [],

	init: function() {
		var needs = get(this, 'needs'),
		length = get(needs, 'length');

		if (length > 0) {

			if (this.container) {
				verifyNeedsDependencies(this, this.container, needs);
			}

			// if needs then initialize controllers proxy
			get(this, 'controllers');
		}

		this._super.apply(this, arguments);
	},

	/**
		@method controllerFor
		@see {Ember.Route#controllerFor}
		@deprecated Use `needs` instead
	*/
	controllerFor: function(controllerName) {
				return Ember.controllerFor(get(this, 'container'), controllerName);
	},

	/**
		Stores the instances of other controllers available from within
		this controller. Any controller listed by name in the `needs`
		property will be accessible by name through this property.

		```javascript
		App.CommentsController = Ember.ArrayController.extend({
			needs: ['post'],
			postTitle: function(){
				var currentPost = this.get('controllers.post'); // instance of App.PostController
				return currentPost.get('title');
			}.property('controllers.post.title')
		});
		```

		@see {Ember.ControllerMixin#needs}
		@property {Object} controllers
		@default null
	*/
	controllers: defaultControllersComputedProperty
});

})();



(function() {

})();



(function() {
/**
Ember Application

@module ember
@submodule ember-application
@requires ember-views, ember-routing
*/

})();

(function() {
/**
@module ember
@submodule ember-extension-support
*/
/**
	The `DataAdapter` helps a data persistence library
	interface with tools that debug Ember such
	as the [Ember Extension](https://github.com/tildeio/ember-extension)
	for Chrome and Firefox.

	This class will be extended by a persistence library
	which will override some of the methods with
	library-specific code.

	The methods likely to be overridden are:

	* `getFilters`
	* `detect`
	* `columnsForType`
	* `getRecords`
	* `getRecordColumnValues`
	* `getRecordKeywords`
	* `getRecordFilterValues`
	* `getRecordColor`
	* `observeRecord`

	The adapter will need to be registered
	in the application's container as `dataAdapter:main`

	Example:

	```javascript
	Application.initializer({
		name: "dataAdapter",

		initialize: function(container, application) {
			application.register('dataAdapter:main', DS.DataAdapter);
		}
	});
	```

	@class DataAdapter
	@namespace Ember
	@extends Ember.Object
*/
Ember.DataAdapter = Ember.Object.extend({
	init: function() {
		this._super();
		this.releaseMethods = Ember.A();
	},

	/**
		The container of the application being debugged.
		This property will be injected
		on creation.

		@property container
		@default null
	*/
	container: null,

	/**
		Number of attributes to send
		as columns. (Enough to make the record
		identifiable).

		@private
		@property attributeLimit
		@default 3
	*/
	attributeLimit: 3,

	/**
		Stores all methods that clear observers.
		These methods will be called on destruction.

		@private
		@property releaseMethods
	*/
	releaseMethods: Ember.A(),

	/**
		Specifies how records can be filtered.
		Records returned will need to have a `filterValues`
		property with a key for every name in the returned array.

		@public
		@method getFilters
		@return {Array} List of objects defining filters.
		 The object should have a `name` and `desc` property.
	*/
	getFilters: function() {
		return Ember.A();
	},

	/**
		Fetch the model types and observe them for changes.

		@public
		@method watchModelTypes

		@param {Function} typesAdded Callback to call to add types.
		Takes an array of objects containing wrapped types (returned from `wrapModelType`).

		@param {Function} typesUpdated Callback to call when a type has changed.
		Takes an array of objects containing wrapped types.

		@return {Function} Method to call to remove all observers
	*/
	watchModelTypes: function(typesAdded, typesUpdated) {
		var modelTypes = this.getModelTypes(),
				self = this, typesToSend, releaseMethods = Ember.A();

		typesToSend = modelTypes.map(function(type) {
			var wrapped = self.wrapModelType(type);
			releaseMethods.push(self.observeModelType(type, typesUpdated));
			return wrapped;
		});

		typesAdded(typesToSend);

		var release = function() {
			releaseMethods.forEach(function(fn) { fn(); });
			self.releaseMethods.removeObject(release);
		};
		this.releaseMethods.pushObject(release);
		return release;
	},

	/**
		Fetch the records of a given type and observe them for changes.

		@public
		@method watchRecords

		@param {Function} recordsAdded Callback to call to add records.
		Takes an array of objects containing wrapped records.
		The object should have the following properties:
			columnValues: {Object} key and value of a table cell
			object: {Object} the actual record object

		@param {Function} recordsUpdated Callback to call when a record has changed.
		Takes an array of objects containing wrapped records.

		@param {Function} recordsRemoved Callback to call when a record has removed.
		Takes the following parameters:
			index: the array index where the records were removed
			count: the number of records removed

		@return {Function} Method to call to remove all observers
	*/
	watchRecords: function(type, recordsAdded, recordsUpdated, recordsRemoved) {
		var self = this, releaseMethods = Ember.A(), records = this.getRecords(type), release;

		var recordUpdated = function(updatedRecord) {
			recordsUpdated([updatedRecord]);
		};

		var recordsToSend = records.map(function(record) {
			releaseMethods.push(self.observeRecord(record, recordUpdated));
			return self.wrapRecord(record);
		});


		var contentDidChange = function(array, idx, removedCount, addedCount) {
			for (var i = idx; i < idx + addedCount; i++) {
				var record = array.objectAt(i);
				var wrapped = self.wrapRecord(record);
				releaseMethods.push(self.observeRecord(record, recordUpdated));
				recordsAdded([wrapped]);
			}

			if (removedCount) {
				recordsRemoved(idx, removedCount);
			}
		};

		var observer = { didChange: contentDidChange, willChange: Ember.K };
		records.addArrayObserver(self, observer);

		release = function() {
			releaseMethods.forEach(function(fn) { fn(); });
			records.removeArrayObserver(self, observer);
			self.releaseMethods.removeObject(release);
		};

		recordsAdded(recordsToSend);

		this.releaseMethods.pushObject(release);
		return release;
	},

	/**
		Clear all observers before destruction
		@private
	*/
	willDestroy: function() {
		this._super();
		this.releaseMethods.forEach(function(fn) {
			fn();
		});
	},

	/**
		Detect whether a class is a model.

		Test that against the model class
		of your persistence library

		@private
		@method detect
		@param {Class} klass The class to test
		@return boolean Whether the class is a model class or not
	*/
	detect: function(klass) {
		return false;
	},

	/**
		Get the columns for a given model type.

		@private
		@method columnsForType
		@param {Class} type The model type
		@return {Array} An array of columns of the following format:
		 name: {String} name of the column
		 desc: {String} Humanized description (what would show in a table column name)
	*/
	columnsForType: function(type) {
		return Ember.A();
	},

	/**
		Adds observers to a model type class.

		@private
		@method observeModelType
		@param {Class} type The model type class
		@param {Function} typesUpdated Called when a type is modified.
		@return {Function} The function to call to remove observers
	*/

	observeModelType: function(type, typesUpdated) {
		var self = this, records = this.getRecords(type);

		var onChange = function() {
			typesUpdated([self.wrapModelType(type)]);
		};
		var observer = {
			didChange: function() {
				Ember.run.scheduleOnce('actions', this, onChange);
			},
			willChange: Ember.K
		};

		records.addArrayObserver(this, observer);

		var release = function() {
			records.removeArrayObserver(self, observer);
		};

		return release;
	},


	/**
		Wraps a given model type and observes changes to it.

		@private
		@method wrapModelType
		@param {Class} type A model class
		@param {Function} typesUpdated callback to call when the type changes
		@return {Object} contains the wrapped type and the function to remove observers
		Format:
			type: {Object} the wrapped type
				The wrapped type has the following format:
					name: {String} name of the type
					count: {Integer} number of records available
					columns: {Columns} array of columns to describe the record
					object: {Class} the actual Model type class
			release: {Function} The function to remove observers
	*/
	wrapModelType: function(type, typesUpdated) {
		var release, records = this.getRecords(type),
				typeToSend, self = this;

		typeToSend = {
			name: type.toString(),
			count: Ember.get(records, 'length'),
			columns: this.columnsForType(type),
			object: type
		};


		return typeToSend;
	},


	/**
		Fetches all models defined in the application.

		@private
		@method getModelTypes
		@return {Array} Array of model types
	*/

 // TODO: Use the resolver instead of looping over namespaces.
	getModelTypes: function() {
		var namespaces = Ember.A(Ember.Namespace.NAMESPACES), types = Ember.A(), self = this;

		namespaces.forEach(function(namespace) {
			for (var key in namespace) {
				if (!namespace.hasOwnProperty(key)) { continue; }
				var klass = namespace[key];
				if (self.detect(klass)) {
					types.push(klass);
				}
			}
		});
		return types;
	},

	/**
		Fetches all loaded records for a given type.

		@private
		@method getRecords
		@return {Array} An array of records.
		 This array will be observed for changes,
		 so it should update when new records are added/removed.
	*/
	getRecords: function(type) {
		return Ember.A();
	},

	/**
		Wraps a record and observers changes to it.

		@private
		@method wrapRecord
		@param {Object} record The record instance.
		@return {Object} The wrapped record. Format:
		columnValues: {Array}
		searchKeywords: {Array}
	*/
	wrapRecord: function(record) {
		var recordToSend = { object: record }, columnValues = {}, self = this;

		recordToSend.columnValues = this.getRecordColumnValues(record);
		recordToSend.searchKeywords = this.getRecordKeywords(record);
		recordToSend.filterValues = this.getRecordFilterValues(record);
		recordToSend.color = this.getRecordColor(record);

		return recordToSend;
	},

	/**
		Gets the values for each column.

		@private
		@method getRecordColumnValues
		@return {Object} Keys should match column names defined
		by the model type.
	*/
	getRecordColumnValues: function(record) {
		return {};
	},

	/**
		Returns keywords to match when searching records.

		@private
		@method getRecordKeywords
		@return {Array} Relevant keywords for search.
	*/
	getRecordKeywords: function(record) {
		return Ember.A();
	},

	/**
		Returns the values of filters defined by `getFilters`.

		@private
		@method getRecordFilterValues
		@param {Object} record The record instance
		@return {Object} The filter values
	*/
	getRecordFilterValues: function(record) {
		return {};
	},

	/**
		Each record can have a color that represents its state.

		@private
		@method getRecordColor
		@param {Object} record The record instance
		@return {String} The record's color
			Possible options: black, red, blue, green
	*/
	getRecordColor: function(record) {
		return null;
	},

	/**
		Observes all relevant properties and re-sends the wrapped record
		when a change occurs.

		@private
		@method observerRecord
		@param {Object} record The record instance
		@param {Function} recordUpdated The callback to call when a record is updated.
		@return {Function} The function to call to remove all observers.
	*/
	observeRecord: function(record, recordUpdated) {
		return function(){};
	}

});


})();



(function() {
/**
Ember Extension Support

@module ember
@submodule ember-extension-support
@requires ember-application
*/

})();


})();


if (typeof location !== 'undefined' && (location.hostname === 'localhost' || location.hostname === '127.0.0.1')) {
	Ember.Logger.warn("You are running a production build of Ember on localhost and won't receive detailed error messages. "+
							 "If you want full error messages please use the non-minified build provided on the Ember website.");
}
