/**
 * @license
 * Copyright 2015 The Incremental DOM Authors. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS-IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports):"function"==typeof define&&define.amd?define(["exports"],t):t(e.IncrementalDOM={})}(this,function(e){"use strict";function t(e){this.stack_=[],this.root=e,this.currentNode=e}function n(n,r){this.walker=new t(n),this.doc=n.ownerDocument,this.nsStack_=[void 0],this.prevContext=r,this.created=e.notifications.nodesCreated&&[],this.deleted=e.notifications.nodesDeleted&&[]}function r(e,t){this.attrs=d(),this.attrsArr=[],this.newAttrs=d(),this.key=t,this.keyMap=null,this.keyMapValid=!0,this.lastVisitedChild=null,this.nodeName=e,this.text=null}e.notifications={nodesCreated:null,nodesDeleted:null},t.prototype.getCurrentParent=function(){return this.stack_[this.stack_.length-1]},t.prototype.firstChild=function(){this.stack_.push(this.currentNode),this.currentNode=this.currentNode.firstChild},t.prototype.nextSibling=function(){this.currentNode=this.currentNode.nextSibling},t.prototype.parentNode=function(){this.currentNode=this.stack_.pop()},n.prototype.getCurrentNamespace=function(){return this.nsStack_[this.nsStack_.length-1]},n.prototype.enterNamespace=function(e){this.nsStack_.push(e)},n.prototype.exitNamespace=function(){this.nsStack_.pop()},n.prototype.markCreated=function(e){this.created&&this.created.push(e)},n.prototype.markDeleted=function(e){this.deleted&&this.deleted.push(e)},n.prototype.notifyChanges=function(){this.created&&this.created.length>0&&e.notifications.nodesCreated(this.created),this.deleted&&this.deleted.length>0&&e.notifications.nodesDeleted(this.deleted)};var i,a=function(e){i=new n(e,i)},o=function(){i=i.prevContext},s=function(){return i},l=Object.prototype.hasOwnProperty,u=Object.create,c=function(e,t){return l.call(e,t)},d=function(){return u(null)},f=function(e,t,n){var i=new r(t,n);return e.__incrementalDOMData=i,i},p=function(e){var t=e.__incrementalDOMData;if(!t){var n=e.nodeName.toLowerCase(),r=null;e instanceof Element&&(r=e.getAttribute("key")),t=f(e,n,r)}return t};e.symbols={"default":"__default",placeholder:"__placeholder"},e.applyAttr=function(e,t,n){null==n?e.removeAttribute(t):e.setAttribute(t,n)},e.applyProp=function(e,t,n){e[t]=n};var h=function(e,t,n){if("string"==typeof n)e.style.cssText=n;else{e.style.cssText="";var r=e.style;for(var i in n)c(n,i)&&(r[i]=n[i])}},m=function(t,n,r){var i=typeof r;"object"===i||"function"===i?e.applyProp(t,n,r):e.applyAttr(t,n,r)},y=function(t,n,r){var i=p(t),a=i.attrs;if(a[n]!==r){var o=e.attributes[n]||e.attributes[e.symbols["default"]];o(t,n,r),a[n]=r}};e.attributes=d(),e.attributes[e.symbols["default"]]=m,e.attributes[e.symbols.placeholder]=function(){},e.attributes.style=h;var v="http://www.w3.org/2000/svg",g=function(e){"svg"===e?s().enterNamespace(v):"foreignObject"===e&&s().enterNamespace(void 0)},k=function(e){("svg"===e||"foreignObject"===e)&&s().exitNamespace()},N=function(e){return"svg"===e?v:s().getCurrentNamespace()},C=function(e,t,n,r){var i,a=N(t);if(i=a?e.createElementNS(a,t):e.createElement(t),f(i,t,n),r)for(var o=0;o<r.length;o+=2)y(i,r[o],r[o+1]);return i},b=function(e,t,n,r){return"#text"===t?e.createTextNode(""):C(e,t,n,r)},w=function(e){for(var t=d(),n=e.children,r=n.length,i=0;r>i;i+=1){var a=n[i],o=p(a).key;o&&(t[o]=a)}return t},x=function(e){var t=p(e);return t.keyMap||(t.keyMap=w(e)),t.keyMap},_=function(e,t){return t&&x(e)[t]},O=function(e,t,n){x(e)[t]=n},D=function(e,t,n){var r=p(e);return n==r.key&&t===r.nodeName},M=function(e,t,n){var r,i=s(),a=i.walker,o=a.currentNode,l=a.getCurrentParent();if(o&&D(o,e,t))r=o;else{var u=_(l,t);u?r=u:(r=b(i.doc,e,t,n),t&&O(l,t,r),i.markCreated(r)),o&&p(o).key?(l.replaceChild(r,o),p(l).keyMapValid=!1):l.insertBefore(r,o),a.currentNode=r}return r},S=function(t){var n,r=s(),i=r.walker,a=p(t),o=a.keyMap,l=a.keyMapValid,u=a.lastVisitedChild,c=t.lastChild;if(a.lastVisitedChild=null,!(c===u&&l||a.attrs[e.symbols.placeholder]&&i.currentNode!==i.root)){for(;c!==u;)t.removeChild(c),r.markDeleted(c),n=p(c).key,n&&delete o[n],c=t.lastChild;for(n in o)c=o[n],c.parentNode||(r.markDeleted(c),delete o[n]);a.keyMapValid=!0}},A=function(e){var t=p(e);g(t.nodeName)},V=function(e){var t=p(e);k(t.nodeName)},P=function(e){var t=s(),n=t.walker,r=n.getCurrentParent(),i=p(r);i.lastVisitedChild=e},j=function(){var e=s(),t=e.walker;A(t.currentNode),t.firstChild()},E=function(){var e=s(),t=e.walker;P(t.currentNode),t.nextSibling()},T=function(){var e=s(),t=e.walker;t.parentNode(),V(t.currentNode)};e.patch=function(e,t,n){a(e),j(),t(n),T(),S(e),s().notifyChanges(),o()};var B=3,I=[];e.elementOpen=function(e,t,n,r){for(var i=M(e,t,n),a=p(i),o=a.attrsArr,s=!1,l=B,u=0;l<arguments.length;l+=1,u+=1)if(o[u]!==arguments[l]){s=!0;break}for(;l<arguments.length;l+=1,u+=1)o[u]=arguments[l];if(u<o.length&&(s=!0,o.length=u),s){var c,d=a.newAttrs;for(c in d)d[c]=void 0;for(l=B;l<arguments.length;l+=2)d[arguments[l]]=arguments[l+1];for(c in d)y(i,c,d[c])}return j(),i},e.elementOpenStart=function(e,t,n){I[0]=e,I[1]=t,I[2]=n},e.attr=function(e,t){I.push(e,t)},e.elementOpenEnd=function(){var t=e.elementOpen.apply(null,I);return I.length=0,t},e.elementClose=function(e){T();var t=s().walker.currentNode;return S(t),E(),t},e.elementVoid=function(t,n,r,i){var a=e.elementOpen.apply(null,arguments);return e.elementClose.apply(null,arguments),a},e.elementPlaceholder=function(t,n,r,i){var a=e.elementOpen.apply(null,arguments);return y(a,e.symbols.placeholder,!0),e.elementClose.apply(null,arguments),a},e.text=function(e,t){var n=M("#text",null),r=p(n);if(r.text!==e){r.text=e;for(var i=e,a=1;a<arguments.length;a+=1)i=arguments[a](i);n.data=i}return E(),n}});
//# sourceMappingURL=incremental-dom-min.js.map